# include <cstdio>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int n;
int len[MAX_N];

vector <pair <int, int>> st;

bool check (int let)
{
	int i, j;
	st.clear ();
	len[0] = 0;
	///printf ("------- %d\n", let);
	for (i = 1; i <= n; i ++)
	{
		///printf ("%d %d\n", i, len[i]);
		if (len[i] > len[i - 1])
			continue;

		while (st.size () && st[st.size () - 1].first > len[i])
			st.pop_back ();
		j = -1; 
		while (st.size ())
		{
			j ++;
			if ((len[i] - j) <= 0)
				return false;
			///printf ("%d %d %d\n", st[st.size () - 1].first, st[st.size () - 1].second, len[i] - j);
		
			if (st[st.size () - 1].first == (len[i] - j))
			{
				if (st[st.size () - 1].second == (let - 1))
				{
					st.pop_back ();
					continue;
				}
				st[st.size () - 1].second ++;
				break;
			}
			st.push_back ({len[i] - j, 1});
			break;
		}
		if (!st.size ())
		{
			j ++;
			if (len[i] - j)
				st.push_back ({len[i] - j, 1});
			else
				return false;
		}
	}
	return true;
}

int main ()
{
	int i, fl = false;
	int l, r, mid;
	scanf ("%d", &n);
	for (i = 1; i <= n; i ++)
	{
		
		scanf ("%d", &len[i]);
		if (len[i - 1] >= len[i])
			fl = true;
	}
	if (!fl)
	{
		printf ("1\n");
		return 0;
	}
	l = 1;
	r = n + 2;
	while (r - l > 1)
	{
		mid = (l + r) >> 1;
		if (check (mid))
			r = mid;
		else
			l = mid;
	}
	printf ("%d\n", r);
	return 0;
}
