# include <cstdio>
# include <vector>
# include <map>
# include <algorithm>

using namespace std;

const int MAX_N = 8e5 + 10;

int n, k;

int l[MAX_N];
int r[MAX_N];
int p[MAX_N];

pair <int, pair <int, int>> seg[MAX_N];
int dp[MAX_N];

map <int, int> cmp;
vector <int> in[MAX_N];
vector <int> out[MAX_N];
int f[MAX_N];
int t[MAX_N];
int sz;

int main ()
{
	int i, j;
	scanf ("%d%d", &n, &k);
	for (i = 1; i <= n; i ++)
	{
		scanf ("%d%d%d", &seg[i].second.first, &seg[i].first, &seg[i].second.second);
		if (n > 3000)
		{
			l[i] = seg[i].second.first;
			r[i] = seg[i].first;
			p[i] = seg[i].second.second;
			cmp[l[i]] = 0;
			if (l[i] > 1)
				cmp[l[i] - 1] = 0;
			cmp[r[i]] = 0;
			if (r[i] < k)
				cmp[r[i] + 1] = 0;
		}
	}
	
	if (n > 3000)
	{
		cmp[k] = 0;
		i = 1;
		for (map <int, int> :: iterator it = cmp.begin (); it != cmp.end (); it ++, i ++)
			(*it).second = i;
		sz = i - 1;
	
		for (i = 1; i <= n; i ++)
		{
			l[i] = cmp[l[i]];
			r[i] = cmp[r[i]];
			in[l[i]].push_back (i);
			out[r[i]].push_back (i);
		}
		int cnt = 0;
		for (i = 1; i <= sz; i ++)
		{
			cnt += in[i].size ();
			if (cnt <= 0)
				break;
			cnt -= out[i].size ();
		}
		if (i <= sz)
		{
			printf ("-1\n");
			return 0;
		}
		cnt = 0;
		f[0] = 1;
		for (i = 1; i <= sz; i ++)
		{
			if (f[i - 1])
				for (j = 0; j < (int) in[i].size (); j ++)
					f[r[in[i][j]]] = true;
		}
		if (f[sz])
			printf ("1\n");
		else
			printf ("2\n");
		return 0;
	}
	
	sort (seg + 1, seg + n + 1);
	
	bool fl;
	long long l, r, mid;
	l = 0;
	r = (1LL << 48);
	while (r - l > 1)
	{
		mid = (l + r) >> 1;
		fl = false;
		///printf ("%lld %lld %lld\n", l, r, mid);
		for (i = 1; i <= n; i ++)
		{
			dp[i] = (1 << 30);
			if (seg[i].second.first == 1 && seg[i].second.second <= mid)
				dp[i] = 0;
			for (j = 1; j <= i; j ++)
			{
				if (dp[j] < seg[j].first && (seg[j].first + 1) == seg[i].second.first && seg[i].second.second <= mid)
					dp[i] = seg[j].first; 
				if ((seg[i].second.second + seg[j].second.second) > mid)
					continue;
				if (seg[j].first < seg[i].second.first)
					continue;
				if (seg[i].first < dp[i] && dp[j] < seg[i].second.first)
					dp[i] = seg[j].first;
			}
			///printf ("%d %d\n", i, dp[i]);
			if (dp[i] <= k && seg[i].first == k)
			{
				fl = true;
				break;
			}
		}
		if (fl)
			r = mid;
		else
			l = mid;
	}
	if (r == (1LL << 48))
		r = -1;
	printf ("%lld\n", r);
	return 0;
}
