#include <iostream>
#include <cstdio>
using namespace std;
const int MAX_N = 3e3 + 15;
const int MAX_K = 1e8 + 15;
const long long INF = 1e18;
int N;
long long K;
long long curr[MAX_K], currminmax = INF;
struct gra
{
    int le;
    int ri;
    long long st;
    gra(int _le, int _ri, long long _st)
    {
        le = _le;
        ri = _ri;
        st = _st;
    }
};
gra a[MAX_N];
void solve(int idx)
{
    if(idx == N + 1)
    {
        int currmax = 0;
        for(long long i = 1; i <= K; ++ i)
        {
            if(curr[i] == 0)   return;
            if(currmax < curr[i])   currmax = curr[i];
        }
        if(currmax < currminmax)   currminmax = currmax;
        return;
    }
    solve(idx + 1);
    for(int i = a[idx].le; i <= a[idx].ri; ++ i)   curr[i] += a[idx].st;
    solve(idx + 1);
    for(int i = a[idx].le; i <= a[idx].ri; ++ i)   curr[i] -= a[idx].st;
}
int main()
{
    cin >> N >> K;
    for(int i = 1; i <= N; ++ i)   cin >> a[i].le >> a[i].ri >> a[i].st;
    solve(1);
    if(currminmax == INF)   cout << "-1\n";
    else   cout << currminmax << "\n";
    return 0;
}
