#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define mp make_pair
#define sz(a) (int)((a).size())

typedef long long ll;
typedef long double ld;
typedef pair < int, int > pi;

const int MAX_N = (int)2e5 + 123;
const int inf = (int)1e9 + 123;

int n;
int a[MAX_N];

map < int, int > ptr;

bool check(int sz) {
    ptr.clear();
    for (int i = 1; i + 1 <= n; i++) {
        if (a[i] < a[i + 1])
            continue;
        bool found = 0;
        while(!ptr.empty()) {
            auto it = ptr.end();
            it--;
            if (it -> f > a[i + 1])
                ptr.erase(it);
            else
                break;
        }
        for (int j = a[i + 1]; j > 0; j--) {
            int val = (ptr.count(j) ? ptr[j] : 1);
            if (val < sz) {
                found = 1;
                ptr[j] = val + 1;
                break;
            }
            if (ptr.count(j))
                ptr[j] = 1;
        }
        if (!found)
            return 0;
    }
    return 1;
}

int main() {

    #ifdef NICK
    freopen("input.txt", "r", stdin);
    #endif // NICK
    scanf("%d", &n);
    for (int i = 1; i <= n; i++)
        scanf("%d", &a[i]);
    bool good = 1;
    for (int i = 1; i + 1 <= n; i++)
        if (a[i] >= a[i + 1]) {
            good = 0;
            break;
        }
    if (good) {
        puts("1");
        return 0;
    }
    int l = 2, r = n, mid = -1, best = -1;
    while(l <= r) {
        mid = (l + r) / 2;
        if (check(mid))
            best = mid, r = mid - 1;
        else
            l = mid + 1;
    }
    assert(best != -1);
    printf("%d\n", best);
    return 0;
}
