#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define mp make_pair
#define sz(a) (int)((a).size())

typedef long long ll;
typedef long double ld;
typedef pair < int, int > pi;
typedef pair < ll, ll > pl;

const int MAX_N = (int)2e5 + 123;
const int inf = (int)2e9 + 123;

struct seg {
    int l, r, p;
} a[MAX_N];

bool cmp(const seg &a, const seg &b) {
    return a.r < b.r;
}

int n, k;

int dp[3005][3005];

bool good(int i, int j) {
    if (a[i].r < a[j].r && a[j].l > a[i].l && a[j].l <= a[i].r + 1)
        return 1;
    return 0;
}

int main() {
    #ifdef NICK
    freopen("input.txt", "r", stdin);
    #endif // NICK
    scanf("%d%d", &n, &k);
    for (int i = 1; i <= n; i++)
        scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p);
    sort(a + 1, a + n + 1, &cmp);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        dp[i][j] = inf;
    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++) {
            if (!good(i, j))
                continue;
            if (a[i].l == 1)
                dp[i][j] = (a[j].l == a[i].r + 1 ? max(a[j].p, a[i].p) : a[j].p + a[i].p);
            if (dp[i][j] == inf)
                continue;
            for (int nw = j + 1; nw <= n; nw++) {
                if (!good(j, nw))
                    continue;
                if (a[nw].l <= a[i].r)
                    continue;
                int val = (a[nw].l == a[j].r + 1 ? max(a[j].p, a[nw].p) : a[j].p + a[nw].p);
                val = max(val, dp[i][j]);
                dp[j][nw] = min(dp[j][nw], val);
            }
        }
    int ans = inf;
    for (int i = 1; i <= n; i++) {
        if (a[i].l == 1 && a[i].r == k)
            ans = min(ans, a[i].p);
        for (int j = i + 1; j <= n; j++)
            if (a[j].r == k)
                ans = min(ans, dp[i][j]);
    }
    ans = (ans == inf ? -1 : ans);
    printf("%d", ans);
    return 0;
}
