#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define mp make_pair
#define sz(a) (int)((a).size())

typedef long long ll;
typedef long double ld;
typedef pair < int, int > pi;
typedef pair < ll, ll > pl;

const int MAX_N = (int)2e5 + 123;
const int inf = (int)2e9 + 123;

int n, k;

struct seg {
    int l, r, p;
    bool operator < (const seg &b) const {
        return r < b.r;
    }
} a[MAX_N];

map < int, int > pref;

bool bad() {
    for (int i = 1; i <= n; i++)
        pref[a[i].l]++, pref[a[i].r + 1]--;
    if (pref[1] == 0)
        return 1;
    int now = 0;
    for (auto i : pref) {
        now += i.s;
        if (now == 0 && i.f <= k)
            return 1;
    }
    return 0;
}

map < int, int > good;

void Solution_for_one() {
    good[0] = 1;
    for (int i = 1; i <= n; i++) {
        if (good[a[i].l - 1])
            good[a[i].r] = 1;
    }
    printf("%d", (good[k] ? 1 : 2));
    exit(0);
}

bool Good(int i, int j) {
    if (a[i].r < a[j].r && a[j].l > a[i].l && a[j].l <= a[i].r + 1)
        return 1;
    return 0;
}

int dp[MAX_N];

bool check(int val) {
    for (int i = 1; i <= n; i++) {
        dp[i] = inf;
        if (a[i].p > val)
            continue;
        if (a[i].l == 1) {
            dp[i] = 0;
            continue;
        }
        for (int last = 1; last < i; last++)
            if (Good(last, i) && a[last].p + a[i].p <= val && dp[last] < a[i].l)
                dp[i] = min(dp[i], a[last].r);
    }
    for (int i = 1; i <= n; i++)
        if (a[i].r == k && dp[i] != inf)
            return 1;
    return 0;
}

int main() {
    #ifdef NICK
    freopen("input.txt", "r", stdin);
    #endif // NICK
    scanf("%d%d", &n, &k);
    for (int i = 1; i <= n; i++)
        scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p);

    if (bad()) {
        puts("-1");
        exit(0);
    }

    sort(a + 1, a + n + 1);
    bool allone = 1;
    for (int i = 1; i <= n; i++)
        if (a[i].p != 1) {
            allone = 0;
            break;
        }
    if (allone)
        Solution_for_one();

    int l = 1, r = (int)2e9, mid = -1, ans = -1;
    while(l <= r) {
        mid = (l + r) / 2;
        if (check(mid)) {
            ans = mid;
            r = mid - 1;
        }
        else
            l = mid + 1;
    }
    assert(ans != -1);
    printf("%d", ans);
    return 0;
}
