#include <bits/stdc++.h>

#define size(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
const long long inf = 2e5;
typedef long long ll;

using namespace std;

ll n;
vector < ll > l(n);

bool can(ll k) {
	k--;
	ll ans = 0;
	vector < ll > s(l[0], 0);
	for (ll i = 1; i < n; i++) {
		if (l[i] == l[i - 1]) {
			bool fl = false;
			for (ll i = size(s) - 1; i >= 0; i--) {
				if (s[i] < k) {
					s[i]++;
					ans = max(s[i], ans);
					i++;
					fl = true;
					for (;i < size(s); i++) s[i] = 0;
					break;
				}
			}
			if (!fl) return false;
		} else if (l[i] < l[i - 1]) {
			bool fl = false;
			while (size(s) > l[i]) s.pop_back();
			for (ll i = size(s) - 1; i >= 0; i--) {
				if (s[i] < k) {
					s[i]++;
					ans = max(s[i], ans);
					i++;
					fl = true;
					for (;i < size(s); i++) s[i] = 0;
					break;
				}
			}
			if (!fl) return false;
		} else {
			while (size(s) < l[i]) s.push_back(0);
		}
	}
	return ans <= k;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	cin >> n;
	l.resize(n);
	for (ll i = 0; i < n; i++) cin >> l[i];

	// cout << can(2) << "\n";
	// return 0;

	ll l = 0, r = inf + 1;
	while (r - l > 1) {
		ll m = l + (r - l) / 2;
		if (can(m)) r = m;
		else l = m;
	}

	cout << r;

	return 0;
}
/*
bool can(ll k) {
	ll ans = 1;
	vector < pair < ll, ll > > s;
	s.push_back({0, 0});
	s.push_back({l[0], 1});
	for (ll i = 1; i < n; i++) {
		if (l[i] < l[i - 1]) {
			ll last = 0, idx = inf;
			while (size(s) > 1 && (s.back().first > l[i] || s.back().second >= k)) {
				last = s.back().second;
				idx = s.back().first;
				s.pop_back();
				if (s.back().first < l[i] && last < k) {
					idx = l[i];
					break;
				}
			}
			if (size(s) > 1 && s.back().second < k && last >= k) {
				last = s.back().second;
				idx = s.back().first;
				s.pop_back();
			}
			if ((last >= k)) {
				return false;
			}
			idx = min(idx, l[i]);
			if (l[i] - 1 > 0 && (s.empty() ? 1 : s.back().first + 1 != l[i])) s.push_back({l[i] - 1, last});
			s.push_back({l[i], last + 1});
			ans = max(ans, last + 1);
		} else if (l[i] == l[i - 1]) {
			ll last = 0, idx = inf;
			while (!s.empty() && s.back().second >= k) {
				last = s.back().second;
				idx = s.back().first;
				s.pop_back();
			}
			if (size(s) > 1) {
				last = s.back().second;
				idx = s.back().first;
				s.pop_back();
			}
			if ((s.back().first + 1 < idx) || (s.empty() && idx > 1)) s.push_back({idx - 1, last});
			s.push_back({idx, last + 1});
			ans = max(ans, last + 1);
			if (s.back().first < l[i]) s.push_back({l[i], 1});
		} else {
			s.push_back({l[i], 1});
		}
	}
	return ans <= k;
}
*/