#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <algorithm>
#	include <string>
#	include <vector>
#	include <iomanip>
#	include <functional>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = (ll)1e9 + 7;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n;
	cin >> n;

	string s;
	cin >> s;

	int x, y;
	cin >> x >> y;

	vector<int> a(4, 0);

	int x_max = 0, x_min = 0, y_max = 0, y_min = 0;
	for (int i = 0; i < n; i++)
		if (s[i] == 'U')
		{
			y_max++;

			if (y_max == y)
				a[1] = i + 1;
		}
		else if (s[i] == 'D')
		{
			y_min--;

			if (y_min == y)
				a[3] = i + 1;
		}
		else if (s[i] == 'L')
		{
			x_min--;

			if (x_min == x)
				a[0] = i + 1;
		}
		else
		{
			x_max++;
			if (x_max == x)
				a[2] = i + 1;
		}

	if (x > x_max || x < x_min || y > y_max || y < y_min)
	{
		cout << -1 << endl;
		return 0;
	}

	cout << a[0] << ' ' << a[1] << ' ' << a[2] << ' ' << a[3] << endl;
}