#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <algorithm>
#	include <string>
#	include <vector>
#	include <iomanip>
#	include <functional>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)1e9 + 7;

ll res(vector<ll> &u, vector<pair<pair<ll, ll>, pair<ll, ll>>> &a, ll c, ll k)
{
	if (c == u.size())
	{
		ll p = 0, l = 1, r = 1, m = 0, cnt = 0;

		while (p < a.size())
		{
			if (u[a[p].second.second] == 1)
				if (a[p].first.second == 0)
				{
					if (cnt == 0 && a[p].first.first > r + 1)
						return INF;

					cnt += a[p].second.first;

					if (cnt > m)
						m = cnt;
				}
				else
				{
					cnt -= a[p].second.first;
					r = a[p].first.first;
				}

			p++;
		}

		if (r != k)
			return INF;
		else
			return m;
	}
	else
	{
		ll ans = INF;

		u[c] = 0;
		ans = min(ans, res(u, a, c + 1, k));

		u[c] = 1;
		ans = min(ans, res(u, a, c + 1, k));

		return ans;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	ll n, k;
	cin >> n >> k;

	vector<pair<pair<ll, ll>, pair<ll, ll>>> a;
	for (ll i = 0; i < n; i++)
	{
		ll l, r, p;
		cin >> l >> r >> p;
		a.push_back(make_pair(make_pair(l, 0), make_pair(p, i)));
		a.push_back(make_pair(make_pair(r, 1), make_pair(p, i)));
	}

	sort(a.begin(), a.end());

	vector<ll> us(n, 0);

	ll t = res(us, a, 0, k);

	if (t == INF)
		cout << -1 << endl;
	else
		cout << t << endl;
}