//#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <algorithm>
#	include <string>
#	include <vector>
#	include <iomanip>
#	include <functional>
//#else
//#	include <bits/stdc++.h>
//#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = (ll)1e9 + 7;
const ll SIZE = 1000;

vector<ll> my_pow2_res(1, 1);
ll my_pow2(ll n)
{
	if (n < my_pow2_res.size())
		return my_pow2_res[n];
	my_pow2_res.push_back(2 * my_pow2(n - 1));
	return my_pow2_res.back();
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif

	ll g;
	scanf("%lld", &g);

	for (ll _i = 0; _i < g; _i++)
	{
		ll a, b;

		ll l = 0, r = 60;
		while (l < r - 1)
		{
			ll m = (r - l) / 2 + l;

			printf("X %lld\n", my_pow2(m));
			fflush(stdout);
			scanf("%lld", &a);
			if (a == -1)
				return 0;
			scanf("%lld", &b);

			if (a == 1 && b == my_pow2(m))
				l = m;
			else
				r = m;
		}

		printf("X %lld\n", my_pow2(l + 1));
		fflush(stdout);
		scanf("%lld", &a);
		if (a == -1)
			return 0;
		scanf("%lld", &b);

		printf("N %lld\n", (my_pow2(l) * a / (b - a * my_pow2(l + 1)) * 2 + 1));
		fflush(stdout);

		char s[SIZE];
		scanf("%s", s);

		if (s[0] == 'W')
			return 0;
	}
}