#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define line vector<ll>
#define ld long double
#define pll pair<ll, ll>
#define f first
#define s second
#define forx(x, a) for(auto &x : a)
#define forn(i, n) for(ll i = 0; i < n; i++)
#define all(a) a.begin(), a.end()

#define INF 1e9 * 1e5

struct event
{
    ll st, fi;
    ll p;

    event()
    {
        st = fi = p = -1;
    }

    event(ll a, ll b)
    {
        st = a;
        fi = b;
    }
    event(ll a)
    {
        p = a;
    }
    event(ll a, ll b, ll c)
    {
        st = a;
        fi = b;
        p = c;
    }
};

istream &operator >> (istream &in, event &e)
{
    in >> e.st >> e.fi >> e.p;
    return in;
}

struct cur
{
    ll pos;
    ll type;
    ll pr;

    cur()
    {
        pos = type = pr = -1;
    }

    cur(const cur &b)
    {
        pos = b.pos;
        type = b.type;
        pr = b.pr;
    }

    cur(event a, ll t)
    {
        type = t;
        if (type == 1)
        {
            pos = a.st;
            pr = a.p;
        }
        else
        {
            pos = a.fi;
            pr = -a.p;
        }
    }

    bool operator < (cur b)
    {
        if (pos < b.pos)
            return true;
        if (pos > b.pos)
            return false;
        return type < b.type;
    }
};

ll n, k, ans = INF;
vector<event> parts;

void cnt(line &take)
{
    /*forx(x, take)
        cerr << x << " ";
    cerr << "\n";*/

    cur tmp1(event(0, 0, 0), 1);
    cur tmp2(event(k + 1, k + 1, 0), 1);

    vector<cur> today;
    today.push_back(tmp1);
    today.push_back(tmp2);

    forn(i, n)
    {
        if (take[i])
        {
            today.push_back({parts[i], 1});
            today.push_back({parts[i], 2});
        }
    }
    sort(all(today));

    /*forx(x, today)
    {
        cerr << x.pos << " ";
    }
    cerr << "\n";*/

    ll mx = 0;
    ll now = 0;
    //cerr << today[0].pos << " ";
    for (ll i = 1; i < today.size(); i++)
    {
        mx = max(mx, now);
        //cerr << today[i].pos << " ";
        if (now == 0 && !(today[i].pos == (today[i - 1].pos + 1)))
        {
            //cerr << "\n\n\n\n";
            return;
        }
        now += today[i].pr;
        mx = max(mx, now);
    }
    //cerr << mx << " " << ans << "\n";
    ans = min(ans, mx);
}

void gen(line &data, ll index)
{
    if (index == n)
    {
        cnt(data);
        return;
    }
    data[index] = 0;
    gen(data, index + 1);

    data[index] = 1;
    gen(data, index + 1);

    return;
}

int main()
{
    #ifdef LOCAL
    freopen("nap.in", "rt", stdin);
    freopen("nap.out", "wt", stdout);
    #else
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);
    #endif // LOCAL

    cin >> n >> k;
    parts.resize(n);

    forx(x, parts)
    {
        cin >> x;
    }

    line tmp(n);
    gen(tmp, 0);

    if (ans == INF)
        ans = -1;

    cout << ans;
    cerr << ans;

    return 0;
}
