#include <bits/stdc++.h>
using namespace std;

int n;
vector<int> l;

bool check(int c) {
    vector<pair<int, int>> cur;
    int curlen = 0;

    for (int i = 0; i < n; i++) {
        if (l[i] > curlen) {
            curlen = l[i];
        } else {
            if (c == 0) {
                return false;
            }
            while (!cur.empty() && cur.back().first > l[i]) {
                cur.pop_back();
            }
            int index = l[i];
            while (!cur.empty() && index > 0 && cur.back().first == index && cur.back().second == c) {
                cur.pop_back();
                index--;
            }
            if (index < 1) {
                return false;
            }
            if (!cur.empty() && cur.back().first == index) {
                cur.back().second++;
            } else {
                cur.push_back(make_pair(index, 1));
            }
            curlen = l[i];
        }
    }
    return true;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif

    scanf("%d", &n);
    l.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }

    int L = -1;
    int R = n;
    while (R - L > 1) {
        int M = (R + L) / 2;
        if (check(M)) {
            R = M;
        } else {
            L = M;
        }
    }

    cout << R + 1 << endl;

    return 0;
}