#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <ctime>

using namespace std;

bool is_prime(long long a){
    long long i = 2;
    while (i * i <= a){
        if (a % i == 0){
            return false;
        }
        ++i;
    }

    return true;
}

long long gcd(long long a, long long b){
    while (b != 0){
        a %= b;
        swap(a, b);
    }

    return a;
}

int main(){
    ios::sync_with_stdio(false);
    //cin.tie(0);

    srand(time(NULL));

    vector<long long> sransk;

    for (long long i = 3; i < 1000; ++i){
        if (is_prime(i)){
            sransk.push_back(i);
        }
    }

    long long n;
    cin >> n;

    for (long long z = 0; z < n; ++z){
        long long b = 1;
        long long c, d;

        cout << "X " << 2 << endl;
        cin >> c >> d;
        b = (b * d) / gcd(b, d);

        for (long long i = 0; i < 30; ++i){
            cout << "X " << sransk[i] << endl;
            cin >> c >> d;
            b = (b * d) / gcd(b, d);
        }

        /*for (long long i = 0; i < 49; ++i){
            cout << "X " << sransk[rand() % sransk.size()] << endl;
            cin >> c >> d;
            b = (b * d) / gcd(b, d);
        }*/

        cout << "N " << b << endl;
        string str;
        cin >> str;
        if (str == "Wrong"){
            assert(false);
        }
    }

    return 0;
}
