#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

bool check(const vector<int> &ch)
{
    if (ch.size() == 1)
        return false;

    for (int i = 1; i < ch.size(); i++)
        if (ch[i] > ch[i-1])
            return false;

    return true;
}

int main()
{
    int n;
    cin >> n;

    vector<int> v(n);
    for (int &e : v)
        cin >> e;

    int max_e = *(max_element(v.begin(), v.end()));
    vector<int> ch(max_e+1, 0);

    int ptr = 0;
    int res = 0;
    for (int i = 0; i < n; i++) {
        int last_ptr = ptr;
        ptr = v[i];

        if (ptr > last_ptr)
            for (int j = last_ptr; j < ptr; j++)
                ch[j] = 0;
        else
            if (check(ch))
                ch[ptr-1]++;
            else
                next_permutation(ch.begin(), ch.begin()+ptr);

        res = max(res, *(max_element(ch.begin(), ch.begin()+ptr)));
    }

    cout << res + 1<< endl;
}
