#include <bits/stdc++.h>

#define fs first
#define sc second
#define int int64_t

using namespace std;


const int INF = 1e10;

const int max_n = 1024 * 256;

vector <int> go[max_n];

struct Tree {
    vector <int> t;

    Tree() {
        t.resize(max_n, INF);
    }

    int get(int l, int r, int tl, int tr, int v) {
        if (l <= tl && r >= tr) {
            return t[v];
        }

        if (l > tr || r < tl) {
            return INF;
        }vector <int> go[max_n + 1];
        return min(get(l, r, tl, (tl + tr) / 2, v * 2), get(l, r, (tl + tr) / 2 + 1, tr, v * 2 + 1));
    }

    void upd(int c, int x) {
        c += max_n;
        while (c) {
            t[c] = min(t[c], x);
            c /= 2;
        }
    }
};

signed main() {
    int k, n;
    cin >> n >> k;
    int p[n], l[n], r[n], bl[n];
    vector <int> comp;
    comp.push_back(-1);
    int max_x = 0;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i] >> p[i];
        bl[i] = l[i];
        max_x = max(max_x, r[i]);
        comp.push_back(r[i]);
        comp.push_back(l[i] - 1);
    }
    comp.push_back(k);vector <int> go[max_n + 1];
    max_x = k;
    sort(comp.begin(), comp.end());
    for (int i = 0; i < n; i++) {
        r[i] = lower_bound(comp.begin(), comp.end(), r[i]) - comp.begin();
        l[i] = lower_bound(comp.begin(), comp.end(), l[i] - 1) - comp.begin();
        go[r[i]].push_back(i);
    }
    max_x = lower_bound(comp.begin(), comp.end(), max_x) - comp.begin();
    int L = 0, R = INF;
    while (R - L > 1) {
        int MID = (R + L) / 2;
        Tree dp;
        dp.upd(0, 0);
        for (int i = 1; i <= max_x; i++) {
            for (int v : go[i]) {
                if (comp[l[v]] == bl[v] - 1) {
                    if (dp.t[l[v] + max_n] <= MID && p[v] <= MID) {
                        dp.upd(i, p[v]);
                    }
                }
                if (dp.get(l[v], r[v] - 1, 0, max_n, 1) + p[v] <= MID) {
                    dp.upd(i, p[v]);
                }
            }
        }
        if (dp.t[max_x + max_n] <= MID) {
            R = MID;
        } else {
            L = MID;
        }
    }
    if (R != INF) {
        cout << R;
    } else {
        cout << -1;
    }
    return 0;
}
