#include <bits/stdc++.h>

#define fs first
#define sc second
#define int int64_t

using namespace std;


const int INF = 1e12 + 228;
const int max_n = (1 << 18);

vector <int> go[max_n];

struct Tree {
    vector <int> t;

    Tree() {
        t.resize(max_n * 2, INF);
    }

    int get(int l, int r, int tl, int tr, int v) {
        if (l <= tl && r >= tr) {
            return t[v];
        }

        if (l > tr || r < tl) {
            return INF;
        }
        return min(get(l, r, tl, (tl + tr) / 2, v * 2), get(l ,r, (tl + tr) / 2 + 1, tr, v * 2 + 1));
    }

    void upd(int c, int x) {
        c += max_n;
        while (c) {
            t[c] = min(t[c], x);
            c /= 2;
        }
    }
};

signed main() {
    int k, n;
    cin >> n >> k;

    int p[n], l[n], r[n], bl[n];
    vector <int> comp;
    comp.push_back(0);
    int max_x = 0;
    int max_p = 0;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i] >> p[i];
        max_p = max(max_p, p[i]);
        bl[i] = l[i];
        max_x = max(max_x, r[i]);
        comp.push_back(r[i]);
        comp.push_back(l[i] - 1);
    }
    if (max_p != 1) {
        int ans = INF;
        for (int i = 1; i < (1 << n); i++) {
            vector <pair <int, pair <int, int> > > happ;
            for (int j = 0; j < n; j++) {
                if (i & (1 << j)) {
                    happ.push_back({l[j], {-1, j}});
                    happ.push_back({r[j], {1, j}});
                }
            }
            sort(happ.begin(), happ.end());
            if (happ[0].fs > 1 || happ[happ.size() - 1].fs < k) {
                continue;
            }
            int just = p[happ[0].sc.sc];
            int maxx = just;
            for (int j = 1; j < happ.size(); j++) {
                if (just == 0) {
                    maxx = ans;
                    break;
                }
                if (happ[j].sc.fs == -1) {
                    just += p[happ[j].sc.sc];
                    maxx = max(maxx, just);
                } else {
                    just -= p[happ[j].sc.sc];
                }
            }
            ans = min(ans, maxx);
        }
        if (ans != INF) {
            cout << ans;
        } else {
            cout << -1;
        }
        return 0;
    }
    sort(comp.begin(), comp.end());

    for (int i = 0; i < n; i++) {
        r[i] = lower_bound(comp.begin(), comp.end(), r[i]) - comp.begin();
        l[i] = lower_bound(comp.begin(), comp.end(), l[i] - 1) - comp.begin();
        go[r[i]].push_back(i);
    }
    if (max_x < k) {
        cout << -1;
        return 0;
    }
    max_x = lower_bound(comp.begin(), comp.end(), k) - comp.begin();
    //cout << max_x << '\n';
    int L = 0, R = INF;
    while (R - L > 1) {
        int MID = L + (R - L) / 2;
        Tree dp;
        dp.upd(0, 0);
        for (int i = 1; i <= max_x; i++) {
            for (int v : go[i]) {
                if (comp[l[v]] == bl[v] - 1) {
                    if (dp.get(l[v], l[v], 0, max_n - 1, 1) <= MID && p[v] <= MID) {
                        dp.upd(i, p[v]);
                    }
                }
                if (dp.get(l[v], r[v] - 1, 0, max_n - 1, 1) <= MID - p[v]) {
                    dp.upd(i, p[v]);
                    //cout << i << ' ' << p[v] << '\n';
                }
            }
        }
        if (dp.get(max_x, max_x, 0, max_n - 1, 1) <= MID) {
            R = MID;
        } else {
            L = MID;
        }
    }
    if (R != INF) {
        cout << R;
    } else {
        cout << -1;
    }
    return 0;
}
