#include <bits/stdc++.h>

using namespace std;


template<typename T1, typename T2> istream &operator >> (istream &in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T> istream &operator >> (istream &in, vector<T> &arr) {
    for (auto &i : arr) {
        in >> i;
    }
    return in;
}

template<typename T> ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto i : arr) {
        out << i << ' ';
    }
    out << endl;
    return out;
}

//kd
const int MAXN = 1e6 + 10;
int mr[MAXN], md[MAXN], mu[MAXN], ml[MAXN];


int main()
{
    int n;
    string s;
    int x, y;
    cin >> n >> s >>x >> y;
    for (int i(n); i >= 1; i--) {
        md[i]=md[i - 1];
        mu[i] = mu[i - 1];
        ml[i] = ml[i - 1];
        mr[i] = mr[ i - 1];
        if (s[i - 1] == 'D') {
            md[i]++;
        }
        if (s[i - 1] == 'U') {
            mu[i]++;
        }
        if (s[i - 1] == 'R' ) {
            mr[i]++;
        }
        if (s[ i - 1] == 'L') {
            ml[i]++;
        }
    }

    int bml = 0, bmu = -1, bmr = 0, bmd = -1;
    for (int i(0); i <= n; i++) {
        int curry = mu[i];
        if (curry >= y) {
            int kek = lower_bound(md, md + n + 1, curry - y) - md;
            if (kek <= n && md[kek] == curry - y) {
                bmu = i;
                bmd = kek;
                //cout << i << ' ' << kek << endl;
                break;
            } else {
                cout << -1 << endl;
                return 0;
            }
        }
        int currx = mr[i];
        if (currx >= x) {
            int kek = lower_bound(ml, ml + n + 1, currx - x) - ml;
            if (kek <= n && ml[kek] == currx - x) {
                bmr = i;
                bml = kek;
                break;
            } else {
                cout << -1 << endl;
                return 0;
            }
        }
    }
    if (bmd == -1) {
        cout << -1 << endl;
        return 0;
    }
    /*if (mr[1] - ml[1] != x || mu[1] - md[1] != y) {
        cout << -1 << endl;
        return 0;
    }*/
    cout << bml << ' ' << bmu << ' ' << bmr << ' ' << bmd << endl;
    return 0;
}
