#include <bits/stdc++.h>

using namespace std;
#define int int64_t

template<typename T1, typename T2> istream &operator >> (istream &in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T> istream &operator >> (istream &in, vector<T> &arr) {
    for (auto &i : arr) {
        in >> i;
    }
    return in;
}

template<typename T> ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto i : arr) {
        out << i << ' ';
    }
    out << endl;
    return out;
}

//kd

vector<pair<int, pair<int, int>>> a;


int get(vector<int> &ind, int k) {
    vector<int> bal(k + 1);
    for (auto u : ind) {
        //cout << a[u].first << ' ' << a[u].second.first << endl;
        for (int i(a[u].first); i <= a[u].second.first; i++) {
            bal[i] += a[u].second.second;
        }
    }
    int mx = -1e18;
    for (int i(1); i < k + 1; i++) {
        if (bal[i] == 0) {
            return -1;
        }
        mx = max(mx, bal[i]);
    }
    //cout << endl;
    return mx;
}

signed main()
{
    int n, k;
    cin >> n >> k;
    a.resize(n);

    for (int i(0); i < n; i++) {
        int l, r, p;
        cin >> l >> r >> p;
        a[i] = {l, {r, p}};
    }
    int ans = 1e18;
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> ind;
        for (int i(0); i < n; i++) {
            if ((mask >> i) & 1) {
                ind.push_back(i);
            }
        }
        int gt = get(ind, k);
        if (gt != -1) {
            ans = min(ans, gt);
        }
    }
    if (ans == 1e18) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
    return 0;
}
