#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define eb emplace_back

typedef long long ll;
typedef long double ld;

int get(char c) {
    if (c == 'L') return 0;
    if (c == 'R') return 1;
    if (c == 'U') return 2;
    return 3;
}

const int NF = -228;

int fnd(int t, int needx, vector<vector<int> > &pf) {
    if (needx == 0) return -1;
    for (int i = 0; i < pf.size(); i++) {
        if (pf[i][t] == needx) return i;
    }
    return NF;
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    string s;
    cin >> s;
    ll x, y;
    cin >> x >> y;
    vector<vector<int> > pf(n, vector<int> (4));
    for (int i = 0; i < n; i++) {
        if (i) pf[i] = pf[i - 1];
        pf[i][get(s[i])]++;
    }

    map<ll, int> posr, posu;

    for (int i = 0; i < n; i++) {
        if (posr.count(pf[i][1])) continue;
        posr[pf[i][1]] = i;
    }

    for (int i = 0; i < n; i++) {
        if (posu.count(pf[i][2])) continue;
        posu[pf[i][2]] = i;
    }

    pair<int, int> res = {-1, -1};

    posr[0] = -1;
    posu[0] = -1;

    for (int pd = -1; pd < n; pd++) {
        ll dy = 0;
        if (pd != -1) dy = -pf[pd][3];
        if (!posu.count(y - dy)) continue;
        int pu = posu[y - dy];
        res = {pu + 1, pd + 1};
    }


    for (int pl = -1; pl < n; pl++) {
        ll dx = 0;
        if (pl != -1) dx = -pf[pl][0];
        if (!posr.count(x - dx)) continue;
        int pr = posr[x - dx];

        cout << pl + 1 << ' ' << res.F << ' ' << pr + 1<< ' ' << res.S;
        return 0;
    }
    cout << -1;
    return 0;
}
