#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <cmath>
#include <stack>
#include <queue>
#include <set>
#include <map>

#define ft first
#define sd second
#define mk make_pair
#define pb push_back
#define pf push_front
#define all(c) (c).begin(), (c).end()
#define SWS ios_base::sync_with_stdio(false)
#define rfile freopen("input.txt", "r", stdin)
#define wfile freopen("output.txt", "w", stdout)

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int Z = (int)1e5 + 111;
const int INF = (int)1e9 + 111;
const int MODF = (int)1e9 + 7;

int n, k, l[Z], r[Z], c[Z];

ll tr(int x) {
    //cout << x << '\n';
    ll ans = -1, cnt = 0;
    vector <pair <int, pair <int, int> > > v;
    for (int i = 0; i < n; i++)
    if ((x >> i) & 1) {
        v.pb(mk(l[i], mk(1, c[i])));
        v.pb(mk(r[i] + 1, mk(0, c[i])));
    }
    sort(all(v));
    if (v.front().ft > 1)
        return -1;
    for (int i = 0; i < v.size(); i++) {
        //cout << v[i].ft << ' ' << v[i].sd.ft << ' ' << v[i].sd.sd << '\n';
        if (v[i].sd.ft == 1) {
            cnt += v[i].sd.sd;
            ans = max(ans, cnt);
            if (i && v[i - 1].sd.ft == 0 && v[i].ft > v[i - 1].ft)
                return -1;
        }
        else
            cnt -= v[i].sd.sd;
    }
    //cout << ans << "\n\n";
    if (v.back().ft - 1 < k)
        return -1;
    return ans;

}

int main()
{
    ll ans = INF * INF;
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i] >> c[i];
    for (int i = 1; i < (1 << n); i++) {
        int t = tr(i);
        if (t >= 0)
            ans = min(tr(i), ans);
    }

    cout << ans;

    return 0;
}
