/*
	Open Olympiad 2017 tour 1
	Task A
	Solve by Ed_Os
*/
#include <iostream>
#include <cstdio>
#include <time.h>
#include <cstdlib>
#include <map>
using namespace std;
#define ll long long
#define ull unsigned long long

const int max_n = 100500;
map<int,bool> w;
map<int,int>   q,c;

int n,a[max_n],ans,lst[max_n],lst_sz,mx_l;
bool check(int mx_b)
{
	for(int i = 0;i < mx_l;i++)
		lst[i] = 0;
	bool fnd;
	for(int i = 1;i < n;i++)
	{
		fnd = false;
		if(a[i] <= a[i - 1])
		{
			for(int j = a[i] - 1;j >= 0 && !fnd;j--)
				if(lst[j] + 1 < mx_b)
				{
					lst[j]++;
					for(int z = j + 1;j < mx_l;j++)
						lst[z] = 0;
					fnd = true;
				}
		}
		else
		{
			for(int z = a[i-1];z < mx_l;z++)
				lst[z] = 0;
			fnd = true;
		}
		if(!fnd)
			return false;
	}
	return true;
}
int main()
{
	//freopen("input","r",stdin);
	ios_base::sync_with_stdio(false);
	cin >> n;
	for(int i = 0;i < n;i++)
	{
		cin >> a[i];
		mx_l = a[i];
	}
	int l = 1,r = 1000000000,mid;
	while(l <= r)
	{
		mid = (l + r)/2;
		//cout << mid << endl;
		if(check(mid))
		{
			ans = mid;
			r = mid - 1;
		}
		else
			l = mid + 1;
	}
	cout << ans;
	return 0;
}
