#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

#define TASK "sample"

const int maxN = 1e5 + 100;
const int INF = 1e9;
const long long LINF = 3e18;
const long long MOD = 1e9 + 7;
const long long P = 257;
const int K = 1000;

map<int, int> cnt;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif

	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; i++)
	{
		int l;
		scanf("%d", &l);
		cnt[l]++;
	}

	long long l = 0, r = maxN;
	while (r - l > 1)
	{
		long long m = (l + r) / 2;
		bool flag = true;

		for (auto it : cnt)
		{
			if (m == 1 && it.second > 1)
				flag = false;
			else if (m > 1)
			{
				long long curr = 1;
				for (int j = 0; j < it.first; j++)
				{
					curr *= m;
					if (curr >= it.second)
						break;
				}
				if (curr < it.second)
					flag = false;
			}
		}
		if (flag)
		{
			r = m;
		}
		else
			l = m;
	}

	printf("%lld", r);
	
	return 0;
}

