#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

#define TASK "sample"

const int maxN = 1e5 + 100;
const int INF = 1e9;
const long long LINF = 3e18;
const long long MOD = 1e9 + 7;
const long long P = 257;
const int K = 1000;

long long len[maxN];

map<int, int> c;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	int n;
	scanf("%d", &n);
	
	for (int i = 0; i < n; i++)
	{
		scanf("%lld", &len[i]);
	}

	if (n == 1)
	{
		printf("1");
		return 0;
	}
	bool h = true;
	for (int i = 0; i < n - 1; i++)
	{
		if (len[i] >= len[i + 1])
		{
			h = false;
		}
	}
	if (h)
	{
		printf("1");
		return 0;
	}

	int l = 1, r = n;
	while (r - l > 1)
	{
		int m = (l + r) / 2;

		bool flag = true;
		c.clear();
		int cl = 0;
		for (int i = 0; i < n; i++)
		{
			if (len[i] > cl)
			{
				cl = len[i];
			}
			else
			{
				cl = len[i];
				while (!c.empty() && c.rbegin()->first >= cl)
				{
					c.erase(c.rbegin()->first);
				}
				int pos = len[i] - 1;
				while (1)
				{
					if (pos == -1)
					{
						flag = false;
						break;
					}
					if (c.count(pos) == 0)
					{
						c[pos] = 1;
						break;
					}
					else
					{
						c[pos]++;
						if (c[pos] == m)
							c[pos] = 0, pos--;
						else
							break;
					}
				}
				if (!flag)
					break;
			}
		}
		if (flag)
			r = m;
		else
			l = m;
	}

	printf("%d", r);

	return 0;
}

