#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct segTree {
    int n;
    vector<int> t;
    inline segTree(int _n){
        n=_n;
        t.assign(2*n,INT_MAX);
    }
    inline void upd(int v,int val){
        v+=n;
        if(val>=t[v])return;
        t[v]=val;
        for(v>>=1;v;v>>=1)
            t[v]=min(t[v*2],t[v*2+1]);
    }
    inline int get(int l,int r){
        int res=INT_MAX;
        for(l+=n,r+=n;l<=r;l=(l+1)>>1,r=(r-1)>>1){
            if(l&1)res=min(res,t[l]);
            if(!(r&1))res=min(res,t[r]);
        }
        return res;
    }
};

struct seg {
    int l,r,p;
    seg(){}
    inline bool operator < (const seg&x)const{return r<x.r;}
};

int n,k;
seg s[100000];
vector<int> vinsort;
map<int,int> insort;

inline bool ok(int hi){
    segTree rmq(vinsort.size());
    vector<bool> can(n,false);
    for(int i=0;i<n;i++){
        if(s[i].p>hi)continue;
        if(s[i].l==1)can[i]=true;
        else {
            int bl=0,br=(int)vinsort.size()-1;
            while(bl<br){
                int bm=(bl+br)>>1;
                if(vinsort[bm]>=s[i].l)br=bm;
                else bl=bm+1;
            }
            int y=rmq.get(bl,insort[s[i].r]);
            if(y!=INT_MAX&&y+s[i].p<=hi)can[i]=true;
            if(bl!=0&&vinsort[bl-1]==s[i].l-1&&rmq.get(bl-1,bl-1)<=hi)can[i]=true;
        }
        if(can[i])rmq.upd(insort[s[i].r],s[i].p);
        if(can[i]&&s[i].r==k)return true;
    }
    return false;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin>>n>>k;
    for(int i=0;i<n;i++)cin>>s[i].l>>s[i].r>>s[i].p,insort[s[i].r];
    for(auto it=insort.begin(); it!=insort.end(); it++){
        it->second=(int)vinsort.size();
        vinsort.push_back(it->first);
    }
    sort(s,s+n);
    if(s[n-1].r<k)return cout<<-1,0;
    int z=s[n-1].l;
    for(int i=n-2;i>=0;i--){
        if(s[i].r+1<z)return cout<<-1,0;
        z=min(z,s[i].l);
    }
    if(z!=1)return cout<<-1,0;
    ll bl=1,br=2000000000;
    while(bl<br){
        ll bm=(bl+br)>>1;
        if(ok(bm))br=bm;
        else bl=bm+1;
    }
    cout<<bl;
}
