#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#define fi first
#define se second
using namespace std;
typedef long long ll;

const int MAXN = 1e5 + 10;

int n = 0;
int l[MAXN];
vector<int> s[MAXN];

inline int get_next(int i, int k){
    if (l[i] < l[i+1]){
        s[i+1].assign(l[i+1], 0);
        for (int j = 0; j < l[i]; j++){
            s[i+1][j] = s[i][j];
        }
       /* for (int j = l[i]; j < l[i + 1]; j++){
            s[i+1][j] = 0;
        }*/
        return 1;
    }
    /*if (l[i] == l[i + 1]){
        int m = l[i + 1];
        s[i+1].assign(m, 0);
        for (int j = 0; j < m; j++){
            s[i+1][j] = s[i][j];
        }
        s[i + 1][m - 1]++;
        for (int j = m - 1; j > 0; j--){
            if (s[i+1][j] >= k){
                s[i+1][j - 1] += (int)(s[i+1][j] / k);
                s[i+1][j] %= k;
            }
        }
        if (s[i + 1][0] >= k){
            return -1;
        }
        return 1;
    }*/

   // if (l[i] > l[i + 1]){
    int m = l[i + 1];
    s[i+1].assign(m, 0);
    for (int j = 0; j < m; j++){
        s[i+1][j] = s[i][j];
    }
    s[i + 1][m - 1]++;
    for (int j = m - 1; j > 0; j--){
        if (s[i+1][j] == k){
            s[i+1][j - 1]++;
            s[i+1][j] = 0;
        }
    }
    if (s[i + 1][0] >= k){
        return -1;
    }
    return 1;

}

/*inline bool is_lower(int x, int k){
    int m = min(l[x], l[x + 1]);
    for (int j = 0; j < l[x + 1]; j++){
        if (s[x + 1][j] >= k){
            return false;
        }
    }
    for (int j = 0; j < m; j++){

        if (s[x][j] < s[x+1][j]) {
            return true;
        }

        if (s[x][j] > s[x+1][j]) {
            return false;
        }

    }
    if (l[x] >= l[x + 1]){
        return false;
    }

    return true;
*
}*/

bool check(int k){
    for (int i = 0; i < n; i++){
        s[i].clear();
    }
    s[0].assign(l[0], 0);
    for (int i = 0; i < n - 1; i++){
        if (get_next(i, k) == -1){
            /*for (int j = 0; j < l[i + 1]; j++){
                cerr << s[i + 1][j];
            }
            cerr << "\n";*/
            return false;
        }
       /* if (!is_lower(i, k)){
            return false;
        }*/

       /* for (int j = 0; j < l[i + 1]; j++){
            cerr << s[i + 1][j];
        }
        cerr << "\n";*/
    }
    return true;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; i++){
        scanf("%d", &l[i]);
    }

    int left = 0;
    int right = MAXN + 1;
    while (left + 1 < right){
        int mid = (left + right) / 2;
        if (check(mid)){
            right = mid;
        } else {
            left = mid;
        }
    }


    printf("%d\n", right);
    fclose(stdin);
    fclose(stdout);
    return 0;
 }
