import math

def transform(order, l, p, c, otype):
    if otype == -1:
        od = (order - 1) * (c ** p) + 1
        order = od
    elif otype == 0:
        od = order + 1
        if od > c ** l:
            c = -1
        order = od
    else:
        od = (order - 1) // (c ** p) + 1
        #print(otype, od)
        od += 1
        if od > c ** (l - p):
            c = -1
        order = od
    return (order, c)

def iterate(s, c):
    order = 1
    prev = -1
    for l in s:
        l = int(l)
        if prev != -1:
            if prev < l:
                order, c = transform(order, prev, l - prev, c, -1)
            elif prev == l:
                order, c = transform(order, prev, l - prev, c, 0)
            else:
                order, c = transform(order, prev, prev - l, c, 1)
            if c == -1:
                return 0
            #print(order, c)
        prev = l
    return 1

input()

s = input().split()
l = 0
r = 100000
while l + 1 < r:
    m = (l + r) // 2
    if iterate(s, m) != 0:
        r = m
    else:
        l = m
print(r)