#include <bits/stdc++.h>

#define ll long long int

const ll INF = 10000000000000000000000;

using namespace std;

vector< vector<ll> > segs;
vector< vector<ll> > stacker;

/*vector<int> seg_union(int l, int r, int l1, int r1) {
    int l2 = max(l, l1);
    int r2 = min(r, r1);
    return vector<int>({l2, r2});
}*/

ll n, k;

ll gen(vector<ll> &visited, ll idx) {
    if (idx < n) {
        ll a = gen(visited, idx + 1);
        visited[idx] = 1;
        ll b = gen(visited, idx + 1);
        visited[idx] = 0;
        return min(a, b);
    } else {
        ll f = 0;
        while (f < k) {
            ll oldf = f;
            for (ll i = 0; i < n; i++) {
                if (visited[i] && segs[i][0] <= f && f <= segs[i][1]) {
                    f = segs[i][1] + 1;
                }
            }
            if (f == oldf) {
                break;
            }
        }
        if (f >= k) {
            ll maxp = 0;
            /*for (ll x : visited) {
                cout << x;
            }
            cout << "\n";*/
            f = 0;
            ll p = 0;
            stack<ll> exits;
            for (ll i = 0; i < n; i++) {
                while (!exits.empty() && f > exits.top()) {
                    p -= exits.top();
                    exits.pop();
                }
                if (visited[i]) {
                    f = segs[i][0];
                    p += segs[i][2];
                    exits.push(segs[i][1]);
                    if (p > maxp) {
                        maxp = p;
                    }
                }
            }

            return maxp;
        } else {
            return INF;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);

    cin >> n >> k;
    segs.assign(n, vector<ll>());
    for (ll i = 0; i < n; i++) {
        ll l, r, p;
        cin >> l >> r >> p;
        l--; r--;
        vector<ll> t({l, r, p});
        segs[i] = t;
    }

    sort(segs.begin(), segs.end());
    /*for (vector<int> t : segs) {
        for (int a : t) {
            cout << a << " ";
        }
        cout << "\n";
    }*/

    vector<ll> visited(n, 0);
    cout << gen(visited, 0);

    return 0;
}