#include <cstdio>
#define INF 5000

bool add(int q, int *str, int n)
{
    for (int i = n - 1; i >= 0; i--) {
        str[i]++;
        if (str[i] < q) {
            for (int j = n; j < INF; j++)
                str[j] = 0;
            return true;
        }
        str[i] = 0;
    }
    return false;
}

bool can(int n, int *mas, int q)
{
    int *str = new int[INF];
    for (int i = 0; i < INF; i++)
        str[i] = 0;
    for (int i = 1; i < n; i++)
        if (mas[i] <= mas[i - 1] && !add(q, str, mas[i])) {
            delete[] str;
            return false;
        }
    delete[] str;
    return true;
}

int main()
{
    int n;
    scanf("%d", &n);
    int *mas = new int[n];
    for (int i = 0; i < n; i++)
        scanf("%d", &mas[i]);
    /*for (int i = 1; ; i++)
        if (can(n, mas, i)) {
            printf("%d\n", i);
            break;
        }*/
    int a = 1, b = n, m;
    while (a < b) {
        m = (a + b) >> 1;
        if (!can(n, mas, m))
            a = m + 1;
        else
            b = m;
    }
    printf("%d\n", a);
    return 0;
}
