#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)5001;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

int n;
int a[MAXN];

const int lol = 5001;

#include <unordered_map>

unordered_map<int, int> b;
int l[MAXN], r[MAXN];

bool f(long long c) {
    b.clear();

    for(int i = 1; i < n; i++) {
        if(a[i] > a[i - 1]) {
            while(b.size() && (--b.end()) -> first >= r[i - 1] + 1)
                b.erase(--b.end());
        }
        if(a[i] == a[i - 1]) {
            int len = min(a[i], lol);

            bool ok = 0;
            for(int j = r[i]; j >= 0; j--) {
                if(b[j] + 1 < c) {
                    b[j]++;
                    ok = 1;
                    break;
                } else b[j] = 0;
            }

            if(!ok) return 0;
        }
        if(a[i] < a[i - 1]) {
            int len = min(a[i], lol);

            bool ok = 0;
            for(int j = r[i]; j >= 0; j--) {
                if(b[j] + 1 < c) {
                    b[j]++;
                    ok = 1;
                    break;
                } else b[j] = 0;
            }

            if(!ok) return 0;
        }
    }
    return 1;
}

int main() {
//    freopen(".in", "r", stdin);

    cin >> n;
    for(int i = 0; i < n; i++) {
        a[i] = next_int<int>();

        l[i] = a[i] - min(a[i], lol);
        r[i] = a[i] - 1;
    }

    long long l = 1;
    long long r = (int)1e7;
    while(r - l > 1) {
        long long c = (l + r) / 2;
        if(f(c))
            r = c;
        else
            l = c;
    }

    if(f(l))
        cout << l << "\n";
    else
        cout << r << "\n";
}
