#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

const int q = 30;
const bool DEBUG = 0;
long long n = 5;

pair<long long, long long> get(long long k) {
	pair<long long, long long> ans;
	if(DEBUG) {
		ans = make_pair(n / k, n);
		long long temp = __gcd(ans.first, ans.second);
		ans.first /= temp;
		ans.second /= temp;
	} else {
		cout << "X " << k << endl;
		cin >> ans.first >> ans.second;
	}
	return ans;
}

unsigned long long random() {
	unsigned long long q = rand() + (16LL << rand());
	unsigned long long w = rand() + (16LL << rand());
	return (q + (32 << w)) % (long long)1e18 + 1;
}

int main() {
//	freopen(".in", "r", stdin);
	srand(time(0));

	int w;
	if(DEBUG)
		w = 1;
	else
		cin >> w;

	while(w--) {
        long long ans = 1;
		for(int i = 0; i < q; i++) {
			pair<long long, long long> temp = get(i + 1);
			ans = max(ans, temp.second);
		}
		cout << "N " << ans << endl;
	}
}
