#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector <int> l_raw, l, sz;


struct arr {
    vector <int> a;
    arr(int n) {
        a.resize(n, 0);
    }
    int get(int id) {
        return a[id];
    }
    void add(int id, int d) {
        a[id] += d;
    }
    void set0(int st, int ed) {
        for (int i = st; i < ed; i++)
            a[i] = 0;
    }
};

bool check(int al) {
    int64_t pows[32];
    pows[0] = 1;
    for (int i = 1; i < 32; i++) {
        if (pows[i - 1] * al > n)
            pows[i] = n + 1;
        else
            pows[i] = pows[i - 1] * al;
    }
    int digs[sz.size()];
    for (int i = 0; i < sz.size(); i++)
        if (sz[i] > 31)
            digs[i] = n + 1;
        else
            digs[i] = pows[sz[i]];
    //cout << "CH " << al << endl;
    arr a(sz.size());
    for (int i = 1; i < n; i++) {
        //cout << "STEP " << i << endl;
        if (l[i] > l[i - 1]) {
            a.set0(l[i - 1], l[i]);

        } else {
            a.add(l[i] - 1, 1);
            for (int j = l[i] - 1; j >= 0; j--) {
                if (a.get(j) < digs[j])
                    break;
                if (j == 0)
                    return false;
                a.add(j, -digs[j]);
                a.add(j - 1, 1);
            }
        }
    }
    return true;
}

int main() {
    cin >> n;
    l.resize(n);
    vector <int> ls(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        ls[i] = l[i];
    }
    for (int i = 1; i < n; i++) {
        if (l[i] <= l[i - 1])
            break;
        if (i == n - 1) {
            cout << 1;
            return 0;
        }
    }
    sort(ls.begin(), ls.end());
    ls.resize(unique(ls.begin(), ls.end()) - ls.begin());
    sz.resize(ls.size());
    sz[0] = ls[0];
    for (int i = 1; i < ls.size(); i++)
        sz[i] = ls[i] - ls[i - 1];
    for (int i = 0; i < n; i++)
        l[i] = upper_bound(ls.begin(), ls.end(), l[i]) - ls.begin();
    /*for (int i = 0; i < ls.size(); i++)
        cout << sz[i] << ' ';
    cout << endl;
    for (int i = 0; i < ls.size(); i++)
        cout << l[i] << ' ';
    cout << endl;*/
    int bl = 1, br = n, mid;
    while (br - bl > 1) {
        mid = (bl + br) / 2;
        if (check(mid))
            br = mid;
        else
            bl = mid;
    }
    cout << br;
    return 0;
}
