#include <iostream>
#include <vector>

using namespace std;

int64_t gcd(int64_t a, int64_t b) {
    if (a == 0 || b == 0)
        return a + b;
    return gcd(b % a, a);
}

int main() {
    int g;
    cin >> g;
    for (; g > 0; g--) {
        int Q = 24;
        int qs[] = {2, 3, 5, 7, 11,
                    13, 17, 19, 23, 29,
                    31, 37, 41, 43, 47,
                    53, 59, 71, 73, 79,
                    83, 87, 89, 97};
        int64_t res = 1, c1, c2;
        for (int i = 0; i < Q; i++) {
            cout << "X " << qs[i] << endl;
            cin >> c1 >> c2;
            c2 /= gcd(c2, res);
            res *= c2;
        }
        cout << "N " << res;
        string ans;
        cin >> ans;
    }
    return 0;
}
