#include <iostream>
#include <vector>

using namespace std;

int64_t gcd(int64_t a, int64_t b) {
    if (a == 0 || b == 0)
        return a + b;
    return gcd(b % a, a);
}

void ask(int64_t x, int64_t &c1, int64_t &c2) {
    cout << "X " << x;
    cin >> c1 >> c2;
}

int main() {
    int g;
    cin >> g;
    for (; g > 0; g--) {
        int64_t l = 1, r = 1e18 + 1, c1, c2;
        while (r - l > 1) {
            ask((l + r) / 2, c1, c2);
            if (c1 == 0)
                r = (l + r) / 2;
            else
                l = (l + r) / 2;
        }
        cout << "N " << l;
        string ans;
        cin >> ans;
        if (ans != "Correct")
            return 0;
    }
    return 0;
}
