#include <cstdio>
#include <vector>
#include <string>
#include <iostream>

using namespace std;

const int INF = 2e9;

bool check(vector < int > &a, int n, int k)
{
	long long cur = 0;
	for (int i = 1; i < n; ++i)
	{
		if (a[i - 1] < a[i])
		{
			for (int j = a[i - 1]; j < a[i]; ++j)
				cur *= k;
		}
		else
		{
			if (a[i - 1] > a[i])
			{
				for (int j = a[i - 1]; j > a[i]; --j)
					cur /= k;
			}
			cur++;
		}
		long long max = 1;
		for (int j = 0; j < a[i]; ++j)
		{
			max *= k;
		}
		if (max == cur)
		{
			return false;
		}
	}
	return true;
}

int main()
{
	freopen("input.txt", "rt", stdin);
	int n;
	scanf("%d", &n);
	vector < int > a(n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &a[i]);
	}
	int l = 0, r = n;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		bool f = check(a, n, m);
		if (f)
			r = m;
		else
			l = m;
	}
	printf("%d", r);
	/*long long k = 1;
	long long cur = 0;
	for (int i = 1; i < n; ++i)
	{
		if (a[i - 1] < a[i])
		{
			for (int j = a[i - 1]; j < a[i]; ++j)
				cur *= k;
		}
		else
		{
			if (a[i - 1] > a[i])
			{
				for (int j = a[i - 1]; j > a[i]; --j)
					cur /= k;
			}
			cur++;
		}
		long long max = 1;
		for (int j = 0; j < a[i]; ++j)
		{
			max *= k;
		}
		if (max < cur + 1)
		{
			k++;
		}
	}
	printf("%lld", k);*/
	return 0;
}