#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int k;

ll cnt(const vector <int> &l, const vector <int> &r, const vector <int> &p, const vector <bool> &grab)
{
    int n = l.size();
    vector <ll> add(k + 1);
    for (int i = 0; i < n; i++)
    {
        if (grab[i])
        {
            add[l[i]] += p[i];
            add[r[i] + 1] -= p[i];
        }
    }
    ll cur = 0;
    ll res = 0;
    for (int i = 0; i < k; i++)
    {
        cur += add[i];
        if (cur == 0)
        {
            return 1e18;
        }
        else
        {
            res = max(res, cur);
        }
    }
    return res;
}

int main()
{
    //freopen("a.in", "r", stdin);
    srand(time(0));
    int n;
    scanf("%d%d", &n, &k);
    vector <int> l(n), r(n), p(n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d%d", &l[i], &r[i], &p[i]);
        l[i]--, r[i]--;
    }
    vector <bool> grab(n);
    for (int i = 0; i < n; i++)
    {
        grab[i] = 1;
    }
    double t0 = 1e6;
    double temp = t0;
    ll num = cnt(l, r, p, grab);
    ll best = num;
    while (clock() / (double) CLOCKS_PER_SEC <= 4.9)
    {
        best = min(best, num);
        auto was = grab;
        for (int it = 0; it < n * temp / t0; it++)
        {
            int cur = rand() % n;
            grab[cur] = !grab[cur];
        }
        ll res = cnt(l, r, p, grab);
        if (res < num)
        {
            num = res;
        }
        else
        {
            double lol = exp(-(res - num) / temp);
            int x = 1 + rand();
            int y = 1 + rand();
            x %= y;
            if (x / (double) y <= lol)
            {
                num = res;
            }
            else
            {
                grab = was;
            }
        }
        temp *= 0.9999;
    }
    if (best == 1e18)
    {
        puts("-1");
        return 0;
    }
    printf("%lld\n", best);
}
