#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <fstream>

using namespace std;

int g;

bool ask(long long n) {
	cout << "X " << n << endl;
	cout.flush();
	pair<int, int> p;
	cin >> p.first >> p.second;
	return (p.first > 0);
}

void out(long long n) {
	cout << "N " << n << endl;
	cout.flush();
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");

	cin >> g;

	while (g) {
		g--;

		long long l = 1, r = 1e17;
		while (r - l > 1) {
			long long m = (l + r) / 2;
			if (ask(m))
				l = m;
			else
				r = m;
		}

		out(l);
		string s;
		cin >> s;
	}
	return 0;
}