#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <fstream>

using namespace std;

const long long N = 1e18 - 1;
int g;

long long gcd(long long a, long long b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

map<int, pair<int, int> > que;

bool ask(long long n) {
	if (que.find(n) != que.end())
		return (que[n].first > 0);

	cout << "X " << n << endl;
	cout.flush();
	pair<long long, long long> p;
	//p.first = N / n;
	//p.second = N;
	//long long d = gcd(p.first, p.second);
	//p.first /= d;
	//p.second /= d;

	cin >> p.first >> p.second;
	que[n] = make_pair(p.first, p.second);
	return (p.first > 0);
}

bool out(long long n) {
	cout << "N " << n << endl;
	cout.flush();
	string s;
	cin >> s;
	return s == "Correct";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");

	cin >> g;

	while (g) {
		g--;

		long long l = 1, r = 1e18;
		int q = 0;
		while (r - l > 1) {
			long long m = (l + r) / 2;
			q++;
			if (ask(m))
				l = m;
			else
				r = m;
		}

		out(r);
	}
	return 0;
}