#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

int l[100000], n;
int str[6000][6000];

bool check(int k) {
	for (int i = 0; i < l[0]; i++) {
		str[0][i] = 0;
	}
	for (int i = 1; i < n; i++) {
		if (l[i] <= l[i - 1]) {
			for (int j = 0; j < l[i]; j++) {
				str[i][j] = str[i - 1][j];
			}
			bool ok = false;
			for (int j = l[i] - 1; j >= 0; j--) {
				if (str[i][j] == k - 1) {
					str[i][j] = 0;
				}
				else {
					str[i][j]++;
					ok = true;
					break;
				}
			}
			if (!ok) {
				return false;
			}
		}
		else {
			for (int j = 0; j < l[i - 1]; j++) {
				str[i][j] = str[i - 1][j];
			}
			for (int j = l[i - 1]; j < l[i]; j++) {
				str[i][j] = 0;
			}
		}
	}
}

int main() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &l[i]);
	}
	int ll = 1;
	int rr = 6000;
	while (ll < rr) {
		int mid = (ll + rr - 1) / 2;
		bool res = check(mid);
		if (res) {
			rr = mid;
		}
		else {
			ll = mid + 1;
		}
	}
	printf("%d", ll);
	return 0;
}