#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <random>
#include <ctime>

using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define FASTIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)


void maketl()
{
	int i = 0;
	while (1)
	{
		++i, --i;
	}
}

int gcd(int a, int b)
{
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

pair<int, int> f(int a, int b)
{
	a = b / a;
	int d = gcd(a, b);
	a /= d;
	b /= d;
	return mp(a, b);
}

bool check(int c, vector<int> &v)
{
	vector<int> p(5001, 1);
	for (int i = 1; i < v.size(); i++)
	{
		if (v[i] > v[i - 1])
		{
			for (int j = v[i] + 1; j < 5; j++) p[j] = 1;
			continue;
		}
		p[v[i]]++;
		if (p[v[i]] > c)
		{
			if (v[i] == 1)
				return false;
			p[v[i]] = 1;
			for (int j = v[i] - 1; j >= 1; j--)
			{
				++p[j];
				if (p[j] <= c)
					break;
				else
				{
					if (j == 1)
						return false;
					p[j] = 1;
				}
			}
		}
	}
	return true;
}

signed main()
{
	FASTIO;
	srand(time(0));

	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int l = 0, r = 1000000000;
	//cout << check(2, v);
	while (r - l > 1)
	{
		int mid = (r + l) / 2;
		if (check(mid, v))
			r = mid;
		else
			l = mid;
	}
	cout << r;
}