#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <random>
#include <ctime>

using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define FASTIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)


void maketl()
{
	int i = 0;
	while (1)
	{
		++i, --i;
	}
}

int gcd(int a, int b)
{
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

pair<int, int> f(int a, int b)
{
	a = b / a;
	int d = gcd(a, b);
	a /= d;
	b /= d;
	return mp(a, b);
}

int p[200002];
int mark[200002];

const int N = 10;

bool check(int c, vector<int> &v)
{
	for (int i = 0; i <= N; i++)
		p[i] = mark[i] = 0;
	for (int i = 1; i < v.size(); i++)
		if (v[i] <= v[i - 1])
			mark[v[i] - 1]++;
	int mx = 0;
	for (int i = N; i >= 1; i--)
	{
		int d = mark[i];
		int cur = p[i];
		mark[i - 1] += (cur + d) / c;
	}
	return mark[0] < c;
}

signed main()
{
	FASTIO;
	srand(time(0));

	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int l = 0, r = 1000000000;
	//cout << check(2, v);
	while (r - l > 1)
	{
		int mid = (r + l) / 2;
		if (check(mid, v))
			r = mid;
		else
			l = mid;
		//cout << l << " " << r << endl;
	}
	cout << r;
}