#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <random>
#include <ctime>

using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define FASTIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)

struct q
{
	int l, r, w;
	q() {}
	q(int l, int r, int w) : l(l), r(r), w(w) {}
	bool operator<(const q&a)
	{
		if (r == a.r)
			return l < a.l;
		return r < a.r;
	}
};

int dp[3001];

signed main()
{
	FASTIO;
	srand(time(0));
	for (int i = 0; i < 3001; i++)
		dp[i] = 10000000000000000;
	int n, m;
	cin >> n >> m;
	vector<q> v(n);
	for (int i = 0; i < n; i++)
	{
		int l, r, w;
		cin >> l >> r >> w;
		v[i] = q(l, r, w);
	}
	sort(v.begin(), v.end());
	for (int i = 0; i < n; i++)
		if (v[i].l == 1)
			dp[i] = v[i].w;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < i; j++)
			if (v[j].r >= v[i].l - 1)
			{
				int a = dp[j];
				int b = v[i].w;
				if (v[j].r >= v[i].l)
					b += v[j].w;
				dp[i] = min(dp[i], max(a, b));
			}
	
	/*for (int i = 0; i < n; i++)
		for (int j = 0; j < i; j++)
			if (v[j].r >= v[i].l - 1)
			{
				int a = dp[j];
				if (v[j].r >= v[i].l)
					a += v[i].w;
				dp[i] = min(dp[i], a);
			}*/
	
	int ans = 10000000000000000;
	for (int i = 0; i < n; i++)
		if (v[i].r == m)
			ans = min(ans, dp[i]);
	cout << ((ans == 10000000000000000) ? -1 : ans);
}