#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <random>
#include <ctime>

using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define FASTIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)

struct q
{
	int l, r, w;
	q() {}
	q(int l, int r, int w) : l(l), r(r), w(w) {}
	bool operator<(const q&a)
	{
		if (r == a.r)
			return l < a.l;
		return r < a.r;
	}
};

int dp[3001];
const int inf = 1000000000000000000;

signed main()
{
	FASTIO;
	srand(time(0));
	for (int i = 0; i < 3001; i++)
		dp[i] = inf;
	int n, m;
	cin >> n >> m;
	vector<q> v(n);
	for (int i = 0; i < n; i++)
	{
		int l, r, w;
		cin >> l >> r >> w;
		v[i] = q(l, r, w);
	}
	int ans = inf;
	for (int mask = 0; mask < (1 << n); mask++)
	{
		vector<int> ka(m + 1, 0);
		vector<pair<int, pair<int, int>>> e;
		for (int i = 0; i < n; i++)
			if ((mask >> i) & 1)
			{
				e.push_back(mp(v[i].l, mp(-1, v[i].w)));
				e.push_back(mp(v[i].r, mp(1, v[i].w)));
				for (int j = v[i].l; j <= v[i].r; j++)
					ka[j] = 1;
			}
		sort(e.begin(), e.end());
		int cur = 0, d = 0, op = 0;
		if (mask == 3)
			cout << "";
		for (int i = 0; i < e.size(); i++)
		{
			op += -e[i].second.first;
			cur += -e[i].second.first * e[i].second.second;
			d = max(cur, d);
			
		}
		for (int i = 1; i <= m; i++)
			if (!ka[i])
				d = inf;
		ans = min(ans, d);
	}
	cout << ((ans == inf) ? -1 : ans);
}