#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <random>
#include <ctime>

using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define FASTIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)

struct q
{
	int l, r, w;
	q() {}
	q(int l, int r, int w) : l(l), r(r), w(w) {}
	bool operator<(const q&a)
	{
		if (r == a.r)
			return l < a.l;
		return r < a.r;
	}
};

pair<int, int> dp[3001];
const int inf = 1000000000000000000;

signed main()
{
	FASTIO;
	srand(time(0));
	for (int i = 0; i < 3001; i++)
		dp[i] = mp(inf, inf);
	int n, m;
	cin >> n >> m;
	vector<q> v(n);
	for (int i = 0; i < n; i++)
	{
		int l, r, w;
		cin >> l >> r >> w;
		v[i] = q(l, r, w);
	}
	sort(v.begin(), v.end());
	for (int i = 0; i < n; i++)
		if (v[i].l == 1)
			dp[i].first = v[i].w, dp[i].second = -1;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < i; j++)
			if (v[j].r >= v[i].l - 1 && v[j].l < v[i].l && dp[j].second < v[i].l - 1)
			{
				int a = dp[j].first;
				int b = v[i].w;
				if (v[j].r >= v[i].l)
					b += v[j].w;
				if (max(a, b) < dp[i].first)
				{
					dp[i].first = max(a, b);
					dp[i].second = v[j].r;
				}
			}

	/*for (int i = 0; i < n; i++)
	for (int j = 0; j < i; j++)
	if (v[j].r >= v[i].l - 1)
	{
	int a = dp[j];
	if (v[j].r >= v[i].l)
	a += v[i].w;
	dp[i] = min(dp[i], a);
	}*/

	int ans = inf;
	for (int i = 0; i < n; i++)
		if (v[i].r == m)
			ans = min(ans, dp[i].first);
	cout << ((ans == inf) ? -1 : ans);
}