#include <iostream>
#include <algorithm>
#include <fstream>

using namespace std;

long long fact[50];

long long fast_pow(int n, int k, int kol)
{
    if (k==0)
        return 1;
    long long w=fast_pow(n,k/2,kol);
    long long q=w;
    if (q>=kol)
        return q;
    q*=w;
    if (q>=kol)
        return q;
    if (k%2==1)
        q*=1ll*n;
    return q;
}

bool ok(int n, int k, int kol)
{
    long long w=fast_pow(n,k/2,kol);
    long long q=w;
    if (q>=kol)
        return true;
    q*=w;
    if (q>=kol)
        return true;
    if (k%2==1)
        q*=1ll*n;
    if (q>=kol)
        return true;
    return false;
}

long long findans(int ll, int kol)
{
    int l=1,r=kol;
    while (l!=r)
    {
        int tm=(l+r)/2;
        if (ok(tm,ll,kol))
            r=tm;
        else
            l=tm+1;
    }
    return l;
}

int main()
{
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    int n,a[100100],b[100100];
    cin >>n;
    for (int i=0; i<n; i++)
        cin >>a[i];
    for (int i=0; i<n; i++)
        b[i]=a[i];
    sort(a,a+n);
    a[n]=a[n-1]+1;
    int kol=1;
    fact[0]=1ll;
    for (int i=1; i<10; i++)
        fact[i]=fact[i-1]*1ll*i;
    long long ans=0;
    for (int i=0; i<n; i++)
        if (a[i]!=a[i+1])
            ans=max(ans,findans(a[i],kol)),kol=1;
        else
            kol++;
    int kk=1,sum=0;
    for (int i=0; i<n-1; i++)
        if (a[i+1]>=a[i]){
            if (kk>=ans+sum)
                sum++;
        }
        else
            kk++;
    cout <<ans+sum<<"\n";
    return 0;
}
