#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);--(i))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define SZ(x) (x).size()
#define all(x) (x).begin(),x.end()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<pii> vpii;

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do {ch=getchar();}while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9')x=x*10+ch-'0',ch=getchar();
    return p==1?x:-x;
}

mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

template <typename T1, typename T2> bool umin(T1 &x, const T2&y){if(x>y){x=y;return true;} return false;}
template <typename T1, typename T2> bool umax(T1 &x, const T2&y){if(x<y){x=y;return true;} return false;}

const int maxn=(int)1e6+10;
const int inf=(int)1e9+5;
const int mod=(int)1e9+7;
const ll llinf=(ll)1e18+5;
const ld pi=acos(-1.0);

int n;
int l[maxn];

bool can(int diff){
    map<int,int> a;
    int LEN=0;
    rep(i,0,n){
        int len=l[i];
        if(len>LEN){
            LEN=len;
            continue;
        }

        while(!a.empty()&&prev(a.end())->fi>len)a.erase(prev(a.end()));

        bool found=false;
        for(int i=len;i>=1;--i){
            if(!a.count(i))a[i]=1;
            if(a[i]!=diff){
                a[i]++;
                found=true;
                break;
            }else a.erase(a.find(i));
        }
        if(!found)return false;
        LEN=len;
    }
    return true;
}

int main() {
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);

    srand(228);
    n=getint<int>();
    rep(i,0,n){
        l[i]=rand()%10+1;
    }

    bool ok=true;
    rep(i,1,n)ok&=l[i-1]<l[i];
    if(ok){
        printf("%d\n",1);
        return 0;
    }

    if(can(2)){
        printf("%d\n",2);
        return 0;
    }

    int lf=2,rg=n+1;
    while(rg-lf>1){
        int md=(lf+rg)/2;
        if(can(md))rg=md;
        else lf=md;
    }
    printf("%d\n",rg);

    return 0;
}
