#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);--(i))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define SZ(x) (x).size()
#define all(x) (x).begin(),x.end()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<pii> vpii;

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do {ch=getchar();}while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9')x=x*10+ch-'0',ch=getchar();
    return p==1?x:-x;
}

mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

template <typename T1, typename T2> bool umin(T1 &x, const T2&y){if(x>y){x=y;return true;} return false;}
template <typename T1, typename T2> bool umax(T1 &x, const T2&y){if(x<y){x=y;return true;} return false;}

const int maxn=(int)1e6+10;
const int inf=(int)1e9+5;
const int mod=(int)1e9+7;
const ll llinf=(ll)1e18+5;
const ld pi=acos(-1.0);

int l[maxn],r[maxn],p[maxn];

void get(const vi &z, int &k){
    k=lower_bound(all(z),k)-z.begin()+1;
}

vi g[maxn];

int n,k;

bool check(){
    vpii ev;
    rep(i,0,n){
        ev.pb(mp(l[i],-1));
        ev.pb(mp(r[i]+1,1));
    }
    sort(all(ev));
    if(ev[0].fi!=1)return false;
    if(ev.back().fi!=k+1)return false;
    int c=0;
    rep(i,0,ev.size()){
        c+=ev[i].se;
        if(c==0&&i+1!=ev.size())return false;
    }
    return true;
}

int main() {
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);

    n=getint<int>();
    k=getint<int>();

    vi z;
    z.pb(1); z.pb(k);

    bool ok=true;
    rep(i,0,n){
        l[i]=getint<int>();
        r[i]=getint<int>();
        p[i]=getint<int>();
        ok&=(p[i]==1);
        z.pb(l[i]);
        z.pb(r[i]);
    }

    if(!check()){
        cout<<-1<<endl;
        return 0;
    }

    sort(all(z));
    z.erase(unique(all(z)),z.end());

    get(z,k);
    vi c(k+2,0);
    rep(i,0,n){
        get(z,l[i]);
        get(z,r[i]);
        c[l[i]]++;
        c[r[i]+1]--;
        g[r[i]].pb(i);
    }

    assert(ok);

    vi can(k+1);
    can[0]=1;
    for(int r=1;r<=k;++r){
        for(int i:g[r]){
            can[r]|=can[l[i]-1];
        }
    }
    cout<<2-can[k]<<endl;



    return 0;
}
