#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);--(i))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define SZ(x) (x).size()
#define all(x) (x).begin(),x.end()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<pii> vpii;

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do {ch=getchar();}while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9')x=x*10+ch-'0',ch=getchar();
    return p==1?x:-x;
}

mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

template <typename T1, typename T2> bool umin(T1 &x, const T2&y){if(x>y){x=y;return true;} return false;}
template <typename T1, typename T2> bool umax(T1 &x, const T2&y){if(x<y){x=y;return true;} return false;}

const int maxn=(int)4e5+10;
const int inf=(int)1e9+5;
const int mod=(int)1e9+7;
const ll llinf=(ll)1e18+5;
const ld pi=acos(-1.0);

int l[maxn],r[maxn],p[maxn];

void get(const vi &z, int &k){
    k=lower_bound(all(z),k)-z.begin()+1;
}

vi g[maxn];

int n,k;

bool check(){
    vpii ev;
    rep(i,0,n){
        ev.pb(mp(l[i],-1));
        ev.pb(mp(r[i]+1,1));
    }
    sort(all(ev));
    if(ev[0].fi!=1)return false;
    if(ev.back().fi!=k+1)return false;
    int c=0;
    rep(i,0,ev.size()){
        c+=ev[i].se;
        if(c==0&&i+1!=ev.size())return false;
    }
    return true;
}

ll dp[maxn];
ll t[4*maxn];


ll getmin(int v,int idx,int tl,int tr){
    ll ret=t[v];
    if(tl==tr)return ret;
    int tm=(tl+tr)/2;
    if(idx<=tm)umin(ret,getmin(v+v,idx,tl,tm));
    else umin(ret,getmin(v+v+1,idx,tm+1,tr));
    return ret;
}

void upd(int v,int l,int r,ll val,int tl,int tr){
    if(l<=tl&&tr<=r){
        umin(t[v],val);
        return;
    }
    int tm=(tl+tr)/2;
    if(l<=tm)upd(v+v,l,r,val,tl,tm);
    if(r>tm)upd(v+v+1,l,r,val,tm+1,tr);
}

bool can(int x){
    for(int i=0;i<=4*k;++i)t[i]=llinf;
    for(int i=0;i<=k;++i)dp[i]=llinf;
    dp[0]=0;
    for(int r=1;r<=k;++r){
        for(int i:g[r]){
            ll c=llinf;
            if(dp[l[i]-1]<=x)umin(c,p[i]);
            if(getmin(1,l[i],1,k)+p[i]<=x)umin(c,p[i]);
            if(r==k&&c<=x)return true;
            if(l[i]<r)upd(1,l[i]+1,r,c,1,k);
            umin(dp[r],c);
        }
    }
    return false;
}

int main() {
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);

    n=getint<int>();
    k=getint<int>();

    vi z;
    z.pb(1); z.pb(k);
    if(k!=1)z.pb(k-1);
    if(k!=1)z.pb(2);

    rep(i,0,n){
        l[i]=getint<int>();
        r[i]=getint<int>();
        p[i]=getint<int>();
        assert(p[i]>=1);
        assert(r[i]<=k);
        z.pb(l[i]);
        if(l[i]-1>=1)z.pb(l[i]-1);
        z.pb(r[i]);
        if(r[i]+1<=k)z.pb(r[i]+1);
    }
    sort(all(z));
    z.erase(unique(all(z)),z.end());

    get(z,k);
    rep(i,0,n){
        get(z,l[i]);
        get(z,r[i]);
        g[r[i]].pb(i);
    }

    ll res=llinf;
    rep(mask,0,1<<n){
        vll sum(k+1,0);
        rep(i,0,n){
            if(mask>>i&1){
                for(int j=l[i];j<=r[i];++j){
                    sum[j]+=p[i];
                }
            }
        }
        bool bad=false;
        ll val=0;
        rep(i,1,k+1){
            if(sum[i]==0)bad=true;
            umax(val,sum[i]);
        }
        if(!bad)umin(res,val);

    }
    if(res==llinf)res=-1;
    cout<<res<<endl;
    return 0;

    /*
    int lf=0,rg=2*inf;
    while(rg-lf>1){
        int md=(lf+rg)/2;
        if(can(md)){
            rg=md;
        }else {
            lf=md;
        }
    }
    printf("%d\n",rg);*/
    return 0;
}
