#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);--(i))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define SZ(x) (x).size()
#define all(x) (x).begin(),x.end()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<pii> vpii;

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do {ch=getchar();}while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9')x=x*10+ch-'0',ch=getchar();
    return p==1?x:-x;
}

mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

template <typename T1, typename T2> bool umin(T1 &x, const T2&y){if(x>y){x=y;return true;} return false;}
template <typename T1, typename T2> bool umax(T1 &x, const T2&y){if(x<y){x=y;return true;} return false;}

const int maxn=(int)4e5+10;
const int inf=(int)1e9+5;
const int mod=(int)1e9+7;
const ll llinf=(ll)1e18+5;
const ld pi=acos(-1.0);

int l[maxn],r[maxn],p[maxn];

void get(const vi &z, int &k){
    k=lower_bound(all(z),k)-z.begin()+1;
}

vi g[maxn];

int n,k;

bool check(){
    vpii ev;
    rep(i,0,n){
        ev.pb(mp(l[i],-1));
        ev.pb(mp(r[i]+1,1));
    }
    sort(all(ev));
    if(ev[0].fi!=1)return false;
    if(ev.back().fi!=k+1)return false;
    int c=0;
    rep(i,0,ev.size()){
        c+=ev[i].se;
        if(c==0&&i+1!=ev.size())return false;
    }
    return true;
}

ll dp[maxn];
ll t[4*maxn];


ll getmin(int v,int idx,int tl,int tr){
    ll ret=t[v];
    if(tl==tr)return ret;
    int tm=(tl+tr)/2;
    if(idx<=tm)umin(ret,getmin(v+v,idx,tl,tm));
    else umin(ret,getmin(v+v+1,idx,tm+1,tr));
    return ret;
}

void upd(int v,int l,int r,ll val,int tl,int tr){
    if(l<=tl&&tr<=r){
        umin(t[v],val);
        return;
    }
    int tm=(tl+tr)/2;
    if(l<=tm)upd(v+v,l,r,val,tl,tm);
    if(r>tm)upd(v+v+1,l,r,val,tm+1,tr);
}

bool can(ll x){
    fill(dp,dp+n+1,inf);
    vi order(n);
    rep(i,0,n)order[i]=i;
    sort(all(order),[&](int i,int j){
       return r[i]<r[j];
    });
    rep(_,0,n){
        int i=order[_];
        if(p[i]>x)continue;
        if(l[i]==1){
            dp[i]=1;
        }
        rep(__,0,_){
            int j=order[__];
            if(r[i]==r[j])continue;
            if(dp[j]==inf)continue;
            if(r[j]+1==l[i]){
                umin(dp[i],l[i]);
                continue;
            }
            if(r[j]<l[i])continue;
            if(l[j]>=l[i])continue;
            if(p[i]+p[j]>x)continue;
            if(l[i]>dp[j]){
                umin(dp[i],r[j]);
            }
        }
    }
    rep(i,0,n)if(r[i]==k&&dp[i]!=inf)return true;
    return false;
}
bool can2(int x){
    for(int i=0;i<=4*k;++i)t[i]=llinf;
    for(int i=0;i<=k;++i)dp[i]=llinf;
    dp[0]=0;
    for(int r=1;r<=k;++r){
        for(int i:g[r]){
            ll c=llinf;
            if(dp[l[i]-1]<=x)umin(c,p[i]);
            if(getmin(1,l[i],1,k)+p[i]<=x)umin(c,p[i]);
            if(r==k&&c<=x)return true;
            if(l[i]<r)upd(1,l[i]+1,r,c,1,k);
            umin(dp[r],c);
        }
    }
    return false;
}

ll solve(){
    ll res=llinf;int ans=2;
        rep(mask,0,1<<n){
            vll sum(k+1,0);
            vi cnt(k+1,0);
            rep(i,0,n){
                if(mask>>i&1){
                    for(int j=l[i];j<=r[i];++j){
                        sum[j]+=p[i];
                        cnt[j]+=1;
                    }
                }
            }
            bool bad=false;
            ll val=0;
            int mx=0;
            rep(i,1,k+1){
                if(sum[i]==0)bad=true;
                umax(val,sum[i]);
                umax(mx,cnt[i]);
            }
            if(!bad){
                if(umin(res,val)){
                    ans=mx;
                }
            }

        }
        if(res==llinf)res=-1;
        assert(ans<=2);
        assert(res<=2*inf);
        return res;
}

int main() {
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);

    n=getint<int>();
    k=getint<int>();
/*
    cout<<n<<' '<<k<<endl;
    rep(i,0,n){
        l[i]=gen()%k+1;
        r[i]=gen()%k+1;
        p[i]=gen()%5+1;
        if(l[i]>r[i])swap(l[i],r[i]);
        cout<<l[i]<<' '<<r[i]<<' '<<p[i]<<endl;
    }*/

    vi z;
    z.pb(1); z.pb(k);
    if(k!=1)z.pb(k-1);
    if(k!=1)z.pb(2);


    bool ok=true;
    rep(i,0,n){
        l[i]=getint<int>();
        r[i]=getint<int>();
        p[i]=getint<int>();
        ok&=p[i]==1;
        assert(p[i]>=1);
        assert(r[i]<=k);
        z.pb(l[i]);
        if(l[i]-1>=1)z.pb(l[i]-1);
        z.pb(r[i]);
        if(r[i]+1<=k)z.pb(r[i]+1);
    }
    if(!check()){
        cout<<-1<<endl;
        return 0;
    }
    sort(all(z));
    z.erase(unique(all(z)),z.end());

    get(z,k);
    rep(i,0,n){
        get(z,l[i]);
        get(z,r[i]);
        g[r[i]].pb(i);
    }

    if(ok){
        vi can(k+1);
        can[0]=1;
        for(int r=1;r<=n;++r){
            for(int i:g[r]){
                can[r]|=can[l[i]-1];
            }
        }
        cout<<2-can[k]<<endl;
        return 0;
    }

    ll lf=0,rg=llinf-1;
    while(rg-lf>1){
        ll md=(lf+rg)/2;
        if((n<=3000&&can(md))||(n>3000&&can2(md))){
            rg=md;
        }else {
            lf=md;
        }
    }
    if(n<=3000&&!can(rg))rg=-1;
    if(n>3000&&!can2(rg))rg=-1;
    printf("%lld\n",rg);
    return 0;
}
