#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

const int L = 0;
const int U = 1;
const int R = 2;
const int D = 3;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef _GOPEN
	freopen("/home/olymp/prjs/file.in", "r", stdin);
	freopen("/home/olymp/prjs/file.out", "w", stdout);
#endif

	int n, x, y;
	string s;
	cin >> n >> s >> x >> y;

	vector<int> ans(4, n);

	if (x == 0) {
		ans[L] = ans[R] = 0;
	} else if (x < 0) {
		ans[R] = 0;
	} else {
		ans[L] = 0;
	}

	if (y == 0) {
		ans[U] = ans[D] = 0;
	} else if (y < 0) {
		ans[U] = 0;
	} else {
		ans[D] = 0;
	}

	for (int i = 0; i < n && x; i++) {
		if (x > 0 && s[i] == 'R') {
			x--;
			ans[R] = i + 1;
		}
		if (x < 0 && s[i] == 'L') {
			x++;
			ans[L] = i + 1;
		}
	}

	for (int i = 0; i < n && y; i++) {
		if (y > 0 && s[i] == 'U') {
			y--;
			ans[U] = i + 1;
		}
		if (y < 0 && s[i] == 'D') {
			y++;
			ans[D] = i + 1;
		}
	}

	if (x || y) {
		cout << "-1\n";
	} else {
		for (auto t : ans) cout << t << " ";
		cout << "\n";
	}

	return 0;
}
