#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
#include <map>
using namespace std;
#define int long long

pair <int, int> sol(int R, int L, int x) {
	int dif = R - L - x;
	if (dif >= 0) {
		int R_prime = dif; 
		int L_prime = 0;
		if (R_prime < 0 || R_prime > R || L_prime < 0 || L_prime > L) {
			return {-1, -1};
		}
		return {L_prime, R_prime};
	} else {
		int R_prime = 0;
		int L_prime = -dif;
		if (R_prime < 0 || R_prime > R || L_prime < 0 || L_prime > L) {
			return {-1, -1};
		}		
		return {L_prime, R_prime};
	}
}

signed main() {
	int n;
	cin >> n;
	string s;
	map <char, int> cnt;
	cin >> s;
	for (int i = 0; i < n; i++) {
		cnt[s[i]] += 1;
	}
	int x, y;
	cin >> x >> y;
	pair <int, int> non_x = sol(cnt['R'], cnt['L'], x);
	if (non_x == make_pair(-1LL, -1LL)) {
		cout << -1;
		return 0;
	}
	int ansL, ansR, ansU, ansD;
	if (non_x.first == 0) {
		ansL = n;
	} else if (non_x.first == cnt['L']) {
		ansL = 0;
	} else {
		int count = cnt['L'];
		for (int i = 0; i < n; i++) {
			count -= (s[i] == 'L');
			if (count == non_x.first) {
				ansL = i + 1;
				break;
			}
		}
	}

	if (non_x.second == 0) {
		ansR = n;
	} else if (non_x.second == cnt['R']) {
		ansR = 0;
	} else {
		int count = cnt['R'];
		for (int i = 0; i < n; i++) {
			count -= (s[i] == 'R');
			if (count == non_x.second) {
				ansR = i + 1;
				break;
			}
		}
	}



	pair <int, int> non_y = sol(cnt['U'], cnt['D'], y);
	if (non_y == make_pair(-1LL, -1LL)) {
		cout << -1;
		return 0;
	}
	if (non_y.first == 0) {
		ansD = n;
	} else if (non_y.first == cnt['D']) {
		ansD = 0;
	} else {
		int count = cnt['D'];
		for (int i = 0; i < n; i++) {
			count -= (s[i] == 'D');
			if (count == non_y.first) {
				ansD = i + 1;
				break;
			}
		}
	}

	if (non_y.second == 0) {
		ansU = n;
	} else if (non_y.second == cnt['U']) {
		ansU = 0;
	} else {		
		int count = cnt['U'];
		for (int i = 0; i < n; i++) {
			count -= (s[i] == 'U');
			if (count == non_y.second) {
				ansU = i + 1;
				break;
			}
		}
	}
	cout << ansL << " " << ansU << " " << ansR << " " << ansD;
}