// ol_079_Napoleon.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
long long k;

struct Cut
{
	int L, R;
	long long p;
};

bool operator <(Cut a, Cut b)
{
	//return (a.L < b.L || a.L == b.L && (a.R > b.R || a.R == b.R && a.p < b.p));
	return (a.R < b.R);
}

vector <Cut> cut;

int zero()
{
	cout << -1;
	return 0;
}

int main()
{
	cin.tie(NULL);

	cin >> n >> k;

	cut.clear();
	cut.resize(n);
	bool ok = false;
	bool ok2 = false;
	for (int i = 0; i < n; i++)
	{
		cin >> cut[i].L >> cut[i].R >> cut[i].p;
		if (cut[i].R == k)
			ok = true;
		if (cut[i].L == 1)
			ok2 = true;
	}
	if (!ok || !ok2)
		return zero();

	sort(cut.begin(), cut.end());

	vector <long long> res;
	vector <bool> endb;
	res.clear();
	res.resize(n);
	endb.clear();
	endb.resize(n, false);
	res[0] = cut[0].p;
	endb[0] = true;
	for (int i = 1; i < n; i++)
	{
		if (cut[i].L > cut[i - 1].R)
			return zero();
		int L = -1, R = i - 1, mid;
		while (L + 1 < R)
		{
			mid = (L + R) / 2;
			if (cut[mid].R < cut[i].L - 1)
				L = mid;
			else
				R = mid;
		}
		if (cut[R].R == cut[i].L - 1)
		{
			res[i] = max(res[R], cut[i].p);
			if (res[R] < cut[i].p)
				endb[i] = true;
		}
		else
		{
			//res[i] = max(res[R], cut[R].p + cut[i].p);
			if (endb[R])
				res[i] = res[R] + cut[i].p;
			else
			{
				res[i] = max(res[R], cut[R].p + cut[i].p);
				if (cut[R].p + cut[i].p >= res[R])
					endb[i] = true;
			}
		}
	}

	//cout << res[n - 1];
	long long ans = res[n - 1];
	for (int i = n - 2; i >= 0 && cut[i].R == cut[n - 1].R; i--)
		ans = min(ans, res[i]);

	cout << ans;
	
	return 0;
}