#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

#define size(a) int(a.size())

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    string s;
    cin >> s;
    int x, y;
    cin >> x >> y;

    vector<int> cnt(4, 0), answ(4, 0);

    for (int i = 0; i < n; i++) {
        if (s[i] == 'L')
            cnt[0]++;
        if (s[i] == 'U')
            cnt[1]++;
        if (s[i] == 'R')
            cnt[2]++;
        if (s[i] == 'D')
            cnt[3]++;
    }

    if (x >= 0 && y >= 0) {
        if (cnt[2] < x || cnt[1] < y) {
            cout << -1;
            return 0;
        }
        answ[2] = x;
        answ[1] = y;
    }

    if (x >= 0 && y < 0) {
        if (cnt[2] < x || cnt[3] < -y) {
            cout << -1;
            return 0;
        }
        answ[2] = x;
        answ[3] = -y;
    }

    if (x < 0 && y >= 0) {
        if (cnt[0] < -x || cnt[1] < y) {
            cout << -1;
            return 0;
        }
        answ[0] = -x;
        answ[1] = y;
    }

    if (x < 0 && y < 0) {
        if (cnt[0] < -x || cnt[3] < -y) {
            cout << -1;
            return 0;
        }
        answ[0] = -x;
        answ[3] = -y;
    }

    for (int i = 0; i < 4; i++)
        cnt[i] = 0;

    for (int i = 0; i < n; i++) {
        if (s[i] == 'L') {
            answ[0]--;
            if (answ[0] == 0) {
                cnt[0] = i + 1;
            }
        }
        if (s[i] == 'U') {
            answ[1]--;
            if (answ[1] == 0) {
                cnt[1] = i + 1;
            }
        }
        if (s[i] == 'R') {
            answ[2]--;
            if (answ[2] == 0) {
                cnt[2] = i + 1;
            }
        }
        if (s[i] == 'D') {
            answ[3]--;
            if (answ[3] == 0) {
                cnt[3] = i + 1;
            }
        }
    }

    for (int i: cnt)
        cout << i << ' ';
    return 0;
}

/*
4
LRUD
3 2

4
DURL
0 0

8
LLURDRRD
1 -1
*/
