#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

#define size(a) int(a.size())

using namespace std;

struct cafe{
    int l, r, p;
};

bool operator <(cafe a, cafe b) {
    return a.l < b.l || a.l == b.l && a.r < b.r;
}

int pow(int x, int p) {
    int answ = 1;

    for (int i = 0; i < p; i++) {
        answ *= x;
    }
    return answ;
}

int main() {
    ios_base::sync_with_stdio(false);

    int n, k;
    cin >> n >> k;

    vector<cafe> v(n);
    vector<int> dp(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].p;
    }

    sort(v.begin(), v.end());

    int mx_r = v[0].r;

    if (n <= 10) {
        int mn = 1e9 + 239;
        for (int i = 0; i < pow(2, n); i++) {
            vector<pair<int,pair<int,int>>> events;
            int mn_l = 1e9 + 239, mx_r = -1;
            for (int j = 0; j < n; j++) {
                if ((i >> j) & 1) {
                    if (v[j].l > mx_r + 1 && mx_r != -1) {
                        mn_l = 0;
                    }
                    mn_l = min(mn_l, v[j].l);
                    mx_r = max(mx_r, v[j].r);

                    events.push_back({v[j].l, {0, v[j].p}});
                    events.push_back({v[j].r, {1, v[j].p}});
                }
            }
            sort(events.begin(), events.end());
            int balance = 0;
            int mx = 0;
            for (int j = 0; j < size(events); j++) {
                balance += events[j].second.second * (events[j].second.first ? -1 : 1);
                //cout << mx << endl;
                mx = max(mx, balance);
            }
            //cout << endl;
            if (mx_r >= k && mn_l == 1)
                mn = min(mn, mx);
        }
        cout << (mn == 1e9 + 239 ? -1 : mn);
        return 0;
    }
 }
