import java.util.*;
import java.io.*;

public class D2_B_2 {
	FastScanner in;
	PrintWriter out;

	public void solve() {
		int n = in.nextInt();
		String s = in.next();
		int x = in.nextInt();
		int y = in.nextInt();
		
		int u = 0;
		int d = 0;
		int r = 0;
		int l = 0;
		int bposx = 0;
		int bposy = 0;
		
		for (int i = 0; i < n; i++){
			switch (s.charAt(i)){
			case 'U':{
				u++;
				if (u == y){
					bposy = i;
				}
				break;
			}
			case 'D':{
				d--;
				if (d == y){
					bposy = i;
				}
				break;
			}
			case 'L':{
				l--;
				if (l == x){
					bposx = i;
				}
				break;
			}
			case 'R':{
				r++;
				if (r == x){
					bposx = i;
				}
				break;
			}
			}
		}
		
		if ((x < l)||(x > r)||(y < d)||(y > u)){
			out.println(-1);
			return;
		}
		
		int resu = 0;
		int resd = 0;
		int resl = 0;
		int resr = 0;
		
		if (x <= 0){
			resr = 0;
			resl = bposx+1;
		}
		if (x >= 0){
			resl = 0;
			resr = bposx+1;
		}
		if (y <= 0){
			resu = 0;
			resd = bposy+1;
		}
		if (y >= 0){
			resd = 0;
			resu = bposy+1;
		}
		
		out.println(resl + " " + resu + " " + resr + " " + resd);
	}
	
	public void run() {
		try {
			in = new FastScanner(new File("input.txt"));
			out = new PrintWriter(new File("output.txt"));

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new D2_B_2().run();
	}
}
