#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    map<int, int> dict;

    int p = -1;
    for (int k = 0; k < n; k++) {
        int x; cin >> x;
        if (x <= p) {
            dict[x]++;
        }
        p = x;
    }
    if (dict.empty()) { cout << 1; return 0; }

    vec<pii> lst(1, pii(0, 0));
    for (auto it = dict.begin(); it != dict.end(); it++) {
        lst.pb(pii((*it).first, (*it).second));
    }

    int l = 1, r = 1e5 + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;

        vec<pii> a = lst;
        for (int k = (int)a.size() - 1; k >= 1; k--) {
            if (a[k].first - a[k - 1].first <= 17) {
                int tmp = a[k].second;
                for (int j = 0; j < (a[k].first - a[k - 1].first); j++) {
                    tmp /= mid;
                }
                a[k - 1].second += tmp;
            }
        }
        if (a[0].second == 0) { r = mid; }
        else { l = mid; }
    }
    cout << r;
    return 0;
}
