#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    if (n == 1) { cout << 1; return 0; }
    int res = 1;
    vec<int> arr(5001);

    int p = -1;
    for (int k = 0; k < n; k++) {
        int x; cin >> x;
        if (x <= p) {
            arr[x]++;
            for (int i = x + 1; i < 5001; i++) { arr[i] = 0; }
        }
        p = x;

        int l = 0, r = 1e5 + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;

            vec<int> a = arr;
            for (int i = 5000; i > 0; i--) {
                a[i - 1] += a[i] / mid;
            }
            if (a[0] != 0) { l = mid; }
            else { r = mid; }
        }
        res = max(res, r);
    }
    cout << res;
    return 0;
}
