#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(x) (int(x.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;
const long double eps = 1e-10;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

struct kek
{
    int l, r, c;
    kek() { }
};

int n;
int L[maxn];

bool read()
{
    if (scanf("%d", &n) != 1)
        return false;

    for (int i = 0; i < n; ++i)
        scanf("%d", L + i);

    return true;
}

bool check(int z)
{
    vector<kek> cur;
    kek p;
    p.l = 0, p.r = L[0] - 1, p.c = 0;
    cur.push_back(p);

    for (int i = 1; i < n; ++i)
    {
        if (L[i] > L[i - 1])
        {
            kek q;
            q.l = L[i - 1], q.r = L[i] - 1;
            q.c = 0;
            cur.push_back(q);
        }
        else
        {
            for (; cur.back().l >= L[i]; cur.pop_back());

            if (cur.back().r >= L[i])
            {
                p = cur.back();
                cur.pop_back();
                p.r = L[i] - 1;
                cur.push_back(p);
            }

            for (; !cur.empty() && cur.back().c == z - 1; cur.pop_back());

            if (cur.empty())
                return false;

            p = cur.back();
            cur.pop_back();
            kek q;
            q.l = q.r = p.r;
            q.c = p.c + 1;

            if (p.l != p.r)
            {
                --p.r;
                cur.push_back(p);
            }

            cur.push_back(q);

            if (q.r != L[i] - 1)
            {
                q.l = q.r + 1;
                q.r = L[i] - 1;
                q.c = 0;
                cur.push_back(q);
            }
        }
    }

    return true;

    /*vector<int> cur(L[0], 0);

    for (int i = 1; i < n; ++i)
    {
        if (L[i] > L[i - 1])
        {
            for (; size(cur) < L[i]; cur.push_back(0));
        }
        else
        {
            for (; size(cur) > L[i]; cur.pop_back());
            bool good = false;

            for (int j = L[i] - 1; j >= 0; --j)
                if (cur[j] != z - 1)
                {
                    ++cur[j];

                    for (int k = j + 1; k < L[i]; ++k)
                        cur[k] = 0;

                    good = true;
                    break;
                }

            if (!good)
                return false;
        }
    }

    return true;*/
}

void solve()
{
    int l = 1, r = n;

    for (; l < r; )
    {
        int m = (l + r) / 2;

        if (check(m))
            r = m;
        else
            l = m + 1;
    }

    printf("%d\n", l);
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    return 0;
}
