#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(x) (int(x.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;
const long double eps = 1e-10;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

int n, x, y;
string s;

bool read()
{
    if (scanf("%d", &n) != 1)
        return false;

    scanf("%s", buff);
    s = buff;
    scanf("%d %d", &x, &y);
    return true;
}

void solve()
{
    int ans_l, ans_u, ans_r, ans_d;
    int curx = 0, cury = 0;
    ans_l = ans_r = ans_u = ans_d = n;

    if (x <= 0)
        ans_r = 0;

    if (x >= 0)
        ans_l = 0;

    if (y <= 0)
        ans_u = 0;

    if (y >= 0)
        ans_d = 0;

    for (int i = 0; i < n; ++i)
    {
        if (s[i] == 'L')
        {
            if (i < ans_l)
            {
                --curx;

                if (curx == x)
                    ans_l = i + 1;
            }
        }

        if (s[i] == 'R')
        {
            if (i < ans_r)
            {
                ++curx;

                if (curx == x)
                    ans_r = i + 1;
            }
        }

        if (s[i] == 'U')
        {
            if (i < ans_u)
            {
                ++cury;

                if (cury == y)
                    ans_u = i + 1;
            }
        }

        if (s[i] == 'D')
        {
            if (i < ans_d)
            {
                --cury;

                if (cury == y)
                    ans_d = i + 1;
            }
        }
    }

    if (x == curx && y == cury)
        printf("%d %d %d %d\n", ans_l, ans_u, ans_r, ans_d);
    else
        printf("-1\n");
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    return 0;
}
