#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(x) (int(x.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;
const long double eps = 1e-10;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

struct range
{
    int l, r, p;
    range() { }
    range(int l, int r, int p) : l(l), r(r), p(p) { }
};

int n, k;
range a[maxn];
llong dp[maxn];
map<int, int> mp;

bool read()
{
    if (scanf("%d %d", &n, &k) != 2)
        return false;

    forn (i, n)
        scanf("%d %d %d", &a[i].l, &a[i].r, &a[i].p);

    return true;
}

bool cmp(range a, range b) { return a.r < b.r || (a.r == b.r && a.l < b.l); }

void solve()
{
    /*vector<int> v;
    v.push_back(k);

    for (int i = 0; i < n; ++i)
        v.push_back(a[i].l), v.push_back(a[i].r);

    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());

    for (int i = 0; i < size(v); ++i)
        mp[v[i]] = i;

    for (int i = 0; i < n; ++i)
        a[i].l = mp[a[i].l], a[i].r = mp[a[i].r];

    k = mp[k];*/

    if (n <= 3000)
    {
        sort(a, a + n, cmp);

        for (int i = 0; i < n; ++i)
        {
            dp[i] = linf;

            if (a[i].l == 1)
                dp[i] = a[i].p;
        }

        for (int i = 0; i < n; ++i)
            for (int j = i - 1; j >= 0; --j)
                if (a[j].r >= a[i].l - 1)
                {
                    if (a[j].r >= a[i].l)
                        dp[i] = min(dp[i], max(dp[j], 0ll + a[i].p + a[j].p));
                    else
                        dp[i] = min(dp[i], dp[j]);
                }

        llong ans = linf;

        for (int i = 0; i < n; ++i)
        {
            //cout << a[i].l << ' ' << a[i].r << " : " << dp[i] << endl;
            if (a[i].r == k)
                ans = min(ans, dp[i]);
        }

        if (ans != linf)
            printf("%lld\n", ans);
        else
            printf("-1\n");
    }
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    return 0;
}
