#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(x) (int(x.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;
const long double eps = 1e-10;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

struct range
{
    int l, r, p;
    range() { }
    range(int l, int r, int p) : l(l), r(r), p(p) { }
};

int n, k;
llong ans1;
range a[maxn];
llong dp[3002][3002];
map<int, int> mp;

bool read()
{
    if (scanf("%d %d", &n, &k) != 2)
        return false;

    forn (i, n)
        scanf("%d %d %d", &a[i].l, &a[i].r, &a[i].p);

    return true;
}

bool cmp(range a, range b) { return a.r < b.r || (a.r == b.r && a.l < b.l); }

void solve()
{
    /*vector<int> v;
    v.push_back(k - 1);
    v.push_back(k + 1);
    v.push_back(k);

    for (int i = 0; i < n; ++i)
    {
        v.push_back(a[i].l);
        v.push_back(a[i].r);
        v.push_back(a[i].l - 1);
        v.push_back(a[i].r - 1);
        v.push_back(a[i].l + 1);
        v.push_back(a[i].r + 1);
    }

    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());

    for (int i = 0; i < size(v); ++i)
        mp[v[i]] = i;

    for (int i = 0; i < n; ++i)
        a[i].l = mp[a[i].l], a[i].r = mp[a[i].r];

    k = mp[k];*/

    if (n <= 3000)
    {
        for (int i = n - 1; i >= 0; --i)
            a[i + 1] = a[i];

        a[0].l = a[0].r = -1;
        a[0].p = 0;
        ++n;
        sort(a, a + n, cmp);

        forn (i, 3002)
            forn (j, 3002)
                dp[i][j] = linf;

        for (int i = 0; i < n; ++i)
        {
            if (a[i].l == 1)
                dp[i][0] = a[i].p;
            else
                for (int j = i - 1; j >= 0; --j)
                    if (a[j].r < a[i].r && a[j].l < a[i].l && a[i].l - 1 <= a[j].r && dp[i][j] == linf)
                    {
                        int l = 0, r = n - 1;

                        for (; l < r; )
                        {
                            int m = (l + r + 1) / 2;

                            if (a[m].r < a[i].l)
                                l = m;
                            else
                                r = m - 1;
                        }

                        if (a[i].l <= a[j].r)
                            dp[i][j] = max((llong) a[i].p + a[j].p, dp[j][l]);
                        else
                            dp[i][j] = max((llong) a[i].p, dp[j][l]);
                    }

            //cout << i << ' ' << 0 << " : " << dp[i][0] << endl;
            for (int j = 1; j < n; ++j)
            {
                //cout << i << ' ' << j << " : " << dp[i][j] << endl;
                dp[i][j] = min(dp[i][j], dp[i][j - 1]);
            }
        }

        llong ans = linf;

        for (int i = 0; i < n; ++i)
            if (a[i].r == k)
                ans = min(ans, dp[i][n - 1]);

        if (ans == linf)
            ans = -1;

        printf("%lld\n", ans);

        /*if (ans != ans1)
        {
            printf("%d %d\n", n, k);

            for (int j = 0; j < n; ++j)
                cout << a[j].l << ' ' << a[j].r << ' ' << a[j].p << endl;

            cout << ans << ' ' << ans1 << endl;

            exit(0);
        }*/
    }
    else
    {
        set<int> g;
        map<int, int> d;
        g.insert(0);
        sort(a, a + n, cmp);

        for (int i = 0; i < n; ++i)
            ++d[a[i].l], --d[a[i].r + 1];

        int bal = 0;
        bool g1 = false, g2 = false;

        for (int i = 0; i < n; ++i)
        {
            if (a[i].l == 1)
                g1 = true;

            if (a[i].r == k)
                g2 = true;
        }

        if (!g1 || !g2)
        {
            printf("-1\n");
            return ;
        }

        for (auto i : d)
        {
            bal += i.second;

            if (i.first <= k && bal == 0)
            {
                printf("-1\n");
                return ;
            }
        }

        for (int i = 0; i < n; ++i)
            if (g.count(a[i].l - 1))
                g.insert(a[i].r);

        if (g.count(k))
            printf("1\n");
        else
            printf("2\n");
    }
}

void naive()
{
    ans1 = linf;

    for (int mask = 1; mask < (1 << n); ++mask)
    {
        vector<llong> cur(k + 1);

        for (int i = 0; i < n; ++i)
            if ((mask >> i) & 1)
            {
                for (int j = a[i].l; j <= a[i].r; ++j)
                    cur[j] += a[i].p;
            }

        bool good = true;

        for (int j = 1; j <= k; ++j)
            if (cur[j] == 0)
                good = false;

        if (!good)
            continue;

        llong res = 0;

        for (int j = 1; j <= k; ++j)
            res = max(res, cur[j]);

        ans1 = min(ans1, res);
    }

    if (ans1 == linf)
        ans1 = -1;
}

void gen()
{
    n = 1 + rand() % 6;
    k = 1 + rand() % 10;
    cout << n << ' ' << k << endl;

    forn (i, n)
    {
        a[i].l = 1 + rand() % k;
        a[i].r = 1 + rand() % k;
        if (a[i].l > a[i].r) swap(a[i].l, a[i].r);
        a[i].p = 1 + rand() % 5;
        cerr << "here\n";
    }
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA
    srand(time(nullptr));

    if (1)
        while (read())
            solve();
    else
    {
        for (;;)
        {
            gen();
            naive();
            solve();
        }
    }

    return 0;
}
