#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <iomanip>

using namespace std;

const int INF = 2147483647;
const long long lINF = 9223372036854775807;

#define ll long long
#define fi(n) for(int i = 0; i < (n); i++)
#define FOR(i, k, n) for(int i = (k); i < (n); i++)
//#define cin in
//#define cout out

int main()
{
	ifstream in;
	in.open("input.txt");
	ofstream out;
	out.open("output.txt");

	ll n;
	cin >> n;
	string s;
	cin >> s;
	ll x, y;
	cin >> x >> y;
	char rc1 = 'q', rc2 = 'q';
	map<char, int> m;
	if (x > 0)
		rc1 = 'R', m['L'] = 0;
	else if (x < 0)
		rc1 = 'L', m['R'] = 0;
	if (y > 0)
		rc2 = 'U', m['D'] = 0;
	else if(y < 0)
		rc2 = 'D', m['U'] = 0;
	x = abs(x), y = abs(y);
	ll x1 = 0, y1 = 0;
	for (ll k = 0; (x != x1 || y != y1) && k < s.length(); k++)
	{
		if (x != x1 && s[k] == rc1)
			x1++;
		if (y != y1 && s[k] == rc2)
			y1++;
		if (m[rc1] == 0 && x == x1 && x1 != 0)
			m[rc1] = k + 1;
		if (m[rc2] == 0 && y == y1 && y1 != 0)
			m[rc2] = k + 1;
	}
	if (x != x1 || y != y1)
		cout << -1;
	else
		cout << m['L'] << " " << m['U'] << " " << m['R'] << " " << m['D'];
	return 0;
}

