#include <bits/stdc++.h>

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define ll long long
#define ull unsigned long long
#define mp make_pair

using namespace std;

const int N = 3001;
const int mod = 1e9 + 7;
const int inf = 1e9;
const ll Inf = 1e18;

struct segment {
  int l, r, c;
} a[N];
int n, k, p[N];
ll dp[N];

bool cmp(segment a, segment b) {
  return a.r < b.r;
}

void upd(ll &a, ll b, int i, int j) {
  if (a > b) {
    p[i] = j;
    a = b;
  }
}

int main() {
  #ifdef wws
    freopen("in", "r", stdin);
  #endif
  ios_base :: sync_with_stdio(0);
  cin >> n >> k;
  for (int i = 1;i <= n;i++) {
    cin >> a[i].l >> a[i].r >> a[i].c;
    dp[i] = Inf;
  }
  sort(a + 1, a + n + 1, &cmp);
  dp[0] = 0;
  p[0] = 0;
  for (int i = 1;i <= n;i++) {
//    cout << i << endl;
    for (int j = 0;j < i;j++) {
      if (a[i].l <= a[j].l || a[i].l > a[j].r + 1) continue;
      if (a[p[j]].r >= a[i].l) continue;
      upd(dp[i], max(dp[j], 1ll * a[i].c + a[j].c * (a[i].l <= a[j].r)), i, j);
    }
  }
  ll ans = Inf;
  for (int i = 0;i <= n;i++) {
    if (a[i].r == k) {
      ans = min(ans, dp[i]);
    }
  }
  if (ans == Inf) ans = -1;
  cout << ans << endl;
  return 0;
}
