#include <bits/stdc++.h>

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define ll long long
#define ull unsigned long long
#define mp make_pair
#define PI pair < ll, int >

using namespace std;

const int N = 1e6;
const int mod = 1e9 + 7;
const int inf = 1e9;
const ll Inf = 1e18;

struct segment {
  int l, r, c;
} a[N];
int n, k, p[N];
ll dp[N];

bool cmp1(segment a, segment b) {
  if (a.l != b.l) return a.l < b.l;
  return a.r < b.r;
}
bool cmp2(segment a, segment b) {
  return a.r < b.r;
}

void upd(ll &a, ll b, int i, int j) {
  if (a > b) {
    p[i] = j;
    a = b;
  }
}

int main() {
  #ifdef wws
    freopen("in", "r", stdin);
  #endif
  ios_base :: sync_with_stdio(0);
  cin >> n >> k;
  for (int i = 1;i <= n;i++) {
    cin >> a[i].l >> a[i].r >> a[i].c;
    dp[i] = Inf;
  }
  sort(a + 1, a + n + 1, &cmp2);
  if (n <= 3000) {
    for (int i = 1;i <= n;i++) {
      for (int j = 0;j < i;j++) {
        if (a[i].l > a[j].r + 1 || a[p[j]].r >= a[i].l) continue;
        upd(dp[i], max(dp[j], 1ll * a[i].c + 1ll * a[j].c * (a[i].l <= a[j].r)), i, j);
      }
    }
    ll ans = Inf;
    for (int i = 0;i <= n;i++) {
      if (a[i].r == k) {
        ans = min(ans, dp[i]);
      }
    }
    if (ans == Inf) ans = -1;
    cout << ans << endl;
    return 0;
  }
  map < int, int > d;
  d[0] = 1;
  for (int i = 1;i <= n;i++) {
    if (d.count(a[i].l - 1)) {
      d[a[i].r] = 1;
    }
  }
  if (d.count(k)) {
    cout << 1;
  } else {
    int now = 1;
    for (int i = 1;i <= n;i++) {
      if (a[i].l <= now) {
        now = max(now, a[i].r + 1);
      }
    }
    if (now == k + 1) cout << 2;
    else cout << -1;
  }
  return 0;
}
