#include <bits/stdc++.h>

using namespace std;

#define long long long
typedef pair<int, int> pii;
typedef vector<bool> bools;
typedef vector<int> ints;
typedef vector<long> longs;
typedef vector<pii> piis;

#define inf (int) 2e9

/*
5
2 2 2 2 2

4
3 1 2 2

6
1 1 1 1 1 1
 */

int len, n;
ints l;

bool can(long mid) {
    bool ok = true;
    longs smb(len, 1);
    for (int j = l[0]; j < len; ++j) {
        smb[j] = 0;
    }

    for (int i = 1; i < n; ++i) {
        for (int j = l[i]; j < len; ++j) {
            smb[j] = 0;
        }
        if (l[i - 1] < l[i]) {
            for (int j = l[i - 1]; j < l[i] - 1; ++j) {
                smb[j] = 1;
            }
        }

        bool inc = false;
        for (int j = l[i] - 1; j >= 0; --j) {
            if (smb[j] == mid) {
                smb[j] = 1;
            } else {
                smb[j]++;
                inc = true;
                break;
            }
        }
        if (!inc) {
            ok = false;
            break;
        }
    }
    return ok;
}

int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    cin >> n;
    l = ints(n);
    len = 0;
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
        len = max(len, l[i]);
    }

    long left = 0;
    long right = 1ll << 60;
    while (right - left > 1) {
        long mid = right - (right - left) / 2;

        bool ok = can(mid);

        if (ok) {
            right = mid;
        } else {
            left = mid;
        }
    }

    if (left > 0 && can(left)) {
        cout << left;
    } else
        cout << right;

    return 0;
}