#include <bits/stdc++.h>

using namespace std;

#define long long long
typedef pair<long, long> pll;
typedef vector<bool> bools;
typedef vector<int> ints;
typedef vector<long> longs;
typedef vector<pll> plls;

#define inf (int) 2e9

#define aassert(X) (void)(1/(X))
#define debug 0

#if debug
const long n = 10;
int req = 0;

int init() {
    return 1;
}

long gcd(long a, long b) {
    return a * b == 0 ? a + b : gcd(b, a % b);
}

pll ask(long t) {
    cout << "ask " << t;
    req++;
    long nom = n / t;
    long g = gcd(n, nom);
    pll res = {nom / g, n / g};
    if (nom == 0) {
        res = {0, 1};
    }
    cout << ": " << res.first << " " << res.second << endl;
    return res;
}

void answer(long ans) {
    if (n == ans) {
        cout << "OK: " << req << " requests" << endl;
    } else {
        cout << "Fuck: exp " << n << ", got " << ans;
    }
}
#else
int init() {
    int g;
    cin >> g;
    return g;
}

pll ask(long t) {
    cout << "X " << t << endl;
    int a, b;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    cin >> b;
    return {a, b};
}

void answer(long n) {
    cout << "N " << n << endl;
    string res;
    cin >> res;
    if (res != "Correct") {
        exit(0);
    }
}
#endif


bool is_prime(long n) {
    for (long i = 2; i * i <= n; ++i) {
        if (n % i == 0) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    longs primes;
    for (long i = 2;; ++i) {
        if (is_prime(i)) {
            primes.push_back(i);
            if (primes.size() == 59) break;
        }
    }

//    long tmp = 1;
//    for (long p : primes) tmp *= p;
//    cerr << tmp;

    int g = init();
    for (int test = 0; test < g; ++test) {
        long max_d = 0;
        unordered_map<long, pll> cache;
        for (long i = (1ll << 59); i >= 1; i /= 2) {

            pll cur = ask(i);
            cache[i] = cur;
            if (cur.first == -1 && cur.second == -1) {
                return 0;
            }
            max_d = max(max_d, cur.second);
//            if (cur.first == 0) {
//                break;
//            }
        }

        aassert(max_d > 1);
        if (max_d == 1) {
            if (cache[3].first == 1 && cache[3].second == 1) {
                max_d = 3;
            } else if (cache[2].first == 1 && cache[2].second == 1) {
                max_d = 2;
            }
        }
        answer(max_d);
    }

    return 0;
}