#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int INF = 1e9;
const int maxN = 100005;

int arr[maxN];

inline int get(int i, vector<int>& sym, int& l, int& r)
{
    if(i >= l && i < r) return 0;
    else return sym[i];
}

int check(int c, int n)
{
    vector<int> sym(5 + 2e5, 0);

    int l = 0, r = arr[0];
    for(int i = 1; i < n; i++)
    {
        if(arr[i] > arr[i - 1])
        {
            l = arr[i-1], r = arr[i];
            continue;
        }


        if(arr[i] - 1 >= l && arr[i] - 1 < r) sym[arr[i] - 1] = 1, r = arr[i] - 1;
        else sym[arr[i] - 1]++;

        int j = arr[i] - 1;
        while(j > 0 && get(j, sym, l, r) >= c)
        {
            sym[j] = 0;
            if(j - 1 >= l && j - 1 < r)
            {
                sym[j - 1] = 1;
                r = j - 1;
            }
            else
            {
                sym[j - 1]++;
            }
            j--;
        }
        if(sym[j] >= c) return 0;
    }
    return 1;
}

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n; i++) cin >> arr[i];

    int l = 0, r = maxN;
    while(r - l > 1)
    {
        int m = (l + r) / 2;

        if(check(m, n)) r = m;
        else l = m;
    }

    cout << r << endl;




    return 0;
}
