#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int INF = 1e9;
const int maxN = 200005;

int arr[maxN];
int st[maxN * 4];
int toSet[maxN * 4];

void push(int v)
{
    if(toSet[v] == -1) return;

    toSet[v * 2] = toSet[v];
    toSet[v * 2 + 1] = toSet[v];
    st[v * 2] = toSet[v];
    st[v * 2 + 1] = toSet[v];
    toSet[v] = -1;
}

int get(int v, int l, int r, int i)
{
    if(l == r - 1) return st[v];

    push(v);

    int m = (l + r) / 2;
    if(i < m) return get(v * 2, l, m, i);
    else return get(v * 2 + 1, m, r, i);
}

void set_st(int v, int l, int r, int a, int b, int x)
{
    if(b <= l || r <= a) return;
    if(a <= l && r <= b)
    {
        toSet[v] = x;
        st[v] = x;
        return;
    }

    push(v);

    int m = (l + r) / 2;
    set_st(v*2, l, m, a, b, x);
    set_st(v*2 + 1, m, r, a, b, x);
}

void build(int v, int l, int r)
{
    st[v] = 0;
    toSet[v] = -1;

    if(l == r-1) return;

    int m = (l + r) / 2;
    build(v*2, l, m);
    build(v*2+1, m, r);
}

int check(int c, int n)
{
   build(1, 0, 2 + 2e5);

    for(int i = 1; i < n; i++)
    {
        if(arr[i] > arr[i-1])
        {
            set_st(1, 0, 2 + 2e5, arr[i-1], arr[i], 0);
            continue;
        }



        set_st(1, 0, 2 + 2e5, arr[i] - 1, arr[i], get(1, 0, 2 + 2e5, arr[i] - 1) + 1);
        int j = arr[i] - 1;
        while(j > 0 && get(1, 0, 2 + 2e5, j) >= c)
        {
            set_st(1, 0, 2 + 2e5, j, j + 1, 0);
            set_st(1, 0, 2 + 2e5, j - 1, j, get(1, 0, 2 + 2e5, j - 1) + 1);
            j--;
        }
        if(get(1, 0, 2 + 2e5, j) >= c) return 0;
    }
    return 1;
}

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n; i++) cin >> arr[i];


    int l = 0, r = maxN;
    while(r - l > 1)
    {
        int m = (l + r) / 2;

        if(check(m, n)) r = m;
        else l = m;
    }

    cout << r << endl;

    return 0;
}
