#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int INF = 1e9;
const int maxN = 1000005;

int check(string& str, int i1, int i2, int i3, int i4, int x, int y)
{
    int used[4] = {0, 0, 0, 0};

    int cx = 0, cy = 0;
    for(int i = 0; i < str.size(); i++)
    {
        if(i >= i1) used[0] = 1;
        if(i >= i2) used[1] = 1;
        if(i >= i3) used[2] = 1;
        if(i >= i4) used[3] = 1;

        if(str[i] == 'L' && !used[0]) cx--;
        else if(str[i] == 'U' && !used[1]) cy++;
        else if(str[i] == 'R' && !used[2]) cx++;
        else if(str[i] == 'D' && !used[3]) cy--;
    }

    return cx == x && cy == y;
}

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    string str;
    cin >> str;

    int x, y;
    cin >> x >> y;

    for(int i1 = 0; i1 <= n; i1++)
    {
        for(int i2 = 0; i2 <= n; i2++)
        {
            for(int i3 = 0; i3 <= n; i3++)
            {
                for(int i4 = 0; i4 <= n; i4++)
                {
                    if(check(str, i1, i2, i3, i4, x, y))
                    {
                        cout << i1 << " " << i2 << " " << i3 << " " << i4 << endl;
                        return 0;
                    }
                }
            }
        }
    }
    cout << -1 << endl;

    return 0;
}
