#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Query
{
    int l, r;
    ll p;
};

Query query[maxN];

vector<pair<int, int>> event;
vector<int> coords;

vector<Query> qarr[maxN];
int dp[maxN];

map<int, vector<Query>> qarr;
map<int, int> dp;

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    k++;

    for(int i = 0; i < n; i++)
    {
        cin >> query[i].l >> query[i].r >> query[i].p;

        event.push_back(make_pair(query[i].l, 1));
        event.push_back(make_pair(query[i].r + 1, -1));

        qarr[query[i].l].push_back(query[i]);
    }
    sort(event.begin(), event.end());

    int ok = 1;
    int cnt = 0, lst = -10;
    for(int i = 0; i < event.size();)
    {
        int j = i;
        while(j < event.size() && event[i].first == event[j].first) j++;

        for(int k = i; k < j; k++) cnt += event[i].second;

        if(cnt == 0 && lst < event[i].first - 1) ok = 0;
        if(cnt != 0) lst = event[i].first;
    }

    if(event.back().second < k) ok = 0;

    dp[1] = 1;
    for(auto it : qarr.begin())
    {
        if(!dp[it->first]) continue;

        for(auto q : it->second)
        {
            dp[q.r] = 1;
        }
    }

    if(dp[k]) cout << 1 << endl;
    else if(ok) cout << 2 << endl;
    else cout << -1 << endl;





    return 0;
}
