#ifndef C
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>


using namespace std;


typedef long long ll;
typedef long double ld;


struct __D__ {
	__D__() {
#ifdef _DEBUG
		freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#else
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#endif
	}
} __d__;


pair<int, int> q[228];
int c[228];


bool check(int a, int b, int c) { //a <= b <= c
	return a <= b && b <= c;
}


int main() {
	int n, k;
	cin >> n >> k;
	set<int> grs;
	for (int i = 0; i < n; i++) {
		cin >> q[i].first >> q[i].second >> c[i];
		grs.insert(q[i].first);
		grs.insert(min(k, q[i].first + 1));
		grs.insert(max(1, q[i].first - 1));
		grs.insert(q[i].second);
		grs.insert(min(k, q[i].second + 1));
		grs.insert(max(1, q[i].second - 1));
	}
	grs.insert(k);
	int mxmask = (1 << n);
	ll ans = 1e18;
	for (int mask = 0; mask < mxmask; mask++) {
		ll tans = 0;
		bool kek = 1;
		for (int w : grs) {
			bool ok = 0;
			ll sum = 0;
			for (int i = 0; i < n; i++) {
				if (((mask >> i) & 1) && check(q[i].first, w, q[i].second)) {
					ok = 1;
					sum += c[i];
				}
			}
			if (ok) {
				tans = max(tans, sum);
			}
			else {
				kek = 0;
				break;
			}
		}
		if (kek) {
			ans = min(ans, tans);
		}
	}
	if (ans == (ll)1e18) {
		cout << -1;
	}
	else {
		cout << ans;
	}
}



#endif