#ifndef D
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>


using namespace std;


typedef long long ll;
typedef long double ld;


struct __D__ {
	__D__() {
#ifdef _DEBUG
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#else
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#endif
	}
} __d__;


map<ll, pair<ll, ll> > mem;



pair<ll, ll> get(ll x) {
	if (mem.count(x)) {
		return mem[x];
	}
	cout << "X " << x << endl;
	ll a, b;
	cin >> a >> b;
	if (a == -1) {
		exit(0);
	}
	return mem[x] = { a, b };
}


void ans(ll x) {
	cout << "N " << x << endl;
	string com;
	cin >> com;
	if (com != "Correct") {
		exit(0);
	}
}


bool f(ll x) {
	if (get(2ll*x).first == 0) {
		return 1;
	}
	return 0;
}


int main() {
	int g;
	cin >> g;
	mt19937_64 gen;
	while (g--) {
		mem.clear();
		ll kek = get(2).second;
		if (kek != 2ll) {
			ans(kek);
			continue;
		}
		ll l = 0;
#ifdef _DEBUG
		ll r = 100;
#else
		ll r = 1e18;
#endif
		r >>= 1;
		r++;
		bool ok = 0;
		while (r - l > 1ll) {
			uniform_int_distribution<int> kek(l, r);
			ll m = kek(gen);
			if (f(m)) {
				r = m;
			}
			else {
				l = m;
			}
			if (2 * l > r) {
				ok = 1;
				ans(get(2ll*l).second);
				break;
			}
		}
		if (!ok) {
			ans(2ll*l);
		}
	}
}



#endif