#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <assert.h>
#include <set>
#include <iomanip>
using namespace std;

const int len = 100000;
int x, y;
int l[len], r[len], c[len];
long long b[len];
vector < int > comp;
  
int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> x >> y;
	for (int i = 0; i < x; i++) {
		cin >> l[i] >> r[i] >> c[i];
		comp.push_back(l[i]);
		comp.push_back(r[i]);
	}
	comp.push_back(1);
	comp.push_back(y);
	sort(comp.begin(), comp.end());

	comp.resize(unique(comp.begin(), comp.end()) - comp.begin());
	for (int i = 0; i < x; i++) {
		l[i] = lower_bound(comp.begin(), comp.end(), l[i]) - comp.begin();
		r[i] = lower_bound(comp.begin(), comp.end(), r[i]) - comp.begin();
	}

	long long ans = 1ll << 60;
	for (int i = 0; i < (1 << x); i++) {
		long long now = 0;
		for (int j = 0; j < comp.size(); j++)
			b[j] = 0;
		for (int j = 0; j < x; j++) {
			if ((i & (1 << j)) != 0) {
				for (int k = l[j]; k <= r[j]; k++)
					b[k] += c[j];
			}
		}
		bool have = true;
		for (int j = 0; j < comp.size(); j++) {
			if (b[j] == 0) {
				have = false;
			}
			now = max(now, b[j]);
		}
		if(have)
		ans = min(ans, now);
	}
	if (ans != (1ll << 60))
		cout << ans;
	else
		cout << -1;
}