// B.cpp:      .
//

#include <iostream>
#include <string>
#include <vector>
using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	string s;
	cin >> s;
	int cur_x = 0;
	int cur_y = 0;
	vector<int>lefts;
	vector<int>rights;
	vector<int>ups;
	vector<int>downs;
	vector < pair<int, int>>temp(n);
	for (int i = 0; i < s.length(); i++){
		if (s[i] == 'L'){
			cur_x--;
			lefts.push_back(i);
		}
		else if (s[i] == 'U'){
			cur_y++;
			ups.push_back(i);
		}
		else if (s[i] == 'R'){
			cur_x++;
			rights.push_back(i);
		}
		else{
			cur_y--;
			downs.push_back(i);
		}
		temp[i] = make_pair(cur_x, cur_y);
	}
	int x, y;
	cin >> x >> y;

	for (int i = 0; i < s.length(); i++){
		if (temp[i].first == x && temp[i].second == y){
			cout << i + 1 << " " << i + 1 << " " << i + 1 << " " << i + 1;
			return 0;
		}
	}

	if (x == 0 && y == 0){
		cout << 0 << " " << 0 << " " << 0 << " " << 0;
		return 0;
	}
	if (cur_x == x && cur_y == y){
		cout << n << " " << n << " " << n << " " << n;
		return 0;
	}
	int d_x = cur_x - x;
	int d_y = cur_y - y;

	int l_ = n;
	int u_ = n;
	int r_ = n;
	int d_ = n;
	if (d_x > 0){
		if (rights.size() - d_x - 1 == -1){
			//cout << 0;
			r_ = 0;
		}
		else if ((rights.size() - d_x - 1) < -1){
			//cout << -1;
			r_ = -1;
		}
		else{
			//cout << rights[rights.size() - d_x - 1];
			r_ = rights[rights.size() - d_x - 1];
		}
	}
	else if(d_x<0){
		if (lefts.size() + d_x - 1 == -1){
			//cout << 0;
			l_ = 0;
		}
		else if ((lefts.size() + d_x - 1) < -1){
			//cout << -1;
			l_ = -1;
		}
		else{
			//cout << lefts[lefts.size() - d_x - 1];
			l_ = lefts[lefts.size() + d_x - 1];
		}
	}

	if (d_y > 0){
		if (ups.size() - d_y - 1 == -1){
			//cout << 0;
			u_ = 0;
		}
		else if ((ups.size() - d_y - 1) < -1){
			//cout << -1;
			u_ = -1;
		}
		else{
			//cout << lefts[lefts.size() - d_x - 1];
			u_ = ups[ups.size() - d_y - 1];
		}
	}
	else if(d_y<0){
		if (downs.size() + d_y - 1 == -1){
			//cout << 0;
			d_ = 0;
		}
		else if ((downs.size()+ d_y - 1) < -1){
			//cout << -1;
			d_ = -1;
		}
		else{
			//cout << lefts[lefts.size() - d_x - 1];
			d_ = downs[downs.size() + d_y - 1];
		}
	}
	if (l_ == -1 || r_ == -1 || u_ == -1 || d_ == -1){
		cout << -1;
		return 0;
	}
	cout << l_+1 << " " << u_+1<< " " << r_+1 << " " << d_+1;
	return 0;
}

