#include <bits/stdc++.h>
#define ll long long
using namespace std;

struct St {
    int l, r, p;
    friend bool operator < (St a, St b) {
        return a.l < b.l;
    }
};


const int N = 1e5 + 100;
vector <St> v;
ll d[N];

const ll inf = 1e9 * 1e5 + 1000;

int main()
{
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);

    int n, k;
    cin >> n >> k;

    v.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].p;
    }

    sort(v.begin(), v.end());
    v.push_back({k + 1, k + 1, 0});
    n++;
    for (int i = 0; i < n; i++) {
        if (v[i].l == 1) d[i] = 0;
        else d[i] = inf;
    }

    for (int i = 0; i < n; i++) {
        if (d[i] == inf) continue;
        for (int j = i + 1; j < n; j++) {
            if (v[i].r + 1 >= v[j].l) {
                d[j] = min(d[j], v[i].p + d[i]);
            }
        }
    }

    if (d[n - 1] == inf) d[n - 1] = -1;
    cout << d[n - 1] << endl;

    return 0;
}
