#include <bits/stdc++.h>
#define ll long long
using namespace std;

struct St {
    int l, r, p;
    friend bool operator < (St a, St b) {
        return a.l < b.l;
    }
};


const int N = 1e5 + 100;
vector <St> v;
ll d[N];
const ll inf = 1e16;

int main()
{
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);

    set <int> s;
    map <int, int> mp;
    int n, k;
    cin >> n >> k;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].p;
        s.insert(v[i].l);
        s.insert(v[i].r);
    }
    s.insert(1);
    s.insert(k);
    int dl = 1;
    for (int i : s) {
        mp[i] = dl;
        dl++;
    }

    for (int i = 0; i < n; i++) {
        v[i].l = mp[v[i].l];
        v[i].r = mp[v[i].r];
    }

    ll res = inf;

    for (int mask = 0; mask < (1 << n); mask++) {
        for (int i = 1; i <= mp[k]; i++) d[i] = 0;
        for (int i = 0; i < n; i++) {
            if (!((1 << i) & mask)) continue;
            for (int j = v[i].l; j <= v[i].r; j++) d[j] += v[i].p;
        }

        bool fl = true;
        ll mx = 0;
        for (int i = 1; i <= mp[k]; i++) {
            if (d[i] == 0) fl = false;
            mx = max(mx, d[i]);
        }
        if (fl) res = min(res, mx);
    }

    if (res == inf) res = -1;
    cout << res << endl;

    return 0;
}
