#pragma comment(linker,"/STACK:166777216")
#define _CRT_SECURE_NO_WARNINGS
#define ll long long
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int z;
vector<int> a;
vector<vector<pair<int,int>>> sparse;
void make_sparse(const int& n)
{
	int d = 1;
	while ((1 << d) < n)
		++d;
	sparse = vector<vector<pair<int, int>>>(d);
	for (int i = 0; i < d; ++i)
		sparse[i] = vector<pair<int, int>>(n);
	for (int i = 0; i < n; ++i)
		sparse[0][i] = make_pair(a[i], i);
	for (int i = 1; i < d; ++i)
	for (int j = 0; j < n; ++j)
	{
		pair<int, int> q1 = sparse[i - 1][j], q2 = sparse[i - 1][min(n - 1, j + (1 << (i - 1)))];
		if (q1.first < q2.first)
			sparse[i][j] = q1;
		else
			sparse[i][j] = q2;
	}
}
pair<int, int> min_sparse(const int& l, const int& r)
{
	int d = 1, s = r - l + 1;
	while ((1 << d) < s)
		++d;
	--d;
	pair<int, int> q1 = sparse[d][l], q2 = sparse[d][r - (1 << d) + 1];
	if (q1.first < q2.first)
		return q1;
	else
		return q2;
}
int checkr(const int&, const int&, const int&);
int checkl(const int& l, const int& r, const int& m)
{
	if (r < l)
		return 0;
	pair<int, int> msp = min_sparse(l, r);
	int q = msp.first;
	if (q == m)
		return checkl(l, msp.second - 1, q) + 1 + checkl(msp.second + 1, r, q);
	else
		return checkr(l, r, m + 1) / z;
}
int checkr(const int& l, const int& r, const int& m)
{
	if (r < l)
		return 0;
	pair<int, int> msp = min_sparse(l, r);
	int q = msp.first, pos = msp.second, s;
	if (pos == l)
		s = checkl(l + 1, r, q);
	else
		s = checkr(l, pos - 1, q) + 1 + checkl(pos + 1, r, q);
	if (z != 1)
	while ((q > m) && s)
	{
		--q;
		s /= z;
	}
	return s;
}

int main()
{
	ios_base::sync_with_stdio(0);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	a = vector<int>(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	make_sparse(n);
	int x = 0, y = n;
	z = ((y - x) >> 1);
	while (z)
	{
		z += x;
		if (z == 2)
		{
			z = 2;
		}
		if (checkl(0, n - 1, 0))
			x = z;
		else
			y = z;
		z = ((y - x) >> 1);
	}
	cout << y;
	return 0;
}