#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

ifstream in("input.txt");

bool cmp(pair <pair <int, int>, int> a, pair <pair <int, int>, int> b){
    if (a.first.second == b.first.second){
        return a.first.first < b.first.first;
    }
    return a.first.second < b.first.second;
}

int main() {
    int n, k;
    in >> n >> k;
    vector <pair <pair <int, int>, int> > p(n);
    for (int i = 0; i < n; i++){
        in >> p[i].first.first >> p[i].first.second >> p[i].second;
    }
    p.push_back(make_pair(make_pair(0, 0), 0));
    vector <int> dk(n + 1, 2e9 + 2);
    dk[0] = 0;
    sort(p.begin(), p.end(), cmp);
    /*for (int i = 0; i <= n; i++){
        //cout << p[i].first.first << " " << p[i].first.second << " " << p[i].second << endl;
    }*/
    int res = 2e9 + 2;
    for (int i = 1; i <= n; i++){
        int j = i - 1;
        while (j >= 0 && p[j].first.second >= p[i].first.first){
            dk[i] = min(max(dk[j], p[j].second + p[i].second), dk[i]);
            j--;
        }
        while (j >= 0 && p[j].first.second + 1 >= p[i].first.first){
            dk[i] = min(max(dk[j], p[i].second), dk[i]);
            j--;
        }
        if (p[i].first.second == k){
            res = min(res, dk[i]);
        }
    }
    if (res == 2e9 + 2){
        cout << -1 << endl;
        return 0;
    }
    cout << res << endl;
    return 0;
}