#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

ifstream in("input.txt");

const long long inf = 2e11 + 5;

bool cmp(pair <pair <long long, long long>, long long> a, pair <pair <long long, long long>, long long> b){
    if (a.first.second == b.first.second){
        return a.first.first < b.first.first;
    }
    return a.first.second < b.first.second;
}

int main() {
    long long n, k;
    in >> n >> k;
    vector <pair <pair <long long, long long>, long long> > p(n);
    for (long long i = 0; i < n; i++){
        in >> p[i].first.first >> p[i].first.second >> p[i].second;
    }
    p.push_back(make_pair(make_pair(0, 0), 0));
    vector <long long> dk(n + 1, inf);
    dk[0] = 0;
    sort(p.begin(), p.end(), cmp);
    /*for (long long i = 0; i <= n; i++){
        cout << p[i].first.first << " " << p[i].first.second << " " << p[i].second << endl;
    }*/
    long long res = inf;
    for (long long i = 1; i <= n; i++){
        long long j = i - 1;
        while (j >= 0 && p[j].first.second >= p[i].first.first){
            dk[i] = min(max(dk[j], p[j].second + p[i].second), dk[i]);
            j--;
        }
        while (j >= 0 && p[j].first.second + 1 == p[i].first.first){
            dk[i] = min(max(dk[j], max(p[j].second, p[i].second)), dk[i]);
            j--;
        }
        if (p[i].first.second >= k){
            res = min(res, dk[i]);
        }
    }
    if (res == inf){
        while (true) {
            res ++;
        }
        cout << -1 << endl;
        return 0;
    }
    cout << max(res, (long long) 1) << endl;
    return 0;
}