#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mk make_pair
#define eps 1lle-8
#define all(x) x.begin(), x.end()
#define inf 2e9
#define nl nullptr
#define linf 8e18
#define Size 100005

int N;
vector<ll> V;

ll pw(ll k, ll p) {
	if (!p)
		return 1;
	if (p % 2)
		return k * pw(k, p - 1);
	ll s = pw(k, p / 2);
	return s * s;
}

bool check(int k) {
	ll cnt = 1;
	ll mx = V[0];
	for (int i = 1; i < N; i++) {
		mx = max(mx, V[i]);
		if (V[i - 1] >= V[i]) {
			cnt += pw(k, V[i - 1] - V[i]);
		}
	}
	return pw(k, mx) >= cnt;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif

	cin >> N;

	for (int i = 0; i < N; i++) {
		int a;
		scanf("%d", &a);
		V.push_back(a);
	}

	int l = 0, r = 65;
	while (r - l > 1) {
		int m = l + r >> 1;
		if (check(m))
			r = m;
		else
			l = m;
	}

	cout << r << "\n";

	return 0;
}