#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mk make_pair
#define eps 1lle-8
#define all(x) x.begin(), x.end()
#define inf 2e9
#define linf 8e18
#define TL clock() * 1.0 / CLOCKS_PER_SEC
#define Size 400005

struct ev {
	ll l, r, p;
	ev(ll l, ll r, ll p) : l(l), r(r), p(p) {}
};

struct ev1 {
	ll x, in, p;
	bool close;
	ev1(ll x, ll in, bool close, ll p) : x(x), in(in), close(close), p(p) {}
};

vector<ev> V;

bool cmp(ev1 a, ev1 b) {
	return a.x < b.x || a.x == b.x && !a.close && b.close;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif
	ll N, K;
	cin >> N >> K;

	for (ll i = 0; i < N; i++) {
		ll l, r, p;
		cin >> l >> r >> p;
		V.push_back(ev(l, r, p));
	}

	ll mn = inf;
	for (ll mask = 0; mask < (1 << N); mask++) {
		if (TL > 3.9)
			break;
		vector<ev1> G;
		for (ll i = 0; i < N; i++)
			if ((1 << i) & mask) {
				G.push_back(ev1(V[i].l, i, 0, V[i].p));
				G.push_back(ev1(V[i].r, i, 1, V[i].p));
			}
		sort(all(G), cmp);
		ll w = 0;
		ll ans = -1;
		if (!G.size())
			continue;
		if (G[0].x > 1 || G.rbegin()->x < K)
			continue;
		for (ll i = 0; i < G.size(); i++) {
			if (i != 0) {
				if (G[i].x - G[i - 1].x > 1 && w == 0) {
					ans = -1;
					break;
				}
			}
			if (!G[i].close)
				w += G[i].p;
			else
				w -= G[i].p;
			ans = max(ans, w);
		}
		if (ans != -1)
			mn = min(mn, ans);
	}
	if (mn == inf)
		cout << "-1\n";
	else
		cout << mn << "\n";

	return 0;
}