#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mk make_pair
#define eps 1lle-8
#define all(x) x.begin(), x.end()
#define inf 2lle9
#define linf 8e1ll8
#define Size 10000007

const int MAX = 100;
const int CNT = 6;
bool B[MAX];

ll gcd(ll x, ll y) {
	if (!y)
		return x;
	return gcd(y, x % y);
}

pair<ll, ll> ask(ll x) {
	cout << "X " << x << endl;
	ll c, z;
	cin >> c >> z;
	return mk(c, z);
}

int main() {
#ifdef _DEBUG
	//freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif
	/*
	B[1] = 1;
	for (int i = 2; i * i <= MAX; i++)
		if (!B[i])
			for (int j = 2 * i; j <= MAX; j += i)
				B[j] = 1;
	vector<int> Prim;
	for (int i = 2; i < MAX; i++) {
		if (!B[i]) {
			Prim.push_back(i);
		}
	}*/

	int N;
	cin >> N;
	for (int i = 0; i < N; i++) {
		
		ll l = 0, r = 1e18;
		while (r - l > 1) {
			ll m = l + r >> 1;
			auto cur = ask(m);
			if (cur.first == 0)
				r = m;
			else
				l = m;
		}
		cout << "N " << l << "\n";
		string st;
		cin >> st;
		if (st != "Correct")
			return 0;
	}

#ifdef _DEBUG
	system("pause");
#endif

	return 0;
}