#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define ll long long
#define f first
#define s second
#define all(v) v.begin(), v.end()
#define pii pair<int, int>
#define sz(v) int(v.size())

using namespace std;

const int N = 1e5 + 123;
const int MAXN = 1e6 + 123;
const int INF = 1e9 + 7;
const double EPS = 1e-9;

vector<int> primes;

pair<ll, ll> ask(int x) {
    cout << "X " << x << endl;
    pair<ll, ll> drobe;
    cin >> drobe.f;
    if (drobe.f == -1) {
        exit(0);
    }
    cin >> drobe.s;
    return drobe;
}

ll solve() {
    set<pair<ll, ll> > s;            
    for (int i = 0; i < sz(primes); i++) {
        s.insert(ask(primes[i]));
    }    
    ll prob = (*s.rbegin()).s;
    pair<ll, ll> tmp = ask(prob);
    if (tmp.s != 1) 
        prob = tmp.s;
    return prob;
}

bool prime(int x) {
    for (int i = 2; i * i <= x; i++) if (x % i == 0) return false;
    return true;
}

int n;

pii answer(int x) {
    pii drobe;
    drobe.f = (n - x + 1) / x;
    drobe.s = n;
    int g = __gcd(drobe.f, drobe.s);
    drobe.f /= g;
    drobe.s /= g;
    return drobe;
}

int main() {
    #define fn ""
    #ifdef SONY
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
//        freopen(fn".in", "r", stdin);
//        freopen(fn".out", "w", stdout);
    #endif // SONY
    srand(time(0));
    for (int i = 2; sz(primes) < 59; i++) {
        if (prime(i)) primes.pb(i);    
    }
    /*
    int iter = 100;
    while (iter--) {
        n = rand() % 10000 + 1;
        set<pii> cur;
        for (auto it : primes) {
            cur.insert(answer(it));
        }
        int prob = (*cur.rbegin()).s;
        pii tmp = answer(prob);
        //cout << tmp.f << " " << tmp.s << endl;
        if (tmp.s != 1) prob = tmp.s;
        cout << n << " " << prob << endl;
    } 
    return 0;
    */
    int g;
    cin >> g;
    while (g--) {
        ll answer = solve();
        assert(answer >= 1 && answer <= (ll) 1e18);
        cout << "N " << answer << endl;
        string s;
        cin >> s;
        if (s == "Wrong") exit(0);
    }
    return 0;
}
