#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define ll long long
#define f first
#define s second
#define all(v) v.begin(), v.end()
#define pii pair<int, int>
#define sz(v) int(v.size())

using namespace std;

const int N = 1e5 + 123;
const int MAXN = 1e6 + 123;
const int INF = 1e9 + 7;
const double EPS = 1e-9;

vector<int> primes;

pair<ll, ll> ask(ll x) {
    cout << "X " << x << endl;
    pair<ll, ll> drobe;
    cin >> drobe.f;
    if (drobe.f == -1) {
        assert(0);
    }
    cin >> drobe.s;
    assert(drobe.f >= 0 && drobe.f <= (ll) 1e18);
    assert(drobe.s >= 0 && drobe.s <= (ll) 1e18);
    return drobe;
}

ll solve() {
    set<ll> s;
    int l = 0, r = sz(primes) - 1;
    int lim = -1;
    while (l <= r) {
        int m = (l + r) / 2;
        if (ask(primes[m]).f == 0) {
            r = m - 1;
        } else {
            l = m + 1;
            lim = m;
        }
    }
    ++lim;
    //cout << lim << endl;
    //if (lim == 0) return 1;
    //assert(lim > 0);
    for (int i = 0; i < min(sz(primes), lim + 2); i++) {
        ll prob1 = primes[i];
        s.insert(ask(prob1).s);
    }    
    return *s.rbegin();
}

bool prime(int x) {
    for (int i = 2; i * i <= x; i++) if (x % i == 0) return false;
    return true;
}

ll n;

pair<ll, ll> answer(ll x) {
    pair<ll, ll> drobe;
    drobe.f = (n - x + 1) / x;
    drobe.s = n;
    ll g = __gcd(drobe.f, drobe.s);
    drobe.f /= g;
    drobe.s /= g;
    return drobe;
}

int big_rand() {
    return 1e5 + rand() % (int(1e5));
}

ll solve_sony() {
    set<ll> s;
    int l = 0, r = sz(primes) - 1;
    int lim = -1;
    while (l <= r) {
        int m = (l + r) / 2;
        if (answer(primes[m]).f == 0) {
            r = m - 1;
        } else {
            l = m + 1;
            lim = m;
        }
    }
    ++lim;
    //cout << lim << endl;
    if (lim == 0) return 1;
    assert(lim > 0);
    for (int i = 0; i < 30; i++) {
        ll prob1 = primes[rand() % lim];
        s.insert(answer(prob1).s);
    }    
    return *s.rbegin();
}


int main() {
    #define fn ""
    #ifdef SONY
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
//        freopen(fn".in", "r", stdin);
//        freopen(fn".out", "w", stdout);
    #endif // SONY
    srand(time(0));
    for (int i = 2; sz(primes) < 60; i++) {
        if (prime(i)) primes.pb(i);    
    }
    /*
    int iter = 1000;
    while (iter--) {
        n = big_rand();
        if (solve_sony()!=n){
            cout << n << " " << solve_sony() << endl;
            return 0;
        }
    } 
    return 0;
    */   
    int g;
    cin >> g;
    while (g--) {
        ll answer = solve();
        cout << "N " << answer << endl;
        string s;
        cin >> s;
        if (s == "Wrong") {
            while (1) {

            }
        }
    }
    return 0;
}
