#include <bits/stdc++.h>

/*
When the days are cold
And the cards are fold
And the saints we see
All are made of gold

When your dreams all failed
And the ones we hail
Are the worst of all
And the blood's run stale
*/

using namespace std;

typedef long long ll;
#define LL (ll)
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
#define mp make_pair
#define pb push_back
#define all(U) U.begin(), U.end()
#define gmin(U) (*U.begin())
#define imin(U) (U.begin())
#define gmax(U) (*(--U.end()))
#define imax(U) (--U.end())
#define clr(U) memset(U, 0, sizeof U)
#define sz(U) int(U.size())

const ll inf = 2e18;

struct seg {
    int l, r, p;
};

bool cmp(const seg &a, const seg &b)
{
    if (a.r == b.r)
    {
        if (a.p == b.p)
            return a.l > b.l;
        return a.p < b.p;
    }
    return a.r < b.r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector <seg> s(n);
    set <int> pts;
    pts.insert(0);
    pts.insert(k);
    for (int i(0); i < n; ++i) {
        cin >> s[i].l >> s[i].r >> s[i].p;
        pts.insert(s[i].l);
        pts.insert(s[i].l - 1);
        pts.insert(s[i].r);
        pts.insert(s[i].r - 1);
    }
    int tmp(0);
    map <int, int> trans;
    for (int u : pts)
        trans[u] = tmp++;
    for (seg &se : s)
    {
        se.l = trans[se.l];
        se.r = trans[se.r];
    }
    ll dp[trans[k] + 1], w[trans[k] + 1];
    dp[0] = 0;
    w[0] = 0;
    for (int i(1); i <= trans[k]; ++i)
        dp[i] = inf;
    sort(all(s), cmp);
    for (seg &cur : s) {
        if (dp[cur.l - 1] == inf) continue;
        ll cp = dp[cur.r];
        dp[cur.r] = max(dp[cur.l - 1], w[cur.l - 1] + cur.p);
        w[cur.r] = 0;
        for (int i(cur.l); i < cur.r; ++i)
            if (dp[i] > dp[cur.r])
            {
                dp[i] = dp[cur.r];
                w[i] = cur.p;
            }
            else if (dp[i] == dp[cur.r] && w[i] > cur.p)
                w[i] = cur.p;
        if (cp < dp[cur.r]) dp[cur.r] = cp;
        //cout << cur.r << ' ' << dp[cur.r] << '\n';
    }
    if (dp[trans[k]] == inf) cout << -1;
    else cout << dp[trans[k]];
}
