#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int N = 1e5 + 50;
const ll INF = 1e18 + 50;

struct str {
    ll x, y, p;
} a[N];

bool operator<(str a, str b) {
    return make_pair(make_pair(a.x, a.y), a.p) < make_pair(make_pair(b.x, b.y), b.p);
}

ll ans = INF;
ll n, k;

void dfs(int i, ll cur, int ma) {
    if (a[i].y == k)
        ans = min(ans, cur);
    for (int j = 0; j < n; j++) {
        if (a[j].x > ma && a[i].x < a[j].x && a[i].y < a[j].y && a[i].y >= a[j].x) {
            if (a[i].y == a[j].x)
                dfs(j, max(cur, a[j].p), a[i].y);
            else
                dfs(j, max(cur, a[i].p + a[j].p), a[i].y);
        }
    }
}

int main()
{
    cin >> n >> k;
    k++;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y >> a[i].p;
        a[i].y++;
    }
    sort(a, a + n);
    for (int i = 0; i < n; i++) {
        if (a[i].x == 1)
            dfs(i, a[i].p, 0);
    }
    if (ans == INF)
        cout << -1;
    else
        cout << ans;
    return 0;
}
