#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

bool nonprime[200];
vector < ll > primes, prefp;

int main()
{
    primes.push_back(1);
    for (int i = 2; i <= 100; i++) {
        if (!nonprime[i]) {
            primes.push_back(i);
            for (int j = i + i; j <= 100; j += i)
                nonprime[j] = true;
        }
    }
    prefp = primes;
    for (int i = 1; i < 16; i++)
        prefp[i] *= prefp[i - 1];
    int g;
    cin >> g;
    for (int i = 0; i < g; i++) {
        int left = 0, right = 16;
        while (left + 1 < right) {
            int mid = (left + right) / 2;
            cout << "X " << prefp[mid] << endl;
            ll x, y;
            cin >> x;
            if (x == -1)
                return 0;
            cin >> y;
            if (x == 1 && y == prefp[mid])
                left = mid;
            else
                right = mid;
        }
        ll l1 = 1, r1 = primes[right];
        while (l1 + 1 < r1) {
            ll m1 = (l1 + r1) / 2;
            cout << "X " << prefp[left] * m1 << endl;
            ll x, y;
            cin >> x;
            if (x == -1)
                return 0;
            cin >> y;
            if (x == 0)
                r1 = m1;
            else
                l1 = m1;
        }
        cout << "N " << prefp[left] * l1 << endl;
        string s;
        cin >> s;
        if (s == "Wrong")
            return 0;
    }
    return 0;
}
