#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <random>
#include <map>

using namespace std;

const int INF = 2e9 + 7;

map <int, int> kor;
multiset <int> d[200500];
int mini[400000];
int mdv = 262144;




set <int> q;
pair < pair <int, int> , int> ot[100500];
int n;
int k;



multiset < pair <int, int> > delite;
multiset < pair <int, pair <int, int> > > dobav;

int get(int nom, int tl, int tr, int l, int r) {
	if (tl > r || tr < l) {
		return INF;
	}
	if (tl >= l && tr <= r) {
		return mini[nom];
	}
	return min(get(2 * nom, tl, (tr + tl) / 2, l, r), get(2 * nom + 1, (tl + tr) / 2 + 1, tr, l, r));
}

void add(int nom, int dob) {
	d[nom].insert(dob);
	mini[nom + mdv] = (*d[nom].begin());
	nom = nom + mdv;
	while (nom != 1) {
		nom = nom / 2;
		mini[nom] = min(mini[nom * 2], mini[nom * 2 + 1]);
	}
}

void del(int nom, int dob) {
	d[nom].erase(d[nom].find(dob));
	if (d[nom].size() != 0) {
		mini[nom + mdv] = (*d[nom].begin());
	}
	else {
		mini[nom + mdv] = INF;
	}
	nom = nom + mdv;
	while (nom != 1) {
		nom = nom / 2;
		mini[nom] = min(mini[nom * 2], mini[nom * 2 + 1]);
	}
}

bool pr(int m) {
	q.clear();
	delite.clear();
	dobav.clear();
	q.insert(0);
	for (int i = 0; i < mdv; i++) {
		d[i].clear();
		mini[i + mdv] = INF;
	}
	for (int i = mdv - 1; i > 0; i--) {
		mini[i] = min(mini[i * 2], mini[i * 2 + 1]);
	}

	for (int i = 1; i <= n; i++) {
		if (ot[i].second > m) {
			continue;
		}
		while (dobav.size() != 0 && dobav.begin()->first <= ot[i].first.first) {
			add(dobav.begin()->second.first, dobav.begin()->second.second);
			dobav.erase(dobav.begin());
		}
		while (delite.size() != 0 && delite.begin()->first < ot[i].first.first) {
			del(delite.begin()->second, delite.begin()->first);
			delite.erase(delite.begin());
		}
		

		int mini = get(1, 0, mdv - 1, 0, m - ot[i].second);
		if (mini < ot[i].first.second) {
			q.insert(ot[i].first.second);
			dobav.insert(make_pair(mini + 1, make_pair(ot[i].second, ot[i].first.second)));
			delite.insert(make_pair(ot[i].first.second, ot[i].second));
		}



		if (q.find(ot[i].first.first - 1) != q.end()) {
			//dobav.insert(make_pair(ot[i].first.first, make_pair(ot[i].second, ot[i].first.second)));
			add(ot[i].second, ot[i].first.second);
			delite.insert(make_pair(ot[i].first.second, ot[i].second));
			q.insert(ot[i].first.second);
		}
	}
	return (q.find(k) != q.end());

}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; i++) {
		cin >> ot[i].first.first >> ot[i].first.second >> ot[i].second;
	}
	sort(ot + 1, ot + n + 1);
	q.insert(0);
	for (int i = 1; i <= n; i++) {
		set <int>::iterator it = q.end();
		it--;
		if ((*it) >= ot[i].first.first - 1) {
			q.insert(ot[i].first.second);
		}
	}
	if (q.find(k) == q.end()) {
		cout << -1;
		return 0;
	}

	int l = 0, r = INF;
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (pr(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
}
	

