#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-5;

//oh hi there

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	int n;
	cin >> n;

	vector<ll> a(n);
	map<ll, ll> cnt;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		cnt[a[i]]++;
	}

	sort(all(a));
	auto it = unique(all(a));
	if (it != a.end()) a.erase(it);
	
	ll ans = 1;
	for (int i = 0; i < a.size(); i++) {
		ans = max(ans, (ll)ceil(pow((double)cnt[a[i]], 1./(double(a[i]))) - EPS));
	}

	cout << ans;

	return 0;
}