#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//oh hi there

int n;
vector<int> a;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector<int> b = a;
	sort(all(b));
	auto it = unique(all(b));
	if (it != b.end())
		b.erase(it, b.end());

	vector<int> d;
	map<int, int> pos;
	d.push_back(b[0]);
	pos[b[0]] = 0;
	for (int i = 1; i < b.size(); i++) {
		pos[b[i]] = i;
		d.push_back(b[i] - b[i - 1]);
	}

	bool flag = false;
	vector<int> cnt(b.size(), 0);
	cnt[pos[a[0]]]++;
	for (int i = 1; i < n; i++) {
		if (a[i] <= a[i - 1]) {
			cnt[pos[a[i]]]++;
			flag = true;
		}
	}

	if (!flag) {
		cout << 1;
		return 0;
	}

	int ans = 2;
	for (int i = cnt.size() - 1; i >= 0; i--) {
		int tmp = 2;
		while (powl(ld(tmp), ld(d[i])) < cnt[i]) {
			tmp++;
		}
		ans = max(ans, tmp);
	}

	cout << ans;

	return 0;
}