#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forab(i, a, b) for (int i = (int)(a); i < (int)(b); ++i)
#define all(a) a.begin(), a.end()
#define TASK "sum"
typedef long long ll;
const int inf = int(1e9) + 10;
const ll infll = ll(1e18) + 1;
const int N = 100000 + 10;
/*int n, k;
Event scanline[N];

struct Event {
    int l, r, p;
    Event() {
        l = r = p = 0;
    }
    void get() {
        cin >> l >> r >> p;
    }
};

bool cmp(Event &a, Event &b) {
    return (a.l < b.l ? a : (a.r < b.r));
}*/

int g;
int done = 0;

ll ask(ll a) {
    ll ans1, ans2;
    printf("X %lld\n", a);
    fflush(stdout);
    scanf("%lld", &ans1);
    if (ans1 == -1)
        exit(0);
    scanf("%lld", &ans2);
    return ans1;
}

pair<int, int> clever_solve() {
    ll l = 1, r = infll;
    ll last = -infll, now = ask(ll(inf) - 10), m;
    last = now;
    ll last_m = -1;
    while (last == now) {
        last_m = m;
        m = int(sqrt(l + r));
        last = now;
        now = ask(m);
        //cout << last << " " << now << "!!!!!" << endl;
        if (now > 0)
            l = m;
        else
            r = m;
        done++;
        assert(done <= 60);
    }
    return {m, last_m};
}

ll solve() {
    auto M = clever_solve();
    //cout << "Done\n";
    ll l = M.first, r = M.second;
    //cout << l << " " << r << endl;
    while (l + 1 != r) {
        ll m = (l + r) / 2;
        ll now = ask(m);
        if (now > 0)
            l = m;
        else
            r = m;
        done++;
        assert(done <= 60);
    }
    return l;
}

int main() {
    //freopen(TASK ".in", "r", stdin);
    //freopen(TASK ".out", "w", stdout);
    scanf("%d", &g);
    forn(i, g) {
        printf("N %lld\n", solve());
        fflush(stdout);
        string response;
        cin >> response;
        if (response != "Correct")
            exit(0);
        done = 0;
    }
    /*scanf("%d %d", &n, &k);
    forn(i, n)
        scanline[i].get();
    sort(scanline, scanline + n, cmp);*/
    return 0;
}