#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
#include <stack>
#include <sstream>
#include <vector>
#include <queue>

#define f first
#define s second
#define ll long long

using namespace std;

ll ans=1;

bool update(vector<ll> & v)
{
    int i=v.size()-1;
    while(i>0 && v[i]>=ans)
    {
        v[i-1]++;
        v[i]-=ans;
    }
    if(v[0]>=ans)
    {
        return 0;
    }
    return 1;
}

void build(vector<ll> & v)
{
    ///cout<<ans<<endl;
    int n=v.size();
    vector< vector<ll> >  a(n);
    for(int i=0;i<n;i++)
    {
        if(i==0)
        {
            for(int j=0;j<v[i];j++)
            {
                a[i].push_back(0);
            }
        }
        else
        {
            if(v[i]>v[i-1])
            {
                a[i]=a[i-1];
                for(int j=v[i-1];j<v[i];j++)
                {
                    a[i].push_back(0);
                }
            }
            else
            {
                for(int j=0;j<v[i];j++)
                {
                    a[i].push_back(a[i-1][j]);
                    if(j==v[i]-1)
                    {
                        a[i][j]++;
                        if(a[i][j]>=ans)
                        {
                            if(!update(a[i]))
                            {
                                ans++;
                                build(v);
                                return;
                            }
                        }
                    }
                }
            }

        }
    }
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<v[i];j++)
        {
            cout<<a[i][j]<<" ";
        }
        cout<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    srand(time(NULL));
    int n;
    cin>>n;
    vector<ll> v(n);
    for(int i=0;i<n;i++)
    {
        cin>>v[i];
    }
    build(v);
    cout<<ans;
    return 0;
}
