#include <bits/stdc++.h>

using namespace std;

int l[100010];

int my_rand()
{
    return (rand() << 16) + rand();
}

struct Node
{
    int x, c, y;
    Node *l, *r;
    Node(int x_ = 0, int c_ = 1, int y_ = my_rand()): x(x_), c(c_), y(y_), l(NULL), r(NULL) {}
};

Node* merge(Node* v, Node* u)
{
    if (v == NULL)
        return u;
    if (u == NULL)
        return v;
    if (v->y < u->y)
    {
        v->r = merge(v->r, u);
        return v;
    }
    else
    {
        u->l = merge(v, u->l);
        return u;
    }
}

pair<Node*, Node*> split(Node* v, int x)
{
    if (v == NULL)
        return {v, v};
    pair<Node*, Node*> p;
    if (v->x <= x)
    {
        p = split(v->r, x);
        v->r = p.first;
        p.first = v;
    }
    else
    {
        p = split(v->l, x);
        v->l = p.second;
        p.second = v;
    }
    return p;
}

bool kek;
int mi;

Node* ins(Node* v, Node* u)
{
    kek = 0;
    if (v == NULL)
        return u;
    if (v->x == u->x)
    {
        if (v->c == mi - 1)
        {
            kek = 1;
            return merge(v->l, v->r);
        }
        else
            v->c++;
    }
    else if (u->y < v->y)
    {
        pair<Node*, Node*> p = split(v, u->x);
        u->l = p.first;
        u->r = p.second;
        return u;
    }
    else if (v->x < u->x)
        v->r = ins(v->r, u);
    else
        v->l = ins(v->l, u);
    return v;
}

int main()
{
    srand(228);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    bool qwe = 1;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i];
        if (l[i] <= l[i - 1])
            qwe = 0;
    }
    if (qwe)
    {
        cout << 1 << endl;
        return 0;
    }
    int le = 1, ri = n;
    while (ri - le > 1)
    {
        mi = (le + ri) / 2;
        Node* root = NULL;
        map<int, int> ma;
        bool d = 1;
        for (int i = 1; i < n; i++)
        {
            if (l[i] <= l[i - 1])
            {
                pair<Node*, Node*> p = split(root, l[i]);
                root = p.first;
                kek = 1;
                int t = l[i];
                while (kek)
                {
                    if (t == 0)
                    {
                        d = 0;
                        break;
                    }
                    if (ma.count(t) == 0)
                        ma[t] = my_rand();
                    root = ins(root, new Node(t, 1, ma[t]));
                    t--;
                }
                if (!d)
                    break;
            }
        }
        if (d)
            ri = mi;
        else
            le = mi;
    }
    cout << ri << endl;
    return 0;
}
