#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>

using namespace std;

const int inf = 2e9;
const int maxn = 128000;
int n, k;
bitset<maxn> used;
vector<pair<int, int> > g[maxn];
vector<pair<int, int>> d;
void dfs(int v)
{
    used[v] = 1;
    for (int i = 0; i < g[v].size(); ++i)
    {
        int to = g[v][i].first, p = g[v][i].second;
        if (!used[to])
            dfs(to);
    }
}
int main()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
    {
        int fr, to, p;
        cin >> fr >> to >> p;
        if (to > k)
            to = k;
        g[fr].push_back({to, p});
        d.push_back({fr, 0});
        d.push_back({to, 1});
    }
    dfs(1);
    if (used[k])
    {
        cout << 1;
        return 0;
    }
    int cnt = 0;
    sort(d.begin(), d.end());
    for (int i = 0; i < d.size(); ++i)
    {
        if (d[i].second)
            cnt--;
        else
            cnt++;
        if (cnt == 0 && d[i].first != k)
        {
            cout << -1;
            return 0;
        }
    }
    cout << 2;


    return 0;
}
