#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <map>

using namespace std;

const int inf = 2e9;
const int maxn = 128000;
int n, k;
bitset<maxn> used;
vector<pair<int, int> > g[maxn];
vector<pair<int, int>>a;
void dfs(int v)
{
    used[v] = 1;
    //cout << v << endl;
    for (int i = 0; i < g[v].size(); ++i)
    {
        int to = g[v][i].first, p = g[v][i].second;
        if (!used[to + 1])
        dfs(to + 1);
    }
}
int main()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
    {
        int fr, to, p;
        cin >> fr >> to >> p;
        if (to > k)
            to = k;
        g[fr].push_back({to, p});
        a.push_back({fr, to});
    }
    dfs(1);
    if (used[k + 1])
    {
        cout << 1;
        return 0;
    }
    int cnt = 0;
    int x = 1;
    sort(a.begin(), a.end());
    for (int i = 0; i < n; ++i)
    {
        if (x >= a[i].first && x <= a[i].second)
            x = a[i].second + 1;
    }
    if (x == k + 1)
        cout << 2;
    else
        cout << -1;


    return 0;
}
