#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <map>

using namespace std;

const int inf = 2e9;
const int maxn = 128000;
int n, k;
map<int, bool> used;
vector<int>  g[maxn];
vector<pair<int, int>>a;
void dfs(int v)
{
    used[v] = 1;
    for (int i = 0; i < g[v].size(); ++i)
    {
        int to = g[v][i];
        if (!used[to + 1])
            dfs(to + 1);
    }
}
int main()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
    {
        int fr, to, p;
        cin >> fr >> to >> p;
        g[fr].push_back(to);
        a.push_back({fr, to});
    }
    dfs(1);
    if (used[k + 1])
    {
        cout << 1;
        return 0;
    }
    int x = 1;
    sort(a.begin(), a.end());
    for (int i = 0; i < n; ++i)
    {
        if (x >= a[i].first && x <= a[i].second)
            x = a[i].second + 1;
    }
    if (x == k + 1)
    {
        cout << 2;
    }
    else
        cout << -1;

    return 0;
}
