import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Locale;

public class ZE2 implements Runnable {

	
	int[] wnow;
	int[] l;
	int k;
	
	public void solve() throws IOException {
		int n = nextInt();
		l = new int[n];
		k = 1;
		
		int max = 0;
		for (int i = 0; i < n; i++) {
			l[i] = nextInt();
			max = Math.max(max, l[i]);
		}
		
		wnow = new int[max];
		
		for (int i = 0; i < l[0]; i++) {
			wnow[i] = 1;
		}
		
		for (int i = 1; i < n; i++) {
			if (l[i]<= l[i-1]) {
				for (int j = l[i] + 1; j <= l[i-1]; j++) {
					wnow[j-1] = 0;
				}
				
				if (!addLetter(l[i])) {
					k++;
					wnow[l[i]-1] = k;
				}
			} else {
				for (int j = l[i-1] + 1; j <= l[i]; j++) {
					wnow[j-1] = 1;
				}
			}
		}
		
		out.write(k+ "");
	}
	
	boolean addLetter(int to) {
		if (to <= 0)
			return false;
		int letterNow = wnow[to-1];
		if (letterNow <k) {
			wnow[to-1]++;
			return true;
		}
		if (addLetter(to-1)) {
			wnow[to-1] = 1;
			return true;
		} else 
			return false;
	}
	
	
	BufferedReader in;
	BufferedWriter out;
	@Override
	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new BufferedWriter(new OutputStreamWriter(System.out));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(read());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(read());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(read());
	}
	
	String read() throws IOException {
		StringBuilder sb = new StringBuilder();
		int c = 0;
		while (c >= 0 && c <= ' ')
			c = in.read();
		if (c < 0) 
			return "";
		while (c > ' ') {
			sb.append((char) c);
			c = in.read();
		}
		return sb.toString();
	}

	public static void main(String[] args) {
		try {
			Locale.setDefault(Locale.US);
		} catch (Exception e) {
		}
		new Thread(null, new ZE2(), "1", 1 << 25).start();
	}
}
