import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Locale;

public class ZF1 implements Runnable {

//	static final int PLUS = 1;
//	static final int MINUS = -1;
//	static final int ZERO = 0;
	
	
	public void solve() throws IOException {
		int n = nextInt();
		String s = read();
		int x = nextInt();
		int y = nextInt();
		
		int l = 0, u = 0, r = 0, d = 0;
		for (int i = 0; i < s.length(); i++) {
			switch (s.charAt(i)) {
			case 'L':
				l++;
				break;
			case 'R':
				r++;
				break;
			case 'U':
				u++;
				break;
			case 'D':
				d++;
				break;
			default:
				break;
			}
		}
		int al, ar, au, ad;
		
		if (x <= 0) {
			ar = 0;
			if (l < -x)  {
				out.write("-1");
				return;
			}
			int c = 0;
			int i;
			for (i = 0; c < x; i++) {
				if (s.charAt(i) == 'L')
					c++;
			}
			al = i;
			
		} else {
			
			al = 0;
			if (r < x)  {
				out.write("-1");
				return;
			}
			int c = 0;
			int i;
			for (i = 0; c < x; i++) {
				if (s.charAt(i) == 'R')
					c++;
			}
			ar = i;
		}
		
		
		if (y <= 0) {
			au = 0;
			if (d < -y)  {
				out.write("-1");
				return;
			}
			int c = 0;
			int i;
			for (i = 0; c < x; i++) {
				if (s.charAt(i) == 'D')
					c++;
			}
			ad = i;
			
		} else {
			
			ad = 0;
			if (u < x)  {
				out.write("-1");
				return;
			}
			int c = 0;
			int i;
			for (i = 0; c < x; i++) {
				if (s.charAt(i) == 'U')
					c++;
			}
			au = i;
		}
		
		out.write(al + " " + au + " " + ar + " " + ad);
	}
	
	
	BufferedReader in;
	BufferedWriter out;
	@Override
	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new BufferedWriter(new OutputStreamWriter(System.out));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(read());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(read());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(read());
	}
	
	String read() throws IOException {
		StringBuilder sb = new StringBuilder();
		int c = 0;
		while (c >= 0 && c <= ' ')
			c = in.read();
		if (c < 0) 
			return "";
		while (c > ' ') {
			sb.append((char) c);
			c = in.read();
		}
		return sb.toString();
	}

	public static void main(String[] args) {
		try {
			Locale.setDefault(Locale.US);
		} catch (Exception e) {
		}
		new Thread(null, new ZF1(), "1", 1 << 25).start();
	}
}
