#include <bits/stdc++.h>

using namespace std;

#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#define F first
#define S second

typedef long long ll;
typedef long double ld;

auto start_t = clock();

template<typename T>
void die(T ans)
{
    cout << ans << endl;
    cerr << "Done in " << (start_t - clock()) / ld(CLOCKS_PER_SEC) << "sec" << endl;
    exit(0);
}

int code(char c)
{
    switch (c)
    {
    case 'U':
        return 0;
    case 'R':
        return 1;
    case 'D':
        return 2;
    case 'L':
        return 3;
    default:
        return 4;
    }
}

int n;
string s;
int x, y;

vector<int > prefu;
vector<int > prefd;
vector<int > prefl;
vector<int > prefr;
vector<int > sufu;
vector<int > sufd;
vector<int > sufl;
vector<int > sufr;

vector<int> ans;

int main()
{
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(13);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    cin >> n;
    cin >> s;
    cin >> x >> y;

    prefu.resize(n);
    prefd.resize(n);
    prefl.resize(n);
    prefr.resize(n);
    sufd.resize(n);
    sufu.resize(n);
    sufl.resize(n);
    sufr.resize(n);

    ans.resize(4, n);

    prefu[0] = s[0] == 'U';
    prefr[0] = s[0] == 'R';
    prefd[0] = s[0] == 'D';
    prefl[0] = s[0] == 'L';

//    sufu[n-1] = s.back() == 'U';
//    sufr[n-1] = s.back() == 'R';
//    sufd[n-1] = s.back() == 'D';
//    sufl[n-1] = s.back() == 'L';

    for (int i = 1; i < n; i++)
    {
        prefu[i] = prefu[i-1] + (s[i] == 'U');
        prefr[i] = prefr[i-1] + (s[i] == 'R');
        prefd[i] = prefd[i-1] + (s[i] == 'D');
        prefl[i] = prefl[i-1] + (s[i] == 'L');
    }

//    for (int i = n-2; i >= 0; i--)
//    {
//        sufu[i] = sufu[i+1] + (s[i] == 'U');
//        sufr[i] = sufr[i+1] + (s[i] == 'R');
//        sufd[i] = sufd[i+1] + (s[i] == 'D');
//        sufl[i] = sufl[i+1] + (s[i] == 'L');
//    }
//
//    sort(all(sufu));
//    sort(all(sufr));
//    sort(all(sufd));
//    sort(all(sufl));

    {
        bool found = false;
        for (int i = -1; i < n && !found; i++)
        {
            int val = (i == -1 ? 0 : prefu[i]);

            if (val == x)
            {
                found = true;
                ans[0] = i+1;
                ans[2] = 0;
                break;
            }

            auto it = lower_bound(all(prefd), val-x);

            if (it != prefd.end() && *it == val-x)
            {
                found = true;
                ans[0] = i+1;
                ans[2] = it - prefd.begin() + 1;
                break;
            }
        }

        if (!found)
            die("-1");
    }

    {
        bool found = false;
        for (int i = -1; i < n && !found; i++)
        {
            int val = (i == -1 ? 0 : prefr[i]);

            if (val == y)
            {
                found = true;
                ans[1] = i+1;
                ans[3] = 0;
                break;
            }

            auto it = lower_bound(all(prefl), val-y);

            if (it != prefl.end() && *it == val-y)
            {
                found = true;
                ans[1] = i+1;
                ans[3] = it - prefl.begin() + 1;
                break;
            }
        }

        if (!found)
            die("-1");
    }

    for (int i = 3; i < 7; i++)
        cout << ans[i % 4] << " ";

    return 0;
}
