#include <bits/stdc++.h>

using namespace std;

#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#define F first
#define S second

typedef long long ll;
typedef long double ld;

const ll INFll = (1ll << 50);

auto start_t = clock();

template<typename T>
void die(T ans)
{
    cout << ans << endl;
    cerr << "Done in " << (start_t - clock()) / ld(CLOCKS_PER_SEC) << "sec" << endl;
    exit(0);
}

//struct Treap
//{
//    Treap* l = nullptr;
//    Treap* r = nullptr;
//
//    int x;
//    int p = rand();
//    ll val;
//    ll mnval = INFll;
//};
//
//ll valOf(Treap* t)
//{
//    if (t == nullptr) return INFll;
//
//    return t->val;
//}
//
//void cnt(Treap* t)
//{
//    if (t == nullptr) return;
//
//    t->mnval = min({t->val, valOf(t->l), valOf(t->r)});
//}
//
//Treap* merge(Treap* l, Treap* r)
//{
//    if (l == nullptr) return r;
//    if (r == nullptr) return l;
//
//    if (l->p > r->p)
//    {
//        l->r = merge(l->r, r);
//        cnt(l);
//        return l;
//    } else
//    {
//        r->l = merge(l, r->l);
//        cnt(r);
//        return r;
//    }
//}
//
//pair<Treap*, Treap* > split(Treap* v, ll key)
//{
//    if (v == nullptr) return make_pair(v, v);
//
//    if (v->x <= key)
//    {
//        auto spl = split(v->r, key);
//        v->r = spl.F;
//        spl.F = v;
//
//        cnt(spl.F);
//        cnt(spl.S);
//
//        return spl;
//    } else
//    {
//        auto spl = split(v->l, key);
//        v->l = spl.S;
//        spl.S = v;
//
//        cnt(spl.F);
//        cnt(spl.S);
//
//        return spl;
//    }
//}
//
//Treap data[1024*1024];
//int ptr = 0;
//
//Treap* newTreap(ll x, ll r)
//{
//    Treap* res = data + ptr++;
//
//    res->x = r;
//    res->val = x;
//    res->mnval = x;
//
//    return res;
//}
//
//Treap* root = nullptr;
//
//void add(ll x, ll r)
//{
//    auto spl = split(root, r);
//    root = merge(merge(spl.F, newTreap(x, r)), spl.S);
//}
//


int n, k;
vector<pair<pair<int, int>, int > > a;
vector<int > cmp;

class segtree
{
public:
    vector<ll > t;
    int n;

    ll query(int l, int r)
    {
        ll res = INFll;

        for (l += n, r += n; l < r; l >>= 1, r >>= 1)
        {
            if (l & 1)
                res = min(res, t[l++]);
            if (r & 1)
                res = min(res, t[--r]);
        }

        return res;
    }

    void modify(int p, ll val)
    {
        for (t[p += n] = val; p > 1; p >>= 1)
            t[p >> 1] = min(t[p], t[p ^ 1]);
    }

    segtree(int sz) : t(sz << 1, INFll), n(sz) {};
};

int getCmp(int x)
{
    return lower_bound(all(cmp), x) - cmp.begin();
}

bool comp(pair<pair<int, int>, int >& a, pair<pair<int, int>, int >& b)
{
    if (a.F.S != b.F.S)
        return a.F.S < b.F.S;
    return a.F.F < b.F.F;
}

int main()
{
    ios_base::sync_with_stdio(0);
//    cout << fixed << setprecision(13);

   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

    cin >> n >> k;
    a.resize(n);
    for (auto& x: a)
        cin >> x.F.F >> x.F.S >> x.S;

    cmp.push_back(1);
    cmp.push_back(0);
    cmp.push_back(k);
    for (auto& q: a)
    {
        cmp.push_back(q.F.F);
        cmp.push_back(q.F.F - 1);
        cmp.push_back(q.F.S);
    }

    sort(all(cmp));

    cmp.erase(unique(all(cmp)), cmp.end());

    sort(all(a), comp);

    vector<ll > dp(cmp.size(), INFll);

    dp[0] = 0;

    vector<pair<int, pair<ll, ll > > > keks;

    if(n <= 5000)
    {
        int it = 0;
        for (auto& q: a)
        {
            int l = getCmp(q.F.F);
            int r = getCmp(q.F.S);
            ll p = q.S;

    //        cerr << getCmp(q.F.F - 1) << " " << r << " -> " << tr.query(getCmp(q.F.F - 1), r + 1) << endl;
            dp[r] = min(dp[r], max(dp[getCmp(q.F.F - 1)], p));
            for (int i = 0; i < it; i++)
                if (a[i].F.S >= q.F.F)
                    dp[r] = min(dp[r], max(dp[getCmp(a[i].F.F - 1)], a[i].S + p));

            if (dp[r] != INFll)
                keks.push_back(make_pair(q.F.S, make_pair(dp[r], p)));

            it++;
        }

        if (dp[getCmp(k)] == INFll)
            die(-1);

        die(dp[getCmp(k)]);
    }

    int it = 0;
    ll maxl = -1000;

    for (auto& q: a)
    {
        int l = getCmp(q.F.F);
        int r = getCmp(q.F.S);
        ll p = q.S;

//        cerr << getCmp(q.F.F - 1) << " " << r << " -> " << tr.query(getCmp(q.F.F - 1), r + 1) << endl;
        dp[r] = min(dp[r], max(dp[getCmp(q.F.F - 1)], p));

        if (maxl >= q.F.F)
        {
            // cerr << max\l << " " << q.F.S << endl;
            dp[r] = min(dp[r], 2ll);
        }

//        for (int i = 0; i < it; i++)
//            if (a[i].F.S >= q.F.F)
//                dp[r] = min(dp[r], max(dp[getCmp(a[i].F.F - 1)], a[i].S + p));

//        if (dp[r] != INFll)
//            keks.push_back(make_pair(q.F.S, make_pair(dp[r], p)));

        if (dp[r] != INFll)
            maxl = max(maxl, q.F.F * 1ll);

        it++;
    }

    if (dp[getCmp(k)] == INFll)
        die(-1);

    die(dp[getCmp(k)]);

    return 0;
}
