		#include <iostream>
		#include <algorithm>
		#include <vector>
		#include <map>
		#include <set>
		#include <string>
		#include <cmath>
		#include <ctime>
		#include <queue>
		#define X first
		#define Y second
		typedef long long ll;
		typedef long double ld;
		typedef unsigned long long ull;
		const ll INF = 1e9 + 4;
		const ll MAX = 60;
		using namespace std;
		struct ST {
			vector<ll> v;
			ll n;
			void init(ll n) {
				v.resize(4 * n);
				this->n = n;
				return;
			}
			void set(ll pos, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
				if (tr == -1)
					tr = n;
				if (tr <= pos || tl > pos)
					return;
				if (tr == tl - 1 && tl == pos)
					return void(v[ver] = val);
				ll tm = (tl + tr) / 2;
				if (tm < pos)
					set(pos, val, ver * 2 + 1, tl, tm);
				else set(pos, val, ver * 2 + 2, tm, tr);
				v[ver] = v[ver * 2 + 1] + v[ver * 2 + 2];
			}
			ll get(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
				if (tr == -1)
					tr = n;
				if (tr <= l || tl >= r)
					return INF;
				if (tl == tr - 1)
					return (v[ver] == 1 ? l : INF);
				ll tm = (tr + tl) / 2;
				ll ret = get(l, min(tm, r), ver * 2 + 1, tl, tm);
				if (ret != INF)
					return ret;
				return get(max(tm, l), tr, ver * 2 + 2, tm, tr);
			}
			ll getsum(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
				if (tr == -1)
					tr = n;
				if (tl >= r || tr <= l)
						 0;
				if (tl == l && tr == r)
					return v[ver];
				ll tm = (tl + tr) / 2;
				return getsum(l, min(tm, r), ver * 2 + 1, tl, tm) +
					getsum(max(tm, l), r, ver * 2 + 2, tm, tr);
			}
		} tr;
		const ll MAXN = 1000000 + 3;
		ull last = 1;
		bool check(ull x) {
			cout << "X " << x << endl;
			ull a, b;
			cin >> a >> b;
			if (a)
				last = max(last,b);
			return a != 0;
		}

		int main() {
		#ifdef _DEBUG
			//freopen("input.txt", "r", stdin);
			//freopen("output.txt", "w", stdout);
		#endif
			ios_base::sync_with_stdio(false);
			cin.tie(0);
			cout.tie(0);
			vector<ull> v(MAX,1);
			for (ll i = 1; i < MAX; i++) {
				v[i] = v[i - 1] * 2;
			}
			ll g;
			cin >> g;
			while (g--) {
				ll l = 0, r = MAX-1;
				while (r - l > 1) {
					ll m = (r + l) / 2;
					if (check(v[m]))
						l = m;
					else r = m;
				}
				check(v[l]);
				check(v[r]);
				cout <<"N "<<last<<endl;
				string s;	
				cin >> s;
				if (s != "Correct")
					return 0;
				last = 1;
			}
			return 0;
		}