#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 100000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

ll len[MAXN];
ll n;

bool check(ll mx) {
	vector<ll> word(1000000, 1);

	for (ll i = 0; i < n; i++) {
		for (ll j = len[i - 1]; j < len[j]; j++) {
			word[j] = 1;
		}
		if (len[i] > len[i - 1]) { continue; }

		ll pt = len[i] - 1;
		word[pt]++;
		while (pt > 0 && word[pt] > mx) {
			word[pt] = 1;
			word[pt - 1]++;
			pt--;
		}
		if (word[0] > mx) {
			return false;
		}
	}
	return true;
}

int main() {
	
	cin >> n;
	for (ll i = 0; i < n; i++) {
		cin >> len[i];
	}

	ll l = 0, r = n + 1;
	ll m = (l + r) / 2;
	while (r - l > 1) {
		if (check(m)) {
			r = m;
		}
		else {
			l = m;
		}
		m = (l + r) / 2;
	}

	cout << r;

	return 0;
}