#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 200000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

int main() {

	ll n;
	cin >> n;
	string s;
	cin >> s;
	ll x, y;
	cin >> x >> y;

	bool L = true, R = true, U = true, D = true;
	int iL, iR, iU, iD;

	if (x == 0) {
		iL = 0, iR = 0;
		L = false;
		R = false;
	}
	else if (x < 0) {
		iR = 0;
		R = false;
	}else{
		iL = 0;
		L = false;
	}

	if (y == 0) {
		iU = 0, iD = 0;
		U = false;
		D = false;
	}
	else if (y < 0) {
		iU = 0;
		U = false;
	}
	else {
		iD = 0;
		D = false;
	}

	ll mx = 0, my = 0;
	for (ll i = 0; i < n; i++) {
		switch (s[i]) {
		case 'L':
			if (L) {
				mx--;
			}
			break;
		case 'R':
			if (R) {
				mx++;
			}
			break;
		case 'U':
			if (U) {
				my++;
			}
			break;
		case 'D':
			if (D) {
				my--;
			}
			break;
		}

		if (x == mx) {
			if (R) {
				iR = i + 1;
				R = false;
			}
			R = false;
			if (L) {
				iL = i + 1;
				L = false;
			}
		}
		else if (x < mx) {
			if (R) {
				iR = i + 1;
				R = false;
			}
		}
		else {
			if (L) {
				iL = i + 1;
				L = false;
			}
		}

		if (y == my) {
			if (U) {
				iU = i + 1;
				U = false;
			}
			if (D) {
				iD = i + 1;
				D = false;
			}
		}
		else if (y < my) {
			if (U) {
				iU = i + 1;
				U = false;
			}
		}
		else {
			if (D) {
				iD = i + 1;
				D = false;
			}
		}
	}

	if (mx != x || my != y) {
		cout << -1;
	}
	else {
		cout << iL << " " << iU << " " << iR << " " << iD;
	}

	return 0;
}