#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 200000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

ll gcd(ll a, ll b) {
	while (b > 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	ll g;
	cin >> g;

	for (ll q = 0; q < g; q++) {
		ll l = 2;
		ll del = 1;
		bool f = true;
		bool pr = false;
		while (f) {
			cout << "X " << l << "\n"; cout.flush();
			ll a, b;
			cin >> a;
			if (a == -1) {
				assert(false);
				return 0;
			}
			cin >> b;
			if (a == 1 && pr) {
				cout << "N " << l << "\n"; cout.flush();
				break;
			}
			else if (a == 1 && b == l) {
				l++;
			}
			else if (a > 1) {
				pr = false;
				l = b;
			} else if (a == 0) {
				pr = true;
				l--;
			}
			else { 
				del *= l;
				l = del + 1;
				pr = false;
			}
		}

		string s;
		cin >> s;
		if (s == "Wrong") { return 0; }
	}

	return 0;
}