#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <unordered_map>
#include <string>
#define SZ(v) (int)v.size()
#define dout(x) if(debug)cout<<#x<<": "<<x<<endl;
#define X first
#define Y second
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define p4(a,b,c,d) p(p(a,b),p(c,d))
using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = (1LL << 61);
const long long MOD = 1e9 + 7;
const long long MOD2 = 1e9 + 9;
const long long MOD3 = (1LL << 31) - 1;
ll MAX_VAL = 1e18 + 2;
const int inf = 2e9;
const long double PI = acos(-1);
void solve();
int myrand() {
	return (abs(rand() << 16) | (rand() >> 16)) ^ (abs(rand() << 16) | (rand() >> 16));
}
bool debug = 0;
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	debug = 1;
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);
	srand((unsigned)time(NULL));
	solve();
}
const int N = 200005;
const int lg = 26;
const int MAGIC = 420;
int n, k;
int l[N], r[N];
ll p[N];
vector< p3(int, int, int) > ev;
ll res(int mask) {
	ll ret = 0, now = 0;
	int cnt = 0;
	ev.clear();
	for (int i = 0; i < n; i++)if (mask & (1 << i)) {
		ev.push_back({ {l[i],-1},i });
		ev.push_back({ {r[i],1},i });
	}
	sort(ev.begin(), ev.end());
	if (ev[0].X.X != 1 || ev.back().X.X != k)
		return INF;
	for (int i = 0; i < SZ(ev); i++) {
		int ind = ev[i].Y;
		if (ev[i].X.Y == 1) {
			now -= p[ind];
			cnt--;
		}
		else {
			cnt++;
			now += p[ind];
		}
		if (cnt == 0 && i != SZ(ev) - 1 && ev[i].X.X != ev[i+1].X.X - 1)
			return INF;
		ret = max(ret, now);
	}
	return ret;
}

void solve() {
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> p[i];
	}
	ll ans = INF;
	for (int mask = 1; mask < (1 << n); mask++) {
		ans = min(ans, res(mask));
	}
	if (ans == INF)cout << -1 << endl;
	else cout << ans << endl;
}