#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef long double ld;

const int N = 100100;
const ll INF = (ll)(1e18);

pair<pair<int,int>,int> gr[N];
int n, k;


int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> gr[i].F.F >> gr[i].F.S >> gr[i].S;
    }
    ll ans = INF;
    for (int i = 1; i < (1 << n); i++) {
        ll cur = 0;
        int mil = 1000000000;
        int mar = 0;
        for (int j = 0; j < n; j++) {
            if ((i & (1 << j)) != 0) {
                mil = min(mil, gr[j].F.F);
                mar = max(mar, gr[j].F.S);
            }
        }
        if (mil > 1 || mar < k) continue;
        {
            int last = 0;
            multiset<tuple<int,int,int>> st;
            for (int j = 0; j < n; j++) {
                if ((i & (1 << j)) != 0) {
                    st.insert(make_tuple(gr[j].F.F, 0, gr[j].S));
                    st.insert(make_tuple(gr[j].F.S, 1, gr[j].S));
                }
            }
            bool f = true;
            int cnt = 0;
            for (auto it : st) {
                if (cnt == 0 && get<0>(it) - 1 > last){
                    f = false;
                }
                if (get<1>(it) == 0) {
                    cnt++;
                } else {
                    cnt--;
                }
                last = get<0>(it);
            }
            if (!f) continue;
        }
        multiset<tuple<int,int,int>> st;
        for (int j = 0; j < n; j++) {
            if ((i & (1 << j)) != 0) {
                st.insert(make_tuple(gr[j].F.F, 0, gr[j].S));
                st.insert(make_tuple(gr[j].F.S, 1, gr[j].S));
            }
        }
        ll sum = 0;
        for (auto it : st) {
            if (get<1>(it) == 0) {
                sum += get<2>(it);
            } else {
                sum -= get<2>(it);
            }
            cur = max(cur, sum);
        }
        ans = min(ans, cur);
    }
    if (ans == INF) {
        cout << -1;
    } else {
        cout << ans;
    }
    return 0;
}

