#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>
#include <cstring>

using namespace std; 
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const char* name = "LURD";

const int dd = (int)1e6 + 1;
vector<int> E[dd];
int ans[5];

void no() {
	cout << "-1";
	exit(0);
}

int solve() {
	int n;
	cin >> n;

	string s;
	cin >> s;

	for (int i = 0; i < n; i++) {
		int tp = strchr(name, s[i]) - name;
		E[tp].push_back(i);
	}

	int x, y;
	cin >> x >> y;

	ans[0] = ans[1] = ans[2] = ans[3] = n - 1;

	if (x < 0) {
		int pos = (int)E[0].size() - abs(x);
		if (pos < 0) no();
		ans[0] = E[0][pos];
	}

	if (y > 0) {
		int pos = (int)E[1].size() - abs(y);
		if (pos < 0) no();
		ans[1] = E[1][pos];
	}

	if (x > 0) {
		int pos = (int)E[2].size() - abs(x);
		if (pos < 0) no();
		ans[2] = E[2][pos];
	}

	if (y < 0) {
		int pos = (int)E[3].size() - abs(y);
		if (pos < 0) no();
		ans[3] = E[3][pos];
	}

	for (int i = 0; i < 4; i++)
		cout << ans[i] + 1 << " ";

	return 0;
}