#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>
#include <cstring>

using namespace std;
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)2e5 + 1;

ll dp[dd];
struct ev {
	ll l, r, p;
	ev() {}
	ev(ll l, ll r) : l(l), r(r) {}
	bool operator < (ev b) const {
		return r == b.r ? l == b.l ? p < b.p : l < b.l : r < b.r;
	}
} A[dd];

pair<ll, ll> Q[dd];

int solve() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, k;
	cin >> n >> k;

	for (int i = 0; i < n; i++) {
		cin >> A[i].l >> A[i].r >> A[i].p;
	}

	sort(A, A + n);
	
	fill(dp, dp + n + 1, (ll)1e18);
	dp[0] = 0;

	for (int i = 1; i <= n; i++) {
		Q[i] = { A[i - 1].r, A[i - 1].l };

		int j = upper_bound(Q + 1, Q + i, make_pair(A[i - 1].l - 1, -1ll)) - Q;

		if (A[j - 1].r + 1 == A[i - 1].l) {
			dp[i] = min(dp[i], max(dp[j], A[i - 1].p));
		}

		if (A[j - 1].r + 1 > A[i - 1].l) {
			dp[i] = min(dp[i], max(dp[j], A[i - 1].p + A[j - 1].p));
		}

		if (A[i - 1].l == 1) {
			dp[i] = min(dp[i], A[i - 1].p);
		}
	}

	ll ans = (ll)1e18;
	for (int i = 1; i <= n; i++) {
		if (A[i - 1].r == k) {
			ans = min(ans, dp[i]);
		}
	}

	if (ans == (ll)1e18) {
		cout << -1;
	} else {
		cout << ans;
	}
	return 0;
}