#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>
#include <random>

using namespace std; 
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}


ll gcd(ll a, ll b) {
	while (b) a %= b, swap(a, b);
	return a;
}

pair<ll, ll> ask(ll x) {
	cout << "X " << x << endl;
	ll a, b;
	cin >> a >> b;
	return { a, b };
}

void out(ll x) {
	cout << "N " << x << endl;
}

vector<int> T;

mt19937 rnd(1);

ll R() {
	return ((ll)rnd() << 31) + (ll)rnd();
}

int solve() {

	for (int i = 2; i < 60; i++) {
		int ok = 1;
		for (int j = 2; j * j <= i; j++) ok &= (i % j) > 0;
		if (ok) T.push_back(i);
	}

	int g;
	cin >> g;

	while (g--) {

		ll cur = 1;
		
		ll p = 1;

		for (int i = 0; i < 30; i++) {

			auto c = ask(p * 4);
			
			if (c.first != 0) {
				p *= 4;
				ll t = c.second, q = gcd(t, cur);
				cur = cur / q * t;
			} else {
				auto c = ask(p * 2);
				ll t = c.second, q = gcd(t, cur);
				cur = cur / q * t;
				break;
			}
		}

		out(cur);
		string s;
		cin >> s;
		if (s != "Correct") {
			assert(0);
		}
	}
	return 0;
}