#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>
#include <random>

using namespace std; 
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}


ll gcd(ll a, ll b) {
	while (b) a %= b, swap(a, b);
	return a;
}

ll TT;

void init(ll x) {
	TT = x;
}

map<ll, pair<ll, ll> > MM;

pair<ll, ll> ask(ll x) {
	if (MM.count(x)) return MM[x];
	/*ll a = TT / x, b = TT;
	ll q = gcd(a, b);
	a /= q, b /= q;
	return { a, b };*/

	cout << "X " << x << endl;
	ll a, b;
	cin >> a;

	if (a == -1) {
		assert(0);
	}

	cin >> b;
	return MM[x] = { a, b };
}

void out(ll x) {
	//assert(x == TT);
	cout << "N " << x << endl;
}

vector<int> T;


ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

bool check(ll a, ll b, ll c) {
	return (a <= c / b);
}

int solve() {

	ll g;
	cin >> g;

	ll x = (1 << 4);

	while (g--) {

		MM.clear();
		init(g + 1);

		ll cur = 1;
		
		ll p = x;

		ll max = (ll)1e18 + 1;

		for (int i = 0; i < 10; i++) {

			auto c = ask(p);
			
			if (c.first == 0) {
				max = p;
				p /= 2;
			} else {

				cur = lcm(cur, c.second); 
				
				ll tt = x;

				while (tt > 1 && !check(tt, p, max)) {
					tt /= 2;
				}

				if (tt == 1) break;
				p *= tt;
			}
		}

		out(cur);
		string s;
		cin >> s;
		
		if (s != "Correct") {
			assert(0);
		}
	}
	return 0;
}