#include <iostream>
#include <stdio.h>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <stack>
#include <stdlib.h>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define in(s) freopen(s, "r", stdin);
#define out(s) freopen(s, "w", stdout);
#define forn(i, n) for(int i = 0; i < n; i++)
#define endl '\n'

ll now = 1ll;

vector <ll> next(const vector <ll> &a, ll k)
{
	vector <ll> s;
	ll q = min((ll)a.size(), k);
	forn(i, q)
		s.push_back(a[i]);
	if (k > a.size())
	{
		while (s.size() != k)
			s.push_back(1ll);
		return s;
	}
	s.back()++;
	vector <ll> past = s;
	for (int i = s.size() - 1; i >= 1; i--)
	{
		if (s[i] > now)
		{
			s[i] = 1ll;
			s[i - 1]++;
		}
	}
	if (s[0] > now)
	{
		now++;
		s = past;
	}
	return s;
}

int main()
{
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll n;
	cin >> n;

	vector <ll> arr(n);
	forn(i, n)
	{
		cin >> arr[i];
	}
	
	vector < vector<ll> > have(n);
	forn(i, arr[0])
	{
		have[0].push_back(1);
	}
	
	for (int i = 1; i < n; i++)
	{
		have[i] = next(have[i - 1], arr[i]);
	}
	cout << now;
	return 0;
}