#include <iostream>
#include <stdio.h>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <stack>
#include <stdlib.h>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define in(s) freopen(s, "r", stdin);
#define out(s) freopen(s, "w", stdout);
#define forn(i, n) for(int i = 0; i < n; i++)
#define endl '\n'

int now = 1;
bool flag = true;
vector <int> next(const vector <int> &a, int k)
{
	vector <int> s;
	int q = min((int)a.size(), k);
	forn(i, q)
		s.push_back(a[i]);
	if (k > a.size())
	{
		while (s.size() != k)
			s.push_back(1);
		return s;
	}
	s.back()++;
	vector <int> past = s;
	for (int i = s.size() - 1; i >= 1; i--)
	{
		if (s[i] > now)
		{
			s[i] = 1;
			s[i - 1]++;
		}
	}
	if (s[0] > now)
	{
		flag = false;
	}
	return s;
}


int main()
{
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n;
	cin >> n;

	vector <int> arr(n);
	forn(i, n)
	{
		cin >> arr[i];
	}

	int l = 1, r = n;
	while (l != r)
	{
		int mid = (l + r) / 2;
		now = mid;
		flag = true;
		vector < vector<int> > have(n);
		forn(i, arr[0])
		{
			have[0].push_back(1);
		}
		for (int i = 1; i < n; i++)
		{
			have[i] = next(have[i - 1], arr[i]);
			if (!flag)
				break;
		}
		if (flag)
			r = mid;
		else
			l = mid + 1;
	}
	cout << l;
	return 0;
}