#include <bits/stdc++.h>

using namespace std;

vector<vector<char>> str;
vector<int> sz;

bool check(int k) {
    for (int i = 1; i < sz.size(); i++) {
        if (sz[i] > sz[i - 1]) {
            for (int j = 0; j < sz[i - 1]; j++) {
                str[i][j] = str[i - 1][j];
            }
            for (int j = sz[i - 1]; j < sz[i]; j++) {
                str[i][j] = 'a';
            }
        } else {
            bool ok = false;
            for (int j = sz[i] - 1; j >= 0; j--) {
                if (str[i - 1][j] < 'a' + k - 1) {
                    ok = true;
                    str[i][j] = str[i - 1][j] + 1;
                    for (int m = j + 1; m < sz[i]; m++) {
                        str[i][m] = 'a';
                    }
                    for (int m = 0; m < j; m++) {
                        str[i][m] = str[i - 1][m];
                    }
                }
            }
            if (!ok) {
                return false;
            }
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    sz.assign(n, 0);
    str.assign(n, vector<char>());
    for (int i = 0; i < n; i++) {
        cin >> sz[i];
        str[i].assign(sz[i], 'a');
    }
    int l = 1;
    int r = n + 2;
    while (l < r) {
        int m = (l + r) / 2;
        if (check(m)) {
            r = m;
        } else {
            l = m + 1;
        }
    }
    cout << l;
}
