#include <iostream>
#include <vector>

using namespace std;

const long long INF = 1000000000000000000;

int main()
{
	int n;
	cin >> n;
	vector<long long> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	long long l = 0;
	long long r = INF;
	while (r - l > 1) {
		long long mid = (l + r) / 2;
		vector<int> now;
		now.resize(a[0], 1);
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (a[i] > (int)now.size()) {
				now.resize(a[i], 1);
			}
			else {
				now.resize(a[i]);
				bool f = false;
				for (int j = a[i] - 1; j >= 0; j--) {
					if (now[j] == mid) {
						now[j] = 1;
					}
					else {
						now[j]++;
						f = true;
						break;
					}
				}
				if (!f) {
					ok = false;
					break;
				}
			}
		}
		if (!ok) {
			l = mid;
		}
		else {
			r = mid;
		}
	}
	cout << r << endl;
    return 0;
}

