#include <iostream>
#include <vector>
#include <map>

using namespace std;

const long long INF = 1000000;

int main()
{
	int n;
	scanf("%d", &n);
	vector<long long> a(n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
	}
	long long l = 1;
	long long r = INF;
	while (r - l > 1) {
		long long mid = (l + r) / 2;
		vector<pair<long long, long long> > d;
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (a[i] <= a[i - 1]) {
				long long h = a[i];
				while (!d.empty()) {
					auto elem = d.back();
					if (elem.first > h) {
						d.pop_back();
					}
					else {
						break;
					}
				}
				if (!d.empty() && d.back() == make_pair(h, mid - 1)) {
					d.pop_back();
					long long last_h = h;
					while (!d.empty()) {
						auto elem = d.back();
						if (elem.second >= mid - 1 && elem.first == last_h - 1) {
							last_h = elem.first;
							d.pop_back();
						}
						else {
							break;
						}
					}
					if (last_h == 1) {
						ok = false;
						break;
					}
					else {
						if (d.empty() || d.back().first != last_h - 1) {
							d.push_back(make_pair(last_h - 1, 1));
						}
						else {
							d.back().second++;
						}
					}
				}
				else {
					if (d.empty() || d.back().first != h) {
						d.push_back(make_pair(h, 1));
					}
					else {
						d.back().second++;
					}
				}
			}
		}
		if (!ok) {
			l = mid;
		}
		else {
			r = mid;
		}
	}
	bool f = false;
	for (int i = 1; i < n; i++) {
		if (a[i] <= a[i - 1]) {
			f = true;
			break;
		}
	}
	if (!f) {
		cout << 1 << endl;
		return 0;
	}
	cout << r << endl;
    return 0;
}

