#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

const long long INF = 1000000000000000000;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<array<long long, 3> > a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i][0] >> a[i][1] >> a[i][2];
	}
	sort(a.begin(), a.end());
	vector<long long> dp(n, INF);
	dp[0] = a[0][2];
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < i; j++) {
			if (a[j][1] >= a[i][0]) {
				dp[i] = min(dp[i], max(dp[j], a[j][2] + a[i][2]));
			}
			else if (a[j][1] == a[i][0] - 1) {
				dp[i] = min(dp[i], max(dp[j], a[i][2]));
			}
		}
	}
	long long ans = INF;
	for (int i = 0; i < n; i++) {
		if (a[i][1] == m) {
			ans = min(ans, dp[i]);
		}
	}
	if (ans >= INF) {
		cout << -1 << endl;
	}
	else {
		cout << ans << endl;
	}
    return 0;
}

