#include <bits/stdc++.h>

using namespace std;


ifstream fin("input.txt");
ofstream fout("output.txt");
ofstream deb("debug.txt");

template<typename T>
void printc(vector<T> &a) {
    for (auto x : a)
        cout << x << " ";
    cout << endl;
}

template<typename T>
void printd(vector<T> &a) {
    for (auto x : a)
        deb << x << " ";
    deb << endl;
}


signed main()
{
    long long n, x, y;
    string s;
    fin >> n;
    fin >> s;
    fin >> x >> y;

    long long l = -1;
    long long r = -1;
    long long d = -1;
    long long u = -1;

    if (x == 0)
        l = r = 0;
    else if (x < 0) {
        r = 0;
        int cnt = 0;
        int i = 0;
        while (i < n && cnt < -x) {
            cnt += (s[i++] == 'L');
        }
        if (cnt == -x)
            l = i;
        else {
            fout << -1;
            return 0;
        }
    }
    else if (x > 0) {
        l = 0;
        int cnt = 0;
        int i = 0;
        while (i < n && cnt < x) {
            cnt += (s[i++] == 'R');
        }
        if (cnt == x)
            r = i;
        else {
            fout << -1;
            return 0;
        }
    }

    if (y == 0)
        u = d = 0;
    else if (y < 0) {
        u = 0;
        int cnt = 0;
        int i = 0;
        while (i < n && cnt < -y) {
            cnt += (s[i++] == 'D');
        }
        if (cnt == -y)
            d = i;
        else {
            fout << -1;
            return 0;
        }
    }
    else if (y > 0) {
        d = 0;
        int cnt = 0;
        int i = 0;
        while (i < n && cnt < y) {
            cnt += (s[i++] == 'U');
        }
        if (cnt == y)
            u = i;
        else {
            fout << -1;
            return 0;
        }
    }

    fout << l << " " << u << " " << r << " " << d << endl;

    return 0;
}
