#include <bits/stdc++.h>

using namespace std;

#define int int64_t

ifstream fin("input.txt");
ofstream fout("output.txt");
ofstream deb("debug.txt");

template<typename T>
void printc(vector<T> &a) {
    for (auto x : a)
        cout << x << " ";
    cout << endl;
}

template<typename T>
void printd(vector<T> &a) {
    for (auto x : a)
        deb << x << " ";
    deb << endl;
}

pair<int, int> query(int a) {
    cout << "X " << a << endl;
    int t, p;
    cin >> t >> p;
    return {t, p};
}

int max_val = 1000000000000000000;

signed main()
{
    int g;
    cin >> g;
    for (int ii = 0; ii < g; ii++) {
        int L = 0, R = max_val + 1;
        while (R - L > 1) {
            int m = (L + R) / 2;
            auto d = query(m);
            pair<int, int> tmp = {d.second - d.first * m, d.second * m};
            int k = __gcd(tmp.first, tmp.second);
            tmp.first /= k;
            tmp.second /= k;
            if (tmp.second == m)
                R = m;
            else
                L = m;
        }
        cout << "N " << L << endl;
    }
    return 0;
}
