#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair < x, y >
#define first X
#define second Y

#include <iostream>
#include <vector>
#include <stdio.h>
#include <set>
#include <map>
#include <iterator>
#include <climits>
#include <algorithm>
#include <cmath>
#include <random>
#include <queue>
#include <time.h>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1e9 + 7;
const i64 LINF = 1e18 + 7;

int error() {
	printf("-1\n");
	return 0;
}

int main() {

#ifdef _DEBUG
	freopen("C.txt", "r", stdin);
#endif

	int n, k;
	scanf("%d%d", &n, &k);

	vector < i64 > p(n), dyn(n, LINF + 7);
	int l, r;
	vector < _p(int, _p(int, int)) > events;
	map < int, i64 > pos2prev;
	map < int, i64 >::iterator it;

	for (int i = 0; i < n; i++) {
		scanf("%d%d%lld", &l, &r, &p[i]);
		events.pb(mp(l, mp(0, i)));
		events.pb(mp(r, mp(1, i)));
		pos2prev.insert(mp(r + 1, LINF)).X;
	}

	sort(events.begin(), events.end());
	set < _p(i64, int) > s;

	i64 ans = LINF;
	bool res = true;

	if (events[0].X != 1) {
		return error();
	}



	set < int > s2op;

	int ci;
	for (ci = 0; ci < events.size() && events[ci].X == 1 && events[ci].Y.X == 0; ci++) {
		s.insert(mp(p[events[ci].Y.Y], events[ci].Y.Y));
		dyn[events[ci].Y.Y] = p[events[ci].Y.Y];
	}
	for (int i = ci; i < events.size() && res; i++) {
		
		if (events[i].Y.X == 1) {

			if (s.size()) {
				if (s.begin()->X == p[events[i].Y.Y] && s.begin()->Y == events[i].Y.Y) {
					while (s2op.size()) {
						s.insert(mp(p[*s2op.begin()], *s2op.begin()));
						s2op.erase(s2op.begin());
					}
				}
			}
			else {
				s2op.erase(events[i].Y.Y);
			}

			s.erase(mp(dyn[events[i].Y.Y], events[i].Y.Y));

			it = pos2prev.find(events[i].X + 1);
			if (it != pos2prev.end()) {
				it->Y = min(it->Y, dyn[events[i].Y.Y]);
			}

			if (events[i].X == k) {
				ans = min(ans, dyn[events[i].Y.Y]);
			}

			if (s.size() == 0) {
				if (events[i].X < k && it == pos2prev.end()) {
					res = false;
				}
			}
		}
		else {
			it = pos2prev.find(events[i].X);
			if (it != pos2prev.end()) {
				dyn[events[i].Y.Y] = max(it->Y, p[events[i].Y.Y]);
			}
			if (s.size() && dyn[events[i].Y.Y] > max(s.begin()->X + p[events[i].Y.Y], dyn[s.begin()->Y])) {	
				s2op.insert(events[i].Y.Y);
				dyn[events[i].Y.Y] = max(s.begin()->X + p[events[i].Y.Y], dyn[s.begin()->Y]);
			}
			else {
				s.insert(mp(p[events[i].Y.Y], events[i].Y.Y));
			}
		}

	}

	if (ans == LINF) {
		printf("-1\n");
	}
	else {
		printf("%lld\n", ans);
	}

	return 0;
}