#pragma GCC "-O3"
#include <bits/stdc++.h>


using namespace std;


#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 100228;
const int INF = 1000000000;


int n;
vector<int> ans[2];
int l[MAXN];
int d[13 * MAXN];
int mod[13 * MAXN];
int ss = 1;


inline void push(int v) {
	if (mod[v]) {
		d[v] = mod[v];
		if (v < ss) {
			int vn = v << 1;
			mod[vn] = mod[v];
			mod[vn + 1] = mod[v]; 
		}
		mod[v] = 0;
	}
}


int spusk(int v, int vl, int vr, int x) {
	if (vl == vr) {
		return vl;
	}
	int vn = v << 1;
	int vm = (vl + vr) >> 1;
	push(vn);
	push(vn + 1);
	if (d[vn + 1] < x) {
		return spusk(vn + 1, vm + 1, vr, x);
	}
	return spusk(vn, vl, vm, x);
}


void add(int v, int vl, int vr, int l, int r, int x) {
	if (vl > r || vr < l) {
		push(v);
		return;
	}
	if (l <= vl && vr <= r) {
		mod[v] = x;
		push(v);
		return;
	}
	push(v);
	int vn = v << 1;
	int vm = (vl + vr) >> 1;
	add(vn, vl, vm, l, r, x);
	add(vn + 1, vm + 1, vr, l, r, x);
	d[v] = min(d[vn], d[vn + 1]);
}


inline bool get(int cnt) {
	for (int i = 1; i < 2 * ss; i++) {
		d[i] = INF;
	}
	memset(mod, 0, sizeof(mod)); 
	for (int i = 0; i < n; i++) {
		if (i == 0) {
			add(1, 1, ss, 1, l[i], 1);
		} else {
			if (l[i] > l[i - 1]) {
				add(1, 1, ss, l[i - 1] + 1, l[i], 1);
			} else {
				if (d[1] >= cnt) {
					return 0;
				}
				if (i != n - 1) {
					push(1);
					int pos = spusk(1, 1, ss, cnt);
					//cout << cnt << ' ' << pos << ' ' << d[3] << endl;
					add(1, 1, ss, pos, pos, d[ss + pos - 1] + 1);
					if (pos < l[i]) {
						add(1, 1, ss, pos + 1, l[i], 1);
					}
					if (l[i] < l[i - 1]) {
						add(1, 1, ss, l[i] + 1, l[i - 1], INF);
					}
				}
			}
		}
	}
	return 1;
}


int main() {
	scanf("%d", &n);
	vector<pair<int, int> > bad;
	for (int i = 0; i < n; i++) {
		scanf("%d", &l[i]);
		if (l[i] > 2 * n) {
			bad.push_back(make_pair(l[i], i));
		}
	}
	sort(all(bad));
	int cur = 2 * n + 1;
	for (int i = 0; i < sz(bad); i++) {
		if (i && bad[i].first > bad[i - 1].first) {
			cur++;
		}
		l[bad[i].second] = cur;
	}
	int len = 0;
	for (int i = 0; i < n; i++) {
		len = max(len, l[i]);
	}
	while (ss < len) {
		ss <<= 1;
	}
	int l = 1;
	int r = n;
	while (l != r) {
		int mid = (l + r) >> 1;
		if (get(mid)) {
			r = mid;
		} else {
			l = mid + 1;
		}
	}
	printf("%d\n", l);
	return 0;
}
