#pragma GCC "-O3"
#include <bits/stdc++.h>


using namespace std;


#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 100228;
const int INF = 2000000001;


struct road
{
	int l, r, p;
	road(){}
	road(int _l, int _r, int _p) {
		l = _l;
		r = _r;
		p = _p;
	}
};


bool operator <(road a, road b) {
	return a.r < b.r || (a.r == b.r && a.l < b.l);
}


int n, k;
road s[MAXN];
int dp[MAXN];


int main() {
	scanf("%d %d", &n, &k);
	for (int i = 0; i < n; i++) {
		scanf("%d %d %d", &s[i].l, &s[i].r, &s[i].p);
	}
	sort(s, s + n);
	int ans = INF;
	for (int i = 0; i < n; i++) {
		dp[i] = INF;
		if (s[i].l == 1) {
			dp[i] = s[i].p;
		} else {
			for (int j = i - 1; j >= 0; j--) {
				if (s[j].r < s[i].l - 1) {
					break;
				}
				if (s[j].r == s[i].l - 1) {
					dp[i] = min(dp[i], max(dp[j], s[i].p));
				} else {
					dp[i] = min(dp[i], max(dp[j], s[i].p + s[j].p));
				}
			}
		}
		if (s[i].r == k) {
			ans = min(ans, dp[i]);
		}
	}
	if (ans == INF) {
		printf("-1\n");
		return 0;
	}
	printf("%d\n", ans);
	return 0;
}
