///#pragma comment(linker, "/STACK:100000000");
#include <bits/stdc++.h>

#define X first
#define Y second
#define REP(i, a, b) for (int i = (a); i <= (b); ++i)
#define pb push_back
#define all(v) (v).begin(), (v).end()
#define sz(v) ((int)(v).size())

using namespace std;

typedef pair <int, int> pii;
typedef long long ll;

void done()
{
    cout << -1;
    exit(0);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    string s;
    cin >> s;

    int nx, ny;
    cin >> nx >> ny;

    map <int, int> ccr;
    map <int, int> ccu;

    vector <int> pl(n + 1);
    vector <int> pr(n + 1);
    vector <int> pu(n + 1);
    vector <int> pd(n + 1);

    ccr[0] = 0;
    ccu[0] = 0;

    REP (i, 1, n)
        pl[i] = pl[i - 1] + (s[i - 1] == 'L');

    REP (i, 1, n) {
        pr[i] = pr[i - 1] + (s[i - 1] == 'R');
        ccr[pr[i]] = i;
    }

    REP (i, 1, n) {
        pu[i] = pu[i - 1] + (s[i - 1] == 'U');
        ccu[pu[i]] = i;
    }

    REP (i, 1, n)
        pd[i] = pd[i - 1] + (s[i - 1] == 'D');

    int ansl = -1, ansr = -1;
    int ansu = -1, ansd = -1;

    REP (i, 0, n)
    {
        int x = nx + pl[i];
        if (ccr.find(x) == ccr.end())
            continue;
        ansl = i;
        ansr = ccr[x];
        break;
    }

    REP (i, 0, n)
    {
        int y = ny + pd[i];
        //cout << pd[i] << '\n';
        if (ccu.find(y) == ccu.end())
            continue;
        ansd = i;
        ansu = ccu[y];
        break;
    }

    if (ansl == -1 || ansd == -1)
        done();
    cout << ansl << ' ' << ansu << ' ' << ansr << ' ' << ansd << '\n';
    return 0;
}
