#include <bits/stdc++.h>

#define X first
#define Y second
#define pb push_back
#define REP(i, a, b) for (int i = (a); i <= (b); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) ((int)(v).size())

using namespace std;

typedef pair <int, int> pii;
typedef long long ll;

const int maxn = 1e5;
pii d[maxn];
map <int, bool> used;
map <int, vector <int> > cc;
set <int> ok;
int n, k;

void done()
{
    cout << -1;
    exit(0);
}

void dfs(int ind)
{
    if (ind == k + 1)
    {
        ok.insert(ind);
        return;
    }

    used[ind] = true;

    for (auto e : cc[ind])
    {
        if (!used[e + 1])
            dfs(e + 1);
        if (ok.find(e + 1) != ok.end())
            ok.insert(ind);
    }
}


int main()
{
    freopen("input.txt", "r", stdin);
    cin >> n >> k;
    vector <pii> e(n);
    for (int i = 0; i < n; i++)
    {
        int l, r, p;
        cin >> l >> r >> p;

        d[i].X = l;
        d[i].Y = r;

        cc[l].pb(r);

        e[i].Y = r;
        e[i].X = l;
    }

    sort(e.begin(), e.end());

    int ptr = 0;

    REP (i, 0, n - 1)
    {
        if (e[i].X > ptr + 1)
            done();
        ptr = e[i].Y;
    }

    if (ptr != k)
        done();

    dfs(1);
    if (ok.empty())
    {
        done();
    }
    cout << (ok.find(1) != ok.end() ? 1 : 2) << '\n';
    return 0;
}
