#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cstdio>
#include <ctime>
#include <algorithm>

using namespace std;

#define forn (i, s, n) for (int (i) = (s); (i) < (n); ++(i))
#define all(arr) (arr.begin(), arr.end())
#define TASK ""
#define TL 0
#define mp make_pair
#define lucky 13373228

typedef long long ll;
typedef double dbl;

int main() {
#ifdef SOLVE	
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif

	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
	//srand(lucky);

	int n, x, y;
	string com;
	cin >> n >> com >> x >> y;
	vector <int> L, R, U, D;
	for (int i = 0; i < n; ++i) {
		char c = com[i];
		if (c == 'L') {
			L.push_back(i);
		}
		if (c == 'R') {
			R.push_back(i);
		}
		if (c == 'U') {
			U.push_back(i);
		}
		if (c == 'D') {
			D.push_back(i);
		}
	}
	if (x > (int)R.size() || x < -(int)L.size() || y > (int)U.size() || y < -(int)D.size()) {
		cout << -1;
		return 0;
	}
	for (int r = 0; r <= R.size(); ++r) {
		for (int u = 0; u <= U.size(); ++u) {
			int need_l = r - x;
			int need_d = u - y;
			if (need_l < 0 || need_d < 0 || need_l > L.size() || need_d > D.size()) {
				continue;
			}
			if (need_l == 0) {
				cout << 0 << " ";
			}
			else {
				cout << L[need_l - 1] + 1 << " ";
			}
			if (u == 0) {
				cout << 0 << " ";
			}
			else {
				cout << U[u - 1] + 1 << " ";
			}
			if (r == 0) {
				cout << 0 << " ";
			}
			else {
				cout << R[r - 1] + 1 << " ";
			}
			if (need_d == 0) {
				cout << 0 << " ";
			}
			else {
				cout << D[need_d - 1] + 1 << " ";
			}
			return 0;
		}
	}

#if TL
	cerr << (dbl)clock() / CLOCKS_PER_SEC << "\n";
#endif

	return 0;
}