#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cstdio>
#include <ctime>
#include <algorithm>

using namespace std;

#define forn (i, s, n) for (int (i) = (s); (i) < (n); ++(i))
#define all(arr) (arr.begin(), arr.end())
#define TASK ""
#define TL 0
#define mp make_pair
#define lucky 13373228

typedef long long ll;
typedef double dbl;

int main() {
#ifdef SOLVE	
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif

	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
	//srand(lucky);

	int n, x, y;
	string com;
	cin >> n >> com >> x >> y;
	vector <int> L, R, U, D;
	for (int i = 0; i < n; ++i) {
		char c = com[i];
		if (c == 'L') {
			L.push_back(i);
		}
		if (c == 'R') {
			R.push_back(i);
		}
		if (c == 'U') {
			U.push_back(i);
		}
		if (c == 'D') {
			D.push_back(i);
		}
	}
	if (x > (int)R.size() || x < -(int)L.size() || y > (int)U.size() || y < -(int)D.size()) {
		cout << -1;
		return 0;
	}
	int lr = 0, rr = (int)R.size(), lu = 0, ru = U.size();
	while (rr - lr > 1) {
		int r = (lr + rr) / 2;
		int need_l = r - x;
		if (need_l < 0) {
			rr = r;
		}
		else {
			while (ru - lu > 1) {
				int u = (ru + lu) / 2;
				int need_d = u - y;
				if (need_d < 0) {
					ru = u;
				}
				else {
					lu = u;
				}
			}
			lr = r;
		}
	}
	if (lr - x == 0) {
		cout << 0 << " ";
	}
	else {
		cout << L[lr - x - 1] + 1 << " ";
	}
	if (lu == 0) {
		cout << 0 << " ";
	}
	else {
		cout << U[lu - 1] + 1 << " ";
	}
	if (lr == 0) {
		cout << 0 << " ";
	}
	else {
		cout << R[lr - 1] + 1 << " ";
	}
	if (lu - y == 0) {
		cout << 0 << " ";
	}
	else {
		cout << D[lu - y - 1] + 1 << " ";
	}

#if TL
	cerr << (dbl)clock() / CLOCKS_PER_SEC << "\n";
#endif

	return 0;
}