#define _CRT_SECURE_NO_DEPRECATE

#pragma warning(disable:4996)

#include<vector>
#include<string>
#include<set>
#include<unordered_set>
#include<map>
#include<deque>
#include<iostream>
#include<cstdlib>
#include<cstring>
#include<ctime>
#include<algorithm>
#include<cstdio>
#include<bitset>
#include<queue>

typedef long long ll;

using namespace std;

#define F first
#define S second
#define forn(a, b) for(register int a = 0; a < b; ++a)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	//cin.tie(0);
	//ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}


int n, k;
struct p {
	int l, r, w;
};
bool operator<(p lhs, p rhs) {
	if (lhs.w == rhs.w)return lhs.l < rhs.l;
	return lhs.w < rhs.w;
}
p v[100001];
ll M;

struct SGtree {
	static const int size = 1 << 4;
	//ll a[size * 2];
	ll m[size * 2];
	ll d[size * 2];
	void push(int v, int l, int r) {
		if (r - l > 1) {
			d[v * 2 + 1] += d[v];
			d[v * 2 + 2] += d[v];
		}
		//a[v] += d[v];
		m[v] += d[v];
		d[v] = 0;
	}

	void clear() {
		//fill(a, a + size * 2, 0);
		fill(m, m + size * 2, 0);
		fill(d, d + size * 2, 0);
	}

	void add(int L, int R, ll D, int v = 0, int l = 0, int r = size) {
		push(v, l, r);
		if (L >= r || R < l)
			return;
		if (L <= l && r - 1 <= R) {
			d[v] += D;
			return;
		}
		add(L, R, D, v * 2 + 1, l, (l + r) >> 1);
		add(L, R, D, v * 2 + 2, (l + r) >> 1, r);
		m[v] = max(m[v * 2 + 1], m[v * 2 + 2]);
	}

	ll ask(int L, int R, int v = 0, int l = 0, int r = size) {
		push(v, l, r);
		if (L >= r || R < l)
			return 0;
		if (L <= l && r - 1 <= R) {
			return m[v];
		}
		return max(ask(L, R, v * 2 + 1, l, (l + r) >> 1), ask(L, R, v * 2 + 2, (l + r) >> 1, r));
	}
} T;


bool check() {
	T.clear();
	forn(i, n) {
		T.add(v[i].l, v[i].r, v[i].w);
		if (T.ask(v[i].l, v[i].r) > M) {
			T.add(v[i].l, v[i].r, -v[i].w);
		}
	}
	forn(i, k) {
		int tt = T.ask(i + 1, i + 1);
		if (!tt || tt > M)return false;
	}
	return true;

}

void solve() {
	cin >> n >> k;
	forn(i, n) {
		cin >> v[i].l >> v[i].r >> v[i].w;
	}
	sort(v, v + n);
	ll L = 0;
	ll R = 1000000000000000;
	while (R - L > 1) {
		M = L + R >> 1;
		if (M < 10) {
			M = M;
		}
		if (!check())
			L = M;
		else
			R = M;
	}
	M = R;
	if (!check()) {
		cout << -1 << endl;
		return;
	}
	cout << R << endl;
}