#include <fstream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
    const int INF = 2e6;
    //ifstream cin("i-B.txt");
    int n;
    cin >> n;
    vector<int> a(n);
    int l = 0, r = 0, u = 0, d = 0;
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        if (c == 'L') {
            a[i] = 0;
            --l;
        } else if (c == 'U') {
            a[i] = 1;
            ++u;
        } else if (c == 'R') {
            a[i] = 2;
            ++r;
        } else {
            a[i] = 3;
            --d;
        }
    }
    int x, y;
    cin >> x >> y;
    if (x > r || x < l || y > u || y < d) {
        cout << -1;
        return 0;
    }
    int ansu = 0, ansd = 0, ansl = 0, ansr = 0;
    if (x > 0) {
        ansl = 0;
        int ctr = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] == 2) {
                ++ctr;
                if (ctr == x) {
                    ansr = i + 1;
                    break;
                }
            }
        }
    } else if (x < 0) {
        ansr = 0;
        int ctr = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] == 0) {
                --ctr;
                if (ctr == x) {
                    ansl = i + 1;
                    break;
                }
            }
        }
    }
    if (y > 0) {
        ansd = 0;
        int ctr = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] == 1) {
                ++ctr;
                if (ctr == y) {
                    ansu = i + 1;
                    break;
                }
            }
        }
    } else if (y < 0) {
        ansu = 0;
        int ctr = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] == 3) {
                --ctr;
                if (ctr == y) {
                    ansd = i + 1;
                    break;
                }
            }
        }
    }

    cout << ansl << " " << ansu << " " << ansr << " " << ansd;
    return 0;
}
