#include <fstream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

bool ans(ll n) {
    cout << "N " << n << endl;
    cout.flush();
    string s;
    cin >> s;
    return s == "Wrong";
}

pair<ll,ll> q(ll n) {
    cout << "X " << n << endl;
    cout.flush();
    ll s;
    cin >> s;
    if (s == -1) {
        return make_pair(-1, -1);
    } else {
        ll k;
        cin >> k;
        return {s, k};
    }
}

int main() {
    //ifstream cin("i-D.txt");
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        ll l = 1, r = 1000000000000000000;
        while (r - l > 1) {
            ll m = l + (r - l) / 2;
            auto j = q(m + 1);
            if (j.first == -1) return 0;
            else if (j.first == 0) r = m;
            else l = m;
        }
        if (ans(r)) return 0;
    }
    return 0;
}
