#include <fstream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

bool ans(ll n) {
    cout << "N " << n << endl;
    cout.flush();
    string s;
    cin >> s;
    return s == "Wrong";
}

pair<ll,ll> q(ll n) {
    cout << "X " << n << endl;
    cout.flush();
    ll s;
    cin >> s;
    if (s == -1) {
        return make_pair(-1, -1);
    } else {
        ll k;
        cin >> k;
        return {s, k};
    }
}

int main() {
    //ifstream cin("i-D.txt");
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        bool fl = false;
        int ct = 0;
        ll l = 1, r = 1000000000000000001, m;
        pair<ll,ll> j;
        while (!fl && r - l > 1) {
            m = l + (r - l) / 2;
            j = q(m);
            ++ct;
            if (j.first == -1) while (true);
            else if (j.first == 0) r = m;
            else {
                if (l == 1 && r != 1000000000000000001) {
                    if (ans(j.second)) return 0;
                    fl = true;
                } else {
                    l = m;
                }
            }
        }
        if (fl) continue;
        if (r == l)
            if (ans(l)) while (true);
            else continue;
        if (j.first == -1) while (true);

        if (m == r  && j.first == 0) {
            if (ans(l)) return 0;
        } else if (m == r) {
            if (ans(r)) return 0;
        } else {
            if (ans(l)) return 0;
        }
    }
    return 0;
}
