#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <queue>
#include <map>

using namespace std;

const int MX = 60;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int l = 2, r = n;
	bool is = 1;
	for (int i = 1; i < n; i++)
		if (a[i] <= a[i - 1])
			is = 0;
	if (is) {
		cout << 1;
		return 0;
	}
	vector<int> b(MX);
	for (int i = 1; i < n; i++)
		if (a[i] <= a[i - 1] && a[i] < MX)
			b[a[i]]++;
	while (l != r) {
		int m = (l + r) / 2;
		vector<int> c = b;
		for (int j = MX - 1; j > 0; j--) {
			c[j - 1] += c[j] / m;
		}
		if (c[0])
			l = m + 1;
		else
			r = m;
	}
	cout << l;
	return 0;
}