#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <queue>
#include <map>

using namespace std;

const int MX = 33;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int l = 2, r = n;
	bool is = 1;
	for (int i = 1; i < n; i++)
		if (a[i] <= a[i - 1])
			is = 0;
	if (is) {
		cout << 1;
		return 0;
	}
	vector<int> b;
	for (int i = 1; i < n; i++)
		if (a[i] <= a[i - 1] && a[i] < MX)
			b.push_back(a[i]);
	while (l != r) {
		int m = (l + r) / 2;
		vector<int> c(MX);
		bool is = 1;
		for (int i = 0; i < b.size(); i++) {
			c[b[i]]++;
			for (int j = b[i]; j > 0; j--) {
				if (c[j] >= m) {
					c[j - 1]++;
					c[j] -= m;
				}
			}
			for (int j = b[i] + 1; j < MX; j++)
				c[j] = 0;
			if (c[0])
				is = 0;
		}

		if (!is)
			l = m + 1;
		else
			r = m;
	}
	cout << l;
	return 0;
}