#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define f first
#define s second
#define mp make_pair
#define pb push_back

const int maxn = 100500;
const int inf = 2e9;
const double eps = 1e-8;
const int base = 1073676287;

int a[maxn];
vector < pair < pair < int, int >, int > > cur;
vector < pair < pair < int, int >, int > > newCur;

void Delete( int len ) {
	int pos = -1 + cur.size();
	while ( cur[pos].f.f > len ) {
		cur.pop_back();
		--pos;
	}
	int l = cur[pos].f.f;
	int r = cur[pos].f.s;
	int type = cur[pos].s;
	cur.pop_back();
	cur.pb( mp( mp( l, len ), type ) );
}

bool Add( int x ) {
	bool need = true;
	int pos = -1 + cur.size();
	newCur.clear();
	while ( need ) {
		if ( pos < 0 )
			return false;
		int l = cur[pos].f.f;
		int r = cur[pos].f.s;
		int type = cur[pos].s;
		cur.pop_back();
		if ( l != r ) {
			cur.pb( mp( mp( l, r - 1 ), type ) );
            ++pos;
		}
		++type;
		if ( type < x ) {
			newCur.pb( mp( mp( r, r ), type ) );
			need = false;
		} else {
			newCur.pb( mp( mp( r, r ), 0 ) );
			--pos;
		}
	}
	int sz = newCur.size();
	for ( int j = sz - 1; j >= 0; j-- )
        cur.pb( newCur[j] );
	return true;
}

bool correct( int x, int n ) {
	if ( x == 1 ) {
	    for ( int j = 1; j < n; j++ )
	    	if ( a[j] <= a[j - 1] )
	    		return false;
	    return true;
	}
	cur.clear();
	cur.pb( mp( mp( 1, a[0] ), 0 ) );
	for ( int j = 1; j < n; j++ ) {
		if ( a[j] > a[j - 1] ) {
			cur.pb( mp( mp( a[j - 1] + 1, a[j] ), 0 ) );
			continue;
		}
		Delete( a[j] );
		if ( !Add( x ) )
			return false;
	}
	return true;
}

int main()
{
    srand( time( NULL ) );
    // freopen( "input.txt", "r", stdin );
    // freopen( "output.txt", "w", stdout );
    // ios_base::sync_with_stdio( false );
    int n;
    scanf ( "%d", &n );
    for ( int j = 0; j < n; j++ )
    	scanf ( "%d", &a[j] );
    int l = 1;
    int r = maxn;
    while ( r - l ) {
    	int mid = ( l + r ) >> 1;
    	if ( correct( mid, n ) )
    		r = mid;
    	else
    		l = mid + 1;
    }
    printf ( "%d\n", l );
    return 0;
}
