#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define f first
#define s second
#define mp make_pair
#define pb push_back

const int maxn = 1000500;
const int inf = 2e9;
const double eps = 1e-8;
const int base = 1073676287;

char t[maxn];
int blocked[maxn];

int main()
{
    srand( time( NULL ) );
    // freopen( "input.txt", "r", stdin );
    // freopen( "output.txt", "w", stdout );
    // ios_base::sync_with_stdio( false );
    for ( int j = 0; j < maxn; j++ )
    	blocked[j] = -1;
    int n;
    scanf ( "%d\n", &n );
    gets( t );
    int x, y;
    scanf ( "%d%d", &x, &y );
    int len = strlen( t );
    if ( x < 0 )
    	blocked['R'] = 0;
    else
    	blocked['L'] = 0;
    if ( y < 0 )
    	blocked['U'] = 0;
    else
    	blocked['D'] = 0;
    int curX, curY;
    curX = curY = 0;
    for ( int j = 0; j < len; j++ ) {
    	if ( curX == x ) {
    		if ( blocked['L'] == -1 )
    			blocked['L'] = j;
    		if ( blocked['R'] == -1 )
    			blocked['R'] = j;
    	}
    	if ( curY == y ) {
    		if ( blocked['U'] == -1 )
    			blocked['U'] = j;
    		if ( blocked['D'] == -1 )
    			blocked['D'] = j;
    	}
    	if ( blocked[t[j]] == -1 ) {
    		if ( t[j] == 'U' )
    			++curY;
    		if ( t[j] == 'D' )
    			--curY;
    		if ( t[j] == 'R' )
    			++curX;
    		if ( t[j] == 'L' )
    			--curX;
    	}
    }
    if ( curX != x || curY != y ) {
    	puts( "-1" );
    	return 0;
    }
    if ( blocked['U'] == -1 )
    	blocked['U'] = len;
    if ( blocked['D'] == -1 )
    	blocked['D'] = len;
    if ( blocked['R'] == -1 )
    	blocked['R'] = len;
    if ( blocked['L'] == -1 )
    	blocked['L'] = len;
    printf ( "%d %d %d %d\n", blocked['L'], blocked['U'], blocked['R'], blocked['D'] );
    return 0;
}
