#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define f first
#define s second
#define mp make_pair
#define pb push_back

const int maxn = 100500;
const int inf = 2e9;
const double eps = 1e-8;
const int base = 1073676287;

map < int, int > q;
map < int, int >::iterator it;
pair < pair < int, int >, int > a[maxn];
int dp[3 * maxn];
int use[3 * maxn];

int solution( int n, int k ) {
	sort( a, a + n );
	for ( int j = 0; j <= k + 10; j++ )
		use[j] = dp[j] = false;
	if ( n >= 0 ) {
    	dp[0] = true;
    	for ( int j = 0; j < n; j++ ) {
    		int l = a[j].f.f;
    		int r = a[j].f.s;
    		if ( dp[l - 1] )
    			dp[r] = true;
    		int pos = r;
    		while ( !use[pos] && pos >= l ) {
                use[pos] = true;
                --pos;
            }
    	}
    	int cnt = 0;
    	for ( int j = 1; j <= k; j++ )
    		if ( !use[j] )
    			return -1;
    	if ( dp[k] )
    		return 1;
    	return 2;
    }
}

int used[maxn];

ll brute( int n, int k ) {
	ll ans = 1LL * inf * inf;
	for ( int mask = 0; mask < ( 1 << n ); mask++ ) {
		for ( int j = 1; j <= k; j++ )
			used[j] = 0;
		for ( int j = 0; j < n; j++ )
			if ( mask & ( 1 << j ) ) {
				int l = a[j].f.f;
				int r = a[j].f.s;
				int d = a[j].s;
				for ( int i = l; i <= r; i++ )
					used[i] += d;
			}
		ll newAns = 0;
		for ( int j = 1; j <= k; j++ ) {
			if ( !used[j] ) {
				newAns = 1LL * inf * inf;
				break;
			}
			newAns = max( newAns, 1LL * used[j] );
		}
		ans = min( ans, newAns );
	}
	return ans == 1LL * inf * inf ? -1 : ans;
}

int main()
{
    // srand( time( NULL ) );
    // srand( base );
    // freopen( "input.txt", "r", stdin );
    // freopen( "output.txt", "w", stdout );
    // ios_base::sync_with_stdio( false );

    int n, k;
    scanf ( "%d%d", &n, &k );
    q[1] = 1;
    q[k] = 1;
    for ( int j = 0; j < n; j++ ) {
    	scanf ( "%d%d%d", &a[j].f.f, &a[j].f.s, &a[j].s );
    	q[a[j].f.f] = 1;
    	q[a[j].f.s] = 1;
    	q[a[j].f.s + 1] = 1;
    }
    if ( n <= 22 ) {
    	printf ( "%d\n", brute( n, k ) );
    	return 0;
    }
    int timer = 1;
    for ( it = q.begin(); it != q.end(); it++ )
    	it -> s = timer++;
    k = q[k];
    for ( int j = 0; j < n; j++ ) {
    	a[j].f.f = q[a[j].f.f];
    	a[j].f.s = q[a[j].f.s];
    }
    sort( a, a + n );
    if ( k >= 2 * maxn )
    	return 228;
    printf ( "%d\n", solution( n, k ) );


    // int it = 1000;
   	// while ( it-- ) {
   	// 	int n = 5;
   	// 	int k = 10;
   	// 	for ( int j = 0; j < n; j++ ) {
   	// 		a[j] = mp( mp( 1 + rand() % k, 1 + rand() % k ), 1 );
   	// 		if ( a[j].f.f > a[j].f.s )
   	// 			swap( a[j].f.f, a[j].f.s );
   	// 	}
   	// 	ll bruteAns = brute( n, k );
   	// 	ll myAns = solution( n, k );
   	// 	if ( bruteAns != myAns ) {
   	// 		puts( "kek" );
   	// 		printf ( "%d %d\n", n, k );
   	// 		for ( int j = 0; j < n; j++ )
   	// 			printf ( "%d %d %d\n", a[j].f.f, a[j].f.s, a[j].s );
   	// 		cout << "Correct: " << bruteAns << "   My: " << myAns << endl;
   	// 		return 0;
   	// 	}
   	// }
   	// puts( "all good" );
    return 0;
}
