#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define f first
#define s second
#define mp make_pair
#define pb push_back

const int maxn = 100500;
const int inf = 2e9;
const double eps = 1e-8;
const int base = 1073676287;

ll st[maxn];
vector < pair < ll, ll > > query;
string q;

bool ask( int x ) {
	cout << "X " << st[x] << endl;
	ll a, b;
	cin >> a >> b;
	query.pb( mp( a, b ) );
	return a != 0LL;
}

void solve() {
	query.clear();
	int l = 0;
	int r = 60;
	while ( r - l ) {
		int mid = ( l + r ) >> 1;
		if ( ask( mid ) )
			l = mid + 1;
		else
			r = mid;
	}
	int sz = query.size();
	for ( int j = sz - 1; j >= 0; j-- )
		if ( query[j].f != 0LL ) {
			cout << "N " << query[j].s << endl;
			break;
		}
	cin >> q;
}

int main()
{
    srand( time( NULL ) );
    // freopen( "input.txt", "r", stdin );
    // freopen( "output.txt", "w", stdout );
    // ios_base::sync_with_stdio( false );
    st[0] = 1;
    for ( int j = 1; j < 70; j++ )
    	st[j] = 2LL * st[j - 1];
    int q;
   	scanf ( "%d", &q );
   	while ( q-- )
   		solve();
    return 0;
}
