#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef double dbl;

template <class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << "\n";
}


const ll INF = 1e9;

struct point{
    int l, r, c;
};

bool cmp(point a, point b){
    if (a.l != b.l)
        return a.l < b.l;
    return a.r > b.r;
}


int main()
{


    /*freopen("test.in", "r", stdin);
    /*freopen("test.out", "w", stdout);/**/
    int n;
    scanf("%d", &n);
    vector<int> lst(n);
    for (int i = 0; i < n; i++)
        scanf("%d", &lst[i]);
    bool flag = true;
    for (int i = 1; i < n; i++)
        if (lst[i] <= lst[i - 1])
            flag = false;
    if (flag){
        cout << 1 << endl;
        return 0;
    }
    vector<int> s;
    for (int i = 0; i < n; i++)
        if (i == 0 || lst[i] < 30 || (i < n - 1 && lst[i] >= lst[i + 1]));
            s.push_back(min(50, lst[i]));
    n = s.size();
    int l = 0;
    int r = n;
    vector<vector<int> > answer(n);
    for (int i = 0; i < n; i++)
        answer[i].resize(s[i]);
    while (l + 1 < r){
        int m = (l + r) / 2;
        bool can = true;
        for (int i = 0; i < n; i++){
            if (i == 0){
                for (int j = 0; j < s[i]; j++)
                    answer[i][j] = 1;
            }
            else{
                if (s[i] > s[i - 1]){
                    for (int j = 0; j < s[i - 1]; j++)
                        answer[i][j] = answer[i - 1][j];
                    for (int j = s[i - 1]; j < s[i]; j++)
                        answer[i][j] = 1;
                }
                else{
                    for (int j = 0; j < s[i]; j++)
                        answer[i][j] = answer[i - 1][j];
                    int cur = s[i] - 1;
                    while (cur >= 0 && answer[i][cur] == m)
                        cur--;
                    if (cur >= 0){
                        for (int j = cur + 1; j < s[i]; j++)
                            answer[i][j] = 1;
                        answer[i][cur]++;
                    }
                    else{
                        can = false;
                        break;
                    }
                }
            }
        }
        if (can)
            r = m;
        else
            l = m;
    }
    cout << r << endl;
    return 0;
}
