#include <bits/stdc++.h>

using namespace std;
typedef long long nagai;

char mem[500000000];
int ptr = 0;

void* operator new(size_t n)
{
	ptr += n;
	return (void*)(mem + ptr - n);
}

void operator delete(void* ignored)
{}


struct nd
{
	nd* le;
	nd* ri;
	int sum;
	bool is0;

	nd()
		: le(nullptr), ri(nullptr), sum(0), is0(false)
	{}

	void children()
	{
		if (!le)
			le = new nd();
		if (!ri)
			ri = new nd();
	}

	void push()
	{
		children();
		if (!is0)
			return;
		le->is0 = true;
		ri->is0 = true;
		le->sum = ri->sum = 0;
		is0 = false;
	}
	
	void set0(int l, int r, int ql, int qr)
	{
		if (l >= qr || ql >= r)
			return;
		if (ql <= l && r <= qr)
		{
			is0 = true;
			sum = 0;
			return;
		}
		push();
		int m = (l + r) / 2;
		le->set0(l, m, ql, qr);
		ri->set0(m, r, ql, qr);
		sum = le->sum + ri->sum;
	}

	void set(int l, int r, int ind, int x)
	{
		if (ind < l || ind >= r)
			return;
		if (r - l == 1)
		{
			sum = x;
			return;
		}
		push();
		int m = (l + r) / 2;
		le->set(l, m, ind, x);
		ri->set(m, r, ind, x);
		sum = le->sum + ri->sum;
	}

	int get(int l, int r, int ind)
	{
		if (ind < l || ind >= r)
			return 0;
		if (r - l == 1)
			return sum;
		push();
		int m = (l + r) / 2;
		return le->get(l, m, ind) + ri->get(m, r, ind);
	}
};

int main()
{
	int n;
	cin >> n;
	vector<int> l(n);
	for (int& x : l)
		cin >> x;
	nd* st = new nd();	
	int MX = 1000000001;
	int L = 0, R = n;
	while (R - L > 1)
	{
		int M = (L + R) / 2;
		//cerr << M << endl;
		bool f = true;
		st->set0(0, MX, 0, MX);
		for (int i = 0; i < n - 1; ++i)
		{
			if (l[i + 1] <= l[i])
			{
				int ind = l[i + 1] - 1;
				while (true)
				{
					int old = st->get(0, MX, ind);
					if (old != M - 1)
					{
						st->set(0, MX, ind, old + 1);
						break;
					}
					else
					{
						if (ind == 0)
						{
							f = false;
							break;
						}
						st->set0(0, MX, ind, MX);
						--ind;
					}
				}
				if (!f)
					break;
			}
		}
		if (f)
			R = M;
		else
			L = M;
	}
	cout << R << endl;
}

