#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

const char L = 'L', R = 'R', D = 'D', U = 'U';

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    string p;
    cin >> p;
    int x, y;
    cin >> x >> y;
    vector<int> l {0}, r = {0}, u = {0}, d = {0};
    for (int i = 0; i < n; ++i) {
        switch(p[i]) {
            case (L) : {
                l.push_back(i + 1);
                break;
            }
            case (R) : {
                r.push_back(i + 1);
                break;
            }
            case (U) : {
                u.push_back(i + 1);
                break;
            }
            case (D) : {
                d.push_back(i + 1);
                break;
            }
        }
    }
    int numl = l.size() - 1, numr = r.size() - 1, numd = d.size() - 1, numu = u.size() - 1;
    int breakr = 0, breakl = -1;
    int ansr, ansl;
    for (; breakr <= numr; ++breakr) {
        if (breakr >= x && numl >= breakr - x) {
            breakl = breakr - x;
            ansr = r[breakr];
            ansl = l[breakl];
            break;
        }
    }
    int breaku = 0, breakd = -1;
    int ansu, ansd;
    for (; breaku <= numu; ++breaku) {
        if (breaku >= y && numd >= breaku - y) {
            breakd = breaku - y;
            ansu = u[breaku];
            ansd = d[breakd];
            break;
        }
    }
    if (breakl == -1 || breakd == -1) {
        cout << "-1\n";
        return 0;
    }
    cout << ansl << " " << ansu << " " << ansr << " " << ansd << "\n";
//    cout << endl;
//    system("pause");
    return 0;
}