#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define fst first
#define snd second
#define sz(a_) (int((a_).size()))
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;

constexpr int maxn = 2e5;

int a[maxn];
int cur[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int l = 0, r = n;
    set<int>::iterator it;
    while (r-l > 1) {
        //cout << l <<  ' ' << r << endl;
        int m = (l+r)/2;
        for (int i = 0; i < a[0]; ++i) {
            cur[i] = 0;
        }
        set<int> nz;
        bool u = 1;
        for (int i = 1; i < n; ++i) {
            if (a[i] > a[i-1]) {
                while (!nz.empty()) {
                    it = prev(nz.end());
                    if (*it >= a[i-1]) {
                        cur[*it] = 0;
                        nz.erase(it);
                    } else {
                        break;
                    }
                }
            } else {
                bool w = 0;
                for (int j = a[i]-1; j >= 0; --j) {
                    if (cur[j] == m-1) {
                        cur[j] = 0;
                        nz.erase(j);
                    } else {
                        if (cur[j] == 0) {
                            nz.insert(j);
                        }
                        ++cur[j];
                        w = 1;
                        break;
                    }
                }
                if (!w) {
                    u = 0;
                    break;
                }
            }
        }
        if (u) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << '\n';
    return 0;
}
