#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define fst first
#define snd second
#define sz(a_) (int((a_).size()))
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    int x, y;
    cin >> x >> y;
    int u, l, r, d;
    u = l = r = d = 0;
    for (int i = 0; i < sz(s); ++i) {
        switch (s[i]) {
            case 'U': ++u; break;
            case 'L': ++l; break;
            case 'D': ++d; break;
            case 'R': ++r; break;
        }
    }
    d *= -1;
    l *= -1;
    if (x > r || x < l || y > u || y < d) {
        cout << "-1\n";
        return 0;
    }
    int rl, ru, rd, rr;
    rl = ru = rd = rr = 0;
    if (x < 0) {
        rr = 0;
        int cnt = 0;
        for (int i = 0; i < sz(s); ++i) {
            if (cnt == -x) {
                break;
            }
            if (s[i] == 'L') {
                ++cnt;
            }
            ++rl;
        }
    } else {
        rl = 0;
        int cnt = 0;
        for (int i = 0; i < sz(s); ++i) {
            if (cnt == x) {
                break;
            }
            if (s[i] == 'R') {
                ++cnt;
            }
            ++rr;
        }
    }
    if (y < 0) {
        ru = 0;
        int cnt = 0;
        for (int i = 0; i < sz(s); ++i) {
            if (cnt == -y) {
                break;
            }
            if (s[i] == 'D') {
                ++cnt;
            }
            ++rd;
        }
    } else {
        rd = 0;
        int cnt = 0;
        for (int i = 0; i < sz(s); ++i) {
            if (cnt == y) {
                break;
            }
            if (s[i] == 'U') {
                ++cnt;
            }
            ++ru;
        }
    }
    cout << rl << ' '  << ru << ' ' << rr << ' ' << rd << '\n';
    return 0;
}
