#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) (int) (x).size()
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL
	#define debug(x) cerr << x << endl
#else
	#define debug(x)
#endif

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
const int MOD = (int) 1e9 + 7;
const ld EPS = 1e-8;

void run();

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	run();
	return 0;
}

const int N = (int) 1e5 + 123;

ll n_ok = 1;

pair<ll, ll> ask(ll t) {
	cout << "X " << t << endl;
	#ifdef LOCAL
		ll q = n_ok / t;
		ll d = __gcd(q, n_ok);
		return {q / d, n_ok / d};
	#endif
	pair<ll, ll> res;
	cin >> res.first;
	if (res.first == -1) {
		exit(0);
	}
	cin >> res.second;
	return res;
}

void ans(ll x) {
	cout << "N " << x << endl;
	string res;
	#ifdef LOCAL
		return;
	#endif
	cin >> res;
	if (res != "Correct") {
		exit(0);
	}
}

ll nxt(ll p) {
	ll tmp = (ll) sqrt(p);
	if (tmp * tmp < p) tmp++;
	return tmp;
}

void rec(ll p, ll div) {
	if (p == 1) {
		ans(div);
	}
	auto res = ask(p * div);
	ll a = res.first;
	ll b = res.second;
	a *= div;
	ll qq = __gcd(a, b);
	a /= qq;
	b /= qq;
	ll x = a;
	ll y = b - x * p;
	ll div2 = x * p + y;
	if (p > 2) rec(nxt(p), div2 * div);
	else ans(div2 * div);
}

void solve() {
	ll p = (ll) 1e9;
	
	while (1) {
		auto res = ask(p);
		if (res.first == 0) {
			if (p == 2) break;
			p = nxt(p);
		} else {
			ll a = res.first;
			ll b = res.second;
			ll x = a;
			ll y = b - x * p;
			ll div = x * p + y;
			rec(nxt(p), div);
			
			return;
		}
	}
	
	ans(1);
}

void run() {
	ll g;
	cin >> g;
	#ifdef LOCAL
		n_ok = g;
		g = 1;
	#endif
	
	for (ll i = 0; i < g; i++) {
		solve();
	}
}
