#include <iostream>
#include <vector>

using namespace std;

bool good(const vector<int> &lengs, int n)
{
	vector<int> curr(lengs[0], 0);
	for (int i = 1; i < lengs.size(); ++i)
	{
		if (lengs[i] == lengs[i - 1])
		{
			bool flag = false;
			for (int j = curr.size() - 1; j >= 0; --j)
			{
				if (curr[j] < n - 1)
				{
					++curr[j];
					fill(curr.begin() + j + 1, curr.end(), 0);
					flag = true;
					break;
				}
			}
			if (!flag)
				return false;
		}
		else if (lengs[i] < lengs[i - 1])
		{
			bool flag = false;
			vector<int> tmp(lengs[i]);
			for (int j = 0; j < lengs[i]; ++j)
				tmp[j] = curr[j];
			for (int j = tmp.size() - 1; j >= 0; --j)
			{
				if (tmp[j] < n - 1)
				{
					++tmp[j];
					fill(tmp.begin() + j + 1, tmp.end(), 0);
					flag = true;
					break;
				}
			}
			if (!flag)
				return false;
			curr = tmp;
		}
		else
		{
			curr.resize(lengs[i], 0);
		}
	}
	return true;
}

int main()
{
	int n;
	cin >> n;
	vector<int> l(n);
	for (int i = 0; i < n; ++i)
		cin >> l[i];
	int left = 0, right = n;
	while (right - left > 1)
	{
		int middle = (right + left) / 2;
		if (good(l, middle))
			right = middle;
		else
			left = middle;
	}
	cout << right << '\n';
	return 0;
}

