#include <iostream>
#include <vector>

using namespace std;

bool good(const vector<int> &lengs, int alph, int k)
{
	long long code = 0;
	vector<long long> pow(k + 1);
	pow[0] = 1;
	for (int i = 1; i < pow.size(); ++i)
		pow[i] = pow[i - 1] * alph;
	for (int i = 1; i < lengs.size(); ++i)
	{
		if (lengs[i] == lengs[i - 1])
			++code;
		else if (lengs[i] < lengs[i - 1])
			code /= pow[lengs[i - 1] - lengs[i]];
		else
			code *= pow[lengs[i] - lengs[i - 1]];
		if (code >= pow[k])
			return false;
	}
	return true;
}

int main()
{
	int n;
	cin >> n;
	vector<int> l(n);
	int k = 0;
	for (int i = 0; i < n; ++i)
	{
		cin >> l[i];
		if (l[i] > k)
			k = l[i];
	}
	int left = 0, right = n;
	while (right - left > 1)
	{
		int middle = (right + left) / 2;
		if (good(l, middle, k))
			right = middle;
		else
			left = middle;
	}
	cout << right << '\n';
	return 0;
}

