#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> par;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef long double ld;
typedef vector<bool> vbool;
typedef vector<par> vpar;

#define _ inline
#define forn(i, b, n) for(ll i = b; i < n; ++i)
#define rforn(i, b, n) for(ll i = b; i >= n; --i)
#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define pw(n) (1ll << (n))
#define mp make_pair
#define pushb push_back

_ ll logn(ll n) {
	ll x = ll(log2(double(n)));
	if (pw(x) != n) ++x;
	return x;
}

ll check(string s, ll l, ll u, ll r, ll d, ll x, ll y) {
	ll xx = 0, yy = 0;
	forn(i, 0, s.size()) {
		if (s[i] == 'L' && i < l) xx--;
		if (s[i] == 'R' && i < r) xx++;
		if (s[i] == 'U' && i < u) yy++;
		if (s[i] == 'D' && i < d) yy--;
	}
	return (xx == x) && (yy == y);
}

int source() {
	string ss = "LRDU";
	ll n, x, y;
	string s;
	cin >> n;
	cin >> s;
	cin >> x >> y;
	vvll a(n + 1, vll(4, 0));
	ll maxi = 0;
	forn(i, 1, n + 1) {
		forn(j, 0, 4) {
			a[i][j] = a[i - 1][j] + (s[i - 1] == ss[j]);
			maxi = max(maxi, a[i][j]);
		}
	}
	vll t(maxi + 1, -1);
	ll ansl, ansr, ansd, ansu;
	bool z = 1;
	forn(i, 0, n + 1) {
		if (t[a[i][0]] == -1) {
			t[a[i][0]] = i;
		}
	}
	forn(i, 0, n + 1) {
		if (a[i][1] < x || a[i][1] - x >= maxi) continue;
		if (t[a[i][1] - x] != -1) {
			ansl = t[a[i][1] - x];
			ansr = i;
			z = 0;
			break;
		}
	}
	if(z) {
		cout << -1;
		return 0;
	}
	z = 1;
	t.assign(maxi + 1, -1);
	forn(i, 0, n + 1) {
		if (t[a[i][2]] == -1) {
			t[a[i][2]] = i;
		}
	}
	forn(i, 0, n + 1) {
		if (a[i][3] < y || a[i][3] - y >= maxi) continue;
		if (t[a[i][3] - y] != -1) {
			ansd = t[a[i][3] - y];
			ansu = i;
			z = 0;
			break;
		}
	}
	if (z) {
		cout << -1 << '\n';
		return 0;
	}
		cout << ansl << ' ' << ansu << ' ' << ansr << ' ' << ansd;
	return 0;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	srand('1');
	ios::sync_with_stdio(0);
	source();
	return 0;
}