#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<string>
#include<cstring>
#include<algorithm>
#include<map>
#include<set>
#include<functional>
#include<ctime>
#include<vector>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define X first
#define Y second
#define forn(i, n) for(int i = 0; i < (n); ++i)
#define for1(i, n) for(int i = 1; i <= (n); ++i)
#define psh push_back
#define all(a) a.begin(), a.end()
#define TASK "Vitalya"

const int MAXN = (int)5e3 + 7;
const int dd = (int)1e5 + 7;
const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin); freopen(TASK".out", "w", stdout);
#endif
}

int a[MAXN];
int d[MAXN][MAXN];
int cnt = 1;
set<ull> s;
int n;
ull pr = 239017;

void debug() {
#ifdef _DEBUG
	cout << "\n\n";
	forn(i, n) {
		forn(j, 20)
			cout << d[i][j] << " ";
		cout << "\n";
	}
#endif
}

void next(int i) {
	int uk = a[i] - 1;
	while (uk >= 0 && d[i][uk] == cnt) {
		--uk;
	}
	if (uk == -1) {
		++cnt;
		for (int j = 0; j < a[i] - 1; ++j)
			d[i][j] = 1;
		d[i][a[i] - 1] = cnt;
	} else {
		++d[i][uk];
		for (int j = uk + 1; j < a[i]; ++j)
			d[i][j] = 1;
	}
}

int main() {
	file();
	cin >> n;
	forn(i, n) {
		cin >> a[i];
	}
	forn(i, n) {
		if (i == 0) {
			forn(j, a[i]) 
				d[i][j] = 1;
		} else {
			if (a[i] > a[i - 1]) {
				forn(j, a[i - 1])
					d[i][j] = d[i - 1][j];
				for (int j = a[i - 1]; j < a[i]; ++j)
					d[i][j] = 1;
			} else {
				forn(j, a[i])
					d[i][j] = d[i - 1][j];
				ull h = 0;
				do {
					next(i);
					h = 0;
					forn(j, a[i]) {
						h = h * pr + d[i][j];
					}
				} while (s.find(h) != s.end());
				s.insert(h);
			}
		}
	}
	int ans = 0;
	forn(i, n) {
		forn(j, 5000)
			ans = max(ans, d[i][j]);
	}
	cout << ans;
	debug();

	return 0;
}