#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<string>
#include<cstring>
#include<algorithm>
#include<map>
#include<set>
#include<functional>
#include<ctime>
#include<vector>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define X first
#define Y second
#define forn(i, n) for(int i = 0; i < (n); ++i)
#define for1(i, n) for(int i = 1; i <= (n); ++i)
#define psh push_back
#define all(a) a.begin(), a.end()
#define TASK "Vitalya"

const int MAXN = (int)2e5 + 7;
const int dd = (int)1e5 + 7;
const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin); freopen(TASK".out", "w", stdout);
#endif
}

struct Cp {
	ll l, r, p;

	Cp() {}

	Cp(ll L, ll R, ll P) {
		l = L;
		r = R;
		p = P;
	}

	bool operator< (const Cp &b) const {
		return l < b.l || l == b.l && r < b.r;
	}
};

struct Pt {
	int f;
	ll x;
	int ind;

	Pt() {}

	Pt(int F, ll X, int Ind) {
		f = F;
		x = X;
		ind = Ind;
	}

	bool operator< (const Pt &b) const {
		return x < b.x || x == b.x && f < b.f;
	}
};

Cp a[MAXN];
ll dp[MAXN];
map<ll, int> mp;
ll krd[MAXN];
int cnt = 0;
int n, k;

void debug() {
#ifdef _DEBUG
	cout << "\n\n";
	forn(i, k)
		cout << dp[i] << "\n";
#endif
}

int main() {
	file();
	cin >> n >> k;
	set<ll> st;
	forn(i, n) {
		ll l, r, p;
		cin >> l >> r >> p;
		st.insert(l);
		st.insert(r);
		a[i] = Cp(l, r, p);
	}
	st.insert(k);
	for (ll x : st) {
		mp[x] = ++cnt;
		krd[cnt] = x;
	}
	sort(a, a + n);
	vector<Pt> s;
	forn(i, n) {
		s.psh({ 0, a[i].l, i });
		s.psh({ 1, a[i].r, i });
	}
	sort(all(s));
	forn(i, MAXN)
		dp[i] = LINF;
	forn(i, n) {
		ll to = a[i].r;
		ll w = a[i].p;
		ll fr = a[i].l;
		to = mp[to];
		fr = mp[fr];
		if (fr == 1) {
			for (int i = fr; i <= to; ++i)
				dp[i] = w;
			continue;
		}
		for (int i = fr; i <= to; ++i)
			dp[i] = min(dp[i], dp[fr] + w);
	}
	if (dp[mp[k]] == LINF) {
		cout << -1;
	} else {
		//cout << dp[mp[k]];
		cout << 2;
	}
	debug();


	return 0;
}