#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <algorithm>

/// problem "muffin"

const int N = 1000100;

char str[N];
std::vector<int> ls, us, ds, rs;

int main()
{
    ///assert(freopen("input.txt", "r", stdin));

    int n;
    scanf("%d", &n);
    scanf("%s", str);

    ls.push_back(-1); us.push_back(-1);
    rs.push_back(-1); ds.push_back(-1);

    for (int i = 0; i < n; ++i) {
        if (str[i] == 'L') ls.push_back(i);
        if (str[i] == 'U') us.push_back(i);
        if (str[i] == 'D') ds.push_back(i);
        if (str[i] == 'R') rs.push_back(i);
    }

    int x = (int)rs.size() - (int)ls.size();
    int y = (int)us.size() - (int)ds.size();

    int nx, ny;
    scanf("%d%d", &nx, &ny);

    while (rs.size() && x > nx)
        rs.pop_back(), --x;
    while (ls.size() && x < nx)
        ls.pop_back(), ++x;
    while (us.size() && y > ny)
        us.pop_back(), --y;
    while (ds.size() && y < ny)
        ds.pop_back(), ++y;

    if (!(rs.size() && ls.size() && us.size() && ds.size()))
        printf("-1\n");
    else
        printf("%d %d %d %d\n",
               ls.back()+1,
               us.back()+1,
               rs.back()+1,
               ds.back()+1);

    return 0;
}
