#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <inttypes.h>
#include <vector>
#include <algorithm>

#define EXIT_ASSERT(COND) if (!(COND)) exit(0)

/// problem "Panna Cotta"

void qu(int64_t& a, int64_t& b, int64_t x)
{
    printf("X %lld\n", x); fflush(stdout);
    scanf("%lld", &a); EXIT_ASSERT(a != -1);
    scanf("%lld", &b);
}

void put_res(int64_t val)
{
    printf("N %lld\n", val); fflush(stdout);
    char buf[10];
    scanf("%s", buf); EXIT_ASSERT(buf[0] != 'W');
}

int64_t gcd(register int64_t a, register int64_t b)
{
    register int64_t c;
    while (a != 0)
        c = a,
        a = b%a,
        b = c;
    return b;
}

inline
int64_t lca(int64_t a, int64_t b)
{
    return (a/gcd(a, b))*b;
}


void solve()
{
    int64_t a, b;
    qu(a, b, 2);
    if (a == 0) return put_res(1);
    int64_t d = 2;
    while (true) {
        qu(a, b, 2*d - 1);
        if (a == 0)
            return put_res(d);
        else
            d = lca(d, b);
    }
}

int main()
{
    ///assert(freopen("input.txt", "r", stdin));

    int g; scanf("%d", &g);
    while (g--) solve();

    return 0;
}
