#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

#define X first
#define Y second

const int M = 5e3 + 5;
int n;
int a[M];
int b[M][M];

bool ch(int x)
{
	for (int i = 0; i < a[0]; ++i)
		b[0][i] = 1;
	for (int i = 1; i < n; ++i)
	{
		if (a[i] <= a[i - 1])
		{
			for (int j = 0; j < a[i - 1]; ++j)
				b[i][j] = b[i - 1][j];
			int j = a[i] - 1;
			while (j >= 0 && b[i][j] == x) --j;
			if (j < 0)
				return 0;
			b[i][j]++;
			for (int k = j + 1; k < a[i]; ++k)
				b[i][k] = 1;
		}
		else
		{
			for (int j = 0; j < a[i - 1]; ++j)
				b[i][j] = b[i - 1][j];
			for (int j = a[i - 1]; j < a[i]; ++j)
				b[i][j] = 1;
		}
	}
	return 1;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	int l = 1, r = M;
	while(l < r)
	{
		int m = (l + r) / 2;
		if (ch(m))
			r = m;
		else
			l = m + 1;
	}
	cout << l;
}