#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <bitset>

using namespace std;

typedef long long ll;

#define X first
#define Y second
#define pii pair<int, int> 
#define mp make_pair
#define inb push_back
#define LINF 2e18

struct pt
{
	int l, r, p;
};

const int M = 100005;
pt a[M];
int n, k;
ll dp[M];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &k);
	for (int i = 0; i < n; ++i)
		scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p);
	vector<pii> x;
	for (int i = 0; i < n; ++i)
		x.inb(mp(a[i].r, i));
	for (int i = 0; i < n; ++i)
		if (a[i].l == 1)
			dp[i] = a[i].p;
	sort(x.begin(), x.end());
	for (int i = 0; i < x.size(); ++i)
	{
		if (dp[x[i].Y])
			continue;
		ll mx = LINF;
		int ind = x[i].Y;
		for (int j = 0; j < i; ++j)
			if (x[j].X >= a[ind].l && dp[j])
				mx = min(mx, dp[j] + a[ind].p);
			else if (x[j].X == a[ind].l - 1 && dp[j])
				mx = min(mx, max(dp[j], (ll)a[ind].p));
		if (mx != LINF)
			dp[x[i].Y] = mx;
	}
	ll ans = LINF;
	for (int i = 0; i < n; ++i)
		if (a[i].r == k && dp[i])
			ans = min(ans, dp[i]);
	cout << (ans == LINF ? -1 : ans);
}