#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <bitset>
#include <map>

using namespace std;

typedef long long ll;

#define X first
#define Y second
#define pii pair<int, int> 
#define mp make_pair
#define inb push_back
#define LINF 2e18

struct pt
{
	int l, r, p;
};

const int M = 100005;
pt a[M];
int n, k;
ll dp[M];
map<int, int> z;

void solve1()
{
	vector<pii> x;
	for (int i = 0; i < n; ++i)
		x.inb(mp(a[i].r, i));
	for (int i = 0; i < n; ++i)
		if (a[i].l == 1)
			z[a[i].r] = 1;
	sort(x.begin(), x.end());
	for (int i = 0; i < x.size(); ++i)
	{
		if (i && a[x[i].Y].l - 1 > x[i - 1].X)
			cout << -1, exit(0);
		if (z.find(a[x[i].Y].l - 1) != z.end())
			z[x[i].X] = 1;
	}
	if (!z[k])
	{
		if (x.back().X == k)
			z[k] = 2;
		else
			z[k] = -1;
	}
	cout << z[k];
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &k);
	int mx = 1;
	for (int i = 0; i < n; ++i)
		scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p), mx = max(mx, a[i].p);
	if (mx == 1)
		solve1();
	ll ans = LINF;
	for (int i = 1; i < (1 << n); ++i)
	{
		vector<pair<int, pii> > x;
		for (int j = 0; j < n; ++j)
			if (i & (1 << j))
				x.inb(mp(a[j].l, mp(-1, j))), x.inb(mp(a[j].r, mp(1, j)));
		sort(x.begin(), x.end());
		int bal = 0, r = 0;
		for (int i = 0; i < x.size(); ++i)
		{
			bal += x[i].Y.X;
			if (!bal && !(i < x.size() - 1 && x[i + 1].X == x[i].X + 1 || i == x.size() - 1))
				r = 1;
		}
		if (!r && x.back().X == k && x[0].X == 1)
		{
			ll mx = 0;
			ll sum = 0;
			for (int i = 0; i < x.size(); ++i)
			{
				if (x[i].Y.X == -1)
					sum += a[x[i].Y.Y].p;
				else
					sum -= a[x[i].Y.Y].p;
				mx = max(mx, sum);
			}
			ans = min(ans, mx);
		}
	}
	cout << (ans == LINF ? -1 : ans);
}