#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)
#define fi first
#define se second
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef pair <int,int> pii;

template <typename T>
inline istream &operator >> (istream &in, vector <T> &v) {
    for(auto &it: v)
        in >> it;
    return in;
}

template <typename T>
inline ostream &operator << (ostream & out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T>
inline ostream &operator << (ostream & out, const set <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T1, typename T2>
inline ostream & operator << (ostream &out, const pair <T1, T2> &p) {
    out << p.fi << ' ' << p.se << endl;
}

string s;

int amount (char x) {
    int res = 0;
    For(i, 0, sz(s) - 1) {
        if(s[i] == x)
            res++;
    }
    return res;
}

int solve (char a, int coord) {
    int cur = 0;
    if(coord == 0)
        return 0;
    for(int i = 0;i < sz(s); ++i) {
        if(s[i] == a)
            cur++;
        if(cur == coord)
            return i + 1;
    }
    cout << "-1";
    exit(0);
}

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    int n; cin >> n;
    cin >> s;
    int x, y; cin >> x >> y;

    vector <int> result (4);
    if(x < 0) {
        result[2] = 0;
        result[0] = solve('L', abs(x));
    }
    else {
        result[0] = 0;
        result[2] = solve('R', abs(x));
    }

    if(y < 0) {
        result[1] = 0;
        result[3] = solve('D', abs(y));
    }
    else {
        result[3] = 0;
        result[1] = solve('U', abs(y));
    }

    cout << result;
    return 0;
}
