#include <iostream>
#include <vector>
#include <algorithm>

const long long INF = (long long)1e18 + 10;

int main(void) {
	long long n, k;
	scanf("%lld%lld", &n, &k);
	bool fl = true;
	std::vector<std::pair<std::pair<long long, long long>, long long>> a;
	for (long long i = 0; i < n; ++i) {
		long long l, r, p;
		scanf("%lld%lld%lld", &l, &r, &p);
		a.push_back({{l, r}, p});
		if (p != 1) {
			fl = false;
		}
	}
	std::sort(a.begin(), a.end());
	if (n <= 10) {
		long long answer = INF;
		for (long long mask = 0; mask < (1 << n); ++mask) {
			std::vector<std::pair<std::pair<long long, long long>, long long>> cur;
			for (long long i = 0; i < n; ++i) {
				if ((mask >> i) & 1) {
					cur.push_back(a[i]);
				}
			}
			if (cur.empty()) {
				continue;
			}
			if (cur[0].first.first > 1 || cur.back().first.second < k) {
				continue;
			}
			long long sum = cur[0].second;
			bool lol = true;
			for (long long i = 1; i < cur.size(); ++i) {
				if (cur[i].first.first - 1 > cur[i - 1].first.second) {
					lol = false;
					break;
				}
				sum += cur[i].second;
			}
			if (!lol) {
				continue;
			}
			answer = std::min(answer, sum);
		}
		if (answer != INF) {
			printf("%lld\n", answer);
		} else {
			printf("-1\n");
		}
	}
	return 0;
}