#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

int main(void) {
	long long n, k;
	scanf("%lld%lld", &n, &k);
	std::vector<std::pair<std::pair<long long, long long>, long long>> a(n);
	std::set<long long> u;
	u.insert(1);
	u.insert(k);
	for (long long i = 0; i < n; ++i) {
		scanf("%lld%lld%lld", &a[i].first.first, &a[i].first.second, &a[i].second);
		u.insert(a[i].first.first);
		u.insert(a[i].first.second);
	}
	std::sort(a.begin(), a.end());
	std::vector<std::pair<std::pair<long long, long long>, long long>> lol;
	int i;
	for (i = 0; i < n; ++i) {
		if (a[i].first.first == 1) {
			if (!lol.empty() && a[i].first.second > lol.back().first.second) {
				lol.pop_back();
			}
			lol.push_back(a[i]);
		} else {
			break;
		}
	}
	for (; i < n; ++i) {
		if (a[i].first.first - 1 <= lol.back().first.second) {
			if (lol.size() == 1) {
				lol.push_back(a[i]);
			} else {
				while (lol.size() >= 2 && a[i].first.first - 1 <= lol[lol.size() - 2].first.second) {
					lol.pop_back();
				}
				lol.push_back(a[i]);
			}
		}
	}
	if (lol.back().first.second < k) {
		printf("-1\n");
		return 0;
	}
	for (int i = 1; i < lol.size(); ++i) {
		if (lol[i].first.first <= lol[i - 1].first.second) {
			printf("2\n");
			return 0;
		}
	}
	printf("1\n");
	return 0;
}