#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

const int N = 100100;
const int M = 3030;
const int INF = 2e9 + 5;

int l[N];
int r[N];
int p[N];

tuple<int, int, int> e[N];

int n, k;

bool a[M][M];
int b[M];

namespace g24 {

    map<int, vector<int>> a;
    map<int, bool> b;

    bool f1(int pos) {
        if (pos > k) return true;
        if (b.count(pos)) return b[pos];
        bool &res = b[pos];
        res = false;
        for (int r : a[pos]) {
            if (f1(r + 1)) return res = true;
        }
        return res;
    }

    bool can1() {
        a.clear();
        b.clear();
        for (int i = 0; i < n; i++) {
            a[l[i]].pb(r[i]);
        }
        return f1(1);
    }
};

bool can2() {
    vector<pair<int, int>> all;
    for (int i = 0; i < n; i++) all.eb(l[i], r[i]);
    sort(all.begin(), all.end());
    int tr = 0;
    for (auto &it : all) {
        if (it.F > tr + 1) return false;
        tr = max(tr, it.S);
    }
    return tr >= k;
}

bool isok(int mx) {
    for (int i = n; i >= 0; i--) {
        b[i] = -1;
        if (r[i] == k) {
            //fill(a[i], a[i] + M, p[i] <= mx);
            if (p[i] <= mx) b[i] = M;
        } else {
            //fill(a[i], a[i] + M, false);

            int num = upper_bound(l, l + n + 2, r[i]) - l;
            int num1 = upper_bound(l, l + n + 2, r[i] + 1) - l;

            for (int j = i + 1; j < num; j++) {
                if (b[j] >= num && p[i] + p[j] <= mx) b[i] = j;
                //a[i][j] = b[j][num] && (p[i] + p[j] <= mx);
            }

            if (p[i] <= mx)
            for (int j = num; j < num1; j++) {
                if (b[j] >= num) b[i] = j;
                //a[i][j] = b[j][num] && (p[i] <= mx);
            }
        }
    }
    return b[0] != -1;
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> k;
    bool group24 = true;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i] >> p[i];
        e[i] = make_tuple(l[i], r[i], p[i]);

        group24 &= p[i] == 1;
    }
    if (!can2()) {
        cout << -1 << endl;
        return 0;
    }
    if (group24 && n > 3000) {
        cout << (g24::can1() ? 1 : 2) << endl;
        return 0;
    }
    assert(n < M);

    e[n + 1] = make_tuple(k + 1, k + 1, 0);
    sort(e, e + n + 2);

    for (int i = 0; i <= n + 1; i++) {
        tie(l[i], r[i], p[i]) = e[i];
    }

    int l = 1;
    int r = INF;
    int ans = -1;
    while (l <= r) {
        int mid = (l + 0ll + r) / 2;
        if (isok(mid)) {
            ans = mid;
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    cout << ans << endl;
    return 0;
}
