#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

const int N = 100100;
const int M = N;
const int INF = 2e9 + 5;

int l[N];
int r[N];
int p[N];

tuple<int, int, int> e[N];

int n, k;

int b[M];

namespace g24 {

    map<int, vector<int>> a;
    map<int, bool> b;

    bool f1(int pos) {
        if (pos > k) return true;
        if (b.count(pos)) return b[pos];
        bool &res = b[pos];
        res = false;
        for (int r : a[pos]) {
            if (f1(r + 1)) return res = true;
        }
        return res;
    }

    bool can1() {
        a.clear();
        b.clear();
        for (int i = 0; i < n; i++) {
            a[l[i]].pb(r[i]);
        }
        return f1(1);
    }
};

bool can2() {
    vector<pair<int, int>> all;
    for (int i = 0; i < n; i++) all.eb(l[i], r[i]);
    sort(all.begin(), all.end());
    int tr = 0;
    for (auto &it : all) {
        if (it.F > tr + 1) return false;
        tr = max(tr, it.S);
    }
    return tr >= k;
}

struct segtree {

    int n;
    vector<int> mx;

    int set(int x, int y) {
        x += n;
        while (x > 0) {
            mx[x] = max(mx[x], y);
            x >>= 1;
        }
    }

    int findnum(int x, int vl) {
        if (x >= n) return x - n;
        if (mx[x << 1 | 1] >= vl) return findnum(x << 1 | 1, vl);
        return findnum(x << 1, vl);
    }

    int query(int l, int r, int q) {
        if (l <= r) return -1;
        int ans = -1;
        vector<int> tl, tr;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) tl.pb(l++);
            if (r & 1) tr.pb(--r);
        }
        for (int i : tr) {
            if (mx[i] >= q) return findnum(i, q);
        }
        reverse(tl.begin(), tl.end());
        for (int i : tl) {
            if (mx[i] >= q) return findnum(i, q);
        }
        return -1;
    }

    void clear() {
        mx.assign(2 * n, -1);
    }

    segtree(int n, int df): n(n), mx(2 * n, df) {}
};

const int BLOCK = 330;
const int MCNT = (N / BLOCK) + 1;

struct block {
    vector<pair<int, int>> v;
    vector<int> poses;
    int mpp;
    int n;
    segtree sg;

    void add(int pp, int pos) {
        v.eb(pos, pp);
        mpp = max(mpp, pp);
    }

    void clear() {
        sg.clear();
    }

    void upd(int x, int y) {
        x = lower_bound(poses.begin(), poses.end(), x) - poses.begin();
        //assert()
        sg.set(x, y);
    }

    void init() {
        sort(v.begin(), v.end());
        for (int i = 0; i < v.size(); i++) poses.pb(v[i].F);
        n = v.size();
        sg = segtree(n, -1);

//        cout << "block" << endl;
//        for (auto &it : v) {
//            cout << it.F << " " << it.S << endl;
//        }
//        cout << "end block" << endl;
    }

    int find2(int tp, int l, int r, int bb) {
        for (int i = n - 1; i >= 0; i--) {
            if (v[i].S <= tp && v[i].F >= l && v[i].F < r && sg.mx[n + i] >= bb) return v[i].F;
        }
        return -1;
    }

    int find1(int l, int r, int bb) {
        l = lower_bound(poses.begin(), poses.end(), l) - poses.begin();
        r = lower_bound(poses.begin(), poses.end(), r) - poses.begin();
        int pos = sg.query(l, r, bb);
        if (pos == -1) return -1;
        return poses[pos];
    }

    block(): v(), mpp(-1), poses(), sg(1, 0) {}
};

block abc[MCNT];
int bnum[MCNT];
int bcnt = 0;

bool isok(int mx) {
    segtree sg(M, -1);

    for (int i = 0; i < bcnt; i++) abc[i].clear();

    for (int i = n; i >= 0; i--) {
        b[i] = -1;
        if (r[i] == k) {
            if (p[i] <= mx) b[i] = M;
        } else {

            int num = upper_bound(l, l + n + 2, r[i]) - l;
            int num1 = upper_bound(l, l + n + 2, r[i] + 1) - l;

            if (p[i] <= mx) {
                int tmp = sg.query(num, num1, num);
                if (tmp != -1) {
                    b[i] = tmp;
                    sg.set(i, b[i]);
                    abc[bnum[i]].upd(i, b[i]);
                    continue;
                }
            }

            int mpp = mx - p[i];
            int lb = bcnt - 1;
            for (int j = 0; j < bcnt; j++) {
                if (abc[j].mpp > mpp) {
                    lb = j;
                    break;
                }
            }

//            cout << "abc " << mpp << " " << lb << endl;

            b[i] = abc[lb].find2(mpp, i + 1, num, num);
            for (int j = lb - 1; j >= 0 && b[i] == -1; j--) {
                b[i] = abc[j].find1(i + 1, num, num);
            }

//            for (int j = i + 1; j < num; j++) {
//                if (b[j] >= num && p[j] <= mx - p[i]) b[i] = j;
//            }
        }
        sg.set(i, b[i]);
        abc[bnum[i]].upd(i, b[i]);
    }
    return b[0] != -1;
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> k;
    bool group24 = true;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i] >> p[i];
        e[i] = make_tuple(l[i], r[i], p[i]);

        group24 &= p[i] == 1;
    }
    if (!can2()) {
        cout << -1 << endl;
        return 0;
    }
    if (group24 && n > 3000) {
        cout << (g24::can1() ? 1 : 2) << endl;
        return 0;
    }
    assert(n < M);

    e[n + 1] = make_tuple(k + 1, k + 1, 0);
    sort(e, e + n + 2);

    for (int i = 0; i <= n + 1; i++) {
        tie(l[i], r[i], p[i]) = e[i];
//        cout << i << ": " << l[i] << " " << r[i] << " " << p[i] << endl;
    }

{
    vector<pair<int, int>> w;
    for (int i = 0; i <= n + 1; i++) w.eb(p[i], i);
    sort(w.begin(), w.end());

    for (int i = 0; i < w.size(); i += BLOCK) {
        for (int j = i; j < w.size() && j < i + BLOCK; j++) {
            abc[bcnt].add(w[j].F, w[j].S);
            bnum[w[j].S] = bcnt;
        }
        abc[bcnt].init();
        bcnt++;
    }
}

    int l = 1;
    int r = INF;
    int ans = -1;
    while (l <= r) {
        int mid = (l + 0ll + r) / 2;
        if (isok(mid)) {
            ans = mid;
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    cout << ans << endl;
    return 0;
}
