#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

struct db {
    long long x, y;

    db(): x(0), y(1) {}
    db(long long x, long long y): x(x), y(y) {}
};

db query(long long t) {
    cout << "X " << t << endl;
    db res;
    cin >> res.x;
    if (res.x == -1) {
        exit(0);
    }
    cin >> res.y;
    return res;
}

void answer(long long t) {
    cout << "N " << t << endl;
    string s;
    cin >> s;
    if (s == "Wrong") {
        exit(0);
    }
}

const long long INF = 1e18;

long long nok(long long a, long long b) {
    return a / __gcd(a, b) * b;
}

void fixup(long long &x, long long y) {
    if (x % y == 0) return;
    x += y - (x % y);
}

void fixdown(long long &x, long long y) {
    if (x % y == 0) return;
    x -= x % y;
}

bool ispr(int x) {
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        long long l = 2;
        long long r = INF;
        long long ans = 1;
        long long mst = 1;

        vector<int> cc;

        for (int i = 2; i <= 200 && cc.size() < 20; i++) {
            if (ispr(i)) cc.pb(i);
        }
        //cerr << cc.size() << endl;

        for (auto i : cc) {
            db res = query(i);
            mst = nok(mst, res.y);
        }

        answer(mst);

        //fixup(l, mst);
        //fixdown()
//
//        while (l <= r) {
//            long long mid = (l + r) / 2;
//            db res = query(mid);
//            if (res.x != 0) {
//                ans = mid;
//                l = mid + 1;
//                mst = nok(mst, res.y);
//
//                l = max(l, mid * res.x);
//
//                fixup(l, mst);
//                fixdown(r, mst);
//
//            } else {
//                r = mid - 1;
//            }
//        }
//        answer(ans);
    }
    return 0;
}
