#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

struct db {
    long long x, y;

    db(): x(0), y(1) {}
    db(long long x, long long y): x(x), y(y) {}
};

db query(long long t) {
    cout << "X " << t << endl;
    db res;
    cin >> res.x;
    if (res.x == -1) {
        exit(0);
    }
    cin >> res.y;
    return res;
}

void answer(long long t) {
    cout << "N " << t << endl;
    string s;
    cin >> s;
    if (s == "Wrong") {
        exit(0);
    }
}

const long long INF = 1e18;

long long nok(long long a, long long b) {
    return a / __gcd(a, b) * b;
}

void fixup(long long &x, long long y) {
    if (x % y == 0) return;
    x += y - (x % y);
}

void fixdown(long long &x, long long y) {
    if (x % y == 0) return;
    x -= x % y;
}

bool ispr(int x) {
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        long long mst = 1;
        int l = 1;
        int r = 59;

        while (l <= r) {
            int mid = (l + r) / 2;
            db res = query((1ll<<mid));
            if (res.x == 0) {
                r = mid - 1;
                continue;
            }
            mst = nok(mst, res.y);
            l = mid + 1;
        }
        cout << mst << endl;
    }
    return 0;
}
