#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <string>
#include <initializer_list>
#include <cassert>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;

int const INF = 1e9 + 7;
ll const LLINF = 1e18 + 19;
int const mod = 1e9 + 9;
int const ph = 257;
ld const eps = 1e-8;

bool operator == (par a, par b) {
	return a.first == b.first && a.second == b.second;
}
bool operator != (par a, par b) {
	return a.first != b.first || a.second != b.second;
}
par operator + (par a, par b) {
	return{ a.first + b.first, a.second + b.second };
}
par operator - (par a, par b) {
	return{ a.first - b.first, a.second - b.second };
}

namespace std {
	using std::hash;
	using std::size_t;
	template <>
	struct hash<par> {
		size_t operator ()(par const& a) const {
			return (1LL * hash<int>()(a.first) * ph + hash<int>()(a.second)) % mod;
		}
	};
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	int ans = 1;
	int prev = -INF;
	int pref;
	for (int i = 0; i < n; i++) {
		int q;
		cin >> q;
		if (!i) pref = q;
		if (q <= prev) {
			if (pref > q) pref = q; else pref--;
			if (!pref) {
				ans++;
				pref = q;
			}
		}
		prev = q;
	}
	cout << ans;
	return 0;
}