#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <string>
#include <initializer_list>
#include <cassert>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;

int const INF = 1e9 + 7;
ll const LLINF = 1e18 + 19;
int const mod = 1e9 + 9;
int const ph = 257;
ld const eps = 1e-8;

bool operator == (par a, par b) {
	return a.first == b.first && a.second == b.second;
}
bool operator != (par a, par b) {
	return a.first != b.first || a.second != b.second;
}
par operator + (par a, par b) {
	return{ a.first + b.first, a.second + b.second };
}
par operator - (par a, par b) {
	return{ a.first - b.first, a.second - b.second };
}

namespace std {
	using std::hash;
	using std::size_t;
	template <>
	struct hash<par> {
		size_t operator ()(par const& a) const {
			return (1LL * hash<int>()(a.first) * ph + hash<int>()(a.second)) % mod;
		}
	};
}

int kol[256];
int t[256];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	string s;
	cin >> s;
	int x, y;
	cin >> x >> y;
	for (char i : s) kol[i]++;
	if (x < 0) {
		x *= -1;
		if (kol['L'] < x) {
			cout << -1;
			return 0;
		}
		else {
			if (x) {
				kol['L'] = kol['R'] = kol['U'] = kol['D'] = 0;

				for (int i = 0; i < n; i++) {
					kol[s[i]]++;
					if (kol[s[i]] == x) {
						t['L'] = i + 1;
						break;
					}
				}
			}
			else t['L'] = 0;
		}
	}
	else if (x > 0) {
		if (kol['R'] < x) {
			cout << -1;
			return 0;
		}
		else {

			kol['L'] = kol['R'] = kol['U'] = kol['D'] = 0;
			for (int i = 0; i < n; i++) {
				kol[s[i]]++;
				if (kol[s[i]] == x) {
					t['R'] = i + 1;
					break;
				}
			}
		}
	}
	if (y < 0) {
		y *= -1;
		if (kol['U'] < y) {
			cout << -1;
			return 0;
		}
		else {

			kol['L'] = kol['R'] = kol['U'] = kol['D'] = 0;
			for (int i = 0; i < n; i++) {
				kol[s[i]]++;
				if (kol[s[i]] == y) {
					t['U'] = i + 1;
					break;
				}
			}
		}
	}
	else if (y > 0) {
		if (kol['D'] < y) {
			cout << -1;
			return 0;
		}
		else {

			kol['L'] = kol['R'] = kol['U'] = kol['D'] = 0;
			for (int i = 0; i < n; i++) {
				kol[s[i]]++;
				if (kol[s[i]] == y) {
					t['D'] = i + 1;
					break;
				}
			}
		}
	}
	cout << t['L'] << " " << t['U'] << " " << t['R'] << " " << t['D'];
	return 0;
}