#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)2e5 + 7;

int A[dd], l[dd];

int solve() {
	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; ++i)
		scanf("%d", &l[i]);

	int L = 0, R = n;

	while (R - L > 1) {

		int M = (R + L) / 2;

		for (int i = 0; i < l[0]; ++i)
			A[i] = 1;

		for (int ii = 1; ii < n; ++ii) {
			if (l[ii] > l[ii - 1]) {
				for (int i = l[ii - 1]; i < l[ii]; ++i)
					A[i] = 1;
			} else {
				int mn = (int)1e9;
				for (int i = 0; i < l[ii]; ++i)
					if (A[i] != M) mn = A[i];

				if (mn == (int)1e9) {
					L = M;
					break;
				}

				for (int i = l[ii] - 1; i >= 0; --i) if (A[i] == mn) {
					A[i]++;
					
					for (int j = i + 1; j < l[ii]; ++j)
						A[j] = 1;
					break;
				}
			}

		}

		if (L != M) R = M;

	}
	printf("%d", R);
	return 0;
}
