#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)3e3 + 7;
const int inf = (int)2e9 + 7;

struct st {
	int l, r, p;
} A[dd];

int dp[dd][dd], F[4 * dd], iF;

void uin(int &a, int b) {
	if (a > b) a = b;
}

int solve() {
	int n, k;
	scanf("%d %d", &n, &k);
	for (int i = 0; i < n; ++i)
		scanf("%d %d %d", &A[i].l, &A[i].r, &A[i].p);
	A[n++] = { 0, 0, 0 };
	A[n++] = { k + 1, k + 1, 0 };

	for (int i = 0; i < n; ++i) {
		F[iF++] = A[i].l, F[iF++] = A[i].r;
		F[iF++] = A[i].l - 1, F[iF++] = A[i].r + 1;
	}
	
	sort(F, F + iF);
	iF = unique(F, F + iF) - F;

	for (int i = 0; i < n; ++i)
		A[i].l = lower_bound(F, F + iF, A[i].l) - F, A[i].r = lower_bound(F, F + iF, A[i].r) - F;

	sort(A, A + n, [](st a, st b) {
		return a.r < b.r;
	});
	
	for (int i = 0; i < n; ++i)
		fill(dp[i], dp[i] + dd, inf);
	
	dp[0][1] = 0;
	for (int i = 1; i < n; ++i) {
		int j = 0, cur = inf;
		for (int k = A[i].l - 1; k <= A[i].r; ++k) {
			while (A[j].r < k) ++j;
			while (A[j].r == k) {
				uin(cur, max(dp[j][A[i].l - 1], k == A[i].l - 1 ? A[i].p : A[i].p + A[j].p));
				++j;
			}
			dp[i][k] = cur;
		}
	}
	printf("%d", dp[n - 1][A[n - 1].r] == inf ? -1 : dp[n - 1][A[n - 1].r]);
	return 0;
}
