#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)3e3 + 7;
const int inf = (int)2e9 + 7;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

ll pt[dd];

int solve() {
	srand(3425345);
	for (int i = 2; i < 101; ++i)
		pt[i - 2] = i;

	int g;
	cin >> g;
	while (g--) {
		ll ans = 1;
		random_shuffle(pt, pt + 99);
		for (int i = 0; i < 30; ++i) {
			cout << "X " << pt[i] << endl;
			ll a, b;
			cin >> a >> b;
			if (a == -1) return 0;
			ans = ans / gcd(ans, b) * b;
		}
		cout << "N " << ans << endl;
		string s;
		cin >> s;
		if (s[0] == 'W')
			return 0;
	}

	return 0;
}
