#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)3e3 + 7;
const int inf = (int)2e9 + 7;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

int pt[dd];

int solve() {
	srand(856745);
	for (int i = 2; i < 1001; ++i)
		pt[i - 2] = i;

	int g, F = inf;
	cin >> g;
	while (g--) {
		F = inf;
		ll ans = 1;
		random_shuffle(pt, pt + 999);
		int cnt = 0;
		for (int i = 0; cnt < 999 && i < 10; ++i, ++cnt) {
			if (pt[cnt] > F) {
				--i;
				continue;
			}
			cout << "X " << pt[cnt] << endl;
			ll a, b;
			cin >> a >> b;
			if (a == 0) F = min(F, pt[cnt]);
			if (a == -1) return 0;
			ans = ans / gcd(ans, b) * b;
		}
		cout << "N " << ans << endl;
		string s;
		cin >> s;
		if (s[0] == 'W')
			return 0;
	}

	return 0;
}
