#include <iostream>
#include <vector>
#include <stdio.h>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long int64;

const int64 MAXINT = (int64)1e18;

int64 toint(const string &s) {
	int64 res = 0;
	for (int i = 0; i < s.size(); i++) {
		res *= 10;
		res += (s[i] - '0');
	}
	return res;
}

int ask(int64 m) {
	cout << "X " << m << "\n";
	cout.flush();
	int64 a, b;
	string buf;
	cin >> buf;
	if (buf == "Wrong" || buf == "-1") {
		return -1;
	}
	a = toint(buf);
	cin >> b;
	if (a == 0) {
		return 0;
	}
	return true;
}

void solve() {
	int g, tmp;
	cin >> g;
	string buf;
	for (int it = 0; it < g; it++) {
		int64 left = 0, right = MAXINT + 1, mid;
		while (right - left > 1) {
			mid = (right + left) / 2;
			tmp = ask(mid);
			if (tmp == -1) {
				return;
			}
			if (tmp) {
				left = mid;
			}
			else {
				right = mid;
			}
		}
		cout << "N " << left << "\n";
		cout.flush();
		cin >> buf;
		if (buf == "Wrong" || buf == "-1") {
			return;
		}
	}
	//cout << "";
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
    return 0;
}

