#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair <int, int>
#define pll pair <long long, long long>
#define pld pair <long double, long double>
#define pb push_back
#define ff first
#define ss second

int n;
int maxl = 5005;
vector <long long> arr;

bool check(long long val)
{
    vector <long long> stat(maxl, 1);
    for(int i = 1; i < n; i++)
    {
        if(arr[i - 1] < arr[i])
            continue;
        for(int j = arr[i] + 1; j < maxl; j++)
            stat[j] = 1;
        int now = arr[i];
        while(true)
        {
            if(now < 1) return false;
            stat[now]++;
            if(stat[now] > val)
            {
                stat[now] = 1;
                now--;
            }
            else
                break;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);

    cin >> n;
    arr.resize(n);
    for(int i = 0; i < n; i++)
        cin >> arr[i];

    long long l = 0, r = n;
    while(r > l + 1)
    {
        long long m = (l + r) / 2;
        if(check(m))
            r = m;
        else
            l = m;
    }
    cout << r;
    return 0;
}
