#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair <int, int>
#define pll pair <long long, long long>
#define pld pair <long double, long double>
#define pb push_back
#define ff first
#define ss second

string s;
vector < pair <char, int> > hor, ver;
vector <int> movel, mover, moved, moveu;

int main()
{
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    cin >> s;
    int x, y;
    cin >> x >> y;

    //go
    hor.push_back({'0', 0});
    ver.push_back({'0', 0});
    for(int i = 0; i < n; i++)
    {
        if(s[i] == 'L' or s[i] == 'R') hor.push_back({s[i], i + 1});
        else ver.push_back({s[i], i + 1});
    }

    //solve for horizontal
    int brl = n + 1, brr = n + 1;
    bool reachedx = false;
    movel.push_back(0);
    mover.push_back(0);
    for(int i = hor.size() - 1; i > 0; i--)
    {
        if(hor[i].first == 'L')
        {
            movel.push_back(movel.back() + 1);
            mover.push_back(mover.back());
        }
        else
        {
            mover.push_back(mover.back() + 1);
            movel.push_back(movel.back());
        }
    }
    reverse(movel.begin(), movel.end());
    reverse(mover.begin(), mover.end());

    int xcor = 0;
    for(int i = 0; i < hor.size(); i++)
    {
        if(brl > hor[i].second && xcor <= x && xcor + mover[i] >= x)
        {
            brl = hor[i].second;
            for(int j = i; j < hor.size(); j++)
            {
                xcor += (hor[j].first == 'R');
                if(xcor == x)
                {
                    brr = hor[j].second;
                    break;
                }
            }
            reachedx = true;
            break;
        }
        if(brr > hor[i].second && xcor >= x && xcor - movel[i] <= x)
        {
            brr = hor[i].second;
            for(int j = i; j < hor.size(); j++)
            {
                xcor -= (hor[j].first == 'L');
                if(xcor == x)
                {
                    brl = hor[j].second;
                    break;
                }
            }
            reachedx = true;
            break;
        }

        //move
        if(hor[i].first == 'L') xcor--;
        else if(hor[i].first == 'R') xcor++;
    }
    if(!reachedx)
    {
        cout << -1;
        return 0;
    }


    //solve for vertical
    int brd = n, bru = n;
    bool reachedy = false;
    moved.push_back(0);
    moveu.push_back(0);
    for(int i = ver.size() - 1; i > 0; i--)
    {
        if(ver[i].first == 'D')
        {
            moved.push_back(moved.back() + 1);
            moveu.push_back(moveu.back());
        }
        else
        {
            moveu.push_back(moveu.back() + 1);
            moved.push_back(moved.back());
        }
    }
    reverse(moved.begin(), moved.end());
    reverse(moveu.begin(), moveu.end());

    int ycor = 0;
    for(int i = 0; i < ver.size(); i++)
    {
        if(brd > ver[i].second && ycor <= y && ycor + moveu[i] >= y)
        {
            brd = ver[i].second;
            for(int j = i; j < ver.size(); j++)
            {
                ycor += (ver[j].first == 'U');
                if(ycor == y)
                {
                    bru = ver[j].second;
                    break;
                }
            }
            reachedy = true;
            break;
        }
        if(bru > ver[i].second && ycor >= y && ycor - moved[i] <= y)
        {
            bru = ver[i].second;
            for(int j = i; j < ver.size(); j++)
            {
                ycor -= (ver[j].first == 'D');
                if(ycor == y)
                {
                    brd = ver[j].second;
                    break;
                }
            }
            reachedy = true;
            break;
        }

        //move
        if(ver[i].first == 'D') ycor--;
        else if(ver[i].first == 'U') ycor++;
    }
    if(!reachedy)
    {
        cout << -1;
        return 0;
    }

    cout << brl << " " << bru << " " << brr << " " << brd << endl;
    return 0;
}
