#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair <int, int>
#define pll pair <long long, long long>
#define pld pair <long double, long double>
#define pb push_back
#define ff first
#define ss second
#define ppiii pair < pair <long long, long long> , long long>

int n, k;
vector <ppiii> segm, segm2;

const long long INF = 100000000000000;

void go(long long val)
{
    cout << val;
    exit(0);
}

void solve1()
{
    map <long long, long long> start;
    sort(segm.begin(), segm.end());
    for(int i = n - 1; i >= 0; i--)
    {
        //cout << "Now seg: " << segm[i].first.first << " " << segm[i].first.second << endl;
        start[segm[i].first.first] = max(start[segm[i].first.first], max(start[segm[i].first.second + 1], segm[i].first.second));
    }
    if(start[1] >= k)
    {
        go(1);
    }

    //check pos 2
    if(segm[0].first.first > 1)
    {
        go(-1);
    }
    long long theend = segm[0].first.second;
    for(int i = 1; i < n; i++)
    {
        if(segm[i].first.first <= theend + 1)
        {
            theend = max(theend, segm[i].first.second);
        }
    }
    if(theend >= k)
    {
        go(2);
    }
    else
    {
        go(-1);
    }
}


bool check(long long val)
{
    set < pair <long long, pair <long long, pair <long long, long long > > > > posbef;
    for(int i = 0; i < segm2.size(); i++)
    {
        //cout << "nowsegm: " << segm2[i].first.second << " " << segm2[i].first.first << endl;
        while(!posbef.empty() && ((*posbef.begin()).first < segm2[i].first.second - 1 or (*posbef.begin()).second.second.second >= segm2[i].first.second - 1))
            posbef.erase(posbef.begin());
        if(segm2[i].first.second == 1)
        {
            if(segm2[i].second <= val)
               posbef.insert({segm2[i].first.first, {segm2[i].second, {segm2[i].second, -1}}});
        }
        else
        {
            for(auto j: posbef)
            {
                long long now = j.second.second.first;
                //cout << "on this " << j.first << " " << segm2[i].first.second << endl;
                if(j.first >= segm2[i].first.second)
                    now = max(now, segm2[i].second + j.second.first);
                //cout << "checking now: " << now << endl;
                //cout << now << " " << val << endl;
                if(now <= val)
                {
                    posbef.insert({segm2[i].first.first, {segm2[i].second, {now, j.first}}});
                    break;
                }
            }
        }
        //cout << "nowposs: " << posbef.size() << endl;
    }
    /*cout << "Posbef: " << endl;
    for(auto j: posbef)
        cout << j.first << " ";
    cout << endl;*/

    auto it = posbef.lower_bound({k, {0, {0, 0}}});
    if(it == posbef.end())
        return false;
    else
        return true;

}

void cleversolve()
{
    sort(segm2.begin(), segm2.end());
    long long l = 0, r = INF;
    while(r > l + 1)
    {
        long long m = (l + r) / 2;
        if(check(m))
            r = m;
        else
            l = m;
    }
    if(r == INF)
        go(-1);
    else
        go(r);
    //cout << check(1);
}

int main()
{
    cin >> n >> k;
    segm.resize(n);
    segm2.resize(n);
    for(int i = 0; i < n; i++)
    {
        cin >> segm[i].first.first >> segm[i].first.second >> segm[i].second;
        segm2[i] = segm[i];
        swap(segm2[i].first.first, segm2[i].first.second);
    }

    //go
    cleversolve();

    return 0;
}
