#define _CRT_SECURE_NO_WARNINGS
#define make_pair mp
#define push_back pb
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstdio>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
vector < vector < pair < int, ll > > > gr;
vector < bool > used;
vector < pair < pair < int, int >, ll > > vec;
int n, k;
void dfs(int v, ll can) {
	used[v] = true;
	for (pair < int, ll >  to : gr[v]) {
		if (used[to.first] || to.second > can)
			continue;
		dfs(to.first, can);
	}
}
bool check(int x) {
	used.assign(n + 2, false);
	dfs(0, x);
	return used[n+1];
}
int main() {
	cin >> n >> k;
	vec.resize(n+1);
	for (int i = 1; i <= n; i++) {
		cin >> vec[i].first.first >> vec[i].first.second >> vec[i].second;
	}
	gr.resize(n + 2);
	for (int i = 1; i <= n; i++) {
		if (vec[i].first.first == 1)
			gr[0].pb(mp(i, vec[i].second));
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (j == i)
				continue;
			if (vec[i].first.first <= vec[j].first.first) {
				if (vec[i].first.second == vec[j].first.first - 1) {
					gr[i].pb(mp(j, vec[i].second));
				}
				if (vec[i].first.second >= vec[j].first.first)
					gr[i].pb(mp(j, vec[j].second + vec[i].second));
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		if (vec[i].first.second == k) {
			gr[i].pb(mp(n+1, vec[i].second));
		}
	}
	ll l = 1, r = 2e9;
	ll ans = -1;
	while (l <= r) {
		ll m = (l + r) / 2ll;
		if (check(m)) {
			ans = m;
			r = m - 1ll;
		}
		else
			l = m + 1ll;
	}
	cout << ans << endl;
}