#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define fs first
#define sc second
#define pb push_back
#define pob pop_back
#define double long double
#define mp make_pair
#define sz(a) ((int) a.size())
#define forn(i, j, n) for (int i = j; i < n; ++i)
#define forc(i, n, j) for (int i = n - 1; i >= j; --i)
//#define endl "\n"
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <double, double> pdd;
typedef pair <bool, bool> pbb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vpii;
typedef vector <vpii> vvpii;
typedef vector <double> vd;
typedef vector <bool> vb;
typedef vector <vd> vvd;
typedef vector <vb> vvb;
const int MAX = 1e5 + 5;
int n, mass1[MAX], mass2[MAX];
pii t[4 * MAX];
inline pii combine(pii a, pii b)
{
    if (a.fs > b.fs) return a;
    if (a.fs < b.fs) return b;
    return mp(a.fs, max(a.sc, b.sc));
}

void build(int v, int tl, int tr)
{
    if (tl == tr) {t[v] = mp(mass2[tl], tl);}
    else
    {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = combine(t[v * 2], t[v * 2 + 1]);
    }
}

pii get(int v, int tl, int tr, int l, int r)
{
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) / 2;
    if (r <= tm) return get(v * 2, tl, tm, l, r);
    if (l >= tm + 1) return get(v * 2 + 1, tm + 1, tr, l, r);
    return combine(get(v * 2, tl, tm, l, tm), get(v * 2 + 1, tm + 1, tr, tm + 1, r));
}

int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    pii arr[n];
    int p;
    forn(i, 0, n) cin >> arr[i].fs >> arr[i].sc >> p;
    sort(arr, arr + n);
    forn(i, 0, n) mass1[i] = arr[i].fs;
    forn(i, 0, n) mass2[i] = arr[i].sc;
    build(1, 0, n - 1);
    int pos = 1;
    vpii mass;
    while (true)
    {
        int ind = upper_bound(mass1, mass1 + n, pos) - mass1;
        --ind;
        if (ind == -1) {cout << -1; return 0;}
        pii maxx = get(1, 0, n - 1, 0, ind);
       // cout << maxx.fs << " " << maxx.sc << endl;
        if (maxx.fs <= pos) {cout << -1; return 0;}
        pos = maxx.fs;
        mass.pb(mp(mass1[maxx.sc], 1));
        mass.pb(mp(maxx.fs, 0));
        if (pos == n) break;
    }
    sort(mass.begin(), mass.end());
    int cnt = 0, maxx = 0;
    forn(i, 0, sz(mass))
    {
        int s = mass[i].sc;
        if (s == 0) {--cnt;}
        else {++cnt;}
        maxx = max(maxx, cnt);
    }
    cout << maxx << endl;
    return 0;
}
