#include <iostream>
#include <vector>


using namespace std;


const int V = 1e4;


bool inc(vector<int> & me, int b, int ws)
{
	int i = ws - 1;
	while (i >= 0 && me[i] == b)
	{
		me[i] = 1;
		i -= 1;
	}
	if (i == -1)
	{
		return 0;
	}
	else
	{
		me[i]++;
		return 1;
	}
}



bool check(vector<int> const& fund, int b)
{
	vector<int> me(V, 0);
	int workspace = 0;
	for (auto i : fund)
	{
		if (i > workspace)
		{
			while (workspace < i)
			{
				me[workspace++] = 1;
			}
		}
		else
		{
			workspace = i;
			if (!inc(me, b, workspace)) return 0;
		}
		//for (int w = 0; w < workspace; w++) cout << me[w] << ' '; cout << endl;
	}
	return 1;
}


int main()
{
	int n;
	cin >> n;
	vector<int> fund(n);
	for (int i = 0; i < n; i++)
	{
		cin >> fund[i];
	}
	int l = 0;
	int r = 1e9 + 7;
	while (r - l > 1)
	{
		int m = l + (r - l) / 2;
		//cerr << "CHECK: " << m << endl;
		if (check(fund, m))
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}
	cout << r << endl;
}