#include <iostream>
#include <vector>
#include <set>
#include <map>


using namespace std;


const long long INF = 1ll << 60;


long long check(int mask, int k, vector<vector<int>> const& e)
{
	//cerr << mask << endl;
	int i = 0;
	multiset<vector<int>> s;
	while (mask > 0)
	{
		if (mask % 2)
		{
			s.insert({e[i][0]    , -1, e[i][2]});
			s.insert({e[i][1] + 1,  1, e[i][2]});
		}
		i++;
		mask >>= 1;
	}
	if (s.begin()->at(0) != 1 || s.rbegin()->at(0) != k + 1)
	{
		return INF;
	}
	//cerr << "KEK" << mask << endl;
	long long ans = 0;
	long long b = 0;
	int c = 0;
	int prev = -1;
	for (auto i : s)
	{
		//cerr << "C: " << i[0] << ' ' << i[1] << ' ' << i[2] << endl;
		if (i[0] != prev)
		{
			prev = i[0];
			ans = max(ans, b);
		}
		if (i[1] == -1)
		{
			b += i[2];
		}
		else
		{
			b -= i[2];
			c += (b == 0);
		}
	}
	//cerr << endl;
	return (c > 1 ? INF : ans);
}


void stupid(int n, int m)
{
	vector<vector<int>> e;
	for (int i = 0; i < n; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		e.push_back({a, b, c});
	}
	long long a = INF;
	for (int mask = 1; mask < (1 << n); mask++)
	{
		a = min(a, check(mask, m, e));
	}
	cout << (a == INF ? -1 : a) << endl;
}


struct Node
{
	vector<int> go;
	bool vis = 0;
	Node() {};
};

map<int, Node> g;


void dfs(int v = 1)
{
	//cerr << "V: " << v << endl;
	g[v].vis = 1;
	for (auto i : g[v].go)
	{
		if (!g[i].vis)
		{
			dfs(i);
		}
	}
}



int main()
{
	int n, m;
	cin >> n >> m;
	if (n <= 10)
		stupid(n, m);
	multiset<vector<int>> s;
	for (int i = 0; i < n; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		g[a].go.push_back(b + 1);
		s.insert({a, 1});
		s.insert({b + 1, -1});
	}
	if (s.begin()->at(0) != 1 || s.rbegin()->at(0) != m + 1)
	{
		cout << -1 << endl;
		return 0;
	}
	int bal = 0;
	int prev = 1;
	for (auto i : s)
	{
		//cerr << i[0] << ' ' << i[1] << endl;
		if (i[0] != prev && bal == 0)
		{
			cout << -1 << endl;
			return 0;
		}
		prev = i[0];
		bal += i[1];
	}
	dfs(1);
	cout << (g[m + 1].vis ? 1 : 2) << endl;
}