#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 100, inf = 1e9 + 100;

int n;

int a[maxn];

int b[maxn];

int k;

int q[4 * (maxn + 100)];

void build(int v, int l, int r){
    q[v] = 0;
    if (l == r)
        return;
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
}

void push(int v, int l, int r){
    if (!q[v])
        return;
    if (l == r){
        b[l] = 0;
        return;
    }
    q[2 * v] = 1;
    q[2 * v + 1] = 1;
}

void update(int v, int tl, int tr, int l, int r){
    push(v, tl, tr);
    if (l > r)
        return;
    if (tl == l && tr == r){
        q[v] = 1;
        push(v, tl, tr);
        return;
    }
    int m = (tl + tr) / 2;
    update(2 * v, tl, m, l, min(r, m));
    update(2 * v + 1, m + 1, tr, max(l, m + 1), r);
}

void get(int v, int l, int r, int id){
    push(v, l, r);
    if (l == r)
        return;
    int m = (l + r) / 2;
    if (id <= m)
        get(2 * v, l, m, id);
    get(2 * v + 1, m + 1, r, id);
}

bool add(int i){
    while (i >= 0){
        get(1, 0, maxn - 1, i);
        b[i]++;
        if (b[i] != k)
            return 1;
        b[i] = 0;
        i--;
    }
    return 0;
}

bool check(int val1){
    k = val1;
    for (int i = 0; i < maxn; i++)
        b[i] = 0;
    for (int i = 1; i < n; i++)
        if (a[i] <= a[i - 1]){
            update(1, 0, maxn - 1, a[i] + 1, min(maxn - 1, a[i - 1]));
            if (!add(min(maxn, a[i]) - 1))
                return 0;
        }
    return 1;
}

int main()
{
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin >> n;
    bool ez = 1;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        if (i > 0 && a[i] <= a[i - 1])
            ez = 0;
    }
    if (ez){
        cout << 1;
        return 0;
    }
    int l = 1, r = n;
    while (r - l > 1){
        int m = (l + r) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    cout << r;
}
