#include <bits/stdc++.h>

using namespace std;

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    string s;
    cin >> s;

    vector<int> l(n + 1, 0), u(n + 1, 0), r(n + 1, 0), d(n + 1, 0);

    for (int i = n - 1; i > -1; --i)
    {
        if (s[i] == 'L') l[i] = l[i + 1] + 1;
        else l[i] = l[i + 1];
        if (s[i] == 'U') u[i] = u[i + 1] + 1;
        else u[i] = u[i + 1];
        if (s[i] == 'R') r[i] = r[i + 1] + 1;
        else r[i] = r[i + 1];
        if (s[i] == 'D') d[i] = d[i + 1] + 1;
        else d[i] = d[i + 1];
    }

    vector<int> h(n + 1, 0);
    for (int i = 0; i < n; ++i)
        if (s[i] == 'L') h[i] = -1;
        else if (s[i] == 'R') h[i] = +1;

    vector<int> v(n + 1, 0);
    for (int i = 0; i < n; ++i)
        if (s[i] == 'D') v[i] = -1;
        else if (s[i] == 'U') v[i] = +1;

    int xf, yf;
    cin >> xf >> yf;

    vector<int> ans(4, -1);

    int x = 0;
    x += h[0];
    for (int i = 0; i < n + 1; ++i)
    {
        if (x == xf)
        {
            ans[0] = i;
            ans[2] = i;
            break;
        }
        else if (x + r[i] == xf)
        {
            ans[0] = i;
            ans[2] = n;
            break;
        }
        else if (x - l[i] == xf)
        {
            ans[0] = n;
            ans[2] = i;
            break;
        }
        x += h[i];
    }

    int y = 0;
    for (int i = 0; i < n + 1; ++i)
    {
        if (y == yf)
        {
            ans[1] = i;
            ans[3] = i;
            break;
        }
        else if (y + u[i] == yf)
        {
            ans[1] = i;
            ans[3] = n;
            break;
        }
        else if (y - d[i] == yf)
        {
            ans[1] = n;
            ans[3] = i;
            break;
        }
        y += v[i];
    }

    for (int i : ans)
        if (i == -1)
        {
            cout << "-1";
            exit(0);
        }

    for (int i : ans)
        cout << i << " ";

    return 0;
}
