#include <bits/stdc++.h>
#define pb push_back
#define x first
#define y second
#define mp make_pair
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
 
using namespace std;

const string FILENAME = "input";

typedef pair <int, int> point;
typedef long long base;

const int MAXN = 1 << 18;

int n, k;
vector <pair <point, int>> arr;

bool check(int M) {
	vector <pair <int, point>> res;
	res.pb(mp(0, mp(0, 0)));
	for (int i = 0; i < n; ++i) {
		if (arr[i].y > M) continue;
		int L = -1;
		for (int q = res.size(); q--;) {
			auto j = res[q];
			if (j.y.y + 1 == arr[i].x.x) {
				L = arr[i].x.x - 1;
				break;
			} else if (j.y.y >= arr[i].x.x) {
				if (j.y.x < arr[i].x.x && j.x + arr[i].y <= M) {
					if (L == -1 || L > j.y.y) {
						L = j.y.y;
					}
				}
			} else {
				break;
			}
		}
		if (L != -1) {
			res.pb({arr[i].y, {L, arr[i].x.y}});
			if (arr[i].x.y == k) {
				return true;
			}
		}
	}
	return false;
}

bool cmp(pair <point, int> a, pair <point, int> b) {
	return a.x.y < b.x.y;
}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n >> k;
	arr.resize(n);
	int p = 0;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i].x.x >> arr[i].x.y >> arr[i].y;
		p = max(p, arr[i].y);
	}
	if (p == 1) {
		set <int> ans[2];
		ans[0].insert(0);
		ans[1].insert(0);
		sort(arr.begin(), arr.end(), cmp);
		for (auto i: arr) {
			if (ans[0].count(i.x.x - 1)) {
				ans[0].insert(i.x.y);
			} 
			if ((*ans[1].rbegin()) >= (i.x.x - 1)) {
				ans[1].insert(i.x.y);
			}
		}
		if (ans[0].count(k)) {
			cout << 1 << endl;
		} else if (ans[1].count(k)) {
			cout << 2 << endl; 
		} else {
			cout << -1 << endl;
		} 
	} else {
		sort(arr.begin(), arr.end(), cmp);
		int L = 0, R = 2e9 + 1;
		while (R - L > 1) {
			int M = ((long long)R + L) / 2;
			if (check(M)) {
				R = M;
			} else {
				L = M;
			}
		}
		if (L == 2e9) {
			cout << -1 << endl;
 		} else {
 			cout << R << endl;
 		}
	}
} 