#include <bits/stdc++.h>

int INF = 1e6;

using namespace std;

vector<int> nextperm(vector<int> &a, int x, bool &ok)
{
    vector<int> b(a.size(), 0);
    int d = 1;
    for (int i = a.size() - 1; i >= 0; i--)
    {
        int n = a[i] + d;
        if (n >= x)
        {
            d = 1;
            n -= x;
        }
        else
            d = 0;
        b[i] = n;
    }
    if (d != 0)
        ok = 0;
    return b;
}


bool success(vector<int> &a, int x)
{
    bool ok = 1;
    vector<int> c;
    for (int i = 0; i < (int)a.size(); i++)
    {
        if (i == 0)
        {
            c.resize(a[i], 0);
        }
        else
        {
            if (a[i] == a[i - 1])
                c = nextperm(c, x, ok);
            else
            if (a[i] > a[i - 1])
            {
                int d = a[i] - a[i - 1];
                for (int j = 0; j < d; j++)
                    c.push_back(0);
            }
            else
            {
                int d = a[i - 1] - a[i];
                for (int j = 0; j < d; j++)
                    c.pop_back();
                c = nextperm(c, x, ok);
            }
            if (!ok)
                return false;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "rt", stdin);
    ///freopen("output.txt", "wt", stdout);
    int n;
    cin >> n;
    vector<int> len(n);
    for (int i = 0; i < n; i++)
        cin >> len[i];
    int l = 0;
    int r = INF;
    while (r - l > 1)
    {
        int mid = (l + r) / 2;
        if (success(len, mid))
            r = mid;
        else
            l = mid;
    }
    cout << r;
    return 0;
}
