#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss ,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif
#define int ll

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}
template<typename...Ts, typename T>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ",";
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(6);
		srand(300);
	}
	~init() {
		#ifdef LOCAL
		cerr << "Time: " << clock() * 1.0 / CLOCKS_PER_SEC << " s.\n";
		#endif
	}
} init;

const int MAXN = 2e5 + 1;
int a[MAXN];
int num[MAXN];
int zeroaft = 0;
bool inc(int x, int m) {
	for (int i = x; i > 0; --i) {
		++num[i];
		if (num[i] < m) return true;
		else num[i] = 0;
	}
	return ++num[0] < m;
}
bool check(int n, int m) {
	dbg(m);
	memset(num, 0, MAXN * sizeof(int));
	// dbg(0);
	// for (int j = 0; j < 3; ++j) dbg(num[j]);
	for (int i = 1; i < n; ++i) {
		dbg(i, a[i], a[i - 1], a[i] > a[i - 1] );
		if (a[i] > a[i - 1]) {
			num[a[i]] = 0;
		} else {
			if (!inc(a[i], m)) {
				return false;
			}
			for (int j = a[i] + 1; j <= a[i - 1]; ++j) num[j] = 0;
		}
		// dbg(i);
		// for (int j = 0; j < 3; ++j) dbg(num[j]);
	}
	return true;
}

int32_t main() {

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}

	int l = 0, r = n;
	while (r - l > 1) {
		int m = l + r >> 1;
		if (check(n, m)) r = m;
		else l = m;
	}

	cout << r << '\n';


	return 0;
}
