#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss ,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif
// #define int ll

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}
template<typename...Ts, typename T>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ",";
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(6);
		srand(300);
	}
	~init() {
		#ifdef LOCAL
		cerr << "Time: " << clock() * 1.0 / CLOCKS_PER_SEC << " s.\n";
		#endif
	}
} init;

const int MAXN = 1e5 + 1, INF = 1e9 + 7;
int a[MAXN];
int num[MAXN];
int zeroaft = 0;
// bool inc(int x, int m) {
// 	for (int i = x; i > 0; --i) {
// 		if (i > zeroaft) 
// 			num[i] = 0;
// 		++num[i];
// 		if (num[i] < m) return true;
// 		else num[i] = 0;
// 	}
// 	return ++num[0] < m;
// }
std::unordered_map<int, int> coord;
set<int> all;
const int KAL = 15;
int tree[KAL * MAXN];
bool flag[KAL * MAXN * 4];
int sh;
void build(int n) {
	if (n == 1) sh = 1;
	else sh = 1 << 32 - __builtin_clz(n - 1);
}

inline void push(int v, int tl, int tr) {
	flag[v] = false;
	if (tl == tr) 
		tree[v - sh] = 0;
	flag[v + v] = flag[v + v + 1] = true;
}

void upd(int v, int tl, int tr, int l, int r) {
	if (l > tr || r < tl) return;
	if (flag[v]) push(v, tl, tr);
	if (l <= tl && tr <= r) {
		flag[v] = true;
		return;
	} 
	int tm = tl + tr >> 1;
	// if ()
	upd(v + v + 1, tm + 1, tr, l, r);
	
	upd(v + v, tl, tm, l, r);
}

int get(int v, int tl, int tr, int i) {
	if (i < tl || i > tr) return 0;
	if (flag[v]) push(v, tl, tr);
	if (tl == tr) return tree[v - sh];
	int tm = tl + tr >> 1;
	int ans = 0;
	ans += get(v + v, tl, tm, i);
	ans += get(v + v + 1, tm + 1, tr, i);
	return ans;
}

bool inc(int x, int m) {
	for (int i = x; i >= 0; --i) {
		dbg(i);
		dbg(sh);
		int cur = get(1, 0, sh - 1, i);
		dbg(cur);
		++cur;
		if (cur < m) {
			tree[i] = cur;
			return true;
		} else {
			tree[i] = 0;
		}
	}
	return false;
}

bool check(int n, int m) {
	dbg(m);
	memset(tree, 0, KAL * MAXN * sizeof(int));
	memset(flag, 0, KAL * 4 * MAXN * sizeof(bool));
	dbg(m);
	// dbg(0);
	// for (int j = 0; j < 10; ++j) cerr << get(1, 0, sh - 1, j) << ' ';
	// dbg("");
	for (int i = 1; i < n; ++i) {
		dbg(i, a[i], a[i - 1], a[i] > a[i - 1] );
		if (a[i] > a[i - 1]) {
			upd(1, 0, sh - 1, a[i - 1] + 1, a[i]);
			// num[a[i]] = 0;
		} else {
			if (!inc(a[i], m)) {
				return false;
			}
			dbg("inced");
			upd(1, 0, sh - 1, a[i] + 1, a[i - 1]);
			// zeroaft = a[i];
			// for (int j = a[i] + 1; j <= a[i - 1]; ++j) num[j] = 0; <--- remove it!
		}
		// dbg(i);
		// for (int j = 0; j < 10; ++j) cerr << get(1, 0, sh - 1, j) << ' ';
		// dbg("");
	}
	return true;
}

int32_t main() {
	// while (true) {
		int n/* = rand() % 300*/;
		cin >> n;
		dbg(n);
		coord.clear();
		all.clear();
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
			// a[i] = rand() % 300 + 1;
			dbg(a[i]);
			--a[i];
			// dbg(i);
			for (int j = max(0, a[i] - KAL + 1); j <= a[i]; ++j)
				all.insert(j);
		}
		coord.max_load_factor(0.25);
		for (int i : all) {
			int sz = coord.size();
			coord[i] = sz;
		}

		for (int i = 0; i < n; ++i) {
			a[i] = coord[a[i]];
		}
		dbg("compressed");
		build(coord.size());
		dbg("built");
		// return 0;
		int l = 0, r = n;
		while (r - l > 1) {
			int m = l + r >> 1;
			if (check(n, m)) r = m;
			else l = m;
		}

		cout << r << '\n';
	// }

	return 0;
}
