#include <bits/stdc++.h>

using namespace std;

const int mx = 300000, smx = 250000;
int n, a[mx], t[10*mx];

void push(int v) {
    if (t[v] != -1) {
        t[v*2] = t[v];
        t[v*2+1] = t[v];
        t[v] = -1;
    }
}

void update(int l, int r, int color, int v = 1, int tl = 0, int tr = smx) {
    if (l > r)
        return;
    if ((l == tl) && (r == tr))
        t[v] = color;
    else {
        push(v);
        int tm = (tl + tr) / 2;
        update(l, min(r, tm), color, v*2, tl, tm);
        update(max(l, tm+1), tr, color, v*2+1, tm+1, tr);
    }
}

int get(int pos, int v = 1, int tl = 0, int tr = smx) {
    if (tl == tr)
        return t[v];
    push(v);
    int tm = (tl + tr) / 2;
    if (pos <= tm)
        return get(pos, v*2, tl, tm);
    else
        return get(pos, v*2+1, tm+1, tr);
}

bool check(int k) {
    update(0, smx, 0);
    update(0, a[0]-1, 1);
    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i-1]) {
            update(a[i-1], a[i]-1, 1);
        }
        else {
            update(a[i], a[i-1]-1, 0);
            int jj = a[i] - 1;
            while (get(jj) == k) {
                jj--;
                if (jj < 0)
                    return 0;
            }
            int kkk = get(jj);
            update(jj, jj, kkk+1);
            update(jj+1, a[i]-1, 1);
        }
    }
    return 1;
}

int binsearch (int l, int r) {
    if (l == r) return l;
    int m = (l + r) / 2;
    if (check(m)) return binsearch(l, m);
    else return binsearch(m+1, r);
}

int main()
{
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    bool b = 1;
    for (int i = 0; i < (n - 1); ++i) {
        if (a[i] >= a[i+1]) {
            b = 0;
            break;
        }
    }
    if (b == 1) {
        cout << 1 << endl;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = min(a[i], 220000);
    }
    cout << binsearch(1, n) << endl;
    return 0;
}
