#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <ctime>

using namespace std;

typedef long long LL;

int main() {
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n;
  cin >> n;

  string s;
  cin >> s;

  int tx, ty;
  cin >> tx >> ty;

  int cx = 0, cy = 0;

  int X[256], Y[256];

  X['L'] = -1;
  X['R'] = 1;
  X['U'] = X['D'] = 0;

  Y['D'] = -1;
  Y['U'] = 1;
  Y['L'] = Y['R'] = 0;

  int ans[256];

  ans['L'] = 0;
  ans['R'] = 0;
  ans['U'] = 0;
  ans['D'] = 0;

  auto printans = [&]() {
    cout << ans['L'] << ' ' << ans['U'] << ' ' << ans['R'] << ' ' << ans['D'] << '\n';
    exit(0);
  };

  if (cx == tx && cy == ty) printans();

  for (int i = 0; i < s.length(); ++i) {
    if (abs(cx - tx) > abs(cx + X[s[i]] - tx) || abs(cy - ty) > abs(cy + Y[s[i]] - ty)) {
      ans[s[i]] = i + 1;
      cx += X[s[i]];
      cy += Y[s[i]];
    }
    if (cx == tx && cy == ty) printans();
  }

  cout << -1 << endl;
  
  return 0;
}