#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)x.size())
#define endl '\n'

typedef long long llong;

const int INF = 2e9;
const llong LINF = 1e18;

const bool JUDGE = false, STRESS = false;

int cnt_tests = 1;
template<typename T> inline void umax(T &a, T b);
template<typename T> inline void umin(T &a, T b);
void inv(bool exp);

// 300+ and ez win

// Code below

int n;

vector<int> arr;

void inp() {
    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
}

vector<vector<int> > cur;

bool operator < (vector<int> &a, vector<int> &b) {
    for (int i = 0; i < min(sz(a), sz(b)); i++) {
        if (a[i] != b[i])
            return a[i] < b[i];
    }
    return sz(a) < sz(b);
}

void Fill(vector<int> &a, vector<int> &b) {
    for (int i = 0; i < min(sz(a), sz(b)); i++) {
        a[i] = b[i];
    }
}

llong pw(llong base, llong k) {
    llong res = 1ll;
    for (int i = 0; i < k; i++) {
        res *= base;
    }
    return res;
}

void solve() {
    cur.resize(n);
    for (int i = 0; i < n; i++) {
        cur[i].resize(arr[i], 0);
    }
    int ans = 0;
    for (int i = 1; i < n; i++) {
        Fill(cur[i], cur[i - 1]);
        if (cur[i - 1] >= cur[i]) {
            pair<int, int> pos = {INF, 0};
            for (int j = 0; j < sz(cur[i]); j++) {
                if (j >= sz(cur[i - 1])) {
                    pos = {0, -j};
                    break;
                }
                umin(pos, {cur[i - 1][j] + 1, -j});
                if (cur[i][j] > cur[i - 1][j])
                    break;
            }
            cur[i][-pos.se] = pos.fi;
            umax(ans, pos.fi);
            for (int j = -pos.se + 1; j < sz(cur[i]); j++) {
                cur[i][j] = 0;
            }
        }
    }
    for (int i = 1; ; i++) {
        if (pw(i, arr[0]) >= n) {
            cout << i << endl;
            return;
        }
    }
}

void run();

int main() {
    srand(time(0));
    if (JUDGE) {
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    } else {
        freopen("input.txt", "r", stdin);
    }
    for (int i = 0; i < cnt_tests; i++) {
        run();
    }
    return 0;
}

void stress() {
    inp();
    solve();
}

void run() {
    if (STRESS) {
        stress();
    } else {
        inp();
        solve();
        cout << endl;
    }
}

template<typename T>
inline void umax(T &a, T b) {
    if (a < b)
        a = b;
}

template<typename T>
inline void umin(T &a, T b) {
    if (a > b)
        a = b;
}

void inv(bool exp) {
    if (!exp) {
        vector<int> a;
        a[-1] += 1;
    }
}
