#define _CRT_SECURE_NO_WARNINGS

#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mk make_pair
#define inb push_back
#define all(v) v.begin(), v.end()

int solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)5007;

int n;
int a[MAXN];

int check(int x)
{
	vi lst, cur;
	lst.resize(5000);
	for (int i = 1; i < n; ++i)
	{	
		if (a[i - 1] < a[i])
		{
			int j = 0;
			for (auto &x : lst)
				cur.inb(x);
			for (int j = a[i - 1]; j < a[i]; ++j)
				cur.inb(0);
		}
		else
		{
			if (a[i - 1] >= a[i])
			{
				for (int j = 0; j <= a[i]; ++j)
					cur.inb(lst[j]);
				int pos = a[i];
				while (1)
				{
					++cur[pos];
					if (cur[pos] == x)
					{
						if (!pos)
							return 0;
						cur[pos] = 0, --pos;
					}
					else
						break;
				}
			}
		}
		swap(cur, lst);
		cur.clear();
	}
	return 1;
}

int solve()
{
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &a[i]), --a[i];
	}
	int l = 0, r = 5007;
	while (r - l > 1)
	{
		int m = l + r >> 1;
		if (check(m))
			r = m;
		else
			l = m;
	}
	cout << r;
	return 0;
}