#define _CRT_SECURE_NO_WARNINGS

#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mk make_pair
#define inb push_back
#define all(v) v.begin(), v.end()

int solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)1e6 + 7;

int n;
char a[MAXN];
int l[MAXN], r[MAXN], u[MAXN], d[MAXN];
int lans, rans, uans, dans;
set<pii> rs, us;
int hb, vb;

int solve()
{
	scanf("%d", &n);
	scanf("%s", a);
	scanf("%d %d", &hb, &vb);
	us.insert(mk(u[0], 0));
	rs.insert(mk(r[0], 0));
	for (int i = 1; i <= n; ++i)
	{
		l[i] = l[i - 1];
		r[i] = r[i - 1];
		d[i] = d[i - 1];
		u[i] = u[i - 1];
		if (a[i - 1] == 'L')
			++l[i];
		if (a[i - 1] == 'D')
			++d[i];
		if (a[i - 1] == 'U')
			++u[i], us.insert(mk(u[i], i));
		if (a[i - 1] == 'R')
			++r[i], rs.insert(mk(r[i], i));
	}
	{
		//vertical
		int ok = 0;
		for (int i = 0; i <= n; ++i)
		{
			int cd = d[i];
			auto it = us.lower_bound(mk(cd + vb, -1));
			if (it != us.end() && (*it).X == cd + vb)
			{
				dans = i;
				uans = (*it).Y;
				ok = 1;
				break;
			}
		}
		if (!ok)
			puts("-1"), exit(0);
	}
	{
		//horizontal
		int ok = 0;
		for (int i = 0; i <= n; ++i)
		{
			int cl = l[i];
			auto it = rs.lower_bound(mk(cl + hb, -1));
			if (it != rs.end() && (*it).X == cl + hb)
			{
				lans = i;
				rans = (*it).Y;
				ok = 1;
				break;
			}
		}
		if (!ok)
			puts("-1"), exit(0);
	}
	printf("%d %d %d %d\n", lans, uans, rans, dans);
	return 0;
}