#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define y1 kekek

const ld pi = acos(-1.0);
const ld eps = 1e-8;
const int BIG = 1e9;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ll MAX_N = 4 * 1e5 + 1;

int n, k, l[MAX_N], r[MAX_N], p[MAX_N];
vector<vector<tuple<int, int, int> > > op(MAX_N);
vector<vector<tuple<int, int, int> > > cl(MAX_N);

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    scanf("%d%d", &n, &k);
    vector<int> v;
    v.push_back(1);
    v.push_back(k);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d%d", &l[i], &r[i], &p[i]);
        v.push_back(l[i]);
        v.push_back(r[i]);
        v.push_back(r[i] + 1);
        v.push_back(l[i] - 1);
    }
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    int t = lower_bound(v.begin(), v.end(), 1) - v.begin();
    k = lower_bound(v.begin(), v.end(), k) - v.begin() + 1 - t;
    for (int i = 0; i < n; i++)
    {
        l[i] = lower_bound(v.begin(), v.end(), l[i]) - v.begin() - t;
        r[i] = lower_bound(v.begin(), v.end(), r[i]) - v.begin() - t;
        op[l[i]].push_back(make_tuple(p[i], l[i], r[i]));
        cl[r[i]].push_back(make_tuple(p[i], l[i], r[i]));
    }
    vector<ll> rt;
    rt.assign(k, 0);
    vector<bool> can;
    can.assign(k, false);
    int ps = 0;
    multiset<tuple<int, int, int> > c;
    while (ps < k)
    {
        for (tuple<int, int, int> x : op[ps])
            c.insert(x);
        if (!can[ps])
        {
            if (c.empty())
            {
                cout << -1;
                return 0;
            }
            tuple<int, int, int> now = *c.begin();
            for (int i = get<1>(now); i <= get<2>(now); i++)
                rt[i] += get<0>(now), can[i] = true;
        }
        for (tuple<int, int, int> x : cl[ps])
            c.erase(c.lower_bound(x));
        ps++;
    }
    ll now = 0;
    for (int i = 0; i < k; i++)
    {
        if (rt[i] == 0)
            now = INF;
        else
            now = max(now, rt[i]);
    }
    if (now == INF)
        now = -1;
    cout << now;
    return 0;
}
