#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define y1 kekek

const ld pi = acos(-1.0);
const ld eps = 1e-8;
const int BIG = 1e9;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ll MAX_N = 4 * 1e5 + 1;

int n, k, l[MAX_N], r[MAX_N], p[MAX_N];
vector<vector<tuple<int, int, int> > > op(MAX_N);
vector<vector<tuple<int, int, int> > > cl(MAX_N);

void only1()
{
    for (int i = 0; i < n; i++)
    {
        op[l[i]].push_back(make_tuple(p[i], -r[i], -l[i]));
        cl[r[i]].push_back(make_tuple(p[i], -r[i], -l[i]));
    }
    vector<ll> rt;
    rt.assign(k, 0);
    vector<bool> can;
    can.assign(k, false);
    int ps = 0;
    multiset<tuple<int, int, int> > c;
    while (ps < k)
    {
        for (tuple<int, int, int> x : op[ps])
            c.insert(x);
        if (!can[ps])
        {
            //cerr << ps << "\n";
            if (c.empty())
            {
                cout << -1;
                exit(0);
            }
            tuple<int, int, int> now = *c.begin();
            //cerr << get<1>(now) << " " << get<2>(now) << "\n";
            for (int i = -get<2>(now); i <= -get<1>(now); i++)
                rt[i] += get<0>(now), can[i] = true;
        }
        for (tuple<int, int, int> x : cl[ps])
            c.erase(c.lower_bound(x));
        ps++;
    }
    ll now = 0;
    for (int i = 0; i < k; i++)
    {
        if (rt[i] == 0)
            now = INF;
        else
            now = max(now, rt[i]);
    }
    if (now == INF)
        now = -1;
    cout << now;
    exit(0);
}

void solve_exp()
{
    ll ans = INF;
    for (int ms = 0; ms < (1 << n); ms++)
    {
        vector<ll> tr;
        tr.assign(k, 0);
        for (int i = 0; i < n; i++)
            if ((ms & (1 << i)) != 0)
            {
                for (int j = l[i]; j <= r[i]; j++)
                    tr[j] += (ll)p[i];
            }
        ll now = 0;
        for (int i = 0; i < k; i++)
        {
            if (tr[i] == 0)
                now = INF;
            else
                now = max(now, tr[i]);
        }
        ans = min(ans, now);
    }
    if (ans == INF)
        ans = -1LL;
    cout << ans;
    exit(0);
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    scanf("%d%d", &n, &k);
    vector<int> v;
    v.push_back(1);
    v.push_back(k);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d%d", &l[i], &r[i], &p[i]);
        v.push_back(l[i]);
        v.push_back(r[i]);
        v.push_back(r[i] + 1);
        v.push_back(l[i] - 1);
    }
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    int t = lower_bound(v.begin(), v.end(), 1) - v.begin();
    k = lower_bound(v.begin(), v.end(), k) - v.begin() + 1 - t;
    bool ch = true;
    for (int i = 0; i < n; i++)
    {
        ch &= (p[i] == 1);
        l[i] = lower_bound(v.begin(), v.end(), l[i]) - v.begin() - t;
        r[i] = lower_bound(v.begin(), v.end(), r[i]) - v.begin() - t;
    }
    if (ch)
        only1();
    if (n <= 10)
        solve_exp();
    vector<int> pl(k + 1, 0);
    for (int i = 0; i < n; i++)
        pl[l[i]]++, pl[r[i] + 1]--;
    if (pl[0] == 0)
    {
        cout << -1;
        return 0;
    }
    for (int i = 1; i < k; i++)
    {
        pl[i] += pl[i - 1];
        if (pl[i] == 0)
        {
            cout << -1;
            return 0;
        }
    }
    for (int i = 0; i < n; i++)
    {
        op[l[i]].push_back(make_tuple(p[i], -r[i], -l[i]));
        cl[r[i]].push_back(make_tuple(p[i], -r[i], -l[i]));
    }
    ll lf = 0;
    ll rtr = (ll)BIG * n;
    while (rtr - lf > 1)
    {
        ll h = (lf + rtr) / 2;
        vector<ll> rt;
        rt.assign(k, 0);
        vector<bool> can;
        can.assign(k, false);
        bool ch = true;
        for (int i = 0; i < k; i++)
        {
            if (can[i])
                continue;
            tuple<int, int, int> pr = make_tuple(BIG, BIG, BIG);
            for (int j = 0; j < n; j++)
                if (l[j] <= i && i <= r[j])
                {
                    bool dd = true;
                    for (int k = l[j]; k < i; k++)
                        if (p[j] + rt[k] > h)
                        {
                            dd = false;
                            break;
                        }
                    if (dd)
                        pr = min(pr, make_tuple(p[j], -r[j], l[j]));
                }
            if (get<1>(pr) == BIG)
            {
                ch = false;
                break;
            }
            for (int j = get<2>(pr); j <= -get<1>(pr); j++)
                rt[j] += get<0>(pr), can[j] = true;
        }
        if (ch)
            rtr = h;
        else
            lf = h;
    }
    cout << rtr;
    return 0;
}
