#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <functional>
#include <climits>
#include <cassert>

using namespace std;

typedef unsigned int index;

int main() 
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	ios::sync_with_stdio(false);
	size_t n;
	string a;
	cin >> n >> a;
	int x, y;
	cin >> x >> y;
	vector<vector<index>> poses(4);
	for (index i = 0; i < n; i++)
	{
		if (a[i] == 'L')
			poses[0].push_back(i + 1);
		else if (a[i] == 'U')
			poses[1].push_back(i + 1);
		else if (a[i] == 'R')
			poses[2].push_back(i + 1);
		else if (a[i] == 'D')
			poses[3].push_back(i + 1);
	}
	vector<index> ans(4);
	if (x > 0)
	{
		if (poses[2].size() >= (size_t)x)
		{
			ans[0] = 0;
			ans[2] = poses[2][(index)x - 1];
		}
		else
		{
			cout << -1 << endl;
			return 0;
		}
	}
	if (x < 0)
	{
		if (poses[0].size() >= (size_t)-x)
		{
			ans[2] = 0;
			ans[0] = poses[0][(index)x - 1];
		}
		else
		{
			cout << -1 << endl;
			return 0;
		}
	}
	if (x == 0)
		ans[0] = 0, ans[2] = 0;
	if (y > 0)
	{
		if (poses[3].size() >= (size_t)y)
		{
			ans[1] = 0;
			ans[3] = poses[3][(index)x - 1];
		}
		else
		{
			cout << -1 << endl;
			return 0;
		}
	}
	if (y < 0)
	{
		if (poses[1].size() >= (size_t)-y)
		{
			ans[3] = 0;
			ans[1] = poses[1][(index)x - 1];
		}
		else
		{
			cout << -1 << endl;
			return 0;
		}
	}
	if (x == 0)
		ans[1] = 0, ans[3] = 0;
	for (auto i: ans)
		cout << i << " ";
	cout << endl;
}
