#include <bits/stdc++.h>
#define forn(n) for (int i = 0; i < (n); i++)
#define pb push_back
typedef long long LL;
using namespace std;

const int MAXN = 1e5;
int len[MAXN];
int dp[MAXN];
void inis(int x, int L, int R)
{
    if (R - L == 1)
    {
        dp[x] = L;
        return;
    }
    int M = (L + R) / 2;
    inis(2 * x + 1, L, M);
    inis(2 * x + 2, M, R);
    if (len[dp[2 * x + 1]] <= len[dp[2 * x + 2]])
        dp[x] = dp[2 * x + 1];
    else
        dp[x] = dp[2 * x + 2];
}

int get(int x, int L, int R, int st, int fn)
{
    if (st >= R || L >= fn)
        return -1;
    if (st <= L && R <= fn)
        return dp[x];
    int M = (L + R) / 2;
    int ind1 = get(2 * x + 1, L, M, st, fn);
    int ind2 = get(2 * x + 2, M, R, st, fn);
    if (ind2 == -1 || (ind1 != -1 && len[ind1] <= len[ind2]))
        return ind1;
    return ind2;
}

LL step(LL a, LL b)
{
    if (b == 0)
        return 1;
    LL res = step(a, b >> 1);
    res *= res;
    if (b & 1)
        res *= a;
    return res;
}

LL rec(int L, int R, int val, int n)
{
    if (R - L <= 1)
        return 1;
    vector<int> vec;
    int ind = get(0, 0, n, L, R);
    //out << L << ' ' << R << ' ' << ind << endl;
    vec.push_back(ind);
    ind = get(0, 0, n, ind + 1, R);
    while (len[vec[0]] == len[ind])
    {
        vec.push_back(ind);
        ind = get(0, 0, n, ind + 1, R);
    }
    LL ans = max(rec(L, vec[0], len[vec[0]], n), rec(vec.back() + 1, R, len[vec[0]], n));
    for (int i = 1; i < vec.size(); i++)
    {
        ans = max(ans, rec(vec[i - 1] + 1, vec[i], len[vec[0]], n));
    }
    LL b = len[vec[0]] - val;
    LL cnt = vec.size();///ans ^ b >= cnt
    if (b == 1)
        ans = max(ans, cnt);
    else
    {
        LL ind = 1;
        while (step(ind, b) < cnt)
            ind++;
        ans = max(ans, ind);
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> len[i];
    }
    inis(0, 0, n);
    cout << rec(0, n, 0, n);
}
