using System;
using System.Collections.Generic;
using System.IO;

namespace ConsoleApplication1
{
    class Program
    {
        struct vector3
        {
            public int coord;
            public int type;
            public int p;
            public int id;
        }

        static void Main(string[] args)
        {
            TextReader input = Console.In;
            string[] s = input.ReadLine().Split();
            n = int.Parse(s[0]);
            k = int.Parse(s[1]);
            list = new List<vector3>();
            for (int i = 0; i < n; i++)
            {
                s = input.ReadLine().Split();
                list.Add(new vector3
                {
                    coord = int.Parse(s[0]),
                    type = 1,
                    p = int.Parse(s[2]),
                    id = i,
                });
                list.Add(new vector3
                {
                    coord = int.Parse(s[1]),
                    type = -1,
                    p = int.Parse(s[2]),
                    id = i,
                });
            }
            list.Sort(Comp);
            ans = long.MaxValue;
            Rec(0, "");
            if (ans == long.MaxValue)
            {
                Console.Write(-1);
            }
            else
            {
                Console.WriteLine(ans);
            }
            //Console.ReadKey();
        }


        static long Check(string s)
        {
            long balance = 0;
            long max = -1;
            List<vector3> newList = new List<vector3>();

            for (int i = 0; i < list.Count; i++)
            {
                vector3 current = list[i];
                if (s[current.id] == '1')
                {
                    newList.Add(current);
                }
            }
            
            newList.Add(new vector3 { coord = -1 });
            if (newList[0].coord != 1)
                return -1;
            for (int i = 0; i < newList.Count - 1; i++)
            {
                vector3 current = newList[i];
                balance += current.p * current.type;
                max = Math.Max(max, balance);
                if (balance == 0)
                {
                    if ((current.coord == k) || (newList[i + 1].coord == current.coord + 1))
                    {

                    }
                    else
                    {
                        return -1;
                    }
                }
            }
            return max;
        }

        static List<vector3> list;
        static int n;
        static int k;
        static long ans;
        static void Rec(int curLen, string s)
        {
            if (curLen == n)
            {
                long current = Check(s);
                if (current != -1)
                {
                    ans = Math.Min(current, ans);
                }
                return;
            }

            Rec(curLen + 1, s + '0');
            Rec(curLen + 1, s + '1');
        }

        static int Comp(vector3 first, vector3 second)
        {
            if (first.coord != second.coord)
            {
                return first.coord - second.coord;
            }
            return second.type - first.type;
        }
    }
}
