#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 100005;
const ll inf = (ll)1e18;

int n, k;

vector <pair <pair <int, int>, ll> > arr;

ll dp[MAXN];

int main() {

    //freopen("in.in", "r", stdin);

    cin >> n >> k;

    for(int i = 0; i < n; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        arr.push_back(make_pair(make_pair(a, b), c));
    }

    sort(arr.begin(), arr.end());

    ll l = arr[0].first.first, r = arr[0].first.second;

    for(int i = 1; i < n; i++) {
        if (arr[i].first.first > arr[i - 1].first.second + 1) {
            cout << -1;
            return 0;
        }
        r = arr[i].first.second;
    }

    if (!(l == 1 && r == k)) {
        cout << -1;
        return 0;
    }

    dp[0] = arr[0].second;

    for(int i = 1; i < n; i++) {
        dp[i] = inf;
    }

    for(int i = 1; i < n; i++) {
        for(int j = 0; j < i; j++) {
            if (arr[j].first.second + 1 >= arr[i].first.first) {
                if (arr[j].first.second >= arr[i].first.first) {
                    dp[i] = min(dp[i], max(dp[j], arr[i].second + arr[j].second));
                }
                else {
                    dp[i] = min(dp[i], dp[j]);
                }
            }
        }
    }

    if (dp[n - 1] == inf) {
        cout << -1;
        return 0;
    }

    cout << dp[n - 1];

    return 0;
}
