#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 100005;
const ll inf = (ll)1e18;

int n, k;

vector <pair <int, int> > arr;

ll dp[MAXN];

bool cmp(pair <int, int> a, pair <int, int> b) {
    if (a.second < b.second) {
        return true;
    }
    if (a.second > b.second) {
        return false;
    }
    if (a.first < b.first) {
        return true;
    }
    else {
        return false;
    }
}

int main() {

    //freopen("in.in", "r", stdin);

    cin >> n >> k;

    for(int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        arr.push_back(make_pair(a, b));
    }

    sort(arr.begin(), arr.end());

    ll l = arr[0].first, r = arr[0].second;

    for(int i = 1; i < n; i++) {
        //cout << arr[i].first << " " << arr[i].second << endl;
        if (arr[i].first > arr[i - 1].second + 1) {
            cout << -1;
            return 0;
        }
        r = max(r, (ll)arr[i].second);
    }

    if (!(l == 1 && r >= k)) {
        cout << -1;
        return 0;
    }

    sort(arr.begin(), arr.end(), cmp);

    if (arr[0].first == 1) {
        dp[0] = 1;
    }

    for(int i = 1; i < n; i++) {
        if (arr[i].first == 1) {
            dp[i] = 1;
            continue;
        }
        int b = 0, e = n;
        while(e - b > 1) {
            int m = (b + e) / 2;
            if (arr[m].second > arr[i].first) {
                e = m;
            }
            else {
                b = m;
            }
        }
        while(arr[b].second == arr[i].first) {
            if (dp[b] == 1) {
                dp[i] = 1;
                break;
            }
            b--;
            if (b == -1) {
                break;
            }
        }
        if (dp[i] == 1 && arr[i].second >= k) {
            cout << 1;
            return 0;
        }
    }

    cout << 2;

    return 0;
}
