#include <iostream>
#include <vector>

using namespace std;

const int sz = 310;

vector<int> w;
int n;

bool check(int k)
{
    int i, j;
    vector<int> s(sz);
    for (i = 0; i < w[0]; i++)
        s[i] = 1;
    for (i = 1; i < n; i++)
    {
        int l = w[i];
        l--;
        for (j = 0; j < l; j++)
            if (s[j] == 0)
                s[j] = 1;
        for (j = l+1; j < sz; j++)
            s[j] = 0;
        s[l]++;
        j = l;
        while (j != 0 && s[j] > k)
        {
            s[j] = 1;
            s[j-1]++;
            j--;
        }
    }
    for (i = 0; i < sz; i++)
        if (s[i] > k)
            return false;
    return true;
}

int main()
{
    int i, j, ans = 1;
    cin >> n;
    w.resize(n);
    for (i = 0; i < n; i++)
        cin >> w[i];
    int l = 1, r = sz;
    while(l < r)
    {
        int mid = (l+r)/2;
        if (check(mid))
            r = mid;
        else
            l = mid+1;
    }
    cout << l;
    return 0;
}
