import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by olymp on 10.03.2017.
 */
public class TaskEclair12 {
    FastScanner in;
    PrintWriter out;
    public static void main(String[] args){
        new TaskEclair12().run();
    }

    static int[] size;
    static long[] Allpermitation;
    static int n;
    static int m;
    public void solve(){
        n = in.nextInt();
        size = new int[n];
        m = -1;
        for (int i = 0; i < n; i++){
            size[i] = in.nextInt();
            m = Math.max(m ,size[i]);
        }
        Allpermitation = new long[m];
        if (n!=1) {
            long ans = magicSearch();
            out.print(ans);
        }else {
            out.print(1);
        }
    }

    public long magicSearch() {
        long l = 0;
        long r = Integer.MAX_VALUE;
        while ((r-l)>1){
            long mid = (r+l)/2;
            if (real(mid)){
                r = mid;
            }else{
                l = mid;
            }
        }
        return r;

    }

    public boolean real(long mid) {
        long letter = mid;

        perm(letter);
        long permitation = Allpermitation[size[0]-1]-1;
        long buf = permitation+1;
        for (int i = 1; i < n; i++){
            if (size[i]==size[i-1]){
                if (permitation > 0){
                    permitation--;
                }else{
                    permitation = Allpermitation[size[i]-1]-1;
                    buf = permitation+1;
                    letter--;
                    if (letter<=0){
                        return false;
                    }
                }
            }else {
                if (size[i]>size[i-1]){
                    if (permitation==0){
                        permitation = Allpermitation[size[i]-size[i-1]]-1;
                    }else {
                        permitation = permitation * Allpermitation[size[i]-size[i-1]] - 1;
                    }
                    buf = permitation+1;
                }else{
                    if (permitation==0 || buf==0 || size[i]==1){
                        letter--;
                        if (letter<=0){
                            return false;
                        }
                        permitation = Allpermitation[size[i]]-1;
                    }else {
                        long help = (buf - permitation) % Allpermitation[size[i]];
                        if (help == 0 && (buf - permitation) / Allpermitation[size[i]] < Allpermitation[size[i]]) {
                            permitation = Allpermitation[size[i]] - (buf - permitation) / Allpermitation[size[i]] - 1;
                        } else {
                            if ((buf - permitation) / Allpermitation[size[i]] == Allpermitation[size[i]] - 1) {
                                letter--;
                                if (letter <= 0) {
                                    return false;
                                }
                                permitation = Allpermitation[size[i]] - 1;
                            } else {
                                permitation = Allpermitation[size[i]] - (buf - permitation) / Allpermitation[size[i]];
                            }
                        }
                    }
                    buf = permitation+1;
                }
            }
        }
        return true;
    }


    public void perm(long letter) {
        long p = 1;
        for (int i = 0; i < m; i++){
            Allpermitation[i] = p;
            if (p < 10000000){
                p = p*letter;
            }
        }
    }


    public void run(){
        try {
            in = new FastScanner(new File("input.txt"));
            out = new PrintWriter(new File("output.txt"));

            solve();

            out.close();
        }catch (IOException e){
            e.printStackTrace();
        }

    }
    class FastScanner{
        BufferedReader br;
        StringTokenizer st;
        FastScanner(File f){
            try {
                br = new BufferedReader(new FileReader(f));
            }catch (FileNotFoundException e){
                e.printStackTrace();
            }

        }
        String next(){
            while (st == null || !st.hasMoreTokens()){
                try {
                    st = new StringTokenizer(br.readLine());
                }catch (IOException e){
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
        int nextInt(){
            return Integer.parseInt(next());
        }
    }
}

