import java.io.*;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * Created by olymp on 10.03.2017.
 */
public class TaskMuffin2 {
    FastScanner in;
    PrintWriter out;
    public static void main(String[] args){
        new TaskMuffin2().run();
    }

    static int n;
    static int m = 4;
    static int xf;
    static int yf;
    static String way;
    static ArrayList<Integer>[] help;
    public void solve(){
        n = in.nextInt();
        way = in.next();
        xf = in.nextInt();
        yf = in.nextInt();
        help = new ArrayList[m];
        for (int i = 0; i < m; i++){
            help[i] = new ArrayList<>();
            help[i].add(0);
        }
        for (int i = 0; i < way.length(); i++){
            if (way.charAt(i)=='L'){
                help[0].add(i+1);
            }
            if (way.charAt(i)=='U'){
                help[1].add(i+1);
            }
            if (way.charAt(i)=='R'){
                help[2].add(i+1);
            }
            if (way.charAt(i)=='D'){
                help[3].add(i+1);
            }
        }
        for (int l = 0; l < help[0].size(); l++){
            for (int u = 0; u < help[1].size(); u++){
                for (int r = 0; r < help[2].size(); r++){
                    for (int d = 0; d < help[3].size(); d++){
                        if (test(help[0].get(l), help[1].get(u), help[2].get(r), help[3].get(d))){
                            out.print(help[0].get(l)+" "+help[1].get(u)+" "+help[2].get(r)+" "+help[3].get(d));
                            out.close();
                            System.exit(0);
                        }
                    }
                }
            }
        }
        out.print(-1);

    }

    public boolean test(int l, int u, int r, int d) {
        int x = 0;
        int y = 0;
        for (int i = 0; i < way.length(); i++){
            if (i == l){
                l = 0;
            }
            if (i == r){
                r = 0;
            }
            if (i == u){
                u = 0;
            }
            if (i == d){
                d = 0;
            }
            if (way.charAt(i)=='L' && l != 0){
                x--;
            }
            if (way.charAt(i)=='R' && r != 0){
                x++;
            }
            if (way.charAt(i)=='U' && u != 0){
                y++;
            }
            if (way.charAt(i)=='D' && d != 0){
                y--;
            }
        }
        if (x==xf && y==xf){
            return true;
        }else {
            return false;
        }
    }


    public void run(){
        try {
            in = new FastScanner(new File("input.txt"));
            out = new PrintWriter(new File("output.txt"));

            solve();

            out.close();
        }catch (IOException e){
            e.printStackTrace();
        }

    }
    class FastScanner{
        BufferedReader br;
        StringTokenizer st;
        FastScanner(File f){
            try {
                br = new BufferedReader(new FileReader(f));
            }catch (FileNotFoundException e){
                e.printStackTrace();
            }

        }
        String next(){
            while (st == null || !st.hasMoreTokens()){
                try {
                    st = new StringTokenizer(br.readLine());
                }catch (IOException e){
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
        int nextInt(){
            return Integer.parseInt(next());
        }
    }
}

