import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by olymp on 10.03.2017.
 */
public class TaskMaffin3 {
    FastScanner in;
    PrintWriter out;
    public static void main(String[] args){
        new TaskMaffin3().run();
    }

    static int n;
    static String way;
    static int[][] dp;
    static int xf;
    static int yf;
    public void solve(){
        n = in.nextInt();
        way = in.next();
        xf = in.nextInt();
        yf = in.nextInt();
        dp = new int[n+1][4];
        dp[0][0] = 0;
        dp[0][1] = 0;
        dp[0][2] = 0;
        dp[0][3] = 0;
        int l = -1;
        int r = -1;
        int u = -1;
        int d = -1;
        /*for (int i = 0; i < way.length(); i++){
            if (way.charAt(i)=='L'){
                dp[i+1][0] = dp[i][0]-1;
                dp[i+1][1] = dp[i][1];
                dp[i+1][2] = dp[i][2]-1;
                dp[i+1][3] = dp[i][3];
            }
            if (way.charAt(i)=='U'){
                dp[i+1][0] = dp[i][0];
                dp[i+1][1] = dp[i][1]+1;
                dp[i+1][2] = dp[i][2];
                dp[i+1][3] = dp[i][3]+1;
            }
            if (way.charAt(i)=='R'){
                dp[i+1][0] = dp[i][0]+1;
                dp[i+1][1] = dp[i][1];
                dp[i+1][2] = dp[i][2]+1;
                dp[i+1][3] = dp[i][3];
            }
            if (way.charAt(i)=='D'){
                dp[i+1][0] = dp[i][0];
                dp[i+1][1] = dp[i][1]-1;
                dp[i+1][2] = dp[i][2];
                dp[i+1][3] = dp[i][3]-1;
            }
        }
        if (xf >= 0){
            l = 0;
        }
        if (xf <= 0){
            r = 0;
        }
        if (yf >= 0){
            d = 0;
        }
        if (yf <= 0){
            u = 0;
        }
        for (int i = 0; i < n; i++){
            if (way.charAt(i)=='L' && l==-1){
                if (dp[i+1][0]<=xf){
                    l = i+1;
                }
            }
            if (way.charAt(i)=='U' && u==-1){
                if (dp[i+1][1]>=yf){
                    u = i+1;
                }
            }
            if (way.charAt(i)=='R' && r==-1){
                if (dp[i+1][2]>=xf){
                    r = i+1;
                }
            }
            if (way.charAt(i)=='D' && d==-1){
                if (dp[i+1][1]<=yf){
                    d = i+1;
                }
            }
        }
        if (l!=-1 && r != -1 && d != -1 && u != -1){
            out.println(l+" "+u+" "+r+" "+d);
        }else{
            out.print(-1);
        }*/
        int x = 0;
        int y = 0;
        for (int i = 0; i < way.length(); i++) {
            if (x <= xf && l==-1){
                l = i;
            }
            if (x >= xf && r==-1){
                r = i;
            }
            if (y <= yf && d==-1){
                d = i;
            }
            if (y >= yf && u == -1){
                u = i;
            }
            if (way.charAt(i) == 'L' && l == -1) {
                x--;
            }
            if (way.charAt(i) == 'U' && u == -1) {
                y++;
            }
            if (way.charAt(i) == 'R' && r == -1) {
                x++;
            }
            if (way.charAt(i) == 'D' && d == -1) {
                y--;
            }
        }
        if (x==xf && y == yf){
            out.println(l+" "+u+" "+r+" "+d);
        }else{
            out.print(-1);
        }
    }




    public void run(){
        try {
            in = new FastScanner(new File("input.txt"));
            out = new PrintWriter(new File("output.txt"));

            solve();

            out.close();
        }catch (IOException e){
            e.printStackTrace();
        }

    }
    class FastScanner{
        BufferedReader br;
        StringTokenizer st;
        FastScanner(File f){
            try {
                br = new BufferedReader(new FileReader(f));
            }catch (FileNotFoundException e){
                e.printStackTrace();
            }

        }
        String next(){
            while (st == null || !st.hasMoreTokens()){
                try {
                    st = new StringTokenizer(br.readLine());
                }catch (IOException e){
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
        int nextInt(){
            return Integer.parseInt(next());
        }
    }
}

