#include <bits/stdc++.h>
using namespace std;

// n log^3 or log^2?

const int maxn = 1e5+5;

int a[maxn];

map<int, int> s;
int t;

bool inc(int k){
    if(k == 0) return 0;
    s[k]++;
    if(s[k] == t){
        s[k] = 0;
        return inc(k-1);
    }
    return 1;
}

void d(int k){
    while(1){
        auto it = s.lower_bound(k);
        if(it != s.end()) s.erase(it);
        else break;
    }
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    bool perfect = 1;

    for(int i = 0; i < n; i++){
        cin >> a[i];
        if(i > 0 && a[i] <= a[i-1]) perfect = 0;
    }

    if(perfect) cout << 1, exit(0);

    int l = 2, r = n;
    while(l < r){
        t = (l+r)/2;
        bool good = 1;
        s.clear();
        for(int i = 1; i < n; i++){
            if(a[i] <= a[i-1]){
                d(a[i]+1);
                if(!inc(a[i])){
                    good = 0;
                    break;
                }
            }
        }
        if(good) r = t;
        else l = t+1;
    }

    cout << l;

    return 0;
}
