#include <stdio.h>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, int, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds;*/

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vvi graph;
typedef vector<char> vc;
typedef pair<int, int> pii;

/* <-----------------------------------------------------------------------------> */

const int mx = 5003;

int n;
vi l, v(mx);

bool check(int m)
{
    for (int i = 1; i <= l[0]; ++i)
        v[i] = 1;
    for (int i = l[0] + 1; i < mx; ++i)
        v[i] = 0;

    for (int i = 1; i < n; ++i)
    {
        int j = l[i];
        while (j && v[j] == m) --j;
        if (!j) return false;
        ++v[j];
        for (int k = j - 1; k && !v[k]; --k)
            v[k] = 1;
        for (++j; j <= l[i]; ++j)
            v[j] = 1;
        for (; j < mx; ++j)
            v[j] = 0;
    }

    return true;
}

void solve()
{
    scanf("%d", &n);
    l.resize(n);
    for (int & i : l)
        scanf("%d", &i);

    int lf = 1, rg = n;

    while (lf < rg)
    {
        int m = (lf + rg) >> 1;
        if (check(m)) rg = m;
        else lf = m + 1;
    }

    printf("%d", lf);
}

/* <-----------------------------------------------------------------------------> */

// #define LOCAL
// #define FILE_NAME

int main()
{
#if defined LOCAL
    freopen("input.txt", "r", stdin);
#elif defined FILE_NAME
    freopen(FILE_NAME".in", "r", stdin);
    freopen(FILE_NAME".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
