#include <stdio.h>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds;*/

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vvi graph;
typedef vector<char> vc;
typedef pair<int, int> pii;

/* <-----------------------------------------------------------------------------> */

typedef pair<ll, ll> pll;

pll ask(ll t)
{
    printf("X %lld\n", t);
    fflush(stdout);
    ll a, b;
    scanf("%lld%lld", &a, &b);
    return {a, b};
}

void answer(ll t)
{
    printf("N %lld\n", t);
    fflush(stdout);
    char s[10];
    scanf("%s");
}

void subsolve()
{
    ll l = 1, r = (ll)1e18;
    while (l < r)
    {
        ll m = (l + r + 1) / 2LL;
        pll res = ask(m);
        if (!res.ft) r = m - 1;
        else l = m;
    }
    return answer(l);
}

void solve()
{
    int g;
    scanf("%d", &g);
    while (g--)
        subsolve();
}

/* <-----------------------------------------------------------------------------> */

// #define LOCAL
// #define FILE_NAME

int main()
{
#if defined LOCAL
    freopen("input.txt", "r", stdin);
#elif defined FILE_NAME
    freopen(FILE_NAME".in", "r", stdin);
    freopen(FILE_NAME".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
