#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct segment {
    int left, right, p;
    segment () {}
    segment (int l, int r, int p1) {
        left = l;
        right = r;
        p = p1;
    }
};

bool less1(segment s1, segment s2) {
    if (s1.left < s2.left) {
        return true;
    }
    else if (s1.left > s2.left) {
        return false;
    }
    else {
        if (s1.right < s2.right) {
            return true;
        }
        else {
            return false;
        }
    }
}

int main() {
    ifstream fin;
    fin.open("input.txt");
    ofstream fout;
    fout.open("output.txt");
    int n, k, right, res;
    bool flag = true;
    set <int> possible;
    fin >> n >> k;
    vector <segment> variants(n);
    for (int i = 0; i < n; i++) {
        fin >> variants[i].left >> variants[i].right >> variants[i].p;
    }
    variants.push_back(segment(0, 0, 1));
    variants.push_back(segment(k + 1, k + 1, 1));
    n += 2;
    sort(variants.begin(), variants.end(), less1);
    right = 0;
    for (int i = 0; i < n; i++) {
        if (variants[i].left > right) {
            flag = 0;
        }
        else {
            right = max(variants[i].right + 1, right);
        }
    }
    if (flag) {
        //vector <bool> dp(n);
        possible.insert(0);
        for (int i = 0; i < n; i++) {
            if (possible.count(variants[i].left)) {
                possible.insert(variants[i].right + 1);
            }
        }
        if (possible.count(k + 1)) {
            res = 1;
        }
        else {
            res = 2;
        }
    }
    else {
        res = -1;
    }
    fout << res << '\n';
    fin.close();
    fout.close();
    return 0;
}
