#include <bits/stdc++.h>
using namespace std;

#define mp(a, b) make_pair((a), (b))
#define int int64_t
#define ff first.first
#define fs first.second
#define s second

const int INF = 1000000000000000000;

bool cmp(const pair < pair < int, int >, int >& a, const pair < pair < int, int >, int >& b)
{
    return a.fs < b.fs || (a.fs == b.fs && (a.ff < b.ff || (a.ff == b.ff && a.s < b.s)));
}

void update1(pair < int, int >& dp, pair < int, int >& dp1, int dpp, int c, int d)
{
    if (max(max(dpp, c), d) < dp.first)
    {
        dp.first = max(max(dpp, c), d);
        dp.second = c;
    }
    if (c < dp1.second)
    {
        dp1.second = c;
        dp1.first = max(max(dpp, c), d);
    }
}

void update2(pair < int, int >& dp, pair < int, int >& dp1, int dpp, int c, int d)
{
    if (max(dpp + c, d) < dp.first)
    {
        dp.first = max(dpp + c, d);
        dp.second = c;
    }
    if (c < dp1.second)
    {
        dp1.second = c;
        dp1.first = max(dpp + c, d);
    }
}

void bad_solution(int n, int k)
{
    vector < pair < pair < int, int >, int > > a1(n);
    for (auto& x : a1)
    {
        cin >> x.ff >> x.fs >> x.s;
    }
    a1.push_back(mp(mp(0, 0), 0));
    sort(a1.begin(), a1.end(), cmp);
    if (a1.back().fs != k)
    {
        cout << -1 << endl;
        exit(0);
    }
    vector < pair < int, int > > dp(n + 1, make_pair(INF, INF));
    dp[0] = pair<int64_t, int64_t>(0, 0);
    vector < pair < int, int > > dp1(dp);
    for (int asd = 0; asd <= n; ++asd)
    {
        int ind = lower_bound(a1.begin(), a1.end(), make_pair(make_pair((int64_t)0, a1[asd].ff - 1), (int64_t)0), cmp) - a1.begin();
        while (ind < asd)
        {
            if (a1[ind].fs == a1[asd].ff - 1)
            {
                update1(dp[asd], dp1[asd], dp[ind].second, a1[asd].s, dp[ind].first);
                update1(dp[asd], dp1[asd], dp1[ind].second, a1[asd].s, dp1[ind].first);
            }
            else
            {
                update2(dp[asd], dp1[asd], dp[ind].second, a1[asd].s, dp[ind].first);
                update2(dp[asd], dp1[asd], dp1[ind].second, a1[asd].s, dp1[ind].first);
            }
            ++ind;
        }
    }
    cout << dp.back().first << endl;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    if (n <= 3000)
    {
        bad_solution(n, k);
        return 0;
    }
    vector < pair < int, int > > a;
    a.reserve(n);
    int p;
    map < int, set < int > > help;
    for (int i = 0; i < n; ++i)
    {
        pair < int, int > x;
        cin >> x.first >> x.second >> p;
        help[x.first].insert(x.second + 1);
        a.push_back(make_pair(x.first, x.second + 1));
    }
    sort(a.begin(), a.end());
    int right = 1;
    for (auto& x : a)
    {
        if (x.first > right)
        {
            cout << -1 << endl;
            return 0;
        }
        right = max(right, x.second);
    }
    if (right != k + 1)
    {
        cout << -1 << endl;
        return 0;
    }
    set < int > vis;
    deque < int > queue;
    vis.insert(1);
    queue.push_back(1);
    while (!queue.empty())
    {
        int curr = queue.front();
        queue.pop_front();
        for (auto& x : help[curr])
        {
            if (x == k + 1)
            {
                cout << 1 << endl;
                return 0;
            }
            if (!vis.count(x))
            {
                vis.insert(x);
                queue.push_back(x);
            }
        }
    }
    cout << 2 << endl;
    return 0;
}

