#include <bits/stdc++.h>
using namespace std;

#define mp(a, b) make_pair((a), (b))
#define int int64_t
#ifdef LOCAL
const int n = 1000000000000000000ll;
#endif

int gcd(int a, int b)
{
    return b == 0 ? a : gcd(b, a % b);
}

void get(int t, int& a, int& b)
{
#ifdef LOCAL
    t = (n / t);
    int d = gcd(n, t);
    a = t / d;
    b = n / d;
#else
    cout << "X " << t << endl;
    cin >> a;
    if (a == -1)
    {
        exit(1);
    }
    cin >> b;
#endif
}

signed solution()
{
    int left = 1, right =  1000000000000000100ll;
    while (right - left > 1)
    {
        int mid = (left + right) / 2;
        int a, b;
        get(mid, a, b);
        if (a == 0)
        {
            right = mid;
        }
        else
        {
            left = mid;
        }
    }
    cout << "N " << left << endl;
    string res;
    cin >> res;
    if (res == "Wrong")
    {
        exit(0);
    }
    return 0;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int g;
    cin >> g;
    for (int i = 0; i < g; ++i)
    {
        solution();
    }
    return 0;
}

