#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;

#define X first
#define Y second
#define TASK  ""

const int MAXN = (int)1e6 + 7;

int prefL[MAXN], prefD[MAXN], prefU[MAXN], prefR[MAXN];

int xx, yy, n;

string s;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	cin >> n;
	cin >> s;
	cin >> xx >> yy;
	for (int i = 1; i <= n; i++)
	{
		prefD[i] = prefD[i - 1];
		prefU[i] = prefU[i - 1];
		prefL[i] = prefL[i - 1];
		prefR[i] = prefR[i - 1];
		if (s[i - 1] == 'L')
		{
			prefL[i] = prefL[i - 1] + 1;
		}
		if (s[i - 1] == 'U')
			prefU[i] = prefU[i - 1] + 1;
		if (s[i - 1] == 'D')
			prefD[i] = prefD[i - 1] + 1;
		if (s[i - 1] == 'R')
			prefR[i] = prefR[i - 1] + 1;
	}
	int cnt1 = xx;
	int cnt2 = yy;

	pair<int, int> t, t1;
	t = { -1, -1 };
	t1 = { -1, -1 };
	for (int i = 0; i <= n; i++)
	{
		int j = lower_bound(prefR, prefR + n + 1, prefL[i] + cnt1) - prefR;
		if (prefR[j] == prefL[i] + cnt1)
		{
			t = { i, j };
			break;
		}
	}
	for (int i = 0; i <= n; i++)
	{
		int j = lower_bound(prefU, prefU + n + 1, prefD[i] + cnt2) - prefU;
		if (prefU[j] == prefD[i] + cnt2)
		{
			t1 = { i, j };
			break;
		}
	}
	if (t == make_pair(-1, -1) || t1 == make_pair(-1, -1))
		cout << -1;
	else
		cout << t.X << ' ' << t1.Y << ' ' << t.Y << ' ' << t1.X;

}