#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;

#define X first
#define Y second
#define TASK  ""

const int MAXN = (int)1e6 + 7;

struct sob {
	int l, r, ind;
	ll p;
	sob(int l, int r, int ind, ll p) : l(l), r(r), ind(ind), p(p) {};
};

vector<pair<int, bool>> sc;

pair<int, int> a[MAXN];

ll p[MAXN];

int n, k;

ll q[MAXN];

vector<pair<pair<int, bool>, int>> scc;

vector<sob> v;

bool cmp(sob a, sob b)
{
	return a.r < b.r;
}

vector<int> g[MAXN];

map<int, vector<int>> mp;

bool dp[MAXN], used[MAXN];

bool dfs(int vv)
{
	used[vv] = 1;
	bool f = 0;
	if (v[vv].r == k)
	{
		dp[vv] = 1;
		return true;
	}
	for (int i = 0; i < g[vv].size(); i++)
	{
		int to = g[vv][i];
		if (used[to] && dp[to] == 1)
			f = 1;
		if (!used[to])
			f |= dfs(to);
	}
	return dp[vv] = f;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	cin >> n >> k;
	int uk = 2;
	bool check = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].X >> a[i].Y >> p[i];
		sc.push_back({ a[i].X, 0 });
		sc.push_back({ a[i].Y, 1 });
		v.push_back(sob(a[i].X, a[i].Y, i, p[i]));
		if (p[i] != 1)
			check = 1;
	}
	int bal = 0;
	int lastb = 0;
	int maxd = 0;
	sort(sc.begin(), sc.end());
	for (int j = 0; j < sc.size(); j++)
	{
		if (sc[j].Y == 0)
		{
			bal++;
			if (bal == 1)
				maxd = max(maxd, sc[j].X - lastb);
		}
		else
		{
			bal--;
			if (bal == 0)
				lastb = sc[j].X;
		}
	}
	if (k - lastb != 0 || maxd > 1)
	{
		cout << -1;
		return 0;
	}
	if (check && n <= 10)
	{
		ll ans = ll(1e18 + 18);
		for (int i = 1; i < (1 << n); i++)
		{
			vector<int> kek;
			for (int j = 0; j < n; j++)
			{
				if ((i >> j) & 1)
				{
					kek.push_back(j);
				}
			}

			scc.clear();
			for (int j = 0; j < kek.size(); j++)
			{
				scc.push_back({ { a[kek[j]].X, 0 }, kek[j] });
				scc.push_back({ { a[kek[j]].Y, 1 }, kek[j] });
			}
			sort(scc.begin(), scc.end());
			bool f = 0;
			if (scc[0].X.X != 1 || scc[scc.size() - 1].X.X != k)
				f = 1;
			int bal = 0;
			ll curp = 0;
			ll curmx = 0;
			int lastb = 0;
			int maxd = 0;
			for (int j = 0; j < scc.size(); j++)
			{
				if (scc[j].X.Y == 0)
				{
					curp += (p[scc[j].Y]);
					curmx = max(curmx, curp);
					bal++;
					if (bal == 1)
						maxd = max(maxd, scc[j].X.X - lastb);
				}
				else
				{
					bal--;
					if (bal == 0)
						lastb = scc[j].X.X;
					curp -= (p[scc[j].Y]);
				}
			}
			if (k - lastb != 0 || maxd > 1)
				continue;
			ans = min(ans, curmx);
		}
		if (ans == ll(1e18 + 18))
			cout << -1;
		else
			cout << ans;
		return 0;
	}
	sort(v.begin(), v.end(), cmp);
	for (int i = 0; i < v.size(); i++)
	{
		mp[v[i].l].push_back(i);
	}
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < mp[v[i].r + 1].size(); j++)
		{
			g[i].push_back(mp[v[i].r + 1][j]);
			
		}
	}
	for (int i = 0; i < v.size(); i++)
	{
		if (v[i].l == 1)
			dfs(i);
	}
	for (int i = 0; i < n; i++)
		if (dp[i])
		{
			cout << 1;
			return 0;
		}
	cout << 2;
	return 0;
	
}