#include <bits/stdc++.h>
#define ll long long

using namespace std;

int n;
vector< int > lens;

bool get_next(vector<int>& a, int m) {
    int sz = a.size();
    bool changed = false;
    for (int i = sz - 1; i > -1; --i) {
        if (a[i] < m - 1) {
            changed = true;
            ++a[i];
            for (int j = i + 1; j < sz; ++j) {
                a[j] = 0;
            }
            break;
        }
    }
    return changed;
}

inline bool check(int m) {
    if (m == 0) {
        return false;
    }
    vector< vector<int> > words(n);
    words[0].resize(lens[0]);
    for (int i = 0; i < lens[0]; ++i) {
        words[0][i] = 0;
    }
    for (int i = 1; i < n; ++i) {
        words[i].resize(lens[i]);
        if (lens[i] > lens[i - 1]) {
            for (int j = 0; j < lens[i - 1]; ++j) {
                words[i][j] = words[i - 1][j];
            }
            for (int j = lens[i - 1]; j < lens[i]; ++j) {
                words[i][j] = 0;
            }
        } else {
            for (int j = 0; j < lens[i]; ++j) {
                words[i][j] = words[i - 1][j];
            }
            bool res = get_next(words[i], m);
            if (!res) return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    lens.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> lens[i];
    }

    int l = 0, r = (int)(1e9);
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m)) {
            r = m;
        } else {
            l = m;
        }
    }

    cout << r << "\n";

}
