#include <bits/stdc++.h>
#define ll long long

using namespace std;

int main()
{
    int n;
    cin >> n;
    string s;
    cin >> s;
    int to_x, to_y;
    cin >> to_x >> to_y;
    // l - 0, u - 1, r - 2, d - 3
    int l = 0, u = 1, r = 2, d = 3;
    vector< int > suf(4, 0);
    for (char c : s) {
        if (c == 'L') ++suf[l];
        else if (c == 'U') ++suf[u];
        else if (c == 'R') ++suf[r];
        else ++suf[d];
    }
    int x = 0, y = 0;
    vector< bool > disabled(4, false);
    vector< int > ans(4, n);
    if (to_x >= x) {
        ans[l] = 0;
        disabled[l] = true;
    }
    if (to_x <= x) {
        ans[r] = 0;
        disabled[r] = true;
    }
    if (to_y >= y) {
        ans[d] = 0;
        disabled[d] = true;
    }
    if (to_y <= y) {
        ans[u] = 0;
        disabled[u] = true;
    }
    vector<int> dx = {-1, 0, 1, 0};
    vector<int> dy = {0, 1, 0, -1};
    for (int i = 0; i < n; ++i) {
        char c = s[i];
        int c_id;
        if (c == 'L') c_id = 0;
        else if (c == 'U') c_id = 1;
        else if (c == 'R') c_id = 2;
        else c_id = 3;
        if (disabled[c_id]) continue;
        x += dx[c_id];
        y += dy[c_id];
        if (!disabled[l] && to_x >= x) {
            ans[l] = i + 1;
            disabled[l] = true;
        }
        if (!disabled[r] && to_x <= x) {
            ans[r] = i + 1;
            disabled[r] = true;
        }
        if (!disabled[d] && to_y >= y) {
            ans[d] = i + 1;
            disabled[d] = true;
        }
        if (!disabled[u] && to_y <= y) {
            ans[u] = i + 1;
            disabled[u] = true;
        }
    }
    if (x != to_x || y != to_y) {
        cout << -1 << "\n";
    } else {
        for (int i = 0; i < 4; ++i) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
}
