#include <bits/stdc++.h>
#define ll long long

using namespace std;

ll INF = (ll)(1e18);

int n, k;

void solve_1() {
    vector< pair< pair<int, int>, int > > segs(n);
    for (int i = 0; i < n; ++i) {
        cin >> segs[i].first.first >> segs[i].first.second >> segs[i].second;
    }
    ll ans = INF;
    for (int mask = 1; mask < (1 << n); ++mask) {
        vector< bool > use;
        int mask_2 = mask;
        while (mask_2 > 0) {
            use.push_back(mask_2 % 2);
            mask_2 /= 2;
        }
        while (use.size() < n) use.push_back(0);
        vector< pair< pair<int, int>, int > > cur_segs;
        for (int i = 0; i < n; ++i) {
            if (use[i]) cur_segs.push_back(segs[i]);
        }
        // here i have cur_segs

        //event: pos, type[0 - open, 1 - close] , id
        set< pair< pair<int, int>, int> > evs;

        for (int i = 0; i < cur_segs.size(); ++i) {
            auto p = cur_segs[i];
            int l = p.first.first;
            int r = p.first.second;

            evs.insert({{l, 0}, i});
            evs.insert({{r, 1}, i});
        }

        int opened = 0, last_x = -1;
        ll mx = -1;
        ll cur_pressure = 0;
        int len = 0;
        for (auto p : evs) {
            int x = p.first.first;
            int type = p.first.second;
            int id = p.second;
            if (type == 0) {
                //opens

                if (opened == 0) {
                    last_x = x;
                }
                ++opened;
                cur_pressure += cur_segs[id].second;
                mx = max(mx, cur_pressure);
            } else {
                --opened;
                if (opened == 0) {
                    len += x - last_x + 1;
                }
                cur_pressure -= cur_segs[id].second;
                mx = max(mx, cur_pressure);
            }
        }
        if (len < k) continue;
        ans = min(ans, mx);
    }
    if (ans == INF) {
        cout << "-1\n";
    } else {
        cout << ans << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;

    if (n <= 10) {
        solve_1();
    }
}
