import java.util.Scanner;

public class PannaCotta {
	
	static long lcm(long a, long b) {
		return (a * (b / gcd(a,b )));
	}
	
	static long gcd(long a, long b) {
		if (b == 0) {
			return a;
		}
		return gcd(b, a % b);
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int g = in.nextInt();
		while (g-- > 0) {
			long cur = 1L;
			while (true) {
				long next = cur + 1;
				System.out.println("X " + next);
				long a = in.nextLong();
				if (a == -1) {
					return;
				}
				long b = in.nextLong();
				if (a == 0) {
					System.out.println("N " + cur);
					break;
				} 
				cur = lcm(cur, b);
				
			}
			String res = in.next();
			if (!res.equals("Correct")) {
				return;
			}
			
		}
	}
}
