#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <ctime>

using namespace std;

#pragma warning(disable : 4996)

const int MAXN = 2e5 + 10;

int n, a[MAXN], last, now, x[MAXN];

bool f(int m) {
	for (int i = 0; i < MAXN; i++) {
		a[i] = 0;
	}
	for (int i = 0; i <= x[0]; i++) {
		a[i] = 1;
	}
	int last = x[0];
	for (int i = 1; i < n; i++) {
		for (int j = last + 1; j < MAXN; j++) {
			a[j] = 0;
		}
		if (a[x[i]] == m) {
			int l = x[i] - 1;
			while (l > -1 && a[l] == m) {
				l--;
			}
			if (l < 0) return false;
			a[l]++;
		}
		else {
			a[x[i]]++;
		}
		last = x[i];
	}
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
	/*freopen("", "r", stdin);
	freopen("", "w", stdout);*/
#endif
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i];
		x[i]--;
	}
	int l = 0;
	int r = 1e9;
	while (r - l > 1) {
		int mid = r + l >> 1;
		if (f(mid)) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	cout << r;
	return 0;
}