#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <ctime>
#include <unordered_map>

using namespace std;

#pragma warning(disable : 4996)

const int MAXN = 1e5 + 10;

int n, a[MAXN];

bool f(int m) {
	vector < int > now(300000, 0);
	for (int i = 0; i < a[0]; i++) {
		now[i] = 1;
	}
	for (int i = 1; i < n; i++) {
		if (a[i - 1] >= a[i]) {
			int j = a[i] - 1;
			while (j > -1 && now[j] == m) {
				now[j] = 1;
				j--;
			}
			if (j < 0) {
				return false;
			}
			now[j]++;
		}
		else {
			int j = a[i] - 1;
			while (j > a[i - 1] - 1) {
				now[j] = 1;
				j--;
			}
		}
	}
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
	/*freopen("", "r", stdin);
	freopen("", "w", stdout);*/
#endif
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int l = 0;
	int r = 1e9;
	while (r - l > 1) {
		int mid = r + l >> 1;
		if (f(mid)) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	cout << r;
	return 0;
}