#include <bits/stdc++.h>
#define F first
#define S second
#define endl "\n"
#define ALL(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)1e5;

int n;
int data[N];
map <int, int> ma;

bool pplus(int x, int &cnt) {
    if (x == 0) {
        return 0;
    }

    ma[x]++;
    if (ma[x] == cnt) {
        ma.erase(ma.find(x));
        return pplus(x - 1, cnt);
    }

    return 1;
}

bool check(int cnt) {
    bool fl;
    for (int i = 1; i < n; ++i) {
        if (data[i] <= data[i - 1]) {
            auto tmp = ma.upper_bound(data[i]);
            ma.erase(tmp, ma.end());

            fl = pplus(data[i], cnt);
            if (!fl) {
                return 0;
            }
        }
    }

    return 1;
}

int main() {
    ios::sync_with_stdio(false);
    #ifdef _HOME_
        //freopen("in.in", "r", stdin);
        //freopen("in.in", "w", stdout);
    #endif // _HOME_

    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> data[i];
    }

    bool fl = 1;
    for (int i = 1; i < n; ++i) {
        if (data[i] <= data[i - 1]) {
            fl = 0;
            break;
        }
    }

    if (fl) {
        cout << 1 << endl;
        return 0;
    }

    int l = 0, r = (int)1e5, m;

    while (r - l > 1) {
        m = (l + r) >> 1;

        map <int, int> tmp;
        swap(ma, tmp);

        if (check(m)) {
            r = m;
        } else {
            l = m;
        }
    }

    cout << r << endl;

    return 0;
}
