#include <bits/stdc++.h>
#define F first
#define S second
#define endl "\n"
#define ALL(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)1e5;

int n, k;
pair <pair <int, int>, int> data[N];

ll check(vector <pair <pair <int, int>, int> > data) {
    ll res = 0, np = 0;

    vector <pair <int, int> > her;
    for (auto v : data) {
        her.push_back({v.F.F, -v.S});
        her.push_back({v.F.S, v.S});
    }

    sort(ALL(her));

    int cnt = 0;
    int last = 0;
    for (auto v : her) {
        if (cnt == 0) {
            if (v.F - last > 1) {
                return (ll)1e18;
            }
        }

        np -= v.S;
        res = max(res, np);
        if (v.S < 0) {
            ++cnt;
        } else {
            --cnt;
        }
        last = v.F;
    }

    if (k - last > 0) {
        return (ll)1e18;
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    #ifdef _HOME_
        //freopen("in.in", "r", stdin);
        //freopen("in.in", "w", stdout);
    #endif // _HOME_

    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> data[i].F.F >> data[i].F.S >> data[i].S;
    }

    if (n <= 20) {
        ll ans = (ll)1e18;
        for (int mask = 1; mask < (1 << n); ++mask) {
            vector <pair <pair <int, int>, int> > her;
            for (int i = 0; i < n; ++i) {
                if ((mask & (1 << i)) != 0) {
                    her.push_back(data[i]);
                }
            }

            ans = min(ans, check(her));
        }

        if (ans == (ll)1e18) {
            cout << -1;
        } else {
            cout << ans;
        }
    }

    return 0;
}
