#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
using namespace std;
typedef long long ll;
typedef long double ld;

inline ll get() {
	ll x;
	cin >> x;
	return x;
}

void solve();

int main() {
#ifdef _DEBUG
	freopen("../input.txt", "r", stdin);
	freopen("../output.txt", "w", stdout);
#endif
	solve();
}

const ll INF = 2e18;
const pair<ll, ll> kuk = { 0ll, 0ll };

struct IT {
	map<ll, pair<ll,ll>> t;
	map<ll, pair<ll,ll>> sm;
	ll sz;
	IT(ll k) {
		sz = 1;
		while (sz < k) sz *= 2;
		sz--;
	}
	void push(ll v) {
		pair<ll,ll> kek = sm[v];
		if (sm[v * 2 + 1] == kuk) sm[v * 2 + 1] = kek;
		else sm[v * 2 + 1] = min(sm[v * 2 + 1], kek);
		if (sm[v * 2 + 2] == kuk) sm[v * 2 + 2] = kek;
		else sm[v * 2 + 2] = min(sm[v * 2 + 2], kek);
		sm[v] = { INF, INF };
	}
	pair<ll,ll> update(ll v, ll tl, ll tr, ll l, ll r, ll x, ll num) {
		if (tl > l || tr < r || l > r) return{ INF, INF };
		if (tl == l && tr == r) {
			if (sm[v] == kuk) sm[v] = { x, num };
			else sm[v] = min(sm[v], { x, num });
			if (t[v] == kuk) return sm[v];
			else return min(t[v], sm[v]);
		}
		ll tm = (tr + tl) / 2;
		t[v] = min(update(v * 2 + 1, tl, tm, l, min(tm, r), x, num), update(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r, x, num));
	}
	void update(ll l, ll r, pair<ll, ll> kek) {
		update(0, 0, sz, l, r, kek.first, kek.second);
	}
	pair<ll, ll> get_min(ll v, ll tl, ll tr, ll pos) {
		if (tl > pos || tr < pos) return{ INF, INF };
		if (tl == tr && tl == pos) {
			if (t[v] == kuk) return{ INF, INF };
			return t[v];
		}
		push(v);
		ll tm = (tr + tl) / 2;
		t[v] = min(get_min(v * 2 + 1, tl, tm, pos), get_min(v * 2 + 2, tm + 1, tr, pos));
		return t[v];
	}
	pair<ll, ll> get_min(ll pos) {
		return get_min(0, 0, sz, pos);
	}
};

bool comp(pair<ll, ll> a, pair<ll, ll> b) {
	if (a.first == b.first) return a.second > b.second;
	return a.first < b.first;
}

void solve() {
	ll n = get(), k = get();
	vector<pair<pair<ll,ll>, ll>> kek(n);
	vector<ll> posX, pos;
	vector<pair<ll, ll>> tt;
	for (ll i = 0;i < n;i++) {
		cin >> kek[i].first.first >> kek[i].first.second >> kek[i].second;
		kek[i].first.first--, kek[i].first.second--;
	}
	ll mn = INF;
	for (ll i = 1;i < (1ll << n);i++) {
		ll u = true;
		vector<pair<pair<ll, ll>, ll>> nk;
		for (ll j = 0;j < n;j++) {
			if (i & (1ll << j)) nk.push_back(kek[j]);
		}
		sort(nk.begin(), nk.end());
		ll mx = 0;
		ll nw = 0;
		vector<pair<ll, ll>> line;
		for (ll j = 0;j < nk.size();j++) {
			line.push_back({ nk[j].first.first, nk[j].second });
			line.push_back({ nk[j].first.second, -nk[j].second });
		}
		sort(line.begin(), line.end(), comp);
		if (line[0].first != 0) continue;
		if (line.back().first != k - 1) continue;
		for (ll j = 0;j < line.size();j++) {
			nw += line[j].second;
			if (line[j].first != k - 1 && nw == 0 && (j == line.size() - 1 || line[j+1].first != line[j].first + 1)) {
				u = false;
				break;
			}
			mx = max(nw, mx);
		}
		if (u) {
			mn = min(mx, mn);
		}
	}
	if (mn == INF) cout << -1;
	else cout << mn;
}