#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>

using namespace std;

int n;
vector<int> lens(n);

int num_of_var(int len, int kol){
	if (kol == 1){
		return 1;
	}
	int res = kol;
	int ch = 1;
	while (ch < len && res < n){
		res *= kol;
		ch++;
	}
	return res;
}

int less_len(int now_k, int len, int x, int old_len){
	int number = num_of_var(len, x) - now_k;
	int prst = floor(log(number) / log(x)) - (old_len - len);
	if (prst <= 0){
		return num_of_var(old_len - len, x) - 1;
	}
	return prst;
}

bool check(int x){
	int now_k = num_of_var(lens[0], x) - 1;
	for (int i = 1; i < n; i++){
		if (now_k == 0){
			return false;
		}
		if (lens[i] == lens[i - 1]){
			now_k--;
		}
		else if (lens[i] > lens[i - 1]){
			now_k = (now_k + 1) * num_of_var(lens[i] - lens[i - 1], x) - 1;
		}
		else{
			now_k = less_len(now_k, lens[i], x, lens[i - 1]);
		}
	}
	return true;
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	lens.resize(n);
	for (int i = 0; i < n; i++){
		cin >> lens[i];
	}
	int m;
	int l = 0;
	int r = 1000000000;
	while (l + 1 < r){
		m = (l + r) >> 1;
		if (check(m)){
			r = m;
		}
		else{
			l = m;
		}
	}
	cout << r;
}