#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>

using namespace std;

long long n;
vector<long long> lens(n);

long long num_of_var(long long len, long long kol){
	if (kol == 1){
		return 1;
	}
	long long res = kol;
	long long ch = 1;
	while (ch < len && res < n){
		res *= kol;
		ch++;
	}
	return res;
}

long long less_len(long long now_k, long long len, long long x, long long old_len){
	long long number = num_of_var(len, x) - now_k;
	long long prst = floor(log(number) / log(x)) - (old_len - len);
	if (prst <= 0){
		return num_of_var(old_len - len, x) - 1;
	}
	return prst;
}

bool check(long long x){
	long long now_k = num_of_var(lens[0], x) - 1;
	for (long long i = 1; i < n; i++){
		if (now_k == 0 && lens[i] <= lens[i - 1]){
			return false;
		}
		if (lens[i] == lens[i - 1]){
			now_k--;
		}
		else if (lens[i] > lens[i - 1]){
			now_k = ((now_k + 1) * num_of_var(lens[i] - lens[i - 1], x) - 1) % 1000000000;
		}
		else{
			now_k = less_len(now_k, lens[i], x, lens[i - 1]);
		}
	}
	return true;
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	lens.resize(n);
	for (long long i = 0; i < n; i++){
		cin >> lens[i];
	}
	long long m;
	long long l = 0;
	long long r = 100000;
	while (l + 1 < r){
		m = (l + r) >> 1;
		if (check(m)){
			r = m;
		}
		else{
			l = m;
		}
	}
	cout << r;
}