#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <cmath>

using namespace std;

#define endl '\n'

int x, y;
int n;
string s;

bool rec(int l, int r, int u, int d, int tx, int ty, int ind){
	if (x == tx && y == ty){
		cout << l << " " << u << " " << r << " " << d;
		return true;
	}
	if (ind == n){
		return false;
	}
	if (ind == -1){
		if (rec(l, r, u, d, tx, ty, ind + 1) || rec(0, r, u, d, tx, ty, ind + 1) || rec(l, 0, u, d, tx, ty, ind + 1) || rec(l, r, 0, d, tx, ty, ind + 1) || rec(l, r, u, 0, tx, ty, ind + 1)){
			return true;
		}
		return false;
	}
	if (l == n){
		if (s[ind] == 'L'){
			if (rec(l, r, u, d, tx - 1, ty, ind + 1)){
				return true;
			}
		}
		if (rec(ind, r, u, d, tx, ty, ind)){
			return true;
		}
	}
	if (l != n && s[ind] == 'L'){
		if (rec(l, r, u, d, tx, ty, ind + 1)){
			return true;
		}
	}
	if (r == n){
		if (s[ind] == 'R'){
			if (rec(l, r, u, d, tx + 1, ty, ind + 1)){
				return true;
			}
		}
		if (rec(l, ind, u, d, tx, ty, ind)){
			return true;
		}
	}
	if (r != n && s[ind] == 'R'){
		if (rec(l, r, u, d, tx, ty, ind + 1)){
			return true;
		}
	}
	if (u == n){
		if (s[ind] == 'U'){
			if (rec(l, r, u, d, tx, ty + 1, ind + 1)){
				return true;
			}
		}
		if (rec(l, r, ind, d, tx, ty, ind)){
			return true;
		}
	}
	if (u != n && s[ind] == 'U'){
		if (rec(l, r, u, d, tx, ty, ind + 1)){
			return true;
		}
	}
	if (d == n){
		if (s[ind] == 'D'){
			if (rec(l, r, u, d, tx, ty - 1, ind + 1)){
				return true;
			}
		}
		if (rec(l, r, u, ind, tx, ty, ind)){
			return true;
		}
	}
	if (d != n && s[ind] == 'D'){
		if (rec(l, r, u, d, tx, ty, ind + 1)){
			return true;
		}
	}
	return false;
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> s >> x >> y;
	if (x == 0 && y == 0){
		cout << "0 0 0 0 ";
		return 0;
	}
	if (!rec(n, n, n, n, 0, 0, -1)){
		cout << -1;
	}
}