#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <cassert>
///compilation should be fast
///do not include everything
using namespace std;
const long long MAXN = 1e5 + 10;
const long long INF = 4e9 + 10;
long long zap[MAXN][3];
vector <pair <long long, long long> > v;
vector <vector <long long> > gv;
set <long long> s;
map <long long, long long> m;
long long n, k;
bool check(long long mw){
    m.clear();
    m.insert(make_pair(1, 0));
    for (long long i = 0; i < n; i++){
        long long y = gv[i][1];
        long long x = gv[i][0];
        long long w = gv[i][2];
        //cout << x << ' ' << y << ' ' << w << endl;
        long long val = INF;
        for (map <long long, long long>::iterator it = m.begin(); it != m.end(); it++){
            long long cp = (it->first);
            long long cw = (it->second);
            if (cp == x){
                if (w <= mw){
                    val = min(val, w);
                }
            }
            if (cp > x){
                if (cw + w <= mw){
                    val = min(val, w);
                }
            }
        }
        //for (map <long long, long long>::iterator it = m.begin(); it != m.end(); it++){
        //    cout << (it->first) << ' ' << (it->second) << endl;
        //}
        //cout << endl << endl;
        if (val == INF){
            continue;
        }
        if (m.find(y + 1) == m.end()){
            m.insert(make_pair(y + 1, val));
        }
        else{
            m[y + 1] = min(m[y + 1], val);
        }
    }
    if (m.find(k + 1) == m.end()){
        return false;
    }
    else{
        return true;
    }
}

signed main(){

    cin >> n >> k;
    bool flag = true;
    for (long long i = 0; i < n; i++){
        cin >> zap[i][0] >> zap[i][1] >> zap[i][2];
        if (zap[i][2] > 1){
            flag = false;
        }
        v.push_back(make_pair(zap[i][0], zap[i][1]));
        vector <long long> t;
        t.resize(3);
        t[0] = zap[i][0];
        t[1] = zap[i][1];
        t[2] = zap[i][2];
        gv.push_back(t);
    }

    if (flag){
        sort(v.begin(), v.end());
        s.insert(1);
        long long mx = 1;
        for (long long i = 0; i < n; i++){
            long long x = v[i].first;
            long long y = v[i].second;
            if (x <= mx){
                mx = max(mx, y + 1);
            }
            if (s.find(x) != s.end()){
                s.insert(y + 1);
            }
        }
        // 5 1cout << mx << endl;
        if (mx != k + 1){
            cout << -1;
        }
        else if (s.find(k + 1) != s.end()){
            cout << 1;
        }
        else{
            cout << 2;
        }
        cout << endl;
    }
    else{
        sort(gv.begin(), gv.end());
        //check(4);
        sort(v.begin(), v.end());
        long long mx = 1;
        for (long long i = 0; i < n; i++){
            long long x = v[i].first;
            long long y = v[i].second;
            if (x <= mx){
                mx = max(mx, y + 1);
            }
        }
        if (mx != k + 1){
            cout << -1 << endl;
            return 0;
        }
        long long left = 0;
        long long right = INF;
        while (right - left > 1){
            long long mid = (left + right) / 2;
            if (check(mid)){
                right = mid;
            }
            else{
                left = mid;
            }
        }
        cout << right;
    }

    return 0;
}
