#include <bits/stdc++.h>

#define All(x) x.begin(), x.end()
#define SZ(x) (int)x.size()
#define pushb push_back
#define popb pop_back
#define filename ""
#define __ fflush(stdout)
#define F first
#define S second

typedef long long ll;
typedef long double ld;

using namespace std;

void file() {
	#ifdef home
		freopen(".in", "r", stdin);
		freopen("2.out", "w", stdout);
	#else
		//freopen(filename".in", "r", stdin);
		//freopen(filename".out", "w", stdout);
	#endif
}

const int N = 2e5, inf = 2e9, MOD = 1e9 + 7, m = 2e5;

const ll INF = 1e18 + 1e9;

const int dx[] = {1, -1, 0, 0, 1, -1, 1, -1};
const int dy[] = {0, 0, 1, -1, 1, -1, -1, 1};

int l[N];

int n;

bool can(int x) {
	vector<int> now;
	for (int i = 1; i <= n; i++) {
		if (l[i] > l[i - 1]) {
			while (SZ(now) < l[i]) now.pushb(0);
		}
		else {
			while (SZ(now) > l[i]) now.popb();
			bool can = 0;
			for (int j = SZ(now) - 1; j >= 0; j--) {
				if (now[j] < x - 1) {
					now[j]++;
					for (int k = j + 1; k < SZ(now); k++) now[k] = 0;
					can = 1;
					break; 
				}
			}
			if (!can) return 0;
		}	
	}
	return 1;
}

pair<int, int> t[N * 7];

int ch[N * 7];

void push(int v, int y, int l, int r) {
	if (ch[v] == 0) return;
	t[v].S = r;
	t[v].F = ch[v];
	ch[v + v] = ch[v + v + 1] = ch[v];
	ch[v] = 0;
}

pair<int, int> combine(int y, pair<int, int> f, pair<int, int> s) {
	if (s.F < y) return s;
	if (f.F < y) return f;
	return s;
}

void upd(int y, int v, int l, int r, int L, int R, int x) {
	push(v, y, l, r);
	if (L > R || r < L || R < l) return;
	if (L <= l && R >= r) {
		ch[v] = x;
		push(v, y, l, r);
		return;
	}
	int mid = (l + r) / 2;
	upd(y, v + v, l, mid, L, R, x);
	upd(y, v + v + 1, mid + 1, r, L, R, x);
	t[v] = combine(y, t[v + v], t[v + v + 1]);
}

bool ok(int x) {
	upd(x, 1, 1, m, 1, m, x);
	upd(x, 1, 1, m, 1, l[1], 1);         
	for (int i = 2; i <= n; i++) {
		if (l[i] > l[i - 1]) upd(x, 1, 1, m, l[i - 1] + 1, l[i], 1);
		else if (l[i] <= l[i - 1]) {
			upd(x, 1, 1, m, l[i] + 1, l[i - 1], x);
			push(1, x, 1, m);
			pair<int, int> p = t[1];
			if (p.F == x) return 0;
			upd(x, 1, 1, m, p.S, p.S, p.F + 1);
			upd(x, 1, 1, m, p.S + 1, l[i], 1);
		}
	}
	return 1; 
}

int main() {
	file();
	cin >> n;
	for (int i = 1; i <= n; i++) scanf("%d", l + i);
	int l = 1;
	int r = 1e5;
	int ans = -1;
	while (l <= r) {
		int mid = (l + r) / 2;
		if (ok(mid)) ans = mid, r = mid - 1;
		else l = mid + 1;
	}
	cout << ans;
	return 0;
}