#include <bits/stdc++.h>

#define All(x) x.begin(), x.end()
#define SZ(x) (int)x.size()
#define pushb push_back
#define popb pop_back
#define filename ""
#define __ fflush(stdout)
#define F first
#define S second

typedef long long ll;
typedef long double ld;

using namespace std;

void file() {
	#ifdef home
		freopen(".in", "r", stdin);
		freopen("2.out", "w", stdout);
	#else
		//freopen(filename".in", "r", stdin);
		//freopen(filename".out", "w", stdout);
	#endif
}

const int N = 22, inf = 2e9, MOD = 1e9 + 7;

const ll INF = 1e18 + 1e9;

const int dx[] = {1, -1, 0, 0, 1, -1, 1, -1};
const int dy[] = {0, 0, 1, -1, 1, -1, -1, 1};

int l[N], r[N], p[N], pref[N];

ll a[N];

void compress(int n, int &k) {
	vector<pair<int, pair<int, int > > > v;
	v.pushb({k, {3, 0}});
	for (int i = 0; i < n; i++) v.pushb({l[i], {1, i}}), v.pushb({r[i], {2, i}});
	sort(All(v));
	int C = 1;
	if (v[0].S.F == 1) l[v[0].S.S] = C;
	if (v[0].S.F == 2) r[v[0].S.S] = C;
	if (v[0].S.F == 3) k = C;
	for (int i = 1; i < SZ(v); i++) {
		if (v[i].F != v[i - 1].F) C += ((v[i].F - v[i - 1].F) > 1) + 1;
		if (v[i].S.F == 1) l[v[i].S.S] = C;
		if (v[i].S.F == 2) r[v[i].S.S] = C;
		if (v[i].S.F == 3) k = C;
	}
}

int main() {
	file();
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; i++) scanf("%d %d %d", l + i, r + i, p + i);
	compress(n, k);
	if (n <= 10) {	
		ll ans = INF;
		for (int mask = 0; mask < (1 << n); mask++) {
			memset(a, 0, sizeof(a));
			for (int i = 0; i < n; i++) {
				if (mask & (1 << i)) for (int j = l[i]; j <= r[i]; j++) a[j] += p[i];
			}	                           
			ll mx = 0;
			for (int j = 1; j <= k; j++) {
				if (!a[j]) mx = INF;
				else mx = max(mx, a[j]);
			} 
			ans = min(ans, mx);
		}
		if (ans == INF) ans = -1;
		cout << ans;
	}
	else {
		for (int i = 1; i <= k; i++) pref[i] = 1;
		for (int i = 1; i <= k; i++) {
			if (pref[i - 1]) continue;
			bool can = 0;
			for (int j = 0; j < n; j++) {
				if (l[j] == i) pref[r[j]] = 0;
				if (l[j] <= i && r[j] >= i) can = 1;
			}
			if (!can) {
				cout << -1;
				return 0;
			}
		}
		cout << pref[k] + 1;              
	}
	return 0;
}