#include<bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e18 + 7;

ll bin_search(ll x, vector <pair <ll, ll> > &ans) {
    ll l = -1, r = ans.size();
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (ans[mid].first >= x) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, k;
    cin >> n >> k;
    vector <pair <pair <ll, ll>, ll> > data(n);
    for (ll i = 0; i < n; i++) {
        cin >> data[i].first.second >> data[i].first.first >> data[i].second;
    }
    sort(data.begin(), data.end());
    vector <pair <ll, ll> > ans;

    /*for (ll i = 0; i < data.size(); i++) {
        ll l = data[i].first.second, r = data[i].first.first, w = data[i].second;
        ll now = w;
        if (l == 1) {
            if (!ans.empty() && ans.back().first == r && ans.back().second < now) {
                continue;
            }
            while (!ans.empty() && ans.back().second >= now) {
                ans.pop_back();
            }
            ans.push_back({r, now});
            continue;
        }
        ll pos = bin_search(l - 1, ans);
        if (ans.empty() || ans[pos].first < l - 1) {
            cout << -1;
            return 0;
        }
        if (ans[pos].first > l - 1) {
            now += ans[pos].second;
        }
        if (!ans.empty() && ans.back().first == r && ans.back().second < now) {
            continue;
        }
        while (!ans.empty() && ans.back().second >= now) {
            ans.pop_back();
        }
        ans.push_back({r, now});
    }
    ll ans1 = -1;
    for (ll i = ans.size() - 1; i >= 0; i--) {
        if (ans[i].first >= k) {
            ans1 = ans[i].second;
        }
    }
    cout << ans1;*/
    ll l = 0, r = INF;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        bool fl = 0;
        for (ll i = 0; i < data.size(); i++) {
            ll l = data[i].first.second, r = data[i].first.first, w = data[i].second;
            ll now = w;
            if (now > mid) continue;
            if (l == 1) {
                if (!ans.empty() && ans.back().first == r && ans.back().second < now) {
                    continue;
                }
                while (!ans.empty() && ans.back().second >= now) {
                    ans.pop_back();
                }
                ans.push_back({r, now});
                continue;
            }
            ll pos = bin_search(l - 1, ans);
            if (ans.empty() || ans[pos].first < l - 1) {
                continue;
            }
            if (ans[pos].first > l - 1) {
                now += ans[pos].second;
            }
            if (now > mid) continue;
            if (!ans.empty() && ans.back().first == r && ans.back().second < w) {
                continue;
            }
            while (!ans.empty() && ans.size() > pos && ans.back().second >= w) {
                ans.pop_back();
            }
            ans.push_back({r, w});
        }
        if (ans.back().first < k) {
            fl = 1;
        }
        if (fl) {
            l = mid;
        } else {
            r = mid;
        }
    }
    if (r == INF) {
        cout << -1;
    } else {
        cout << r;
    }
}
