#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 3e5 + 10;
const long long INF = 1e18;
const int IINF = 1e9;

int n, k;
set<int> s;
map<int, int> mp;
int L[MAX_N], R[MAX_N], p[MAX_N];
pair<int, int> ev[MAX_N];
bool dp[MAX_N];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    int mxp = 0;
    for (int i = 0; i < n; i++) {
        cin >> L[i] >> R[i] >> p[i];
        mxp = max(mxp, p[i]);
        s.insert(L[i]);
        if (L[i] != 1) {
            s.insert(L[i] - 1);
        }
        if (L[i] != k) {
            s.insert(L[i] + 1);
        }
        if (R[i] != 1) {
            s.insert(R[i] - 1);
        }
        if (R[i] != k) {
            s.insert(R[i] + 1);
        }
        s.insert(R[i]);
    }
    s.insert(1);
    s.insert(k);
    int cnt = 0;
    for (auto itr = s.begin(); itr != s.end(); itr++) {
        mp[*itr] = cnt++;
    }
    k = cnt;
    for (int i = 0; i < n; i++) {
        L[i] = mp[L[i]];
        R[i] = mp[R[i]];
    }
    if (n <= 10) {
        long long ans = INF;
        for (int mask = 0; mask < (1 << n); mask++) {
            long long r[k];
            fill(r, r + k, 0);
            for (int i = 0; i < n; i++) {
                if ((mask >> i) & 1) {
                    for (int j = L[i]; j <= R[i]; j++) {
                        r[j] += p[i];
                    }
                }
            }
            long long mx = 0;
            for (int i = 0; i < k; i++) {
                mx = max(mx, r[i]);
                if (r[i] == 0) {
                    break;
                }
                if (i == k - 1) {
                    ans = min(ans, mx);
                }
            }
        }
        if (ans == INF) {
            cout << "-1\n";
        } else {
            cout << ans << "\n";
        }
        return 0;
    }
    int mx = 0;
    for (int i = 0; i < n; i++) {
        ev[i] = {L[i], R[i]};
        if (mx < L[i]) {
            cout << "-1\n";
            return 0;
        }
        mx = max(mx, R[i] + 1);
    }
    if (mx != k) {
        cout << "-1\n";
        return 0;
    }
    sort(ev, ev + n);
    int pos = 0;
    dp[0] = 1;
    for (int i = 0; i < n; i++) {
        if (dp[ev[i].first]) {
            dp[ev[i].second + 1] = 1;
        }
    }
    if (dp[k]) {
        cout << "1\n";
    } else {
        cout << "2\n";
    }
}
