#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <stack>

using namespace std;

int n;
int m[100000];

bool prov(int mid){
    map<int, int> mp;
    stack<int> st;
    for (int i = 1; i < n; ++i){
        if (m[i] <= m[i - 1]){
            int id = m[i];
            mp[id]++;
            while (!st.empty() && st.top() > id){
                mp[st.top()] = 0;
                st.pop();
            }
            if (st.empty() || st.top() != id)
                st.push(id);
            while (mp[id] == mid){
                st.pop();
                mp[id] = 0;
                --id;
                if (id == 0)
                    return false;
                st.push(id);
                mp[id]++;
            }
        }
    }
}

void bin_s(){
    int l = 0, r = 1e5;
    while(r - l > 1){
        int mid = (l + r) / 2;
        if (prov(mid))
            r = mid;
        else
            l = mid;
    }
    cout << r << endl;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i = 0; i < n; ++i){
        cin >> m[i];
    }
    bin_s();
    return 0;
}
