#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <stack>

using namespace std;

int n;
int m[100000];

bool prov(int mid){

	map<int, int> mp;
	vector<int> v;
	for (int i = 1; i < n; ++i){
		if (m[i] <= m[i - 1]){
			int id = m[i];
			mp[id]++;

			while (v.size() != 0 && v[v.size() - 1] > id){
				mp[v[v.size() - 1]] = 0;
				v.pop_back();
			}

			if (v.size() == 0 || v[v.size() - 1] != id)
				v.push_back(id);

			while (mp[id] == mid){
				v.pop_back();
				mp[id] = 0;
				--id;
				if (id == 0)
					return false;
				v.push_back(id);
				mp[id]++;
			}
		}
	}
}

void bin_s(){
	int l = -1, r = 1e5;
	while (r - l > 1){
		int mid = (l + r) / 2;
		if (prov(mid))
			r = mid;
		else
			l = mid;
	}
	cout << r;
}


int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	cin >> n;
	for (int i = 0; i < n; ++i){
		cin >> m[i];
	}
	bin_s();
	return 0;
}
