#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <stack>

using namespace std;

int n;
vector<int> m;
map<int, int> mp;

bool prov(int mid){

	mp.clear();
	stack<int> st;

	for (int i = 1; i < n; ++i){
		if (m[i] <= m[i - 1]){
			int id = m[i];
			mp[id]++;

			while (!st.empty() && st.top() > id){
				mp[st.top()] = 0;
				st.pop();
			}

			if (st.empty() || st.top() != id)
				st.push(id);

			while (mp[id] == mid){
                if (!st.empty() && st.top() == id)
                    st.pop();
				mp[id] = 0;
				--id;
				if (id == 0)
					return false;
                if (!st.empty() && st.top() != id)
                    st.push(id);
				mp[id]++;
			}
		}
	}
}

void bin_s(){
	int l = 0, r = 1e5;
	while (r - l > 1){
		int mid = (l + r) / 2;
		if (prov(mid))
			r = mid;
		else
			l = mid;
	}
	cout << r;
}

int main()
{
	cin >> n;
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	for (int i = 0; i < n; ++i){
		int num;
		cin >> num;
		m.push_back(num);
	}
	bin_s();
	return 0;
}
