#define _CRT_SECURE_NO_WARNINGS
#include <cstdlib>
#include <stdio.h>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <utility>
#include <iostream>
#include <string>
#include <queue>
#include <cassert>

using namespace std;

pair<long long, long long> ask(long long x) {
	cout << "X " << x << endl;
	long long a1, a2;
	cin >> a1;
	assert(a1 != -1);
	cin >> a2;
	return make_pair(a1, a2);
}

void ans(long long x) {
	cout << "N " << x << endl;
	string answer;
	cin >> answer;
	assert(answer != "Wrong");
}

struct dr {
	int x, y;
	dr() {}
	dr(int _x, int _y) {
		x = _x, y = _y;
	}
};


int main() {
	if (1) {
		freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
	}
	int n;
	cin >> n;
	vector<int > g(n);
	for (int i = 0; i < n; i++) {
		cin >> g[i];
	}
	int l = 0, r = (int)1e3;
	while (r - l > 1) {
		int m = (l + r) / 2;
		vector<vector<int> > cur(n);
		for (int i = 0; i < n; i++) {
			cur[i].resize(g[i], 0);
		}
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (g[i] > g[i - 1]) {
				for (int j = 0; j < (int)g[i - 1]; j++) {
					cur[i][j] = cur[i - 1][j];
				}
			}
			else {
				ok = false;
				int pos = -1;
				cur[i] = cur[i - 1];
				for (int c = g[i] - 1; c >= 0; c--) {
					if (cur[i][c] < m - 1) {
						cur[i][c]++;
						pos = c;
						ok = true;
						break;
					}
				}
				for (int c = pos + 1; c < g[i]; c++) {
					cur[i][c] = 0;
				}
				if (!ok) break;
			}
		}  
		if (ok) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
	return 0;
}