#define _CRT_SECURE_NO_WARNINGS
#include <cstdlib>
#include <stdio.h>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <utility>
#include <iostream>
#include <string>
#include <queue>
#include <cassert>
#include <map>

using namespace std;
const long long INF = (int)5e15;

struct Node {
	long long val, val2, add, l, r;
	Node() { l = -1, r = -1, add = 0, val = 0; val2 = 0; };
};


Node t[400000];
int it = 2;

int get_l(int v) {
	if (t[v].l == -1) {
		return t[v].l = it++;
	}
	return t[v].l;
}

int get_r(int v) {
	if (t[v].r == -1) {
		return t[v].r = it++;
	}
	return t[v].r;
}

const int dd = (int)1e9;
void push(int v) {
	t[get_l(v)].val += t[v].add;
	t[get_r(v)].val += t[v].add;
	t[get_r(v)].val2 += t[v].add;
	t[get_l(v)].val2 += t[v].add;
	t[get_r(v)].add += t[v].add;
	t[get_l(v)].add += t[v].add;
	t[v].add = 0;
}

void upd(int v, int tl, int tr, int l, int r, long long _val) {
	if (tl != tr)
	push(v); 
	if (l > tr || r < tl)
		return;
	if (tl >= l && tr <= r) {
		t[v].add += _val;
		t[v].val += _val;
		t[v].val2 += _val;
		return;
	}
	int tm = (tl + tr) / 2;
	upd(get_l(v), tl, tm, l, r, _val);
	upd(get_r(v), tm + 1, tr, l, r, _val);
	t[v].val = max(t[get_l(v)].val, t[get_r(v)].val);
	t[v].val2 = min(t[get_l(v)].val2, t[get_r(v)].val2);
}

long long get(int v, int tl, int tr, int l, int r) {
	if (tl != tr)
	push(v);
	if (l > tr || r < tl)
		return -INF;
	if (tl >= l && tr <= r) {
		return t[v].val;
	}
	int tm = (tl + tr) / 2;
	return max(get(get_l(v), tl, tm, l, r), get(get_r(v), tm + 1, tr, l, r));
}

long long get2(int v, int tl, int tr, int l, int r) {
	push(v);
	if (l > tr || r < tl)
		return INF;
	if (tl >= l && tr <= r) {
		return t[v].val;
	}
	int tm = (tl + tr) / 2;
	return min(get2(get_l(v), tl, tm, l, r), get2(get_r(v), tm + 1, tr, l, r));
}


int main() {
	if (1) {
		freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);

	}

	int n;
	cin >> n;
	vector<int > g(n);
	for (int i = 0; i < n; i++) {
		cin >> g[i];
	}
	int l = 0, r = (int)1e4;
	while (r - l > 1) {
		int m = (l + r) / 2;
		vector<int> cur;
		vector<int> last;
		last.resize(g[0], 0);
		bool ok = true;
		for (int i = 1; i < n; i++) {
			cur.resize(0);
			cur.resize(g[i]);
			if (g[i] > g[i - 1]) {
				for (int j = 0; j < (int)g[i - 1]; j++) {
					cur[j] = last[j];
				}
			}
			else {
				ok = false;
				int pos = -1;
				cur = last;
				for (int c = g[i] - 1; c >= 0; c--) {
					if (cur[c] < m - 1) {
						cur[c]++;
						pos = c;
						ok = true;
						break;
					}
				}
				for (int c = pos + 1; c < g[i]; c++) {
					cur[c] = 0;
				}
				if (!ok) break;
			}
			swap(cur, last);
		}
		if (ok) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
	return 0;
}