#define fs first
#define sc second

#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef double D;

int dx[4] = {-1,0,1,0};
int dy[4] = {0,1,0,-1};

map <char, int> tr;

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n;
    cin >> n;

    string dung;
    int xs,ys;

    cin >> dung >> xs >> ys;

    vector <vector <int> > d(4, vector <int> (n));

    tr['L'] = 0;
    tr['U'] = 1;
    tr['R'] = 2;
    tr['D'] = 3;

    int xpos = 0, ypos = 0;
    for (int i = 0; i < n; ++i)
    {
        if (i > 0)
        for (int k = 0; k < 4; ++k)
        {
            d[k][i] = d[k][i - 1];
        }

        int it = tr[dung[i]];
        d[it][i]++;
        xpos += dx[it];
        ypos += dy[it];
    }

    int ans[4] = {n,n,n,n};
    int deltax = xs - xpos;
    int deltay = ys - ypos;

    //cout << deltax << " " << deltay << endl;

    bool have_ans = true;
    int it = 2;

    if (deltax > 0)
        it = 0;

    deltax = abs(deltax);

    int dn = d[it][n - 1];
    if (dn < deltax) have_ans = false;
    else
    {
        int pos = upper_bound(d[it].begin(), d[it].end(), dn - deltax) - d[it].begin();
        ans[it] = pos;
    }

    it = 3;
    if (deltay > 0) it = 1;

    deltay = abs(deltay);

    dn = d[it][n - 1];
     if (dn < deltay) have_ans = false;
    else
    {
        int pos = upper_bound(d[it].begin(), d[it].end(), dn - deltay) - d[it].begin();
        ans[it] = pos;
    }

    if (!have_ans) cout << "-1";
    else
    {
        for (int i = 0; i < 4; ++i) cout << ans[i] << " ";
    }
    return 0;
}
