#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef double D;

struct sha
{
    LL l,r,p;
};

int n,k;
map <int, vector <int> > mp;
map <int, bool> used;
bool go = false;

void dfs(int pos)
{
    used[pos] = true;
    if (pos == k)
    {
        go = true;
        return;
    }
    for (int i = 0; i < mp[pos].size(); ++i)
    {
        int to = mp[pos][i];
        if (!used[to])
        {
            dfs(to);
        }
    }
}

bool cmp(sha a, sha b)
{
    if (a.l == b.l) return a.r < b.r;
    return a.l < b.l;
}

bool bit(int a, int x)
{
    return a & (1 << x);
}
/*
void full_search(vector <sha> a)
{
    sort(a.begin(),a.end(), cmp);
    vector <sha> ss;
    LL ans = 1e12;

    for (int i = 0; i < (1 << n); ++i)
    {
        ss.resize(0);
        for (int j = 0; j < n; ++j)
        {
            if (bit(i,j)) ss.push_back(a[j]);
        }

        if (ss[0].l != 1)

    }
}
*/
int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n >> k;
    vector <sha> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].l >> a[i].r >> a[i].p;
    }
    sort(a.begin(),a.end());

    //if (n <= 10) full_search(a);
    //else
    {
        for (int i = 0; i < n; ++i)
        {
            mp[a[i].l].push_back(a[i].r);
        }
        dfs(1);
        if (go) cout << "1";
        else
        {
            bool have_ans = (a[0].l == 1);
            int r = a[0].r;
            for (int i = 1; i < n; ++i)
            {
                if (a[i].l > r) have_ans = false;
                else r = max(r, a[i].r);
            }
            if (r == k) cout << "2";
            else cout << "-1";
        }
    }
    return 0;
}
