#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

int getx(char r) {
    if (r == 'L')
        return -1;
    if (r == 'R')
        return 1;
    return 0;
}

int gety(char r) {
    if (r == 'D')
        return -1;
    if (r == 'U')
        return 1;
    return 0;
}

void no() {
    cout << -1 << endl;
    exit(0);
}

vector <int> l, r, u, d;

int32_t main() {
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    string s; cin >> s;
    int x, y; cin >> x >> y;
    int curx = 0, cury = 0;
    int cntl = 0, cntr = 0, cntu = 0, cntd = 0;
    l.push_back(0);
    r.push_back(0);
    u.push_back(0);
    d.push_back(0);
    for (int i = 0; i < (int)s.length(); i++) {
        curx += getx(s[i]),
        cury += gety(s[i]);
        if (s[i] == 'L')
            cntl++, l.push_back(i);
        if (s[i] == 'R')
            cntr++, r.push_back(i);
        if (s[i] == 'U')
            cntu++, u.push_back(i);
        if (s[i] == 'D')
            cntd++, d.push_back(i);
    }

    int dx = curx - x, dy = cury - y;

    int ansl = n, ansr = n, ansu = n, ansd = n;

    if (dx < 0) {
        if (cntl < (-dx))
            no();
        ansl = l[(int)l.size() + dx];
    } else if (dx > 0) {
        if (cntr < dx)
            no();
        ansr = r[(int)r.size() - dx];
    }

    if (dy < 0) {
        if (cntd < (-dy))
            no();
        ansd = d[(int)d.size() + dy];
    } else if (dy > 0) {
        if (cntu < dy)
            no();
        ansu = u[(int)u.size() - dy];
    }

    cout << ansl << " " << ansu << " " << ansr << " " << ansd << endl;

    return 0;
}
