#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <deque>
#include <map>

using namespace std;

#define int int64_t

map <int, int> r;

void f(int a, int d) {
    for (int i = 2; i * i <= a && a != 1; i++) {
        while (a % i == 0) {
            a /= i;
            r[i] += d;
        }
    }
    if (a != 1) {
        r[a] += d;
        a = 1;
    }
}

int get() {
    int ans = 1;
    for (map <int, int> :: iterator it = r.begin(); it != r.end(); ++it)
        for (int i = 0; i < (*it).second; i++)
            ans *= (*it).first;
    return ans;
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int q; cin >> q;
    int cnt = 0;
    for (int test = 0; test < q; test++) {
        int c = 2;
        while (true) {
            int a, b;
            if (c > 1e18)
                a = 0, b = 1;
            else {
                cout << "X " << c << endl;
                //assert(cnt + 1 < 60);
                cin >> a >> b;
                cnt++;
            }
            if (a != 1 || b != c) {
                int p = c / 2;
                r.clear();
                f(b, 1);
                f(p, 1);
                f(b - a * c, -1);
                cout << "N " << get() << endl;
                string s; cin >> s;
                //assert(s == "Correct");
                break;
            }
            c *= 2;
        }
    }

    return 0;
}

