#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
#define int long long
#define pii pair <int, int>
#define kal pair <pii, int>
#define ff first
#define ss second
#define mp make_pair
#define pb push_back
const int INF2 = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int INF = 1e15;

int n, m;
vector <kal> pts;


int32_t main() {
	cin >> n >> m;
	pts.resize(n);
	for (auto & i : pts)
		cin >> i.ff.ff >> i.ff.ss >> i.ss;

	n++;
	pts.pb(mp(mp(0, 0), 0));
	sort(pts.begin(), pts.end());


	vector <vector <int> > dp(n, vector <int> (n, INF2));
	for (int i = 0; i < n; ++i)
		if (pts[i].ff.ff == 1)
			dp[0][i] = pts[i].ss;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			for (int kk = j + 1; kk < n; ++kk) {
				auto k = pts[kk];
				if (pts[i].ff.ss < k.ff.ff && k.ff.ff <= pts[j].ff.ss)
					dp[j][kk] = min(dp[j][kk], pts[j].ss + k.ss);
				if (pts[i].ff.ss < k.ff.ff && k.ff.ff == pts[j].ff.ss + 1)
					dp[j][kk] = min(dp[j][kk], k.ss);
			}
		} 
	}

	int ans = INF2;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (pts[j].ff.ss == m) {
				ans = min(ans, dp[i][j]);
			}
		} 
	}
	if (ans == INF2)
		cout << "-1\n";
	else
		cout << ans << endl;
}
