#include <iostream>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

bool check(int k, vector<int> &arr)
{
	int n = arr.size();
	vector<pair<int, int> > ll;
	int prev = 0;
	for (int u : arr)
	{
		if (u > prev)
		{
			prev = u;
			continue;
		}
		if (k == 1)
			return 0;
		while (!ll.empty() && ll.back().first > u)
			ll.pop_back();
		if (ll.empty() || ll.back().first != u)
			ll.push_back({ u, 0 });
		ll.back().second++;
		while (ll.back().second == k)
		{
			if (ll.back().first == 1)
				return 0;
			int q = ll.back().first;
			ll.pop_back();
			if (ll.empty() || ll.back().first != q - 1)
				ll.push_back({ q - 1, 0 });
			ll.back().second++;
		}
		prev = u;
	}
	return 1;
}

int main()
{
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int &i : arr)
		cin >> i;
	int L = 0, R = n;
	while (R - L > 1)
	{
		int M = (R + L) / 2;
		if (check(M, arr))
			R = M;
		else
			L = M;
	}
	cout << R;
	return 0;
}