#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	string s;
	int n;
	cin >> n >> s;
	int cnt['Z'] = {};
	for (char c : s)
		cnt[c]++;
	int x, y;
	cin >> x >> y;
	char L = 'L', R = 'R', D = 'D', U = 'U';
	if (x < 0)
	{
		swap(L, R);
		x = -x;
	}
	if (y < 0)
	{
		swap(U, D);
		y = -y;
	}
	cnt[L] = cnt[D] = 0;
	if (cnt[R] < x || cnt[U] < y)
	{
		cout << -1;
		return 0;
	}
	cnt[R] = x, cnt[U] = y;
	int bn['Z'] = {};
	for (int i = 0; i < n; i++)
	{
		cnt[s[i]]--;
		if (cnt[s[i]] == 0)
			bn[s[i]] = i + 1;
	}
	cout << bn['L'] << " " << bn['U'] << " " << bn['R'] << " " << bn['D'];
	return 0;
}