#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int int64_t

using namespace std;

int dp[3001][3001];

int32_t main()
{
	int n, k;
	cin >> n >> k;
	if (n <= 3000)
	{
		vector<pair<pair<int, int>, int> > rarr(n);
		for (auto &e : rarr)
			cin >> e.first.second >> e.first.first >> e.second;
		sort(rarr.begin(), rarr.end());
		vector<pair<int, int> > arr(n);
		vector<int> p(n);
		for (int i = 0; i < n; i++)
		{
			arr[i] = rarr[i].first;
			p[i] = rarr[i].second;
		}
		int ans = 1e18;
		for (int i = 0; i < n; i++)
		{
			if (arr[i].second == 1)
				dp[i + 1][0] = p[i];
			else
				dp[i + 1][0] = 0;
			int lb = 0;
			for (int j = 0; j < i; j++)
			{
				dp[i + 1][j + 1] = dp[i + 1][j];
				if (arr[j].first >= arr[i].second)
				{
					if (dp[j + 1][lb] == 0)
						continue;
					int nv = max(dp[j + 1][lb], p[i] + p[j]);
					if (dp[i + 1][j + 1] == 0 || dp[i + 1][j + 1] > nv)
						dp[i + 1][j + 1] = nv;
				}
				else if (arr[j].first == arr[i].second - 1)
				{
					if (dp[j + 1][j] == 0)
						continue;
					int nv = max(p[i], dp[j + 1][j]);
					if (dp[i + 1][j + 1] == 0 || dp[i + 1][j + 1] > nv)
						dp[i + 1][j + 1] = nv;
				}
				else
					lb++;
			}
			if (arr[i].first == k && dp[i + 1][i] != 0)
				ans = min(ans, dp[i + 1][i]);
		}
		if (ans > 1e15)
			cout << -1;
		else
			cout << ans;
		return 0;
	}
	vector<pair<int, int> > arr(n);
	for (auto &e : arr)
	{
		int x;
		cin >> e.second >> e.first >> x;
	}
	sort(arr.begin(), arr.end());
	set<int> ok_bords, av_bords;
	ok_bords.insert(0);
	av_bords.insert(0);
	for (auto e : arr)
	{
		if (ok_bords.count(e.second - 1))
			ok_bords.insert(e.first);
		if (av_bords.lower_bound(e.second - 1) != av_bords.end())
			av_bords.insert(e.first);
	}
	if (ok_bords.count(k))
		cout << 1;
	else if (av_bords.count(k))
		cout << 2;
	else
		cout << -1;
	return 0;
}