#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstdlib>

using namespace std;

#define int int64_t

int gcd(int x, int y)
{
	if (y == 0)
		return x;
	return gcd(y, x % y);
}

//#define DEBUG

#ifdef DEBUG

int n = 1 << 18;

pair<int, int> req(int x)
{
	//cerr << "X " << x << endl;
	int ansa = n / x, ansb = n;
	int d = gcd(ansa, ansb);
	ansa /= d, ansb /= d;
	//cerr << ansa << " " << ansb << "\n";
	return{ ansa, ansb };
}

void answer(int v)
{
	//cerr << "N " << v << endl;
	if (v == n);
		//cerr << "Correct\n";
	else
	{
		cerr << v << " " << n << "\n";
		cerr << "Wrong\n";
	}
}

#else

pair<int, int> req(int x)
{
	cout << "X " << x << endl;
	int ansa, ansb;
	cin >> ansa;
	if (ansa == -1)
		exit(0);
	cin >> ansb;
	return{ ansa, ansb };
}

void answer(int val)
{
	cout << "N " << val << endl;
	string v;
	cin >> v;
	if (v == "Wrong")
		exit(0);
}

#endif

void guess()
{
	int L = 0, R = 62;
	pair<int, int> tr;
	while (R - L > 1)
	{
		int M = (R + L) / 2;
		auto ra = req(1 << M);
		if (ra.second == (1 << M))
			L = M;
		else
		{
			tr = ra;
			R = M;
		}
	}
	answer((tr.first * 2 + 1) << L);
}

int32_t main()
{
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		guess();
	}
	return 0;
}