#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 7;
int k;

struct seg {
	int l, r, p;
};

bool cmp(seg &a, seg &b) {
	if (a.l == b.l) {
		return a.r < b.r;
	} else {
		return a.l < b.l;
	}
}

int rec(vector<seg> &num, vector<int> &used, int j, int p, int cnt, int r) {
	if (j == num.size()) {
		if (r < k) {
			return INF;
		} else {
			return p;
		}
	}
	int ans = rec(num, used, j + 1, p, cnt, r);
	bool flag = false;
	int w = 0;
	p = max(p, num[j].p);
	for (int i = 0; i < used.size(); i++) {
		if (used[i] == 0) {
			continue;
		}
		if (num[i].r == num[j].l - 1) {
			flag = true;
			continue;
		}
		if (num[i].r >= num[j].l) {
			w++;
			p = max(p, num[i].p + num[j].p);
			flag = true;
		}
	}
	if (cnt == 0 && num[j].l != 1) {
		return INF;
	}
	if (cnt != 0 && (!flag || w > 1)) {
		return INF;
	}
	used[j] = 1;
	ans = min(ans, rec(num, used, j + 1, p, cnt + 1, max(r, num[j].r)));
	used[j] = 0;
	return ans;
}

int main() {
	int n;
	cin >> n >> k;
	vector<seg> num(n);
	for (int i = 0; i < n; i++) {
		cin >> num[i].l >> num[i].r >> num[i].p;
	}
	sort(num.begin(), num.end(), cmp);
	if (n <= 10) {
		vector<int> used(n, 0);
		int ans = rec(num, used, 0, 0, 0, 0);
		if (ans == INF) {
			cout << -1;
		} else {
			cout << ans;
		}
	} else {

	}
	return 0;
}