#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se seconds

const int N = 200000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

using namespace std;

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    int x, y;
    cin >> x >> y;
    int u, d, l, r;
    int c1[n + 1], c2[n + 1];
    map<int, int> m;
    fill(c1, c1 + n + 1, 0);
    fill(c2, c2 + n + 1, 0);
    rep(i, 0, n)
        if (s[i] == 'U')
            c1[i + 1]++;
        else
            c2[i + 1]--;
    rep(i, 1, n + 1)
    {
        c1[i] += c1[i - 1];
        c2[i] += c2[i - 1];
    }
    m.clear();
    rep(i, 0, n + 1)
        m[c2[i]] = i;
    bool ok = false;
    rep(i, 0, n + 1)
        if (m.find(y - c1[i]) != m.end())
        {
            u = i;
            d = m[y - c1[i]];
            ok = true;
            break;
        }
    if (!ok)
    {
        cout << -1 << endl;
        return 0;
    }

    fill(c1, c1 + n + 1, 0);
    fill(c2, c2 + n + 1, 0);
    rep(i, 0, n)
        if (s[i] == 'R')
            c1[i + 1]++;
        else
            c2[i + 1]--;
    rep(i, 1, n + 1)
    {
        c1[i] += c1[i - 1];
        c2[i] += c2[i - 1];
    }
    m.clear();
    rep(i, 0, n + 1)
        m[c2[i]] = i;
    ok = false;
    rep(i, 0, n + 1)
        if (m.find(x - c1[i]) != m.end())
        {
            r = i;
            l = m[x - c1[i]];
            ok = true;
            break;
        }
    if (!ok)
    {
        cout << -1 << endl;
        return 0;
    }

    cout << l << " " << u << " " << r << " " << d << endl;
    return 0;
}
