#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

const int N = 200000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

using namespace std;

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, k;
    cin >> n >> k;
    vector<pair<ll, ll> > a(n);
    ll tmp;
    rep(i, 0, n)
        cin >> a[i].fi >> a[i].se >> tmp;
    map<ll, ll> m;
    m[1] = 0;
    m[k] = 0;
    rep(i, 0, n)
    {
        m[a[i].fi] = 0;
        m[a[i].se] = 0;
    }
    ll curr = 0;
    for (auto &it : m)
        it.se = curr++;
    k = m[k];
    rep(i, 0, n)
    {
        a[i].fi = m[a[i].fi];
        a[i].se = m[a[i].se];
    }
    sort(a.begin(), a.end());

    vector<ll> cnt(curr, 0);
    for (auto i : a)
    {
        cnt[i.fi]++;
        if (i.se < curr - 1)
            cnt[i.se + 1]--;
    }
    rep(i, 1, curr)
        cnt[i] += cnt[i - 1];
    rep(i, 0, curr)
        if (cnt[i] == 0)
        {
            cout << -1 << endl;
            return 0;
        }

    vector<bool> dp(curr, false);
    for (auto i : a)
        if (i.fi == 0 || dp[i.fi - 1])
            dp[i.se] = true;
    if (dp[curr - 1])
        cout << 1 << endl;
    else
        cout << 2 << endl;
    return 0;
}
