#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

const int N = 200000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

using namespace std;

struct block
{
    int l, r, p;
    block() {}
    block(int a, int b, int c)
    {
        l = a;
        r = b;
        p = c;
    }
};

bool comp(block b1, block b2)
{
    return b1.r < b2.r;
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<block> a(n);
    rep(i, 0, n)
        cin >> a[i].l >> a[i].r >> a[i].p;
    map<int, int> m;
    m[1] = 0;
    m[k] = 0;
    rep(i, 0, n)
    {
        m[a[i].l] = 0;
        m[a[i].r] = 0;
    }
    int curr = 0;
    for (auto &it : m)
        it.se = curr++;
    k = m[k];
    rep(i, 0, n)
    {
        a[i].l = m[a[i].l];
        a[i].r = m[a[i].r];
    }
    sort(a.begin(), a.end(), comp);

    int dp[n][curr];
    rep(i, 0, n)
        rep(j, 0, curr)
            dp[i][j] = inf;
    rep(i, 0, n)
    {
        if (a[i].l == 0)
        {
            rep(j, 0, a[i].r + 1)
                dp[i][j] = a[i].p;
        }
        else
        {
            rep(j, 0, i)
                if (a[j].l < a[i].l && a[j].r >= a[i].l)
                    dp[i][a[j].r] = min(dp[i][a[j].r], max(dp[j][a[i].l - 1], a[i].p + a[j].p));
                else if (a[j].r == a[i].r - 1)
                    dp[i][a[j].r] = min(dp[i][a[j].r], max(dp[j][a[j].r], a[i].p));
        }
        rep(j, 1, a[i].r + 1)
            dp[i][j] = min(dp[i][j], dp[i][j - 1]);
    }
    int ans = inf;
    rep(i, 0, n)
        if (a[i].r == k)
            ans = min(ans, dp[i][a[i].r]);
    if (ans == inf)
        cout << -1 << endl;
    else
        cout << ans << endl;
    return 0;
}
