#include <bits/stdc++.h>

using namespace std;
struct segmenttree
{
    long long zn;
    long long tl,tr;
    segmenttree *l,*r;
    segmenttree(long long L,long long R)
    {
        l=NULL;
        r=NULL;
        zn=0;
        tl=L;
        tr=R;
    }
    void check()
    {
        long long m=(tl+tr)>>1;
        if(l==NULL)
        {
            l=new segmenttree(tl,m);
        }
        if(r==NULL)
        {
            r=new segmenttree(m+1,tr);
        }
    }
    long long getel(long long pos)
    {
        if(tl==tr)return zn;
        long long m=(tl+tr)>>1;
        check();
        if(pos<=m)
        {
            return (*l).getel(pos);
        }
        else
        {
            return (*r).getel(pos);
        }
    }
    void change(long long pos)
    {
        if(tl==tr){zn++;return;}
        long long m=(tl+tr)>>1;
        check();
        if(pos<=m)
        {
            (*l).change(pos);
        }
        else
        {
            (*r).change(pos);
        }
    }
    void fix(long long pos,long long ttr)
    {
        if(tl==tr){zn=ttr;return;}
        long long m=(tl+tr)>>1;
        check();
        if(pos<=m)
        {
            (*l).fix(pos,ttr);
        }
        else
        {
            (*r).fix(pos,ttr);
        }
    }
    bool del(int right,int left)
    {
        if(tl>=left&&tr<=right)
        {
            //l=NULL;
           // r=NULL;
            zn=0;
            return 1 ;
        }
        if(tl>right||tr<left)
        {
            return 0;
        }
        int a=0,c=0;
        if(l!=NULL)a=(*l).del(left,right);
        if(r!=NULL)c=(*r).del(left,right);
        if(a)l=NULL;
        if(c)r=NULL;
        if(a&&c)return 1;
    }
};
struct tt{
    int pos,tmp;
    tt(){
        pos=0;
        tmp=0;
    }
    tt(int a,int b):pos(a),tmp(b){}

};
bool test(int m,vector<int>& v,bool fl=0)
{
    segmenttree tr(0,1e9+10);
    //int md=v[0];
    for(int i=1;i<v.size();i++)
    {
        if(v[i]>v[i-1])
        {
            /*for(int j=v[i-1];j<v[i];j++)
            {
                tmp[j]=0;
            }*/
        }
        else if(v[i]==v[i-1])
        {
            int d=v[i]-1;
            while(tr.getel(d)>=m)
            {
                //tmp[d]=0;
               // tr.fix(d,0);
                d--;
                if(d==-1)
                    return 0;
            }
            tr.change(d);
            tr.del(d+1,1e9+10);
            //tmp[d]++;
           /* for(int j=d+1;j<v[i];j++)
            {
                tmp[j]=0;
            }*/
        }
        else
        {
            int d=v[i]-1;
            for(int j=v[i];j<v[i-1];j++)
            {
                tr.fix(j,0);
                //tmp[j]=0;
            }
            //md=v[i];
            while(tr.getel(d)>=m)
            {
                //tmp[d]=0;
                tr.fix(d,0);
                d--;
                if(d==-1)
                    return 0;
            }
            tr.change(d);
            //tmp[d]++;
            /*for(int j=d+1;j<v[i];j++)
            {
                tmp[j]=0;
            }*/
        }



    }
    return 1;
}
int main()
{
    ios_base::sync_with_stdio(0);
    int n;
    cin>>n;
    vector<int> v(n);
    for(int i=0;i<n;i++)
    {
        cin>>v[i];
    }
    int l=0,r=100200;
    while(l!=r)
    {
       // cout<<1;
        int m=(l+r)>>1;
        if(test(m,v))
        {
            r=m;
        }
        else
        {
            l=m+1;
        }
    }
    //cout<<test(1,v,1)<<endl;
    cout<<l+1;
    return 0;
}
