#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

#define sqr(a) ((a)*(a))
#define sz(a) int((a).size())
#define forn(i, n) for (int(i) = 0; i < int(n); ++i)

typedef long long ll;
typedef unsigned long long ull;
typedef double dd;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 1e6 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

string s;

int main()
{
    ios::sync_with_stdio(0);
    int n, x, y;
    cin >> n;
    cin >> s;
    cin >> x >> y;
    int l, u, r, d;
    l = u = r = d = 0;
    for (int i = 0; i < n; ++i)
    {
        if (y)
        {
            if (y > 0)
                if (s[i] == 'U') u = i + 1, --y;
            else
                if (s[i] == 'D') d = i + 1, ++y;
        }
        if (x)
        {
            if (x > 0)
                if (s[i] == 'R') r = i + 1, --x;
            else
                if (s[i] == 'L') l = i + 1, ++x;
        }
    }
    if (x || y) cout << -1 << endl;
    else cout << l << ' ' << u << ' ' << r << ' ' << d << endl;
    return 0;
}
