#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

#define sqr(a) ((a)*(a))
#define sz(a) int((a).size())
#define forn(i, n) for (int(i) = 0; i < int(n); ++i)

typedef long long ll;
typedef unsigned long long ull;
typedef double dd;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 2e5 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

struct ds
{
    int l, r;
    ll p;
};

ds a[N];
int n;
ll ans = INFLL;

void rec(int x, int t[10])
{
    if (n == x)
    {
        ll q[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        forn(i, n)
        {
            if (t[i])
            for (int j = a[i].l; j <= a[i].r; ++j)
                q[j] += a[i].p;
        }
        ll r = 0;
        forn(i, n)
        {
            r = max(r, q[i]);
            if (q[i] == 0) return;
        }
        ans = min(ans, r);
    }
    else
    {
        rec(x + 1, t);
        t[x] = 1;
        rec(x + 1, t);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    forn(i, n) cin >> a[i].l >> a[i].r >> a[i].p;
    int t[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    rec(-1, t);
    if (ans == INFLL) cout << -1 << endl;
    else cout << ans << endl;
    return 0;
}




