import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class B {
    FastScanner in;

    void solve() throws IOException {
        int n = in.nextInt();
        int[] mas = new int[n];
        for (int i = 0; i < n; i++) {
            mas[i] = in.nextInt();
        }
        int pre[] = new int[mas[0]];
        int ans = 1;
        for (int i = 0; i < mas[0]; i++) {
            pre[i] = 1;
        }
        for (int i = 1; i < n; i++) {
            boolean p = false;
            for (int j = 0; j < n; j++) {
                if (pre[i] != ans) {
                    p = true;
                }
            }
            if (p) {
                int yk = -1 + mas[0];
                while (pre[yk] == ans) {
                    pre[yk] = 1;
                    yk--;
                }
                pre[yk]++;
            } else {
                pre[mas[0]]++;
                ans++;
            }
        }
        System.out.println(ans);
    }

    void ran() throws IOException {
        in = new FastScanner();
        solve();
    }

    public static void main(String[] args) throws IOException {
        new B().ran();
    }

    class FastScanner {
        StringTokenizer st;
        BufferedReader br;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.valueOf(next());
        }

        long nextLong() throws IOException {
            return Long.valueOf(next());
        }

        Double nextDouble() throws IOException {
            return Double.valueOf(next());
        }
    }
}
