import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.StringTokenizer;

public class B {
    FastScanner in;

    void solve() throws IOException {
        int n = in.nextInt();
        int mas[] = new int[n];
        for (int i = 0; i < n; i++) {
            mas[i] = in.nextInt();
        }
        int d[][] = new int[5000][5000];
        int ans = 1;
        for (int i = 0; i < 5000; i++) {
            d[0][i] = 1;
        }
        for (int i = 1; i < n; i++) {
            boolean p = true;
            for (int j = 0; j < mas[i]; j++) {
                d[i][j] = d[i - 1][j];
                if (p && d[i][j] != ans) {
                    p = false;
                }

            }
            if (p) {
                d[i][mas[i] - 1]++;
                ans++;
            } else {
                int yk = 0;
                while (d[i][yk] == ans) {
                    d[i][yk] = 1;
                    yk++;
                }
                d[i][yk]++;
            }
        }
        System.out.println(ans);
    }

    void ran() throws IOException {
        in = new FastScanner();
        solve();
    }

    public static void main(String[] args) throws IOException {
        new B().ran();
    }

    class FastScanner {
        StringTokenizer st;
        BufferedReader br;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.valueOf(next());
        }

        long nextLong() throws IOException {
            return Long.valueOf(next());
        }

        Double nextDouble() throws IOException {
            return Double.valueOf(next());
        }
    }
}
