import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class B {
    FastScanner in;

    void solve() throws IOException {
        int n = in.nextInt();
        String s = in.next();
        int xt = 0;
        int yt = 0;
        int x = in.nextInt();
        int y = in.nextInt();
        int l = -1;
        int r = -1;
        int u = -1;
        int d = -1;
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) == 'L' && Math.abs(x - xt) < Math.abs(x - xt + 1) && l == -1) {
                l = i;
            } else if (s.charAt(i) == 'L' && l == -1)
                xt--;
            if (s.charAt(i) == 'R' && Math.abs(x - xt) < Math.abs(x - xt - 1) && r == -1)
                r = i;
            else if (s.charAt(i) == 'R' && r == -1)
                xt++;
            if (s.charAt(i) == 'U' && Math.abs(y - yt) < Math.abs(y - (yt + 1)) && u == -1) {
                u = i;
            } else if (s.charAt(i) == 'U' && u == -1)
                yt++;
            if (s.charAt(i) == 'D' && Math.abs(y - yt) < Math.abs(y - (yt - 1)) && d == -1)
                d = i;
            else if (s.charAt(i) == 'D' && d == -1)
                yt--;
        }
        if (l == -1)
            l = n;
        if (r == -1)
            r = n;
        if (u == -1)
            u = n;
        if (d == -1)
            d = n;
        if (x == xt && y == yt) {
            System.out.println(l + " " + u + " " + r + " " + d);
        } else {
            System.out.println(-1);
        }
    }

    void ran() throws IOException {
        in = new FastScanner();
        solve();
    }

    public static void main(String[] args) throws IOException {
        new B().ran();
    }

    class FastScanner {
        StringTokenizer st;
        BufferedReader br;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.valueOf(next());
        }

        long nextLong() throws IOException {
            return Long.valueOf(next());
        }

        Double nextDouble() throws IOException {
            return Double.valueOf(next());
        }
    }
}
