import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class B {
    FastScanner in;

    void solve() throws IOException {
        int g = in.nextInt();
        for (int i = 0; i < g; i++) {
            long l = 0;
            long r = 1000000000000000000l;
            while (l + 1 != r) {
                long m = (l + r) >> 1;
                System.out.println(m);
                System.out.flush();
                long a = in.nextLong();
                if (a == -1)
                    return;
                if (a >= 1) {
                    r = m;
                } else {
                    l = m;
                }
            }
            System.out.println(r);
            System.out.flush();
            String s = in.next();
            if (s.equals("Wrong"))
                return;
        }
    }

    void ran() throws IOException {
        in = new FastScanner();
        solve();
    }

    public static void main(String[] args) throws IOException {
        new B().ran();
    }

    class FastScanner {
        StringTokenizer st;
        BufferedReader br;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.valueOf(next());
        }

        long nextLong() throws IOException {
            return Long.valueOf(next());
        }

        Double nextDouble() throws IOException {
            return Double.valueOf(next());
        }
    }
}
