import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.StringTokenizer;

public class B {
    FastScanner in;

    void solve() throws IOException {
        int n = in.nextInt();
        for (int i = 0; i < n; i++) {
            long l = 0;
            long r = 1000000000000000000l;
            while (l + 1 != r) {
                long m = (l + r) >> 1;
                System.out.println("X " + m);
                System.out.flush();
                long a = in.nextLong();
                long b = in.nextLong();
                if (a == 0) {
                    r = m;
                } else {
                    l = m;
                }
            }
            System.out.println("N " + l);
            System.out.flush();
            in.next();
        }
    }

    void ran() throws IOException {
        in = new FastScanner();
        solve();
    }

    public static void main(String[] args) throws IOException {
        new B().ran();
    }

    class FastScanner {
        StringTokenizer st;
        BufferedReader br;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.valueOf(next());
        }

        long nextLong() throws IOException {
            return Long.valueOf(next());
        }

        Double nextDouble() throws IOException {
            return Double.valueOf(next());
        }
    }
}
