#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define F first
#define S second
#define pb push_back
#define sc scanf
#define pr printf
#define ex exit(0)
#define fname ""
#define MOD 1000000007
#define INF 2147483647
#define y1 asdasf
#define size(x) x.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;

const int N = 200200;

ll t[N * 4], p[N * 4];
int n, mxl, a[N];

void build(int v, int l, int r) {
     p[v] = -1;
     if (l == r) {
        if (l <= a[1]) {
           t[v] = 1;
        } else t[v] = 0;
        return;
     }
     int mid = (l + r) / 2;
     build(v * 2, l, mid);
     build(v * 2 + 1, mid + 1, r);
     t[v] = t[v * 2] + t[v * 2 + 1];
}

void push(int v, ll cnt) {
    if (p[v] != -1) {
       t[v] = cnt * p[v];
       p[v * 2] = p[v * 2 + 1] = p[v];
       p[v] = -1;
    }
}

void upd(int v, int L, int R, int l, int r, ll val) {
     push(v, R - L + 1);
     if (R < l || r < L) return;
     if (l <= L && R <= r) {
        p[v] = val;
        push(v, R - L + 1);
        return;
     }
     int mid = (L + R) / 2;
     upd(v * 2, L, mid, l, r, val);
     upd(v * 2 + 1, mid + 1, R, l, r, val);     
     t[v] = t[v * 2] + t[v * 2 + 1];
     return;
}

void updelm(int v, int L, int R, int pos, ll x) {
     push(v, R - L + 1);
     if (L == R) {
        t[v] += x;      
        return;
     }
     int mid = (L + R) / 2;
     if (pos <= mid) {
        updelm(v * 2, L, mid, pos, x);
     } else {
        updelm(v * 2 + 1, mid + 1, R, pos, x);
     }
     t[v] = t[v * 2] + t[v * 2 + 1];
     return;
}                   

ll get(int v, int L, int R, int l, int r) {
    push(v, R - L + 1);
    if (R < l || r < L) {
       return 0;
    }
    if (l <= L && R <= r) {
       return t[v];
    }
    int mid = (L + R) / 2;
    ll ansl = get(v * 2, L, mid, l, r);
    ll ansr = get(v * 2 + 1, mid + 1, R, l, r);
    t[v] = t[v * 2] + t[v * 2 + 1];
    return ansl + ansr;
}

bool check(ll x) {
     build(1, 1, mxl);
     for (int i = 2; i <= n; i++) {
         if (a[i - 1] >= a[i]) {
            int lq = 1;
            int rq = a[i];
            int p = -1;
            while (lq <= rq) {
                  int midq = (lq + rq) / 2;
                  if (get(1, 1, mxl, midq, a[i]) == (a[i] - midq + 1) * 1LL * x) {
                     rq = midq - 1;                  
                  } else {
                     lq = midq + 1;
                     p = midq;
                  }
            }            
            if (p == -1) return false;
            if (p + 1 <= a[i - 1])
               upd(1, 1, mxl, p + 1, a[i - 1], 0);
            if (p + 1 <= a[i])
               upd(1, 1, mxl, p + 1, a[i], 1);
            updelm(1, 1, mxl, p, 1);
         } else {
            upd(1, 1, mxl, a[i - 1] + 1, a[i], 1);
         }
     }
     return true;
}

int main() {
   sc("%d", &n);
    for (int i = 1; i <= n; i++) {
        sc("%d", &a[i]), mxl = max(mxl, a[i]);    
    }
    mxl++;
    ll l = 1;
    ll r = n;
    ll ans = 0;
    while (l <= r) {
          ll mid = (l + r) / 2;
          if (check(mid)) {
             r = mid - 1;
             ans = mid;
          } else l = mid + 1;
    }
    cout << ans;
    return 0;
}
