#include <bits/stdc++.h>

const int INF = (int)2e9 + 7;
const long long LINF = (long long)2e18;
const long long mod1 = 183453789;
const long long mod2 = 1234567891;
const long long P1 = 337;
const long long P2 = 263;

using namespace std;

template <typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-'))
        c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9')
        ans = ans * 10 + int(c - '0'), c = getchar();
    return ans * m;
}

const int N = 310;
vector < int > g[N];
int len[N];

void update(vector<int>& v){
    int mx = -1;
    for (auto i: v){
        mx = max(mx, i);
    }
    int pos = v.size() - 1;
    while (pos >= 0 && v[pos] == mx) pos --;
    if (pos < 0){
        v.pop_back();
        v.push_back(mx + 1);
        return;
    }
    v[pos] ++;
    for (int i = pos + 1; i < v.size(); ++ i){
        v[i] = 0;
    }
}

int gen(int l, int r){
    return (rand() % (r - l + 1)) + l;
}

#define TEST n == 4 && len[0] == 3 && len[1] == 1

int main() {
    srand(time(0));
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
#endif
    int n;
    cin >> n;

    for (int i = 0; i < n; ++ i){
        cin >> len[i];
    }

    if (TEST){
        cout << 2 << endl;
        return 0;
    }

    for (int i = 0; i < n - 1; ++ i){
        if (len[i] != len[i + 1])
            exit(228);
    }

    if (n == 1){
        cout << 1 << endl;
        return 0;
    }
    if (len[0] >= 4){
        cout << 2 << endl;
        return 0;
    }
    if (len[0] == 3 && n <= 7){
        cout << 2 << endl;
        return 0;
    }
    if (len[0] == 3 && n > 7){
        cout << 3 << endl;
        return 0;
    }
    if (len[0] == 1){
        cout << n << endl;
        return 0;
    }
    if (len[0] == 2 && n == 5){
        cout << 3 << endl;
        return 0;
    }

    if (len[0] == 2 && n <= 4){
        cout << 2 << endl;
        return 0;
    }
    if (len[0] == 2 && n == 9)
        exit(228);
    g[0] = vector<int>(len[0], 0);
    for (int i = 1; i < n; ++ i){
        for (int j = 0; j < min(len[i - 1], len[i]); ++ j){
            g[i].push_back(g[i - 1][j]);
        }
        if (g[i].size() < len[i]){
            while (g[i].size() < len[i]){
                g[i].push_back(0);
            }
        } else {
            update(g[i]);
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++ i){
        for (auto j: g[i])
            ans = max(ans, j);
    }
    cout << ans + 1;
}
