#include <bits/stdc++.h>

const int INF = (int)2e9 + 7;
const long long LINF = (long long)2e18;
const long long mod1 = 183453789;
const long long mod2 = 1234567891;
const long long P1 = 337;
const long long P2 = 263;

using namespace std;

template <typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-'))
        c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9')
        ans = ans * 10 + int(c - '0'), c = getchar();
    return ans * m;
}

const int N = 5000;
int len[N];
int n;

vector < int > g[N];

bool update(vector<int>& v, int mx){
    int ptr = (int)v.size() - 1;
    for (; ptr >= 0 && v[ptr] == mx; ptr --);
    if (ptr < 0){
        int x = v.back();
        if (x == mx) return false;
        v.pop_back();
        v.push_back(x + 1);
        return true;
    }
    v[ptr] ++;
    for (int i = ptr + 1; i < v.size(); ++ i)
        v[i] = 0;

    return true;
}

bool can(int x){
    g[0] = vector<int>(len[0], 0);
    for (int i = 1; i < n; ++ i){
        g[i].clear();
        for (int j = 0; j < min(len[i - 1], len[i]); ++ j){
            g[i].push_back(g[i - 1][j]);
        }
        if (g[i].size() < len[i]){
            while (g[i].size() < len[i])
                g[i].push_back(0);
        } else {
            bool ok = update(g[i], x);
            if (!ok)
                return false;
        }
    }
    return true;
}

int main() {
    srand(time(0));
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
#endif
    n = input<int>();
    for (int i = 0; i < n; ++ i){
        len[i] = input<int>();
    }
    int l = 0, r = n;
    while (l < r){
        int m = (l + r) / 2;
        if (can(m)){
            r = m;
        } else {
            l = m + 1;
        }
    }
    cout << l + 1 << '\n';
}
