import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by olymp on 10.03.2017.
 */
public class B_bin {
    FastScanner in;
    PrintWriter out;

    void solve() throws FileNotFoundException {
        in = new FastScanner(new FileInputStream("input.txt"));
        out = new PrintWriter(new FileOutputStream("output.txt"));
        int n = in.nextInt();
        boolean fl = true;
        String s = in.nextLine();
        int x = in.nextInt();
        int y = in.nextInt();
        int U = 0;
        int D = 0;
        int R = 0;
        int L = 0;
        int le = 0;
        int ri = 0;
        int up = 0;
        int dow = 0;
        for (int i = 0; i < n; i++) {
            char q = s.charAt(i);
            if (q == 'L') {
                le++;
            } else {
                if (q == 'R') {
                    ri++;
                } else {
                    if (q == 'U') {
                        up++;
                    } else {
                        if (q == 'D') {
                            dow++;
                        }
                    }
                }
            }
        }
        int l_le = -1;
        int r_le = n - 1;
        int t = ri - x;
        while (l_le + 1 < r_le) {
            int m = (l_le + r_le) / 2;
            int kek = 0;
            for (int i = 0; i <= m; i++) {
                if (s.charAt(i) == 'L') {
                    kek++;
                }
            }
            if (kek < t) {
                l_le = m;
            } else {
                r_le = m;
            }
        }
        int kek_le = 0;
        for (int i = 0; i <= r_le; i++) {
            if (s.charAt(i) == 'L') {
                kek_le++;
            }
        }
        if (kek_le == t) {
            L = r_le + 1;
            R = n;
        } else {
            int l_ri = -1;
            int r_ri = n - 1;
            int t_ri =  x + le;
            while (l_ri + 1 < r_ri) {
                int m = (l_ri + r_ri) / 2;
                int kek = 0;
                for (int i = 0; i <= m; i++) {
                    if (s.charAt(i) == 'R') {
                        kek++;
                    }
                }
                if (kek < t_ri) {
                    l_ri = m;
                } else {
                    r_ri = m;
                }
            }
            int kek_ri = 0;
            for (int i = 0; i <= r_ri; i++) {
                if (s.charAt(i) == 'R') {
                    kek_ri++;
                }
            }
            if (kek_ri == t_ri) {
                R = r_ri + 1;
                L = n;
            } else {
                fl = false;
            }
        }
        if (fl) {
            int l_up = -1;
            int r_up = n - 1;
            int t_up = y + dow;
            while (l_up + 1 < r_up) {
                int m = (l_up + r_up) / 2;
                int kek = 0;
                for (int i = 0; i <= m; i++) {
                    if (s.charAt(i) == 'U') {
                        kek++;
                    }
                }
                if (kek < t_up) {
                    l_up = m;
                } else {
                    r_up = m;
                }
            }
            int kek_up = 0;
            for (int i = 0; i <= r_up; i++) {
                if (s.charAt(i) == 'U') {
                    kek_up++;
                }
            }
            if (kek_up == t_up) {
                U = r_up + 1;
                D = n;
            } else {
                int l_do = -1;
                int r_do = n - 1;
                int t_do =  up - y;
                while (l_do + 1 < r_do) {
                    int m = (l_do + r_do) / 2;
                    int kek = 0;
                    for (int i = 0; i <= m; i++) {
                        if (s.charAt(i) == 'D') {
                            kek++;
                        }
                    }
                    if (kek < t_do) {
                        l_do = m;
                    } else {
                        r_do = m;
                    }
                }
                int kek_do = 0;
                for (int i = 0; i <= r_do; i++) {
                    if (s.charAt(i) == 'D') {
                        kek_do++;
                    }
                }
                if (kek_do == t_do) {
                    D = r_do  + 1;
                    U = n;
                } else {
                    fl = false;
                }
            }
        }


        if (!fl) {
            out.print(-1);
        } else {
            out.print(L + " " + U + " " + R + " " + D);
        }
        out.close();
    }

    public static void main(String args[]) throws IOException {
        Locale.setDefault(Locale.US);
        new B_bin().solve();
    }

    class FastScanner implements Closeable {
        private BufferedReader br;
        private StringTokenizer tokenizer;

        public FastScanner(InputStream stream) throws FileNotFoundException {
            br = new BufferedReader(new InputStreamReader(stream));
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public String nextLine() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    return br.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken("\n");
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        @Override
        public void close() throws IOException {
            br.close();
        }
    }
}
