import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by olymp on 10.03.2017.
 */
public class D {
    FastScanner in;
    PrintWriter out;

    void solve() throws FileNotFoundException {
        in = new FastScanner(new InputStreamReader(System.in));
        out = new PrintWriter(new OutputStreamWriter(System.out));
        int g = in.nextInt();
        System.out.flush();
        for (int i = 0; i < g; i++) {
            long l = 0;
                     long w = 1000000000;
                     long r = w * w;

            while (l + 1 < r) {
                long m = (l + r) / 2;
                System.out.println("X " + m);
                System.out.flush();
                int a = in.nextInt();
                System.out.flush();
                int b = in.nextInt();
                System.out.flush();
                if (a == 0) {
                    r = m;
                } else {
                    l = m;
                }
            }
            System.out.println("N " + l);
            System.out.flush();
            String s = in.nextLine();
            System.out.flush();
            if (s.charAt(0) == 'W') {
                break;
            }


        }
        out.close();
    }

    public static void main(String args[]) throws IOException {
        Locale.setDefault(Locale.US);
        new D().solve();
    }

    class FastScanner implements Closeable {
        private BufferedReader br;
        private StringTokenizer tokenizer;

        public FastScanner(InputStreamReader stream) throws FileNotFoundException {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public String nextLine() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    return br.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken("\n");
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        @Override
        public void close() throws IOException {
            br.close();
        }
    }
}
