#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>

#define _CRT_SECURE_NO_WARNINGS
#pragma warning (disable : 4996)
#pragma comment (linker, "/STACK:65000000")

using namespace std;

const int NMAX = 1000017;
int n;
int x, y, X1, Y1;
int L, U, R, D;
char c[NMAX];


int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	//freopen("output.txt", "w", stdout);

	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> c[i];
		if (c[i] == 'L') x--;
		if (c[i] == 'U') y++;
		if (c[i] == 'R') x++;
		if (c[i] == 'D') y--;
	}

	cin >> X1 >> Y1;

	L = U = R = D = -1;

	if (x == X1) {
		L = R = n;
	}
	if (x > X1) {
		L = n;
		for (int i = n; i >= 1; i--) {
			if (c[i] == 'R') x--;
			if (x == X1) {
				R = i - 1;
				break;
			}
		}
	}
	if (x < X1) {
		R = n;
		for (int i = n; i >= 1; i--) {
			if (c[i] == 'L') x++;
			if (x == X1) {
				L = i - 1;
				break;
			}
		}
	}
	if (y == Y1) {
		U = D = n;
	}
	if (y > Y1) {
		D = n;
		for (int i = n; i >= 1; i--) {
			if (c[i] == 'U') y--;
			if (y == Y1) {
				U = i - 1;
				break;
			}
		}
	}
	if (y < Y1) {
		U = n;
		for (int i = n; i >= 1; i--) {
			if (c[i] == 'D') y++;
			if (y == Y1) {
				D = i - 1;
				break;
			}
		}
	}
	if (L == -1 || U == -1 || R == -1 || D == -1) {
		cout << -1;
		return 0;
	}
	cout << L << ' ' << U << ' ' << R << ' ' << D;
	return 0;
}