#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <list>
#include <assert.h>
#include <time.h>
#pragma warning(disable: 4996)
#pragma gcc optimize("o3")
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 1e5 + 10;
const ll INF = 1e9;

ll pr(int x) {
	while (true) {
		int checkto = min(x, int(sqrt(x)) + 1);
		bool ok = true;
		if (x % 2 == 0) {
			x++;
			continue;
		}
		for (int i = 3; i < checkto; i += 2)
			if (x % i == 0) {
				ok = false;
				break;
			}
		if (ok)
			return x;
		x++;
	}
}

ll gcd(ll a, ll b) {
	if (b > a)
		swap(a, b);
	return (b ? gcd(b, a % b) : a);
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#endif
	ios::sync_with_stdio(false);
	srand(time(NULL));

	ll g;
	cin >> g;
	while (g--) {
		ll n = 1e9;

		vector<ll> res;
		for (ll i = 0; i < 6; i++) {
			ll e = pr(n);
			cout << "X " << e << endl;
			ll a, b;
			cin >> a >> b;
			if (a == 0)
				n = sqrt(sqrt(n));
			else {
				res.push_back(b);
				n = e + 1;
			}
		}

		ll num = res.back();
		res.pop_back();
		for (ll i : res)
			num = (num * i) / gcd(num, i);

		cout << "N " << num << endl;
		string verd;
		cin >> verd;
		if (verd == "Wrong")
			assert(false);
	}

	return 0;
}