#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
typedef pair <int, int> pii;

const int INF = 1e9;
const ll INFll = 1ll * INF * INF;

vector <int> cnt, a;

bool check(int x) {
    for (int i = 1; i <= a[0]; i++)
        cnt[i] = 1;
    for (int i = a[0] + 1; i < cnt.size(); i++)
        cnt[i] = 0;
    for (int i = 1; i < a.size(); i++) {
        int cur = 0;
        for (int j = a[i]; j >= 1; j--)
            if (cnt[j] < x) {
                cur = j;
                break;
            }
        if (cur == 0)
            return false;
        cnt[cur]++;
        for (int j = cur + 1; j <= a[i]; j++)
            cnt[j] = 1;
        for (int j = a[i] + 1; j < cnt.size(); j++)
            cnt[j] = 0;
        for (int j = 1; j <= a[i]; j++)
            if (cnt[j] == 0)
                cnt[j] = 1;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    a.resize(n);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        mx = max(mx, a[i]);
    }
    cnt.resize(mx + 1, 0);
    int l = 1, r = INF;
    int ans = n;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (check(mid))
            ans = mid, r = mid - 1;
        else
            l = mid + 1;
    }
    cout << ans << endl;
    return 0;
}
