#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

#define mp make_pair
#define pb push_back
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int sz; cin >> sz;
    string path; cin >> path;
    int x, y; cin >> x >> y;
    int cx = 0, cy = 0;
    int min_need = abs(x) + abs(y);
    int l = 0, r = 0, u = 0, d = 0;

    if(sz < min_need) {
        cout << -1;
        return 0;
    }

    forn(i, sz) {
        if(path[i] == 'L') {
            cx--;
            l++;
        }
        if(path[i] == 'R') {
            cx++;
            r++;
        }
        if(path[i] == 'U') {
            cy++;
            u++;
        }
        if(path[i] == 'D') {
            cy--;
            d++;
        }
    }

    int dl = 0, dr = 0, du = 0, dd = 0;

    if(cx >= x && x >= 0) {
        dr = r - abs(cx - x);
    }
    if(cx < x && x >= 0) {
        cout << -1;
        return 0;
    }
    if(cx > x && x < 0) {
        cout << -1;
        return 0;
    }
    if(cx <= x && x < 0) {
        dl = l - abs(cx - x);
    }
    if(cy >= y && y >= 0) {
        du = u - abs(cy - y);
    }
    if(cy < y && y >= 0) {
        cout << -1;
        return 0;
    }
    if(cy >= y && y < 0) {
        dd = d - abs(cy - y);
    }
    if(cy < y && y < 0) {
        cout << -1;
        return 0;
    }

    if(cx == x) {
        if(l > r) {
            dl = l - r + 1;
            dr = 0;
        } else if(r > l) {
            dr = r - l + 1;
            dl = 0;
        } else {
            dl = dr = 0;
        }
    }

    if(cy == y) {
        if(u > d) {
            du = u - d + 1;
            dd = 0;
        } else if(d > u) {
            dd = d - u + 1;
            du = 0;
        } else {
            dd = du = 0;
        }
    }

    l = r = u = d = 0;
    forn(i, sz) {
        if(path[i] == 'L') {
            l++;
        }
        if(path[i] == 'R') {
            r++;
        }
        if(path[i] == 'U') {
            u++;
        }
        if(path[i] == 'D') {
            d++;
        }
        if(l == dl && path[i] == 'L') {
            dl = i;
        }
        if(r == dr && path[i] == 'R') {
            dr = i;
        }
        if(u == du && path[i] == 'U') {
            du = i;
        }
        if(d = dd && path[i] == 'D') {
            dd = i;
        }
    }

    cout << dl << ' ' << du << ' ' << dr << ' ' << dd;

    return 0;
}
