#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

#define mp make_pair
#define pb push_back
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int sz; cin >> sz;
    string path; cin >> path;
    int x, y; cin >> x >> y;
    int l = 0, u = 0, r = 0, d = 0;

    forn(i, sz) {
        if(path[i] == 'L') {
            l--;
        }
        if(path[i] == 'R') {
            r++;
        }
        if(path[i] == 'U') {
            u++;
        }
        if(path[i] == 'D') {
            d--;
        }
    }

    int dl = 0, du = 0, dr = 0, dd = 0;

    if(x > 0) {
        if(r > x) {
            dr = r - x;
        } else if(r == x) {
            dr = r;
        } else {
            cout << -1;
            return 0;
        }
    } else if(x < 0) {
        if(l < x) {
            dl = x - l;
        } else if(l == x) {
            dl = l;
        } else {
            cout << -1;
            return 0;
        }
    } else {
        dl = dr = 0;
    }

    if(y > 0) {
        if(u > y) {
            du = y - u;
        } else if(u == y) {
            du = u;
        } else {
            cout << -1;
            return 0;
        }
    } else if(y < 0) {
        if(d < y) {
            dd = y - d;
        } else if(d == y) {
            dd = d;
        } else {
            cout << -1;
            return 0;
        }
    } else {
        du = dd = 0;
    }

    l = u = r = d = 0;
    bool ll, uu, rr, dd1;
    ll = uu = rr = dd1 = 1;
    forn(i, sz) {
        if(path[i] == 'L') {
            l++;
        }
        if(path[i] == 'R') {
            r++;
        }
        if(path[i] == 'U') {
            u++;
        }
        if(path[i] == 'D') {
            d++;
        }
        if(l > dl && ll && path[i] == 'L' && dl != 0) {
            dl = i;
            ll = 0;
        }
        if(r > dr && rr && path[i] == 'R' && dr != 0) {
            dr = i;
            rr = 0;
        }
        if(u > du && uu && path[i] == 'U' && du != 0) {
            du = i;
            uu = 0;
        }
        if(d > dd && dd1 && path[i] == 'D' && dd != 0) {
            dd = i;
            dd1 = 0;
        }
    }

    cout << dl << ' ' << du << ' ' << dr << ' ' << dd;

    return 0;
}
