#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

#define mp make_pair
#define pb push_back
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ll sz; cin >> sz;
    string path; cin >> path;
    ll x, y; cin >> x >> y;
    ll l, r, u, d;
    l = 0;
    r = 0;
    u = 0;
    d = 0;

    forn(i, sz) {
        if(path[i] == 'L') {
            l++;
        } else if(path[i] == 'R') {
            r++;
        } else if(path[i] == 'U') {
            u++;
        } else {
            d++;
        }
    }

    ll sl, su, sr, sd;
    sl = 0;
    su = 0;
    sr = 0;
    sd = 0;

    if(x > 0) {
        if(r >= x) {
            sr = x;
        } else {
            cout << -1;
            return 0;
        }
    } else if(x < 0) {
        if(l >= -x) {
            sl = -x;
        } else {
            cout << -1;
            return 0;
        }
    } else {
        sl = sr = 0;
    }

    if(y > 0) {
        if(u >= y) {
            sr = y;
        } else {
            cout << -1;
            return 0;
        }
    } else if(y < 0) {
        if(d >= -y) {
            sd = -y;
        } else {
            cout << -1;
            return 0;
        }
    } else {
        su = sd = 0;
    }

    ll al, au, ar, ad;
    al = 0;
    au = 0;
    ar = 0;
    ad = 0;
    l = 0;
    r = 0;
    d = 0;
    u = 0;
    forn(i, sz) {
        if(path[i] == 'L') {
            l++;
        } else if(path[i] == 'R') {
            r++;
        } else if(path[i] == 'U') {
            u++;
        } else {
            d++;
        }
        if(l == sl) {
            al = i + 1;
            sl = -1;
        }
        if(r == sr) {
            ar = i + 1;
            sr = -1;
        }
        if(u == su) {
            au = i + 1;
            su = -1;
        }
        if(d == sd) {
            ad = i + 1;
            sd = -1;
        }
    }

    cout << al << ' ' << au << ' ' << ar << ' ' << ad;

    return 0;
}
