#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

#define mp make_pair
#define pb push_back
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)

using namespace std;

typedef long long ll;

void question(ll x) {
    cout << 'X' << ' ' << x << endl;
}

void answer(ll n) {
    cout << 'N' << ' ' << n << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int t; cin >> t;
    forn(_, t) {
        question(2);
        string s; cin >> s;
        if(s == "-1" || s == "Wrong") {
            return 0;
        }

        ll a = 0;
        forn(i, s.size()) {
            a += (s[i] - '0') * pow(10, s.size() - i - 1);
        }

        ll b; cin >> b;

        if(a / b == 1 / 2) {
            answer(b);
            continue;
        }

        double last = a / b;
        ll l = 0;
        ll r = 1e18;

        while(r - l > 1) {
            ll m = (l + r) >> 1;

            question(m);
            cin >> s;
            if(s == "-1" || s == "Wrong") {
                return 0;
            }
            a = 0;
            forn(i, s.size()) {
                a += (s[i] - '0') * pow(10, s.size() - i - 1);
            }

            b; cin >> b;

            if(a / b > last) {
                l = m;
                last = a / b;
            } else {
                r = m;
                last = a / b;
            }
        }

        answer(r);
    }

    return 0;
}
