#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define ld long double
#define f first
#define s second
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define files1 freopen("input.txt", "r", stdin)
#define files2 freopen("output.txt", "w", stdout)
#define pii pair<int, int>
#define fast_io ios_base::sync_with_stdio(0)
using namespace std;

const int maxn = 2e5 + 500, base = 1e9 + 7;
const int inf = 2e9 + 5;
const ll llinf = 1e18 + 5;

struct node {
	int mn;
	int color;
} tree[4 * maxn];

int l[maxn];
int glob;

void build(int v, int tl, int tr) {
	tree[v].color = -1;
	tree[v].mn = glob;
	if (tl == tr) return;
	int tm = (tl + tr) >> 1;
	build(v<<1, tl, tm);
	build(v<<1|1, tm + 1, tr); 
}

inline void push(int v) {
	if (tree[v].color != -1) {
		if ((v<<1|1) < 4 * maxn) {
			tree[v<<1].color = tree[v].color;
			tree[v<<1|1].color = tree[v].color;
		}
		tree[v].mn = tree[v].color;
		tree[v].color = -1;
	}
}

void mod(int v, int tl, int tr, int l, int r, int col) {
	if (l > r) return;
	push(v);
	if (tl == l && tr == r) {
		tree[v].color = col;
		return;
	}
	int tm = (tl + tr) >> 1;
	mod(v<<1, tl, tm, l, min(r, tm), col);
	mod(v<<1|1, tm + 1, tr, max(l, tm + 1), r, col);
	push(v<<1);
	push(v<<1|1);
	tree[v].mn = min(tree[v<<1].mn, tree[v<<1|1].mn);
}

int get_and_col(int v, int tl, int tr) {
	push(v);
	if (tl == tr) {
		if (tree[v].mn >= glob - 1) {
			return -1;
		}
		tree[v].mn++;
		return tl;
	}
	int tm = (tl + tr) >> 1;
	
	push(v<<1|1);
	push(v<<1);

	int ans;
	if (tree[v<<1|1].mn < glob - 1) {
		ans = get_and_col(v<<1|1, tm + 1, tr);
	}
	else {
 		ans = get_and_col(v<<1, tl, tm);
	}
	tree[v].mn = min(tree[v<<1].mn, tree[v<<1|1].mn);
	return ans;
}

bool can(int n, int m) {
	glob = m;
	build(1, 0, maxn - 1);
	mod(1, 0, maxn - 1, 0, l[0] - 1, 0);

	for (int i = 1; i < n; i++) {
		if (l[i] > l[i - 1]) {
			mod(1, 0, maxn - 1, l[i - 1], l[i] - 1, 0);
		} else {
			mod(1, 0, maxn - 1, l[i], l[i - 1] - 1, m);
			int pos = get_and_col(1, 0, maxn - 1);
			if (pos == -1)
				return 0;
			mod(1, 0, maxn - 1, pos + 1, l[i] - 1, 0);
		}
	}
	return 1;
}

int main() {	
	int n;
	// files1;
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		scanf("%d", l + i);
		// s[i].resize(a[i]);
	}

	// cout << can(n, 1);
	// return 0;

	int l = 1, r = n;
	while (r - l > 0) {
		int m = (l + r) >> 1;
		if (can(n, m))
			r = m;
		else
			l = m + 1;
	}
	cout << l;

	return 0;
}