#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long int ll;
typedef pair<int, int> pii;

#ifdef USE_CERR
#define CERR(a) cerr << a << endl
#else
#define CERR(a)
#endif

template<typename T> using ordered_set = tree<T, null_type, less<T>,
        rb_tree_tag, tree_order_statistics_node_update>;

const int maxn = (const int) (2e5 + 5);

struct node {
    node* left;
    node* right;
    int val;
    int push;

    node() {
        left = nullptr;
        right = nullptr;
        val = 0;
        push = -1;
    }
};

node* build(int l, int r) {
    if (l == r) {
        return new node();
    } else {
        node* nd = new node();
        nd->left = build(l, (l + r) / 2);
        nd->right = build(l, (l + r) / 2);
        return nd;
    }
}

void push(node* node) {
    if (node->push == -1)
        return;
    node->val = node->push;
    if (node->left != nullptr)
        node->left->push = node->push;
    if (node->right != nullptr)
        node->right->push = node->push;
    node->push = -1;
}

void sett(node* node, int L, int R, int l, int r, int val) {
    if (L > R)
        return;
    push(node);
    if (r < L || R < l)
        return;
    if (l >= L && r <= R) {
        node->push = val;
        return;
    }
    sett(node->left, L, R, l, (l + r) / 2, val);
    sett(node->right, L, R, (l + r) / 2 + 1, r, val);
}

int VVV;

bool add(node* node, int l, int r, int v) {
    push(node);
    if (l == r) {
        node->val++;
        if (node->val >= VVV) {
            node->val = 0;
            return true;
        }
        return false;
    } else {
        if (v <= (l + r) / 2)
            add(node->left, l, (l + r) / 2, v);
        else
            add(node->right, (l + r) / 2 + 1, r, v);
    }
}

node* mn;

int n;
int vals[maxn];

bool can(int v) {
    VVV = v;
    sett(mn, 0, maxn - 1, 0, maxn - 1, 0);
    int ptr = vals[0] - 1;

    for (int i = 1; i < n; i++) {
        if (vals[i] > vals[i - 1]) {
            ptr = vals[i] - 1;
        } else {
            sett(mn, vals[i], ptr, 0, maxn - 1, 0);
            ptr = vals[i] - 1;
            for (int z = ptr; z >= 0; z--) {
                if (!add(mn, 0, maxn - 1, z))
                    break;
                if (z == 0)
                    return false;
            }
        }
    }
    return true;
}

int main() {
    mn = build(0, maxn - 1);

    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d", &vals[i]);

    int a = 1, b = (int) (1e5 + 5);
    while (a != b) {
        int la = a, lb = b;
        int mid = (a + b) / 2;
        if (can(mid))
            b = mid;
        else
            a = mid;
        if (la == a && lb == b) {
            if (can(a))
                b = a;
            else
                a = b;
        }
    }

    printf("%d\n", a);
}

/*
5
2 2 2 2 2

4
3 1 2 2
 */