#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;

#ifdef USE_CERR
#define CERR(a) cerr << a << endl
#else
#define CERR(a)
#endif

const int maxn = 1e6 + 5;

int main() {
    int n;
    char s[maxn];
    scanf("%d", &n);
    scanf("%s", s);

    int l = 0, r = 0, u = 0, d = 0;
    vector<int> ls, rs, us, ds;

    ls.push_back(0);
    rs.push_back(0);
    us.push_back(0);
    ds.push_back(0);

    for (int i = 0; i < n; i++) {
        if (s[i] == 'L')
            l++;
        else if (s[i] == 'R')
            r++;
        else if (s[i] == 'U')
            u++;
        else
            d++;

        if (s[i] == 'L')
            ls.push_back(i);
        else if (s[i] == 'R')
            rs.push_back(i);
        else if (s[i] == 'U')
            us.push_back(i);
        else
            ds.push_back(i);
    }

    ls.push_back(n);
    rs.push_back(n);
    us.push_back(n);
    ds.push_back(n);

    int a, b;
    scanf("%d%d", &a, &b);

    for (int x = 0; x <= r; x++) {
        // (R - x) - (L - y) == a
        int y = a - r + l + x;
        if (y < ls.size()) {
            int pos1 = rs.size() - x - 1;
            int pos2 = ls.size() - y - 1;
            printf("%d %d ", ls[pos2], rs[pos1]);
            break;
        }
        if (x == r) {
            printf("-1");
            return 0;
        }
    }

    for (int x = 0; x <= u; x++) {
        // (U - x) - (D - y) == a
        int y = b - u + d + x;
        if (y < ls.size()) {
            int pos1 = us.size() - x - 1;
            int pos2 = ds.size() - y - 1;
            printf("%d %d ", ds[pos2], us[pos1]);
            break;
        }
        if (x == u) {
            printf("-1");
            return 0;
        }
    }
}

/*
4
LRUD
3 2

4
DURL
0 0

8
LLURDRRD
1 -1
 */