import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class Main {

    FastScaner in;
    PrintWriter out;

    class Pair {
        long a, b;
    }

    Pair ask(long v) {
        out.println("X " + v);
        out.flush();
        Pair pair = new Pair();
        pair.a = in.nextLong();
        if (pair.a != -1)
            pair.b = in.nextLong();
        else {
            while (true)
                out.print("kek)");
        }
        return pair;
    }

    boolean ans(long v) {
        out.println("N " + v);
        out.flush();
        return in.next().equals("Correct");
    }

    boolean can(long v) {
        long val = (1L << v);
        Pair p = ask(val);
        return p.a != 0;
    }

    boolean play() {
        /*int a = 0, b = 60;
        while (a != b) {
            int la = a, lb = b;
            int mid = (a + b) / 2;
            if (!can(list, mid))
                b = mid;
            else
                a = mid;
            if (la == a && lb == b) {
                if (can(list, a))
                    b = a;
                else
                    a = b;
            }
        }

        long val = (1L << ((long)a));
        return ans(ask(val).b);*/

        long cur = 0;
        for (int i = 5; i >= 0; i--) {
            cur += (1L << i);
            if (!can(cur))
                cur -= (1 << i);
        }

        long val = (1L << cur);
        return ans(ask(val).b);
    }

    void solve() {
        int g = in.nextInt();
        for (int i = 0; i < g; i++)
            if (!play()) {
                while (true)
                    out.print("lol)");
            }
    }

    void run() {
        out = new PrintWriter(System.out);
        in = new FastScaner();
        solve();
        out.close();
    }

    public static void main(String[] args) {
        (new Main()).run();
    }

    class FastScaner {
        StringTokenizer st;
        BufferedReader br;

        FastScaner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens())
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            return st.nextToken();
        }

        Integer nextInt() {
            return Integer.parseInt(next());
        }

        Long nextLong() {
            return Long.parseLong(next());
        }
    }
}
