#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iterator>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define for1(i, n) for(int i = 1; i <= (int)n; i++)
#define all(v) v.begin(), v.end()

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)1e5 + 7;

int n;
int a[MAXN];

struct seg {
	int l, r, c;
};

bool f(ll m) {
	vector<seg> v;
	v.push_back({ 0, 0, 0 });
	for1(it, n) {
		if (a[it] > a[it - 1]) {
			/*for (int i = a[it - 1] + 1; i <= a[it]; i++) {
				s[i] = 0;
			}
			*/
			v.push_back({ a[it - 1] + 1, a[it], 0 });
		}
		else {
			/*for (int i = a[it] + 1; i <= a[it - 1]; i++) {
				s[i] = 0;
			}*/
			while (true) {
				seg s = v.back();
				v.pop_back();
				if (a[it] >= s.l) {
					s.r = a[it];
					v.push_back(s);
					break;
				}
			}
			/*for (int i = a[it]; i >= 1; i--) {
				if (s[i] >= m) {
					s[i] %= m;
					s[i - 1]++;
				}
			}*/
			seg s = v.back();
			v.pop_back();
			if (s.c == m - 1) {
				v.back().c++;
				if (v.back().r == 0) {
					return false;
				}
				s.c = 0;
				v.push_back(s);
			}
			else {
				s.r--;
				if (s.l <= s.r) {
					v.push_back(s);
				}
				if (v.back().c == s.c + 1) {
					v.back().r = a[it];
				}
				else {
					v.push_back({ a[it], a[it], s.c + 1 });
				}
			}
		}
	}
	return true;
}

void solve() {
	scanf("%d", &n);
	for1(i, n) {
		scanf("%d", a + i);
	}
	ll l = 0, r = MAXN;
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (f(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
}