#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iterator>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define for1(i, n) for(int i = 1; i <= (int)n; i++)
#define all(v) v.begin(), v.end()

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

vi g[4];
int ans[4];

void no() {
	cout << "-1";
	exit(0);
}

void add(int type, int dt) {
	if (dt == 0) {
		ans[type] = 0;
	}
	else {
		ans[type] = g[type][dt - 1];
	}
}

void solve() {
	int n, x, y;
	string s;
	cin >> n >> s >> x >> y;
	forn(i, s.length()) {
		char c = s[i];
		int type = 0;
		if (c == 'U') type = 1;
		if (c == 'R') type = 2;
		if (c == 'D') type = 3;
		g[type].push_back(i + 1);
	}
	//X
	int vx = (int)g[2].size() - (int)g[0].size();
	int dx = max(0, min((int)g[0].size(), vx - x));
	add(0, (int)g[0].size() - dx);
	vx -= dx;
		
	dx = max(0, min((int)g[2].size(), x - vx));
	add(2, (int)g[2].size() - dx);
	vx += dx;
	if (vx != x) {
		no();
	}

	//Y
	int vy = (int)g[1].size() - (int)g[3].size();
	int dy = max(0, min((int)g[3].size(), vy - y));
	add(3, (int)g[3].size() - dy);
	vy -= dy;

	dy = max(0, min((int)g[1].size(), y - vy));
	add(1, (int)g[1].size() - dy);
	vy += dy;
	if (vy != y) {
		no();
	}
	forn(i, 4) {
		cout << ans[i] << ' ';
	}
}