#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define mp make_pair
#define sz(a) (int)((a).size())

typedef long long ll;
typedef long double ld;
typedef pair < int, int > pi;
typedef pair < ll, ll > pl;

const int MAX_N = (int)2e5 + 123;
const int inf = (int)2e9 + 123;

int n, k;

struct seg {
    int l, r, p;
    bool operator < (const seg &b) const {
        return r < b.r;
    }
} a[MAX_N];

map < int, int > pref;
bool bad() {
    for (int i = 1; i <= n; i++)
        pref[a[i].l]++, pref[a[i].r + 1]--;
    if (pref[1] == 0)
        return 1;
    int now = 0;
    for (auto i : pref) {
        now += i.s;
        if (now == 0 && i.f <= k)
            return 1;
    }
    return 0;
}

map < int, int > good;

void Solution_for_one() {
    good[0] = 1;
    for (int i = 1; i <= n; i++) {
        if (good[a[i].l - 1])
            good[a[i].r] = 1;
    }
    printf("%d", (good[k] ? 1 : 2));
    exit(0);
}

int dp[3005][3005];

bool Good(int i, int j) {
    if (a[i].r < a[j].r && a[j].l > a[i].l && a[j].l <= a[i].r + 1)
        return 1;
    return 0;
}

int main() {
    #ifdef NICK
    freopen("input.txt", "r", stdin);
    #endif // NICK
    scanf("%d%d", &n, &k);
    for (int i = 1; i <= n; i++)
        scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p);
    if (bad()) {
        puts("-1");
        exit(0);
    }
    sort(a + 1, a + n + 1);
    bool allone = 1;
    for (int i = 1; i <= n; i++)
        if (a[i].p != 1) {
            allone = 0;
            break;
        }
    if (allone)
        Solution_for_one();


    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        dp[i][j] = inf;
    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++) {
            if (!Good(i, j))
                continue;
            if (a[i].l == 1)
                dp[i][j] = (a[j].l == a[i].r + 1 ? max(a[j].p, a[i].p) : a[j].p + a[i].p);
            if (dp[i][j] == inf)
                continue;
            for (int nw = j + 1; nw <= n; nw++) {
                if (!Good(j, nw))
                    continue;
                if (a[nw].l <= a[i].r)
                    continue;
                int val = (a[nw].l == a[j].r + 1 ? max(a[j].p, a[nw].p) : a[j].p + a[nw].p);
                val = max(val, dp[i][j]);
                dp[j][nw] = min(dp[j][nw], val);
            }
        }
    int ans = inf;
    for (int i = 1; i <= n; i++) {
        if (a[i].l == 1 && a[i].r == k)
            ans = min(ans, a[i].p);
        for (int j = i + 1; j <= n; j++)
            if (a[j].r == k)
                ans = min(ans, dp[i][j]);
    }
    assert(ans != inf);
    printf("%d", ans);
    return 0;
}
