#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define mp make_pair
#define sz(a) (int)((a).size())

typedef long long ll;
typedef long double ld;
typedef pair < int, int > pi;
typedef pair < ll, ll > pl;

const int MAX_N = (int)2e5 + 123;
const int inf = (int)2e9 + 123;

int n, k;

struct seg {
    int l, r, p;
    bool operator < (const seg &b) const {
        return r < b.r;
    }
} a[MAX_N];

map < int, int > pref;

bool bad() {
    for (int i = 1; i <= n; i++)
        pref[a[i].l]++, pref[a[i].r + 1]--;
    if (pref[1] == 0)
        return 1;
    int now = 0;
    for (auto i : pref) {
        now += i.s;
        if (now == 0 && i.f <= k)
            return 1;
    }
    return 0;
}

pi _find(int x, int y) {
    int l = 1, r = n, mid = -1, L = n + 1, R = 0;
    while(l <= r) {
        mid = (l + r) / 2;
        if (a[mid].r >= x) {
            L = mid;
            r = mid - 1;
        }
        else
            l = mid + 1;
    }
    l = 1, r = n;
    while(l <= r) {
        mid = (l + r) / 2;
        if (a[mid].r <= y) {
            R = mid;
            l = mid + 1;
        }
        else
            r = mid - 1;
    }
    return mp(L, R);
}

int dp[MAX_N];

int calc(int id, int val, pi seg) {
    if (a[id].p > val)
        return inf;
    if (a[id].l == 1)
        return 0;
    for (int i = seg.f; i <= seg.s; i++)
        if (dp[i] < a[id].l && a[i].p + a[id].p <= val)
            return a[i].r;
    return inf;
}

map < int, bool > have;

bool check(int val) {
    have.clear();
    for (int i = 1; i <= n; i++) {
        dp[i] = calc(i, val, _find(a[i].l, a[i].r - 1));
        if (a[i].p <= val && have.count(a[i].l - 1))
            dp[i] = a[i].l - 1;
        if (dp[i] != inf) {
            have[a[i].r] = 1;
            if (a[i].r == k)
                return 1;
        }
    }
    return 0;
}

int main() {
    #ifdef NICK
    freopen("input.txt", "r", stdin);
    #endif // NICK
    scanf("%d%d", &n, &k);
    for (int i = 1; i <= n; i++)
        scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p);

    if (bad()) {
        puts("-1");
        exit(0);
    }

    sort(a + 1, a + n + 1);
    int l = 1, r = (int)2e9, mid = -1, ans = -1;
    while(l <= r) {
        mid = (0ll + l + r) / 2;
        if (check(mid)) {
            ans = mid;
            r = mid - 1;
        }
        else
            l = mid + 1;
    }
    assert(ans != -1);
    printf("%d", ans);
    return 0;
}
