#include <bits/stdc++.h>

#define size(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
const long long inf = 2e5;
typedef long long ll;

using namespace std;

ll n;
vector < ll > l(n);

bool can(int k) {
	ll ans = 1;
	vector < pair < ll, ll > > s(1, {inf, 0});
	for (ll i = 0; i < n; i++) {
		if (i == 0 || l[i] < l[i - 1]) {
			ll last = 0, idx = -1;
			while (!s.empty() && s.back().first >= l[i]) {
				last = s.back().second;
				idx = s.back().first;
				s.pop_back();
			}
			if (idx == l[i]) s.push_back({idx - 1, last});
			s.push_back({l[i], last + 1});
			ans = max(ans, last + 1);
		} else if (l[i] == l[i - 1]) {
			ll last = 0, idx = -1;
			while (!s.empty() && s.back().second >= k) {
				s.pop_back();
			}
			if (s.empty()) {
				return false;
			}
			last = s.back().second;
			idx = s.back().first;
			s.pop_back();
			if ((!s.empty() && s.back().first + 1 < idx) || (s.empty() && idx > 1)) s.push_back({idx - 1, last});
			s.push_back({idx, last + 1});
			if (!s.empty() && s.back().first + 1 < l[i]) s.push_back({l[i], 1});
		} else {
			s.push_back({l[i], 1});
		}
	}
	return ans <= k;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	cin >> n;
	l.resize(n);
	for (ll i = 0; i < n; i++) cin >> l[i];

	// cout << can(7) << "\n";
	// return 0;

	ll l = 0, r = inf + 1;
	while (r - l > 1) {
		ll m = l + (r - l) / 2;
		if (can(m)) r = m;
		else l = m;
	}

	cout << r;

	return 0;
}