#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <algorithm>
#	include <string>
#	include <vector>
#	include <iomanip>
#	include <functional>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef unsigned long long ll;
typedef long double ld;

const ll MOD = (ll)1e9 + 7;

vector<ll> pow2_res(1, 1);
ll pow2(ll n)
{
	if (n < pow2_res.size())
		return pow2_res[n];
	pow2_res.push_back(2 * pow2(n - 1));
	return pow2_res.back();
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif

	ll g;
	cin >> g;

	for (ll _i = 0; _i < g; _i++)
	{
		ll a, b;

		ll l = 0, r = 61;
		while (l < r - 1)
		{
			ll m = (r - l) / 2 + l;

			cout << "X " << pow2(m) << endl;
			cin >> a;
			if (a == -1)
				return 0;
			cin >> b;

			if (a == 1 && b == pow2(m))
				l = m;
			else
				r = m;
		}

		cout << "X " << pow2(l + 1) << endl;
		cin >> a;
		if (a == -1)
			return 0;
		cin >> b;

		cout << "N " << (ll)(pow2(l) * (ld)b / (b - pow2(l + 1) * (ld)a)) << endl;

		string s;
		cin >> s;

		if (s[0] == 'W')
			return 0;
	}
}