#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <algorithm>
#	include <string>
#	include <vector>
#	include <iomanip>
#	include <functional>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef unsigned long long ll;
typedef long double ld;

const ll MOD = (ll)1e9 + 7;

vector<ll> pow2_res(1, 1);
ll pow2(ll n)
{
	if (n < pow2_res.size())
		return pow2_res[n];
	pow2_res.push_back(2 * pow2(n - 1));
	return pow2_res.back();
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif

	ll g;
	cin >> g;

	for (ll _i = 0; _i < g; _i++)
	{
		ll a, b;

		ll l = 0, r = 64;
		while (l < r - 1)
		{
			ll m = (r - l) / 2 + l;

			cout << "X " << pow2(m) << endl;
			cin >> a;
			if (a == -1)
				return 0;
			cin >> b;

			if (a == 1 && b == pow2(m))
				l = m;
			else
				r = m;
		}

		cout << "X " << pow2(l + 1) << endl;
		cin >> a;
		if (a == -1)
			return 0;
		cin >> b;

		ll _a = pow2(l), _b = b, _c = b, _d = pow2(l + 1), _e = a;

		while ((_a % 2 == 0 || _b % 2 == 0) && _c % 2 == 0 && (_d % 2 == 0 || _d % 2 == 0))
		{
			if (_a % 2 == 0)
				_a /= 2;
			else
				_b /= 2;

			_c /= 2;

			if (_d % 2 == 0)
				_d /= 2;
			else
				_e /= 2;
		}

		for (ll p = 3; p <= 10000000; p += 2)
			while ((_a % p == 0 || _b % p == 0) && _c % p == 0 && (_d % p == 0 || _d % p == 0))
			{
				if (_a % p == 0)
					_a /= p;
				else
					_b /= p;

				_c /= p;

				if (_d % p == 0)
					_d /= p;
				else
					_e /= p;
			}

		cout << "N " << _a * _b / (_c - _d * _e) << endl;

		string s;
		cin >> s;

		if (s[0] == 'W')
			return 0;
	}
}