#include <stdio.h>
#include <bits/stdc++.h>

#define pp pop_back
#define pb push_back
#define sz(a) (int)(a.size())
#define mp make_pair
#define F first
#define S second
#define y1 _y1
#define next _next
#define prev _prev
#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = (int)1e5 + 123;
const int inf = (int)1e9 + 123;
const ll INF = (ll)1e18 + 123;

struct data {
	int l, r, p;
	data() {
		l = r = p = 0;
	}
	void in() {
		cin >> l >> r >> p;
	}
};

bool cmp(data a, data b) {
	if(a.r == b.r)
		return a.l < b.l;
	return a.r < b.r;
}

int n, k;
data a[N];
ll res = INF;
vector<pair<int, pii> > g;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	unsigned int FOR;
	asm("rdtsc" : "=a"(FOR));
	srand(FOR);
	cin >> n >> k;
	for(int i = 0; i < n; i ++)
		a[i].in();
	//sort(a, a + n, &cmp);

	for(int mask = 1; mask < (1 << n); mask ++) {
		g.clear();
		int l = -1, r = -1;					
		bool ok = 1;
		for(int i = n - 1; i >= 0; i --) {
			if(mask & (1 << i)) {
				g.pb(mp(1, mp(a[i].l, a[i].p)));
				g.pb(mp(2, mp(a[i].r + 1, a[i].p)));
				if(l == -1) l = a[i].l, r = a[i].r;
				else {
					if(a[i].r < l - 1) {
						ok = 0;
						break;			
					}
					l = min(l, a[i].l);
				}
			}
		}
		if(!ok || l > 1 || r < k) continue;
		ll cost = 0, mx = -1;
		sort(all(g));
		//cout << "\n";		
		for(int i = 0; i < sz(g); i ++) {
			//if(mask == 3)
			//cout << g[i].F << " " << g[i].S.F << " " << g[i].S.S << " " << cost << " mx: " << mx << "\n";
			if(g[i].F == 1)  cost += g[i].S.S;
			else             cost -= g[i].S.S;
			if(i == sz(g) - 1 || g[i + 1].S.F != g[i].S.F)
				mx = max(mx, cost);	
		}
		//cout << "mx: " << mx << "\n";
		res = min(res, mx);
	}
	if(res == INF) res = -1;
	cout << res;
	return 0;
}