#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define line vector<ll>
#define ld long double
#define f first
#define s second
#define forx(x, a) for(auto &x : a)
#define all(a) a.begin(), a.end()
#define forn(i, n) for(ll i = 0; i < n; i++)

int main()
{
    #ifdef LOCAL
    freopen("muffin.in", "rt", stdin);
    freopen("muffin.out", "wt", stdout);
    #else
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);
    #endif // LOCAL

    ll n, x, y;
    cin >> n;
    string done;
    cin >> done;
    cin >> x >> y;

    cerr << done << " " << x << " " << y << "\n";

    ll left, right, up, down;
    left = right = up = down = 0;
    forx(x, done)
    {
        if (x == 'L')
            left++;
        else if (x == 'R')
            right++;
        else if (x == 'U')
            up++;
        else
            down++;
    }

    cerr << left << " " << right << " " << up << " " << down << "\n";

    ll dR, dL, dU, dD;
    dR = dL = dU = dD = 0;

    if (x == 0)
    {
        dR = 0;
        dL = 0;
    }
    else
    {
        if (right - left == x)
        {
            dR = right;
            dL = left;
        }
        else
        {
            if (right - left > x)
            {
                dR = right - (right - left - x);
                dL = left;
            }
            else
            {
                dR = right;
                dL = left - (x - right + left);
            }
        }
    }

    if (y == 0)
    {
        dU = 0;
        dD = 0;
    }
    else
    {
        if (up - down == y)
        {
            dU = up;
            dD = down;
        }
        else
        {
            if (up - down > y)
            {
                dU = up - (up - down - y);
                dD = down;
            }
            else
            {
                dU = up;
                dD = down - (y - up + down);
            }
        }
    }

    //cerr << dR << " " << dL << "\n";
    //cerr << dU << " " << dD << "\n";

    if (dR < 0 || dL < 0 || dU < 0 || dD < 0)
    {
        cout << "-1\n";
        cerr << "-1\n";
        return 0;
    }

    ll cntL, cntR, cntU, cntD;
    cntL = cntR = cntU = cntD = 0;

    ll ansL, ansR, ansU, ansD;
    ansL = ansR = ansU = ansD = 0;

    for(ll i = 0; i < n; i++)
    {
        auto x = done[i];
        if (x == 'L')
            cntL++;
        if (cntL == dL)
        {
            ansL = i;
            break;
        }
    }
    for(ll i = 0; i < n; i++)
    {
        auto x = done[i];
        if (x == 'R')
            cntR++;
        if (cntR == dR)
        {
            ansR = i;
            break;
        }
    }
    for(ll i = 0; i < n; i++)
    {
        auto x = done[i];
        if (x == 'U')
            cntL++;
        if (cntU == dU)
        {
            ansU = i;
            break;
        }
    }
    for(ll i = 0; i < n; i++)
    {
        auto x = done[i];
        if (x == 'D')
            cntD++;
        if (cntD == dD)
        {
            ansD = i;
            break;
        }
    }

    cout << ansL << " " << ansU << " " << ansR << " " << ansD << "\n";
    cerr << ansL << " " << ansU << " " << ansR << " " << ansD << "\n";

    return 0;
}
