#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;

vector<int> l;
int n;

void next(vector<int> &p, int m) {
	int k = p.size();
	for (int i = k - 1; i >= 0; i--) {
		if (p[i] == m) {
			p.pop_back();
		}
		else {
			p[i]++;
			break;
		}
	}
	while (p.size() != k) {
		p.push_back(1);
	}
}

int  c(vector<int> p, int m) {
	for (int i = 0; i < p.size(); i++) {
		if (p[i] != m) {
			return 0;
		}
	}
	return 1;
}

bool check(int m) {
	vector<int> p(l[0]);
	for (int i = 0; i < l[0]; i++) {
		p[i] = 1;
	}
	for (int i = 1; i < n; i++) {
		if (l[i - 1] < l[i]) {
			while (p.size() != l[i])
				p.push_back(1);
		}
		if (l[i - 1] >= l[i]) {
			while (p.size() != l[i])
				p.pop_back();
			if (c(p, m)) {
				return 0;
			}
			next(p, m);
		}
	}
	return 1;
}

int main() {
	cin >> n;
	l.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	int l = 0;
	int r = 5001;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if (!check(m))
			l = m;
		else
			r = m;
	}
	cout << r;
	return 0;
}