from random import *
from math import *

DEBUG = False
answer = -1
cnt_atts = 0
MAX_ATTS = 60

def lcm(a, b):
    return a // gcd(a, b) * b

def get(x):
    if DEBUG:
        global cnt_atts
        cnt_atts += 1
        if cnt_atts > MAX_ATTS:
            print('Too many queries!')
            exit(1)
        a = answer // x
        b = answer
        d = gcd(a, b)
        return a // d, b // d
    else:
        if x not in mem:
            print('X', x)
            s = input()
            if s == '-1':
                exit()
            else:
                a, b = map(int, s.split())
                mem[x] = (a, b)
        return mem[x]

seed(239566)

g = int(input())
for tt in range(g):
    if DEBUG:
        answer = int(input())
        cnt_atts = 0

    mem = dict()

    q = 60
    l = 2
    r = 1000
    mult = 1
    for i in range(q):
        if r < l:
            break
        x = randint(l, r)

        a, b = get(x * mult)
        if a == 0:
            r = min(r // 2, x * mult - 1)
        else:
            mult = lcm(mult, b)

    print('N', mult)

    if not DEBUG:
        res = input()
        if res == 'Wrong':
            exit()
