#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
const int MAXN = 1e5 + 100;
const int MAXL = 1e3 * 5 + 100;

int lnc[MAXN];
int n;

bool pr(int m){
    int mas[MAXL];

    for (int i = 0; i < MAXL; ++i){
        mas[i] = 0;
    }

    for (int i = 0; i < lnc[0]; ++i){
        mas[i] = 1;
    }

    for (int i = 1; i < n; ++i){
        if (lnc[i] > lnc[i - 1]){
            for (int j = lnc[i - 1]; j < lnc[i]; ++j){
                mas[j] = 1;
            }
        } else {
            int j = 0;
            while (mas[j] == m){
                mas[j] = 1;
                j++;
            }

            mas[j]++;

            if (j >= lnc[i]){
                return false;
            }
        }
    }

    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for (int i = 0; i < n; ++i){
        cin >> lnc[i];
    }

    int l = 1;
    int r = 3;

    while (l + 1 < r){
        int m = (l + r) / 2;

        if (pr(m)){
            r = m;
        } else {
            l = m;
        }
    }

    cout << r << endl;
    return 0;
}
