#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>

using namespace std;
const int MAXN = 1e5 + 100;

int n, k;
vector<int> mas[MAXN];
vector<pair<int, int>> sob;

bool keks(){
    sort(sob.begin(), sob.end());
    int bal = 0;

    for (int i = 0; i < sob.size(); ++i){
        if (bal == 0 && i != 0){
            return false;
        }

        if (sob[i].second == 1){
            bal++;
        } else {
            bal--;
        }
    }

    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;
    bool fl = true;
    bool lft = false;
    bool rght = false;

    for (int i = 0; i < n; ++i){
        int l, r, w;
        cin >> l >> r >> w;

        if (l == 1){
            lft = true;
        }

        if (r == k){
            rght = true;
        }

        mas[i].push_back(r - 1);
        mas[i].push_back(l - 1);
        mas[i].push_back(w);

        sob.push_back({l - 1, 1});
        sob.push_back({r, 2});

        if (w != 1){
            fl = false;
        }
    }

    if (!keks() || !lft || !rght){
        cout << -1 << endl;
        return 0;
    }

    if (fl){
        map<int, bool> mp;
        sort(mas, mas + n);

        for (int i = 0; i < n; ++i){
            if (mas[i][1] == 0){
                mp[mas[i][0]] = true;
            } else {
                if (mp.count(mas[i][1] - 1)){
                    mp[mas[i][0]] = true;
                }
            }
        }

        if (mp.count(k - 1)){
            cout << 1 << endl;
        } else {
            cout << 2 << endl;
        }
    }

    return 0;
}
