#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;
typedef unsigned long long ull;

#define F first
#define S second
#define en end()
#define bg begin()
#define rev reverse
#define mp make_pair
#define pb push_back
#define um unordered_map
#define all(x) x.bg, x.en
#define sqr(x) ((x) * (x))
#define sz(x) (int)x.size()

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;
const double pi = acos(-1.0);
const double eps = (double)1e-9;

const int N = 200500;

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

int n, mx, l[N], t[N * 4], k[N * 4];

void build(int v, int l, int r) {
	if (l == r) {
		t[v] = 1;
		return;
	}
	int mid = (l + r) >> 1;
	build(v + v, l, mid);
	build(v + v + 1, mid + 1, r);
	t[v] = 1;
}

void push(int v) {
	if (k[v]) {
		t[v + v] = t[v + v + 1] = 1;
		k[v + v] = k[v + v + 1] = 1;
		k[v] = 0;
	}
}

void upd(int v, int l, int r, int lx, int rx) {
	if (lx < l || r < lx)
		return;
	if (lx <= l && r <= rx) {
		t[v] = 1;
		k[v] = 1;
		return;
	}
	push(v);
	int mid = (l + r) >> 1;
	upd(v + v, l, mid, lx, rx);
	upd(v + v + 1, mid + 1, r, lx, rx);
	t[v] = min(t[v + v], t[v + v + 1]);
}

void upd(int v, int l, int r, int pos) {
	if (l == r) {
		t[v]++;
		return;
	}
	int mid = (l + r) >> 1;
	if (pos <= mid)
		upd(v + v, l, mid, pos);
	else
		upd(v + v + 1, mid + 1, r, pos);
	t[v] = min(t[v + v], t[v + v + 1]);
}

int get(int v, int l, int r, int lx, int rx, int lim) {
	if (r > rx)
		return get(v + v, l, (l + r) >> 1, lx, rx, lim);
	if (l == r) {
		if (t[v] == lim)
			return -1;
		return r;
	}
	int mid = (l + r) >> 1;
	if (t[v + v + 1] < lim)
		return get(v + v + 1, mid + 1, r, lx, rx, lim);
	return get(v + v, l, mid, lx, rx, lim);
}

inline bool check(int lim) {
	build(1, 1, mx);
	for (int i = 2; i <= n; i++) {
		if (l[i - 1] < l[i])
			upd(1, 1, mx, l[i - 1] + 1, mx);
		else {
			int pos = get(1, 1, mx, 1, l[i], lim);
			if (pos == -1)
				return 0;
			upd(1, 1, mx, pos);
			upd(1, 1, mx, pos + 1, mx);
		}
	}
	return 1;
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);

	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	cin >> n;

	for (int i = 1; i <= n; i++)
		cin >> l[i], mx = max(mx, l[i]);

	int l = 1, r = N, ans = -1;

	while (l <= r)  {
		int mid = (l + r) >> 1;
		if (check(mid)) {
			ans = mid;
			r = mid - 1;
		}
		else
			l = mid + 1;
	}

	cout << ans;

	return 0;
}
