#include <iostream>
#include <vector>

using namespace std;

struct delta {
    int plus_x, plus_y, minus_x, minus_y;
};

int main()
{
    int n;
    cin >> n;

    vector<char> v(n);
    vector<delta> d(n);

    for (char &e : v)
        cin >> e;

    int res_x = 0, res_y = 0;
    int cnt_l = 0, cnt_r = 0, cnt_u = 0, cnt_d = 0;
    for (char e : v)
        if (e == 'L') {
            res_x--;
            cnt_l++;
        } else if (e == 'R') {
            cnt_r++;
            res_x++;
        } else if (e == 'U') {
            res_y++;
            cnt_u++;
        } else {
            res_y--;
            cnt_d++;
        }

    int need_x, need_y;
    cin >> need_x >> need_y;

    int delta_x = -need_x + res_x, delta_y = -need_y + res_y;

    int break_l = 0, break_r = 0, break_u = 0, break_d = 0;
    if (delta_x > 0)
        break_r = delta_x;
    else if (delta_x < 0)
        break_l = -delta_x;
    if (delta_y > 0)
        break_u = delta_y;
    else if (delta_y < 0)
        break_d = -delta_y;

    if (cnt_r < break_r || cnt_l < break_l || cnt_u < break_u || cnt_d < break_d) {
        cout << -1 << endl;
        return 0;
    }

    int ans_r = n, ans_l = n, ans_d = n, ans_u = n;
    int i = 0;
    for (char e : v) {
        if (cnt_r == break_r)
            ans_r = i;
        if (cnt_l == break_l)
            ans_l = i;
        if (cnt_u == break_u)
            ans_u = i;
        if (cnt_d == break_d)
            ans_d = i;

        if (e == 'L') {
            cnt_l--;
        } else if (e == 'R') {
            cnt_r--;
        } else if (e == 'U') {
            cnt_u--;
        } else {
            cnt_d--;
        }

        i++;
    }

    cout << ans_l << ' ' << ans_u << ' ' << ans_r << ' ' << ans_d << endl;
}
