#include <bits/stdc++.h>

using namespace std;

#define forn(i, x, n) for (int i = int(x); i <= int(n); ++i)
#define for1(i, n, x) for (int i = int(n); i >= int(x); --i)
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair <ll, ll> PII;
typedef long double ld;
typedef vector <ll> vi;

const int N = 2e6 + 10;
const int INF = 1e9 + 9;
const int B = 1e9 + 7;

int n, k;
int a[N];

bool poss(int mx) {
    k = mx;
    vector <PII> st;
    forn(i, 2, n) {
        if (a[i] > a[i - 1]) continue;
        while (st.size() && st.back().F > a[i] - 1) st.pop_back();
        if (st.size() && st.back().F == a[i] - 1) {
            int j = st.size() - 1, x = a[i] - 1;
            for (; j >= 0 && x >= 0; --j, --x) {
                if (st[j].S + 1 < mx || st[j].F != x) break;
                st.pop_back();
            }
            if (x < 0) return 0;
            if (!st.size() || st.back().F != x)
                st.pb({x, 0});
        }
        else
            st.pb({a[i] - 1, 0});
        ++st[st.size() - 1].S;
        //cerr << i << ": " << st.back().F << "\n";
    }
    return 1;
}

int main() {
    #ifdef black
    freopen("in", "r", stdin);
    #endif // black
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    bool ok = 1;
    forn(i, 1, n) {
        cin >> a[i];
        ok &= (a[i] > a[i - 1]);
    }
    if (ok) {
        cout << "1\n";
        return 0;
    }

    int l = 2, r = n;
    while (l < r) {
        int m = (l + r) / 2;
        if (!poss(m)) l = m + 1;
        else r = m;
    }
    cout << l << "\n";

    return 0;
}
