#include <iostream>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 3e5, MOD = 1e9 + 7;
const ll INF = 1e13;

int n, m;

vector <int> s;

int a[N];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < a[0]; i++)
        s.push_back(0);
    int k = 1;
    for (int i = 1; i < n; i++)
    {
        //cout << s << endl;
        if (a[i] > a[i - 1])
        {
            while (a[i - 1] < a[i])
                s.push_back(0), a[i - 1]++;
            continue;
        }
        if (a[i] < a[i - 1])
        {
            while (a[i - 1] > a[i])
            {
                a[i - 1]--;
                s.pop_back();
            }
            k++;
            s[s.size() - 1]++;
            continue;
        }
        int f = 0;
        for (int j = 1; j < s.size(); j++)
            if (s[j] > s[j - 1])
                f = 1;
        if (f)
        {
            next_permutation(s.begin(), s.end());
            continue;
        }
        f = 0;
        for (int j = 1; j < s.size(); j++)
            if (s[j] != s[j - 1])
                f = 1;
        if (!f)
            k++;
        s[s.size() - 1]++;
    }
    //cout << s << endl;
    cout << k << endl;
    return 0;
}
