#include <iostream>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 3e5, MOD = 1e9 + 7;
const ll INF = 1e13;


ll otv = INF;
int n, m;

ll l[N], r[N], pp[N];

void rec(int i, vector <ll> &a)
{
    ll ans = 0;
    if (i == n)
    {
        int f = 0;
        for (int j = 0; j < m; j++)
        {
            if (a[j] == 0)
                f = 1;
            ans = max(ans, a[j]);
        }
        if (!f)
            otv = min(otv, ans);
        return;
    }
    rec(i + 1, a);
    //cout << i << endl;
    for (int j = l[i]; j <= r[i]; j++)
        a[j] += pp[i];
    rec(i + 1, a);
    for (int j = l[i]; j <= r[i]; j++)
        a[j] -= pp[i];
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i] >> r[i] >> pp[i];
        l[i]--;
        r[i]--;
    }

    vector <ll> a;

    a.resize(m);

    rec(0, a);

    if (otv == INF)
        cout << -1 << endl;
    else
        cout << otv << endl;
    return 0;
}
