/*
	Open Olympiad 2017 tour 1
	Task C
	Solve by Ed_Os
*/
#include <iostream>
#include <cstdio>
#include <time.h>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;
#define ll long long
#define ull unsigned long long

const ll max_n = 100050,max_d = 200000000;
//map<ll,ll> q;
pair<pair<ll,ll>,ll > line[max_n];
ll n,k,t;
bool w[max_n];
vector<ll> ot[max_n];
pair<ll,ll> dp[max_n];
pair<ll,ll> get(ll p)
{
	if(!w[p])
	{
		w[p] = true;
		if(line[p].first.first == 1)
		{
			dp[p] = make_pair(line[p].second,0);
			return dp[p];
		}
		ll res = max_d,rb = -1,tres;
		pair<ll,ll> tmp;
		for(ll j = 0;j < ot[p].size();j++)
		{
			//cout << "OK" << endl;
			tmp = get(ot[p][j]);
			if(tmp.second - 1 >= line[p].first.first)
				continue;
			if(line[j].first.second == line[p].first.first - 1)
				tres = max(tmp.first,line[p].second);
			else
				tres = max(tmp.first,line[p].second + line[j].second);
			if(tres < res)
			{
				res = tres;
				rb = line[j].first.second;
			}
		}
		dp[p] = make_pair(res,rb);	
	}
	return dp[p];
}
int main()
{
	//freopen("input","r",stdin);
	ios_base::sync_with_stdio(false);
	cin >> n >> k;
	for(ll i = 0;i < n;i++)
		cin >> line[i].first.first >> line[i].first.second >> line[i].second;
	for(ll i = 0;i < n;i++)
		for(ll j = 0;j < n;j++)
			if(line[i].first.second > line[j].first.second && line[i].first.first - 1 <= line[j].first.second  && line[i].first.first > line[j].first.first)
				ot[i].push_back(j);
			
	ll ans = max_d;
	for(ll i = 0;i < n;i++)
	{
	// 	cout << "----- " << i << endl;
		if(line[i].first.second == k)
			ans = min((get(i)).first,ans);
	}
	cout << (ans < max_d ? ans:-1);
	return 0;
}
