#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <random>
#include <ctime>
#include <queue>
using namespace std;

#define TASK "sample"

const int maxN = 1e5 + 100;
const int INF = 1e9;
const long long LINF = 3e18;
const long long MOD = 1e9 + 7;
const long long P = 257;
const int K = 1000;
const long long SIZE = (1LL << 31);

mt19937_64 gen;


long long random(long long l, long long r)
{
	uniform_int_distribution<long long> dist(l, r);
	return dist(gen);
}

pair<long long, long long> ask(long long x)
{
	long long f, s;
	cout << "X " << x;
	cin >> f >> s;
	return make_pair(f, s);
}

void ans(long long x)
{
	string s;
	cout << "N " << x;
	cin >> s;
	if (s == "Wrong")
		exit(0);
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif

	int g;
	cin >> g;
	for (int game = 0; game < g; game++)
	{
		int curr = 0;
		for (long long k = 4; k >= 0; k--)
		{
			if (ask(curr + (1 << k)).first != 0)
				curr += (1 << k);
		}
		ans(curr);
	}

	return 0;
}

