#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define FREOPEN freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

typedef long long ll;
typedef long double ld;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;

const int INF = 1e9;
const ll INF64 = 1e18;
const int N = 200100;
const int M = 5;
const int DEBUG = 0;

int n, ww, a[N], d[N];
int t[N * 4 + 100], p[N * 4 + 100];

void build(int v, int tl, int tr) {
    p[v] = 0;
    if (tl == tr) {
        t[v] = 1;
    }
    else {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
}

inline void push(int v, int tl, int tr) {
    if (tl != tr) {
        p[v * 2] |= p[v];
        p[v * 2 + 1] |= p[v];
    }
    if (p[v])
        t[v] = 1;
    p[v] = 0;
}

void cl(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (l > r)
        return;
    if (tl == l && tr == r) {
        p[v] = 1;
        push(v, tl, tr);
    }
    else {
        int tm = (tl + tr) / 2;
        cl(v * 2, tl, tm, l, min(r, tm));
        cl(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
}

void inc(int v, int tl, int tr, int ind) {
    push(v, tl, tr);
    if (tl == tr)
        t[v]++;
    else {
        int tm = (tl + tr) / 2;
        if (ind <= tm) {
            inc(v * 2, tl, tm, ind);
            push(v * 2 + 1, tm + 1, tr);
        }
        else {
            inc(v * 2 + 1, tm + 1, tr, ind);
            push(v * 2, tl, tm);
        }
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (l > r || t[v] >= ww)
        return -1;
    if (tl == tr)
        return tl;
    else {
        int tm = (tl + tr) / 2;
        int ans = get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
        if (ans == -1)
            ans = get(v * 2, tl, tm, l, min(r, tm));
        return ans;
    }
}

int pr(int v, int tl, int tr, int ind) {
    push(v, tl, tr);
    if (tl == tr)
        return t[v];
    else {
        int tm = (tl + tr) / 2;
        if (ind <= tm)
            return pr(v * 2, tl, tm, ind);
        else
            return pr(v * 2 + 1, tm + 1, tr, ind);
    }
}

inline bool check(int w) {
    ww = w;
    int len = a[0];
    build(1, 0, N);
    if (DEBUG) {
        cout << "=====================" << endl;
        forn(i, len)
            cout << d[i] << ' ';
        cout << endl;
    }
    for (int v = 1; v < n; v++) {
        if (a[v] > a[v - 1]) {
            cl(1, 0, N, len, a[v] - 1);
            len = a[v];
        }
        else {
            len = a[v];
            int ind = get(1, 0, N, 0, len - 1);
            if (ind == -1)
                return 0;
            inc(1, 0, N, ind);
            cl(1, 0, N, ind + 1, len - 1);
        }
    }
    return 1;
}

int main() {
    cin >> n;
    forn(i, n) {
        scanf("%d", &a[i]);
    }
    int l = 0, r = 1e5;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    cout << r << endl;
    return 0;
}


/*



*/



