#include <cstdio>
#define INF 50

struct Point
{
    int a;
    int x;
    Point(int a, int x)
    {
        this->a = a;
        this->x = x;
    }
};

bool add(int q, int *str, int n)
{
    for (int i = n - 1; i >= 0; i--) {
        str[i]++;
        if (str[i] < q)
            return true;
        str[i] = 0;
    }
    return false;
}

bool can(int n, Point **mas, int q)
{
    int *str = new int[INF];
    for (int i = 0; i < INF; i++)
        str[i] = 0;
    for (int i = 1; i < n; i++)
        if (mas[i]->x <= mas[i - 1]->x && !add(q, str, mas[i]->a)) {
            delete[] str;
            return false;
        }
    delete[] str;
    return true;
}

int main()
{
    int n, a;
    scanf("%d", &n);
    Point **mas = new Point*[n];
    for (int i = 0; i < n; i++) {
        scanf("%d", &a);
        mas[i] = new Point(a, a);
        if (mas[i]->x > INF)
            mas[i]->x = INF;
    }
    for (int i = 1; ; i++)
        if (can(n, mas, i)) {
            printf("%d\n", i);
            break;
        }
    /*int a = 1, b = n + 1;
    while (a < b) {
        int m = (a + b) / 2;
        if (can(n, mas, m))
            a = m + 1;
        else
            b = m;
    }
    a--;
    printf("%d\n", a);*/
    return 0;
}
