#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

long long ans = 0;

void go(int p, int k) {
	if(p == 0) {
		ans++;
		return;
	}
	if(k == 0) return;

	go(p, k - 1);
	go(p - 1, k);
}

long long f(long long len, long long k) {
    ans = 0;

	go(len, k);

	return ans;
}

long long C(long long n, long long k) {
    double ans = 1;
    for(int i = 1; i <= k; i++)
        ans = ans * (n - k + i) / i;
    return (int)(ans + EPS);
}

int main() {
//	freopen(".in", "r", stdin);

    int n; cin >> n;
    int len; cin >> len;

    for(int ans = 1; ; ans++)
        if(f(len, ans) >= n) {
            cout << ans << "\n";
            return 0;
        }
}
