#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

int n;
int a[MAXN];

const int lol = 30;

int b[MAXN][lol];

bool f(long long c) {
    for(int i = 0; i < min(a[0], lol); i++)
        b[0][i] = 0;

    for(int i = 1; i < n; i++) {
        if(a[i] > a[i - 1]) {
            for(int j = 0; j < min(a[i], lol); j++) {
                if(a[i - 1] - min(a[i - 1], lol) >= (a[i] - min(a[i], lol) + j))
                    b[i][j] = b[i - 1][abs((a[i - 1] - min(a[i - 1], lol)) - (a[i] - min(a[i], 20) + j))];
                else
                    b[i][j] = 0;
            }
        }
        if(a[i] == a[i - 1]) {
            int len = min(a[i], lol);

            for(int j = 0; j < len; j++)
                b[i][j] = b[i - 1][j];

            bool ok = 0;
            for(int j = len - 1; j >= 0; j--) {
                if(b[i][j] + 1 < c) {
                    b[i][j]++;
                    ok = 1;
                    break;
                } else b[i][j] = 0;
            }

            if(!ok) return 0;
        }
        if(a[i] < a[i - 1]) {
            for(int j = 0; j < min(a[i], lol); j++) {
                if(a[i - 1] - min(a[i - 1], lol) >= (a[i] - min(a[i], lol) + j))
                    b[i][j] = b[i - 1][abs((a[i - 1] - min(a[i - 1], lol)) - (a[i] - min(a[i], lol) + j))];
                else
                    b[i][j] = 0;
            }

            int len = min(a[i], lol);
            bool ok = 0;
            for(int j = len - 1; j >= 0; j--) {
                if(b[i][j] + 1 < c) {
                    b[i][j]++;
                    ok = 1;
                    break;
                } else b[i][j] = 0;
            }

            if(!ok) return 0;
        }
    }
    return 1;
}

int main() {
//	freopen(".in", "r", stdin);

    cin >> n;
    for(int i = 0; i < n; i++)
        a[i] = next_int<int>();

    long long l = 1;
    long long r = (int)1e9;
    while(r - l > 1) {
        long long c = (l + r) / 2;
        if(f(c))
            r = c;
        else
            l = c;
    }

    if(f(l))
        cout << l << "\n";
    else
        cout << r << "\n";
}
