#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

int l[MAXN], r[MAXN], c[MAXN];

int main() {
//	freopen(".in", "r", stdin);

	int n, k; cin >> n >> k;
	for(int i = 0; i < n; i++) {
		l[i] = next_int<int>();
		r[i] = next_int<int>();
		c[i] = next_int<int>();
	}

	long long ans = INF;
	for(int i = 0; i < (1 << n); i++) {
		vector<pair<int, int> > q;
		for(int j = 0; j < n; j++)
			if((1 << j) & i) {
				q.push_back(make_pair(l[j], -c[j]));
				q.push_back(make_pair(r[j], c[j]));
			}

		sort(all(q));

		if(!q.size()) continue;

		if(q[0].first != 1 || q.back().first != k)
			continue;

		long long kek = 0, ska = 0;
		for(int j = 0; j < q.size(); j++) {
			ska -= q[j].second;
			kek = max(kek, ska);
		}

		ans = min(ans, kek);
	}

	if(ans == INF)
		ans = -1;

	cout << ans << "\n";
}
