#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

const int q = 30;
const bool DEBUG = 0;
long long n = 10;

map<long long, pair<long long, long long> > kek;

pair<long long, long long> get(long long k) {
    if(kek.find(k) != kek.end())
        return kek[k];

	pair<long long, long long> ans;
	if(DEBUG) {
		ans = make_pair(n / k, n);
		long long temp = __gcd(ans.first, ans.second);
		ans.first /= temp;
		ans.second /= temp;
	} else {
		cout << "X " << k << "\n"; fflush(stdout);
		cin >> ans.first >> ans.second;
	}
	return ans;
}

unsigned long long my_random() {
	unsigned long long q = rand() + (rand() << 16LL);
	unsigned long long w = rand() + (rand() << 16LL);
	return (q + (w << 32LL));
}

bool used[MAXN];

int main() {
//	freopen(".in", "r", stdin);
	srand(time(0));

	int w;
	if(DEBUG)
		w = 1;
	else
		cin >> w;

	while(w--) {
        long long ans = 1;
        kek.clear();

        long long l = 0;
        long long r = 59;
        while(l != r) {
            long long c = (l + r + 1) / 2;

            if(get(1LL << c).first > 0)
                l = c;
            else
                r = c - 1;
        }

        ans = max(ans, get(1LL << l).second);

        cout << "N " << ans << "\n"; fflush(stdout);
        if(!DEBUG) {
            string res; cin >> res;
        }
	}
}
