#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int main() {
    int n, k;
    cin >> n >> k;
    vector <int> cords(2, 1);
    cords[1] = k;
    int s[n], e[n], p[n];
    for (int i = 0; i < n; i++) {
        cin >> s[i] >> e[i] >> p[i];
        cords.push_back(s[i]);
        if (s[i] < k)
            cords.push_back(s[i] + 1);
        if (s[i] > 1)
            cords.push_back(s[i] - 1);
        cords.push_back(e[i]);
        if (e[i] < k)
            cords.push_back(e[i] + 1);
        if (e[i] > 1)
            cords.push_back(e[i] - 1);
    }
    sort(cords.begin(), cords.end());
    cords.resize(unique(cords.begin(), cords.end()) - cords.begin());
    /*for (int i = 0; i < cords.size(); i++)
        cout << cords[i] << ' ';
    cout << endl;*/
    for (int i = 0; i < n; i++) {
        s[i] = lower_bound(cords.begin(), cords.end(), s[i]) - cords.begin();
        e[i] = lower_bound(cords.begin(), cords.end(), e[i]) - cords.begin();
        //cout << s[i] << ' ' << e[i] << endl;
    }
    int64_t a[cords.size()], res = 1e18, mx_p;
    for (int i = 1; i < (1 << n); i++) {
        for (int j = 0; j < cords.size(); j++)
            a[j] = 0;
        for (int j = 0; j < n; j++)
            if (i & (1 << j))
                for (int k = s[j]; k <= e[j]; k++)
                    a[k] += p[j];
        /*if (i == 10) {
            for (int j = 0; j < cords.size(); j++)
                cout << a[j] << ' ';
            cout << endl;
        }*/
        mx_p = 0;
        for (int j = 0; j < cords.size(); j++) {
            if (a[j] == 0)
                break;
            mx_p = max(mx_p, a[j]);
            if (j == cords.size() - 1)
                res = min(res, mx_p);
        }
    }
    if (res == 1e18)
        cout << "-1";
    else
        cout << res;
    return 0;
}
