#include <cstdio>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

using namespace std;

bool check(vector < int > &a, int n, int k)
{
	vector < int > s(a[0], 0);
	for (int i = 1; i < n; ++i)
	{
		if (a[i - 1] < a[i])
		{
			for (int j = a[i - 1]; j < a[i]; ++j)
				s.push_back(0);
		}
		else
		{
			if (a[i - 1] > a[i])
			{
				for (int j = a[i - 1]; j > a[i]; --j)
					s.pop_back();
			}
			s.back()++;
			int j = s.size() - 1;
			while ((j > 0) && (s[j] >= k))
			{
				s[j] = 0;
				s[j - 1]++;
				j--;
			}
			if (s[0] >= k)
				return false;
		}
	}
	return true;
}

int main()
{
	freopen("input.txt", "rt", stdin);
	int n;
	scanf("%d", &n);
	vector < int > a(n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &a[i]);
	}
	bool f = true;
	for (int i = 0; i < n - 1; ++i)
		if (a[i] >= a[i + 1])
			f = false;
	if (f)
	{
		printf("1");
		return 0;
	}
	int l = 1, r = n;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		bool f = check(a, n, m);
		if (f)
			r = m;
		else
			l = m;
	}
	printf("%d", r);
	return 0;
}