#include <cstdio>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

using namespace std;

const long long INF = 8e13;

bool check(vector < int > &a, int n, int k)
{
	int border = 1;
	long long k_border = 1;
	while (k_border <= INF)
	{
		border++;
		k_border *= k;
	}
	long long cur = 0;
	for (int i = 1; i < n; ++i)
	{
		if (a[i - 1] < a[i])
		{
			for (int j = a[i - 1]; j < min(a[i], border); ++j)
				cur *= k;
		}
		else
		{
			if (a[i - 1] > a[i])
			{
				for (int j = min(a[i - 1], border); j > a[i]; --j)
					cur /= k;
			}
			if (a[i] <= border)
				cur++;
		}
		long long maxim = 1;
		if (a[i] <= border)
		{
			for (int j = 0; j < a[i]; ++j)
			{
				maxim *= k;
			}
			if (maxim == cur)
			{
				return false;
			}
		}
	}
	return true;
}

int main()
{
	freopen("input.txt", "rt", stdin);
	int n;
	scanf("%d", &n);
	vector < int > a(n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &a[i]);
	}
	bool f = true;
	for (int i = 0; i < n - 1; ++i)
		if (a[i] >= a[i + 1])
			f = false;
	if (f)
	{
		printf("1");
		return 0;
	}
	int l = 1, r = n;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		bool f = check(a, n, m);
		if (f)
			r = m;
		else
			l = m;
	}
	printf("%d", r);
	return 0;
}