#include <bits/stdc++.h>

using namespace std;

struct my
{
    int l, r, p;
};

map<int, vector<int>> go;
set<int> visited;

void dfs(int v)
{
    if (visited.count(v))
        return ;
    visited.insert(v);
    for (auto e : go[v])
        dfs(e + 1);
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<my> our(n);
    vector<int> ends;
    vector<pair<int, int>> events;
    for (int i = 0; i < n; i++) {
        cin >> our[i].l >> our[i].r >> our[i].p;
        go[our[i].l].push_back(our[i].r);
        events.push_back({our[i].l, -1});
        events.push_back({our[i].r, 1});
        ends.push_back(our[i].r);
    }
    sort(ends.begin(), ends.end());
    if (n <= 3000)
    {
        map<int, pair<int, int>> d;
        d[0] = {0, 0};
        map<int, int> last;
        for (auto a : ends)
        {
            // counting d[a]
            for (auto e : our)
            {
                if (e.l <= a && e.r >= a)
                {
                    auto p = d.lower_bound(e.l - 1);
                    if (p == d.end())
                        continue;
                    int pl = p->first;
                    int bereza;
                    if (pl < e.l)
                        bereza = d[pl].second;
                    else
                        bereza = last[pl];
                    auto New = make_pair(max(d[pl].first, bereza + e.p), e.p);
                    if (e.r == a)
                        New.second = 0;
                    if (d.count(a) == 0 || d[a] > New)
                        d[a] = New, last[a] = e.p;
                }
            }
        }
        if (d.count(k) == 0)
            cout << -1;
        else
            cout << d[k].first;
    }
    else
    {

        sort(events.begin(), events.end());
        int len = 0, opened = 0;
        int pr;
        for (auto e : events)
        {
            if (opened == 0)
                pr = e.first;
            opened -= e.second;
            if (opened == 0)
                len += e.first - pr + 1;
        }
        dfs(1);
        if (len < k)
            cout << -1;
        else if (visited.count(k + 1))
            cout << 1;
        else
            cout << 2;
    }
}