#include <bits/stdc++.h>

using namespace std;

struct my
{
    int l, r, p;
};

bool operator < (my & a, my & b)
{
    return a.l < b.l;
}

map<int, vector<int>> go;
set<int> visited;

void dfs(int v)
{
    if (visited.count(v))
        return ;
    visited.insert(v);
    for (auto e : go[v])
        dfs(e + 1);
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<my> our(n);
    vector<int> ends;
    vector<pair<int, int>> events;
    for (int i = 0; i < n; i++) {
        cin >> our[i].l >> our[i].r >> our[i].p;
        go[our[i].l].push_back(our[i].r);
        events.push_back({our[i].l, -1});
        events.push_back({our[i].r, 1});
    }
    sort(our.begin(), our.end());
    if (true)
    {
        map<int, pair<int, int>> d;
        d[0] = {0, 0};
        map<int, int> last;
        for (auto e : our)
        {
            auto t = d.lower_bound(e.l - 1);
            if (t == d.end())
                continue;
            int pl = t->first;
            int bereza;
            if (e.l < pl + 1)
                bereza = last[pl];
            else
                bereza = 0;
            auto New = make_pair(max(d[pl].first, bereza + e.p), e.p);
            if (d.count(e.r) == 0 || d[e.r] > New)
            {
                d[e.r] = New;
                last[e.r] = e.p;
            }
        }

        if (d.count(k) == 0)
            cout << -1;
        else
            cout << d[k].first;
    }
    else
    {

        sort(events.begin(), events.end());
        int len = 0, opened = 0;
        int pr;
        for (auto e : events)
        {
            if (opened == 0)
                pr = e.first;
            opened -= e.second;
            if (opened == 0)
                len += e.first - pr + 1;
        }
        dfs(1);
        if (len < k)
            cout << -1;
        else if (visited.count(k + 1))
            cout << 1;
        else
            cout << 2;
    }
}