#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = numeric_limits<ll>::max();
const ll mod = 1000000007;
const ld eps = 1e-8;
const ll maxn = 1234;
vector<vector<ll>> mas;
map<ll, ll> mp;
ll curmax = -1;

void add1(ll pos, ll cnt) {
    if (mp.count(pos) && mp[pos] == cnt) {
        mp[pos] = 1;
        add1(pos - 1, cnt);
    }
    if (!mp.count(pos)) mp[pos] = 1 + (curmax >= pos);
    else mp[pos]++;
    curmax = min(curmax, pos);
}

bool check(ll cnt) {
    mp.clear();
    for (int i = 0; i < mas.size(); i++) {
        for (int j = 0; j < mas[i].size(); j++) {
            curmax = max(curmax, mas[i][j] - 2);
            bool f = false;
            while (!mp.empty() && mp.rbegin()->first >= mas[i][j])
                mp.erase(--mp.end()), f = true;
            //if (f) add1(i.first - 1, cnt);
            add1(mas[i][j] - 1, cnt);
        }
    }
    if (mp.begin()->first <= -1) return false;
    return true;
}

int run() {
    ll n;
    cin >> n;
    ll pr = -1;
    bool flag = true;
    mas.push_back(vector<ll>());
    for (int i = 0; i < n; ++i) {
        ll a;
        cin >> a;
        if (a < pr) {
            flag = false;
            mas.push_back(vector<ll>());
        } else if (a == pr) {
            flag = false;
        }
        pr = a;
        mas[mas.size() - 1].push_back(a);
    }
    if (flag) {
        cout << "1\n";
        return 0;
    }
    ll l = 1;
    ll r = 8;
    while (l + 1 != r) {
        ll mid = (l + r) >> 1;
        curmax = -1;
        if (check(mid)) r = mid;
        else l = mid;
    }
    cout << r << endl;
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#define STRESS2
#ifdef STRESS
    freopen("input.txt", "w", stdout);
    cout << "1000000\n";
    for (int i = 1; i <= 1000000; i++) cout << ll(1e18) - i << endl;
    return 0;
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else

#endif

    run();
    return 0;
}