#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = numeric_limits<ll>::max();
const ll mod = 1000000007;
const ld eps = 1e-8;
const ll maxn = 1234;

struct vote {
    ll l;
    ll r;
    ll p;

    vote() {}

    friend bool operator<(vote a, vote b) {
        if (a.l < b.l) return true;
        if (a.l == b.l && a.r > b.r) return true;
        return false;
    }
};

bool cmp(vote a, vote b) {
    if (a.l < b.l) return true;
    if (a.l == b.l && a.r > b.r) return true;
    return false;
}

int run() {
    ll n, k;
    cin >> n >> k;
    vector<vote> mas(n);
    ll maxp = 1;
    for (int i = 0; i < n; ++i) {
        cin >> mas[i].l >> mas[i].r >> mas[i].p;
        maxp = max(maxp, mas[i].p);
    }
    ll ans = -1;
    if (n <= 10 && maxp != 1) {
        for (int msk = 1; msk < (1 << n); msk++) {
            vector<vote> vec;
            for (int j = 0; j < n; ++j) {
                if (msk & (1 << j)) vec.push_back(mas[j]);
            }
            if (vec.empty() || vec[0].l != 1 || vec[vec.size() - 1].r != k) continue;
            ll l = 0;
            ll r = 0;
            ll maxp = 0;
            ll curp = 0;
            while (l != vec.size()) {
                while (r < vec.size() && vec[l].r >= vec[r].l) curp += vec[r++].p;
                maxp = max(maxp, curp);
                if (l + 1 == r && l != vec.size() - 1 && vec[r].l > vec[l].r + 1) {
                    break;
                }
                curp -= vec[l++].p;
                if (l == vec.size()) {
                    if (ans == -1) ans = maxp;
                    else ans = min(ans, maxp);
                }
            }
        }
        cout << ans;
    } else if (maxp == 1) {
        map<ll, vector<ll>> mp;
        set<ll> used;
        queue<ll> q;
        q.push(0);
        for (int i = 0; i < n; ++i) {
            mp[mas[i].l].push_back(mas[i].r);
        }
        while (!q.empty()) {
            ll cur = q.front();
            q.pop();
            if (used.count(cur)) continue;
            used.insert(cur);
            for (auto i : mp[cur]) {
                if (!used.count(i)) {
                    q.push(i);
                }
            }
            if (used.count(k)) {
                cout << 1;
                return 0;
            }
            ll maxr = 1;
            for (auto i : mas) {
                if (i.l <= maxr + 1)maxr = max(maxr, i.r);
            }
            if (maxr != k) {
                cout << -1;
            } else cout << 2;
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else

#endif

    run();
    return 0;
}