#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
vector <int> l;
const int N = 1e9 + 7;

struct tree
{
    tree *l, *r;
    int tl, tr;
    int val;
    int st;
    tree(int x, int l, int r): val(x), st(-1), l(0), r(0), tl(l), tr(r) {}
};

void push(tree *t)
{
    assert(t->tr - t->tl != 1);
    if (t->st != -1)
    {
        t->l->val = t->st;
        t->r->val = t->st;
        t->l->st = t->st;
        t->r->st = t->st;
        t->st = -1;
    }
}

void hello(tree *t)
{
    int m = (t->tl + t->tr) / 2;
    if (!t->l)
    {
        t->l = new tree(0, t->tl, m);
    }
    if (!t->r)
    {
        t->r = new tree(0, m, t->tr);
    }
}

int get_pos(tree *t)
{
    if (t->tr - t->tl == 1)
    {
        return t->tl;
    }
    hello(t);
    push(t);
    if (t->r->val != 0)
    {
        return get_pos(t->r);
    }
    else
    {
        return get_pos(t->l);
    }
}

int get(tree *t, int l, int r)
{
    if (t->tl >= r || t->tr <= l)
    {
        return 0;
    }
    if (t->tl >= l && t->tr <= r)
    {
        return t->val;
    }
    else
    {
        hello(t);
        push(t);
        return max(get(t->l, l, r), get(t->r, l, r));
    }
}

void upd(tree *t, int l, int r, int x)
{
    if (t->tl >= r || t->tr <= l)
    {
        return;
    }
    if (t->tl >= l && t->tr <= r)
    {
        t->st = x;
        t->val = x;
    }
    else
    {
        hello(t);
        push(t);
        upd(t->l, l, r, x), upd(t->r, l, r, x);
        t->val = max(t->l->val, t->r->val);
        return;
    }
}

bool smart_check(int x)
{
    tree *t = new tree(0, 0, N);
    upd(t, 0, l[n - 1], x);
    for (int i = n - 2; i >= 0; i--)
    {
        if (l[i] < l[i + 1])
        {
            upd(t, l[i], N, 0);
            continue;
        }
        else
        {
            if (get(t, 0, N) == 0)
            {
                return 0;
            }
            int ind = get_pos(t);
            int who = get(t, ind, ind + 1);
            upd(t, ind + 1, l[i], x);
            upd(t, ind, ind + 1, who - 1);
        }
    }
    return 1;
}

bool check(int x)
{
    vector <int> cur;
    for (int i = 0; i < l[n - 1]; i++)
    {
        cur.push_back(x);
    }
    for (int i = n - 2; i >= 0; i--)
    {
        if (l[i] < l[i + 1])
        {
            while (cur.size() > l[i])
            {
                cur.pop_back();
            }
            continue;
        }
        else
        {
            bool good = 0;
            int pos = i + 1;
            for (int i = l[pos] - 1; i >= 0; i--)
            {
                if (cur[i] == 0)
                {
                    cur[i] = x;
                }
                else
                {
                    cur[i]--;
                    good = 1;
                    break;
                }
            }
            if (!good)
            {
                return 0;
            }
            while (cur.size() < l[i])
            {
                cur.push_back(x);
            }
        }
    }
    return 1;
}

int main()
{
    scanf("%d", &n);
    l.resize(n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &l[i]);
    }
    int l = -1, r = n + 7;
    while (l < r - 1)
    {
        int m = (l + r) / 2;
        if (smart_check(m))
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    printf("%d\n", r + 1);
}
