#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

int n, ans = 2;
vector <int> l;
map <int, int> m;

inline bool check(int mans)
{
    m.clear();
    for (int i = 0; i < n; i++)
    {
        if (i == 0)
            m[1] = m[l[i]] = 0;
        else
        {
            if (l[i] > l[i - 1])
                m[l[i]] = 0;
            else
            {
                while ((*m.rbegin()).first > l[i])
                {
                    auto it = m.end();
                    it--;
                    m.erase(it);
                }
                for (int k = l[i]; k > max(0, l[i] - 62); k--)
                {
                    if (m[k] < mans - 1)
                    {
                        m[k]++;
                        for (int up = k + 1; up <= l[i]; up++)
                            m[up] = 0;
                        break;
                    }
                    else if (k == 1)
                        return false;
                }
            }
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n;
    l.resize(n);
    bool checkOne = true;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i];
        if (i && l[i] <= l[i - 1])
            checkOne = false;
    }

    if (checkOne)
        return cout << 1, 0;

    int ll = 2, mm, rr = 1e9;
    while (ll < rr)
    {
        mm = (ll + rr) / 2;
        if (check(mm))
            rr = mm;
        else
            ll = mm + 1;
    }

    cout << rr;
    return 0;
}
