#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <fstream>

using namespace std;

const int MAX = 1e6 + 13;

int n;

int x, y;

char c[MAX];

int ansl, ansr, ansd, ansu;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> c[i];
	}

	cin >> x >> y;

	int koll = 0, kolr = 0, kolu = 0, kold = 0;

	if (!x && !y) {
		cout << 0 << ' ' << 0 << ' ' << 0 << ' ' << 0;
		return 0;
	}


	if (x > 0)
		ansl = 0;
	else
		ansr = 0;

	if (y > 0)
		ansd = 0;
	else
		ansu = 0;

	for (int i = 1; i <= n; i++) {
		if (c[i] == 'L')
			koll++;
		if (c[i] == 'R')
			kolr++;
		if (c[i] == 'U')
			kolu++;
		if (c[i] == 'D')
			kold++;
	}

	if (x > 0 && kolr < x) {
		cout << -1;
		return 0;
	}
	if (x < 0 && koll < -x) {
		cout << -1;
		return 0;
	}
	if (y > 0 && kolu < y) {
		cout << -1;
		return 0;
	}
	if (y < 0 && kold < -y) {
		cout << -1;
		return 0;
	}

	koll = kolr = kolu = kold = 0;

	for (int i = 1; i <= n; i++) {
		if (c[i] == 'L')
			koll--;
		if (c[i] == 'R')
			kolr++;
		if (c[i] == 'U')
			kolu++;
		if (c[i] == 'D')
			kold--;

		if (x == koll && !ansl) {
			ansl = i;
		}
		if (x == kolr && !ansr) {
			ansr = i;
		}
		if (y == kolu && !ansu) {
			ansu = i;
		}
		if (y == kold && !ansd) {
			ansd = i;
		}
	}

	cout << ansl << ' ' << ansu << ' ' << ansr << ' ' << ansd;
	return 0;
}