#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

int n;
vector<int> a;

int pw(int a, int b) {
	int ans = 1;

	while (b--) ans *= a;

	return ans;
}

inline bool check(int cnt) {
	for (int i = 0; i < n; i++) {
		bool good = 0;

		for (int l = a[i]; l > 0 && !good; l--) {
			int num = 1;

			for (; i - num >= 0 && a[i - num] >= a[i]; num++) {}

			num--;

			if (num < pw(cnt, a[i] - l + 1)) good = 1;
		}

		if (!good) return 0;
	}

	return 1;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef _GOPEN
	freopen("/home/olymp/prjs/file.in", "r", stdin);
	freopen("/home/olymp/prjs/file.out", "w", stdout);
#endif

	cin >> n;

	a.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	for (int ans = 1; ans <= n; ans++) {
		if (check(ans)) {
			cout << ans << "\n";
			return 0;
		}
	}

	return 0;
}
