#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

int n, mxl = 0;
vector<int> a, num;

inline bool check(int cnt) {
	fill(all(num), 0);

	for (int i = 0; i < n; i++) {
		if (num[a[i] - 1] == 0) {
			for (int j = a[i] - 1; j >= 0 && num[j] == 0; j--) num[j] = 1;
		} else {
			int tmp = a[i] - 1;

			while (tmp >= 0 && num[tmp] == cnt) tmp--;

			if (tmp < 0 || num[tmp] == cnt) return 0;

			num[tmp]++;

			fill(num.begin() + tmp + 1, num.begin() + a[i], 1);
			fill(num.begin() + min(tmp + a[i], mxl), num.end(), 0);
		}
	}

	return 1;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef _GOPEN
	freopen("/home/olymp/prjs/file.in", "r", stdin);
	freopen("/home/olymp/prjs/file.out", "w", stdout);
#endif

	cin >> n;

	a.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mxl = max(mxl, a[i]);
	}

	num.resize(mxl);

	for (int ans = 1; ans <= n; ans++) {
		if (check(ans)) {
			cout << ans << "\n";
			return 0;
		}
	}

	return 0;
}
