#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);
const int MAXP = 1e5;

map<ll, pair<ll, ll> > was;

pair<ll, ll> query(ll x) {
	if (was.count(x)) {
		return was[x];
	}

	cout << "X " << x << endl;
	ll a, b;
	cin >> a;
	if (a == -1) {
		exit(0);
	}
	cin >> b;
	was[x] = {a, b};
	return {a, b};
}

int main() {
	// ios::sync_with_stdio(0);
	// cin.tie(nullptr);
	// cout.tie(nullptr);

	srand(time(NULL));

	vector<bool> sieve(MAXP, 0);
	vector<int> primes(1, 2);

	for (int i = 3; i < MAXP; i += 2) {
		if (!sieve[i]) {
			primes.push_back(i);

			for (int j = i + i; j < MAXP; j += i) {
				sieve[j] = 1;
			}
		}
	}

	int g;
	cin >> g;

	while (g--) {
		was.clear();
		int ind = rand() % (int)primes.size();
		auto tmp = query(primes[ind]);

		while ((tmp.first == 0 || tmp.second == primes[ind]) && ind != 0) {
			ind = rand() % ind;
			tmp = query(primes[ind]);
		}

		ll pr = tmp.second;
		query(pr + 1);

		while (tmp.first != 0) {
			pr = tmp.second;
			query(pr + 1);
		}

		cout << "N " << pr << endl;

		string ans;
		cin >> ans;

		if (ans == "Wrong") return 0;
	}

	return 0;
}
