#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);
const int MAXP = 1e5;

map<ll, pair<ll, ll> > was;

pair<ll, ll> query(ll x) {
	if (was.count(x)) {
		return was[x];
	}

	cout << "X " << x << endl;
	ll a, b;
	cin >> a;
	if (a == -1) {
		exit(0);
	}
	cin >> b;
	was[x] = {a, b};
	return {a, b};
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int g;
	cin >> g;

	while (g--) {
		was.clear();
		
		int l = -1, r = 61;
		ll ans;

		while (r - l > 1) {
			int m = (l + r) / 2;

			auto tmp = query(1LL << m);

			if (tmp == make_pair(0LL, 1LL)) {
				r = m;
			} else {
				l = m;
				ans = tmp.second;
			}
		}

		cout << "N " << ans << endl;

		string verd;
		cin >> verd;

		if (verd == "Wrong") return 0;
	}

	return 0;
}
