#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
using namespace std;
#define int long long
vector <int> arr;
int n;

bool check1 (int k) {
	vector <int> prev(arr[0], 0);
	for (int i = 1; i < n; i++) {
		if (arr[i] > arr[i - 1]) {
			prev.resize(arr[i], 0);
		} else {
			prev.resize(arr[i]);
			int pt = prev.size() - 1;
			bool flag = false;
			while (pt >= 0) {
				if (prev[pt] + 1 < k) {
					prev[pt]++;
					flag = true;
					prev.resize(arr[i], 0);
					break;
				} else {
					prev.pop_back();
					pt--;
				}
			}
			if (!flag || pt == -1) {
				return false; 
			}
		}
		// cout << i << endl;
		// for (auto x : prev) 
		// 	cout << x << " ";
		// cout << endl;
	}
	return true;
}


set <string> ans;

void gen (int left, int k, string pref) {
	if (left == 0) {
		ans.insert(pref);
	} else {
		for (int i = 0; i < k; i++) {
			pref.push_back('a' + i);
			gen(left - 1, k, pref);
			pref.pop_back();
		}
	}
}

bool check2(int k) {
	ans.clear();
	for (int i = 1; i <= 5; i++) {
		gen(i, k, "");
	}
	vector <int> len;
	for (auto x : ans) {
		len.push_back(x.size());
	}
	int pt = 0;
	for (int i = 0; i < n; i++) {
		while (pt < len.size() && len[pt] != arr[i]) {
			pt++;
		}
		if (pt == len.size()) {
			return false;
		}
		pt++;
	}
}

signed main() {	
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	for (int i = 1; i < 6000; i++) {
		if (check1(i)) {
			cout << i << endl;
			return 0;
		}
	}

	fclose(stdin);
	fclose(stdout);
}