#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
using namespace std;
#define int long long
#define y second
#define x first

signed main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	
	int n, k;
	cin >> n >> k;
	vector <pair <int, int> > req(n);
	vector <int> press(n);
	for (int i = 0; i < n; i++) {
		cin >> req[i].x >> req[i].y >> press[i];
	}

	bool ans_ex = false; int ans_press = 1e18;
	for (int mask = 1; mask < (1 << n); mask++) {
		// cout << mask << endl;
		vector <pair <int, pair <int, int> > > events;
		for (int i = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				events.push_back({req[i].x, { -1LL, i}});
				events.push_back({req[i].y + 1, {1LL, i}});
			}
		}
		sort(events.begin(), events.end());
		int bal = 0LL;
		if (events[0].x > 1 || events.back().x <= k) {continue;}
		bool flag = true;
		for (auto e : events) {
			bal += e.y.x;
			if (bal == 0 && e.x <= k) {
				flag = false;
			
			}
		} 
		// cout << "\t"<<flag << endl;
		if (flag) {
			events.clear();
			for (int i = 0; i < n; i++) {
				if ((mask >> i) & 1) {
					events.push_back({req[i].x, {-1LL, i}});
					events.push_back({req[i].y, { 1LL, i}});
				}
			}
			sort(events.begin(), events.end());
			int press_a = 0LL;
			int cur_press = 0LL;
			for (auto e : events) {
				press_a = max(press_a, cur_press);
				cur_press -= e.y.x * press[e.y.y];
				press_a = max(press_a, cur_press);
			}
			press_a = max(press_a, cur_press);
			ans_ex = true;
			ans_press = min(ans_press, press_a);
			// cout << mask << " " press_a
		}
	}
	if (ans_ex) {
		cout << ans_press << endl;
	} else {
		cout << -1 << endl;
	}

	fclose(stdin);
	fclose(stdout);
}