// ol_079_PannaCotta.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>

#define pow2(n) (1ll << (n))

using namespace std;

const int MOD = (1e4) + 9;
const int LEN = 5;// 60;
const int MX = 6000;

int simp[] = {2, 3, 5, 7, 11};

int g, mod;
long long t, a, b;
string res;
vector <long long> prime;
vector <bool> erat;

bool is_pri(int n)
{
	if (n == 1)
		return false;
	for (int i = 2; i * i <= n; i++)
		if (n % i == 0)
			return false;
	return true;
}

int main()
{
	srand(26577878);
	
	cin.tie(NULL);

	cin >> g;

	erat.clear();
	erat.resize(MX, true);

	for (int i = 2; i * i < MX; i++)
	{
		if (!erat[i])
			continue;
		for (int j = i * i; j < MX; j += i)
			erat[j] = false;
	}
	prime.clear();
	prime.resize(LEN, 1);
	long long p = 2000;
	for (int i = 0; i < LEN;)
	{
		while (!erat[p])
			p++;
		if ((pow2(63) - 1) / prime[i] > p)
			prime[i] *= p;
		else
		{
			i++;
			if (i < LEN)
				prime[i] = p;
		}
	}

	/*int pr = 2;
	prime.clear();
	prime.resize(LEN);
	for (int i = 0; i < LEN; i++)
	{
		while (!is_pri(pr))
			pr++;
		prime[i] = pr;
		pr++;
	}//*/

	for (int i = 0; i < g; i++)
	{
		cout << "X 2000\n";
		cout.flush();
		cin >> a >> b;
		bool small = (a == 0);
		long long mx = b;
		for (int j = 0; j < LEN; j++)
		{
			//t = /*prime[j];/*/ rand() % mod + 2;//*/
			t = (small ? simp[j] : prime[j]);
			cout << "X " << t << '\n';
			cout.flush();

			cin >> a;
			if (a == -1)
				return 0;
			cin >> b;
			mx = max(mx, b);
			/*if (a == 0)
				mod = t - 2;
			if (mod < 2)
				break;*/
		}
		cout << "N " << mx << '\n';
		cout.flush();

		cin >> res;
		if (res == "Wrong")
			return 0;
	}

	return 0;
}