// ol_079_PannaCotta.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>

#define pow2(n) (1ll << (n))
#define type(x, t) static_cast<t>(x)

using namespace std;

int g, mod;
long long t, a, b;
string res;

int main()
{
	cin >> g;

	for (int w = 0; w < g; w++)
	{
		int L = 0, R = 64, mid;
		long long la, lb;
		while (L + 1 < R)
		{
			mid = (L + R) / 2;
			cout << "X " << pow2(mid) << '\n';
			cout.flush();

			cin >> a;
			if (a == -1)
				return 0;
			cin >> b;
			if (a == 1 && b == pow2(mid))
				L = mid;
			else
			{
				R = mid;
				la = a, lb = b;
			}
		}
		
		a = la, b = lb;
		cout << "N " << type(pow2(L) * (a * pow2(R) / (b - a * pow2(R)) + 1), long long) << '\n';
		cout.flush();

		cin >> res;
		if (res == "Wrong")
			return 0;
	}
	
	return 0;
}