// ol_079_PannaCotta.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <string>

#define pow2(n) (1ull << (n))
#define type(x) static_cast<unsigned long long>(x)

using namespace std;

int g;
unsigned long long m, a, b, n, la, lb, L, R, mid;
string res;

int main()
{
	cin >> g;

	for (int w = 0; w < g; w++)
	{
		L = 0, R = 64;
		while (L + 1 < R)
		{
			mid = (L + R) / 2;
			cout << "\nX " << pow2(mid) << '\n';
			cout.flush();

			cin >> a;
			if (a == -1)
				return 0;
			cin >> b;
			if (a == 1 && b == pow2(mid))
				L = mid;
			else
			{
				R = mid;
				la = a, lb = b;
			}
		}
		
		a = la, b = lb;

		m = a * pow2(L);
		m /= b - a * pow2(L + 1);
		n = pow2(L) * (type(2) * m + type(1));

		//cout << "N " << type(pow2(L) * (a * pow2(R) / (b - a * pow2(R)) + 1), long long) << '\n';
		cout << "\nN " << n << '\n';
		cout.flush();

		cin >> res;
		if (res != "Correct" || res == "-1")
			return 0;
	}
	
	return 0;
}