#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

#define size(a) int(a.size())

using namespace std;

int pow(int x, int p) {
    if (p == 0) return 1;
    if (p == 1) return x;

    int answ = pow(x, p / 2);
    return answ * answ * (p % 2 ? x : 1);
}

int main() {
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> v(n);

    for (int i = 0; i < n; i++)
        cin >> v[i];

    int c = v[0];
    for (int i = 1; i < 1000; i++) {
        if (pow(i, c) >= n) {
            cout << i;
            return 0;
        }
    }
}
