#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back
#define int ll

const int INF = 1e18 + 10;

struct seg {
    int l, r, p;
    seg() {}
    void read() { cin >> l >> r >> p; }
};
bool operator <(const seg a, const seg b) {
    if (a.l != b.l) { return a.l < b.l; }
    return a.r < b.r;
}

main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    vec<seg> segs(n);
    for (int k = 0; k < n; k++) { segs[k].read(); }
    sort(segs.begin(), segs.end());

    vec<int> dp(n, INF);

    for (int k = 0; k < n; k++) {
        if (segs[k].l == 1) { dp[k] = segs[k].p; }
        for (int i = 0; i < k; i++) {
            if (dp[i] == INF) { continue; }
            if (segs[i].l == segs[k].l) { break; }
            if (segs[i].r + 1 == segs[k].l) { dp[k] = min(dp[k], max(dp[i], segs[k].p)); }
            else if (segs[i].r >= segs[k].l) { dp[k] = min(dp[k], max(dp[i], segs[i].p + segs[k].p)); }
        }
    }
    int res = INF;
    for (int k = 0; k < n; k++) {
        if (segs[k].r >= m) { res = min(res, dp[k]); }
    }
    cout << (res == INF ? -1 : res);
    return 0;
}
