#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <iomanip>

using namespace std;

const int INF = 2147483647;
const long long lINF = 9223372036854775807;

#define ll long long
#define fi(n) for(int i = 0; i < (n); i++)
#define FOR(i, k, n) for(int i = (k); i < (n); i++)
//#define cin in
//#define cout out

int main()
{
	ifstream in;
	in.open("input.txt");
	ofstream out;
	out.open("output.txt");
	
	ll n;
	cin >> n;
	vector<ll> len(n);
	ll maxlen = 0;
	fi(n)
		cin >> len[i], maxlen = max(maxlen, len[i]);

	ll l = 0, r = INF;
	while (r - l > 1)
	{
		ll m = (l + r) / 2;
		vector<vector<ll>> v(n, vector<ll>(maxlen, 0));
		fi(len[0])
			v[0][i] = 1;
		bool pos = true;
		FOR(i, 1, n)
		{
			if (!pos)
				break;
			if (len[i] > len[i - 1])
			{
				FOR(j, 0, len[i])
					v[i][j] = v[i - 1][j];
			}
			else
			{
				pos = false;
				for (ll k = len[i] - 1; k >= 0; k--)
				{
					if (!pos)
						v[i][k] = 1;
					else
						v[i][k] = v[i - 1][k];
					if (!pos && v[i - 1][k] < m)
					{		
						v[i][k] = v[i - 1][k] + 1;
						pos = true;
					}
				}
			}
		}
		if (pos)
			r = m;
		else
			l = m;
	}
	cout << r;
	return 0;
}

