#include <bits/stdc++.h>

#define pb push_back
#define pp pop_back
#define f first
#define s second
#define ll long long
#define ull unsigned long long
#define mp make_pair

using namespace std;

const int N = 3001;
const int mod = 1e9 + 7;
const int inf = 1e9;
const ll Inf = 1e18;

struct segment {
  int l, r, c;
} a[N];
int n, k;
ll dp[N][N];

bool cmp(segment a, segment b) {
  return a.r < b.r;
}

void upd(ll &a, ll b) {
  a = min(a, b);
}

int main() {
  #ifdef wws
    freopen("in", "r", stdin);
  #endif
  ios_base :: sync_with_stdio(0);
  cin >> n >> k;
  for (int i = 1;i <= n;i++) {
    cin >> a[i].l >> a[i].r >> a[i].c;
    for (int j = 0;j <= n;j++) {
      dp[i][j] = Inf;
    }
  }
  sort(a + 1, a + n + 1, &cmp);
/*  for (int i = 1;i <= n;i++) {
    cout << a[i].l << " " << a[i].r << " " << a[i].c << endl;
  }*/
  dp[0][0] = 0;
  for (int i = 1;i <= n;i++) {
    for (int j = 0;j < i;j++) {
      upd(dp[i][j], dp[i - 1][j]);
      if (dp[i - 1][j] == Inf || a[i].l <= a[j].l || a[i].l > a[j].r + 1) continue;
      upd(dp[i][i], max(dp[i - 1][j], 1ll * a[i].c + a[j].c * (a[i].l <= a[j].r)));
    }
    /*cout << i << endl;
    for (int j = 0;j <= i;j++) {
      cout << j << " dp = " << dp[i][j] << endl;
    }*/
  }
  ll ans = Inf;
  for (int i = 0;i <= n;i++) {
    if (a[i].r == k) {
      upd(ans, dp[n][i]);
    }
  }
  if (ans == Inf) ans = -1;
  cout << ans << endl;
  return 0;
}
