#include <bits/stdc++.h>

using namespace std;

#define long long long
typedef pair<int, int> pii;
typedef vector<bool> bools;
typedef vector<int> ints;
typedef vector<long> longs;
typedef vector<pii> piis;

#define inf (int) 2e9

/*
5
2 2 2 2 2

4
3 1 2 2
 */

int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    int n;
    cin >> n;
    ints l(n);
    int len = 0;
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
        len = max(len, l[i]);
    }

    int left = 0;
    int right = 1000000000;
    while (right - left > 1) {
        int mid = right - (right - left) / 2;

        bool ok = true;
        ints smb(len, 1);
        for (int j = l[0]; j < len; ++j) {
            smb[j] = 0;
        }

        for (int i = 1; i < n; ++i) {
            for (int j = l[i]; j < len; ++j) {
                smb[j] = 0;
            }
            bool inc = false;
            for (int j = l[i] - 1; j >= 0; --j) {
                if (smb[j] == mid) {
                    smb[j] = 1;
                } else {
                    smb[j]++;
                    inc = true;
                    break;
                }
            }
            if (!inc) {
                ok = false;
                break;
            }
        }

        if (ok) {
            right = mid;
        } else {
            left = mid;
        }
    }
    cout << right;

    return 0;
}