#include <bits/stdc++.h>

using namespace std;

#define long long long
typedef pair<int, int> pii;
typedef vector<bool> bools;
typedef vector<int> ints;
typedef vector<long> longs;
typedef vector<pii> piis;

#define inf (int) 2e9

/*
4
LRUD
3 2

4
DURL
0 0

8
LLURDRRD
1 -1

7
RRRRRUR
5 1
 */

const pii no = make_pair(2281488, 2281488);

int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    int x, y;
    cin >> x >> y;

    ints l(n + 1, 0), r(n + 1, 0), u(n + 1, 0), d(n + 1, 0);
    for (int i = n - 1; i >= 0; --i) {
        l[i] = l[i + 1];
        r[i] = r[i + 1];
        u[i] = u[i + 1];
        d[i] = d[i + 1];

        if (s[i] == 'U') u[i]++;
        else if (s[i] == 'D') d[i]++;
        else if (s[i] == 'L') l[i]++;
        else if (s[i] == 'R') r[i]++;
    }

    int x0 = r[0] - l[0];
    int y0 = u[0] - d[0];

    int dx = x - x0;
    int dy = y - y0;

    int bl, br;
    bool lrok = false;
    for (bl = 0; bl <= n && !lrok; ++bl) {
        for (br = 0; br <= n; ++br) {
            if (r[br] - l[bl] == -dx) {
                lrok = true;
                break;
            }
        }
    }
    bl--;

    if (!lrok) {
        cout << -1;
        return 0;
    }

    int bu, bd;
    bool udok = false;
    for (bu = 0; bu <= n && !udok; ++bu) {
        for (bd = 0; bd <= n; ++bd) {
            if (u[bu] - d[bd] == -dy) {
                udok = true;
                break;
            }
        }
    }
    bu--;

    if (!udok) {
        cout << -1;
        return 0;
    }

    cout << bl << ' ' << bu << ' ' << br << ' ' << bd;

    return 0;
}