#include <bits/stdc++.h>

using namespace std;

#define long long long
typedef pair<long, long> pll;
typedef vector<bool> bools;
typedef vector<int> ints;
typedef vector<long> longs;
typedef vector<pll> plls;

#define inf (int) 2e9


pll ask(long t) {
    cout << "X " << t << endl;
    int a, b;
    cin >> a;
    if (a == -1) {
        return {-1, -1};
    }
    cin >> b;
    return {a, b};
}

bool answer(long n) {
    cout << "N " << n << endl;
    string res;
    cin >> res;
    return res == "Correct";
}


bool is_prime(long n) {
    for (long i = 2; i * i <= n; ++i) {
        if (n % i == 0) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    int g;
    cin >> g;
    for (int test = 0; test < g; ++test) {
        long max_d = 0;
        for (long i = 2;; ++i) {
            if (!is_prime(i)) continue;

            pll cur = ask(i);
            if (cur.first == -1 && cur.second == -1) {
                return 0;
            }
            max_d = max(max_d, cur.second);
            if (cur.first == 0) {
                break;
            }
        }
        bool corr = answer(max_d);
        if (!corr) {
            return 0;
        }
    }

    return 0;
}