#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Query
{
    int l, r;
    ll p;
};

Query query[maxN];

vector<pair<int, int>> event;
vector<int> coords;

vector<Query> qarr[maxN];
int dp[maxN];

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    for(int i = 0; i < n; i++)
    {
        cin >> query[i].l >> query[i].r >> query[i].p;
        query[i].l--;

        coords.push_back(query[i].l);
        coords.push_back(query[i].r);
        coords.push_back(query[i].r - 1);

        event.push_back(make_pair(query[i].l, 1));
        event.push_back(make_pair(query[i].r, 2));
    }

    sort(event.begin(), event.end());
    int cnt = 0;
    int ok = 1;
    for(int i = 0; i < event.size();)
    {
        int j = i;
        while(j < event.size() && event[j].first == event[i].first)
        {
            if(event[j].second == 1) cnt++;
            else cnt--;
            j++;
        }
        if(j != event.size() && cnt == 0) ok = 0;
        i = j;
    }

    if(event.back().first != k) ok = 0;

    coords.push_back(0);
    coords.push_back(k);
    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());
    k = lower_bound(coords.begin(), coords.end(), k) - coords.begin();
    for(int i = 0; i < n; i++)
    {
        query[i].l = lower_bound(coords.begin(), coords.end(), query[i].l) - coords.begin();
        query[i].r = lower_bound(coords.begin(), coords.end(), query[i].r) - coords.begin();
        qarr[query[i].l].push_back(query[i]);
    }

    dp[0] = 1;
    for(int i = 0; i < k; i++)
    {
        //for(auto q : qarr[i]) cout << coords[q.l] << " " << coords[q.r - 1] << endl;
        if(!dp[i]) continue;
        for(auto q : qarr[i]) dp[q.r - 1] = 1;
    }

    if(dp[k - 1]) cout << 1 << endl;
    else if(ok) cout << 2 << endl;
    else cout << -1 << endl;



    return 0;
}
