#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Query
{
    int l, r;
    ll p;
};

Query query[maxN];

vector<int> coords;

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    for(int i = 0; i < n; i++)
    {
        cin >> query[i].l >> query[i].r >> query[i].p;
    }
    sort(query, query + n, [](Query q1, Query q2){return q1.l < q2.l;});

    ll ans = INF;
    for(int mask = 1; mask < (1<<n); mask++)
    {
        vector<int> ind;
        for(int i = 0; i < n; i++)
        {
            if((mask >> i) & 1) ind.push_back(i);
        }

        int ok = 1;
        if(query[ind[0]].l > 1) ok = 0;

        int r = 0;
        for(int i = 0; i < ind.size(); i++)
        {
            if(query[ind[i]].l > r + 1) ok = 0;
            r = max(r, query[ind[i]].r);
        }
        if(r < k) ok = 0;

        if(ok)
        {
            ll lans = 0;
            vector<Query> ev;
            for(int i : ind)
            {
                Query q = query[i];
                q.r = 1;
                ev.push_back(q);
                q = query[i];
                q.l = q.r + 1;
                q.r = 2;
                ev.push_back(q);
            }
            sort(ev.begin(), ev.end(), [](Query q1, Query q2){return q1.l < q2.l;});

            ll s = 0;
            for(auto e : ev)
            {
                if(e.r == 1) s += e.p;
                else s -= e.p;
                lans = max(s, lans);
            }
            ans = min(ans, lans);
        }
    }

    if(ans == INF) cout << -1 << endl;
    else cout << ans << endl;

    return 0;
}
