#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 3005;

ll gcd(ll a, ll b)
{
    if(a % b == 0) return b;
    return gcd(b, a % b);
}

ll N = 1;

pair<ll, ll> ask(ll x)
{
    cout << "X " << x << endl;
    ll a, b;
    cin >> a;
    if(a == -1) exit(0);
    cin >> b;
    return make_pair(a, b);

    /*ll a = N / x, b = N;
    ll g = gcd(a, b);
    return make_pair(a / g, b / g);*/
}

ll st[70];
int get(ll p)
{
    st[0] = 1;
    for(int i = 1; i <= 61; i++) st[i] = st[i-1] * p;

    int l = 0, r = 61;
    while(r - l > 1)
    {
        int m = (l + r) / 2;
        if(ask(st[m]).second == st[m]) l = m;
        else r = m;
    }
    return l;
}

void solve()
{
    int st = get(2);

    auto p = ask(1 << (st + 1));


    ll ans;
    if(p.first != 0) ans = p.second * (1<<st) / (p.second - (1<<(st+1))*p.first);
    else ans = 1 << st;

    cout << "N " << ans << endl;
    string res;
    cin >> res;
    if(res[0] == 'W') exit(0);
}

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int g;
    cin >> g;
    while(g--) solve();

    return 0;
}
