#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}" << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        out << arr[i] << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

void check(int cnt, int n, vector <int> length)
{
    vector <vector <int> > arr(n);
    arr[0] = vector <int> (length[0], 1);
    bool flag = true;
    for (int i = 1; i < n; ++i)
    {
        if (length[i] > length[i - 1])
        {
            //cout << "kek i = " << i << endl;
            arr[i] = arr[i - 1];
            //cout << length[i] - length[i - 1] << endl;
            for (int j = 0; j < length[i] - length[i - 1]; ++j)
            {
                //cout << "nu ti takoi kek prosto" << endl;
                arr[i].push_back(1);
            }
            //cout << "kek arr[i] = " << arr[i] << endl;
        }
        else
        {
            arr[i] = vector <int> (arr[i - 1].begin(), arr[i - 1].begin() + length[i]);
            int j = length[i] - 1;
            while (j >= 0 && arr[i][j] == cnt)
                --j;
            if (j < 0)
            {
                flag = false;
                break;
            }
            else
            {
                arr[i][j]++;
                for (int k = j + 1; k < length[i]; ++k)
                    arr[i][k] = 1;
            }
        }
    }


    for (int i = 1; i < n; ++i)
    {
        //if (arr[i - 1] >= arr[i])
        //{
        //    cout << i - 1 << " " << i << endl;
        //    cout << arr[i - 1] << " " << arr[i] << endl;
        //}
        assert(arr[i - 1] < arr[i]);
    }
    for (int i = 0; i < n; ++i)
        assert(arr[i].size() == length[i]);
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);

    vector <int> kek;
    int n;
    cin >> n;
    vector <int> length(n);
    cin >> length;

    for (int i = 1; i < n; ++i)
    {
        if (length[i] <= length[i - 1])
        {
            kek.push_back(length[i]);
        }
    }

    int ans = 1;
    for (int i = 0; i < kek.size(); ++i)
    {
        int ya_hochu = i + 1;  /// net ya hochu ...
        if (kek[i] == 1)
        {
            ans = max(ans, ya_hochu);
        }
        else
        {
            int l = 1, r = 1e4;
            while (r - l > 1)
            {
                int deg = kek[i];
                int m = (r + l) / 2;
                int res = 1;
                int now = 0;
                while (now < deg && res < 1000000000000)
                {
                    now++;
                    res *= m;
                }
                if (res > ya_hochu)
                    r = m;
                else
                    l = m;
            }
            ans = max(ans, r);
        }
    }
    cout << ans << endl;
    return 0;
}
