#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "} ";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        out << arr[i] << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> length(n);
    cin >> length;
    int l = 0, r = n;
    while (r - l > 1)
    {
        int cnt = (r + l) / 2;
        vector <vector <pair <int, int> > > arr(n);
        arr[0].push_back(mp(1, length[0]));
        bool flag = true;
        for (int i = 1; i < n; ++i)
        {
            if (length[i] > length[i - 1])
             {
                arr[i] = arr[i - 1];
                int sz = arr[i].size();
                if (arr[i][sz - 1].fi == 1)
                    arr[i][sz - 1].se += length[i] - length[i - 1];
                else
                    arr[i].push_back(mp(1, length[i] - length[i - 1]));
            }
            else
            {
                if (arr[i - 1].size() == 1 && arr[i - 1][0].fi == cnt)
                {
                    flag = false;
                    break;
                }
                int sum = 0;
                int j = 0;
                while (j < arr[i - 1].size() && sum < length[i])
                {
                    arr[i].push_back(arr[i - 1][j]);
                    sum += arr[i - 1][j].se;
                    ++j;
                }
                arr[i][j - 1].se -= sum - length[i];
                j = arr[i].size() - 1;
                while (j >= 0 && arr[i][j].fi == cnt)
                    --j;
                if (j < 0)
                {
                    flag = false;
                    break;
                }
                arr[i].resize(j + 1);
                if (arr[i][j].se == 1)
                {
                    arr[i][j].fi++;
                    if (j > 0 && arr[i][j].fi == arr[i][j - 1].fi)
                    {
                        arr[i][j - 1].se++;
                        arr[i].pop_back();
                    }
                }
                else
                {
                    arr[i][j].se--;
                    arr[i].push_back(mp(arr[i][j].fi + 1, 1));
                }
                sum = 0;
                for (int k = 0; k < arr[i].size(); ++k)
                    sum += arr[i][k].se;
                if (length[i] - sum > 0)
                    arr[i].push_back(mp(1, length[i] - sum));
            }
            //cout << "cnt = " << cnt << endl;
            //cout << "arr = " << arr << endl;
        }
        if (flag)
            r = cnt;
        else
            l = cnt;
    }
    cout << r << endl;
    return 0;
}
