#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}" << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        out << arr[i] << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);

    int n;
    cin >> n;
    int k;
    cin >> k;

    set <int> s;

    vector <int> l(n);
    vector <int> r(n);
    vector <int> p(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> l[i] >> r[i] >> p[i];
        s.insert(l[i]);
        s.insert(r[i]);
    }

    map <int, int> mapa;
    int cnt = 0;
    for (set<int>::iterator it = s.begin(); it != s.end(); ++it)
        mapa[*it] = cnt++;

    for (int i = 0; i < n; ++i)
    {
        l[i] = mapa[l[i]];
        r[i] = mapa[r[i]];
    }
    int ans = 1e18;
    for (int mask = 0; mask < (1 << n); ++mask)
    {
        vector <int> used(cnt, 0);
        for (int i = 0; i < n; ++i)
        {
            if ((mask >> i) & 1)
            {
                for (int j = l[i]; j <= r[i]; ++j)
                    used[j] += p[i];
            }
        }
        bool flag = true;
        for (int i = 0; i < cnt; ++i)
            if (used[i] == 0)
                flag = false;
        if (!flag)
            continue;
        int now = 0;
        for (int i = 0; i < cnt; ++i)
            now = max(now, used[i]);
        ans = min(ans, now);
    }
    if (ans == 1e18)
        cout << -1 << endl;
    else
        cout << ans << endl;
    return 0;
}
