#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}" << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        out << arr[i] << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);

    int n;
    cin >> n;
    int k;
    cin >> k;

    vector <int> l(n);
    vector <int> r(n);
    vector <int> p(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> l[i] >> r[i] >> p[i];
    }

    if (n <= 10)
    {
        int ans = 1e18;
        for (int mask = 0; mask < (1 << n); ++mask)
        {
            vector <pair <pair <int, int>, int> > arr;
            bool flag = false;
            for (int i = 0; i < n; ++i)
            {
                if ((mask >> i) & 1)
                {
                    arr.push_back(mp(mp(l[i], r[i]), p[i]));
                    if (r[i] == k)
                        flag = true;
                }
            }
            if (!flag)
                continue;
            if (arr.size() == 0)
                continue;
            if (arr[0].fi.fi != 1)
                continue;
            sort(arr.begin(), arr.end());
            set <pair <int, int> > now;
            int sum = 0;
            int noww = 0;
            bool flag2 = true;
            for (int i = 0; i < arr.size(); ++i)
            {
                int L = arr[i].fi.fi;
                int R = arr[i].fi.se;
                int P = arr[i].se;
                int last = 1e18;
                while (now.size() > 0 && now.begin()->fi < L)
                {
                    sum -= now.begin()->se;
                    last = now.begin()->fi;
                    now.erase(now.begin());
                }
                if (now.size() == 0 && L - 1 > last)
                    flag2 = false;
                if (!flag2)
                    break;
                now.insert(mp(R, P));
                sum += P;
                noww = max(noww, sum);
            }
            if (flag2)
                ans = min(noww, ans);
        }
        if (ans == 1e18)
            cout << -1 << endl;
        else
            cout << ans << endl;
    }
    else
    {
        vector <pair <int, int> > arr;
        bool flag = false;
        for (int i = 0; i < n; ++i)
        {
            arr.push_back(mp(l[i], r[i]));
            if (r[i] == k)
                flag = true;
        }
        if (!flag)
        {
            cout << -1 << endl;
            return 0;
        }
        sort(arr.begin(), arr.end());
        if (arr[0].fi != 1)
        {
            cout << -1 << endl;
            return 0;
        }
        set <int> s;
        for (int i = 0; i < n; ++i)
        {
            int last = 1e18;
            int L = arr[i].fi;
            int R = arr[i].se;
            while (s.size() > 0 && *s.begin() < L)
            {
                last = *s.begin();
                s.erase(s.begin());
            }
            if (s.size() == 0 && L - 1 > last)
            {
                cout << -1 << endl;
                return 0;
            }
            s.insert(R);
        }


        set <int> pos;
        pos.insert(0);
        for (int i = 0; i < n; ++i)
        {
            int L = arr[i].fi;
            int R = arr[i].se;
            if (pos.count(L - 1) > 0)
                pos.insert(R);
        }
        ///assert(false);
        if (pos.count(k) > 0)
            cout << 1 << endl;
        else
            cout << 2 << endl;
    }
    return 0;
}
