#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}" << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        out << arr[i] << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

map <char, int> arr;
map <char, int> ans;
string s;
int x, y;


void solve_x()
{
    int dif = arr['R'] - arr['L'] - x;
    if (dif > 0)
    {
        int j = s.size() - 1;
        int now = 0;
        while (j >= 0 && now < dif)
        {
            if (s[j] == 'R')
                now++;
            j--;
        }
        if (now < dif)
        {
            cout << -1 << endl;
            exit(0);
        }
        ans['R'] = j + 1;
    }
    else if (dif < 0)
    {
        dif = -dif;
        int j = s.size() - 1;
        int now = 0;
        while (j >= 0 && now < dif)
        {
            if (s[j] == 'L')
                now++;
            j--;
        }
        if (now < dif)
        {
            cout << -1 << endl;
            exit(0);
        }
        ans['L'] = j + 1;
    }
}

void solve_y()
{
    int dif = arr['U'] - arr['D'] - y;
    if (dif > 0)
    {
        int j = s.size() - 1;
        int now = 0;
        while (j >= 0 && now < dif)
        {
            if (s[j] == 'U')
                now++;
            j--;
        }
        if (now < dif)
        {
            cout << -1 << endl;
            exit(0);
        }
        ans['U'] = j + 1;
    }
    else if (dif < 0)
    {
        dif = -dif;
        int j = s.size() - 1;
        int now = 0;
        while (j >= 0 && now < dif)
        {
            if (s[j] == 'D')
                now++;
            j--;
        }
        if (now < dif)
        {
            cout << -1 << endl;
            exit(0);
        }
        ans['D'] = j + 1;
    }
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    int dif = arr['R'] - arr['L'] - x;

    int n;
    cin >> n;
    cin >> s;
    cin >> x >> y;

    arr['L'] = 0;
    arr['R'] = 0;
    arr['D'] = 0;
    arr['U'] = 0;

    ans['L'] = n;
    ans['R'] = n;
    ans['D'] = n;
    ans['U'] = n;

    for (int i = 0; i < n; ++i)
    {
        arr[s[i]]++;
    }

    solve_x();

    solve_y();

    cout << ans['L'] << endl;
    cout << ans['U'] << endl;
    cout << ans['R'] << endl;
    cout << ans['D'] << endl;
    return 0;
}
