#ifndef A
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <ctime>


using namespace std;


typedef long long ll;
typedef long double ld;


#define runtime (double(clock()) / CLOCKS_PER_SEC)
#define all(a) (a).begin(), (a).end()


struct __D__ {
	__D__() {
#ifdef _DEBUG
		freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#else
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#endif
	}
} __d__;


int lens[100005];
int n;


bool nxt(vector<int>::iterator beg, vector<int>::iterator end, int mx) {
	do {
		end--;
		(*end)++;
		if (*end > mx) {
			*end = 0;
			if (end == beg) {
				return 0;
			}
		}
		else {
			break;
		}
	} while (end != beg);
	return 1;
}


bool f(int x) {
	vector<int> prev;
	prev.resize(lens[0], 0);
	for (int i = 1; i < n; i++) {
		if (lens[i - 1] < lens[i]) {
			while (prev.size() < lens[i]) {
				prev.push_back(0);
			}
		}
		else {
			while (prev.size() > lens[i]) {
				prev.pop_back();
			}
			if (!nxt(all(prev), x)) {
				return 0;
			}
		}
	}
	return 1;
}


int main() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> lens[i];
	}
	int l = 0;
	int r = n;
	while (r - l > 1) {
		int m = l + r >> 1;
		if (f(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r + 1;
}



#endif