#ifndef B
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>


using namespace std;


typedef long long ll;
typedef long double ld;


struct __D__ {
	__D__() {
#ifdef _DEBUG
		freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#else
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#endif
	}
} __d__;


int l[1000006];
int u[1000006];
int r[1000006];
int d[1000006];
int memL[3000006];
int memD[3000006];
int *inL = memL + 1500000;
int *inD = memD + 1500000;



int main() {
	int n;
	cin >> n;
	string st;
	cin >> st;
	int x, y;
	cin >> x >> y;
	int i = 0;
	for (char ch : st) {
		i++;
		l[i] = l[i - 1];
		u[i] = u[i - 1];
		r[i] = r[i - 1];
		d[i] = d[i - 1];
		if (ch == 'L') {
			l[i]--;
			inL[l[i]] = i;
		}
		if (ch == 'U') {
			u[i]++;
		}
		if (ch == 'R') {
			r[i]++;
		}
		if (ch == 'D') {
			d[i]--;
			inD[d[i]] = i;
		}
	}
	int La = n, Ra = n, Ua = n, Da = n;
	bool okx = 0;
	for (int i = 0; i <= n; i++) {
		if (inL[x - r[i]] || x - r[i] == 0) {
			La = inL[x - r[i]];
			Ra = i;
			okx = 1;
			break;
		}
	}
	bool oky = 0;
	for (int i = 0; i <= n; i++) {
		if (inD[y - u[i]] || y - u[i] == 0) {
			Da = inD[y - u[i]];
			Ua = i;
			oky = 1;
			break;
		}
	}
	if (okx && oky) {
		cout << La << ' ' << Ua << ' ' << Ra << ' ' << Da;
	}
	else {
		cout << -1;
	}
}



#endif