#ifndef D
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>


using namespace std;


#define runtime (double(clock()) / CLOCKS_PER_SEC)
typedef long long ll;
typedef long double ld;


struct __D__ {
	__D__() {
#ifdef _DEBUG
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#else
		//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#endif
	}
} __d__;


map<ll, pair<ll, ll> > mem;



pair<ll, ll> get(ll x) {
	if (mem.count(x)) {
		return mem[x];
	}
	cout << "X " << x << endl;
	ll a, b;
	cin >> a;
	if (a == -1) {
		exit(0);
	}
	cin >> b;
	return mem[x] = { a, b };
}


void ans(ll x) {
	cout << "N " << x << endl;
	string com;
	cin >> com;
	if (com != "Correct") {
		exit(0);
	}
}


bool f(ll x) {
	if (get(2ll*x).first == 0) {
		return 1;
	}
	return 0;
}


int main() {
	int g;
	cin >> g;
	mt19937_64 gen;
	while (g--) {
		mem.clear();
		ll kek = get(2ll).second;
		if (kek != 2ll) {
			ans(kek);
			continue;
		}
		kek = get(3ll).second;
		if (kek != 3ll) {
			if (get(2ll*kek).first > 0ll) {
				ans(2ll*kek);
			}
			else {
				ans(kek);
			}
			continue;
		}
		kek = get(5ll).second;
		if (kek != 5ll) {
			if (get(4ll*kek).first > 0ll) {
				ans(4ll*kek);
			}
			else if (get(3ll*kek).first > 0ll) {
				ans(3ll*kek);
			}
			else if (get(2ll*kek).first > 0ll) {
				ans(2ll*kek);
			}
			else {
				ans(kek);
			}
			continue;
		}
		ll l = 0;
#ifdef _DEBUG
		ll r = 100;
#else
		ll r = 1e18;
#endif
		r /= 2ll*3ll*5ll;
		r++;
		bool ok = 0;
		while (r - l > 1ll) {
			ll m = r + l >> 1;
			if (f(m)) {
				r = m;
			}
			else {
				l = m;
			}
		}
		ans(2ll * 3ll * 5ll * l);
	}
}



#endif