#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

long long pow(int n, int k)
{
    if (k == 0)
        return 1;
    if (k % 2 == 1)
        return n * pow(n, k - 1);
    return pow(n, k / 2) * pow(n, k / 2);
}

int log(int n, int ans)
{
    if (n == 0)
        return 0;
    else
        return 1 + n / ans;
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(5002);
    for (int i = 0; i < n; i++)
    {
        int l;
        cin >> l;
        a[l - 1]++;
    }
    int ans = 1;
    bool flag = true;
    while (flag)
    {
        flag = false;
        int d = 0;
        for (int i = log(n, ans); i >= 0; i--)
            if (a[i] + d > pow(ans, i + 1))
            {
                flag = true;
                ans++;
                break;
            }
            else
                d = a[i] / ans;
    }
    cout << ans;
}
