#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

bool pred(pair<pair<int, long long>, int> a, pair<pair<int, long long>, int> b)
{
    return a.first.first < b.first.first || a.first.first == b.first.first && a.first.second > b.first.second;
}

long long ans = 2000000000000000000;

void most(const vector<bool> &used, const vector<pair<pair<int, long long>, int>> &a)
{
    int l = 0;
    long long p = 0, sum = 0;
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i].first.first - l > 1 && p == 1000000000000000000)
            return;
        else if (p != 1000000000000000000)
            l = a[i].first.first;
        if (used[a[i].second])
        {
            p += a[i].first.second;
            if (p > sum)
                sum = p;
        }
    }
    if (sum < ans)
        ans = sum;
}

void per(int i, vector<bool> &used, const vector<pair<pair<int, long long>, int>> &a)
{
    if (i == used.size() - 1)
    {
        most(used, a);
        return;
    }
    per(i + 1, used, a);
    used[i] = true;
    per(i + 1, used, a);
    used[i] = false;
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, long long>, int>> a;
    a.push_back({{0, 1000000000000000000}, n});
    a.push_back({{m +  1, -1000000000000000000}, n});
    for (int i = 0; i < n; i++)
    {
        int l, r, w;
        cin >> l >> r >> w;
        a.push_back({{l, w}, i});
        a.push_back({{r, -w}, i});
    }
    sort(a.begin(), a.end(), pred);
    vector<bool> used(n + 1);
    used[n] = true;
    per(0, used, a);
    if (ans == 2000000000000000000)
        cout << -1;
    else
        cout << ans - 1000000000000000000;
}
