#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <fstream>

typedef long long ll;
typedef double dl;

using namespace std;

ll bin_pow(ll a, ll p)
{
	if (p == 0)
		return 1;

	if (p % 2 == 0)
	{
		ll res = bin_pow(a, p / 2);
		return res * res;
	}
	else
	{
		return a * bin_pow(a, p - 1);
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ll n;
	scanf("%lld", &n);

	vector<ll> v(n +1, 1e18);
	vector<vector<ll>> vec;



	ll maxx = -1, cnt = 1, sz =0;
	for (int i = 0; i <= n; ++i)
	{
		if(i < n)
			scanf("%lld", &v[i]);
		if (i != 0 && v[i - 1] == v[i])
		{
			++cnt;
		}
		else
		{
			if (cnt > maxx && i !=0)
			{
				maxx = max(maxx, cnt);
				sz = v[i - 1];
				cnt = 1;
			}
		}
		//vec[i].resize(v[i]);
	}

	for (int c = 1;c <= 1e5; ++c)
	{
		if (bin_pow(c, sz) >= maxx)
		{
			cout << c << endl;
			return 0;
		}
	}

	for (int i = 0; i < v[0]; ++i)
		vec[0].push_back(1);

	ll l = 0, r = 1e4;
	while (l < r - 1)
	{
		ll color = (l + r) / 2;
		
		bool god = 1;

		vector<ll> st(v[n - 1], color);

		for (int i = n - 1; i >= 1;--i)
		{
			int fl = 0;
			if (v[i - 1] == v[i])
			{
				for (int j = st.size() - 1; j >= 0; --j)
				{
					if (st[j] > 1)
					{
						--st[j];
						fl = 1;
						break;
					}
					else
						st[j] = 9;
				}
				if (!fl)
					god = 0;
			}
			else if (v[i - 1] < v[i])
			{
				st.resize(v[i - 1]);
			}
			else
			{
				vector<ll>nst(v[i - 1], color);
				for (int j = 0;j < st.size(); ++j)
					nst[j] = st[j];
				st = nst;
			}
		}

		/*vec.clear();
		vec.resize(n);

		for (int i = 0; i < v[0]; ++i)
			vec[0].push_back(1);

		

		for (int i = 1; i < n; ++i)
		{
			if (v[i] == v[i - 1])
			{
				bool fl = 0;

				vec[i] = vec[i - 1];
				for (int j = vec[i].size() - 1; j >= 0; --j)
				{
					if (vec[i][j] < color)
					{
						fl = 1;
						++vec[i][j];
						for (int kk = j + 1; kk < vec[i].size(); ++kk)
							vec[i][kk] = 1;
						break;
					}
				}

				if (!fl)
				{
					god = 0;
					break;
				}

			}
			else if (v[i] < v[i - 1])
			{
				vec[i].resize(v[i]);

				bool fl = 0;
				for (int j = v[i] - 1; j >= 0; --j)
				{
					if (vec[i - 1][j] < color)
					{
						fl = 1;
						vec[i][j] = vec[i - 1][j] + 1;
						for (int kk = j - 1; kk >= 0; --kk)
							vec[i][kk] = vec[i - 1][kk];
						break;
					}
					else
						vec[i][j] = 1;
				}

				if (!fl)
				{
					god = 0;
					break;
				}
			}
			else
			{
				for (int j = 0; j < v[i - 1]; ++j)
				{
					vec[i].push_back(vec[i - 1][j]);
				}

				while (vec[i].size() < v[i])
				{
					vec[i].push_back(1);
				}
			}
		}*/

		if (god)
		{
			r = color;
		}
		else
			l = color;
	}

	printf("%lld\n", r);
	return 0;
}