#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define ll long long
#define f first
#define s second
#define all(v) v.begin(), v.end()
#define pii pair<int, int>
#define sz(v) int(v.size())

using namespace std;

typedef vector<int> BigInt;

const int N = 1e5 + 123;
const int MAXN = 1e6 + 123;
const int INF = 1e9 + 7;
const double EPS = 1e-9;



int n;
int len[N];

bool full(int len, BigInt num, int base) {
    if (sz(num) != len)
        return true;
    for (auto it : num) {
        if (it != base - 1) {
            return false;
        }
    }
    return true;
}                

void print(BigInt t) {
    cout << t.back();
    for (int i = sz(t) - 2; i >= 0; i--) cout << t[i];
    cout << endl;
}

bool ok(int max_a) {
    BigInt last(len[1], 0);
    for (int i = 2; i <= n; i++) {
        if (len[i - 1] < len[i]) {
            reverse(all(last));
            for (int j = 0; j < len[i] - len[i - 1]; j++) {
                last.pb(0);
            }
            reverse(all(last));
        } else {
            reverse(all(last));
            for (int j = 0; j < len[i - 1] - len[i]; j++) {
                last.pop_back();
            }
            reverse(all(last));
            int j = 0;
            while (j < sz(last) && last[j] == max_a - 1) {
                last[j] = 0;
                j++;
            }
            if (j == sz(last)) 
                return false;
            last[j]++;  
        }
        //print(last);
    }
    return true;
}

int main() {
    #define fn ""
    #ifdef SONY
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
    //    freopen(fn".in", "r", stdin);
    //    freopen(fn".out", "w", stdout);
    #endif // SONY
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> len[i];
    }
    //cout << (!ok(2) ? "ne ok" : "ok") << endl; return 0;
    for (int i = 1; ; i++) {
        if (ok(i)) {
            cout << i;
            return 0;
        }
    }
    return 0;
}
