#include <bits/stdc++.h>

using namespace std;
const int N = 2e6 + 228;
int MAXA = 0;

int cur_B;

int a[N];

struct node {
    int l, r;
    int pu;
    int mn;

    node() {
        l = -1;
        r = -1;
        pu = -1;
        mn = 0;
    }
};

int cnt = 0;
node tree[N * 4];


void push(int v, int l, int r) {
    if(tree[v].pu == -1)
        return;

    tree[v].mn = tree[v].pu;
    if(l == r)
        return;

    if(tree[v].l == -1) {
        tree[cnt++] = node();
        tree[v].l = cnt - 1;
    }
    tree[tree[v].l].pu = tree[v].pu;

    if(tree[v].r == -1) {
        tree[cnt++] = node();
        tree[v].r = cnt - 1;
    }
    tree[tree[v].r].pu = tree[v].pu;

    tree[v].pu = -1;
}

void modify(int ll, int rr, int l, int r, int v, int color) {
    push(v, l, r);
    if(rr < l || r < ll)
        return;
    if(ll <= l && r <= rr) {
        tree[v].pu = color;
//        cout << "kek " << l << " " << r << " " << color << "\n";
        push(v, l, r);
        return;
    }

    int c = (l + r) >> 1;

    if(tree[v].l == -1) {
        tree[cnt++] = node();
        tree[v].l = cnt - 1;
    }

    modify(ll, rr,     l, c, tree[v].l, color);

    if(tree[v].r == -1) {
        tree[cnt++] = node();
        tree[v].r = cnt - 1;
    }
    modify(ll, rr, c + 1, r, tree[v].r, color);

    tree[v].mn = (int)1e9;

    if(tree[v].l != -1)
        tree[v].mn = min(tree[v].mn, tree[tree[v].l].mn);

    if(tree[v].r != -1)
        tree[v].mn = min(tree[v].mn, tree[tree[v].r].mn);
}

int find(int ll, int rr, int l, int r, int v) {
    if(v == -1)
        return -1;

    push(v, l, r);

    if(rr < l || r < ll)
        return -1;

    if(tree[v].mn >= cur_B - 1)
        return -1;

    if(l == r || (tree[v].l == -1 && tree[v].r == -1)) {
//        cout << "kek " << l << " " << r << " = " << tree[v].mn << "\n";
        return r;
    }

    int c = (l + r) >> 1;

    int x;

    x = find(ll, rr, c + 1, r, tree[v].r);
    if(x != -1) {
//        tree[v].mn = (int)1e9;
//
//        if(tree[v].l != -1)
//            tree[v].mn = min(tree[v].mn, tree[tree[v].l].mn);
//
//        if(tree[v].r != -1)
//            tree[v].mn = min(tree[v].mn, tree[tree[v].r].mn);
//
        return x;
    }

    x = find(ll, rr,     l, c, tree[v].l);
//
    if(x != -1) {
//        tree[v].mn = (int)1e9;
//
//        if(tree[v].l != -1)
//            tree[v].mn = min(tree[v].mn, tree[tree[v].l].mn);
//
//        if(tree[v].r != -1)
//            tree[v].mn = min(tree[v].mn, tree[tree[v].r].mn);
        return x;
    }

    return x;
}

int get(int v, int l, int r, int i) {
    push(v, l, r);

    if(l == r) {
        return tree[v].pu;
    }

    int c = (l + r) >> 1;

    int ans;
    if(i <= c) {
        if(tree[v].l == -1) {
            tree[cnt++] = node();
            tree[v].l = cnt - 1;
        }

        ans = get(tree[v].l, l, c, i);
    } else {

        if(tree[v].r == -1) {
            tree[cnt++] = node();
            tree[v].r = cnt - 1;
        }
        ans = get(tree[v].r, c + 1, r, i);
    }

    tree[v].mn = (int)1e9;

    if(tree[v].l != -1)
        tree[v].mn = min(tree[v].mn, tree[tree[v].l].mn);

    if(tree[v].r != -1)
        tree[v].mn = min(tree[v].mn, tree[tree[v].r].mn);

    return ans;
}

void wr(int v, int l, int r) {
    if(tree[v].l == -1 && tree[v].r == -1) {
        if(tree[v].pu == -1)
            return;
        for(int h = l; h <= r; h++) {
            cout << tree[v].pu << " ";
        }
        return;
    }

    int c = (l + r) >> 1;
    wr(tree[v].l, l, c);
    wr(tree[v].r, c + 1, r);
}


int n;

bool check(int x) {
    cur_B = x;
//    cnt = 1;
//    tree[cnt - 1] = node();

    modify(1, a[1], 1, MAXA, 0, 0);
//    wr(0, 1, MAXA);
//    cout << "\n";

    for(int i = 2; i <= n; i++) {
        if(a[i] > a[i - 1]) {
            modify(a[i - 1] + 1, a[i], 1, MAXA, 0, 0);
        } else {
            int l = 1;
            int r = a[i];

            l = find(l, r, 1, MAXA, 0);

            if(l == -1)
                return false;
            if(l != r)
                modify(l + 1, r, 1, MAXA, 0, 0);

            modify(l, l, 1, MAXA, 0, get(0, 1, MAXA, l) + 1);
        }

//        wr(0, 1, MAXA);
//        cout << "\n";
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);
//    freopen(".in", "r", stdin);

    cin >> n;

    for(int i = 1; i <= n; i++) {
        cin >> a[i];
        MAXA = max(MAXA, a[i]);
    }

    int l = 1;
    int r = (int)1e8;

    while(l < r) {
        int c = (l + r) >> 1;

        if(check(c))
            r = c;
        else
            l = c + 1;
    }
    cout << l << "\n";

//    cout << check(3) << "\n";


    return 0;
}
