#include <bits/stdc++.h>

using namespace std;
const int N = 1e6 + 228;

pair<long long, long long> query(long long x) {
    if(x > (long long)1e18)
        return make_pair(0LL, 1LL);
    cout << "X " << x << "\n";

    fflush(stdout);

    long long a;
    cin >> a;

    if(a == -1)
        exit(0);

    long long b;
    cin >> b;

    return make_pair(a, b);
}

bool check(vector<pair<long long, pair<long long, long long> > > v, long long n) {
    for(int i = 0; i < v.size(); i++) {
        long long x = n / v[i].first;
        long long y = n;

        long long g = __gcd(x, y);
        x /= g;
        y /= g;

        if(make_pair(x, y) != v[i].second)
            return false;
    }
    return true;
}

int main() {
//    ios::sync_with_stdio(false);

    int n;
    cin >> n;

    while(n--) {

        vector<pair<long long, pair<long long, long long> > > cur;
        long long l = 0;
        long long r = 60;

        long long z = 1;

        while(l < r) {
            long long c = (l + r + 1LL) >> 1LL;

            pair<long long, long long> p = query(1LL << c);
            z = max(z, p.second);
            cur.push_back(make_pair(1LL << c, p));
            if(p.first == 0)
                r = c - 1;
            else
                l = c;
        }

        bool a = check(cur, z);
        bool b = check(cur, z * 2LL);

        long long answer = z;
        if(b) {
            answer *= 2LL;
        }

        cout << "N " << answer << "\n";
        fflush(stdout);

        string ans;
        cin >> ans;

        if(ans != "Correct")
            exit(0);
    }
}
