#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

bool nonprime[100];
vector < ll > primes, prefp;

int main()
{
    ios::sync_with_stdio(0);
    primes.push_back(1);
    for (int i = 2; i <= 60; i++) {
        if (!nonprime[i]) {
            primes.push_back(i);
            for (int j = i + i; j <= 60; j += i)
                nonprime[j] = true;
        }
    }
    prefp = primes;
    for (int i = 1; i < 16; i++)
        prefp[i] *= prefp[i - 1];
    int g;
    cin >> g;
    for (int i = 0; i < g; i++) {
        int left = 0, right = 16;
        while (left + 1 < right) {
            int mid = (left + right) / 2;
            cout << "X " << prefp[mid] << endl;
            ll x, y;
            cin >> x;
            if (x == -1)
                return 0;
            cin >> y;
            if (x == 1 && prefp[mid] == y)
                left = mid;
            else
                right = mid;
        }
        cout << "X " << prefp[left] << endl;
        ll x, y;
        cin >> x;
        if (x == -1)
            return 0;
        cin >> y;
        if (x == 1 && y == 1)
            cout << "N " << prefp[left] << endl;
        else {
            cout << "X " << primes[right] << endl;
            ll x, y;
            cin >> x;
            if (x == -1)
                return 0;
            cin >> y;
            cout << "N " << y << endl;
        }
        string s;
        cin >> s;
        if (s == "Wrong")
            return 0;
    }
    return 0;
}
