#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <vector>

//#define DEBUG

using namespace std;

int ma = 1;

inline int max(int a, int b) { return a > b ? a : b; }

inline int min(int a, int b) { return a < b ? a : b; }

struct trio {
	int size, firstPos, max;

	trio() {}

	trio(int s, int f, int m) : size(s), firstPos(f), max(m){}
};

void inc(vector<trio *> &suff) {
	trio *last = suff[suff.size() - 1];
	if (last->firstPos == 0) {
		if (suff.size() == 1 || suff[suff.size() - 2]->max >= last->max) { 
			(*last) = trio(last->size, last->size - 1, last->max + 1);
			ma = max(ma, last->max);
		}
		else {
			suff.pop_back();
			trio *k = suff[suff.size() - 1];
			(*k) = trio(last->size + k->size, k->size - 1, last->max);
		}
	}
	else{ --last->firstPos; }
}

void DoMagic(vector<trio *> &suff, int deltaLen) {
	if (deltaLen > 0) { suff.push_back(new trio(deltaLen, 0, 1)); }
	else if (deltaLen == 0) { inc(suff); }
	else{
		for (; abs(deltaLen) >= suff[suff.size() - 1] -> size; deltaLen += suff[suff.size() - 1]->size, suff.pop_back());
		trio *last = suff[suff.size() - 1];
		(*last) = trio(last->size + deltaLen, min(last->size + deltaLen - 1, last->firstPos), (last->size + deltaLen - 1 < last->firstPos) ? last->max - 1 : last->max);
		inc(suff);
	}
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	int n, l1, l2;
	vector<trio *> suff;
	cin >> n;
	cin >> l1;
	suff.push_back(new trio(l1, 0, 1));
	for (int i = 1; i < n; ++i) {
		cin >> l2;
		DoMagic(suff, l2 - l1);
		l1 = l2;
	}
	cout << ma;
	return 0;
}