#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <vector>
#include <string>

//#define DEBUG

using namespace std;

int count(string &s, char c) {
	int res = 0;
	for (int i = 0; i < s.length(); res+=(c == s[i]), ++i);
	return res;
}

void MakeRaznost(int &a, int &b, int raz) {
	int rznst = a - b;
	if (rznst > raz) {
		a -= rznst - raz;
		if (a < 0) {
			a = -1;
			b = -1;
			return;
		}
		return;
	}
	b -= raz - rznst;
	if (b < 0) {
		a = -1;
		b = -1;
		return;
	}
}

int OtvForC(string &s, char c, int numOf) {
	if (numOf == 0) { return 0; }
	int res, i;
	for (res = 0, i = 0; numOf > 0; ++res, numOf -= (s[i] == c), ++i);
	return res;
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	string s;
	int n, x, y;
	cin >> n >> s >> x >> y;
	int Lcount = count(s, 'L'), Rcount = count(s, 'R'), Ucount = count(s, 'U'), Dcount = count(s, 'D');
	MakeRaznost(Rcount, Lcount, x);
	if (Rcount == -1) {
		cout << -1;
		return 0;
	}
	MakeRaznost(Ucount, Dcount, y);
	if (Ucount == -1) {
		cout << -1;
		return 0;
	}
	cout << OtvForC(s, 'L', Lcount) << ' ' << OtvForC(s, 'U', Ucount) << ' ' << OtvForC(s, 'R', Rcount) << ' ' << OtvForC(s, 'D', Dcount);
	return 0;
}