#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//oh hi there

int n;
vector<int> a;

bool check(int x) {
	int mx = -1;
	for (int i = 0; i < n; i++) {
		mx = max(mx, a[i]);
	}
	a[0] = mx;

	ld total = powl(ld(x), ld(mx)) - 1.;
	for (int i = 1; i < n; i++) {
		if (a[i] < a[i - 1]) {
			total -= powl(ld(x), ld(mx - a[i]));
		}
		else if (a[i] == a[i - 1]) {
			total -= 1.;
		}
		else {
			total += pow(ld(x), ld(mx - a[i]));
		}
	}

	return (total >= -EPS);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int l = 0, r = 1e5 + 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
	
		if (check(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}

	cout << r;

	return 0;
}