#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//oh hi there

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	int n, x, y;
	string s;
	cin >> n >> s >> x >> y;

	int cx, cy, l, r, u, d;
	cx = cy = 0;
	l = r = u = d = -1; 
	if (x >= 0) {
		if (y >= 0) {
			l = d = 0;
			if (x == 0) r = 0;
			if (y == 0) u = 0;

			for (int i = 0; i < n; i++) {
				if (s[i] == 'R' && r == -1) {
					cx++;
				}
				if (s[i] == 'U' && u == -1) {
					cy++;
				}

				if (cx == x && r == -1) r = i + 1;
				if (cy == y && u == -1) u = i + 1;
			}
		}
		else {
			l = u = 0;
			if (x == 0) r = 0;
			if (y == 0) d = 0;

			for (int i = 0; i < n; i++) {
				if (s[i] == 'R' && r == -1) {
					cx++;
				}
				if (s[i] == 'D' && d == -1) {
					cy--;
				}

				if (cx == x && r == -1) r = i + 1;
				if (cy == y && d == -1) d = i + 1;
			}
		}
	}
	else {
		if (y >= 0) {
			r = d = 0;
			if (y == 0) u = 0;

			for (int i = 0; i < n; i++) {
				if (s[i] == 'L' && l == -1) {
					cx--;
				}
				if (s[i] == 'U' && u == -1) {
					cy++;
				}

				if (cx == x && l == -1) l = i + 1;
				if (cy == y && u == -1) u = i + 1;
			}
		}
		else {
			r = u = 0;
			if (y == 0) d = 0;

			for (int i = 0; i < n; i++) {
				if (s[i] == 'L' && l == -1) {
					cx--;
				}
				if (s[i] == 'D' && d == -1) {
					cy--;
				}

				if (cx == x && l == -1) l = i + 1;
				if (cy == y && d == -1) d = i + 1;
			}
		}
	}

	if (l == -1 || r == -1 || d == -1 || u == -1) cout << -1;
	else cout << l << " " << u << " " << r << " " << d;

	return 0;
}