// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
	os << "{";
	for (int i = 0; i < (int)v.size(); i++) {
		if (i != 0) {
			os << ", ";
		}
		os << v[i];
	}
	return os << "}";
}

signed main() {
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	vector<int> v(n);
	vector<int> stk;
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	auto ok = [&](int knt) -> bool {
		stk.clear();
		for (int i = 0; i < n; i++) {
			stk.push_back(0);
		}
		while ((int)stk.size() > v[0]) {
			stk.pop_back();
		}
		for (int i = 1; i < n; i++) {
			while ((int)stk.size() > v[i]) {
				stk.pop_back();
			}
			if (v[i-1] < v[i]) {
				stk.push_back(0);
			} else if ((int)stk.size() < v[i] && knt >= 2) {
				stk.push_back(1);
			} else {
				while (!stk.empty() && stk.back() == knt-1) {
					stk.pop_back();
				}
				if (stk.empty()) {
					return false;
				} else {
					stk.back()++;
				}
			}
		}
		return true;
	};
	int l = 1, r = n;
	while (l < r) {
		int m = (l + r) / 2;
		if (ok(m)) {
			r = m;
		} else {
			l = m+1;
		}
	};
	cout << l << endl;
	return 0;
}
