// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

int64_t gcd(int64_t a, int64_t b) {
	return b ? gcd(b, a % b) : a;
}

int64_t lcm(int64_t a, int64_t b) {
	return a / gcd(a, b) * b;
}

namespace Grader {
	int init() {
		int n; cin >> n;
		return n;
	}
	
	void newGame() {
	}
	
	pair<int64_t, int64_t> query(int64_t num) {
		cout << "X " << num << endl;
		int64_t a, b; cin >> a >> b;
		return make_pair(a, b);
	}
	
	void answer(int64_t res) {
		cout << "N " << res << endl;
		string s; cin >> s;
		if (s != "Correct") {
			exit(0);
		}
	}
};

int64_t justNumbers[] = {229, 101, 47, 5, 3, 2};

signed main() {
	ios_base::sync_with_stdio(false);
	int t = Grader::init();
	while (t--) {
		Grader::newGame();
		int64_t res = 1;
		for (int64_t x: justNumbers) {
			int64_t mul = min(x, (int64_t)1e18 / res);
			int64_t a, b; tie(a, b) = Grader::query(mul * res);
			res = lcm(res, b);
		}
		Grader::answer(res);
	}
	return 0;
}
