// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

int64_t gcd(int64_t a, int64_t b) {
	return b ? gcd(b, a % b) : a;
}

int64_t lcm(int64_t a, int64_t b) {
	return a / gcd(a, b) * b;
}

int64_t justNumbers[] = {229, 101, 47, 5, 3, 2};

signed main() {
	ios_base::sync_with_stdio(false);
	int t; cin >> t;
	while (t--) {
		int64_t res = 1;
		for (int64_t x: justNumbers) {
			int64_t mul = min(x, (int64_t)1e18 / res);
			cout << "X " << mul * res << endl;
			int64_t a, b; cin >> a >> b;
			res = lcm(res, b);
		}
		cout << "N " << res << endl;
		string s; cin >> s;
		if (s != "Correct") {
			return 0;
		}
	}
	return 0;
}
