#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double dbl;

#define size(s) (int) (s).size()
#define all(s) (s).begin(), (s).end()
#define rall(s) (s).rbegin(), (s).rend()

const int INF = 1e9, TMP = -2 * INF + 1;
const dbl EPS = 1e-9;

int main() {
	ios::sync_with_stdio(0);

	cin.tie(nullptr);
	cout.tie(nullptr);
	
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	int n, dx[4] = {0, 1, 0, -1}, dy[4] = {1, 0, -1, 0}, cnt;
	pair<int, int> f, pos = {0, 0};
	map<char, int> dir;
	string s;

	dir['U'] = 0;
	dir['R'] = 1;
	dir['D'] = 2;
	dir['L'] = 3;

	cin >> n >> s >> f.first >> f.second;

	int ans[4] = {n, n, n, n};

	for (int i = 0; i < n; i++) {
		pos.first += dx[dir[s[i]]];
		pos.second += dy[dir[s[i]]];
	}



	cnt = 0;

	for (int i = n; i >= 0; i--) {
		if (pos.first + cnt < f.first) {
			cnt += (s[i] == 'D');
		}
	}

	if (pos.first + cnt < f.first) {
		cout << "-1\n";
		return 0;
	}

	ans[3] = n - cnt;



	cnt = 0;

	for (int i = n; i >= 0; i--) {
		if (pos.first - cnt > f.first) {
			cnt += (s[i] == 'U');
		}
	}

	if (pos.first - cnt > f.first) {
		cout << "-1\n";
		return 0;
	}

	ans[1] = n - cnt;



	cnt = 0;

	for (int i = n; i >= 0; i--) {
		if (pos.second + cnt < f.second) {
			cnt += (s[i] == 'L');
		}
	}

	if (pos.second + cnt < f.second) {
		cout << "-1\n";
		return 0;
	}

	ans[0] = n - cnt;


	cnt = 0;

	for (int i = n; i >= 0; i--) {
		if (pos.second - cnt > f.second) {
			cnt += (s[i] == 'R');
		}
	}

	if (pos.second - cnt > f.second) {
		cout << "-1\n";
		return 0;
	}

	ans[2] = n - cnt;


	for (int i = 0; i < 4; i++) {
		cout << ans[i] << ' ';
	}

	cout << '\n';

	return 0;	
}
