#include <bits/stdc++.h>

using namespace std;

struct kek
{
    int l, r;
    long long d;
    kek (int l_ = 0, int r_ = 0, long long d_ = 0): l(l_), r(r_), d(d_) {};
    bool operator <(const kek a)const
    {
        if (r != a.r)
            return r < a.r;
        if (l != a.l)
            return l < a.l;
        return d < a.d;
    }
};

kek mas[(int)1e5 + 10];

/*

int my_rand()
{
    return (rand() << 16) + rand();
}

struct Node
{
    int x, y;
    long long c, mn;
    Node *l, *r;
    Node(int x_ = 0, long long c_ = 0): x(x_), y(my_rand()), c(c_), mn(c_), l(NULL), r(NULL) {}
};

long long min(Node* v)
{
    if (v == NULL)
        return (long long)1e18;
    return v->mn;
}

void update(Node* v)
{
    v->mn = min(v->c, min(min(v->l), min(v->r)));
}

Node* merge(Node* v, Node* u)
{
    if (v == NULL)
        return u;
    if (u == NULL)
        return v;
    if (v->y < u->y)
    {
        v->r = merge(v->r, u);
        update(v);
        return v;
    }
    else
    {
        u->l = merge(v, u->l);
        update(u);
        return u;
    }
}

pair<Node*, Node*> split(Node* v, int x)
{
    if (v == NULL)
        return {v, v};
    pair<Node*, Node*> p;
    if (v->x <= x)
    {
        p = split(v->r, x);
        v->r = p.first;
        p.first = v;
    }
    else
    {
        p = split(v->l, x);
        v->l = p.second;
        p.second = v;
    }
    update(v);
    return p;
}

Node* ins(Node* v, Node* u)
{
    if (v == NULL)
        return u;
    if (u->y < v->y)
    {
        pair<Node*, Node*> p = split(v, u->x);
        u->l = p.first;
        u->r = p.second;
        update(u);
        return u;
    }
    else if (v->x < u->x)
        v->r = ins(v->r, u);
    else
        v->l = ins(v->l, u);
    update(v);
    return v;
}
//*/

int main()
{
    srand(239);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    long long mx = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> mas[i].l >> mas[i].r >> mas[i].d;
        mx = max(mx, mas[i].d);
    }
    if (n <= 10)
    {
        long long ans = (long long)1e18;
        for (int mask = 1; mask < (1 << n); mask++)
        {
            vector<pair<int, int> > v;
            for (int i = 0; i < n; i++)
                if (mask & (1 << i))
                {
                    v.push_back({mas[i].l, mas[i].d});
                    v.push_back({mas[i].r + 1, -mas[i].d});
                }
            v.push_back({1, 0});
            v.push_back({k + 1, 0});
            sort(v.begin(), v.end());
            long long s = 0;
            bool d = 1;
            long long mx = 0;
            for (int i = 0; i + 1 < v.size(); i++)
            {
                s += v[i].second;
                if (v[i].first < v[i + 1].first && s == 0)
                    d = 0;
                if (v[i].first < v[i + 1].first)
                    mx = max(mx, s);
            }
            if (d)
                ans = min(ans, mx);
        }
        if (ans == (long long)1e18)
            ans = -1;
        cout << ans << endl;
        return 0;
    }
    if (mx == 1)
    {
        set<int> se;
        sort(mas, mas + n);
        se.insert(0);
        for (int i = 0; i < n; i++)
        {
            if (se.count(mas[i].l - 1))
                se.insert(mas[i].r);
        }
        if (se.count(k))
        {
            cout << 1 << endl;
            return 0;
        }
        se.clear();
        se.insert(0);
        for (int i = 0; i < n; i++)
        {
            if (se.lower_bound(mas[i].l - 1) != se.end())
                se.insert(mas[i].r);
        }
        if (se.count(k))
        {
            cout << 2 << endl;
            return 0;
        }
        cout << -1 << endl;
        return 0;
    }
    long long dp[n];
    fill(dp, dp + n, (long long)1e18);
    sort(mas, mas + n);
    long long ans = (long long)1e18;
    for (int i = 0; i < n; i++)
    {
        if (mas[i].l == 1)
            dp[i] = mas[i].d;
        for (int j = 0; j < i; j++)
        {
            if (mas[j].r == mas[i].l - 1)
                dp[i] = min(dp[i], max(dp[j], mas[i].d));
            else if (mas[j].r >= mas[i].l)
                dp[i] = min(dp[i], max(dp[j], mas[i].d + mas[j].d));
        }
        if (mas[i].r == k)
            ans = min(ans, dp[i]);
    }
    if (ans == (long long)1e18)
        ans = -1;
    cout << ans << endl;
    return 0;
}
