#include <iostream>
#include <vector>
#include <bitset>
#include <cstdio>
#include <map>

using namespace std;
typedef long long ll;

const ll maxn = 128000;
ll e[maxn];
ll last = 0;
bitset<maxn> used;
pair<int, int> d[60];
map<int, int> u;
int main()
{
    ll g;
    cin >> g;
    for (ll i = 2; i < maxn; ++i)
        if (!used[i])
    {
        e[last++] = i;
        for (ll j = i * i; j < maxn; j += i)
            used[j] = 1;
    }
    d[0] = {1, 1};
    for (int t = 0; t < g; ++t)
        {
            u.clear();
            for (int i = 1; i <= 60; ++i)
            {
                int a, b;
                cout << "X " << e[i - 1] << endl;
                fflush(stdout);
                cin >> a >> b;
                d[i] = {a, b};
                if (u[b])
                {
                    cout << "N " << b << endl;
                    fflush(stdout);
                    string s;
                    cin >> s;
                    if (s == "Wrong")
                        return 0;
                    break;
                }
                u[b] = 1;
            }
    }
    return 0;
}
