import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Locale;

public class ZE1 implements Runnable {

	
	public void solve() throws IOException {
		int n = nextInt();
		int[] l = new int[n];
		for (int i = 0; i < n; i++) {
			l[i] = nextInt();
		}
		
		double ans = Math.pow(n, 1.0/l[0]);
		int m = ans - (int) ans > 0? (int) (ans + 1) : (int) ans;
		
		out.write(m + "");
	}
	
	
	BufferedReader in;
	BufferedWriter out;
	@Override
	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new BufferedWriter(new OutputStreamWriter(System.out));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(read());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(read());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(read());
	}
	
	String read() throws IOException {
		StringBuilder sb = new StringBuilder();
		int c = 0;
		while (c >= 0 && c <= ' ')
			c = in.read();
		if (c < 0) 
			return "";
		while (c > ' ') {
			sb.append((char) c);
			c = in.read();
		}
		return sb.toString();
	}

	public static void main(String[] args) {
		try {
			Locale.setDefault(Locale.US);
		} catch (Exception e) {
		}
		new Thread(null, new ZE1(), "1", 1 << 25).start();
	}
}
