import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Locale;

public class ZH1 implements Runnable {

	long prim = 1;
	public void solve() throws IOException {
		int g = nextInt();
		for (int i = 0; i < g; i++) {
			
			prim = 1;
			long x;
			long c;
			long d;
			do {
				x = nextPrim();
				out.write("X " + x + "\n");
				out.flush();
				c = nextInt();
				if (c == -1)
					return;
				d = nextInt();
			} while (c == 1 && d == x);
			
			long u = d - c*x;
			long p = 1;
			for (; p < (double) x/u; p++) {
				out.write("X " + d * p + "\n");
				out.flush();
				long c1 = nextInt();
				if (c1 == -1)
					return;
				nextInt();
				if (c1 == 0) 
					break;
			}
			p--;
			
			out.write("N " + d * p);
			out.flush();
			String s = read();
//			if (s.equals("Wrong"))
//				return;
//			out.write("aaaaaaaaaaa");

		}
	}
	
	long nextPrim() {
		boolean flag;
		do {
			prim++;
			flag = false;
			for (long i = 2; i <= Math.sqrt(prim); i++) {
				if (prim % i == 0) {
					flag = true;
					continue;
				}
			}
		} while (flag);
		return prim;
	}
	
	BufferedReader in;
	BufferedWriter out;
	@Override
	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new BufferedWriter(new OutputStreamWriter(System.out));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(read());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(read());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(read());
	}
	
	String read() throws IOException {
		StringBuilder sb = new StringBuilder();
		int c = 0;
		while (c >= 0 && c <= ' ')
			c = in.read();
		if (c < 0) 
			return "";
		while (c > ' ') {
			sb.append((char) c);
			c = in.read();
		}
		return sb.toString();
	}

	public static void main(String[] args) {
		try {
			Locale.setDefault(Locale.US);
		} catch (Exception e) {
		}
		new Thread(null, new ZH1(), "1", 1 << 25).start();
	}
}
