#include <bits/stdc++.h>

using namespace std;

#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#define F first
#define S second

typedef long long ll;
typedef long double ld;

auto start_t = clock();

template<typename T>
void die(T ans)
{
    cout << ans << endl;
    cerr << "Done in " << (start_t - clock()) / ld(CLOCKS_PER_SEC) << "sec" << endl;
    exit(0);
}

int n;
vector<int > a;

bool can(int k)
{
    vector<int> last(a[0], 0);
//    cerr << k << ": " << endl;

//    for (int x: last)
//        cerr << x << " ";
//    cerr << endl;

    for (int i = 1; i < n; i++)
    {
        vector<int > cur = last;

        if (cur.size() < a[i])
        {
            while (cur.size() < a[i])
                cur.push_back(0);
        } else
        {
            while (cur.size() > a[i])
                cur.pop_back();
            cur.back()++;

            int p = cur.size() - 1;

            while(p > 0 && cur[p] >= k)
            {
                cur[p] = 0;
                cur[--p]++;
            }

            if (cur[0] >= k) return false;
        }

        last = cur;
//        for (int x: last)
//            cerr << x << " ";
//        cerr << endl;

    }
//    cerr << "--------" << endl;

    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(13);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    cin >> n;

    a.resize(n);

    for (int& x: a)
        cin >> x;

    int l = 1;
    int r = 1000000000;
    int ans;

    while (l <= r)
    {
        int mid = (l + r) >> 1;

        if (can(mid))
        {
            r = mid - 1;
            ans = mid;
        } else
            l = mid + 1;
    }

    die(ans);

    return 0;
}
