#include <bits/stdc++.h>

using namespace std;

#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#define F first
#define S second

typedef long long ll;
typedef long double ld;

auto start_t = clock();

template<typename T>
void die(T ans)
{
    cout << ans << endl;
    cerr << "Done in " << (start_t - clock()) / ld(CLOCKS_PER_SEC) << "sec" << endl;
    exit(0);
}




int main()
{
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(13);
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    int g;

    cin >> g;

    while (g--)
    {
        ll l = 2, r = 1000000000000000001ll;
//        ll l = 1, r = 129ll;

        while (l < r)
        {
            ll mid = (l + r) >> 1;

            cout << "X " << mid << endl;

            ll a, b;
            cin >> a >> b;

            if (a == 0)
                r = mid;
            else
                l = mid + 1;
        }

        cout << "N " << l-1 << endl;

        string ans;
        cin >> ans;

        assert(ans == "Correct");
    }

    return 0;
}
