#include <fstream>
#include <algorithm>
#include <vector>
#include <utility>
#include <ctime>
#include <cassert>
#include <string>
#include <set>
#include <queue>
#include <deque>
#include <random>
#include <bitset>

#pragma warning(disable: 4996)

using namespace std;

typedef long long ll;
typedef long double ld;

ifstream cin("input.txt");
ofstream cout("output.txt");

template<class _T> inline void chkmin(_T& a, _T b) { if (a > b) a = b; }
template<class _T> inline void chkmax(_T& a, _T b) { if (a < b) a = b; }

int l, r, u, d;

int main() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int x, y;
	cin >> x >> y;
	bool swappedx = 0, swappedy = 0;
	if (x < 0) {
		swappedx = true;
		x = -x;
		for (int i = 0; i < n; ++i) {
			if (s[i] == 'L')
				s[i] = 'R';
			else
				if (s[i] == 'R')
					s[i] = 'L';
		}
	}
	if (y < 0) {
		swappedy = 1;
		y = -y;
		for (int i = 0; i < n; ++i) {
			if (s[i] == 'U')
				s[i] = 'D';
			else
				if (s[i] == 'D')
					s[i] = 'U';
		}
	}
	int r = -1, u = -1;
	for (int i = 0; i < n; ++i) {
		if (s[i] == 'R') --x;
		if (s[i] == 'U') --y;
		if (x == 0) r = i;
		if (y == 0) u = i;
	}
	if (x > 0 || y > 0) {
		cout << "-1\n";
		return 0;
	}
	++r; ++u;
	cout << (swappedx ? r : 0) << ' ' << (swappedy ? 0 : u) << ' ' << (swappedx ? 0 : r) << ' ' << (swappedy ? u : 0) << '\n';
}