#include <fstream>
#include <algorithm>
#include <vector>
#include <utility>
#include <ctime>
#include <cassert>
#include <string>
#include <set>
#include <queue>
#include <deque>
#include <random>
#include <bitset>

#pragma warning(disable 4996)

using namespace std;

typedef long long ll;
typedef long double ld;

ifstream cin("input.txt");
ofstream cout("output.txt");

template<class _T> inline void chkmin(_T& a, _T b) { if (a > b) a = b; }
template<class _T> inline void chkmax(_T& a, _T b) { if (a < b) a = b; }

bool GetBit(int n, int i) {
	return (n >> i) & 1;
}

pair<int, int> qqq[10];
ll p[10];

int main() {
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; ++i)
		cin >> qqq[i].first >> qqq[i].second >> p[i];
	ll res = 1e18;
	for (int m = 0; m < 1023; ++m) {
		vector<pair<int, ll>> q;
		for (int i = 0; i < n; ++i) {
			if (GetBit(m, i)) continue;
			q.push_back(make_pair(qqq[i].first, -p[i]));
			q.push_back(make_pair(qqq[i].second, p[i]));
		}
		sort(q.begin(), q.end());
		ll dcp = 0;
		ll maxp = 0;
		if (!q.size()) continue;
		if (q[0].first != 1) continue;
		if (q.back().first != k) continue;
		bool bad = false;
		for (int i = 0; i < q.size(); ++i) {
			dcp -= q[i].second;
			chkmax(maxp, dcp);
			if (dcp == 0 && i < q.size() - 1 && q[i + 1].first > q[i].first + 1) {
				bad = true;
				break;
			}
		}
		if (bad) continue;
		chkmin(res, maxp);
	}
	cout << (res == 1e18 ? -1 : res) << '\n';
}