#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <ctime>
#include <cassert>
#include <string>
#include <set>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cmath>

#pragma warning(disable 4996)

using namespace std;

typedef long long ll;
typedef long double ld;

//ifstream cin("input.txt");
//ofstream cout("output.txt");

template<class _T> inline void chkmin(_T& a, _T b) { if (a > b) a = b; }
template<class _T> inline void chkmax(_T& a, _T b) { if (a < b) a = b; }

const int T[] = { 1000000007, 31627, 179, 13, 4, 2 };

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	int g;
	cin >> g;
	for (int q = 0; q < g; ++q) {
		if (q) {
			string qqq;
			cin >> qqq;
			if (qqq == "Wrong") {
				while (true) ++g;
				cout << g << '\n';
			}
		}
		//ll r = 1e18;
		ll pref = 1;
		for (int i = 0; i < 4; ++i) {
			int x = T[i];
			cout << "X " << x * pref << '\n';
			ll p, q;
			cin >> p >> q;
			if (p == 0)
				continue;
			if (p == 1 && q == x * pref) {
				pref *= x;
				continue;
			}
			pref = pref * q;
		}
		cout << "X " << 4 * pref << "\n";
		ll a, b;
		cin >> a >> b;
		if (a == 0) {
			cout << "X " << pref * 2 << "\n";
			ll c, d;
			cin >> c >> d;
			if (c == 0) {
				cout << "N " << pref << "\n";
				continue;
			}
			if (d == 3) {
				cout << "N " << pref * 3 << "\n";
				continue;
			}
			cout << "N " << pref * 2 << "\n";
			continue;
		}
		if (b >= 6) {
			cout << "N " << pref * b << '\n';
			continue;
		}
		cout << "X " << 2 * pref << "\n";
		ll c, d;
		cin >> c >> d;
		if (b == 5) {
			if (c)
				cout << "N " << 10 * pref << "\n";
			else
				cout << "N " << 5 * pref << "\n";
			continue;
		}
		if (c == 0) {
			cout << "N " << 4 * pref << '\n';
			continue;
		}
		if (d == 3) {
			cout << "N " << 12 * pref << '\n';
			continue;
		}
		cout << "N " << 8 * pref << '\n';
	}
}