		#include <iostream>
		#include <algorithm>
		#include <vector>
		#include <map>
		#include <set>
		#include <string>
		#include <cmath>
		#include <ctime>
		#include <queue>
		#define X first
		#define Y second
		typedef long long ll;
		typedef long double ld;
		typedef unsigned long long ull;
		const ll INF = 1e9 + 4;
		using namespace std;
		struct ST {
			vector<ll> v;
			ll n;
			void init(ll n) {
				v.resize(4 * n);
				this->n = n;
				return;
			}
			void set(ll pos, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
				if (tr == -1)
					tr = n;
				if (tr <= pos || tl > pos)
					return;
				if (tr == tl - 1 && tl == pos)
					return void(v[ver] = val);
				ll tm = (tl + tr) / 2;
				if (tm < pos)
					set(pos, val, ver * 2 + 1, tl, tm);
				else set(pos, val, ver * 2 + 2, tm, tr);
				v[ver] = v[ver * 2 + 1] + v[ver * 2 + 2];
			}
			ll get(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
				if (tr == -1)
					tr = n;
				if (tr <= l || tl >= r)
					return INF;
				if (tl == tr - 1)
					return (v[ver] == 1 ? l : INF);
				ll tm = (tr + tl) / 2;
				ll ret = get(l, min(tm, r), ver * 2 + 1, tl, tm);
				if (ret != INF)
					return ret;
				return get(max(tm, l), tr, ver * 2 + 2, tm, tr);
			}
			ll getsum(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
				if (tr == -1)
					tr = n;
				if (tl >= r || tr <= l)
						 0;
				if (tl == l && tr == r)
					return v[ver];
				ll tm = (tl + tr) / 2;
				return getsum(l, min(tm, r), ver * 2 + 1, tl, tm) +
					getsum(max(tm, l), r, ver * 2 + 2, tm, tr);
			}
		} tr;
		const ll MAXN = 1000000 + 3;
		map<ll, ll> mp;
		vector<ll> v;
		ll n;

		bool check(ll x) {
			mp.clear();
			for (ll i = 0; i < n; i++) {
				mp[v[i]]++;
				for (auto it = mp.begin(); it != mp.end(); it++)
					if (it->X > v[i])
						it->Y = 0;
				if (mp[v[i]] > x && v[i]>1) {
					mp[v[i]] = 1;
					for (ll j = v[i] - 1; j > 0; j--) {
						mp[j]++;
						if (mp[j] <= x || j==1)
							break;
						else mp[j] = 1;
					}
				}
			}
			return mp[1] < x;
		}

		int main() {
		#ifdef _DEBUG
			freopen("input.txt", "r", stdin);
			freopen("output.txt", "w", stdout);
		#endif
			cin >> n;
			v.resize(n);
			for (ll i = 0; i < n; i++)
				cin >> v[i];
			ll l = 1, r = 1e18;
			while (r - l > 1) {
				ll m = (r + l) / 2;
				if (check(m))
					r = m;
				else l = m;
			}
			if (check(l))
				r = l;
			cout << r;
			return 0;
		}