#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 100000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

ll len[MAXN];
ll word[1000000];
ll mc = 1;

ll binp(ll x, ll p) {
	ll res = 1;
	while (p > 0) {
		if (p & 1) {
			res *= x;
		}
		x *= x;
		p /= 2;
	}
	return res;
}

int main() {
	ll n;
	cin >> n;

	cin >> len[0];
	for (ll i = 1; i < n; i++) {
		cin >> len[i];
		assert(len[i] == len[i - 1]);
	}

	ll k = 1;
	while (binp(k, len[0]) < n) {
		k++;
	}

	cout << k;

	return 0;
}