#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 100000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

ll len[MAXN];
ll word[1000000];
ll mc = 1;

int main() {
	ll n;
	cin >> n;

	cin >> len[0];
	for (ll i = 1; i < n; i++) {
		cin >> len[i];
		for (ll j = len[i - 1]; j < len[i]; j++) {
			word[j] = 0;
		}
		if (len[i] > len[i - 1]) { continue; }

		ll pt = len[i] - 1;
		word[pt]++;
		while (pt > 0 && word[pt] == mc) {
			word[pt] = 0;
			word[pt - 1]++;
			pt--;
		}
		if (word[0] == mc) {
			for (ll i = 0; i < len[i]; i++) {
				word[i] = mc - 1;
			}
			mc++;
			word[len[i] - 1] = mc - 1;
		}
	}

	cout << mc;

	return 0;
}