#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 100000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

ll len[MAXN];
ll word[1000000];
ll ct[1000000];
ll mc = 1;

int main() {
	ll n;
	cin >> n;

	cin >> len[0];
	len[0]--;
	ct[len[0]]++;
	for (ll t = 0; t < len[0]; t++) {
		ct[t] = 1;
	}
	for (ll i = 1; i < n; i++) {
		cin >> len[i];
		len[i]--;

		if (len[i] < len[i - 1]) {
			for (ll j = len[i]; j <= len[i - 1]; j++) {
				ct[j] = 1;
			}
		}
		ct[len[i]]++;
		if (len[i] != 0) {
			if ((ct[i - 1] + 1) * (ct[i] - 1) > ct[i - 1] * ct[i]) { ct[i - 1]--; ct[i]++; }
		}
		mc = max(mc, ct[i]);
		mc = max(mc, ct[i - 1]);
	}

	cout << mc;

	return 0;
}