#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 200000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

int main() {
	ll g;
	cin >> g;

	for (ll q = 0; q < g; q++) {
		ll l = 1;
		ll r = 1000000000000000001;
		ll m = (l + r) / 2;

		while (r - l > 1) {
			ll a, b;
			cout << "X " << m << "\n";
			
			cin >> a;
			if (a == -1) {
				return 0;
			}
			cin >> b;

			if (a > 0) {
				l = m;
			}
			else {
				r = m;
			}
			m = (l + r) / 2;
		}

		cout << "N " << l;
		string s;
		cin >> s;
		if (s == "Wrong") { return 0; }
	}

	return 0;
}