#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 200000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

int main() {
	ll g;
	cin >> g;

	for (ll q = 0; q < g; q++) {
		ll a2, b2;
		cout << "X 2\n"; cout.flush();
		cin >> a2 >> b2;
		if (a2 == 0) {
			cout << "N 1\n"; cout.flush();
		}if (a2 != 1) {
			cout << "N " << b2 << "\n"; cout.flush();
		}
		else {
			ll l = 2;
			ll r = 1000000000000000001;
			ll m = l + 1;

			while (r - l > 1) {
				ll a, b;
				printf("X %lld\n", m);
				fflush(stdout);

				scanf("%lld", &a);
				if (a == -1) {
					return 0;
				}
				scanf("%lld", &b);

				if (a == 1) {
					l *= m;
				}
				else if (a > 1) {
					l = max(m, b);
				}
				else {
					r = m;
				}
				m = l + 1;
			}

			printf("N %lld\n", l);
			fflush(stdout);
		}

		char s[20];
		scanf("%s", &s);
		if (s[0] == 'W') { return 0; }
	}

	return 0;
}