#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <unordered_map>
#include <string>
#define SZ(v) (int)v.size()
#define dout(x) if(debug)cout<<#x<<": "<<x<<endl;
#define X first
#define Y second
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define p4(a,b,c,d) p(p(a,b),p(c,d))
using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = (1LL << 61);
const long long MOD = 1e9 + 7;
const long long MOD2 = 1e9 + 9;
const int inf = 2e9;
const long double PI = acos(-1);
void solve();
int myrand() {
	return (abs(rand() << 16) | (rand() >> 16)) ^ (abs(rand() << 16) | (rand() >> 16));
}
bool debug = 0;
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	debug = 1;
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);
	srand((unsigned)time(NULL));
	solve();
}
const int N = 1000005;
const int lg = 26;
const int MAGIC = 420;
struct node {
	int le, ri;
	int let;
	p(int,int) f;
	int prior;
	node *l, *r;
	node(int le, int ri, int let) {
		this->l = this->r = NULL;
		this->le = le;
		this->ri = ri;
		this->let = let;
		this->f = { let,ri };
		this->prior = myrand();
	}
};
p(int, int) f(node *t) {
	p(int, int) ret = { inf,inf };
	if (t != NULL) {
		t->f = { t->let,t->ri };
		ret = t->f;
	}
	return ret;
}
p(int, int) comb(p(int, int) l, p(int, int) r) {
	if (l.X < r.X)return l;
	if (r.X < l.X)return r;
	if (l.Y > r.Y)return l;
	return r;
}
void update(node *t) {
	if (!t)return;
	t->f = f(t);
	t->f = comb(t->f, f(t->l));
	t->f = comb(t->f, f(t->r));
}
void merge(node *&v, node *l, node *r) {
	if (!l)v = r;
	else if (!r)v = l;
	else if (l->prior > r->prior)
		merge(l->r, l->r, r), v = l;
	else
		merge(r->l, l, r->l), v = r;
	update(v);
}
void split(node *v, node *&l, node *&r, int key) {
	if (v == NULL)
		return void(l = r = NULL);
	if (v->le <= key && key <= v->ri) {
		node * t1 = NULL, *t2 = NULL;
		t1 = new node(v->le, key, v->let);
		if (key + 1 <= v->ri)t2 = new node(key + 1, v->ri, v->let);
		merge(l, v->l, t1);
		merge(r, t2, v->r);
		return;
	}
	if (v->le > key)
		split(v->l, l, v->l, key), r = v;
	else
		split(v->r, v->r, r, key), l = v;
	update(v);
}
int ans = 1;
void out(node *t) {
	if (!t)
		return;
	out(t->l);
	ans = max(ans, t->let);
	out(t->r);
}
int n, l, l_prev;
node * root = NULL;
void solve() {
	cin >> n >> l_prev;
	root = new node(1, l_prev, 1);
	for (int i = 2; i <= n; i++) {
		cin >> l;
		if (l <= l_prev) {
			node *t1;
			split(root, root, t1, l);
			int pos = root->f.Y;
			split(root, root, t1, pos);
			split(root, root, t1, pos - 1);
			t1->let++;
			merge(root, root, t1);
			if (pos != l)merge(root, root, new node(pos + 1, l, 1));
		}
		else {
			merge(root, root, new node(l_prev + 1, l, 1));
		}
		l_prev = l;
	}
	out(root);
	cout << ans << endl;
}