#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <unordered_map>
#include <string>
#define SZ(v) (int)v.size()
#define dout(x) if(debug)cout<<#x<<": "<<x<<endl;
#define X first
#define Y second
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define p4(a,b,c,d) p(p(a,b),p(c,d))
using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = (1LL << 61);
const long long MOD = 1e9 + 7;
const long long MOD2 = 1e9 + 9;
const int inf = 2e9;
const long double PI = acos(-1);
void solve();
int myrand() {
	return (abs(rand() << 16) | (rand() >> 16)) ^ (abs(rand() << 16) | (rand() >> 16));
}
bool debug = 0;
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	debug = 1;
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);
	srand((unsigned)time(NULL));
	solve();
}
const int N = 100005;
const int lg = 26;
const int MAGIC = 420;
int porog = 0;
struct node {
	int le, ri;
	int let;
	p(int, int) f;
	int prior;
	node *l, *r;
	node(int le, int ri, int let) {
		this->l = this->r = NULL;
		this->le = le;
		this->ri = ri;
		this->let = let;
		this->f = { let,ri };
		this->prior = myrand();
	}
};
p(int, int) f(node *t) {
	p(int, int) ret = { inf,inf };
	if (t != NULL) {
		ret = t->f;
	}
	return ret;
}
p(int, int) comb(p(int, int) l, p(int, int) r) {
	if (r.X == porog && l.X != porog)return l;
	if (l.X == porog && r.X != porog)return r;
	if (l.X < r.X)return l;
	if (r.X < l.X)return r;
	if (l.Y > r.Y)return l;
	return r;
}
void update(node *t) {
	if (!t)return;
	t->f = f(t);
	t->f = comb(t->f, f(t->l));
	t->f = comb(t->f, f(t->r));
}
void merge(node *&v, node *l, node *r) {
	if (!l)v = r;
	else if (!r)v = l;
	else if (l->prior > r->prior)
		merge(l->r, l->r, r), v = l;
	else
		merge(r->l, l, r->l), v = r;
	update(v);
}
void split(node *v, node *&l, node *&r, int key) {
	if (v == NULL)
		return void(l = r = NULL);
	if (v->le <= key && key <= v->ri) {
		node * t1 = NULL, *t2 = NULL;
		t1 = new node(v->le, key, v->let);
		if (key + 1 <= v->ri)t2 = new node(key + 1, v->ri, v->let);
		merge(l, v->l, t1);
		merge(r, t2, v->r);
		return;
	}
	if (v->le > key)
		split(v->l, l, v->l, key), r = v;
	else
		split(v->r, v->r, r, key), l = v;
	update(v);
}
int n, l[N];
node * root = NULL;
bool check(int x) {
	porog = x;
	delete(root);
	root = new node(1, l[1], 1);
	for (int i = 2; i <= n; i++) {
		if (l[i] <= l[i - 1]) {
			node *t1;
			split(root, root, t1, l[i]);
			int pos = root->f.Y;
			split(root, root, t1, pos);
			split(root, root, t1, pos - 1);
			if (t1 == NULL || t1->let == x)return 0;
			t1->let++;
			t1->f = { t1->let,t1->ri };
			merge(root, root, t1);
			if (pos != l[i])
				merge(root, root, new node(pos + 1, l[i], 1));
		}
		else {
			merge(root, root, new node(l[i - 1] + 1, l[i], 1));
		}
	}
	return 1;
}
void solve() {
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> l[i];
	}
	int le = 0, ri = n;
	while (ri - le > 1) {
		int mid = (le + ri) >> 1;
		if (check(mid))
			ri = mid;
		else
			le = mid;
	}
	cout << ri << endl;
}