#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <unordered_map>
#include <string>
#define SZ(v) (int)v.size()
#define dout(x) if(debug)cout<<#x<<": "<<x<<endl;
#define X first
#define Y second
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define p4(a,b,c,d) p(p(a,b),p(c,d))
using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = (1LL << 61);
const long long MOD = 1e9 + 7;
const long long MOD2 = 1e9 + 9;
const int inf = 2e9;
const long double PI = acos(-1);
void solve();
int myrand() {
	return (abs(rand() << 16) | (rand() >> 16)) ^ (abs(rand() << 16) | (rand() >> 16));
}
bool debug = 0;
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	debug = 1;
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);
	srand((unsigned)time(NULL));
	solve();
}
const int N = 100005;
const int lg = 26;
const int MAGIC = 420;
set< p3(int, int, int) > all;

int n, l[N];

bool check(int x) {
	all.clear();
	all.insert({ {1,l[1]},1 });
	for (int i = 2; i <= n; i++) {
		if (l[i] <= l[i - 1]) {
			while (SZ(all) > 0 && ((--all.end())->X.X > l[i] || (--all.end())->Y == x))
				all.erase(--all.end());
			if (SZ(all) == 0)
				return 0;
			p3(int, int, int) inc = *(--all.end());
			all.erase(--all.end());
			int pos = min(l[i], inc.X.Y);
			if (inc.X.X < pos)
				all.insert({ {inc.X.X,pos - 1},inc.Y });
			all.insert({ {pos,pos},inc.Y + 1 });
			if (pos != l[i])
				all.insert({ {pos + 1, l[i]}, 1 });
		}
		else {
			all.insert({ {l[i - 1] + 1,l[i]},1 });
		}
	}
	return 1;
}
void solve() {
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> l[i];
	}
	int le = 0, ri = n;
	while (ri - le > 1) {
		int mid = (le + ri) >> 1;
		if (check(mid))
			ri = mid;
		else
			le = mid;
	}
	cout << ri << endl;
}