#include <bits/stdc++.h>
using namespace std;
struct segment {
    int l,r,cs;
};
const int maxn=4e5;
segment a[maxn];
pair<int,int> b[maxn];
int st[maxn];
int n,k;
int fpr[maxn];
void compress() {
    for (int i=1;i<=n;i++) {
        b[i]=make_pair(a[i].l,i);
        b[i+n+n]=make_pair(max(1,a[i].l-1),i+n+n);
        b[i+n]=make_pair(a[i].r,i+n);
    }
    sort(b+1,b+n+n+n+1);
    k=0;
    for (int i=1;i<=n+n+n;i++) {
        if (i==1 || b[i].first!=b[i-1].first) k++;
        int x=b[i].second;
        if (x<=n) a[x].l=k;
        else
        if (x<=2*n) a[x-n].r=k;
    }
}
long long f[maxn];
vector<int> ed[maxn];
void sol1() {
    for (int i=1;i<=n;i++) ed[a[i].r].push_back(a[i].l);
    f[0]=1;
    for (int i=1;i<=k;i++) {
        for (int j=0;j<ed[i].size();j++) {
            if (f[ed[i][j]-1]==1) f[i]=1;
        }
    }
    if (f[k]==1) cout << "1\n";
    else cout << "2\n";
}
bool cmp(const segment &i, const segment &j) {
    return (i.l<j.l);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin >> n >> k;
    int fnd1=0,fnd2=0;
    for (int i=1;i<=n;i++) {
        cin >> a[i].l >> a[i].r >> a[i].cs;
        if (a[i].l==1) fnd1=1;
        if (a[i].r==k) fnd2=1;
    }
    if (fnd1==0 || fnd2==0) {
        cout << "-1\n";
        return 0;
    }

    int t=0;
    for (int i=1;i<=n;i++)
        if (a[i].cs==1) t++;
    if (t==n) {
        compress();
        for (int i=1;i<=n;i++) fpr[a[i].l]++,fpr[a[i].r+1]--;
        for (int i=1;i<=k;i++) {
            fpr[i]=fpr[i-1]+fpr[i];
            if (fpr[i]==0) {
                cout << "-1\n";
                return 0;
            }
        }
        sol1();
    }
    else {
        sort(a+1,a+n+1,cmp);
        for (int i=1;i<=n;i++) {
            f[i]=2e9+1;
            if (a[i].l==1) f[i]=a[i].cs;
        }
        long long ans=2e9+1;
        for (int i=1;i<=n;i++) {
            for (int j=i+1;j<=n;j++) {
                if (a[i].l<=a[j].l && a[j].l<=a[i].r && a[j].r>a[i].r) f[j]=max(f[j],max(f[i],1ll*a[i].cs+a[j].cs));
                if (a[i].r+1==a[j].l) f[j]=max(f[j],max(f[i],1ll*a[j].cs));
            }
            if (a[i].r==k) ans=min(ans,f[i]);
        }
        if (ans==2e9+1) cout << "-1\n";
        else
        cout << ans << "\n";
    }
    return 0;
}
