#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>

using namespace std; 
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)1e5 + 1;
int l[dd];
int cur[dd];
int n;

bool check(int x) {

	for (int i = 0; i < l[0]; i++) {
		cur[i] = 0;
	}

	for (int i = 1; i < n; i++) {
		if (l[i] > l[i - 1]) {
			for (int j = l[i - 1]; j < l[i]; j++)
				cur[j] = 0;
		} else {
			int pos = l[i] - 1;

			while (pos >= 0 && cur[pos] == x) {
				pos--;
			}

			if (pos < 0) return false;

			cur[pos]++;
			for (int j = pos + 1; j < l[i]; j++) 
				cur[j] = 0;
		}
	}
	return true;
}

int solve() {
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		scanf("%d", &l[i]);
	}

	int l = -1, r = 27;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (check(m))
			r = m;
		else
			l = m;
	}
	printf("%d\n", r + 1);


	return 0;
}