#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>
#include <cstring>

using namespace std; 
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)2e5 + 1;

ll dp[dd];
struct ev { ll l, r, p; } A[dd];

int solve() {
	int n, k;
	scanf("%d %d", &n, &k);
	
	for (int i = 0; i < n; i++) {
		scanf("%lld %lld %lld", &A[i].l, &A[i].r, &A[i].p);	
	}

	sort(A, A + n, [](ev a, ev b) { return a.r < b.r;  });

	fill(dp, dp + n + 1, (ll)1e18 + 1);
	dp[0] = 0;

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j < i; j++) {
			if (A[j - 1].r + 1 == A[i - 1].l) {
				dp[i] = min(dp[i], max(dp[j], A[i - 1].p));
			}
			if (A[j - 1].r + 1 > A[i - 1].l) {
				dp[i] = min(dp[i], max(dp[j], A[i - 1].p + A[j - 1].p));
			}
		}
		if (A[i - 1].l == 1) {
			dp[i] = min(dp[i], A[i - 1].p);
		}
	}

	ll ans = (ll)1e18 + 1;
	for (int i = 1; i <= n; i++) {
		if (A[i - 1].r == k) {
			ans = min(ans, dp[i]);
		}
	}

	if (ans == (ll)1e18 + 1) {
		puts("-1");
	} else {
		printf("%lld\n", ans);
	}
	return 0;
}