#include <bits/stdc++.h>

using namespace std;

struct section {
    int l, r, p;
};

bool comp(section a, section b) {
    if (a.l == b.l) {
        return a.r < b.r;
    } else {
        return a.l < b.l;
    }
}

int main()
{
    int n, k;
    cin >> n >> k;

    vector <section> food(n);

    for (int i = 0; i < n; i++) {
        cin >> food[i].l >> food[i].r >> food[i].p;
    }

    sort(food.begin(), food.end(), comp);

    int r = 1;
    for (int i = 0; i < n; i++) {
        if (food[i].l <= r + 1) {
            r = food[i].r;
        }
    }

    if (r == k) {
        set <int> right;
        right.insert(0);

        for (int i = 0; i < n; i++) {
            if (right.find(food[i].l - 1) != right.end()) {
                right.insert(food[i].r);
            }
        }

        if (right.find(k) != right.end()) {
            cout << 1 << endl;
        } else {
            cout << 2 << endl;
        }
    } else {
        cout << -1 << endl;
    }

    return 0;
}
