#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>

#define fi first
#define se second
#define m_p make_pair
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0)
#define y1 zachem

using namespace std;

typedef long long ll;

const ll MAXN = 1000005;

char c[MAXN];

ll x = 0, y = 0;
ll n;
ll kol[MAXN], used[MAXN],f[MAXN],f1[MAXN];
ll ans[MAXN];

void road(char way) {
    if (way == 'U') y++;
    if (way == 'D') y--;
    if (way == 'L') x--;
    if (way == 'R') x++;
}

int main()
{
    fast_io;

    ll  i , j, pr,pu,pd,pl;
    ll s1 = 0, s2 = 0;
    ll x1,y1;

    cin >> n;
    pr = n + 1, pu = n + 1, pd = n + 1,pl = n + 1;
    for (i = 1; i <= n; i++) {cin >> c[i]; used[c[i]]++;}

    f[pu] = -1,f[pd] = -1,f[pl] = -1,f[pr] = -1;

    for (i = n; i >= 1; i--) {
        if (c[i] == 'D') f[i] = f[pd] + 1,pd = i;
        if (c[i] == 'U') f[i] = f[pu] + 1,pu = i;
        if (c[i] == 'R') f[i] = f[pr] + 1,pr = i;
        if (c[i] == 'L') f[i] = f[pl] + 1,pl = i;
    }
    cin >> x1 >> y1;
    for (i = 1; i <= n; i++) road(c[i]);

    if (x1 < x) kol['R'] += (x - x1);
    else kol['L'] += (x1 - x);

    if (y1 < y) kol['U'] += (y - y1);
    else kol['D'] += (y1 - y);
    for (i = 1 ; i <= n; i++) {
        if (f[i] == kol[c[i]] && f1[c[i]] == 0 ) {ans[c[i]] = i; kol[c[i]] = 0,f1[c[i]] = 1;}
    }
    if (used['D'] == kol['D']) kol['D'] = 0,ans['D'] = 0;
    if (used['U'] == kol['U']) kol['U'] = 0,ans['U'] = 0;
    if (used['R'] == kol['R']) kol['R'] = 0,ans['R'] = 0;
    if (used['L'] == kol['L']) kol['L'] = 0,ans['L'] = 0;

    if (kol['U'] == 0 && kol['D'] == 0 && kol['R'] == 0 && kol['L'] == 0) {
        cout << ans['L'] << " " << ans['U'] << " " << ans['R'] << " " << ans['D'] << endl;
        return 0;
    }
    cout << -1 << endl;
    return 0;
}
