#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define mk make_pair
#define psh push_back
#define pii pair <int, int>
#define vii vector <int>

typedef long long ll;
typedef long double ld;

const ll INF = ll(1e9) + 7;
const ll LINF = ll(1e18);
const int SIZ = 200000;

set <int> used;
vector <pair <pii, int> > ot;
int n, k;
int f = 0;

void dfs(int v){
    if (v == k) f = 1;
    used.insert(v);
    int lg = -1, rg = n-1;
    while (rg - lg > 1){
        int mid = (lg + rg) / 2;
        if (ot[mid].X.X >= v) rg = mid;
        else lg = mid;
    }
    int left;
    if (ot[rg].X.X == v){
        left = rg;
        lg = 0;
        rg = n;
        while (rg - lg > 1){
            int mid = (lg+rg)/2;
            if (ot[mid].X.X <= v) lg = mid;
            else rg = mid;
        }
        int right = lg;
        for (int i = left; i <= right; i++){
            if (used.find(ot[i].X.Y) == used.end()) dfs(ot[i].X.Y);
        }
    }
}

int main(){
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> k;
    ot.resize(n);
    for (int i = 0; i < n; i++){
        cin >> ot[i].X.X >> ot[i].X.Y >> ot[i].Y;
    }
    sort(ot.begin(), ot.end());
    dfs(1);
    if (f) cout << 1 << "\n";
    else cout << 2 << "\n";
    return 0;
}
