#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include<bitset>
#include <cstring>
#include <queue>
using namespace std;
#define sz(a) (a.size())
#define mp(a, b) make_pair(a, b)
#define all(a) (a.begin(), a.end())
#define rall(a) (a.rbegin(), a.rend())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
vector<int> inc(vector<int> a, int m) {
	for (int i = sz(a) - 1; i >= 0; i--)
		if (a[i] + 1 < m) {
			a[i]++;
			break;
		}
		else
			a[i] = 0;
	int flag = 0;
	for (int i : a)
		if (i != 0)
			flag = 1;
	if (!flag) a[0] = -1;
	return a;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<vector<int> > a(n);
	int sum = 0;
	for (int i = 0; i < n; i++) {
		int s;
		cin >> s;
		a[i].resize(s);
	}
	int l = 0, r = n;
	while (r - l > 1) {
		int m = (r + l) / 2;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < a[i].size(); j++)
				a[i][j] = 0;
		int flag = 1;
		for (int i = 1; i < n; i++) {
			if (sz(a[i]) > sz(a[i - 1]))
				for (int j = 0; j < sz(a[i - 1]); j++)
					a[i][j] = a[i - 1][j];
			else {
				if (sz(a[i]) == sz(a[i - 1]))
					a[i] = inc(a[i - 1], m);
				else {
					for (int j = 0; j < sz(a[i]); j++)
						a[i][j] = a[i - 1][j];
					a[i] = inc(a[i], m);
				}
			}
			if (a[i][0] == -1) {
				flag = 0;
				break;
			}
		}
		if (!flag)
			l = m;
		else
			r = m;
	}
	cout << r;
}