#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include<bitset>
#include <cstring>
#include <queue>
using namespace std;
#define sz(a) (a.size())
#define mp(a, b) make_pair(a, b)
#define all(a) (a.begin(), a.end())
#define rall(a) (a.rbegin(), a.rend())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
struct dim {
	int r, l, d, u;
	dim operator+(char c) {
		dim t;
		t.r = this->r + (c == 'R');
		t.l = this->l + (c == 'L');
		t.u = this->u + (c == 'U');
		t.d = this->d + (c == 'D');
		return t;
	}
};
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<char> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int x2, y2;
	cin >> x2 >> y2;
	vector<dim> suf(n);
	suf[n - 1] = dim{ 0, 0, 0, 0 } + a[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		suf[i] = suf[i + 1] + a[i];
	}
	int x1 = 0, y1 = 0;
	dim ans{ -1,-1,-1,-1 };
	for (int i = 0; i < n; i++) {
		if(ans.r == -1 && ans.l == -1 && x1  == x2)
			ans.r = ans.l = i;
		if (ans.l == -1 && x1 + suf[i].r == x2)
			ans.l = i;
		if (ans.r == -1 && x1 - suf[i].l == x2)
			ans.r = i;

		if (ans.u == -1 && ans.d == -1 && y1 == y2)
			ans.u = ans.d = i;
		if (ans.d == -1 && y1 + suf[i].u == y2)
			ans.d = i;
		if (ans.u == -1 && y1 - suf[i].d == y2)
			ans.u = i;
		x1 += (a[i] == 'R' && ans.r == -1) - (a[i] == 'L' && ans.l == -1);
		y1 += (a[i] == 'U' && ans.u == -1) - (a[i] == 'D' && ans.d == -1);
	}
	if (x1 != x2 || y1 != y2) {
		cout << -1;
	}
	else {
		cout << (ans.l == -1 ? n : ans.l) << ' ';
		cout << (ans.u == -1 ? n : ans.u) << ' ';
		cout << (ans.r == -1 ? n : ans.r) << ' ';
		cout << (ans.d == -1 ? n : ans.d) << ' ';
	}
}