#include <bits/stdc++.h>

#define f first
#define s second

#define ll long long
#define ld long double

#define pb push_back
#define mp make_pair

#define all(x) x.begin(), x.end()
#define sqr(x) ((x) * 1ll (x))
#define sz(x) (int)x.size()

#define rep(type, from, to) for (int type = from; type <= to; ++type)
#define per(type, from, to) for (int type = from; type >= to; --type)
#define Kazakhstan ios_base :: sync_with_stdio(0), cin.tie(0), cout.tie(0);

#define nl '\n'
#define ioi exit(0);

using namespace std;

const int N = (int)1e5 + 7, inf = (int)1e9 + 7;
const ll linf = (ll)1e18 + 7;
const int dx[] = {1, -1, 0, 0, 1, 1, -1, -1}, dy[] = {0, 0, 1, -1, 1, -1, 1, -1};

  int n, k;

  struct fenwick {
    map <int, int> f;
    inline void upd(ll x) {
      for (; x <= inf; x |= x + 1)
        f[x]++;
    }
    inline int get(ll x) {
      int res = 0;
      for (; x >= 0; x = (x & (x + 1)) - 1)
        res += f[x];
      return res;
    }
  } t;

  struct node {
    int l, r, x;
    inline bool operator < (const node &z) const {
      return l < z.l;
    }
  } a[N];

  inline bool cmp(node &a, node &b) {
    if (a.r != b.r) return a.r < b.r;
    return a.l < b.l;
  }

  priority_queue <node> x;
int main() {
  #ifdef Logan
    freopen ("input.txt", "r", stdin);
  #endif

  cin >> n >> k;
  rep(i, 1, n) {
    cin >> a[i].l >> a[i].r >> a[i].x;
    x.push(a[i]);
  }

  sort (a + 1, a + 1 + n, cmp);

  rep(i, 1, n) {
    while (sz(x) && a[i].l - 1 <= x.top().l) x.pop();
    x.push(a[i]);
  }

  vector <node> b;
  while (sz(x))
    b.pb(x.top()), x.pop();

  sort (all(b), cmp);

  int ans = 0;
  pair <int, int> last = {0, inf};
  rep(i, 0, sz(b) - 1) {
    if (last.s < b[i].l) cout << -1, ioi
    if (i == 0) last = {b[i].l, b[i].r};
    else {
      if (b[i].r > last.s) last = {b[i].l, b[i].r};
    }
  }


  for (auto i : b) {
    t.upd(i.l);
    ans = max(ans, t.get(i.l) - t.get(i.l - 1));
  }

  cout << ans;
  ioi
}

