#include <iostream>
#include <stdio.h>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <stack>
#include <stdlib.h>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define in(s) freopen(s, "r", stdin);
#define out(s) freopen(s, "w", stdout);
#define forn(i, n) for(int i = 0; i < n; i++)
//#define endl '\n'

pair<ll, ll> ask(ll x)
{
	cout << "X " << x << endl;
	pair <ll, ll> back;
	cin >> back.first;
	if (back.first == -1ll)
		exit(0);
	cin >> back.second;
	return back;
}

const pair <ll, ll> Empty = { 0ll, 1ll };

int main()
{
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int g;
	cin >> g;

	forn(i, g)
	{
		bool flag = true;
		pair <ll, ll> check = ask(2ll);
		if (check.first == 1ll && check.second == 2ll)
			flag = false;
		else
		{
			cout << "N " << check.second << endl;
			string res;
			cin >> res;
			if (res != "Correct")
				exit(0);
			continue;
		}
		ll l = 1ll, r = (ll)5e+17 + 1ll;
		while (l != r)
		{
			ll mid = (l + r) / 2ll;
			pair <ll, ll> now;
			now = ask(2ll * mid);
			if (now == Empty)
				r = mid;
			else
				l = mid + 1ll;
		}
		l = 2ll * l;
		cout << "N " << l - 2ll << endl;
		string res;
		cin >> res;
		if (res != "Correct")
			exit(0);
	}
	
	return 0;
}