#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    s = "#" + s;
    int x, y;
    cin >> x >> y;
    vector<int> up(n + 1, 0);
    vector<int> down(n + 1, 0);
    vector<int> left(n + 1, 0);
    vector<int> right(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        up[i] = up[i - 1];
        down[i] = down[i - 1];
        left[i] = left[i - 1];
        right[i] = right[i - 1];
        if (s[i] == 'U') {
            up[i]++;
        } else if (s[i] == 'D') {
            down[i]++;
        } else if (s[i] == 'L') {
            left[i]++;
        } else {
            right[i]++;
        }
    }
    int ans_up = -1;
    int ans_down = -1;
    int ans_left = -1;
    int ans_right = -1;
    //solving for up down
    for (int i = 0; i <= n; i++) {
        int cur_pos = up[i] - down[i];

        int l = i;
        int r = n + 1;
        while (l < r) {
            int m = (l + r) / 2;
            if (cur_pos + up[m] - up[i] < y) {
                l = m + 1;
            } else {
                r = m;
            }
        }
        if (l != n + 1 && cur_pos + up[l] - up[i] == y) {
            ans_down = i;
            ans_up = l;
            break;
        }

        l = i;
        r = n + 1;
        while (l < r) {
            int m = (l + r) / 2;
            if (cur_pos - down[m] + down[i] < y) {
                l = m + 1;
            } else {
                r = m;
            }
        }
        if (l != n + 1 && cur_pos - down[l] + down[i] == y) {
            ans_up = i;
            ans_down = l;
            break;
        }
    }
    //solving for left right
    for (int i = 0; i <= n; i++) {
        int cur_pos = right[i] - left[i];

        int l = i;
        int r = n + 1;
        while (l < r) {
            int m = (l + r) / 2;
            if (cur_pos + right[m] - right[i] < x) {
                l = m + 1;
            } else {
                r = m;
            }
        }
        if (l != n + 1 && cur_pos + right[l] - right[i] == x) {
            ans_left = i;
            ans_right = l;
            break;
        }

        l = i;
        r = n + 1;
        while (l < r) {
            int m = (l + r) / 2;
            if (cur_pos - left[m] + left[i] < x) {
                l = m + 1;
            } else {
                r = m;
            }
        }
        if (l != n + 1 && cur_pos - left[l] + left[i] == x) {
            ans_right = i;
            ans_left = l;
            break;
        }
    }
    if (ans_left == -1 || ans_right == -1 || ans_up == -1 || ans_down == -1) {
        cout << -1;
    } else {
        cout << ans_left << ' ' << ans_up << ' ' << ans_right << ' ' << ans_down;
    }
}
