#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<array<int, 3> > a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i][0] >> a[i][1] >> a[i][2];
	}
	sort(a.begin(), a.end());
	set<int> used;
	used.insert(0);
	for (int i = 0; i < n; i++) {
		if (used.find(a[i][0] - 1) != used.end()) {
			used.insert(a[i][1]);
		}
	}
	vector<pair<int, int> > ev;
	for (int i = 0; i < n; i++) {
		ev.push_back(make_pair(a[i][0], 1));
		ev.push_back(make_pair(a[i][1], -1));
	}
	sort(ev.begin(), ev.end());
	if (ev[0].first > 1 || ev.back().first < m) {
		cout << -1 << endl;
		return 0;
	}
	int cnt = 0;
	for (int i = 0; i < 2 * n; i++) {
		if (i != 0 && cnt == 0 && ev[i - 1].first < ev[i].first - 1) {
			cout << -1 << endl;
			return 0;
		}
		cnt += ev[i].second;
	}
	if (used.find(m) != used.end()) {
		cout << 1 << endl;
	}
	else {
		cout << 2 << endl;
	}
    return 0;
}

