#include <bits/stdc++.h>

using namespace std;

#define int int64_t

ifstream fin("input.txt");
ofstream fout("output.txt");
ofstream deb("debug.txt");

template<typename T>
void printc(vector<T> &a) {
    for (auto x : a)
        cout << x << " ";
    cout << endl;
}

template<typename T>
void printd(vector<T> &a) {
    for (auto x : a)
        deb << x << " ";
    deb << endl;
}

pair<int, int> query(int a) {
    cout << "X " << a << endl;
    int t, p;
    cin >> t >> p;
    return {t, p};
}

bool pluss(vector<int> &a, int m) {
    int n = a.size(), i = n - 1;
    while (i >= 0 && a[i] == m - 1)
        a[i--] = 0;
    if (i >= 0) {
        a[i]++;
        return true;
    }
    else
        return false;
}

signed main()
{
    int n;
    fin >> n;
    vector<int> l(n);
    for (int i = 0; i < n; i++)
        fin >> l[i];

    int L = 0, R = n + 1;
    while (R - L > 1) {
        int m = (L + R) / 2;
        bool is_good = true;
        vector<vector<int> > strs(n);
        for (int i = 0; i < n; i++)
            strs[i].resize(l[i]);

        for (int i = 0; i < l[0]; i++)
            strs[0][i] = 0;

        for (int i = 1; i < n; i++) {
            for (int j = 0; j < min(l[i - 1], l[i]); j++)
                strs[i][j] = strs[i - 1][j];
            for (int j = l[i - 1]; j < l[i]; j++)
                strs[i][j] = 0;
            if (l[i] <= l[i - 1])
                is_good = is_good & pluss(strs[i], m);
        }
        if (is_good)
            R = m;
        else
            L = m;
    }

    fout << R << endl;

    return 0;
}
