#include <bits/stdc++.h>

using namespace std;

#define int int64_t

ifstream fin("input.txt");
ofstream fout("output.txt");
ofstream deb("debug.txt");

template<typename T>
void printc(vector<T> &a) {
    for (auto x : a)
        cout << x << " ";
    cout << endl;
}

template<typename T>
void printd(vector<T> &a) {
    for (auto x : a)
        deb << x << " ";
    deb << endl;
}

pair<int, int> query(int a) {
    cout << "X " << a << endl;
    int t, p;
    cin >> t >> p;
    return {t, p};
}

bool pluss(vector<int> &a, int m) {
    int n = a.size(), i = n - 1;
    while (i >= 0 && a[i] == m - 1)
        a[i--] = 0;
    if (i >= 0) {
        a[i]++;
        return true;
    }
    else
        return false;
}

signed main()
{
    int n;
    fin >> n;
    vector<int> l(n);
    int max_l = 0;
    for (int i = 0; i < n; i++) {
        fin >> l[i];
        max_l = max(max_l, l[i]);
    }

    int L = 0, R = n + 1;
    while (R - L > 1) {
        int m = (L + R) / 2;
        map<int, int> cnt;
        for (int i = 1; i < n; i++) {
            if (l[i] <= l[i - 1])
                cnt[max_l - l[i]]++;
        }

        for (int i = 0; i < max_l; i++) {
            cnt[i + 1] += cnt[i] / m;
            cnt[i] %= m;
        }

        int sum = 0;
        for (int i = 0; i < max_l; i++)
            sum += cnt[i];

        if (cnt[max_l] > 0 && (sum > 0 || cnt[max_l] > 1))
            L = m;
        else
            R = m;
    }

    fout << R << endl;

    return 0;
}
