#include <bits/stdc++.h>

using namespace std;

#define int int64_t

ifstream fin("input.txt");
ofstream fout("output.txt");
ofstream deb("debug.txt");

template<typename T>
void printc(vector<T> &a) {
    for (auto x : a)
        cout << x << " ";
    cout << endl;
}

template<typename T>
void printd(vector<T> &a) {
    for (auto x : a)
        deb << x << " ";
    deb << endl;
}

pair<int, int> query(int a) {
    cout << "X " << a << endl;
    int t, p;
    cin >> t;
    if (t == -1)
        p = -1;
    else
        cin >> p;
    return {t, p};
}

int max_val = 1000000000000000000;
int max_val1 = 10;

void ml() {
    vector<int> tmp;
    for (int i = 0; i < max_val; i++)
        tmp.push_back(1);
}

signed main()
{
    int g;
    cin >> g;
    for (int ii = 0; ii < g; ii++) {
        int L = 0, R = 32;
        while (R - L > 1) {
            int m = (L + R) / 2;
            auto d = query((1 << m));
            if (d.first == -1) {
                ml();
            }

            if (d.second == d.first * m)
                L = m;
            else
                R = m;
        }

        // R is max 2^R non div of n
        R++;
        auto x = query((1 << R));
        int a = x.first, b = x.second;

        cout << "N " << b * (1 << (R - 1)) / (b - a * (1 << R)) << endl;
        string s;
        cin >> s;
        if (s == "Wrong")
            return 0;
    }
    return 0;
}
