#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair < x, y >
#define first X
#define second Y

#include <iostream>
#include <vector>
#include <stdio.h>
#include <set>
#include <map>
#include <iterator>
#include <climits>
#include <algorithm>
#include <cmath>
#include <random>
#include <queue>
#include <time.h>
#include <string>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1e9 + 7;
const i64 LINF = 1e18 + 7;

int main() {

#ifdef _DEBUG
	freopen("B.txt", "r", stdin);
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	string s;
	cin >> s;

	int cx, cy;
	cin >> cx >> cy;

	int cnt[4];
	cnt[0] = cnt[1] = cnt[2] = cnt[3] = 0;
	vector < vector < int > > ins(4, vector < int >());
	for (int i = 0; i < n; i++) {
		if (s[i] == 'L') {
			ins[0].pb(i + 1);
			cnt[0]--;
		} 
		if (s[i] == 'U') {
			ins[1].pb(i + 1);
			cnt[1]++;
		}
		if (s[i] == 'R') {
			ins[2].pb(i + 1);
			cnt[2]++;
		}
		if (s[i] == 'D') {
			ins[3].pb(i + 1);
			cnt[3]--;
		}
	}

	if (cx < 0 && cx < cnt[3] || cx >= 0 && cx > cnt[1] || cy < 0 && cy < cnt[0] || cy >= 0 && cy > cnt[2]) {
		cout << -1 << endl;
		return 0;
	}

	int ans[4];

	if (cx == 0) {
		ans[3] = ans[1] = 0;
	}
	else {
		if (cx > 0) {
			ans[3] = 0;
			ans[1] = ins[1][cx - 1];
		}
		else {
			ans[1] = 0;
			ans[3] = ins[3][-cx - 1];
		}
	}

	if (!cy) {
		ans[0] = ans[2] = 0;
	}
	else {
		if (cy > 0) {
			ans[0] = 0;
			ans[2] = ins[2][cy - 1];
		}
		else {
			ans[2] = 0;
			ans[0] = ins[0][-cy - 1];
		}
	}

	for (int i = 0; i < 4; i++) {
		cout << ans[i] << " ";
	}
	cout << endl;
	return 0;
}