#include <iostream>
#include <cmath>

typedef struct stack_item
{
    int l;
    int c;
    struct stack_item* prev;
} stack_item;

using namespace std;

int main()
{
    int n;
    cin >> n;
    int data[n + 1];
    for(int i = 0; i < n; i++)
        cin >> data[i];
    data[n] = 0;
    int low = 0;
    int high = n;
    while(high - low > 1)
    {
        int current = (high + low + 1) / 2;
        stack_item* stack = new stack_item;
        stack->l = 0;
        stack->c = 0;
        for(int i = 0; i <= n; i++)
        {
            int new_l = data[i];
            while(new_l < stack->l)
            {
                if(new_l > stack->prev->l)
                {
                    int index = stack->l - new_l;
                    while(stack->c && index)
                    {
                        stack->c = (stack->c + current - 1) / current;
                        index--;
                    }
                    stack->l = new_l;
                }
                else
                {
                    int index = stack->l - stack->prev->l;
                    while(stack->c && index)
                    {
                        stack->c = (stack->c + current - 1) / current;
                        index--;
                    }
                    stack_item* pop = stack->prev;
                    pop->c += stack->c - 1;
                    delete stack;
                    stack = pop;
                }
            }
            if(new_l > stack->l)
            {
                stack_item* push = new stack_item;
                push->prev = stack;
                push->l = new_l;
                push->c = 1;
                stack = push;
            }
            else if(new_l == stack->l)
            {
                stack->c++;
            }
        }
        if(stack->c > 1)
            low = current;
        else
            high = current;
    }
    cout << high << endl;
    return 0;
}
