#pragma GCC "-O3"
#include <bits/stdc++.h>


using namespace std;


#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 500228;
const int INF = 2000000001;


struct road
{
	int l, r, p;
	road(){}
	road(int _l, int _r, int _p) {
		l = _l;
		r = _r;
		p = _p;
	}
};


bool operator <(road a, road b) {
	return a.r < b.r || (a.r == b.r && a.l < b.l);
}


int n, k;
road s[MAXN];
int dp[MAXN];
bool t[MAXN];
long long sum[MAXN];
map<int, int> where;
long long res = 1e18;


void get(int i) {
	if (i == n) {
		for (int i = 0; i <= k; i++) {
			sum[i] = 0;
		}
		int last = 0;
		for (int i = 0; i < n; i++) {
			if (t[i]) {
				for (int j = s[i].l; j <= s[i].r; j++) {
					sum[j] += s[i].p;
				}
			}	
		}
		bool good = 1;
		long long c = 0;
		for (int i = 0; i <= k; i++) {
			//cout << sum[i] << ' ';
			if (!sum[i]) {
				good = 0;
			} else {
				c = max(c, sum[i]);
			}
		}
		//cout << endl;
		if (good) {
			res = min(res, c);
		}
		return;
	}
	t[i] = 1;
	get(i + 1);
	t[i] = 0;
	get(i + 1);
}


int d[12 * MAXN];


void change(int i, int x) {
	d[i] = min(d[i], x);
	while (i >> 1 > 0) {
		i >>= 1;
		d[i] = min(d[i << 1], d[(i << 1) + 1]);
	}
}


int rmq(int v, int vl, int vr, int l, int r) {
	if (vl > r || vr < l) {
		return INF;
	}
	if (l <= vl && vr <= r) {
		return d[v];
	}
	return min(rmq(v * 2, vl, (vl + vr) / 2, l, r), rmq(v * 2 + 1, (vl + vr) / 2 + 1, vr, l, r));
}


int main() {
	scanf("%d %d", &n, &k);
	vector<int> vt;
	for (int i = 0; i < n; i++) {
		scanf("%d %d %d", &s[i].l, &s[i].r, &s[i].p);
		vt.push_back(s[i].l);
		if (s[i].l != 1) {
			vt.push_back(s[i].l - 1);
		}
		if (s[i].l != k) {
			vt.push_back(s[i].l + 1);
		}
		if (s[i].r != 1) {
			vt.push_back(s[i].r - 1);
		}
		vt.push_back(s[i].r);
		if (s[i].r != k) {
			vt.push_back(s[i].r + 1);
		}
	}
	vt.push_back(1);
	vt.push_back(k);
	if (k != 1) {
		vt.push_back(k - 1);
		vt.push_back(2);
	}
	sort(all(vt));
	vt.resize(distance(vt.begin(), unique(all(vt))));
	for (int i = 0; i < sz(vt); i++) {
		where[vt[i]] = i;
	}
	k = sz(vt) - 1;
	for (int i = 0; i < n; i++) {
		s[i].l = where[s[i].l];
		s[i].r = where[s[i].r];
	}
	if (n <= 10) {
		get(0);
		if (res == 1e18) {
			cout << -1 << endl;
		} else {
			cout << res << endl;
		}
		return 0;
	}
	sort(s, s + n);
	int ss = 1;
	while (ss <= k) {
		ss <<= 1;
	}
	for (int i = 0; i < 2 * ss; i++) {
		d[i] = INF;
	}
	int ans = INF;
	for (int i = 0; i < n; i++) {
		dp[i] = INF;
		if (s[i].l == 0) {
			dp[i] = s[i].p;
		} else {
			dp[i] = max(rmq(1, 1, ss, s[i].l, s[i].l), 1);
			dp[i] = min(dp[i], max(rmq(1, 1, ss, s[i].l + 1, s[i].r + 1), 2)); 
		}
		if (s[i].r == k) {
			ans = min(ans, dp[i]);
		}
		change(ss + s[i].r, dp[i]);
	}
	if (ans == INF) {
		printf("-1\n");
		return 0;
	}
	printf("%d\n", ans);
	return 0;
}
