#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>

using namespace std;

vector<int> len;
int n;

bool ok(int k)
{
	map<int, int> letter;

	for (int i = 1; i < n; ++i)
	{
		if (len[i] > len[i - 1])
			continue;

		letter[len[i] - 1]++;

		if (letter[len[i] - 1] == k)
		{
			letter[len[i] - 1] = 0;
			for (auto v = letter.find(len[i] - 1); ;)
			{
				if (v == letter.begin() && (*v).first == 0)
					return 0;
				else if (v == letter.begin())
					letter[(*v).first - 1] = 0;

				auto old = v;
				--v;

				if ((*v).first + 1 < (*old).first){
					letter[(*old).first - 1] = 1;
					break;
				}
				
				(*v).second++;
				if ((*v).second == k)
					(*v).second = 0;
				else
					break;
			}
		}
	}

	return 1;
}
int main()
{
	cin >> n;

	len.resize(n);

	int i;
	for (i = 0; i < n; ++i)
		cin >> len[i];


	int l = 1, r = 268435456;

	while (l != r)
	{
		int m = (l + r) / 2;

		if (ok(m))
			r = m;
		else l = m + 1;
	}

	cout << l;
	return 0;
}