#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <ctime>

using namespace std;

vector<int> len;
int n;
bool des = 0;

bool ok(int k)
{
	if (k == 1)
		return !des;

	map<int, int> letter;

	for (int i = 1; i < n; ++i)
	{
		if (len[i] > len[i - 1])
			continue;

		letter[len[i] - 1]++;

		letter.erase(letter.find(len[i]), letter.end());

		int f = len[i] - 1;

		while (letter[f] == k)
		{
			letter[f] = 0;
			f--;
			if (f == -1) return 0;
			letter[f]++;
		}
	}

	return 1;
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;

	len.resize(n);

	int i;
	for (i = 0; i < n; ++i)
		cin >> len[i];

	for (i = 1; i < n; ++i)
		if (len[i] <= len[i - 1])
			des = 1;

	int l = 1, r = 100001;

	while (l != r)
	{
		int m = (l + r) / 2;


		if (ok(m))
			r = m;
		else l = m + 1;
	}

	cout << l;
	return 0;
}