#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define ss second
#define ff first
int main()
{
	int n, k;
	cin >> n >> k;

	vector<vector<int>> arr(n, vector<int>(3));

	int i;
	for (i = 0; i < n; ++i)
		cin >> arr[i][0] >> arr[i][1] >> arr[i][2];

	vector<pair<int, int>> line;
	for (i = 0; i < n; ++i)
	{
		line.push_back({ arr[i][0] - 1, -(i+1) });
		line.push_back({ arr[i][1], i+1 });
	}

	sort(line.begin(), line.end());
	vector<pair<int, int>> pr(n);
	set<int> hm;

	if (line[0].first != 0)
	{
		cout << -1;
		return 0;
	}

	int best = 1000000000*2 + 3;
	for (int i = 0; i < line.size(); ++i)
	{
		if (line[i].first == 0 && line[i].second < 0)
		{
			hm.insert(-line[i].ss - 1);
			pr[-line[i].ss - 1] = 
			{ arr[-line[i].ss - 1][2], arr[-line[i].ss - 1][2] };
		}
		else if (line[i].second < 0)
		{
			int mx = 1000000000 * 2 + 3;
			for (auto v : hm)
			{
				int tape = (arr[v][1] < arr[-line[i].ss - 1][0]) ?
					0 : pr[v].ss;

				mx = min(mx, max(pr[v].ff, tape + arr[-line[i].ss - 1][2]));
			}

			if (hm.empty())
			{
				cout << -1;
				return 0;
			}
			
			pr[-line[i].ss - 1] = { mx, arr[-line[i].ss - 1][2] };
		}
		else if (line[i].second > 0)
		{
			if (line[i].first == k)
				best = min(best, pr[line[i].ss - 1].ff);
			hm.erase(line[i].second - 1);
		}
	}

	if (best == 1000000000 * 2 + 3)
	{
		cout << -1;
		return 0;
	}
	cout << best;

	return 0;
}