#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1e9 + 7;
const ll Inf = 1e18 + 9;

#define pb push_back
#define mp make_pair
#define F first
#define S second

const int N = 300010;

int n, k, m;

int l[N], r[N], p[N], ind[N];
bool dp[N];
vector <int> s[N];

bool cmp(int i, int j){
    return mp(l[i], r[i]) < mp(l[j], r[j]);
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> k;
    vector <int> v, v1;
    for (int i = 1; i <= n; i++){
        cin >> l[i] >> r[i] >> p[i];
        v.pb(l[i]);
        v.pb(r[i]);
        if (l[i] > 1)
            v.pb(l[i] - 1);
        if (r[i] < k)
            v.pb(r[i] + 1);
    }
    v.pb(1);
    v.pb(k);
    sort(v.begin(), v.end());
    for (int i = 0; i < (int)v.size(); i++)
        if (i == 0 || v[i] != v[i - 1])
            v1.pb(v[i]);
    m = (int)v1.size();
    for (int i = 1; i <= n; i++){
        l[i] = lower_bound(v1.begin(), v1.end(), l[i]) - v1.begin();
        r[i] = lower_bound(v1.begin(), v1.end(), r[i]) - v1.begin();
        s[r[i]].pb(i);
    }
    for (int i = 1; i <= n; i++)
        ind[i] = i;
    sort(ind + 1, ind + n + 1, cmp);
    if (n <= 10){
        ll ans = Inf;
        for (int mask = 0; mask < (1 << n); mask++){
            ll sum[200];
            for (int i = 0; i < m; i++)
                sum[i] = 0;
            for (int i = 0; i < n; i++)
                if (mask & (1 << i))
                    for (int j = l[i + 1]; j <= r[i + 1]; j++)
                        sum[j] += p[i + 1];
            ll ans1 = 0;
            for (int i = 0; i < m; i++){
                if (sum[i] == 0){
                    ans1 = Inf;
                    break;
                }
                ans1 = max(ans1, sum[i]);
            }
            ans = min(ans, ans1);
        }
        if (ans == Inf)
            cout << "-1\n";
        else
            cout << ans << endl;
        return 0;
    }
    int t = 0, j = 1;
    while (t < m){
        int t1 = t - 1;
        for (; j <= n && l[ind[j]] <= t; j++)
        if (r[ind[j]] > t1)
            t1 = r[ind[j]];
        if (t1 == t - 1)
            break;
        t = t1 + 1;
    }
    if (t < m){
        cout << -1 << endl;
        return 0;
    }
    for (int i = 0; i <= m; i++)
        dp[i] = false;
    dp[0] = true;
    for (int i = 1; i <= n; i++)
        dp[r[ind[i]] + 1] = dp[r[ind[i]] + 1] || dp[l[ind[i]]];
    if (dp[m])
        cout << 1 << endl;
    else
        cout << 2 << endl;
    return 0;
}
