#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <cstdio>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(s) s.begin(), s.end() 

ifstream cin("input.txt");
ofstream cout("output.txt");

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;
	vector <int> l(n);
	int MAX_L = 0;
	for (int i = 0; i < n; i++) {
		cin >> l[i];
		MAX_L = max(MAX_L, l[i]);
	}
	vector <int> now(MAX_L);
	int ans = 1;
	for (int i = 0; i < l[0]; i++) {
		now[i] = 1;
	}
	for (int i = 1; i < n; i++) {
		if (l[i] > l[i - 1]) {
			for (int j = l[i - 1]; j < l[i]; j++) {
				now[j] = 1;
			}
			continue;
		}
		else {
			for (int j = l[i]; j < l[i - 1]; j++) {
				now[j] = 0;
			}
			bool fl = false;
			for (int j = l[i] - 1; j >= 0; j--) {
				if (now[j] != ans) {
					now[j]++;
					fl = true;
					break;
				}
			}
			if (fl) {
				continue;
			}
			now[0] = ans++;
			for (int j = 1; j < l[i]; j++) {
				now[j] = 1;
			}
		}
	}

	cout << ans;
	return 0;
}