#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <cstdio>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(s) s.begin(), s.end() 

ifstream cin("input.txt");
ofstream cout("output.txt");

vector <int> l, now;

int n;

bool f(int ans) {
	now.assign(2 * 1e5, 0);
	for (int i = 0; i < l[0]; i++) {
		now[i] = 1;
	}
	for (int j = 1; j < n; j++) {
		if (l[j] > l[j - 1]) {
			for (int i = l[j - 1]; i < l[j]; i++) {
				now[i] = 1;
			}
		}
		else {
			bool fl = false;
			for (int i = l[j]; i < l[j - 1]; i++) {
				now[i] = 1;
			}
			for (int i = l[j] - 1; i >= 0; i--) {
				if (now[i] < ans) {
					now[i]++;
					fl = true;
					break;
				}
				now[i] = 1;
			}
			if (fl) {
				continue;
			}
			return 0;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	
	cin >> n;
	
	l.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	now.resize((int)2 * 1e5);
	int l = 0, r = n + 1;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		if (f(mid)) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	cout << r;
	return 0;
}