#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <cstdio>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(s) s.begin(), s.end() 

ifstream cin("input.txt");
ofstream cout("output.txt");

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	
	int n;
	cin >> n;

	vector <int> voc(4, 0);
	
	string temp;
	cin >> temp;
	for (auto c : temp) {
		if (c == 'L') {
			voc[0]++;
		}
		if (c == 'R') {
			voc[1]++;
		}
		if (c == 'D') {
			voc[2]++;
		}
		if (c == 'U') {
			voc[3]++;
		}
	}
	int x, y;
	cin >> x >> y;
	vector <int> ans(4, 0);
	for (int i = 0; i < n; i++) {
		char now = temp[i];
		if (now == 'L') {
			if (x < 0) {
				x++;
				ans[0] = i + 1;
			}
		}
		if(now == 'R') {
			if (x > 0) {
				x--;
				ans[1] = i + 1;
			}
		}
		if (now == 'D') {
			if (y < 0) {
				y++;
				ans[2] = i + 1;
			}
		}
		if (now == 'U') {
			if (y > 0) {
				y--;
				ans[3] = i + 1;
			}
		}
	}

	if (x != 0 || y != 0) {
		cout << -1;
	}
	else {
		cout << ans[0] << " " << ans[3] << " " << ans[1] << " " << ans[2];
	}
	return 0;
}