#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cstdio>
#include <ctime>
#include <algorithm>

using namespace std;

#define forn (i, s, n) for (int (i) = (s); (i) < (n); ++(i))
#define all(arr) (arr.begin(), arr.end())
#define TASK ""
#define TL 0
#define mp make_pair
#define lucky 13373228

typedef long long ll;
typedef double dbl;

pair<ll, ll> ask(int t) {
	cout << 'X ' << t << endl;
	pair<ll, ll> res;
	cin >> res.first;
	if (res.first == -1) {
		exit(0);
	}
	cin >> res.second;
	return res;
}

void ans(int n) {
	cout << 'N ' << n << endl;
	string s;
	cin >> s;
	if (s == "Wrong") {
		exit(0);
	}
}

int main() {
#ifdef SOLVE	
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif

	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);
	//srand(lucky);

	int g;
	cin >> g;
	for (int i = 0; i < g; ++i) {
		ll l = 1, r = 1e18 + 1;
		while (r - l > 1) {
			ll m = (l + r) / 2;
			pair<ll, ll> answer = ask(m);
			if (m != 0) {
				l = m;
			}
			else {
				r = m;
			}
			l = max(l, answer.second);
		}
		ans(l);
	}

#if TL
	cerr << (dbl)clock() / CLOCKS_PER_SEC << "\n";
#endif

	return 0;
}