#include <fstream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
    const int INF = 2e6;
    //ifstream cin("i-B.txt");
    int n;
    cin >> n;
    vector<int> a(n);
    int curx = 0, cury = 0;
    bool bx = true, by = true;
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        if (c == 'L') {
            a[i] = 0;
        } else if (c == 'U') {
            a[i] = 1;
        } else if (c == 'R') {
            a[i] = 2;
        } else {
            a[i] = 3;
        }
    }
    int x, y;
    cin >> x >> y;
    int ansx = -1, ansy = -1;
    if (x == 0) {
        ansx = 0;
        bx = false;
    }
    if (y == 0) {
        ansy = 0;
        by = false;
    }
    for (int i = 0; i < n; ++i) {
        if (by && (a[i] == 1 || a[i] == 3)) {
            cury += 2 - a[i];
            if (cury == y) {
                ansy = i + 1;
                by = false;
            }
        } else if (bx) {
            curx += a[i] - 1;
            if (curx == x) {
                ansx = i + 1;
                bx = false;
            }
        }
    }
    if (by || bx) {
        cout << -1;
    } else {
        cout << ansx << " " << ansy << " " << ansx << " " << ansy;
    }
    return 0;
}
