#include <fstream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

bool ans(ll n) {
    cout << "N " << n << endl;
    cout.flush();
    string s;
    cin >> s;
    return s == "Wrong";
}

pair<ll,ll> q(ll n) {
    cout << "X " << n << endl;
    cout.flush();
    ll s;
    cin >> s;
    if (s == -1) {
        return make_pair(-1, -1);
    } else {
        ll k;
        cin >> k;
        return {s, k};
    }
}

int main() {
    //ifstream cin("i-D.txt");
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        ll ctr = 2;
        auto j = q(ctr);
        if (j.first == -1) {
            return 0;
        }
        while (j == make_pair(1ll, ctr)) {
            ctr *= 2;
            j = q(ctr);
            if (j.first == -1) {
                return 0;
            }
        }
        pair<ll,ll> t = q(ctr);
        if (t.first == 0) {
            if (ans(ctr / 2)) return 0;
        } else {
            ll a = t.first, b = t.second;
            j = q(b + 1);
            if (j.first == -1) return 0;
            while (j.first > 0) {
                b *= 2;
                j = q(b + 1);
                if (j.first == -1) return 0;
            }
            if (ans(b)) return 0;
        }

    }
    return 0;
}
