#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <queue>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n;
	string s;
	cin >> n >> s;
	vector< vector<int> > back(4, vector<int>(n + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++)
			back[j][i + 1] = back[j][i];
		if (s[i] == 'L')
			back[0][i + 1]++;
		if (s[i] == 'U')
			back[1][i + 1]++;
		if (s[i] == 'R')
			back[2][i + 1]++;
		if (s[i] == 'D')
			back[3][i + 1]++;
	}
	int x, y;
	cin >> x >> y;
	vector<int> ans(4, -1);
	if (x >= 0) {
		ans[0] = 0;
		for (int i = 0; i <= n; i++) {
			if (back[2][i] == abs(x))
				ans[2] = i;
		}
	}
	else {
		ans[2] = 0;
		for (int i = 0; i <= n; i++) {
			if (back[0][i] == abs(x))
				ans[0] = i;
		}
	}

	if (y >= 0) {
		ans[3] = 0;
		for (int i = 0; i <= n; i++) {
			if (back[1][i] == abs(y))
				ans[1] = i;
		}
	}
	else {
		ans[1] = 0;
		for (int i = 0; i <= n; i++) {
			if (back[3][i] == abs(y))
				ans[3] = i;
		}
	}
	for (int i = 0; i < 4; i++) {
		if (ans[i] == -1) {
			cout << -1;
			return 0;
		}
	}
	for (int i : ans)
		cout << i << ' ';

	return 0;
}