#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <queue>
#include <map>

using namespace std;

struct vert {
	int l, r, p;
};

const long long INF = 1e18 + 10;

bool comp(vert a, vert b) {
	return a.l < b.l;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, k;
	cin >> n >> k;
	vector<vert> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].l >> a[i].r >> a[i].p;
		a[i].l--;
		a[i].r--;
	}
	sort(a.begin(), a.end(), comp);
	int mx = -1;
	int now = 0;
	int place = -1;
	bool is = 1;
	while (place < k - 1) {
		while (now < n && a[now].l <= place + 1) {
			if(a[now].l == place + 1)
				mx = max(mx, a[now].r);
			now++;
		}
		if (mx == place) {
			is = 0;
			break;
		}
		place = mx;
	}
	if (is) {
		cout << 1;
		return 0;
	}
	place = -1;
	now = 0;
	mx = -1;
	while (place < k - 1) {
		while (now < n && a[now].l <= place + 1) {
			mx = max(mx, a[now].r);
			now++;
		}
		if (mx == place) {
			cout << -1;
			return 0;
		}
		place = mx;
	}
	cout << 2;

	return 0;
}