#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <queue>
#include <map>

using namespace std;

long long gcd(long long a, long long b) {
	while (a) {
		b %= a;
		swap(a, b);
	}
	return b;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int g;
	cin >> g;
	while (g--) {
		long long now = 1;
		while (true) {
			cout << "X " << (now + 1) << endl;
			long long a, b;
			cin >> a;
			if (a == -1)
				break;
			cin >> b;
			if (a == 0)
				break;
			now = (b / gcd(now, b)) * now;
		}
		cout << "N " << now << endl;
		string s;
		cin >> s;
		if (s != "Correct")
			return 0;
	}
	return 0;
}