#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define f first
#define s second
#define mp make_pair
#define pb push_back

const int maxn = 100500;
const int inf = 2e9;
const double eps = 1e-8;
const int base = 1073676287;

struct node {
	ll x, minSegm, maxSegm;
	node *l, *r;
	node ( ll _x ) {
		x = _x;
		minSegm = _x;
		maxSegm = _x;
		l = r = NULL;
	}
};

typedef node *pnode;

void update( pnode T, int tl, int tr, int l, int r, ll cnt ) {
	if ( l > r )
		return;
	if ( tl == l && tr == r ) {
		T -> x = min( T -> x, cnt );
		T -> minSegm = min( T -> minSegm, cnt );
		T -> maxSegm = min( T -> maxSegm, cnt );
		return;
	}
	int mid = ( tl + tr ) >> 1;
	if ( !T -> l )
		T -> l = new node( T -> x );
	if ( !T -> r )
		T -> r = new node( T -> x );
	update( T -> l, tl, mid, l, min( r, mid ), cnt );
	update( T -> r, mid + 1, tr, max( l, mid + 1 ), r, cnt );
	T -> minSegm = min( T -> l -> minSegm, T -> r -> minSegm );
	T -> maxSegm = max( T -> l -> maxSegm, T -> r -> maxSegm );
}

ll getMin( pnode T, int tl, int tr, int l, int r ) {
	if ( l > r )
		return 1LL * inf * inf;
	if ( tl == l && tr == r )
		return T -> minSegm;
	int mid = ( tl + tr ) >> 1;
	ll ans = 1LL * inf * inf;
	if ( T -> l )
		ans = min( ans, getMin( T -> l, tl, mid, l, min( r, mid ) ) );
	if ( T -> r )
		ans = min( ans, getMin( T -> r, mid + 1, tr, max( mid + 1, l ), r ) );
}

pair < pair < int, int >, int > a[maxn];

pnode T = new node( 1LL * inf * inf );

int main()
{
    srand( time( NULL ) );
    // freopen( "input.txt", "r", stdin );
    // freopen( "output.txt", "w", stdout );
    // ios_base::sync_with_stdio( false );
    int n, k;
    scanf ( "%d%d", &n, &k );
    for ( int j = 0; j < n; j++ )
    	scanf ( "%d%d%d", &a[j].f.f, &a[j].f.s, &a[j].s );
    sort( a, a + n );
    update( T, 0, k, 0, 0, 0 );
    for ( int j = 0; j < n; j++ ) {
    	int l = a[j].f.f;
    	int r = a[j].f.s;
    	int d = a[j].s;
    	ll curC = getMin( T, 0, k, l, r - 1 );
   		// cout << curC << endl;
    	update( T, 0, k, l, r, curC + 1LL * d );
    	curC = getMin( T, 0, k, l - 1, l - 1 );
  	 	// cout << curC << endl;
    	update( T, 0, k, l, r, max( 1LL * d, curC ) );
    }
    ll curC = T -> maxSegm;
    if ( curC == 1LL * inf * inf )
    	puts( "-1" );
    else
    	cout << curC << endl;
    return 0;
}
