#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef double dbl;

template <class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << "\n";
}

struct point{
    dbl x, y;
    point() {this->x = 0; this->y = 0; }
    point(dbl x, dbl y) {this->x = x; this->y = y; }
    point operator+(point p) { return point(x + p.x, y + p.y); }
    point operator-(point p) { return point(x - p.x, y - p.y); }
    point operator*(dbl k) { return point(x * k, y * k); }
    dbl len2() { return x * x + y * y; }
    dbl len() { return sqrt(len2()); }
    void print(){ cout << x << " " << y << "\n"; }
    void read(){
        dbl a, b;
        cin >> a >> b;
        x = a;
        y = b;
    }
};


int main()
{


    /*freopen("test.in", "r", stdin);
    /*freopen("test.out", "w", stdout);/**/
    int n;
    cin >> n;
    string s;
    cin >> s;
    int x, y;
    cin >> x >> y;
    vector<int> pref1(n + 1, 0);
    vector<int> pref2(n + 1, 0);
    vector<int> pref3(n + 1, 0);
    vector<int> pref4(n + 1, 0);
    vector<int> answer(4, n);
    for (int i = n - 1; i >= 0; i--){
        pref1[i] = pref1[i + 1];
        pref2[i] = pref2[i + 1];
        pref3[i] = pref3[i + 1];
        pref4[i] = pref4[i + 1];
        if (s[i] == 'L')
            pref1[i]--;
        if (s[i] == 'R')
            pref2[i]++;
        if (s[i] == 'D')
            pref3[i]--;
        if (s[i] == 'U')
            pref4[i]++;
    }
    int curX = 0;
    int curY = 0;
    for (int i = 0; i < n; i++){
        if (s[i] == 'L'){
            if (answer[0] != n)
                continue;
            if (answer[1] == n){
                if (pref2[i + 1] + curX >= x && curX <= x)
                    answer[0] = i;
                else
                    curX--;
            }
            else{
                if (curX == x)
                    answer[0] = i;
                else
                    curX--;
            }
        }
        if (s[i] == 'R'){
            if (answer[1] != n)
                continue;
            if (answer[0] == n){
                if (pref1[i + 1] + curX <= x && curX >= x)
                    answer[1] = i;
                else
                    curX++;
            }
            else{
                if (curX == x)
                    answer[1] = i;
                else
                    curX++;
            }
        }
        if (s[i] == 'D'){
            if (answer[2] != n)
                continue;
            if (answer[3] == n){
                if (pref4[i + 1] + curY >= y && curY <= y)
                    answer[2] = i;
                else
                    curY--;
            }
            else{
                if (curY == y)
                    answer[2] = i;
                else
                    curY--;
            }
        }
        if (s[i] == 'U'){
            if (answer[3] != n)
                continue;
            if (answer[2] == n){
                if (pref3[i + 1] + curY <= y && curY >= y)
                    answer[3] = i;
                else
                    curY++;
            }
            else{
                if (curY == y)
                    answer[3] = i;
                else
                    curY++;
            }
        }
    }
    if (curX == x && curY == y)
        cout << answer[0] << " " << answer[3] << " " << answer[1] << " " << answer[2] << endl;
    else
        cout << -1 << endl;
    return 0;
}
