#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef double dbl;

template <class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << "\n";
}


const ll INF = 1e9;

struct point{
    int l, r, w;
};

bool cmp(point a, point b){
    if (a.l != b.l)
        return a.l < b.l;
    return a.r > b.r;
}


int main()
{


    /*freopen("test.in", "r", stdin);
    /*freopen("test.out", "w", stdout);/**/
    int n, k;
    cin >> n >> k;
    vector<point> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i].l >> s[i].r >> s[i].w;
        s[i].l--;
        s[i].r--;
    }
    sort(s.begin(), s.end(), cmp);
    int maxi = s[0].r;
    int nextMAX = -1;
    for (int i = 1; i < n; i++){
        if (s[i].l <= maxi + 1)
            nextMAX = max(nextMAX, s[i].r);
        else{
            if (nextMAX <= maxi){
                cout << -1 << endl;
                return 0;
            }
            maxi = nextMAX;
            nextMAX = -1;
        }
    }
    if (maxi < k - 1 && nextMAX < k - 1){
        cout << -1 << endl;
        return 0;
    }
    int answer = 2;
    int cur = 0;
    set<int> can;
    can.insert(0);
    while (cur < n && can.size() > 0){
        int v = *(can.begin());
        can.erase(v);
        while (cur < n && s[cur].l < v)
            cur++;
        while (cur < n && s[cur].l == v){
            if (s[cur].r == k - 1){
                cout << 1 << endl;
                return 0;
            }
            can.insert(s[cur].r + 1);
            cur++;
        }
    }
    cout << answer << endl;
    return 0;
}
