#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef double dbl;

template <class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << "\n";
}

struct point{
    dbl x, y;
    point() {this->x = 0; this->y = 0; }
    point(dbl x, dbl y) {this->x = x; this->y = y; }
    point operator+(point p) { return point(x + p.x, y + p.y); }
    point operator-(point p) { return point(x - p.x, y - p.y); }
    point operator*(dbl k) { return point(x * k, y * k); }
    void print(){ cout << x << " " << y << "\n"; }
    void read(){
        dbl a, b;
        cin >> a >> b;
        x = a;
        y = b;
    }
};


int main()
{


    /*freopen("test.in", "r", stdin);
    /*freopen("test.out", "w", stdout);/**/
    int q;
    cin >> q;
    vector<ll> power(61, 1);
    for (int i = 1; i < 61; i++)
        power[i] = power[i - 1] * 2;
    for (int i = 0; i < q; i++){
        int l = 0;
        int r = 61;
        ll last = 0;
        while (l + 1 < r){
            int m = (l + r) / 2;
            cout << "X " << power[m] << "\n";
            cout.flush();
            ll a, b;
            cin >> a >> b;
            if (b == power[m])
                l = m;
            else{
                r = m;
                last = b;
            }
        }
        if (last == 0)
            return 1;
        while (last % 2 == 0)
            last /= 2;
        cout << "N " << last * power[l] << "\n";
        cout.flush();
        string s;
        cin >> s;
    }
    return 0;
}
