#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#include <tuple>
#define INF 1791791791791791791
using namespace std;
int main()
{
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> a(n);
	for (int i = 0; i < n; ++i)
		cin >> get<0>(a[i]) >> get<1>(a[i]) >> get<2>(a[i]);
	sort(a.begin(), a.end());
	vector<pair<long long, int>> dp(n, { INF, -1 });
	for (int i = 0; i < n; ++i) {
		if (get<0>(a[i]) == 1) {
			dp[i] = { get<2>(a[i]), -1 };
		}
	}
	for (int i = 0; i < n; ++i) {
		if (dp[i].first < INF) {
			for (int j = i + 1; j < n; ++j) {
				if (get<1>(a[i]) + 1 >= get<0>(a[j]) && (dp[i].second == -1 || get<0>(a[j]) > get<1>(a[dp[i].second]))) {
					if (get<1>(a[i]) + 1 == get<0>(a[j]))
						dp[j] = min(dp[j], make_pair(max(dp[i].first, (long long)get<2>(a[j])), i));
					else
						dp[j] = min(dp[j], make_pair(max(dp[i].first, (long long)get<2>(a[j]) + get<2>(a[i])), i));
				}
			}
		}
	}
	long long ans = INF;
	for (int i = 0; i < n; ++i) {
		if (get<1>(a[i]) == k)
			ans = min(ans, dp[i].first);
	}
	cout << (ans == INF ? -1 : ans);
}
