#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#include <tuple>
#include <map>
#define INF 1791791791791791791
using namespace std;
int main()
{
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> a(n);
	bool sl = true;
	for (int i = 0; i < n; ++i) {
		cin >> get<0>(a[i]) >> get<1>(a[i]) >> get<2>(a[i]);
		sl &= get<2>(a[i]) == 1;
	}
	sort(a.begin(), a.end());
	sl = false;
	if (sl) {
		set<int> st;
		st.insert(0);
		for (int i = 0; i < n; ++i) {
			if (st.count(get<0>(a[i]) - 1))
				st.insert(get<1>(a[i]));
		}
		if (st.count(k))
			cout << 1;
		else {
			set<int> open;
			int pr = 0;
			for (int i = 0; i < n; ++i) {
				while (open.size() && *open.begin() < get<0>(a[i])) {
					pr = *open.begin();
					open.erase(open.begin());
				}
				if (pr + 1 < get<0>(a[i]) && open.empty()) {
					cout << -1;
					return 0;
				}
				open.insert(get<1>(a[i]));
			}
			cout << (open.count(k) ? 2 : -1);
		}
	}
	else {
		vector<pair<long long, int>> dp(n, { INF, -1 });
		set<pair<long long, int>> op, opd, opz, opzd;
		set<int> opc;
		map<int, vector<int>> opo;
		for (int i = 0; i < n; ++i) {
			if (get<0>(a[i]) == 1) {
				dp[i] = { get<2>(a[i]), -1 };
				opc.insert(i);
				op.insert({ dp[i].first, i });
				opd.insert({ get<1>(a[i]), i });
			}
		}
		for (int i = 0; i < n; ++i) {
			/*if (dp[i].first < INF) {
				for (int j = i + 1; j < n; ++j) {
					if (get<1>(a[i]) + 1 >= get<0>(a[j]) && (dp[i].second == -1 || get<0>(a[j]) > get<1>(a[dp[i].second]))) {
						if (get<1>(a[i]) + 1 == get<0>(a[j]))
							dp[j] = min(dp[j], make_pair(max(dp[i].first, (long long)get<2>(a[j])), i));
						else
							dp[j] = min(dp[j], make_pair(max(dp[i].first, (long long)get<2>(a[j]) + get<2>(a[i])), i));
					}
				}
			}*/
			while (opd.size() && opd.begin()->first < get<0>(a[i])) {
				int x = opd.begin()->second;
				opz.insert({ dp[x].first, x });
				opzd.insert(*opd.begin());
				opc.erase(x);
				op.erase({ dp[x].first, x });
				opd.erase(opd.begin());
				for (const auto & y : opo[x]) {
					opc.insert(y);
					op.insert({ dp[y].first, y });
					opd.insert({ get<1>(a[y]), y });
				}
			}
			while (opzd.size() && opzd.begin()->first + 1 < get<0>(a[i])) {
				int x = opzd.begin()->second;
				opz.erase({ dp[x].first, x });
				opzd.erase(opzd.begin());
			}
			if (opz.size()) {
				dp[i] = *opz.begin();
			}
			if (op.size()) {
				dp[i] = min(dp[i], make_pair(op.begin()->first + get<2>(a[i]), op.begin()->second));
			}
			if (opc.count(dp[i].second))
				opo[dp[i].second].push_back(i);
			else {
				opc.insert(i);
				op.insert({dp[i].first, i});
				opd.insert({ get<1>(a[i]), i });
			}
		}
		long long ans = INF;
		for (int i = 0; i < n; ++i) {
			if (get<1>(a[i]) == k)
				ans = min(ans, dp[i].first);
		}
		cout << (ans == INF ? -1 : ans);
	}
}
