#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define fr first
#define sc second
#define next nxt

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

//length, continue, break,getline

const int maxn = 2e5 + 55;
const int inf = 1e9;
const double eps = 1e-7;
const int base = 1e9 + 9;
const ll basell = 1000000000000000003;

int a[maxn];
int n;
int s[5001];

bool update(int x, int l){
	for(int i = 0; i < l; i++)
		if(s[i] == 0){
			s[i] = 1;
			for(int j = i + 1; j < l; j++)
                s[j] = 1;
			return 1;
		}
	for(int i = l; i < 5001; i++)
		s[i] = 0;
	s[l - 1]++;
	for(int i = l - 1; i > 0; i--){
		if(s[i] > x){
			s[i] = 1;
			s[i - 1]++;
		}
		else
			return 1;
	}
	if(s[0] <= x)
		return 1;
	return 0;
}

bool check(int x){
	int i = 1;
	s[0] = 1;
	for(int i = 1; i < a[0]; i++)
        s[i] = 1;
    for(int i = a[0]; i < 5001; i++)
        s[i] = 0;
	for(i = i; i < n; i++){
		if(!update(x, a[i]))
			return 0;
	}
	return 1;
}

pair<int, int> q[maxn];

bool checkfast(int x){
    int qs = 0, ql;
    int ans = x;
    q[0] = mp(1, a[0]);
    ql = a[0];
    for(int i = 1; i < n; i++){
        if(ql < a[i]){
            if(q[qs].fr == 1){
                q[qs].sc += (a[i] - ql);
                ql = a[i];
            }
            else{
                qs++;
                q[qs] = mp(1, a[i] - ql);
                ql = a[i];
            }
        }
        else if(ql == a[i]){
            if(q[qs].fr != ans){
                q[qs].sc--;
                if(q[qs].sc != 0){
                    qs++;
                    q[qs] = mp(q[qs - 1].fr + 1, 1);
                }
                else{
                    q[qs] = mp(q[qs].fr + 1, 1);
                    if(qs > 0 && q[qs].fr == q[qs - 1].fr){
                        q[qs - 1].sc ++;
                        qs--;
                    }
                }
            }
            else if(qs > 0 && ans > 1){
                if(ans == q[qs].fr){
                    int f = q[qs].sc;
                    q[qs] = mp(q[qs - 1].fr + 1, 1);
                    q[qs - 1].sc--;
                    if(q[qs - 1].sc == 0){
                        q[qs - 1] = q[qs];
                        if(qs > 1 && q[qs - 2].fr == q[qs - 1].fr){
                            q[qs - 2].sc++;
                            qs--;
                            q[qs] = mp(1, f);
                        }
                        else{
                            q[qs] = mp(1, f);
                        }
                    }
                    else{
                        qs++;
                        q[qs] = mp(1, f);
                    }
                }

            }
            else{
                ans++;
                if(ql == 1){
                    qs = 0;
                    q[0] = mp(ans, 1);
                }
                else{
                    qs = 1;
                    q[0] = mp(ans - 1, ql - 1);
                    q[1] = mp(ans, 1);
                }
            }
        }
        else{
            while(ql - q[qs].sc >= a[i]){
                ql -= q[qs].sc;
                qs--;
            }
            if(q[qs].fr != ans){
                q[qs].sc -= (ql - a[i] + 1);
                if(q[qs].sc == 0){
                    q[qs] = mp(q[qs].fr + 1, 1);
                }
                else{
                    qs++;
                    q[qs] = mp(q[qs - 1].fr + 1, 1);
                }
            }
            else if(q[qs].sc != ql){
                if(q[qs - 1].fr != q[qs].fr){
                    q[qs - 1].sc--;
                    q[qs + 1] = q[qs];
                    q[qs + 1].sc--;
                    q[qs] = mp(q[qs - 1].fr + 1, 1);
                    if(q[qs + 1].sc != 0)
                        qs++;
                }
            }
            else{
                q[0] = mp(q[0].fr, q[0].sc - 1);
                int i = 1;
                if(q[0].sc == 0)
                    i--;
                q[i] = mp(ans + 1, 1);
                ans++;
            }
        }
    }
    if(ans != x)
        return 0;
    return 1;
}

int main()
{
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
     cin >> n;
//    n = 5;
    int maxa = 0;
    for(int i = 0; i < n; i++){
    	 cin >> a[i];
//    	a[i] = 2;
    	maxa = max(maxa, a[i]);
    }
    // if(maxa <= 5000){
    	/*int l = 1, r = 5000, m;
	    while(l < r){
	    	m = (l + r)/2;
	    	if(check(m)){
	    		r = m;
	    	}
	    	else
	    		l = m + 1;
	    }
	    cout << l << "\n";*/
	    // return 0;
	// }
	// else{
        int l = 1, r = 2e5, m;
        checkfast(3);
	    while(l < r){
	    	m = (l + r)/2;
	    	if(checkfast(m)){
	    		r = m;
	    	}
	    	else
	    		l = m + 1;
	    }
		cout << l;
	//}
    return 0;
}
