#include <bits/stdc++.h>

using namespace std;

struct seg
{
	int l, r, p;
	seg(int l, int r, int p)
		: l(l), r(r), p(p)
	{}

	bool operator <(seg b) const
	{
		return r < b.r;
	}
};

int main()
{
	int n, k;
	cin >> n >> k;
	map<int, vector<int>> ends;
	vector<seg> v;
	int mxp = 1;
	for (int i = 0; i < n; ++i)
	{
		int l, r, p;
		cin >> l >> r >> p;
		--l;
		ends[l].push_back(r);
		mxp = max(mxp, p);
		v.push_back(seg(l, r, p));
	}
	map<int, bool> dp;
	dp[0] = true;
	vector<int> q(1, 0);
	for (int i = 0; i < q.size(); ++i)
	{
		int x = q[i];
		for (int e : ends[x])
		{
			if (!dp[e])
				dp[e] = true, q.push_back(e);
		}
	}
	int mx = 0;
	for (auto& p : ends)
	{
		if (p.first > mx)
		{
			cout << -1 << endl;
			return 0;
		}
		for (int e : p.second)
			mx = max(mx, e);
	}
	if (mx < k)
	{
		cout << -1 << endl;
		return 0;
	}
	if (n > 3000)
	{
		if (dp[k])
			cout << 1 << endl;
		else
			cout << 2 << endl;
		return 0;	
	}
	sort(v.begin(), v.end());
	vector<vector<int>> ans(n);
	vector<vector<int>> prev_c(n);
	int INF = INT_MAX;
	vector<int> ar(n, INF);
	int mn = INF;
	for (int i = 0; i < n; ++i)
	{
		if (v[i].l == 0)
		{
			ans[i].push_back(v[i].p);
			prev_c[i].push_back(-1);
		}
		for (int j = 0; j < i; ++j)
		{
			if (v[j].r < v[i].l)
				continue;
			int a = INF;	
			int ind = ans[j].size() - 1;
			if (ind != -1)
			{
				if (v[j].r == v[i].l)
				{
					a = min(a, max(ans[j][ind], v[i].p));
				}
				else
				{
					a = min(a, max(ans[j][ind], v[i].p + v[j].p));
				}
			}
			a = ar[j];
			if (a < INF)
			{
				ans[i].push_back(a);
				prev_c[i].push_back(v[j].r);
			}
		}
		for (int k1 = 0; k1 < ans[i].size(); ++k1)
		{
			if (v[i].r == k)
			{
				mn = min(mn, ans[i][k1]);
			}
		}
		int mxpr = -100, mxans = -100;
		for (int l = 0; l < ans[i].size(); ++l)
			if (prev_c[i][l] > mxpr || prev_c[i][l] == mxpr && ans[i][l] > mxans)
				mxpr = prev_c[i][l], mxans = ans[i][l];
		ar[i] = mxans;
		vector<pair<int, int>> keks;
		for (int l = 0; l < ans[i].size(); ++l)
		{
			keks.push_back({prev_c[i][l], -ans[i][l]});
		}
		sort(keks.begin(), keks.end());
		for (auto& x : keks)
			x.second *= -1;
		ans[i].clear();
		prev_c[i].clear();
		for (auto x : keks)
		{
			if (ans[i].empty() || x.second > ans[i].back())
				ans[i].push_back(x.second), prev_c[i].push_back(x.first);
		}
	}
	cout << mn << endl;	


}
