#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

typedef long long ll;

ll INF = (ll) 1e18 + 42;
ll PART = (ll) 1e3;

void inter(ll n, bool ask = true) {
    if (ask) {
        cout << "X " << n << endl;
    } else {
        cout << "N " << n << endl;
    }
}

int main() {
    int g;
    cin >> g;
    for (int i = 0; i < g; ++i) {
        ll now = INF;
        ll a, b;
        int cnt = 0;
        ll maxi = now;
        while (true) {
            ++cnt;
            now /= PART;
            if (now == 1) {
                break;
            }
            inter(now);
            cin >> a;
            if (a == -1) {
                return 0;
            }
            cin >> b;
            if (a) {
                break;
            }
            maxi = now;
        }
        if (b == 1 && now != 1) {
            inter(now, false);
            system("pause");
            return 0;
        }
        vector<ll> nums;
        for (ll i = 1; b * i <= maxi; ++i) {
            nums.push_back(b * i);
        }
        int l = 0, r = nums.size();
        while (l < r - 1) {
            int m = (l + r) / 2;
            inter(nums[m]);
            cin >> a;
            if (a == -1) {
                return 0;
            }
            cin >> b;
            if (a == 0) {
                r = m;
            } else {
                l = m;
            }
        }
        inter(nums[l], false);
        string s;
        cin >> s;
//        system("pause");
    }
    return 0;
}