#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define int long long
typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <pii> vpii;
typedef pair <ll, ll> pll;
typedef vector <ll> vll;
typedef long double ld;

const int N = (int)2e5 + 10;
const int INF = (int)1e9 + 10;
const int mod = (int)1e9 + 7;
const ll LLINF = (int)1e18 + 10;
const ld pi = acos(-1.0);

template <typename T> bool umin(T &x, const T y) {if(x>y)return x=y, true; else return false;}
template <typename T> bool umax(T &x, const T y) {if(x<y)return x=y, true; else return false;}

template <typename T>
T getint() {
    char c = getchar(); int x = 0, p = 1;
    while(c == ' ' || c == '\n')
        c = getchar();
    if(c == '-') c = getchar(), p = -1;
    while(c >= '0' && c <= '9') {
        x = x * 10 + c - '0';
        c = getchar();
    }
    return x * p;
}

struct segment{
    int l, r, p;
    segment() {l = 0, r = 0, p = 0;}
    friend bool operator <(segment a, segment b) {
        if(a.r < b.r) return true;
        if(a.r == b.r && a.l < b.l) return true;
        if(a.r == b.r && a.l == b.l && a.p < b.p) return true;
        return false;
    }
};

int n, m;
segment s[N];
int dp[N], p[N];

 main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m;
    for(int i = 1; i <= n; ++i) {
        cin >> s[i].l >> s[i].r >> s[i].p;
    }
  //  condens();
    sort(s + 1, s + n + 1);
    for(int i = 1; i <= n; ++i) {
        dp[i] = LLINF;
        for(int j = 0; j < i; ++j) {
            if(s[j].r + 1 == s[i].l) {
                if(dp[j] == LLINF) continue;
                umin(dp[i], max(dp[j], s[i].p));
            }
            if(s[j].r >= s[i].l) {
                if(dp[j] == LLINF) continue;
                if(s[p[j]].r + 1 >= s[i].l && j) continue;
                if(umin(dp[i], max(dp[j], s[j].p + s[i].p)))
                    p[i] = j;
            }
        }
    }
    int ans = LLINF;
    for(int i = 1; i <= n; ++i) {
        if(s[i].r == m) umin(ans, dp[i]);
    }
    cout << (ans != LLINF ? ans : -1);
    return 0;
}
