#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define fst first
#define snd second
#define sz(a_) (int((a_).size()))
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;

constexpr int maxn = 2e5;

struct req {
    int l, r, p;
};

req rs[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> rs[i].l >> rs[i].r >> rs[i].p;
        --rs[i].l;
    }
    set<int> ce;
    ce.insert(0);
    sort(rs, rs+n, [](const req &a, const req &b) {
            return a.r < b.r;
         });
    for (int i = 0; i < n; ++i) {
        if (ce.count(rs[i].l) > 0) {
            ce.insert(rs[i].r);
        }
    }
    if (ce.count(k) > 0) {
        cout << "1\n";
        return 0;
    }
    if (rs[0].l > 0 || rs[n-1].r < n) {
        cout << "0\n";
        return 0;
    }
    for (int i = 1; i < n; ++i) {
        if (rs[i].l > rs[i-1].r) {
            cout << "0\n";
            return 0;
        }
    }
    cout << "2\n";
    return 0;
}
