#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define fst first
#define snd second
#define sz(a_) (int((a_).size()))
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;

constexpr int maxn = 2e5;

pair<int, int> rs[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, g;
    cin >> n >> k;
    bool y = 0;
    for (int i = 0; i < n; ++i) {
        cin >> rs[i].snd >> rs[i].fst >> g;
        --rs[i].snd;
        if (rs[i].snd == 0) {
            y = 1;
        }
    }
    sort(rs, rs+n);
    if (!y || rs[n-1].fst < k) {
        cout << "-1\n";
        return 0;
    }
    for (int i = 1; i < n; ++i) {
        if (rs[i].snd > rs[i-1].fst) {
            cout << "-1\n";
            return 0;
        }
    }
    set<int> ce;
    ce.insert(0);
    for (int i = 0; i < n; ++i) {
        if (ce.count(rs[i].snd) > 0) {
            ce.insert(rs[i].fst);
         }
    }
    if (ce.count(k) > 0) {
        cout << "1\n";
        return 0;
    }
    cout << 1/0 <<endl;
    return 0;
}
