/*#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define fst first
#define snd second
#define sz(a_) (int((a_).size()))
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;

constexpr int maxn = 2e5;

pair<int, int> rs[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, g;
    cin >> n >> k;
    bool y = 0;
    for (int i = 0; i < n; ++i) {
        cin >> rs[i].snd >> rs[i].fst >> g;
        --rs[i].snd;
        if (rs[i].snd == 0) {
            y = 1;
        }
    }
    sort(rs, rs+n);
    if (!y || rs[n-1].fst < k) {
        cout << "-1\n";
        return 0;
    }
    for (int i = 1; i < n; ++i) {
        if (rs[i].snd > rs[i-1].fst) {
            cout << "-1\n";
            return 0;
        }
    }
    set<int> ce;
    ce.insert(0);
    for (int i = 0; i < n; ++i) {
        if (ce.count(rs[i].snd) > 0) {
            ce.insert(rs[i].fst);
         }
    }
    if (ce.count(k) > 0) {
        cout << "1\n";
        return 0;
    }
    cout << "2\n";
    return 0;
}*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

#define fst first
#define snd second
#define sz(a_) (int((a_).size()))
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;

constexpr ll ul = 1e18;

ll f(ll l, ll r, ll k)
{
    long double cnt = r-l;
    long double t = min(0.2, k/10000.);
    return (ll((r-l)*t)+l+1)*k;
}

int main()
{
    int g;
    cin >> g;
    for (int w = 0; w < g; ++w) {
        ll l = 1, r = ul+1, k = 1;
        while (r-l > 1) {
            //cout << l << ' ' << r << ' ' << k << endl;
            ll m = f(l, r, k);
            cout << "X " << m << endl;
            ll a, b;
            cin >> a;
            if (a == -1) {
                return 0;
            }
            cin >> b;
            if (a == 0) {
                r = m/k;
            } else {
                ll ro = r*k, lo = l*k;
                k = b;
                l = -1;
                r = -1;
                for (ll e = max(lo/b, 1ll); e*b < ro; ++e) {
                    if ((e*b)/m == a*e) {
                        if (l == -1) {
                            l = e;
                        }
                        r = e;
                    } else if (r != -1) {
                        break;
                    }
                }
                ++r;
            }
        }
        cout << "N " << l*k << endl;
        string s;
        cin >> s;
        if (s[0] == 'W') {
            return 0;
        }
    }
    return 0;
}

