import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

/**
 * Created by olymp on 10.03.2017.
 */
public class qwe {
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new qwe().run();
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    void solve() throws IOException {
        int q = nextInt();
        for (int qq = 0; qq < q; qq++) {
            long l = 1, r = 1000000000000000001l;
            while (r - l > 1) {
                long mid = (l + r) / 2;
                out.println("X " + mid);
                out.flush();
                long x = nextLong(), y = nextLong();
                if(x == 0 && y == 1){
                    r = mid;
                }else l = mid;
            }
            out.println("N " + l);
            out.flush();
            String s= nextToken();
        }
    }
}
