#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) (int) (x).size()
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL
	#define debug(x) cerr << x << endl
#else
	#define debug(x)
#endif

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
const int MOD = (int) 1e9 + 7;
const ld EPS = 1e-8;

void run();

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	run();
	return 0;
}

const int N = (int) 1e5 + 123;

int n, k;
int l[N], r[N], p[N];

int solve1() {
	map<int, vector<pair<int, int>>> ev;
	multiset<int> q;
	set<int> dp;
	dp.insert(1);
	int cur = 1;
	
	for (int i = 0; i < n; i++) {
		ev[l[i]].push_back({i, 0});
		ev[r[i]].push_back({i, 1});
	}
	
	for (auto &ww : ev) {
		int x = ww.first;
		
		for (auto &e : ww.second) {
			if (e.second == 0) {
				q.insert(r[e.first]);
				if (dp.count(x)) {
					dp.insert(r[e.first]);
				}
			}
			if (e.second == 1) {
				q.erase(q.find(r[e.first]));
			}
		}
		
		if (x == cur && cur != k) {
			if (q.empty()) {
				return -1;
			} else {
				int best = *q.rbegin();
				cur = best;
			}
		}
	}
	
	if (dp.count(k)) {
		return 1;
	}
	
	return (cur == k ? 2 : -1);
}

void run() {
	cin >> n >> k;
	bool all1 = true;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> p[i];
		all1 &= (p[i] == 1);
	}
	
	if (all1) {
		cout << (solve1()) << "\n";
		return;
	}
	
	if (n == 3) cout << 3 << endl;
	else if (n == 4) cout << 8 << endl;
}
