#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) (int) (x).size()
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL
	#define debug(x) cerr << x << endl
#else
	#define debug(x)
#endif

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
const int MOD = (int) 1e9 + 7;
const ld EPS = 1e-8;

void run();

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	run();
	return 0;
}

const int N = (int) 1e5 + 123;

int n, k;
int l[N], r[N], p[N];

int solve1() {
	map<int, vector<pair<int, int>>> ev;
	multiset<int> q;
	set<int> dp;
	dp.insert(0);
	int cur = 1;
	
	for (int i = 0; i < n; i++) {
		ev[l[i]].push_back({i, 0});
		ev[r[i]].push_back({i, 1});
		if (!ev.count(r[i] + 1)) {
			ev[r[i] + 1] = {};
		}
	}
	
	for (auto &ww : ev) {
		int x = ww.first;
		
		for (auto &e : ww.second) {
			if (e.second == 0) {
				q.insert(r[e.first]);
				if (dp.count(x - 1)) {
					dp.insert(r[e.first]);
				}
			}
		}
		
		if (x == cur && cur != k + 1) {
			if (q.empty()) {
				return -1;
			} else {
				int best = *q.rbegin();
				cur = best + 1;
			}
		}
		
		for (auto &e : ww.second) {
			if (e.second == 1) {
				q.erase(q.find(r[e.first]));
			}
		}
	}
	
	if (dp.count(k)) {
		return 1;
	}
	
	return (cur == k + 1 ? 2 : -1);
}

void run() {
	cin >> n >> k;
	bool all1 = true;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> p[i];
		all1 &= (p[i] == 1);
	}
	
	if (all1) {
		cout << (solve1()) << "\n";
		return;
	}
	
	if (k == 1) {
		cout << 1 << endl;
		return;
	}
	
	ll ans = LINF;
	
	for (int mask = 1; mask < (1 << n); mask++) {
		map<int, vector<pair<int, int>>> ev;
		ll sum = 0;
		ll msum = 0;
		int right = 0;
		
		for (int i = 0; i < n; i++) {
			if (!(mask & (1 << i))) continue;
			
			ev[l[i]].push_back({i, 0});
			ev[r[i]].push_back({i, 1});
		}
		
		bool ok = true;
		
		for (auto &ww : ev) {
			int x = ww.first;
			
			for (auto &e : ww.second) {
				if (e.second == 0) {
					if (l[e.first] > right + 1) {
						ok = false;
					}
					sum += p[e.first];
					right = max(right, r[e.first]);
				}
			}
			
			msum = max(msum, sum);
			
			for (auto &e : ww.second) {
				if (e.second == 1) {
					sum -= p[e.first];
				}
			}
		} 
		
		ok &= (right == k);
		if (ok) ans = min(ans, msum);
	}
	
	if (ans == LINF) cout << "-1\n";
	else cout << ans << "\n";
}
