#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) (int) (x).size()
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL
	#define debug(x) cerr << x << endl
#else
	#define debug(x)
#endif

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
const int MOD = (int) 1e9 + 7;
const ld EPS = 1e-8;

void run();

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	run();
	return 0;
}

const int N = (int) 1e5 + 123;

bool p[N];

pair<ll, ll> ask(ll t) {
	cout << "X " << t << endl;
	pair<ll, ll> res;
	cin >> res.first;
	if (res.first == -1) {
		exit(0);
	}
	cin >> res.second;
	return res;
}

void ans(ll x) {
	cout << "N " << x << endl;
	string res;
	cin >> res;
	if (res != "Correct") {
		exit(0);
	}
}

void solve() {
	ll left = 1;
	ll right = (ll) 1e18 + 1;
	
	while (right - left > 1) {
		ll mid = (left + right) / 2;
		auto res = ask(mid);
		if (res.first == 0) {
			right = mid;
		} else {
			left = mid;
		}
	}
	
	ans(left);
}

void run() {
	for (int i = 2; i < N; i++) {
		if (!p[i]) {
			for (int j = i + i; j < N; j += i) {
				p[j] = 1;
			}
		}
	}
	
	int g;
	cin >> g;
	
	for (int i = 0; i < g; i++) {
		solve();
	}
}
