#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main()
{
	int n;
	cin >> n;
	string s;
	cin >> s;
	int x, y;
	cin >> x >> y;
	vector<int> ans(n, n);
	vector<bool> good(n, false);
	int curx = 0, cury = 0;
	int left = 0, right = 0, up = 0, down = 0;
	for (auto elem : s)
	{
		if (elem == 'U')
		{
			++cury;
			++up;
		}
		else if (elem == 'D')
		{
			--cury;
			++down;
		}
		else if (elem == 'R')
		{
			++curx;
			++right;
		}
		else
		{
			--curx;
			++left;
		}
	}
	if (curx > x)
		right -= curx - x;
	else
		left -= x - curx;
	if (cury > y)
		up -= cury - y;
	else
		down -= y - cury;
	if (right < 0 || left < 0 || up < 0 || down < 0)
	{
		std::cout << -1 << '\n';
		return 0;
	}
	int ansleft = n, ansright = n, ansup = n, ansdown = n;
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == 'U')
		{
			if (up > 0)
				--up;
			else if (ansup == n)
				ansup = i;
		}
		if (s[i] == 'D')
		{
			if (down > 0)
				--down;
			else if (ansdown == n)
				ansdown = i;
		}
		if (s[i] == 'L')
		{
			if (left > 0)
				--left;
			else if (ansleft == n)
				ansleft = i;
		}
		if (s[i] == 'R')
		{
			if (right > 0)
				--right;
			else if (ansright == n)
				ansright = i;
		}
	}
	std::cout << ansleft << " " << ansup << " " << ansright << " " << ansdown;
	return 0;
}

