#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> par;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef long double ld;
typedef vector<bool> vbool;
typedef vector<par> vpar;

#define _ inline
#define forn(i, b, n) for(ll i = b; i < n; ++i)
#define rforn(i, b, n) for(ll i = b; i >= n; --i)
#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define pw(n) (1ll << (n))
#define mp make_pair
#define pushb push_back

_ ll logn(ll n) {
	ll x = ll(log2(double(n)));
	if (pw(x) != n) ++x;
	return x;
}

/*
struct SGTree {
	ll size;
	vll t, add;

	_ void build(ll n) {
		size = pw(logn(n));
		t.assign(size * 2, 0);
		add.assign(size * 2, 0);
	}

	_ ll push(ll i) {
		if (add[i]) {
			t[i] = add[i];
			if (i < size) add[i * 2] = add[i * 2 + 1] = add[i];
			add[i] = 0;
		}
	}

	void modify(ll i, ll l, ll r, ll L, ll R, ll x) {
		push(i);
		if (l >= R || L >= r) return;
		if (l >= L && R >= r) {
			add[i] = x;
			push(i);
			return;
		}
		ll m = (l + r) / 2;
		modify(i * 2, l, m, L, R, x);
		modify(i * 2 + 1, m, r, L, R, x);
		t[i] = max(t[i * 2], t[i * 2 + 1]);
	}

	ll get(ll i, ll l, ll r) {
		if (l == r - 1) {
			push(i);
			return t[i];
		}
		ll m = (l + r) / 2;
		ll ans;
		if (m > i) ans = get(i * 2, l, m);
		else ans = get(i * 2, m, r);
		return ans;
	}
};
*/

int source() {
	ll n;
	scanf("%lld", &n);
	vll a(n);
	ll maxi = 0;
	forn(i, 0, n) {
		scanf("%lld", &a[i]);
		maxi = max(maxi, a[i]);
		a[i]--;
	}
	ll l = 0, r = n;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		bool ans = 1;
		vll d(maxi, 0);
		ll curlen = -1;
		forn(i, 0, n) {
			ll len = a[i];
			if (len > curlen) {
				curlen = len;
				continue;
			}
			forn(j, len + 1, curlen) d[i] = 0;
			curlen = len;
			ll curpos = len;
			bool z = 1;
			while (curpos >= 0) {
				d[curpos]++;
				if (d[curpos] < m) {
					z = 0;
					break;
				}
				curpos--;
			}
			if (z) {
				ans = 0;
				break;
			}
		}
		if (ans) r = m;
		else l = m;
	}
	printf("%lld", r);
	return 0;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	srand('1');
	//ios::sync_with_stdio(0);
	source();
	return 0;
}