#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> par;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef long double ld;
typedef vector<bool> vbool;
typedef vector<par> vpar;

#define _ inline
#define forn(i, b, n) for(ll i = b; i < n; ++i)
#define rforn(i, b, n) for(ll i = b; i >= n; --i)
#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define pw(n) (1ll << (n))
#define mp make_pair
#define pushb push_back

_ ll logn(ll n) {
	ll x = ll(log2(double(n)));
	if (pw(x) != n) ++x;
	return x;
}

struct req {
	ll pos, type, p, i;
	req() {}
	req(ll type, ll pos, ll p, ll i) : type(type), pos(pos), p(p), i(i) {}
};

bool operator < (req a, req b) {
	return (a.pos < b.pos) || (a.pos == b.pos && a.type < b.type);
}

_ void error() {
	cout << -1;
	exit(0);
}

int source() {
	ll n, k;
	cin >> n >> k;
	vector<par> orig(n);
	vll c(n);
	vector<req> a;
	bool flag = 1;
	forn(i, 0, n) {
		cin >> orig[i].F >> orig[i].S >> c[i];
		--orig[i].first, --orig[i].S;
		a.push_back(req(-1, orig[i].F, c[i], i));
		a.push_back(req(1, orig[i].S, c[i], i));
		if (c[i] != 1) flag = 0;
	}
	/*
	if (flag) {

		//For p == 1 for nlogn
		sort(all(a));
		if (a[0].pos != 0) error();
		if (a.back().pos != k - 1) error();
		set<ll> s;
		vector<par> tmp;
		tmp.push_back(par(0, 0));
		tmp.push_back(par(k, k));
		forn(i, 0, a.size()) {
			if (i && a[i - 1].pos != a[i].pos && s.empty()) error();
			if (a[i].type == -1) s.insert(a[i].i);
			else s.erase(a[i].i);
			if (s.size() == 1) tmp.push_back(orig[a[i].i]);
			
		}
		sort(all(tmp));

		vector<req> ans;
		sort(all(ans));
		ll k = 0;
		ll ansk = 0;
		forn(i, 0, ans.size()) {
			if (ans[i].type == -1) ++k;
			else --k;
			ansk = max(ansk, k);
		}
		cout << ansk;
	} else {
	*/
		
		// 2^n * nlogn

		ll mini = 1e18;
		ll maxn = pw(n);
		forn(mask, 0, maxn) {
			ll tmpmask = mask;
			vector<req> kotik;
			forn(i, 0, n) {
				if (tmpmask % 2) {
					kotik.push_back(req(-1, orig[i].F, c[i], i));
					kotik.push_back(req(1, orig[i].S, c[i], i));
				}
				tmpmask /= 2;
			}
			sort(all(kotik));
			if (kotik.empty()) continue;
			if (kotik[0].pos != 0) continue;
			if (kotik.back().pos != k - 1) continue;
			set<ll> s;
			ll res = 0, sum = 0;
			bool ff = 1;
			forn(i, 0, kotik.size()) {
				if (i && kotik[i].pos - kotik[i - 1].pos > 1 && s.empty()) {
					ff = 0;
					break;
				}
				if (kotik[i].type == -1) {
					s.insert(kotik[i].i);
					res += kotik[i].p;
				} else {
					res -= kotik[i].p;
					s.erase(kotik[i].i);
				}
				sum = max(sum, res);
			}
			if (ff) mini = min(mini, sum);
		}
		if (mini == 1e18) error();
		cout << mini;


	//}
	return 0;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	srand('1');
	ios::sync_with_stdio(0);
	source();
	return 0;
}