#include <bits/stdc++.h>

#define f first
#define s second
#define len(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define int long long
#define INF (int)(1e17)
//#define endl '\n'

using namespace std;

struct Segment {
    int l, r, p;
    Segment() = default;
    Segment(int l, int r, int p) : l(l), r(r), p(p) {}
    bool operator<(Segment a) {
        return r < a.r || r == a.r && l < a.l || r == a.r && l == a.l && p < a.p;
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ///freopen(".in", "r", stdin);
    ///freopen(".out", "w", stdout);
    int n, k;
    cin >> n >> k;
    vector<Segment> a(n);
    forn(i, n) {
        cin >> a[i].l >> a[i].r >> a[i].p;
    }
    sort(all(a));
    vector<int> d(n, INF);
    forn(i, n) if (a[i].l == 1) d[i] = a[i].p;
    forn(i, n) {
        forn(j, n) {
            if (a[j].r + 1 == a[i].l) {
                d[i] = min(d[i], max(a[i].p, d[j]));
            }
            else if (a[j].r >= a[i].l && a[j].l < a[i].l) {
                d[i] = min(d[i], max(d[j], a[j].p + a[i].p));
            }
        }
    }
    int ans = INF;
    forn(i, n) {
        if (a[i].r == k) ans = min(ans, d[i]);
    }
    if (ans >= INF) cout << -1;
    else cout << ans;
    return 0;
}
