#include <bits/stdc++.h>

#define f first
#define s second
#define len(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define int long long
#define INF (int)(1e17)
//#define endl '\n'

using namespace std;

struct Segment {
    int l, r, p;
    Segment() = default;
    Segment(int l, int r, int p) : l(l), r(r), p(p) {}
    bool operator<(Segment a) const{
        return r < a.r || r == a.r && l < a.l || r == a.r && l == a.l && p < a.p;
    }
};

bool cmp(Segment a, Segment b) {
    return a.l < b.l || a.l == b.l && a.r < b.r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("c.in", "r", stdin);
    ///freopen(".out", "w", stdout);
    int n, k;
    cin >> n >> k;
    vector<Segment> a(n);
    bool fl = 1;
    forn(i, n) {
        cin >> a[i].l >> a[i].r >> a[i].p;
        if (a[i].p != 1) fl = 0;
    }
    if (fl) {
        sort(all(a), cmp);
        int r = 0;
        forn(i, n) {
            if (a[i].l > r + 1) {
                cout << -1;
                return 0;
            }
            r = max(r, a[i].r);
        }
        if (r != k) {
            cout << -1;
            return 0;
        }
        set<int> s;
        s.insert(0);
        forn(i, n) {
            if (s.find(a[i].l - 1) != s.end()) {
                s.insert(a[i].r);
            }
        }
        if (s.find(k) != s.end()) {
            cout << 1;
        }
        else {
            cout << 2;
        }
        return 0;
    }
    sort(all(a));
    vector<vector<pair<int, int> > > d(n);
    a.pb({0, 0, 0});
    forn(i, n) if (a[i].l == 1) d[i].pb({a[i].p, n});
    forn(i, n) {
        forn(j, i) {
            int mi = INF;
            for (auto s : d[j]) {
                //cout << i << ' ' << j << ' ' << s.f << ' ' << s.s << endl;
                if (a[j].r + 1 == a[i].l) {
                    mi = min(mi, max(a[i].p, s.f));
                }
                if (a[j].r >= a[i].l && a[s.s].r < a[i].l) {
                    mi = min(mi, max(s.f, a[i].p + a[j].p));
                }
            }
            d[i].pb({mi, j});
        }
    }
    int ans = INF;
    forn(i, n) {
        if (a[i].r == k) {
            for (auto s : d[i]) {
                ans = min(ans, s.f);
            }
        }
    }
    if (ans >= INF) cout << -1;
    else cout << ans;
    return 0;
}
