// MINIKEK
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define mkp make_pair
#define pb push_back
#define eb emplace_back
#define left(x) x << 1
#define right(x) x << 1 | 1
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()
#define forn(x, a, b) for (int x = a; x <= b; ++x)
#define for1(x, a, b) for (int x = a; x >= b; --x)

typedef long long ll;
typedef double ld;
typedef pair < int, int > PII;
typedef pair < ll, ll > PLL;
typedef pair < PII, int > seq;

const ld eps = 1e-7;
const ll ool = 1e18 + 9;
const int N = 2e6 + 6, oo = 1e9 + 9, base = 1e9 + 7;

int n, m;
seq a[N];
map < int, vector < int > > g;
map < int, bool > u;

void dfs(int v) {
    u[v] = 1;
    for (auto to : g[v + 1]) {
        if (!u[to]) dfs(to);
    }
}

int main () {

    //freopen("in", "r", stdin);

    cin >> m >> n;
    forn(i, 1, m) {
        cin >> a[i].F.F >> a[i].F.S >> a[i].S;
        g[a[i].F.F].eb(a[i].F.S);
    }

    dfs(0);

    if (u[n]) {
        cout << "1\n";
        return 0;
    }

    sort(a + 1, a + m + 1);

    int ptr = 1;

    forn(i, 1, m) {
        if (a[i].F.F - 1 > ptr) {
            cout << "-1\n";
            return 0;
        }
        ptr = max(ptr, a[i].F.S);
    }

    if (ptr != n) {
        cout << "-1\n";
        return 0;
    }

    cout << "2\n";

    return 0;
}

