#include<iostream>
#include<set>
#include<algorithm>
#include<map>
#include<string>
#include<vector>
#include<sstream>

using namespace std;
int n, k;
long long ans = 10e9;
struct sob{
    int num;
    int ind;
    int type;
};
struct larek{
    int st;
    int ed;
    int p;
};
vector<larek> help;
vector<sob> a;
vector<int> who;
bool sortf(sob a, sob b) {
    if (a.num == b.num) {
        return a.type < b.type;
    }
    return a.num < b.num;
}
void check() {
    vector<sob> vz;
    for (int i = 0; i < n; i++) {
        if (who[i] == 1) {
            vz.push_back({help[i].st, i, 0});
            vz.push_back({help[i].ed, i, 1});
        }
    }
    sort(vz.begin(), vz.end(), sortf);
    if (vz.size() == 0 || vz[0].num > 1 || vz[vz.size() - 1].num < k) {
        return;
    }

    long long sum = 0;
    long long mxp = 0;
    int cnt = 0;
    for (int i = 0; i < vz.size(); i++) {
        if (vz[i].type == 0) {
            sum += help[vz[i].ind].p;
            cnt++;
            mxp = max(mxp, sum);
        } else {
            sum -= help[vz[i].ind].p;
            cnt--;
            if (cnt == 0 && i < vz.size() - 1 && vz[i + 1].num > vz[i].num + 1) {
                return;
            }
        }
    }
    for (auto elem : who) {
        //cout << elem << ' ';
    }
    //cout << endl;
    //cout << mxp << endl;
    ans = min(ans, mxp);
}
void pereb(int left) {
    if (left == 0) {
        check();
    } else {
        who.push_back(0);
        pereb(left - 1);
        who.pop_back();
        who.push_back(1);
        pereb(left - 1);
        who.pop_back();
    }
}
vector<int> e[200000];
int was[200000];
void dfs(int v, int mp) {
    was[v] = 1;
    for (int i = 0; i < n; i++) {
        if (i != v && help[i].p + help[v].p > mp && ((help[i].st >= help[v].st && help[i].st <= help[v].ed) || (help[v].st >= help[i].st && help[v].st <= help[i].ed))) {
            was[i] = 2;
        }
    }
    for (int i = 0; i < e[v].size(); i++) {
        int u = e[v][i];
        if (was[u] == 0) {
            dfs(u, mp);
        }
    }
    for (int i = 0; i < n; i++) {
        if (i != v && help[i].p + help[v].p > mp && ((help[i].st >= help[v].st && help[i].st <= help[v].ed) || (help[v].st >= help[i].st && help[v].st <= help[i].ed))) {
            was[i] = 0;
        }
    }
}

bool check1(int mp) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                if (help[i].p <= mp && help[j].p <= mp && help[i].ed == help[j].st - 1) {
                    e[i].push_back(j);
                } else if (help[i].p + help[j].p <= mp && ((help[j].st >= help[i].st && help[j].st <= help[i].ed))) {
                    e[i].push_back(j);
                } else if (help[i].p + help[j].p <= mp && (help[i].st >= help[j].st && help[i].st <= help[j].ed)) {
                    e[j].push_back(i);
                }
            }
        }
    }
    vector<int> hh;
    for (int i = 0; i < n; i++) {
        if (help[i].st == 1 && help[i].p <= mp) {
            hh.push_back(i);
        }
    }
    for (int i = 0; i < hh.size(); i++) {
        if (was[hh[i]] == 0) {
            dfs(hh[i], mp);
        }
    }
    for (int i = 0; i < n; i++) {
        if (help[i].ed == k && was[i] == 1) {
            //cout << i << endl;
            return true;
        }
    }
    return false;
}
int main() {
    cin >> n >> k;
    int l, r, p;
    bool fl = true;
    for (int i = 0; i < n; i++) {
        cin >> l >> r >> p;
        if (p != 1){
            fl = false;
        }
        help.push_back({l, r, p});
        a.push_back({l, i, 0});
        a.push_back({r, i, 1});
    }
    if (n <= 0) {
        pereb(n);
        if (ans < 10e9) {
            cout << ans;
        } else {
           cout << -1;
        }
    } else if (fl) {
        vector<sob> vz;
        for (int i = 0; i < n; i++) {
            vz.push_back({help[i].st, i, 0});
            vz.push_back({help[i].ed, i, 1});
        }
        sort(vz.begin(), vz.end(), sortf);
        if (vz[0].num > 1 || vz[vz.size() - 1].num < k) {
            cout << -1;
            return 0;
        }
        int cnt = 0;
        for (int i = 0; i < vz.size(); i++) {
            if (vz[i].type == 0) {
                cnt++;
            } else {
                cnt--;
                if (cnt == 0 && i < vz.size() - 1 && vz[i + 1].num > vz[i].num + 1) {
                    cout << -1;
                    return 0;
                }
            }
        }
        map<int, int> hh;
        set<int> gg;
        for (int i = 0; i < vz.size(); i++) {
            if (vz[i].type == 1) {
                gg.insert(vz[i].num);
            } else {
                gg.insert(vz[i].num - 1);
            }
        }
        int cnt1 = 0;
        for (auto elem : gg) {
            hh[elem] = cnt1;
            cnt1++;
        }
        for (int i = 0; i < n; i++) {
            e[hh[help[i].st - 1]].push_back(hh[help[i].ed]);
        }
        dfs(0, 2e9 + 1);
        if (was[hh[k]] == 1) {
            cout << 1;
            return 0;
        }
        cout << 2;
        return 0;
    } else {
        vector<sob> vz;
        for (int i = 0; i < n; i++) {
            vz.push_back({help[i].st, i, 0});
            vz.push_back({help[i].ed, i, 1});
        }
        sort(vz.begin(), vz.end(), sortf);
        if (vz[0].num > 1 || vz[vz.size() - 1].num < k) {
            cout << -1;
            return 0;
        }
        int cnt = 0;
        for (int i = 0; i < vz.size(); i++) {
            if (vz[i].type == 0) {
                cnt++;
            } else {
                cnt--;
                if (cnt == 0 && i < vz.size() - 1 && vz[i + 1].num > vz[i].num + 1) {
                    cout << -1;
                    return 0;
                }
            }
        }
        //cout << check1(3) << endl;
        int left = 0;
        int right = 2e9;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            for (int i = 0; i < n; i++) {
                e[i].clear();
            }
            for (int i = 0; i < n; i++) {
                was[i] = 0;
            }
            if (check1(mid)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        cout << right;
    }
}

