#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)
#define fi first
#define se second
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long i64;

template <typename T>
inline istream &operator >> (istream &in, vector <T> &v) {
    for(auto &it: v)
        in >> it;
    return in;
}

template <typename T>
inline ostream &operator << (ostream & out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T>
inline ostream &operator << (ostream & out, const set <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T1, typename T2>
inline ostream & operator << (ostream &out, const pair <T1, T2> &p) {
    out << p.fi << ' ' << p.se << endl;
}

pair <i64, i64>  query (i64 x) {
    cout << "X " << x << endl;
    pair <i64,i64>  answer;
    cin >> answer.fi >> answer.se;
    return answer;
}

void ready (i64 x) {
    cout << "N " << x << endl;
    string jury; cin >> jury;
    if(jury != "Correct")
        exit(0);
}

void solve_binary(i64 lf, i64 rg) {
    i64 l = lf, r = rg;
    while(r - l > 1) {
        i64 m = (l + r) >> 1;
        if(query(m).fi == 0)
            r = m;
        else
            l = m;
    }
    ready(l);
}

const i64 INF = 1e18 + 1;

int main()
{
#ifdef HOME
    //freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    i64 T; cin >> T;
    For(t, 1, T) {
        solve_binary(1, INF);
    }
    return 0;
}
