#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)
#define fi first
#define se second
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long i64;

/*template <typename T>
inline istream &operator >> (istream &in, vector <T> &v) {
    for(auto &it: v)
        in >> it;
    return in;
}

template <typename T>
inline ostream &operator << (ostream & out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T>
inline ostream &operator << (ostream & out, const set <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}*/


pair <i64, i64>  query (i64 x) {
    cout << "X " << x << endl;
    pair <i64,i64>  answer;
    cin >> answer.fi >> answer.se;
    if(answer.fi == -1)
        exit(0);
    return answer;
}

void ready(i64 x) {
    cout << "N " << x << endl;
    string jury; cin >> jury;
    if(jury != "Correct")
        exit(0);
}

i64 INF = 1e18;

void solve_binary(i64 lf, i64 rg) {
    i64 l = lf, r = rg;
    while(r - l > 1) {
        i64 m = (l + r) / 2;
        if(query(m).fi == 0)
            r = m;
        else
            l = m;
    }
    ready(l);
}

bool good (i64 x) {
    while(x % 2 == 0)
        x /= 2;
    return (x == 1LL);
}

int main()
{
    int T; cin >> T;
    For(t, 1, T) {
        i64 l = -1, r = 62;
        i64 two = 1;
        while(r - l > 1) {
            i64 m = (l + r) >> 1;
            pair <i64,i64> jury = query(two << m);
            if(jury.fi == 1 && good(jury.se))
                l = m;
            else
                r = m;
        }
        pair <i64,i64> jury = query(two << r);
        i64 ans = jury.se;
        while(ans % 2 == 0)
            ans /= 2;
        ready (ans * (two << max(l, 0LL)));
    }
    return 0;
}
