#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <string>
#include <initializer_list>
#include <cassert>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;

int const INF = 1e9 + 7;
ll const LLINF = 1e18 + 19;
int const mod = 1e9 + 9;
int const ph = 257;
ld const eps = 1e-8;

bool operator == (par a, par b) {
	return a.first == b.first && a.second == b.second;
}
bool operator != (par a, par b) {
	return a.first != b.first || a.second != b.second;
}
par operator + (par a, par b) {
	return{ a.first + b.first, a.second + b.second };
}
par operator - (par a, par b) {
	return{ a.first - b.first, a.second - b.second };
}

namespace std {
	using std::hash;
	using std::size_t;
	template <>
	struct hash<par> {
		size_t operator ()(par const& a) const {
			return (1LL * hash<int>()(a.first) * ph + hash<int>()(a.second)) % mod;
		}
	};
}

int kol[256];
string s;

int calc(int coord, char cur) {
	if (kol[cur] < coord) return -1;
	int pref = 0;
	for (int i = 0; i < s.size(); i++) if (s[i] == cur) {
		pref++;
		if (pref == coord) return i + 1;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	cin >> s;
	int x, y;
	cin >> x >> y;
	for (char i : s) kol[i]++;
	int tl, tr, tu, td;
	tl = tr = tu = td = 0;
	if (x < 0) tl = calc(-x, 'L'); else if (x > 0) tr = calc(x, 'R');
	if (y < 0) td = calc(-y, 'D'); else if (y > 0) tu = calc(y, 'U');
	if (tl == -1 || tr == -1 || td == -1 || tu == -1) {
		cout << -1;
		return 0;
	}
	else cout << tl << " " << tu << " " << tr << " " << td;
	return 0;
}