#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <string>
#include <initializer_list>
#include <cassert>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;

int const INF = 1e9 + 7;
ll const LLINF = 1e18;
int const mod = 1e9 + 9;
int const ph = 257;
ld const eps = 1e-8;

bool operator == (par a, par b) {
	return a.first == b.first && a.second == b.second;
}
bool operator != (par a, par b) {
	return a.first != b.first || a.second != b.second;
}
par operator + (par a, par b) {
	return{ a.first + b.first, a.second + b.second };
}
par operator - (par a, par b) {
	return{ a.first - b.first, a.second - b.second };
}

namespace std {
	using std::hash;
	using std::size_t;
	template <>
	struct hash<par> {
		size_t operator ()(par const& a) const {
			return (1LL * hash<int>()(a.first) * ph + hash<int>()(a.second)) % mod;
		}
	};
}

inline ll randll() {
	ll res = rand();
	for (int i = 0; i < 3; i++) {
		res <<= 16;
		res += rand();
	}
	return res;
}

void next() {
	cout << "\n";
	cout.flush();
}

int main() {
	/*
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif*/
	int g;
	cin >> g;
	for (int i = 0; i < g; i++) {
		int q = 30;
		ll n = 0;
		ll l = 1, r = LLINF;
		for (int i = 0; i < q; i++) {
			ll cur = l + r >> 2;
			cout << "X " << cur; next();
			ll a, b;
			cin >> a >> b;
			if (a == b) n = cur;
			if (!a) r = cur; else l = cur;
			n = max(n, b);
		}
		cout << "N " << n; next();
		string ok;
		cin >> ok;
		assert(ok == "Correct");
	}
	return 0;
}