#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)2e5 + 7;

struct st {
	int l, r;

	bool operator < (st b) const {
		return l < b.l;
	}
};

set<pair<st, int> > O;
int used[dd];
set<st> G[dd];

inline void uax(int &a, int b) {
	if (a < b) a = b;
}

int solve() {
	int n, ans = 1;
	scanf("%d", &n);
	int cnt = 1, len, l;
	scanf("%d", &len);
	set<int> S;
	S.insert(0);
	G[0].insert({ 0, len - 1 });
	O.insert({ { 0, len - 1 }, 0 });
	used[0] = 1;
	for (int i = 1; i < n; ++i) {
		scanf("%d", &l);
		if (l > len) {
			G[0].insert({ len, l - 1 });
			O.insert({ { len, l - 1 }, 0 });
			S.insert(0);
		} else {
			while ((*O.rbegin()).first.r >= l) {
				auto Y = *O.rbegin();
				G[Y.second].erase(Y.first);
				if (!(int)G[Y.second].size()) S.erase(Y.second);
				O.erase(--O.end());
				if (Y.first.l < l) {
					Y.first.r = l - 1;
					O.insert(Y);
					G[Y.second].insert(Y.first);
					S.insert(Y.second);
				}
			}

			int k = *S.begin();
			uax(ans, k + 2);
			st L = *G[k].rbegin();
			O.erase({ L, k });
			G[k].erase(L);
			if (L.r == L.l) {
				if (!(int)G[k].size())
					S.erase(k);
			} else {
				L.r--;
				G[k].insert(L);
				O.insert({ L, k });
				L.r++;
			}
			L.l = L.r;
			G[k + 1].insert(L);
			O.insert({ L, k + 1 });
			S.insert(k + 1);
		}
		len = l;
	}
	printf("%d", ans);
	return 0;
}
