#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)2e5 + 7;

int dx[] = { -1, 0, 1, 0 }, dy[] = { 0, 1, 0, -1 };
int ans[4], cnt[4], G[4], K[4];

int solve() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	string s;
	cin >> n >> s;
	int x, y;
	cin >> x >> y;
	int x0 = 0, y0 = 0;
	const char* name = "LURD";
	for (char c : s) {
		x0 += dx[strchr(name, c) - name], y0 += dy[strchr(name, c) - name];
		cnt[strchr(name, c) - name]++;
	}
	G[2] = max(0, x0 - x), G[0] = max(0, x - x0), G[1] = max(0, y0 - y), G[3] = max(0, y - y0);

	for (int i = 0; i < 4; ++i)
		if (G[i] > cnt[i])
			return 0 * puts("-1");

	fill(ans, ans + 4, n);

	for (int i = 0; i < n; ++i) {
		int j = strchr(name, s[i]) - name;
		if (K[j] + G[j] == cnt[j])
			ans[j] = i;
		K[j]++;
	}

	for (int i = 0; i < 4; ++i)
		printf("%d ", ans[i]);

	return 0;
}
