#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)1e5 + 7;
const int inf = (int)1e9 + 7;

struct st {
	int l, r, p;
} A[dd];

int dp[dd];

void uin(int &a, int b) {
	if (a > b) a = b;
}

int solve() {
	int n, k;
	scanf("%d %d", &n, &k);
	for (int i = 0; i < n; ++i)
		scanf("%d %d %d", &A[i].l, &A[i].r, &A[i].p);
	A[n++] = { 0, 0, 0 };
	A[n++] = { k + 1, k + 1, 0 };
	sort(A, A + n, [](st a, st b) {
		return a.r < b.r;
	});
	
	fill(dp, dp + n + 1, inf);
	dp[0] = 0;
	for (int i = 1; i < n; ++i) {
		for (int j = i - 1; j >= 0; --j) {
			if (A[j].r + 1 < A[i].l)
				break;
			if (A[j].r + 1 == A[i].l)
				uin(dp[i], max(dp[j], A[i].p));
			else
				uin(dp[i], max(dp[j], A[i].p + A[j].p));
		}
	}
	printf("%d", dp[n - 1] == inf ? -1 : dp[n - 1]);
	return 0;
}
