#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)3e3 + 7;
const int inf = (int)2e9 + 7;

int pr[dd], cnt;
int us[dd];

bool is_prime(int x) {
	for (int j = 2; j * j <= x; ++j)
		if (x % j == 0)
			return false;

	return true;
}

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

int solve() {
	int q = 30;

	for (int i = 2; cnt < q; ++i)
		if (is_prime(i)) pr[cnt++] = i;

	int g;
	cin >> g;
	while (g--) {
		ll ans = 1;
		random_shuffle(pr, pr + cnt);
		for (int i = 0; i < 20; ++i) {
			cout << "X " << pr[i] << endl;
			ll a, b;
			cin >> a >> b;
			if (a == -1) return 0;
			ans = ans / gcd(ans, b) * b;
		}
		cout << "N " << ans << endl;
		string s;
		cin >> s;
		if (s == "Wrong") return 0;
	}


	return 0;
}
