#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <cstdio>

#define X first
#define Y first
#define pb push_back
#define all(v) v.begin(),v.end()
#define fors(a,b,c) for(int a = b; a < c; ++a)

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e6 + 1;
const int INF = 1e9;

vector<int> u(MAXN), d(MAXN), l(MAXN), r(MAXN);

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;


    string s;
    cin >> s;

    int x, y;
    cin >> x >> y;

    int nx = 0, ny = 0;
    for (int i = n - 1; i >= 0;--i) {
        d[i] = d[i + 1];
        u[i] = u[i + 1];
        l[i] = l[i + 1];
        r[i] = r[i + 1];
        if (s[i] == 'D') {
            d[i]++;
        }
        if (s[i] == 'U') {
            u[i + 1]++;
        }
        if (s[i] == 'R') {
            r[i]++;
        }
        if (s[i] == 'L') {
            l[i]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (s[i] == 'D') {
            ny--;
        }
        if (s[i] == 'U') {
            ny++;
        }
        if (s[i] == 'R') {
            nx++;
        }
        if (s[i] == 'L') {
            nx--;
        }
    }

    int br = n, bl = n, bu = n, bd = n;

    //cout << nx << " " << ny << endl;
    if (nx - x > 0) {
        bool flag = false;
        for (int j = n; j >= 0; j--) {
            if (r[j] == nx - x) {
                br = j;
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << -1 << endl;
            return 0;
        }
    }
    if (nx - x < 0) {
        bool flag = false;
        for (int j = n; j >= 0; j--) {
            if (l[j] == x - nx) {
                bl = j;
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << -1 << endl;
            return 0;
        }
    }

    if (ny - y > 0) {
        bool flag = false;
        for (int j = n; j >= 0; j--) {
            if (u[j] == ny - y) {
                bu = j;
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << -1 << endl;
            return 0;
        }
    }

    if (y - ny > 0) {
        bool flag = false;
        for (int j = n; j >= 0; j--) {
            if (d[j] == y - ny) {
                bd = j;
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << -1 << endl;
            return 0;
        }
    }
    cout << bl << " " << bu << " " << br << " " << bd << endl;
    return 0;
}
