#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <cstdio>

#define X first
#define Y first
#define pb push_back
#define all(v) v.begin(),v.end()
#define fors(a,b,c) for(int a = b; a < c; ++a)

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5;
const int INF = 1e9;

ll check(ll x) {
    cout << "X " << x << endl;
    ll a, b;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
    cin >> b;
    return a;
}

int main() {
    //ifstream cin("input.txt");
    //ofstream cout("output.txt");

    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        ll l = 1, r = 1e18;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (check(mid) == 0) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << "N " << l << endl;
        string res;
        cin >> res;
        if (res != "Correct") {
            cout << 1/ 0;
            exit(0);
        }
    }
    return 0;
}
