#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ldb;
typedef pair<int, int> pii;

#define fi first
#define se second
#define pb push_back
#define mkp make_pair
#define all(v) (v).begin(),(v).end()
#define dbg(a) cout<<#a<<" = "<<a<<endl

//C

ll inf = 1e18;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    //dbg("C");
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, k;
    cin >> n >> k;
    vector<pair<pii, int> > v(n);
    for(int i = 0; i < n; i++) {
        cin >> v[i].fi.fi >> v[i].fi.se >> v[i].se;
    }
    v.pb(mkp(mkp(0, 0), 0));
    sort(all(v));
    if(v[1].fi.fi != 1) {
        cout << -1;
        return 0;
    }
    vector<ll> dp(n + 1, inf);
    dp[0] = v[0].se;
    for(int i = 1; i <= n; i++) {
        ll mn = inf;
        dp[i] = 0;
        for(int j = i-1; j >= 0; j--) {
            if(v[j].fi.se >= v[i].fi.fi) {
                mn = min(mn, dp[j]);
            }
            else if(v[j].fi.se + 1 == v[i].fi.fi) {
                mn = 0;
            }
        }
        //dbg(mn);
        dp[i] = mn + v[i].se;
    }
    ll ans = inf;
    for(int i = 0; i <= n; i++) {
        //cout << dp[i] << " ";
    }
    //cout << endl;
    for(int i = 0; i <= n; i++) {
        if(v[i].fi.se == k) {
            ans = min(ans, dp[i]);
        }
    }
    if(ans == inf) ans = -1;
    cout << ans;

    return 0;
}
