#include <iostream>
#include <vector>
#include <set>


using namespace std;


const int INF = 2e9 + 14;


int check(int mask, int k, vector<vector<int>> const& e)
{
	//cerr << mask << endl;
	int i = 0;
	multiset<vector<int>> s;
	while (mask > 0)
	{
		if (mask % 2)
		{
			s.insert({e[i][0]    , -1, e[i][2]});
			s.insert({e[i][1] + 1,  1, e[i][2]});
		}
		i++;
		mask >>= 1;
	}
	if (s.begin()->at(0) != 1 || s.rbegin()->at(0) != k + 1)
	{
		return INF;
	}
	//cerr << "KEK" << mask << endl;
	int ans = 0;
	long long b = 0;
	int c = 0;
	int prev = 1;
	for (auto i : s)
	{
		//cerr << "C: " << i[0] << ' ' << i[1] << ' ' << i[2] << endl;
		if (i[0] != prev)
		{
			prev = i[0];
			ans = max(ans, b);
		}
		if (i[1] == -1)
		{
			b += i[2];
			if (b > INF) return INF;
		}
		else
		{
			b -= i[2];
			c += (b == 0);
		}
	}
	//cerr << endl;
	return (c ? INF : ans);
}


int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int>> e;
	for (int i = 0; i < n; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		e.push_back({a, b, c});
	}
	int a = INF;
	for (int mask = 1; mask < (1 << n); mask++)
	{
		a = min(a, check(mask, m, e));
	}
	cout << (a == INF ? -1 : a) << endl;
}