#include <bits/stdc++.h>

long long INF = 1e17;

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second || (a.first < b.first && a.second == b.second);
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "rt", stdin);
    ///freopen("output.txt", "wt", stdout);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int> > a(n);
    vector<int> p(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second >> p[i];
    }
    long long ans = INF;
    if (n <= 10)
    {
        for (int mask = 0; mask < (1 << n); mask++)
        {
            vector<int> is(n, 0);
            for (int i = 0; i < n; i++)
            {
                if (mask & (1 << i))
                {
                    is[i] = 1;
                }
            }
            vector<pair<int, long long> > b;
            for (int i = 0; i < n; i++)
            {
                if (is[i])
                {
                    b.push_back({a[i].first, -p[i]});
                    b.push_back({a[i].second, p[i]});
                }
            }
            sort(b.begin(), b.end());
            int d = 0;
            long long maxp = 0;

            long long currp = 0;
            int prevpos = 0;
            int balance = 0;
            for (int i = 0; i < (int)b.size(); i++)
            {
                currp -= b[i].second;
                d = b[i].first - prevpos;
                if (d > 1 && balance == 0)
                {
                    maxp = INF;
                    break;
                }
                prevpos = b[i].first;
                if (b[i].second > 0)
                    balance++;
                else
                    balance--;
                maxp = max(maxp, currp);
            }
            if (b.empty() || b.back().first != k || b[0].first != 1)
                maxp = INF;
            ans = min(ans, maxp);
        }
        if (ans < INF)
            cout << ans;
        else
            cout << -1;
        return 0;
    }


    vector<int> dp(n, -1);
    dp[0] = 1;
    sort(a.begin(), a.end(), cmp);
    vector<pair<int, int> > pos;
    for (int i = 0; i < n; i++)
    {
        pos.push_back({a[i].first, -1});
        pos.push_back({a[i].second, 1});
    }
    sort(pos.begin(), pos.end());
    int balance = 0;
    if (pos[0].first != 1)
    {
        cout << -1;
        return 0;
    }
    if (pos[2 * n - 1].first != k)
    {
        cout << -1;
        return 0;
    }
    balance = -1;
    int prev = pos[0].first;
    for (int i = 1; i < 2 * n; i++)
    {
        if (balance == 0 && pos[i].first - prev > 1)
        {
            cout << -1;
            return 0;
        }
        balance += pos[i].second;
    }
    map<int, int> good;
    good[0] = 1;
    for (int i = 0; i < n; i++)
    {
        int l = a[i].first;
        int r = a[i].second;
        if (good[r] == 0)
            good[r] = INF;
        if (good[l - 1] == 1)
            good[r] = min(good[r], 1);
        else
            good[r] = min(2, good[r]);
    }
    if (good[k] == 1)
        cout << 1;
    else
        cout << 2;
    return 0;
}
