#include <bits/stdc++.h>

long long INF = 1e17;

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.second < b.second || (a.first < b.first && a.second == b.second);
}

struct node
{
    int l;
    int r;
    long long p;
    int prev;
    long long z;
    int id;
    node (int l_ = 0, int r_ = 0, long long p_ = 0, int prev_ = 0, long long z_ = 0, int id_ = 0)
    {
        this->l = l_;
        this->r = r_;
        this->p = p_;
        this->prev = prev_;
        this->z = z_;
        this->id = id_;
    }
};

bool cmp1(node a, node b)
{
    return a.r < b.r;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "rt", stdin);
    ///freopen("output.txt", "wt", stdout);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int> > a(n);
    vector<int> p(n);
    bool f = 1;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second >> p[i];
        if (p[i] != 1)
            f = 0;
    }

    /// ////////////////////////
    if (n <= 10)
    {
        long long ans = INF;
        for (int mask = 0; mask < (1 << n); mask++)
        {
            vector<int> is(n, 0);
            for (int i = 0; i < n; i++)
            {
                if (mask & (1 << i))
                {
                    is[i] = 1;
                }
            }
            vector<pair<int, long long> > b;
            for (int i = 0; i < n; i++)
            {
                if (is[i])
                {
                    b.push_back({a[i].first, -p[i]});
                    b.push_back({a[i].second, p[i]});
                }
            }
            sort(b.begin(), b.end());
            int d = 0;
            long long maxp = 0;

            long long currp = 0;
            int prevpos = 0;
            int balance = 0;
            for (int i = 0; i < (int)b.size(); i++)
            {
                currp -= b[i].second;
                d = b[i].first - prevpos;
                if (d > 1 && balance == 0)
                {
                    maxp = INF;
                    break;
                }
                prevpos = b[i].first;
                if (b[i].second > 0)
                    balance++;
                else
                    balance--;
                maxp = max(maxp, currp);
            }
            if (b.empty() || b.back().first != k || b[0].first != 1)
                maxp = INF;
            ans = min(ans, maxp);
        }
        if (ans < INF)
            cout << ans;
        else
            cout << -1;
        return 0;
    }
    /// //////////////////////////////////////////////
    vector<pair<int, int> > pos;
    for (int i = 0; i < n; i++)
    {
        pos.push_back({a[i].first, -1});
        pos.push_back({a[i].second, 1});
    }
    sort(pos.begin(), pos.end());
    int balance = 0;
    if (pos[0].first != 1)
    {
        cout << -1;
        return 0;
    }
    if (pos[2 * n - 1].first != k)
    {
        cout << -1;
        return 0;
    }
    balance = -1;
    int prev = pos[0].first;
    for (int i = 1; i < 2 * n; i++)
    {
        if (balance == 0 && pos[i].first - prev > 1)
        {
            cout << -1;
            return 0;
        }
        prev = pos[i].first;
        balance += pos[i].second;
    }
    if (f)
    {
        sort(a.begin(), a.end(), cmp);
        map<int, int> good;
        good[0] = 1;
        for (int i = 0; i < n; i++)
        {
            int l = a[i].first;
            int r = a[i].second;
            if (good[r] == 0)
                good[r] = INF;
            if (good[l - 1] == 1)
                good[r] = min(good[r], 1);
            else
                good[r] = min(2, good[r]);
        }
        if (good[k] == 1)
            cout << 1;
        else
            cout << 2;
        return 0;
    }
    /// /////////////////////////////////////

    vector<node> dp(n + 1);
    map<int, set<int> > ed;



    for (int i = 0; i < n; i++)
    {
        dp[i].id = i;
        dp[i].l = a[i].first;
        dp[i].r = a[i].second;
        dp[i].prev = -1;
        dp[i].z = INF;
        dp[i].p = p[i];
    }
    dp[n].id = 0;
    dp[n].l = 0;
    dp[n].r = 0;
    dp[n].p = 0;
    dp[n].prev = -1;
    dp[n].z = 0;
    sort(dp.begin(), dp.end(), cmp1);
    for (int i = 0; i <= n; i++)
    {
        ed[dp[i].r].insert(i);
    }
    for (int i = 1; i <= n; i++)
    {
        ///cout << dp[i].l << " " ;
        if (!ed[dp[i].l - 1].empty())
        {
            int minid = -1;
            for (auto x : ed[dp[i].l - 1])
            {
                if (minid == -1 || dp[minid].z > dp[x].z)
                {
                    if (dp[x].id == 0 || dp[x].prev != -1)
                        minid = x;
                }
            }
            dp[i].prev = minid;
            if (minid != -1)
                dp[i].z = max(dp[i].p, dp[minid].z);
        }
        int j = i - 1;
        while (j >= 0 && dp[j].r >= dp[i].l && dp[j].l < dp[i].l)
        {
            if (j == 0 || (dp[j].prev != -1 && dp[dp[j].prev].r + 1 < dp[i].l))
            {
                if (max(dp[j].z, dp[j].p + dp[i].p) < dp[i].z)
                {
                    dp[i].z = max(dp[j].z, dp[j].p + dp[i].p);
                    dp[i].prev = j;
                }
            }
            j--;
        }
    }
    long long ans = INF;
    for (int i = 0; i <= n; i++)
    {
        if (dp[i].r == k && dp[i].prev != -1)
            ans = min(ans, dp[i].z);
    }
    cout << ans;
    return 0;
}
