#include <bits/stdc++.h>

int INF = 1e6;

using namespace std;

long long pow(long long x, long long p)
{
    if (p == 0)
        return 1ll;
    if (p % 2 == 0)
    {
        long long c = pow(x, p /2);
        return c * c;
    }
    return x * pow(x, p - 1);
}

bool success(vector<int> &a, int x)
{
    long long b = 0;
    int len = a[0];
    for (int i = 1; i < (int)a.size(); i++)
    {
        if (a[i] > a[i - 1])
        {
            int d = a[i] - a[i - 1];
            b *= pow(x, d);
            len = a[i];
        }

        if (a[i] == a[i - 1])
        {
            b += 1;
            if (b >= pow(x, len))
                return false;
        }
        if (a[i] < a[i - 1])
        {
            int d = a[i - 1] - a[i];
            b /= pow(x, d);
            b += 1;
            len = a[i];
            if (b >= pow(x, len))
                return false;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "rt", stdin);
    ///freopen("output.txt", "wt", stdout);
    int n;
    cin >> n;
    vector<int> len(n);
    for (int i = 0; i < n; i++)
        cin >> len[i];
    int l = 0;
    int r = INF;
    while (r - l > 1)
    {
        int mid = (l + r) / 2;
        if (success(len, mid))
            r = mid;
        else
            l = mid;
    }
    cout << r;
    return 0;
}
