#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss ,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif
#define int ll
  
template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}
template<typename...Ts, typename T>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ",";
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(6);
		srand(300);
	}
	~init() {
		#ifdef LOCAL
		cerr << "Time: " << clock() * 1.0 / CLOCKS_PER_SEC << " s.\n";
		#endif
	}
} init;

string s;
const int MAXN = 1e6 + 2;
int lans, rans, uans, dans;
void no() {
	cout << "-1\n";
	exit(0);
}
int32_t main() {
	int n;
	cin >> n >> s;
	int x, y;
	cin >> x >> y;

	if (x > 0) {
		lans = 0;
		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			cnt += s[i] == 'R';
			if (cnt == x) {
				rans = i + 1;
				break;
			}
		}
		if (cnt != x) no();
	}
	if (x == 0) {
		lans = rans = 0;
	}
	if (x < 0) {
		rans = 0;
		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			cnt += s[i] == 'L';
			if (cnt == -x) {
				lans = i + 1;
				break;
			}
		}
		if (cnt != -x) no();
	}
	if (y > 0) {
		dans = 0;
		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			cnt += s[i] == 'U';
			if (cnt == y) {
				uans = i + 1;
				break;
			}
		}
		if (cnt != y) no();
	}
	if (y == 0) {
		dans = uans = 0;
	}
	if (y < 0) {
		uans = 0;
		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			cnt += s[i] == 'D';
			if (cnt == -y) {
				dans = i + 1;
				break;
			}
		}
		if (cnt != -y) no();
	}

	cout << lans << ' ' << uans << ' ' << rans << ' ' << dans << '\n';


	return 0;
}
