#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss ,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif
#define int ll
  
template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}
template<typename...Ts, typename T>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ",";
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(6);
		srand(300);
	}
	~init() {
		#ifdef LOCAL
		cerr << "Time: " << clock() * 1.0 / CLOCKS_PER_SEC << " s.\n";
		#endif
	}
} init;

const int MAXN = 1e5 + 1, INF = 1e18;
struct otr{
	int l, r, p;
} a[MAXN];
int n, k;
int mask;
int ok(int x) {
	if (x < 1 || x > k) return -1;
	int res = 0;
	for (int i = 0; i < n; ++i)
		if ((mask >> i & 1) && (a[i].l <= x && a[i].r >= x))
			res += a[i].p;
	return res;
}

bool dp1[MAXN];
bool dp2[MAXN];

int f1() {
	int ans = INF;
	for (mask = 0; mask < (1 << n); ++mask) {
		bool nice = ok(1) && ok(k);
		for (int i = 0; i < n; ++i)
			nice &= ok(a[i].l) != 0 && ok(a[i].r) != 0 && ok(a[i].l - 1) != 0 && ok(a[i].r + 1) != 0;
		if (nice) {
			int cur = 0;
			for (int i = 0; i < n; ++i) 
				cur = max(cur, ok(a[i].l));
			if (ans > cur) 
				ans = cur;
		}
	}

	if (ans == INF) return -1;
	else {
		return ans;
		// cout << ans << '\n';
	}	
}


int f2() {
	memset(dp1, 0, MAXN * sizeof(bool));
	memset(dp2, 0, MAXN * sizeof(bool));
	std::sort(a, a + n, [](const otr & p1, const otr & p2) {
		return p1.r < p2.r;
	});
	dbg("-------");
	for (int i = 0; i < n; ++i) {
		if (a[i].l == 1)
			dp1[i] = dp2[i] = true;
		dbg(i, dp1[i], dp2[i]);
		for (int j = i + 1; j < n; ++j) {
			if (dp1[i] && a[i].r + 1 == a[j].l)
				dp1[j] = true;
			if (dp2[i] && a[i].r + 1 >= a[j].l)
				dp2[j] = true; 
		}
	}
	bool can1 = false, can2 = false;
	for (int i = 0; i < n; ++i) {
		can1 |= a[i].r == k && dp1[i];
		can2 |= a[i].r == k && dp2[i];
	}
	if (can1) return 1;
	else if (can2) return 2;
	else return -1;
}

int32_t main() {
	// while (true) {
		n = 10, k = 10;
		cin >> n >> k;
		bool only1 = true;
		for (int i = 0; i < n; ++i) {
			a[i].l = rand() % k + 1;
			a[i].r = rand () % k + 1;
			a[i].p = 1;
			if (a[i].l > a[i].r) swap(a[i].l, a[i].r);
			cin >> a[i].l >> a[i].r >> a[i].p;
			only1 &= a[i].p == 1;
		}
		// int x = f1(), y = f2();
		// if (x != y) {
		// 	dbg(n);
		// 	for (int i = 0; i < n; ++i)
		// 		dbg(a[i].l, a[i].r);
		// 	dbg(x, y);
		// 	break;
		// }
		if (n <= 10) {
			cout << f1() << '\n';
		} else {
			cout << f2() << '\n';
		}
	// }
	// int last = -1, pos = 0;
	// bool only1 = true;
	// while (last < k) {
	// 	int mx = -1, wmx;
	// 	for (int i = pos; i < n; ++i) {
	// 		if (a[i].l < last) {
	// 			mx = a[i].r;
	// 			wmx = i;
	// 		}
	// 	}
	// 	last = mx + 1;
	// 	pos = wmx + 1;
	// 	if (mx == -1) {
	// 		cout << "-1\n";
	// 		return 0;
	// 	}
	// }


	return 0;
}
