#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss ,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif
#define int ll

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}
template<typename...Ts, typename T>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ",";
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(6);
		srand(300);
	}
	~init() {
		#ifdef LOCAL
		cerr << "Time: " << clock() * 1.0 / CLOCKS_PER_SEC << " s.\n";
		#endif
	}
} init;

int gcd(int a, int b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int lcm(int a, int b) {
	return a / gcd(a ,b) * b;
}

pll ask(ll x) {
	cout << "X " << x << std::endl;
	pll ans;
	cin >> ans.ff >> ans.ss;
	return ans;
}
void say(ll x) {
	cout << "N " << x << std::endl;
	string s;
	cin >> s;
}

int32_t main() {

	int g;
	cin >> g;
	vector<ll> prs;
	ll pw = 1;
	#ifdef LOCAL
	const int MX = 10;
	#else
	const int MX = 60;
	#endif
	for (int i = 0; i < MX; ++i, pw *= 2) {
		prs.pb(pw);
	}
	while (g--) {
// 		import sys
// def gcd(a, b):
// 	while b:
// 		a, b = b, a % b
// 	return a
// def lcm(a, b):
// 	return a // gcd(a, b) * b
// prs = []
// mul = 1
// # for i in range(2, 100):
// # 	if mul > 10 **18: break
// # 	ok = True
// # 	for j in range(2, i):
// # 		if i % j == 0:
// # 			ok = False
// # 			break
// # 	if ok: 
// # 		prs.append(i)
// # 		mul *= i
		int l = 0, r = MX;
		ll ans = 1;
		bool said = false;
		while (r - l > 1) {
			int m = l + r >> 1;
			pll t = ask(prs[m]);
			ll x = t.ff, y = t.ss;
			if (y == 1 && x == 1) {
				say(prs[m]);
				said = true;
				break;
			}
			ans = lcm(ans, y);
			if (x == 0) r = m;
			else l = m;
		}
		if (!said) {
			say(ans);
		}
	}
	return 0;
}
