#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <ctime>

using namespace std;

typedef long long LL;

int main() {
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n;
  cin >> n;

  vector<int> a(n);

  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }

  int L = 0, R = n;

  while (R - L > 1) {
    int k = (L + R) / 2;

    bool ok = 1;

    map<int, int> digits;
    digits[1] = 1;
    for (int i = 1; i < n && ok; ++i) {
      if (a[i] > a[i - 1]) {
        digits[a[i]] = 1;
        continue;
      }
      if (a[i] <= a[i - 1]) {
        if (!digits.count(a[i])) digits[a[i]] = 2;
        else ++digits[a[i]];
        int j = a[i];
        while (digits[j] > k) {
          if (j == 1) {
            ok = false;
            break;
          }
          digits[j] -= k;
          if (!digits.count(j - 1)) digits[j - 1] = 2;
          else ++digits[j - 1];
          --j;
        }
      }
    }

    if (ok) R = k;
    else L = k;
  }
  
  cout << R << endl;

  return 0;
}