#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <ctime>

using namespace std;

typedef long long LL;

LL gcd(LL a, LL b) {
  while (b != 0) {
    a %= b;
    swap(a, b);
  }
  return a;
}


LL n = 10;

pair<LL, LL> ask(LL t) {
#ifdef _DEBUG
  LL a = n / t, b = n;
  LL g = gcd(a, b);
  cerr << "asked " << t << " -> " << a / g << '/' << b / g << endl;
  return{ a / g, b / g };
#else 
  cout << "X " << t << endl;
  LL a, b;
  cin >> a >> b;
  return{ a, b };
#endif
}

void answer(LL n) {
#ifdef _DEBUG
  cout << "answered " << n << endl;
  if (n != ::n) {
    cout << "NOOOOO" << endl;
    exit(-1);
  }
#else
  cout << "N " << n << endl;
#endif
}

void play() {
  LL MAXN = (LL)1e18;

  LL t = MAXN / 2;

  int q = 0;
  while (1) {
    auto ans = ask(t);
    q++;
    if (ans.first == 0) t /= 2;
    else {
      answer(ans.second);
      cerr << q << endl;
      return;
    }
  }
}


int main() {
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  //cin.tie(0);
  //cin.sync_with_stdio(0);
#ifdef _DEBUG

  for (LL n = 1; n <= 1000; ++n)
    play();

  return 0;
#endif
  int g;
  cin >> g;

  for (int i = 0; i < g; ++i) {
    play();
  }
  
  return 0;
}