#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <ctime>

using namespace std;

typedef long long LL;

LL gcd(LL a, LL b) {
  while (b != 0) {
    a %= b;
    swap(a, b);
  }
  return a;
}

LL n;

pair<LL, LL> ask(LL t) {
#ifdef _DEBUG
  LL a = n / t, b = n;
  LL g = gcd(a, b);
  //cerr << "asked " << t << " -> " << a / g << '/' << b / g << endl;
  return{ a / g, b / g };
#else 
  cout << "X " << t << endl;
  LL a, b;
  cin >> a >> b;
  return{ a, b };
#endif
}

void answer(LL n) {
#ifdef _DEBUG
  //cout << "answered " << n << endl;
  if (n != ::n) {
    cout << "NOOOOO" << endl;
    exit(-1);
  }
#else
  cout << "N " << n << endl;
  string cor;
  cin >> cor;
  if (cor[0] != 'C') exit(0);
#endif
}

void play() {
  LL MAXN = (LL)1e18;

  int q = 0;
  LL L = 0, R = 61;
  pair<LL, LL> prev = { 1, 1 };
  while (R - L > 1) {
    LL mid = (L + R) / 2;
    LL t = min((LL)1e18, 1ll << (mid));
    auto ans = ask(t);
    /*q++;
    if (q > 6) {
      cerr << "Too much" << endl;
      exit(-1);
    }*/
    if (ans.first == 0) {
      if (mid == L - 1) {
        answer(prev.second);
        return;
      }
      R = mid;
    }
    else {
      prev = ans;
      L = mid;
    }
  }
  answer(prev.second);
}


int main() {
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  //cin.tie(0);
  //cin.sync_with_stdio(0);
#ifdef _DEBUG

  for (n = 1; n <= 100000; ++n) {
    cerr << "N: " << n << endl;
    play();
  }

  return 0;
#endif
  int g;
  cin >> g;

  for (int i = 0; i < g; ++i) {
    play();
  }
  
  return 0;
}