#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, k ;
vector <long long> vect ;
pair <int,int> a[8000];
const long long INF = 1000*1ll*1000*1ll*1000*1000*1000*100;
vector <int> to[8000];
long long dp[8000][8000], p[8000] ;

long long rec ( int pos, int pred )
{
    int i;
    long long ans = INF;

    if ( dp[pos][pred] > -1 )
        return dp[pos][pred];

    for ( i=0; i<to[pos].size(); i++ )
    {
        int v = to[pos][i] ;
        ans = min ( ans, max( rec( a[v].first-1, v ), p[v] ) );
    }
    dp[pos][pred] = ans;

    ans = INF;
    for ( i=pos+1; i<a[pred].second; i++ )
    {
         if ( to[i].size() > 0 )
         {
             ans = min ( ans, rec( i, pred ) + p[ pred ] ) ;
         }
    }

    dp[pos][pred] = min ( dp[pos][pred], ans );
    return dp[pos][pred] ;
}

int main()
{
    int i, j;
    cin >> n >> k;
    vect.push_back( k ) ;
    for ( i=1; i<=n; i++ )
    {
        cin >> a[i].first >> a[i].second >> p[i] ;
        int curr = a[i].second + 1;
        if ( count( vect.begin(), vect.end(), a[i].first ) == 0 )
           vect.push_back( a[i].first );
        if ( curr <= k && count( vect.begin(), vect.end(), curr ) == 0 )
           vect.push_back( curr );
        curr = a[i].second - 1;
        if ( curr > 0 && count( vect.begin(), vect.end(), curr ) == 0 )
           vect.push_back( curr );

        curr = a[i].first - 1;
        if ( curr > 0 && count( vect.begin(), vect.end(), curr ) == 0 )
           vect.push_back( curr );
        curr = a[i].first + 1;
        if ( curr <= k && count( vect.begin(), vect.end(), curr ) == 0 )
           vect.push_back( curr );
        if ( count( vect.begin(), vect.end(), a[i].second ) == 0 )
          vect.push_back( a[i].second );
    }
    sort( vect.begin(), vect.end() );

    k = lower_bound( vect.begin(), vect.end(), k ) - vect.begin() + 1;
    a[0] = make_pair( 0, k );
    for ( i=1; i<=n; i++ )
    {
        a[i].first = lower_bound( vect.begin(), vect.end(), a[i].first ) - vect.begin() + 1;
        a[i].second = lower_bound( vect.begin(), vect.end(), a[i].second ) - vect.begin() + 1;
        to[ a[i].second ].push_back( i );
    }

    for ( i=0; i<=k+1; i++ )
     for ( j=0; j<=n+1; j++ )
       dp[i][j] = -1 ;

    for ( j=0; j<=n+1; j++ )
       dp[0][j] = 0;

    long long ans = rec( k, 0 ) ;
    if ( ans >= INF )
        cout << "-1";
    else
        cout << ans;
    return 0;
}
