#define _CRT_SECURE_NO_WARNINGS

#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mk make_pair
#define inb push_back
#define all(v) v.begin(), v.end()

int solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

int n, k;
ll ans;
pair< pii, ll > seg[11];

int solve()
{
	cin >> n >> k;
	for (int i = 0; i < n; ++i)
		cin >> seg[i].X.X >> seg[i].X.Y >> seg[i].Y;
	ans = (ll)1e14 + 88;
	for (int msk = 1; msk < (1 << n); ++msk)
	{
		vector < pair <pii, ll> > q;
		for (int i = 0; i < n; ++i)
		{
			if ((msk >> i) & 1)
			{
				q.inb(mk(mk(seg[i].X.X, -1), seg[i].Y));
				q.inb(mk(mk(seg[i].X.Y, 1), seg[i].Y));
			}
		}
		sort(all(q));
		if (q[0].X.X != 1)
			continue;
		ll sum = 0;
		ll res = 0;
		int f = 1;
		for (int i = 0; i < q.size(); ++i)
		{
			auto ev = q[i];
			int x = ev.X.X;
			int id = ev.X.Y;
			ll cst = ev.Y;
			if (id == -1)
			{
				sum += cst;
			}
			else
			{
				sum -= cst;
				if (!sum)
				{
					if (i + 1 == q.size() && x != k)
					{
						f = 0;
						break;
					}
					if (i + 1 < q.size() && q[i + 1].X != mk(x + 1, -1))
					{
						f = 0;
						break;
					}
				}
			}
			res = max(sum, res);
		}
		if (f)
			ans = min(res, ans);
	}
	if (ans == (ll)1e14 + 88)
		puts("-1"), exit(0);
	cout << ans;
	return 0;
}