#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define y1 kekek

const ld pi = acos(-1.0);
const ld eps = 1e-8;
const int BIG = 1e9;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ll MAX_N = 1e6 + 1;

pair<int, int> solve(int a, int b, int x)
{
    if (x > 0)
    {
        if (b < x)
            return make_pair(BIG, BIG);
        return make_pair(0, x);
    }
    if (a < -x)
        return make_pair(BIG, BIG);
    return make_pair(-x, 0);
}

int kl, ku, kd, kr;
int l, u, r, d, n, x, y;
string s;

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.sync_with_stdio(0);
    cin >> n >> s >> x >> y;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == 'U')
            ku++;
        if (s[i] == 'D')
            kd++;
        if (s[i] == 'L')
            kl++;
        if (s[i] == 'R')
            kr++;
    }
    pair<int, int> t1 = solve(kl, kr, x);
    pair<int, int> t2 = solve(kd, ku, y);
    if (t1.first == BIG || t2.first == BIG)
    {
        cout << -1;
        return 0;
    }
    kl = t1.first;
    kr = t1.second;
    kd = t2.first;
    ku = t2.second;
    l = r = u = d = n;
    for (int i = 0; i < n; i++)
    {
        if (kl == 0)
        {
            l = i;
            break;
        }
        if (s[i] == 'L')
            kl--;
    }
    for (int i = 0; i < n; i++)
    {
        if (kr == 0)
        {
            r = i;
            break;
        }
        if (s[i] == 'R')
            kr--;
    }
    for (int i = 0; i < n; i++)
    {
        if (kd == 0)
        {
            d = i;
            break;
        }
        if (s[i] == 'D')
            kd--;
    }
    for (int i = 0; i < n; i++)
    {
        if (ku == 0)
        {
            u = i;
            break;
        }
        if (s[i] == 'U')
            ku--;
    }
    cout << l << " " << u << " " << r << " " << d;
    return 0;
}
