#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <functional>
#include <climits>
#include <cassert>
#include <map>
#include <set>

using namespace std;

typedef unsigned int index;

bool check(int max_v, int k, const vector<pair<pair<int, int>, int>> &seg)
{
	map<int, vector<pair<int, int>>> fld;
	fld[0].push_back({0, 1});
	int yk = -1;
	vector<pair<int, int>> otr;
	for (auto i: seg)
	{
		while (yk < i.first.first)
		{
			
			int nk;
			auto x = fld.upper_bound(yk);
			if (x == fld.end() or x->first > i.first.first)
			{
				nk = i.first.first;
			}
			else
			{
				nk = x->first;
			}
			for (index j = 0; j < otr.size(); j++)
			{
				otr[j].second -= (nk - yk);
			}
			for (index j = (index)otr.size() - 1; j != (index)-1; j--)
			{
				if (otr[j].second <= 0)
					otr.erase(otr.begin() + j);
			}
			auto &io = fld[nk];
			for (auto j: io)
			{
				otr.push_back(j);
			}
			yk = nk;
		}
		int mn = 1e9;
		for (auto j: otr)
		{
			if (i.second + j.first <= max_v)
			{
				mn = min(mn, j.second);
			}
		}
		if (yk + mn <= i.first.second + 1)
		{
			fld[yk + mn].push_back({i.second, i.first.second - yk - mn + 1});
			//cout << yk + mn << " " << i.first.second - yk - mn + 1 << endl;
			fld[i.first.second + 1].push_back({0, 1});
		}
	}
	if (fld[k].size() > 0)
		return true;
	else
		return false;
}

int main() 
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	ios::sync_with_stdio(false);
	size_t n;
	int k;
	cin >> n >> k;
	vector<pair<pair<int, int>, int>> seg(n);
	for (index i = 0; i < n; i++)
	{
		cin >> seg[i].first.first >> seg[i].first.second >> seg[i].second;
		seg[i].first.first--, seg[i].first.second--;
	}
	sort(seg.begin(), seg.end());
	long long l = -1, r = 2e9 + 5;
	while (r - l > 1)
	{
		long long m = (l + r) / 2;
		if (check((int)m, k, seg))
			r = m;
		else
			l = m;

	}
	if (r == (long long)2e9 + 5)
		cout << -1 << endl;
	else
		cout << r << endl;
}
