#include<iostream>
#include<fstream>
#include<vector>
#include<algorithm>
#include<math.h>
#include<cmath>
#define mp make_pair

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

bool next(vector<long long> &a, vector<long long> &result, long long n, long long k)
{
    long long i = 0, maxim = 0;
    for (i = 0; i < n; ++i)
    {
        result[i] = a[i];
    }
    i = n - 1;
    ++result[i];
    --i;
    while (i >= 0 && result[i + 1] == k)
    {
        result[i + 1] = 0;
        ++result[i];
        --i;
    }
    return (result[i + 1] < k);
}

bool check(long long x, long long maxim, vector<long long> &l, long long n)
{
    long long r, j;
    bool flag = true;
    vector<vector<long long> > curr(2, vector<long long> (maxim, 0));
    for (long long i = 1; i < n; ++i)
    {
        r = i % 2;
        if (l[i] > l[i - 1])
        {
            for (j = 0; j < l[i - 1]; ++j)
            {
                curr[r][j] = curr[1 - r][j];
            }
            for (j; j < l[i]; ++j)
            {
                curr[r][j] = 0;
            }
        }
        else if (l[i] < l[i - 1])
        {
            for (j = 0; j < l[i] - 1; ++j)
            {
                curr[r][j] = curr[1 - r][j];
            }
            curr[r][j] = curr[1 - r][j] + 1;
            if (curr[r][j] >= x)
                flag = false;
        }
        else if (l[i] == l[i - 1])
        {
            if (!next(curr[1 - r], curr[r], l[i - 1], x))
                flag = false;
        }
        if (!flag)
            break;
    }
    return flag;
}

long long bin_search(long long lef, long long r, long long maxim, vector<long long> &l, long long n)
{
    while (r - lef > 1)
    {
        long long m = (r + lef) / 2;
        if (check(m, maxim, l, n))
            r = m;
        else
            lef = m;
    }
    return r;
}

int main()
{
    long long n, maxim = 0, sum = 0, ans;
    in >> n;
    vector<long long> l(n);
    for (long long i = 0; i < n; ++i)
    {
        in >> l[i];
        maxim = max(l[i], maxim);
        sum += l[i];
    }
    ans = bin_search(0, sum + 1, maxim + 1, l, n);
    out << ans << endl;
    return 0;
}
