#include<iostream>
#include<fstream>
#include<vector>
#include<algorithm>
#include<math.h>
#include<cmath>
#define mp make_pair

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

struct z
{
    int l, r;
    long long p;
};

struct event
{
    int segm, type, ind;
    long long p;
    bool operator< (const event &b) const
    {
        if (segm != b.segm)
            return segm < b.segm;
        if (type != b.type)
            return type < b.type;
        if (p != b.p)
            return p < b.p;
        return ind < b.ind;
    }
};

void seq_0_1(vector<int> &chosen, int n, vector<vector<int> > &all_chosen)
{
    if (chosen.size() == n)
    {
        all_chosen.push_back(chosen);
        return;
    }
    chosen.push_back(0);
    seq_0_1(chosen, n, all_chosen);
    chosen[(int)chosen.size() - 1] = 1;
    seq_0_1(chosen, n, all_chosen);
    chosen.pop_back();
}

int main()
{
    int n, k, ind_0;
    bool flag, flag_ans = false;
    long long cnt, maxim, minim_ans = -1;
    in >> n >> k;
    vector<z> all_z(n);
    vector<event> ev;
    event x;
    for (int i = 0; i < n; ++i)
    {
        in >> all_z[i].l >> all_z[i].r >> all_z[i].p;
        x.segm = all_z[i].l;
        x.type = -1;
        x.ind = i;
        x.p = all_z[i].p;
        ev.push_back(x);
        x.segm = all_z[i].r;
        x.type = 1;
        x.ind = i;
        x.p = all_z[i].p;
        ev.push_back(x);
    }
    sort(ev.begin(), ev.end());
    vector<int> chosen;
    vector<vector<int> > all_chosen;
    seq_0_1(chosen, n, all_chosen);
    for (int i = 0; i < all_chosen.size(); ++i)
    {
        flag = true;
        ind_0 = -1;
        maxim = 0;
        cnt = 0;
        for (int j = 0; j < ev.size(); ++j)
        {
            if (all_chosen[i][ev[j].ind] == 0)
                continue;
            if (cnt == 0 && flag)
            {
                if (ind_0 == -1)
                    flag = (ev[j].segm == 1);
                else
                    flag = (ev[j].segm == ev[ind_0].segm + 1);
            }
            cnt += (-ev[j].type) * ev[j].p;
            maxim = max(maxim, cnt);
            if (cnt == 0)
            {
                ind_0 = j;
            }
        }
        if (cnt == 0 && flag)
        {
            flag = (k == ev[ind_0].segm);
        }
        flag_ans = flag_ans | flag;
        if (flag)
        {
            if (minim_ans == -1)
                minim_ans = maxim;
            minim_ans = min(minim_ans, maxim);
        }
    }
    if (flag_ans)
    {
        out << minim_ans << endl;
    }
    else
        out << -1 << endl;
    return 0;
}
