#include <bits/stdc++.h>
using namespace std;

#define int long long

const int maxn = 6e5+5, inf = 1e18;

/*
struct segtree{
    int lb, rb, t;
    segtree *l, *r;
    int s = 0;
    segtree(int _lb, int _rb){
        lb = _lb, rb = _rb;
        if(lb != rb){
            int t = (lb+rb)/2;
            l = new segtree(lb, t);
            r = new segtree(t+1, rb);
        }
    }
    void add(int k, int x){
        s += x;
        if(lb != rb){
            if(k <= t) l->add(k, x);
            else r->add(k, x);
        }
    }
    int sum(int lq, int rq){
        if(lq <= lb && rb <= rq) return s;
        if(rq < lb || rb < lq) return 0;
        return l->sum(lq, rq) + r->sum(lq, rq);
    }
};
*/

struct dt{
    int l, r, p, dp = inf;
};

//int d[maxn];
dt t[maxn];

vector<dt> q[maxn];

main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    set<int> s;
    map<int, int> m;

    s.insert(1);
    s.insert(k);

    for(int i = 0; i < n; i++){
        cin >> t[i].l >> t[i].r >> t[i].p;
        s.insert(max(1ll, t[i].l-1));
        s.insert(min(k, t[i].l+1));
        s.insert(max(1ll, t[i].r-1));
        s.insert(min(k, t[i].r+1));
        s.insert(t[i].l);
        s.insert(t[i].r);
    }

    int cnt = 0;
    for(auto x : s)
        m[x] = cnt++;

    k = m[k];

    for(int i = 0; i < n; i++){
        t[i].r = m[t[i].r];
        t[i].l = m[t[i].l];
        /*
        d[t[i].l]++;
        d[t[i].l+1]--;
        */
        q[t[i].r].push_back(t[i]);
    }

    /*
    sort(t.begin(), t.end(), [](t a, t b){
        return a.r < b.r;
    });
    */

    /*
    int sum = 0;
    for(int i = 0; i < cnt; i++){
        sum += d[i];
        if(sum == 0) cout << -1, exit(0);
    }
    */

    vector<dt> w;

    int ans = inf;
    for(int i = 0; i < cnt; i++){
        for(dt a : q[i]){
            if(a.l == 0) a.dp = a.p;
            for(dt b : w){
                if(b.r == a.l-1)
                    a.dp = min(a.dp, max(b.dp, a.p));
                if(b.r >= a.l)
                    a.dp = min(a.dp, max(b.dp, a.p + b.p));
            }
            w.push_back(a);
            if(i == k) ans = min(ans, a.dp);
            //cerr << a.l << " " << a.r << " " << a.p << " " << a.dp << endl;
        }
    }

    if(ans < inf) cout << ans;
    else cout << -1;

    return 0;
}
