#include <bits/stdc++.h>
using namespace std;

#define int long long

const int maxn = 6e5+5, inf = 1e18;

struct dt{
    int l, r, p, dp = inf;
};

//int d[maxn];
dt t[maxn];

int dp[3005][10000];
int dp3[maxn];

vector<int> q[maxn];

main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    set<int> s;
    map<int, int> m;

    s.insert(1);
    s.insert(k);

    for(int i = 0; i < n; i++){
        cin >> t[i].l >> t[i].r >> t[i].p;
        s.insert(max(1ll, t[i].l-1));
        s.insert(min(k, t[i].l+1));
        s.insert(max(1ll, t[i].r-1));
        s.insert(min(k, t[i].r+1));
        s.insert(t[i].l);
        s.insert(t[i].r);
    }

    int cnt = 0;
    for(auto x : s)
        m[x] = cnt++;

    k = m[k];

    for(int i = 0; i < n; i++){
        t[i].r = m[t[i].r];
        t[i].l = m[t[i].l];
        /*
        d[t[i].l]++;
        d[t[i].l+1]--;
        */
        q[t[i].r].push_back(i);
    }

    int ans = inf;

    if(n > 3000){
        int last = -1;
        for(int i = 0; i < cnt; i++){
            dp3[i] = inf;
            for(int x : q[i]){
                dt a = t[x];
                if(a.l == 0) a.dp = 1;
                else a.dp = dp3[a.l-1];
                if(last >= a.l)
                    a.dp = min(a.dp, 2ll);
                if(a.dp < inf) last = i;
                dp3[a.r] = min(dp3[a.r], a.dp);
                if(i == k) ans = min(ans, a.dp);
            }
        }
    }
    else{
        for(int i = 0; i < cnt; i++){
            for(int x : q[i]){
                dt a = t[x];
                if(a.l == 0){
                    for(int j = a.l; j <= a.r; j++)
                        dp[x][j] = a.p;
                }
                else{
                    dp[x][a.l] = inf;
                    for(int y : q[a.l-1])
                        dp[x][a.l] = min(dp[x][a.l], max(dp[y][a.l-1], a.p));
                    for(int j = a.l+1; j <= a.r; j++){
                        dp[x][j] = dp[x][j-1];
                        for(int y : q[j-1]){
                            //cerr << x << " " << y << endl;
                            dt b = t[y];
                            if(b.l < a.l){
                                dp[x][j] = min(dp[x][j], max(dp[y][a.l-1], b.p+a.p));
                            }
                        }
                    }
                }
                /*
                for(int j = a.l; j <= a.r; j++)
                    cerr << x << " " << j << " " << dp[x][j] << endl;
                */
                if(i == k) ans = min(ans, dp[x][k]);
            }
        }
    }

    if(ans < inf) cout << ans;
    else cout << -1;

    return 0;
}
