#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ld long double

struct Node {
    int l;
    int r;
    int p;
    Node(int l, int r, int p) : l(l), r(r), p(p) {}
};

typedef Node * node;

int n, m;
const ll INF = 1e15;
const int MAXM = 1e5 + 1;
node st[MAXM];
map<pair<int, int>, bool> used;
map<pair<int, int>, ll> dp;

inline bool cmp(node a, node b) {
    return a -> l < b -> l;
}

inline int bins(int x) {
    int l = -1;
    int r = n - 1;
    int m;
    while (l + 1 < r) {
        m = (l + r) / 2;
        if (st[m] -> l >= x) {
            r = m;
        }
        else {
            l = m;
        }
    }
    return r;
}

ll lazy_dp(int x, int i) {
    if (i != -1 && st[i] -> r == m) {
        return st[i] -> p;
    }
    if (used[mp(x, i)])
        return dp[mp(x, i)];
    used[mp(x, i)] = 1;
    ll now_ans = 0;
    int maxi = x;
    ll bans = INF;
    if (i != -1) {
        now_ans = st[i] -> p;
        maxi = st[i] -> r;
    }
    int v = bins(x);
    int j = v;
    for (; j < n && st[j] -> l <= maxi; ++j) {
        if (st[j] -> r > maxi) {
            bans = min(bans, max(lazy_dp(maxi + 1, j), st[j] -> p + (maxi == st[j] -> l ? 0 : now_ans)));
        }
    }
    return dp[mp(x, i)] = bans;
}

int main() {
    scanf("%d%d", &n, &m);
    int p, q, c;
    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &p, &q, &c);
        --p;
        st[i] = new Node(p, q, c);
    }
    sort(st, st + n, cmp);
    ll v = lazy_dp(0, -1);
    if (v >=INF) {
        cout << -1;
    }
    else {
        cout << v;
    }
}
