#include <stdio.h>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds;*/

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vvi graph;
typedef vector<char> vc;
typedef pair<int, int> pii;

/* <-----------------------------------------------------------------------------> */

const int MX = 1e6 + 7;

char s[MX], lf[MX], up[MX], rg[MX], dw[MX];

void imp()
{
    printf("-1");
}

void solve()
{
    int n, x, y;
    scanf("%d", &n);
    scanf("%s", s);
    scanf("%d%d", &x, &y);

    int x1 = 0, y1 = 0;
    forn (i, n)
    {
        if (s[i] == 'L') --x1;
        if (s[i] == 'R') ++x1;
        if (s[i] == 'U') ++y1;
        if (s[i] == 'D') --y1;
    }

    int dx = x - x1, dy = y - y1, ans_l = -1, ans_u = -1, ans_r = -1, ans_d = -1;

    int cnt_l = 0, cnt_r = 0, cnt_u = 0, cnt_d = 0;

    for (int i = n - 1; i >= 0; --i)
    {
        lf[i] = cnt_l;
        rg[i] = -cnt_r;
        up[i] = -cnt_u;
        dw[i] = cnt_d;
    }

    if (dx > 0)
    {
        int i;
        for (i = 0; i < n; ++i)
            if (lf[i] == dx)
            {
                ans_l = i;
                break;
            }
        if (i == n) return imp();
    }
    else if (dx < 0)
    {
        int i;
        for (i = 0; i < n; ++i)
            if (rg[i] == dx)
            {
                ans_r = i;
                break;
            }
        if (i == n) return imp();
    }

    if (dy > 0)
    {
        int i;
        for (i = 0; i < n; ++i)
            if (dw[i] == dy)
            {
                ans_d = i;
                break;
            }
        if (i == n) return imp();
    }
    else if (dy < 0)
    {
        int i;
        for (i = 0; i < n; ++i)
            if (up[i] == dy)
            {
                ans_u = i;
                break;
            }
        if (i == n) return imp();
    }

    printf("%d %d %d %d", ans_l + 1, ans_u + 1, ans_r + 1, ans_d + 1);
}

/* <-----------------------------------------------------------------------------> */

// #define LOCAL
// #define FILE_NAME

int main()
{
#if defined LOCAL
    freopen("input.txt", "r", stdin);
#elif defined FILE_NAME
    freopen(FILE_NAME".in", "r", stdin);
    freopen(FILE_NAME".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
