#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

const long long big_num = 1000000007;

int dfs(vector <vector <int> > &graf, vector <int> &v, vector <long long> &powers, int colors, int u) {
    int w, counter, res, tmp, len;
    len = powers.size();
    if (graf[u].size() == 0) {
        res = 1;
    }
    else {
        counter = 0;
        vector <pair <int, int> > suns;
        for (int i = 0; i < graf[u].size(); i++) {
            w = graf[u][i];
            tmp = dfs(graf, v, powers, colors, w);
            suns.push_back(make_pair(tmp, v[w] - v[u]));
        }
/*
        if (u == 4) {
            cout << "adsfgds\n";
            for (int i = 0; i < suns.size(); i++) {
                cout << suns[i].first << ' ' << suns[i].second << '\n';
            }
        }
*/
        if (colors == 1) {
            for (int i = 0; i < graf[u].size(); i++) {
                counter += suns[i].first;
            }
            res = counter;
        }
        else {
            pair <int, int> now;
            now = suns[0];

            for (int i = 1; i < graf[u].size(); i++) {
                if (now.second - suns[i].second > len) {
                    tmp = 1;
                }
                else {
                    tmp = (now.first - 1) / powers[now.second - suns[i].second] + 1;
                }
                now = suns[i];
                now.first += tmp;
            }
            if (now.second > len) {
                res = 1;
            }
            else {
                res = (now.first - 1) / powers[now.second] + 1;
            }
        }
    }
    //cout << colors << ' ' << u << ' ' << res << '\n';
    return res;
}

bool check(vector <vector <int> > &graf, vector <int> &v, int colors, int n) {
    int tmp;
    vector <long long> powers;
    powers.push_back(1);
    if (colors > 1) {
        while (powers[powers.size() - 1] < big_num) {
            powers.push_back(powers[powers.size() - 1] * colors);
        }
    }
    tmp = dfs(graf, v, powers, colors, n);
    //cout << '\n';
    if (tmp == 1) {
        return true;
    }
    else {
        return false;
    }
}

int main() {
    ifstream fin;
    fin.open("input.txt");
    ofstream fout;
    fout.open("output.txt");
    int n, left, right, mid;
    bool flag;
    fin >> n;
    vector <int> v(n);
    for (int i = 0; i < n; i++) {
        fin >> v[i];
    }
    v.push_back(0);
    vector <vector <int> > graf(n + 1, vector <int> ());
    vector <pair <int, int> > stak;
    stak.push_back(make_pair(0, n));
    for (int i = 0; i < n; i++) {
        while (v[i] <= stak[stak.size() - 1].first) {
            stak.pop_back();
        }
        graf[stak[stak.size() - 1].second].push_back(i);
        stak.push_back(make_pair(v[i], i));
    }
/*
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < graf[i].size(); j++) {
            cout << graf[i][j] << ' ';
        }
        cout << '\n';
    }
    cout << '\n';
*/
    left = 0;
    right = n;
    while (right - left > 1) {
        mid = (left + right) / 2;
        flag = check(graf, v, mid, n);
        //cout << mid << ' ' << flag << '\n';
        if (flag) {
            right = mid;
        }
        else {
            left = mid;
        }
    }
    fout << right;
    fin.close();
    fout.close();
    return 0;
}
