#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <ctime>

using namespace std;

#pragma warning(disable : 4996)

const int MAXN = 1e5 + 10;

int n, a[MAXN], now[MAXN * 2];

int silly_solve() {
	for (int i = 1; i <= 10; i++) {
		long long k = 1;
		for (int j = 0; j < a[0]; j++) {
			k *= i;
		}
		if (k >= n) {
			return i;
		}
	}
}


int solve() {
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < a[0]; j++) {
			now[j] = 1;
		}
		bool t = true;
		for (int j = 1; j < n; j++) {
			int k = a[j - 1] - 1;
			while (k > -1 && now[k] == i) {
				k--;
			}
			if (k < 0) {
				t = false;
				break;
			}
			now[k]++;
			for (k++; k < a[j]; k++) {
				now[k] = 1;
			}
			for (; k < n; k++) {
				now[k] = 0;
			}
		}
		if (t) {
			return i;
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
	/*freopen("", "r", stdin);
	freopen("", "w", stdout);*/
#endif
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cout << solve() << "\n\n";
	return 0;
}