#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <ctime>
#include <unordered_map>

using namespace std;

#pragma warning(disable : 4996)

const int MAXN = 1e5 + 10;

int n, k, l[MAXN], r[MAXN], p[MAXN], ans = -1, now[50];
unordered_map < int, int > kek;
vector < int > tmp, un;

void gen(int i) {
	if (i == n) {
		vector < int > po(un.size(), 0);
		vector < pair < int, int > > pp;
		for (int i = 0; i < n; i++) {
			if (now[i] == 1) {
				pp.push_back(make_pair(l[i], r[i]));
				for (int j = kek[l[i]]; j <= kek[r[i]]; j++) {
					po[j] += p[i];
				}
			}
		}
		if (pp.size() < 1) return;
		sort(pp.begin(), pp.end());
		int mar = pp[0].second + 1;
		for (int j = 0; j < pp.size(); j++) {
			if (pp[j].first > mar) return;
			mar = max(mar, pp[j].second);
		}
		int ans_ = -1;
		for (int i = 0; i < po.size(); i++) {
			if (un[i] <= k && po[i] == 0) {
				return;
			}
			ans_ = max(ans_, po[i]);
		}
		if (ans == -1 || ans > ans_) {
			ans = ans_;
		}
		return;
	}
	now[i] = 0;
	gen(i + 1);
	now[i] = 1;
	gen(i + 1);
	now[i] = 0;
}

void silly_solve() {
	for (int i = 0; i < n; i++) {
		tmp.push_back(l[i]);
		tmp.push_back(r[i]);
	}
	tmp.push_back(1);
	tmp.push_back(k);
	sort(tmp.begin(), tmp.end());
	unique(tmp.begin(), tmp.end());
	un.push_back(tmp[0]);
	for (int i = 1; i < tmp.size(); i++) {
		if (tmp[i - 1] < tmp[i]) {
			un.push_back(tmp[i]);
		}
		else {
			break;
		}
	}
	for (int i = 0; i < un.size(); i++) {
		kek[un[i]] = i;
		//cout << un[i] << " ";
	}
	//cout << "\n";
	gen(0);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
	/*freopen("", "r", stdin);
	freopen("", "w", stdout);*/
#endif
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> p[i];
	}
	silly_solve();
	cout << ans;
	return 0;
}