#include <bits/stdc++.h>
#define F first
#define S second
#define endl "\n"
#define ALL(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)1e5;

int n, k;
pair <pair <int, int>, int> data[N + 2];
int nxt[N + 2];

void init(ll hex) {
    for (int i = 0; i < n + 2; ++i) {
        nxt[i] = -1;
        for (int j = i + 1; j < n + 2; ++j) {
            if (data[i].F.F < data[j].F.F && data[j].F.F < data[i].F.S) {
                if (data[i].S + data[j].S <= hex) {
                    if (nxt[i] == -1 || data[j].F.S > data[nxt[i]].F.S) {
                        nxt[i] = j;
                    }
                }
            } else {
                if (data[i].F.S == data[j].F.F) {
                    if (data[i].S <= hex && data[j].S <= hex) {
                        if (nxt[i] == -1 || data[j].F.S > data[nxt[i]].F.S) {
                            nxt[i] = j;
                        }
                    }
                }
            }
        }
    }
    nxt[n + 1] = n + 1;
}

bool check() {
    for (int k = 0; k < 64; ++k) {
        for (int i = 0; i < n + 2; ++i) {
            if (nxt[i] != -1) {
                nxt[i] = nxt[nxt[i]];
            }
        }
    }

    if (nxt[0] == n + 1) {
        return 1;
    } else {
        return 0;
    }
}

ll check(vector <pair <pair <int, int>, int> > data) {
    ll res = 0, np = 0;

    vector <pair <int, int> > her;
    for (auto v : data) {
        her.push_back({v.F.F, -v.S});
        her.push_back({v.F.S, v.S});
    }

    sort(ALL(her));

    int cnt = 0;
    int last = 0;
    for (auto v : her) {
        if (cnt == 0) {
            if (v.F - last > 1) {
                return (ll)1e18;
            }
        }

        np -= v.S;
        res = max(res, np);
        if (v.S < 0) {
            ++cnt;
        } else {
            --cnt;
        }
        last = v.F;
    }

    if (k - last > 0) {
        return (ll)1e18;
    }
    return res;
}

void sub1() {
    for (int i = 0; i < n; ++i) {
        cin >> data[i].F.F >> data[i].F.S >> data[i].S;
    }

    if (n <= 20) {
        ll ans = (ll)1e18;
        for (int mask = 1; mask < (1 << n); ++mask) {
            vector <pair <pair <int, int>, int> > her;
            for (int i = 0; i < n; ++i) {
                if ((mask & (1 << i)) != 0) {
                    her.push_back(data[i]);
                }
            }

            ans = min(ans, check(her));
        }

        if (ans == (ll)1e18) {
            cout << -1;
        } else {
            cout << ans;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    #ifdef _HOME_
        //freopen("in.in", "r", stdin);
        //freopen("in.in", "w", stdout);
    #endif // _HOME_

    cin >> n >> k;

    if (n <= 20) {
        sub1();
    } else {
        for (int i = 1; i <= n; ++i) {
            cin >> data[i].F.F >> data[i].F.S >> data[i].S;
            data[i].F.S++;
        }
        data[0] = {{0, 1}, 0};
        data[n + 1] = {{k + 1, k + 2}, 0};
        sort(data, data + (n + 2));

        ll l = 0, r = (ll)1e18, m;
        while (r - l > 1) {
            m = (l + r) >> 1;

            init(m);
            if (check()) {
                r = m;
            } else {
                l = m;
            }
        }

        if (r == (ll)1e18) {
            cout << "-1" << endl;
        } else {
            cout << r << endl;
        }
    }

    return 0;
}
