#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
using namespace std;
typedef long long ll;
typedef long double ld;

inline ll get() {
	ll x;
	cin >> x;
	return x;
}

void solve();

int main() {
#ifdef _DEBUG
	freopen("../input.txt", "r", stdin);
	freopen("../output.txt", "w", stdout);
#endif
	solve();
}

vector<ll> v;

bool check(ll n) {
	vector<ll> s(v[0], 0);
	for (ll i = 1;i < v.size();i++) {
		if (v[i] > v[i - 1]) {
			s.resize(v[i], 0);
		}
		else if (v[i] == v[i - 1]) {
			for (ll j = s.size() - 1;j >= 0;j--) {
				s[j]++;
				if (s[j] == n && j != 0) s[j] = 0;
				else break;
			}
			if (s[0] == n) return false;
		}
		else if (v[i] < v[i - 1]) {
			s.resize(v[i]);
			for (ll j = s.size() - 1;j >= 0;j--) {
				s[j]++;
				if (s[j] == n && j != 0) s[j] = 0;
				else break;
			}
			if (s[0] == n) return false;
		}
	}
	return true;
}

void solve() {
	ll n = get();
	v.resize(n);
	for (ll i = 0;i < n;i++) {
		cin >> v[i];
	}
	ll l = 0, r = 100001;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if (check(m)) r = m;
		else l = m;
	}
	cout << r;
}