#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
using namespace std;
typedef long long ll;
typedef long double ld;

inline ll get() {
	ll x;
	cin >> x;
	return x;
}

void solve();

int main() {
#ifdef _DEBUG
	freopen("../input.txt", "r", stdin);
	freopen("../output.txt", "w", stdout);
#endif
	solve();
}

const ll INF = 2e18;
const pair<ll, ll> kuk = { 0ll, 0ll };

struct IT {
	map<ll, pair<ll,ll>> t;
	map<ll, pair<ll,ll>> sm;
	ll sz;
	IT(ll k) {
		sz = 1;
		while (sz < k) sz *= 2;
		sz--;
	}
	void push(ll v) {
		pair<ll,ll> kek = sm[v];
		if (sm[v * 2 + 1] == kuk) sm[v * 2 + 1] = kek;
		else sm[v * 2 + 1] = min(sm[v * 2 + 1], kek);
		if (sm[v * 2 + 2] == kuk) sm[v * 2 + 2] = kek;
		else sm[v * 2 + 2] = min(sm[v * 2 + 2], kek);
		sm[v] = { INF, INF };
	}
	pair<ll,ll> update(ll v, ll tl, ll tr, ll l, ll r, ll x, ll num) {
		if (tl > l || tr < r || l > r) return{ INF, INF };
		if (tl == l && tr == r) {
			if (sm[v] == kuk) sm[v] = { x, num };
			else sm[v] = min(sm[v], { x, num });
			if (t[v] == kuk) return sm[v];
			else return min(t[v], sm[v]);
		}
		ll tm = (tr + tl) / 2;
		t[v] = min(update(v * 2 + 1, tl, tm, l, min(tm, r), x, num), update(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r, x, num));
	}
	void update(ll l, ll r, pair<ll, ll> kek) {
		update(0, 0, sz, l, r, kek.first, kek.second);
	}
	pair<ll, ll> get_min(ll v, ll tl, ll tr, ll pos) {
		if (tl > pos || tr < pos) return{ INF, INF };
		if (tl == tr && tl == pos) {
			if (t[v] == kuk) return{ INF, INF };
			return t[v];
		}
		push(v);
		ll tm = (tr + tl) / 2;
		t[v] = min(get_min(v * 2 + 1, tl, tm, pos), get_min(v * 2 + 2, tm + 1, tr, pos));
		return t[v];
	}
	pair<ll, ll> get_min(ll pos) {
		return get_min(0, 0, sz, pos);
	}
};

void solve() {
	ll n = get(), k = get();
	vector<pair<pair<ll,ll>, ll>> kek(n);
	vector<ll> posX, pos;
	vector<pair<ll, ll>> tt;
	for (ll i = 0;i < n;i++) {
		cin >> kek[i].first.first >> kek[i].first.second >> kek[i].second;
		kek[i].first.first--, kek[i].first.second--;
	}
	kek.push_back({ {0,0},0 });
	sort(kek.begin(), kek.end());
	vector<ll> d(n + 1, INF);
	d[0] = 0;
	for (ll i = 1;i <= n;i++) {
		for (ll j = 0;j < i;j++) {
			if (kek[i].first.first <= kek[j].first.second)
				d[i] = min(d[i], d[j] + kek[i].second);
			else if (kek[i].first.first - 1 == kek[j].first.second)
				d[i] = min(d[i], d[j]);
		}
	}
	ll ans = INF;
	for (ll i = 0;i <= n;i++) {
		if (kek[i].first.second == k - 1)
			ans = min(ans, d[i]);
	}
	if (ans == INF) cout << -1;
	else cout << ans;
}


































/*IT tree(k);
ll mx = 0;
vector<ll> pr(n, -1);
for (ll i = 0;i < n;i++) {
if (kek[i].second.first != 0) {
pair<ll, ll> tmp = tree.get_min(kek[i].second.first - 1);
if (tmp.first == INF || tmp.first == 0) {
cout << -1;
return;
}
pr[i] = tmp.second;
}
pair<ll, ll> tmp = tree.get_min(kek[i].second.first);
if (tmp.first == INF || tmp.first == 0) {
tmp.first = 0;
}
else pr[i] = tmp.second;
tmp.first += kek[i].first;
tmp.second = i;
tree.update(kek[i].second.first, kek[i].second.second, tmp);
}
for (ll i = 0;i < n;i++) {
cout << pr[i] << endl;
}*/