#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

///compilation should be fast
///do not include everything
using namespace std;
const int MAXN = 1e5 + 10;
const int INF = 2e9 + 10;
int zap[MAXN][3];
vector <pair <int, int> > v;
vector <vector <int> > gv;
set <int> s;
map <int, int> m;
int n, k;
bool check(int mw){
    m.clear();
    m.insert(make_pair(1, 0));
    for (int i = 0; i < n; i++){
        int y = gv[i][1];
        int x = gv[i][0];
        int w = gv[i][2];
        //cout << x << ' ' << y << ' ' << w << endl;
        int val = INF;
        for (map <int, int>::iterator it = m.begin(); it != m.end(); it++){
            int cp = (it->first);
            int cw = (it->second);
            if (cp == x){
                if (w <= mw){
                    val = min(val, w);
                }
            }
            if (cp > x){
                if (cw + w <= mw){
                    val = min(val, w);
                }
            }
        }
        //for (map <int, int>::iterator it = m.begin(); it != m.end(); it++){
        //    cout << (it->first) << ' ' << (it->second) << endl;
        //}
        //cout << endl << endl;
        if (val == INF){
            continue;
        }
        m.insert(make_pair(y + 1, val));
    }
    if (m.find(k + 1) == m.end()){
        return false;
    }
    else{
        return true;
    }
}

signed main(){

    cin >> n >> k;
    bool flag = true;
    for (int i = 0; i < n; i++){
        cin >> zap[i][0] >> zap[i][1] >> zap[i][2];
        if (zap[i][2] > 1){
            flag = false;
        }
        v.push_back(make_pair(zap[i][0], zap[i][1]));
        vector <int> t;
        t.resize(3);
        t[0] = zap[i][0];
        t[1] = zap[i][1];
        t[2] = zap[i][2];
        gv.push_back(t);
    }

    if (flag){
        sort(v.begin(), v.end());
        s.insert(1);
        int mx = 1;
        for (int i = 0; i < n; i++){
            int x = v[i].first;
            int y = v[i].second;
            if (x <= mx){
                mx = max(mx, y + 1);
            }
            if (s.find(x) != s.end()){
                s.insert(y + 1);
            }
        }
        // 5 1cout << mx << endl;
        if (mx != k + 1){
            cout << -1;
        }
        else if (s.find(k + 1) != s.end()){
            cout << 1;
        }
        else{
            cout << 2;
        }
        cout << endl;
    }
    else{
        sort(gv.begin(), gv.end());
        //check(4);
        int left = 0;
        int right = INF;
        while (right - left > 1){
            int mid = (left + right) / 2;
            if (check(mid)){
                right = mid;
            }
            else{
                left = mid;
            }
        }
        cout << right;
    }

    return 0;
}
