#include<bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 2 * 1e9 + 7;

vector <pair <ll, ll> > ans;

ll bin_search(ll x) {
    ll l = -1, r = ans.size();
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (ans[mid].first >= x) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, k1;
    cin >> n >> k1;
    vector <pair <pair <ll, ll>, ll> > data(n);
    for (ll i = 0; i < n; i++) {
        cin >> data[i].first.second >> data[i].first.first >> data[i].second;
    }
    sort(data.begin(), data.end());
    ll l = 0, r = INF;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        bool fl = 0;
        ans.clear();
        for (ll i = 0; i < data.size(); i++) {
            ll l = data[i].first.second, r = data[i].first.first, w = data[i].second;
            ll now = w;
            if (now > mid) continue;
            if (l == 1) {
                if (!ans.empty() && ans.back().first == r && ans.back().second < now) {
                    continue;
                }
                while (!ans.empty() && ans.back().second >= now) {
                    ans.pop_back();
                }
                ans.push_back({r, now});
                continue;
            }
            ll pos = bin_search(l - 1);
            if (pos == ans.size()) {
                continue;
            }
            if (ans[pos].first > l - 1) {
                if (w + ans[pos].second > mid) continue;
            }
            if (!ans.empty() && ans.back().first == r && ans.back().second < w) {
                continue;
            }
            while (!ans.empty() && ans.back().first != ans[pos].first && ans.back().second >= w) {
                ans.pop_back();
            }
            ans.push_back({r, w});
        }
        if (ans.empty() || ans.back().first < k1) {
            fl = 1;
        }
        if (fl) {
            l = mid;
        } else {
            r = mid;
        }
    }
    if (r == INF) {
        cout << -1;
    } else {
        cout << (ll) r;
    }
}
/*
3 4
1 2 1
2 3 5
4 4 1
*/
