#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <string>
#include <map>
#include <queue>

using namespace std;
int n;
int m[100000];

bool prov(int mid){
    map<int, int> mp;
    set<int> st;
    for (int i = 1; i < n; ++i){
        int id = m[i];
        if (id <= m[i - 1]){
            mp[id]++;
            st.insert(id);
            while (mp[id] == mid){
                mp[id] = 0;
                st.erase(id);
                --id;
                if (id == 0)
                    return false;
                mp[id]++;
                st.insert(id);
            }
            auto it = st.upper_bound(id);
            while (it != st.end()){
                st.erase(it);
                mp[*it] = 0;
                it = st.upper_bound(id);
            }
        }
    }
}

void bin_s(){
    int l = 0, r = 1e5;
    while(r - l > 1){
        int mid = (l + r) / 2;
        if (prov(mid))
            r = mid;
        else
            l = mid;
    }
    cout << r << endl;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i = 0; i < n; ++i){
        cin >> m[i];
    }
    bin_s();
    return 0;
}
