#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <stack>

using namespace std;

const double EPS = 1e-9;

bool equal(double a, double b){
    return (abs(a - b) <= EPS);
}

void bin(){
    long long l = 1, r = 1e2 + 1;
    while (r - l > 1){
        long long mid = (l + r) / 2;
        cout <<'X' << " " << mid << cout.flush();
        long long a, b;
        cin >> a >> b;
        if (a == 0)
            r = mid;
        else
            l = mid;
    }
    cout << 'N' << " " << r - 1 << cout.flush();
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int g;
	cin >> g;
	for (int i = 0; i < g; ++i){
        bin();
	}
	return 0;
}
