#define _CRT_SECURE_NO_WARNINGS
#include <cstdlib>
#include <stdio.h>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <utility>
#include <iostream>
#include <string>
#include <queue>
#include <cassert>
#include <map>

using namespace std;
const long long INF = (long long)5e15;

struct Node {
	long long val, val2, add, l, r;
	Node() { l = -1, r = -1, add = 0, val = 0; val2 = 0; };
};


Node t[400005];
long long it = 2;

long long get_l(long long v) {
	if (t[v].l == -1) {
		return t[v].l = it++;
	}
	return t[v].l;
}

long long get_r(long long v) {
	if (t[v].r == -1) {
		return t[v].r = it++;
	}
	return t[v].r;
}

const long long dd = (long long)1e9;
void push(long long v) {
	t[get_l(v)].val += t[v].add;
	t[get_r(v)].val += t[v].add;
	t[get_r(v)].val2 += t[v].add;
	t[get_l(v)].val2 += t[v].add;
	t[get_r(v)].add += t[v].add;
	t[get_l(v)].add += t[v].add;
	t[v].add = 0;
}

void upd(long long v, long long tl, long long tr, long long l, long long r, long long _val) {
	if (tl != tr)
	push(v); 
	if (l > tr || r < tl)
		return;
	if (tl >= l && tr <= r) {
		t[v].add += _val;
		t[v].val += _val;
		t[v].val2 += _val;
		return;
	}
	long long tm = (tl + tr) / 2;
	upd(get_l(v), tl, tm, l, r, _val);
	upd(get_r(v), tm + 1, tr, l, r, _val);
	t[v].val = min(t[get_l(v)].val, t[get_r(v)].val);
}

long long get(long long v, long long tl, long long tr, long long l, long long r) {
	if (tl != tr)
	push(v);
	if (l > tr || r < tl)
		return INF;
	if (tl >= l && tr <= r) {
		return t[v].val;
	}
	long long tm = (tl + tr) / 2;
	return min(get(get_l(v), tl, tm, l, r), get(get_r(v), tm + 1, tr, l, r));
}

int main() {
	if (1) {
		freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);

	}

	long long n;
	cin >> n;
	
	vector<long long > g(n);
	long long mxlen = 0;
	for (long long i = 0; i < n; i++) {
		cin >> g[i];
		mxlen = max(mxlen, g[i]);
	}
	mxlen--;
	long long l = 0, r = (long long)1e5;
	
	while (r - l > 1) {
		long long m = (l + r) / 2;
		bool ok = true;
		for (long long i = 0; i < 400000; i++) {
			t[i].add = t[i].val = t[i].val2 = 0;
			t[i].l = t[i].r = -1;
		}
		for (long long i = 1; i < n; i++) {
			if (g[i] > g[i - 1]) {
				continue;
			}
			else {
				long long tl = -1, tr = g[i] ;
				while (tr - tl > 1) {
					long long tm = (tl + tr);
					if (get(1, 0, mxlen, tm, g[i] - 1) < m - 1)
						tl = tm;
					else
						tr = tm;
				}
				if (tl == -1) {
					ok = false;
					break;
				}
				else {
					upd(1, 0, mxlen, tl, tl, 1);
					if (tl != g[i - 1] - 1) {
						upd(1, 0, mxlen, tl + 1, mxlen, -m + 1);
					}
				}
			}
		}
		if (ok) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
	return 0;
}