#define _CRT_SECURE_NO_WARNINGS
#include <cstdlib>
#include <stdio.h>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <utility>
#include <iostream>
#include <string>
#include <queue>
#include <cassert>
#include <map>

using namespace std;
const long long INF = (long long)5e15;

map<int, int> sz, rev;

int t[(int)4e5], add[(int)4e5];

void push(int v) {
	t[v * 2] += add[v];
	t[v * 2 + 1] += add[v];
	add[v * 2] += add[v];
	add[v * 2 + 1] += add[v];
	add[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int val) {
	if (tl != tr)
		push(v);
	if (l > tr || r < tl)
		return;
	if (tl >= l && tr <= r) {
		add[v] += val;
		t[v] += val;
		return;
	}
	int tm = (tl + tr) / 2;
	upd(v * 2, tl, tm, l, r, val);
	upd(v * 2 + 1, tm + 1, tr, l, r, val);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int go(int v, int tl, int tr, int val) {
	push(v);
	if (tl == tr) {
		if (t[v] >= val)
			return tl;
		else
			return tl + 1;
	}
	int tm = (tl + tr) / 2;
	if (t[v * 2 + 1] >= val) {
		return go(v * 2, tl, tm, val);
	}
	else {
		return go(v * 2 + 1, tm + 1, tr, val);
	}
}
int main() {
	if (1) {
		freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
	}
	int n;
	scanf("%d", &n);
	vector<int> g(n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &g[i]);
	}
	int mxx = 0;
	for (int i = 0; i < n; i++) {
		mxx = max(mxx, g[i]);
	}
	mxx--;
	assert(mxx < 1e5);
	int l = 0, r = 1e5;
	while (r - l > 1) {
		int m = (l + r) / 2;
		for (int i = 0; i < 4e5; i++) {
			t[i] = 0, add[i] = 0;
		}
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (g[i] > g[i - 1]) {
				continue;
			}
			else {
				int pos = go(1, 0, mxx, m - 1);
				if (pos == 0) {
					ok = false;
					break;
				}
				else {
					upd(1, 0, mxx, pos - 1, pos - 1, 1);
					upd(1, 0, mxx, pos, mxx, -m + 1);
				}
			}
		}
		if (!ok) {
			l = m;
		}
		else {
			r = m;
		}
	}
	printf("%d", r);
	return 0;
}