#define _CRT_SECURE_NO_WARNINGS
#include <cstdlib>
#include <stdio.h>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <utility>
#include <iostream>
#include <string>
#include <queue>
#include <cassert>
#include <map>

using namespace std;
const long long INF = (long long)5e15;

map<int, int> sz, rev;

int t[(int)4e5], add[(int)4e5];

void push(int v) {
	t[v * 2] += add[v];
	t[v * 2 + 1] += add[v];
	add[v * 2] += add[v];
	add[v * 2 + 1] += add[v];
	add[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int val) {
	if (tl != tr)
		push(v);
	if (l > tr || r < tl)
		return;
	if (tl >= l && tr <= r) {
		add[v] += val;
		t[v] += val;
		return;
	}
	int tm = (tl + tr) / 2;
	upd(v * 2, tl, tm, l, r, val);
	upd(v * 2 + 1, tm + 1, tr, l, r, val);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}


int get(int v, int tl, int tr, int l, int r) {
	if (tl != tr)
		push(v);
	if (l > tr || r < tl)
		return INF;
	if (tl >= l && tr <= r) {
		return t[v];
	}
	int tm = (tl + tr) / 2;
	return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}

int main() {
	if (1) {
		freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
	}
	int n;
	scanf("%d", &n);
	vector<int> g(n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &g[i]);
	}
	int mxx = 0;
	for (int i = 0; i < n; i++) {
		mxx = max(mxx, g[i]);
	}
	assert(mxx < 1e5);
	mxx--;
	int l = 0, r = 1e6;
	while (r - l > 1) {
		int m = (l + r) / 2;
		for (int i = 0; i < 4e5; i++) {
			t[i] = 0, add[i] = 0;
		}
		int lstsz = g[0];
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (g[i] > g[i - 1]) {
				continue;
			}
			else {
				int tl = 0, tr = g[i];
				while (tr - tl > 1) {
					int tm = (tl + tr) / 2;
					if (get(1, 0, mxx, tm, g[i] - 1) < m - 1) {
						tl = tm;
					}
					else {
						tr = tm;
					}
				}
				if (get(1, 0, mxx, tl, tl) < m - 1) {
					upd(1, 0, mxx, tl, tl, 1);
					if (tl < g[i - 1]) {
						upd(1, 0, mxx, tl + 1, g[i - 1], -m + 1);
					}
				}
				else {
					ok = false;
					break;
				}
			}
		}
		if (!ok) {
			l = m;
		}
		else {
			r = m;
		}
	}
	printf("%d", r);
	return 0;
}