#define _CRT_SECURE_NO_WARNINGS
#include <cstdlib>
#include <stdio.h>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <utility>
#include <iostream>
#include <string>
#include <queue>
#include <cassert>
#include <map>

using namespace std;
const long long INF = (long long)5e15;


int it = 2;

int t[(int)1e6], add[(int)1e6], lf[(int)1e6], rf[(int)1e6], st[(int)1e6];

int getl(int v) {
	if (lf[v] == -1) {
		return lf[v] = it++;
	}
	return lf[v];
}

int getr(int v) {
	if (rf[v] == -1) {
		return rf[v] = it++;
	}
	return rf[v];
}

void push(int v) {
	if (st[v] != -1) {
		t[v * 2] = t[v * 2 + 1] = st[v];
		add[v] = 0;
		st[v] = -1;
	}
	t[getl(v)] += add[v];
	t[getr(v)] += add[v];
	add[getl(v)] += add[v];
	add[getr(v)] += add[v];
	add[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int val) {
	if (tl != tr)
		push(v);
	if (l > tr || r < tl)
		return;
	if (tl >= l && tr <= r) {
		add[v] += val;
		t[v] += val;
		return;
	}
	int tm = (tl + tr) / 2;
	upd(getl(v), tl, tm, l, r, val);
	upd(getr(v), tm + 1, tr, l, r, val);
	t[v] = min(t[getl(v)], t[getr(v)]);
}

void tt(int v, int tl, int tr, int l, int r, int val) {
	if (tl != tr)
		push(v);
	if (l > tr || r < tl)
		return;
	if (tl >= l && tr <= r) {
		add[v] = 0;
		t[v] = val;
		st[v] = val;
		return;
	}
	int tm = (tl + tr) / 2;
	tt(getl(v), tl, tm, l, r, val);
	tt(getr(v), tm + 1, tr, l, r, val);
	t[v] = min(t[getl(v)], t[getr(v)]);
}


int get(int v, int tl, int tr, int l, int r) {
	if (tl != tr)
		push(v);
	if (l > tr || r < tl)
		return INF;
	if (tl >= l && tr <= r) {
		return t[v];
	}
	int tm = (tl + tr) / 2;
	return min(get(getl(v), tl, tm, l, r), get(getr(v), tm + 1, tr, l, r));
}

int main() {
	if (1) {
		freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
	}
	int n;
	scanf("%d", &n);
	vector<int> g(n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &g[i]);
	}
	int mxx = 0;
	for (int i = 0; i < n; i++) {
		mxx = max(mxx, g[i]);
	}
	mxx--;
	int l = 0, r = 1e6;
	while (r - l > 1) {
		int m = (l + r) / 2;
		for (int i = 0; i < (int)1e6; i++) {
			t[i] = 0, add[i] = 0;
			lf[i] = -1, rf[i] = -1;
		}
		int lstsz = g[0];
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (g[i] > g[i - 1]) {
				continue;
			}
			else {
				int tl = 0, tr = g[i];
				while (tr - tl > 1) {
					int tm = (tl + tr) / 2;
					if (get(1, 0, mxx, tm, g[i] - 1) < m - 1) {
						tl = tm;
					}
					else {
						tr = tm;
					}
				}
				if (get(1, 0, mxx, tl, tl) < m - 1) {
					upd(1, 0, mxx, tl, tl, 1);
					if (tl <= mxx - 1) {
						tt(1, 0, mxx, tl + 1, mxx, 0);
					}
				}
				else {
					ok = false;
					break;
				}
			}
		}
		if (!ok) {
			l = m;
		}
		else {
			r = m;
		}
	}
	printf("%d", r);
	return 0;
}