#define fs first
#define sc second

#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef double D;

bool plusplus(vector <int> &st, int x)
{
    int n = st.size();
    int it = n - 1;
    bool go = false;
    while (it >= 0 && !go)
    {
        if (st[it] + 1 < x)
        {
            st[it]++;
            go = true;
        }
        else
            st[it] = 0;
        it--;
    }

    return go;
}

bool check(int x, vector <int> l)
{
    int n = l.size();
    vector <vector <int> > design(n);
    for (int i = 0; i < n; ++i)
    {
        design[i].resize(l[i]);
    }

    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < min(l[i - 1], l[i]); ++j)
        {
            design[i][j] = design[i - 1][j];
        }

        if (l[i] <= l[i - 1])
        {
            if (!plusplus(st[i], x)) return false;
        }
    }

    return true;
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n;
    cin >> n;
    vector <int> l(n);
    for (int &v : l)
    {
        cin >> v;
        v = min(v, 800);
    }

    int ans = n;
    int left = 1;
    int right = n - 1;

    while (left <= right)
    {
        int mid = left + (right - left)/2;
        if (check(mid, l))
        {
            ans = mid;
            right = mid - 1;
        }
        else left = mid + 1;
    }

    cout << ans;
    return 0;
}
