# include <iostream>
# include <vector>

using namespace std;

const int MAX_N = 1e5;
int l[MAX_N];
int n;

bool check(int m)
{
    vector<int> ans(l[0], 1);
    for (int i = 1; i < n; i++)
    {
        if (l[i] > l[i - 1])
        {
            for (int k = 0; k < l[i] - l[i - 1]; k++)
            {
                ans.push_back(1);
            }
            continue;
        }
        for (int k = 0; k < l[i - 1] - l[i]; k++)
        {
            ans.pop_back();
        }
        int j = l[i] - 1;
        while (j >= 0 && ans[j] == m) --j;
        if (j == -1) return false;
        ++ans[j];
        for (int k = j + 1; k < l[i]; k++)
        {
            ans[k] = 1;
        }
    }
    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i];
    }
    int l = 0, r = MAX_N + 1;
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        if (check(m))
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    cout << r;
    return 0;
}
