# include <iostream>
# include <vector>
# include <algorithm>
# include <map>
# include <set>
# include <cstring>

# define int long long

using namespace std;


const int MAX_N = 1e5, MAX_C = 1e6, INF = 1e9;
int cnt[MAX_C];
int l[MAX_N], r[MAX_N], p[MAX_N];
int dp[MAX_N], rght[MAX_N];
vector<pair<int, pair<int, int> > > all;
map<int, int> ch;
set<int> un;
int n, k;

bool check()
{
    vector<pair<int, int> > beer;
    for (int i = 0; i < n; i++)
    {
        beer.push_back({l[i], 0});
        if (r[i] + 1 <= k) beer.push_back({r[i] + 1, 1});
        beer.push_back({r[i], 2});
    }
    beer.push_back({1, 1});
    beer.push_back({k, 1});
    sort(beer.begin(), beer.end());
    int curr = 0;
    for (int i = 0; i < (int)beer.size(); i++)
    {
      //  cout << beer[i].first << " " << beer[i].second << " " << curr << "\n";
        if (beer[i].second == 0) ++curr;
        if (beer[i].second == 1)
        {
            if (curr == 0) return false;
        }
        if (beer[i].second == 2) --curr;
    }
    return true;
}



int32_t main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> k;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i] >> r[i] >> p[i];
    }
    if (!check())
    {
        cout << -1;
        return 0;
    }
  /*  for (int i = 0; i < n; i++)
    {
        un.insert(l[i]);
        un.insert(r[i]);
    }
    int curr = 0;
    for (int i : un)
    {
        ch[i] = curr++;
    }
    for (int i = 0; i < n; i++)
    {
        l[i] = ch[l[i]];
        r[i] = ch[r[i]];
    }
    memset(cnt, 0, MAX_C * sizeof(int));
    for (int i = 0; i < n; i++)
    {
        ++cnt[l[i]];
        ++cnt[r[i]];
    } */
    for (int i = 0; i < n; i++)
    {
        all.push_back({r[i], {l[i], p[i]}});
    }
    sort(all.begin(), all.end());
    for (int i = 0; i < n; i++)
    {
        int rc = all[i].first, lc = all[i].second.first, pc = all[i].second.second;
        if (lc == 1)
        {
            dp[i] = pc;
            rght[i] = -1;
            continue;
        }
        dp[i] = -1;
        for (int j = 0; j < i; j++)
        {
            int rj = all[j].first, lj = all[j].second.first;
            if (dp[j] == -1) continue;
            if (rj < lc - 1) continue;
            if (lj >= lc) continue;
            if (rght[j] >= lc) continue;
            if (rj == lc - 1)
            {
                if (dp[i] == -1 || max(dp[j], pc) < dp[i])
                {
                    dp[i] = max(dp[j], pc);
                    rght[i] = -1;
                }
                continue;
            }
            if (dp[i] == -1 || max(dp[j], all[j].second.second + pc) < dp[i])
            {
                dp[i] = max(dp[j], all[j].second.second + pc);
                rght[i] = rj;
            }
        }
    }
    int answer = INF;
 /*   for (int i = 0; i < n; i++)
    {
        cout << all[i].first << " " << all[i].second.first << " " << all[i].second.second << " " << dp[i] << "\n";
    } */
    for (int i = 0; i < n; i++)
    {
        if (all[i].first == k && dp[i] != -1) answer = min(answer, dp[i]);
    }
    cout << answer;
    return 0;
}
