#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <deque>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 60;

pair <int, int> a[MAXN];
bool was[MAXN];

bool check(int m) {
    if (m >= 60)
        return false;
    if (!was[m]) {
        was[m] = true;
        cout << "X " << (1ll << m) << endl;
        int x, y; cin >> x >> y;
        a[m] = make_pair(x, y);
    }
    return a[m].first == 1 && a[m].second == (1ll << m);
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int q; cin >> q;
    int cnt = 0;
    for (int test = 0; test < q; test++) {
        fill(was, was + MAXN, false);
        fill(a, a + MAXN, make_pair(0, 0));
        int l = 0, r = 60;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (check(m))
                l = m;
            else
                r = m;
        }
        if (r == 60)
            cout << "N " << (1ll << l) << endl;
        else {
            check(r);
            int t = (1ll << r);
            int x = a[r].first, y = a[r].second;
            int p = (1ll << l);
            cout << "N " << y * p / (y - x * t) << endl;
        }
        string s; cin >> s;
        assert(s != "Wrong");
    }

    return 0;
}

