#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
#define int long long
#define pii pair <int, int>
#define kal pair <pii, int>
#define ff first
#define ss second
#define mp make_pair
#define pb push_back
const int INF2 = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int INF = 1e15;

int n, m;
vector <kal> pts;



bool is0() {
	int mx = 1;
	for (auto i : pts) {
		if (mx < i.ff.ff)
			return 0;
		mx = max(mx, i.ff.ss + 1);
	}
	return mx > m;
}

bool is1() {
	set <int> is;
	is.insert(0);
	for (auto i : pts)
		if (is.count(i.ff.ff - 1))
			is.insert(i.ff.ss);
	return is.count(m);
}

bool check(int am) {
	vector <vector <bool> > dp(n + 1, vector <bool> (n + 1, INF2));
	for (int i = 1; i <= n; ++i)
		if (pts[i].ff.ff == 1 && pts[i].ss <= am)
			dp[0][i] = 1;
	for (int i = 0; i <= n; ++i) {
		for (int j = i + 1; j <= n; ++j) {
			if (dp[i][j] == INF2)
				continue;
			for (int k = j + 1; k <= n; ++k) {
				if (pts[i].ff.ss < pts[k].ff.ff && pts[k].ff.ss > pts[j].ff.ss && pts[k].ff.ff <= pts[j].ff.ss && pts[k].ss + pts[j].ss <= am)
					dp[j][k] = 1;
				if (pts[i].ff.ss < pts[k].ff.ff && pts[k].ff.ss > pts[j].ff.ss && pts[k].ff.ff == pts[j].ff.ss + 1 && pts[k].ss <= am)
					dp[j][k] = 1;
			}
		} 
	}
	for (int i = 0; i <= n; ++i)
		for (int j = 0; j <= n; ++j)
			if (dp[i][j] != INF2 && pts[j].ff.ss == m)
				return 1;
	return 0;
}



int32_t main() {
	cin >> n >> m;
	pts.resize(n);
	for (auto & i : pts)
		cin >> i.ff.ff >> i.ff.ss >> i.ss;
	pts.pb(mp(mp(0, 0), 0));
	sort(pts.begin(), pts.end());

	int mx = 0;
	for (auto & i : pts)
		mx = max(mx, i.ss);

	if (mx == 1) {
		if (!is0())
			cout << "-1\n";
		else if (!is1())
			cout << "2\n";
		else
			cout << "1\n";
		return 0;
	}

	if (!is0()) {
		cout << "-1\n";
		return 0;
	}

	int l = 0, r = INF;
	while (l + 1 < r) {
		int mm = (l + r) / 2;
		if (check(mm))
			r = mm;
		else
			l = mm;
	}
	cout << r << endl;
}
