#include <iostream>
#include <vector>
#include <algorithm>

#define int int64_t

using namespace std;

int dp[3001][3001];

int32_t main()
{
	int n, k;
	cin >> n >> k;
	vector<pair<pair<int, int>, int> > rarr(n);
	for (auto &e : rarr)
		cin >> e.first.second >> e.first.first >> e.second;
	sort(rarr.begin(), rarr.end());
	vector<pair<int, int> > arr(n);
	vector<int> p(n);
	for (int i = 0; i < n; i++)
	{
		arr[i] = rarr[i].first;
		p[i] = rarr[i].second;
	}
	if (arr[0].second > 1)
	{
		cout << "-1";
		return 0;
	}
	dp[0][0] = 1;
	int ans = 1e18;
	for (int i = 0; i < n; i++)
	{
		if (arr[i].second == 1)
			dp[i + 1][0] = p[i];
		else
			dp[i + 1][0] = 0;
		int lb = 0;
		for (int j = 0; j < i; j++)
		{
			dp[i + 1][j + 1] = dp[i + 1][j];
			if (arr[j].first >= arr[i].second)
			{
				if (dp[j + 1][lb] == 0)
					continue;
				int nv = max(dp[j + 1][lb], p[i] + p[j]);
				if (dp[i + 1][j + 1] == 0 || dp[i + 1][j + 1] > nv)
					dp[i + 1][j + 1] = nv;
			}
			else
				lb++;
		}
		if (arr[i].first == k)
			ans = min(ans, dp[i + 1][i]);
	}
	if (ans > 1e15)
		cout << -1;
	else
		cout << ans;
	return 0;
}