#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define isize(A) int(A.size())
#define pll pair<ll, ll>
#define one first
#define two second
#define fi(i, s, f) for(int i = s; i < f; ++i)
#define fin(i, s, f) for(int i = s; i <= f; ++i)
#define rfi(i, s, f) for(int i = f - 1; i >= s; --i)
#define rfin(i, s, f) for(int i = f; i >= s; --i)
#define mp make_pair
#define pb push_back

const ll MAXN = 1e6;
const ll INF = 1e9 + 7;

struct th {
    ll l, r, p;
};

vector<th> v;

bool cmp(th a, th b) {
    return a.l < b.l || (a.l == b.l && a.r < b.r) || (a.l == b.l && a.r == b.r && a.p < b.p);
}

set<ll> s;
unordered_map<ll, ll> map_;

int main() {
    ios_base::sync_with_stdio(false);

    ll n, k;
    cin >> n >> k;

    v.resize(n);

    fi(i, 0, n) {
        cin >> v[i].l >> v[i].r >> v[i].p;
    }

    sort(v.begin(), v.end(), cmp);

    bool can = 1;

    ll last = 0;

    fi(i, 0, n) {
        if (last < v[i].l - 1) {
            can = 0;
            break;
        }

        last = max(last, v[i].r);
    }

    if (last != k) {
        can = 0;
    }

    if (!can) {
        cout << -1;
        return 0;
    }

    fi(i, 0, n) {
        ll min_ = INF;

        if (v[i].l == 1) {
            min_ = v[i].p;
        }

        if (s.count(v[i].l - 1)) {
            min_ = max(map_[v[i].l - 1], v[i].p);
        }

        fin(j, v[i].l, v[i].r) {
            if (s.count(j)) {
                min_ = min(min_, map_[j] + v[i].p);
            }
        }

        if (min_ != INF) {
            if (s.count(v[i].r)) {
                map_[v[i].r] = min(min_, map_[v[i].r]);
            } else {
                s.insert(v[i].r);
                map_[v[i].r] = min_;
            }
        }
    }

    cout << map_[k];

    return 0;
}

/*
3 5
1 5 1
2 3 1
1 3 1
*/
