#include <iostream>
#include <stdlib.h>
using namespace std;

int main()
{
    long n; cin >> n;
    long left[1000010], right[1000010];
    long up[1000010], down[1000010];
    char ch;
    left[0]=right[0]=up[0]=down[0]=0;
    for (long i=1; i<=n; i++) {
        left[i]=left[i-1];
        right[i]=right[i-1];
        up[i]=up[i-1];
        down[i]=down[i-1];
        cin >> ch;
        switch (ch) {
            case 'L':{left[i]++; break;}
            case 'R':{right[i]++; break;}
            case 'U':{up[i]++; break;}
            case 'D':{down[i]++; break;}
        }
    }
    long x, y;
    cin >> x >> y;

    long RightMax=right[n];
    long UpMax=up[n];
    long LeftMax=left[n];
    long DownMax=down[n];

    long LeftBrake, RightBrake;
    long UpBrake, DownBrake;

    if ((RightMax < x) || (x<0-LeftMax) || (UpMax < y) || (y<0-DownMax)) cout << -1;
    else {
        bool found=false;
        for (long i=0; i<=n; i++) {
            long l=0, r=n, m;
            while (l<r) {
                m=(l+r)/2;
                if (right[m]-left[i]==x) {
                    LeftBrake=i;
                    RightBrake=m;
                    found=true;
                    break;
                }
                if (right[m]-left[i] < x) l=m+1;
                if (right[m]-left[i] > x) r=m-1;
            }
            if (right[l]-left[i]==x) {
                LeftBrake=i;
                RightBrake=l;
                found=true;
                break;
            }
            if (right[r]-left[i]==x) {
                LeftBrake=i;
                RightBrake=r;
                found=true;
                break;
            }
            if (found) break;
        }

        found=false;
        for (long i=0; i<=n; i++) {
            long l=0, r=n, m;
            while (l<r) {
                m=(l+r)/2;
                if (up[m]-down[i]==y) {
                    DownBrake=i;
                    UpBrake=m;
                    found=true;
                    break;
                }
                if (up[m]-down[i] < y) l=m+1;
                if (up[m]-down[i] > y) r=m-1;
            }
            if (up[l]-down[i]==y) {
                DownBrake=i;
                UpBrake=l;
                found=true;
                break;
            }
            if (up[r]-down[i]==y) {
                DownBrake=i;
                UpBrake=r;
                found=true;
                break;
            }
            if (found) break;
        }
        cout << LeftBrake << ' ' << UpBrake << ' ' << RightBrake << ' ' << DownBrake;
    }

    return 0;
}
