#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

const int N = 200000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

using namespace std;

struct block
{
    int l, r, p;
    block() {}
    block(int a, int b, int c)
    {
        l = a;
        r = b;
        p = c;
    }
};

bool comp(block b1, block b2)
{
    return b1.r < b2.r;
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    int n, k;
    cin >> n >> k;
    vector<block> a(n);
    rep(i, 0, n)
    {
        cin >> a[i].l >> a[i].r >> a[i].p;
        assert(a[i].p == 1);
    }
    map<int, int> m;
    m[1] = 0;
    m[k] = 0;
    rep(i, 0, n)
    {
        m[a[i].l] = 0;
        m[a[i].r] = 0;
    }
    int curr = 0;
    for (auto &it : m)
        it.se = curr++;
    k = m[k];
    rep(i, 0, n)
    {
        a[i].l = m[a[i].l];
        a[i].r = m[a[i].r];
    }
    sort(a.begin(), a.end(), comp);

    vector<int> cnt(curr, 0);
    for (auto i : a)
    {
        cnt[i.l]++;
        if (i.r < curr - 1)
            cnt[i.r + 1]--;
    }
    rep(i, 1, curr)
        cnt[i] += cnt[i - 1];
    rep(i, 0, curr)
        if (cnt[i] == 0)
        {
            cout << -1 << endl;
            return 0;
        }

    vector<bool> dp(curr, false);
    for (auto i : a)
        if (i.l == 0 || dp[i.l - 1])
            dp[i.r] = true;
    if (dp[curr - 1])
        cout << 1 << endl;
    else
        cout << 2 << endl;
    return 0;
}
