#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

#define sqr(a) ((a)*(a))
#define sz(a) int((a).size())
#define forn(i, n) for (int(i) = 0; i < int(n); ++i)

typedef long long ll;
typedef unsigned long long ull;
typedef double dd;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 1e6 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

string s;

ll a[100];

int main()
{
    ios::sync_with_stdio(0);
    int q;
    cin >> q;
    int n;
    ll k = 1;
    for (n = 0; k < 1e18; ++n, k *= 2) a[n] = k;
    while (q--)
    {
        ll ans = 0, t, w;
        int l = 0, r = n, m;
        forn(i, 6)
        {
            m = (l + r) / 2;
            cout << "X " << a[m] << endl;
            cin >> t >> w;
            ans = max(w, ans);
            if (t == 0) r = m;
            else l = m;
        }
        cout << "N " << ans << endl;
        cin >> s;
        if (s != "Correct") break;
    }
    return 0;
}



