#include <bits/stdc++.h>

const int INF = (int)2e9 + 7;
const long long LINF = (long long)2e18;
const long long mod1 = 183453789;
const long long mod2 = 1234567891;
const long long P1 = 337;
const long long P2 = 263;

using namespace std;

template <typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-'))
        c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9')
        ans = ans * 10 + int(c - '0'), c = getchar();
    return ans * m;
}

const int N = 1e6 + 10;
char a[N];
int fx, fy;
int ans[4];

int dx[] = {0, 0, -1, 1};
int dy[] = {1, -1, 0, 0};
map < char, int > c;

void ex(){
    cout << -1 << endl;
    exit(0);
}

int n;

void solve(int d, int x){
    for (int i = n - 1;i >= 0; -- i){
        if (a[i] == d)
            x --;
        if (!x){
            ans[d] = i;
            return;
        }
    }

    ex();
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
#endif

    c['U'] = 0;
    c['D'] = 1;
    c['L'] = 2;
    c['R'] = 3;

    cin >> n;
    int x = 0, y = 0;
    for (int i = 0; i < n; ++ i){
        char x; cin >> x;
        a[i] = c[x];
        x += dx[a[i]], y += dy[a[i]];
    }
    cin >> fx >> fy;

    ans[0] = ans[1] = ans[2] = ans[3] = n;

    if (y > fy){
        solve(0, y - fy);
    } else
    if (y < fy){
        solve(1, fy - y);
    }

    if (x < fx){
        solve(2, fx - x);
    } else
    if (x > fx) {
        solve(3, x - fx);
    }

    cout << ans[2] << " " << ans[0] << " " << ans[3] << " " << ans[1] << '\n';
}
