#include <bits/stdc++.h>

const int INF = (int)2e9 + 7;
const long long LINF = (long long)2e18;
const long long mod1 = 183453789;
const long long mod2 = 1234567891;
const long long P1 = 337;
const long long P2 = 263;

using namespace std;

template <typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-'))
        c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9')
        ans = ans * 10 + int(c - '0'), c = getchar();
    return ans * m;
}

const int N = 12;
int l[N], r[N], p[N];

#define dec dsfs

long long ans = LINF;
map < int, long long > m, dec, inc;
int n, k;

void solve(int mask){
    m.clear(), dec.clear(), inc.clear();
    for (int i = 0; i < n; ++ i){
        if (mask & (1 << i))
            m[l[i]] = 1, m[r[i]] = 1,
            inc[l[i]] += p[i], dec[r[i]] += p[i];
    }
    int prev = 0;
    long long cur = 0, res = 0;
    for (auto i: m){
        int x = i.first;
        if (cur == 0){
            if (x - prev > 1) return;
        }
        cur += inc[i.first];
        res = max(res, cur);
        cur -= dec[i.first];

        if (cur == 0){
            prev = x;
        }
    }
    if (k != prev) return;
    ans = min(ans, res);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
#endif
    cin >> n >> k;
    for (int i = 0; i < n; ++ i){
        cin >> l[i] >> r[i] >> p[i];
    }
    for (int mask = 1; mask < (1 << n); ++ mask){
        solve(mask);
    }
    if (ans == LINF){
        cout << -1;
    } else {
        cout << ans;
    }
}
