import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by olymp on 10.03.2017.
 */
public class A {
    FastScanner in;
    PrintWriter out;
    int d;
    int n;
    int[] dp;

    void solve() throws FileNotFoundException {
        in = new FastScanner(new FileInputStream("input.txt"));
        out = new PrintWriter(new FileOutputStream("output.txt"));

        n = in.nextInt();
        int[] l = new int[n];
        for (int i = 0; i < n; i++) {
            l[i] = in.nextInt();
        }
        int m = l[0];
        int k = 1;
        int s = 1;
        while (s < n) {
            k++;
            for (int i = 0; i < m; i++) {
                s *= k;
            }
        }
        out.print(k);

        out.close();
    }

    public static void main(String args[]) throws IOException {
        Locale.setDefault(Locale.US);
        new A().solve();
    }

    class FastScanner implements Closeable {
        private BufferedReader br;
        private StringTokenizer tokenizer;

        public FastScanner(InputStream stream) throws FileNotFoundException {
            br = new BufferedReader(new InputStreamReader(stream));
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public String nextLine() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    return br.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken("\n");
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        @Override
        public void close() throws IOException {
            br.close();
        }
    }
}
