#include <bits/stdc++.h>

using namespace std;

struct ev {
    int x;
    int type;
    int cost;
    int other;
    int ind;
    ev(int _x, int _type, int _cost, int _other, int _ind) {
        x = _x;
        type = _type;
        cost = _cost;
        other = _other;
        ind = _ind;
    }
};

vector<ev> e;

bool cmp(const ev &a, const ev &b) {
    if (a.x == b.x) {
        if (a.type == b.type) {
            if (a.type == 1) return a.other > b.other;
            else return a.other < b.other;
        }
        return a.type > b.type;
    }
    return a.x < b.x;
}

int32_t main() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        int l, r, p;
        cin >> l >> r >> p;
        if (r > k) r = k;
        e.push_back(ev(l, 1, p, r, i));
        e.push_back(ev(r, -1, p, l, i));
    }
    sort(e.begin(), e.end(), cmp);
    if (e[0].x > 1 || e.back().x < k) {
        cout << -1;
        return 0;
    }
    int bal = 0;
    set<int> s;
    for (int i = 0; i < (int)e.size(); ++i) {
        if (e[i].type == 1) bal += e[i].type;
        if (bal == 1) {
            s.insert(e[i].ind);
        }
        if (e[i].type == -1) bal += e[i].type;
    }
    bal = 0;
    int mx = 0;
    for (int i = 0; i < (int)e.size(); ++i) {
        if (s.count(e[i].ind) > 0) bal += e[i].type;
        mx = max(mx, bal);
    }
    cout << mx;
    return 0;
}
