#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>

#define _CRT_SECURE_NO_WARNINGS
#pragma warning (disable : 4996)
#pragma comment (linker, "/STACK:65000000")

using namespace std;

const int NMAX = 100017, LMAX = 200017;
int n, l[NMAX], maxs;

bool prov(int alph) {
	vector <int> vec;
	vec.resize(maxs + 1);
	for (int i = 0; i < maxs; i++) {
		vec[i] = 0;
	}
	for (int i = 0; i < l[1]; i++) {
		vec[i] = 1;
	}
	for (int i = 2; i <= n; i++) {
		bool pref = false;
		for (int j = l[i] - 1; j >= 0; j--) {
			if (vec[j] == 0) {
				pref = true;
				vec[j] = 1;
			}
			else break;
		}
		if (!pref) {
			bool flag = false;
			for (int j = l[i] - 1; j >= 0; j--) {
				if (vec[j] < alph) {
					vec[j]++;
					flag = true;
					for (int e = j + 1; e <= l[i] - 1; e++) {
						vec[e] = 1;
					}
					for (int e = l[i]; e < maxs; e++) {
						vec[e] = 0;
					}
					break;
				}
			}
			if (!flag) return false;
		}
	}
	return true;
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	//freopen("output.txt", "w", stdout);

	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> l[i];
		maxs = max(maxs, l[i]);
	}



	int l, r;
	l = 1; r = n;
	prov(2);
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (!prov(m)) l = m;
		else r = m;
	}
	for (int i = l; i <= r; i++) {
		if (prov(i)) {
			cout << i;
			return 0;
		}
	}
	return 0;
}
