#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>

#define _CRT_SECURE_NO_WARNINGS
#pragma warning (disable : 4996)
#pragma comment (linker, "/STACK:65000000")

using namespace std;

struct line {
	pair <int, int> x;
	int fl;
	int p;
};

bool cmp(line a, line b) {
	if (a.x.first != b.x.first) return a.x.first < b.x.first;
	return a.fl < b.fl;
}

const long long INF = 1e18;
const int NMAX = 100017;
int n, k;
pair <int, int> l[NMAX];
int p[NMAX];
long long ans = INF;



int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	//freopen("output.txt", "w", stdout);

	cin >> n >> k;

	for (int i = 1; i <= n; i++) {
		cin >> l[i].first >> l[i].second >> p[i];
	}


	int cnt = (1 << n);

	for (int i = 0; i < cnt; i++) {
		if (i == 3) {
			i = 3;
		}
		int n1 = i;
		vector <int> vec;
		vec.resize(n + 1);
		int k1 = 0;
		while (n1 > 0) {
			vec[++k1] = n1 % 2;
			n1 /= 2;
		}
		vector <line> scan;
		for (int i = 1; i <= n; i++) {
			if (vec[i]) {
				scan.push_back({ {l[i].first, l[i].second}, 0, p[i] });
				scan.push_back({ {l[i].second, l[i].first}, 1, p[i] });
			}
		}
		sort(scan.begin(), scan.end(), cmp);
		int balance = 0;
		bool flag = true;
		int last = 1;
		for (int i = 0; i < scan.size(); i++) {
			if (scan[i].fl == 0) {
				if (scan[i].x.first > last) {
					flag = false;
					break;
				}
				last = max(last, scan[i].x.second + 1);
			}
		}
		if (!flag || last <= k) continue;
		long long b = 0;
		long long sec = 0;
		for (int i = 0; i < scan.size(); i++) {
			if (scan[i].fl == 0) {
				sec += scan[i].p;
				b = max(b, sec);
			}
			if (scan[i].fl == 1) {
				sec -= scan[i].p;
			}
		}
		if (b == 2) {
			b = 2;
		}
		ans = min(ans, b);
	}
	if (ans == INF) cout << -1;
	else cout << ans;
	return 0;
}




	