#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <list>
#include <assert.h>
#include <time.h>
#pragma warning(disable: 4996)
#pragma gcc optimize("o3")
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 4e5 + 10;
const int INF = 2e9;

int l[SZ], r[SZ], p[SZ], d[SZ];
vector<pair<int, int>> e[SZ];
vector<int> b[SZ];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
#endif
	ios::sync_with_stdio(false);
	srand(time(NULL));

	int n, k;
	cin >> n >> k;
	map<int, int> zp;
	zp[k] = 0;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> p[i];
		zp[l[i]] = zp[r[i]] = 0;
	}
	int kk = -1, last = -INF;
	for (auto &i : zp) {
		if (i.first != last + 1) {
			i.second = kk + 1;
			kk += 2;
		} else
			i.second = kk++;
		last = i.second;
	}
	for (int i = 0; i < n; i++) {
		l[i] = zp[l[i]];
		r[i] = zp[r[i]];
		e[r[i]].push_back({ l[i], p[i] });
		b[l[i]].push_back(r[i]);
	}

	set<int> x;
	for (int i = 0; i < kk; i++) {
		for (int j : b[i])
			x.insert(j);
		if (!x.size())
			return cout << "-1", 0;
		if (*x.begin() == i)
			x.erase(x.begin());
	}

	for (int i = 0; i < kk; i++) {
		d[i] = INF;
		for (auto j : e[i]) {
			d[i] = min(d[i], max((j.first ? d[j.first - 1] : 0), j.second));
			for (int k = j.first; k < i; k++)
				for (auto x : e[k])
					d[i] = min(d[i], max(d[k], j.second + x.second));
		}
	}

	cout << d[kk - 1];
	return 0;
}