#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <list>
#include <assert.h>
#include <time.h>
#pragma warning(disable: 4996)
#pragma gcc optimize("o3")
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 1e5 + 10;
const ll INF = 1e9;

set<int> eanums;

ll pr(ll x) {
	if (x > 1000000000 && eanums.lower_bound(x) != eanums.end()) {
		ll nxt = *eanums.lower_bound(x);
		if (abs(x - nxt) < 50)
			return nxt;
	}
	while (true) {
		int checkto = min(x, ll(sqrt(x)) + 1);
		bool ok = true;
		if (x == 2)
			return x;
		if (x % 2 == 0) {
			x++;
			continue;
		}
		for (int i = 3; i < checkto; i += 2)
			if (x % i == 0) {
				ok = false;
				break;
			}
		if (ok) {
			eanums.insert(x);
			return x;
		}
		x++;
	}
}

ll gcd(ll a, ll b) {
	if (b > a)
		swap(a, b);
	return (b ? gcd(b, a % b) : a);
}

#ifdef _DEBUG
bool checkmode = true;
#else
bool checkmode = false;
#endif
ll gn;

pair<ll, ll> q(ll a) {
	ll x, y;
	if (!checkmode) {
		cout << "X " << a << endl;
		cin >> x >> y;
	}
	else {
		x = gn / a;
		y = gn;
		ll z = gcd(x, y);
		x /= z;
		y /= z;
	}

	return{ x, y };
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#endif
	ios::sync_with_stdio(false);
	srand(time(NULL));

	gn = 100000000000000;
	ll g;
	if (!checkmode)
		cin >> g;
	else
		g = 10000;

	while (g--) {
		gn++;
		ll n = 1053459783;

		bool last = false;
		vector<ll> res;
		ll t = 10;
		for (ll i = 0; i < t; i++) {
			pair<ll, ll> r = q(n);
			if (r.first == 0) {
				if (last)
					n -= max(1ll, n / (10 + rand() % 10));
				else
					n = sqrt(n);
				last = false;
			}
			else {
				last = true;
				res.push_back(r.second);
				n += max(1ll, n / (20 + rand() % 20));
			}
		}

		ll num = res.back();
		res.pop_back();
		for (ll i : res)
			num = ld(num) / ld(gcd(num, i)) * ld(i);

		if (!checkmode) {
			cout << "N " << num << endl;
			string verd;
			cin >> verd;
			if (verd == "Wrong")
				return 0;
		}
		else {
			if (num != gn) {
				cout << "Wrong at " << gn << endl;
				ll x;
				cin >> x;
				return 0;
			}
			else
				cout << "Correct" << endl;
		}
	}
	ll x;
	cin >> x;

	return 0;
}