#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
typedef pair <int, int> pii;

const int INF = 1e9;
const ll INFll = 1ll * INF * INF;

struct point {
    int l, r, p;
};

bool comp(point a, point b) {
    return a.l < b.l || (a.l == b.l && a.p > b.p);
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, k;
    cin >> n >> k;
    vector <point> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i].l >> v[i].r >> v[i].p;
    v.pb({0, 0, 0});
    sort(v.begin(), v.end(), comp);
    vector <ll> dp(v.size() + 1, INFll);
    dp[0] = 0;
    for (int i = 1; i < v.size(); i++) {
        ll val = INFll;
        for (int j = 0; j < i; j++) {
            if (v[j].r + 1 < v[i].l)
                continue;
            ll add;
            if (v[j].r >= v[i].l)
                add = v[j].p + v[i].p;
            else
                add = max(v[j].p, v[i].p);
            val = min(val, max(dp[j], add));
        }
        //cout << val << endl;
        dp[i] = val;
    }
    ll ans = INFll;
    for (int i = 1; i < v.size(); i++)
        if (v[i].r == k)
            ans = min(ans, dp[i]);
    if (ans == INFll)
        cout << -1 << endl;
    else
        cout << ans << endl;
    return 0;
}

