#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

#define mp make_pair
#define pb push_back
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int sz; cin >> sz;
    string path; cin >> path;
    int x, y; cin >> x >> y;
    int l = 0, u = 0, r = 0, d = 0;

    forn(i, sz) {
        if(path[i] == 'L') {
            l++;
        }
        if(path[i] == 'R') {
            r++;
        }
        if(path[i] == 'U') {
            u++;
        }
        if(path[i] == 'D') {
            d++;
        }
    }

    int sl, su, sr, sd;
    sl = su = sr = sd = 0;

    if(x > 0) {
        if(r >= x) {
            sr = x;
        } else {
            cout << -1;
            return 0;
        }
    } else if(x < 0) {
        if(l >= -x) {
            sl = -x;
        } else {
            cout << -1;
            return 0;
        }
    } else {
        sl = sr = 0;
    }

    if(y > 0) {
        if(u >= y) {
            sr = y;
        } else {
            cout << -1;
            return 0;
        }
    } else if(y < 0) {
        if(d >= -y) {
            sd = -y;
        } else {
            cout << -1;
            return 0;
        }
    } else {
        su = sd = 0;
    }

    int cl, cu, cr, cd;
    cl = cu = cr = cd = 0;
    int al, au, ar, ad;
    al = au = ar = ad = 0;

    forn(i, sz) {
        if(path[i] == 'L') {
            cl++;
        }
        if(path[i] == 'R') {
            cr++;
        }
        if(path[i] == 'U') {
            cu++;
        }
        if(path[i] == 'D') {
            cd++;
        }
        if(cl == sl) {
            al = i + 1;
            sl = -1;
        }
        if(cr == sr) {
            ar = i + 1;
            sr = -1;
        }
        if(cd == sd) {
            ad = i + 1;
            sd = -1;
        }
        if(cu == su) {
            au = i + 1;
            su = -1;
        }
    }

    cout << al << ' ' << au << ' ' << ar << ' ' << ad;

    return 0;
}
