#pragma comment(linker, "/STACK:1000000000")
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<string>
#include<map>
#include<cassert>
#include<queue>

//#define int long long

using namespace std;

vector<int> a;
int n;
vector<pair<int, int> > s;

bool inc(vector<pair<int, int> > &s, int alp) {
	if (s.size() == 0)
		return false;

	if (s.back().first == alp - 1) {
		int cnt = s.back().second;
		s.pop_back();
		bool res = inc(s, alp);

		if (!res)
			return false;

		s.push_back({ 0, cnt });
	}
	else {
		s.back().second--;
		int ch = s.back().first + 1;

		if (s.back().second == 0)
			s.pop_back();

		s.push_back({ ch, 1 });
	}

	return true;
}

bool check(int alp) {
	s.clear();
	int c = 0;
	int clen = 0;
	while (c < n) {
		if (a[c] - clen > 0) {
			s.push_back({ 0, a[c] - clen });
		}
		else {
			int del = clen - a[c];
			while (del > 0) {
				int cdel = min(del, s.back().second);
				
				if (s.back().second == cdel)
					s.pop_back();
				else
					s.back().second -= del;

				del -= cdel;
			}
			bool res = inc(s, alp);

			if (!res)
				return false;
		}
		clen = a[c];
		c++;
	}
	return true;
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
	}
	int l = 0, r = n;
	while (r - l > 1) {
		int m = l + r >> 1;

		bool res = check(m);
		if (res)
			r = m;
		else
			l = m;
	}
	cout << r;
}