#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <functional>
#include <cstdio>
#include <cassert>



#define pb push_back
#define mp make_pair
#define ppb pop_back
#define len(v) ((int)(v.size()))


typedef long long ll;


using namespace std;


char string_in_buffer[(int)(2e6)];

void fast_scan(int &x) { scanf("%d", &x); }
void fast_scan(ll &x) { scanf("%lld", &x); }
void fast_scan(double &x) { scanf("%lf", &x); }
void fast_scan(string &s) {
	scanf("%s", string_in_buffer);
	s = string(string_in_buffer);
}
template<class T>
void fast_scan(vector<T> &v) {
	for (T &x : v) {
		fast_scan(x);
	}
}

void fast_print(const int &x) { printf("%d", x); }
void fast_print(const ll &x) { printf("%lld", x); }
void fast_print(const string &s) { printf("%s", s.c_str()); }
void fast_print(const double &x) { printf("%.20lf", x); }

template<class T>
void fast_print(const vector<T> &v) {
	if (v.empty()) return;
	for (int i = 0; i < len(v) - 1; i++) {
		fast_print(v[i]);
		fast_print(" ");
	}
	fast_print(v.back());
}

namespace smart_io {
	bool first_line_print = true;
	bool first_print = false;
	string print_start = "";
	void precall_print() {
		fast_print(print_start);
		print_start = "\n";
		first_print = true;
	}
}

template<class T>
istream &operator,(istream &is, T &x) {
	fast_scan(x);
	return is;
}

template<class T>
ostream &operator,(ostream &os, const T &x) {
	if (!smart_io::first_print) {
		fast_print(" ");
	} else {
		smart_io::first_print = false;
	}
	fast_print(x);
	return os;
}


#define scan cin,
#define print smart_io::precall_print(); cout,


int main() {
	freopen("input.txt", "r", stdin);
	int n;
	scan n;
	string s;
	scan s;
	int x, y;
	scan x, y;

	int U = 0, R = 0, D = 0, L = 0;
	map<char, int> rez;
	rez['D'] = -1;
	rez['U'] = -1;
	rez['L'] = -1;
	rez['R'] = -1;

	if (y >= 0) rez['D'] = 0;
	if (y <= 0) rez['U'] = 0;
	if (x >= 0) rez['L'] = 0;
	if (x <= 0) rez['R'] = 0;

	for (int i = 0; i < len(s); i++) {
		if (s[i] == 'U') U++; 
		if (s[i] == 'D') D++; 
		if (s[i] == 'L') L++; 
		if (s[i] == 'R') R++;
		if (U == y) {
			rez['U'] = i + 1;
		}
		if (-D == y) {
			rez['D'] = i + 1;
		}
		if (R == x) {
			rez['R'] = i + 1;
		}
		if (-L == x) {
			rez['L'] = i + 1;
		}
	}
	for (auto p : rez) {
		if (p.second == -1) {
			print -1;
			return 0;
		}
	}

	print rez['L'], rez['U'], rez['R'], rez['D'];
}