#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define ld long double
#define f first
#define s second
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define files1 freopen("input.txt", "r", stdin)
#define files2 freopen("output.txt", "w", stdout)
#define pii pair<int, int>
#define fast_io ios_base::sync_with_stdio(0)
using namespace std;

const int maxn = 1e5 + 500, base = 1e9 + 7;
const int inf = 2e9 + 5;
const ll llinf = 1e18 + 5;

int a[maxn];
vector<int> s[maxn];

void color(int i, int j) {
	for (int k = j; k < s[i].size(); k++)
		s[i][k] = 0;
}

bool can(int n, int m) {
	color(0, 0);
	for (int i = 1; i < n; i++) {
		if (s[i].size() > s[i - 1].size()) {
			for (int j = 0; j < s[i - 1].size(); j++)
				s[i][j] = s[i - 1][j];
			color(i, s[i - 1].size());
		} else {
			bool fnd = 0;
			for (int j = s[i].size() - 1; j >= 0; j--) {
				if (s[i - 1][j] + 1 < m) {
					fnd = 1;
					for (int k = 0; k <= j; k++)
						s[i][k] = s[i - 1][k];
					s[i][j]++;
					color(i, j + 1);
					break;
				}
			}
			if (!fnd)
				return 0;
		}
	}
	return 1;
}

int main() {
	int n;
	// files1;
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		scanf("%d", a + i);
		s[i].resize(a[i]);
	}

	// cout << can(n, 1);
	// return 0;

	int l = 1, r = n;
	while (r - l > 0) {
		int m = (l + r) >> 1;
		if (can(n, m))
			r = m;
		else
			l = m + 1;
	}
	cout << l;
	return 0;
}