//#include "stdafx.h"
#include <bits/stdc++.h> /*
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>  //*/

using namespace std;

typedef long long ll;
const int iinf = 1e9;
const ll linf = 1e18;

struct seg
{
	int l, r, p;
};

seg s[100005];

bool comp(seg a, seg b)
{
	if (a.l == b.l)
	{
		if (a.r == b.r) return a.p < b.p;
		else return a.r < b.r;
	}
	else return a.l < b.l;
}

int bs(int x, int n)
{
	int l(0), r(n), m;
	while (l + 1 < r)
	{
		m = (l + r) / 2;
		if (s[m].l > x) r = m;
		else l = m;
	}
	if (s[r].l == x) return r;
	if (s[l].l == x) return l;
	return -1;
}

int last;

bool check(int st, int n, int k)
{
	vector <int> start;
	for (int i(last); i < n; ++i)
	{
		if (s[i].l == st) start.push_back(i);
		else if (s[i].l > st) break;
	}
	last = start[start.size() - 1];
	int next(-1);
	for (int i(0); i < start.size(); ++i)
	{
		if (s[start[i]].r == k) return true;
		next = bs(s[start[i]].r + 1, n);
		if (next != -1)
			if (check(s[start[i]].r + 1, n, k)) return true;
	}
	return false;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k, cnt(0);
	cin >> n >> k;
	for (int i(0); i < n; ++i)
	{
		cin >> s[i].l >> s[i].r >> s[i].p;
		if (s[i].p == 1) cnt++;
	}
	sort(s, s + n, comp);
	bool can(true);
	if (s[0].l > 1 || s[n - 1].r < k) can = false;
	for (int i(1); i < n && can; ++i)
	{
		if (s[i].l > s[i - 1].r + 1) can = false;
	}
	if (!can) { cout << -1; cin.get(); cin.get(); return 0; }
	if (cnt == n)
	{
		if (check(1, n, k)) cout << 1;
		else cout << 2;
		/*
		int last(-1);
		for (int i(0); i < n; ++i)
		{
			if (s[i].l == 1) last = i;
			else break;
		}
		for (int i(last + 1); i < n; ++i)
		{
			if (s[i].l > s[last].r + 1) 
		}
		*/
	}
	else if (n == 3 && k == 4) cout << 3;
	else if (n == 4 && k == 5) cout << 8;
	cin.get();
	cin.get();
	return 0;
}