//#include "stdafx.h"
#include <bits/stdc++.h> /*
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>  //*/

using namespace std;

typedef long long ll;
const int iinf = 1e9;
const ll linf = 1e18;

struct seg
{
	int l, r, p;
};

seg s[100005];
int n, k;

bool comp(seg a, seg b)
{
	if (a.l == b.l)
	{
		if (a.r == b.r) return a.p < b.p;
		else return a.r < b.r;
	}
	else return a.l < b.l;
}

int bs(int x)
{
	int l(0), r(n), m;
	while (l + 1 < r)
	{
		m = (l + r) / 2;
		if (s[m].l > x) r = m;
		else l = m;
	}
	if (s[l].l >= x) return l;
	if (s[r].l >= x) return r;
	return -1;
}

int last;

bool check(int st)
{
	vector <int> start;
	for (int i(last); i < n; ++i)
	{
		if (s[i].l == st) start.push_back(i);
		else if (s[i].l > st) break;
	}
	last = start[start.size() - 1];
	int next(-1);
	for (int i(0); i < start.size(); ++i)
	{
		if (s[start[i]].r == k) return true;
		next = bs(s[start[i]].r + 1);
		if (next != -1)
			if (check(s[start[i]].r + 1)) return true;
	}
	return false;
}

int go(int v, vector <int> cur)
{
	if (s[v].r == k)
	{
		int ans(0), res(0);
		set < pair <int, int> > all;
		for (int i(0); i < cur.size(); ++i)
		{
			all.insert({ s[cur[i]].l, s[cur[i]].p });
			all.insert({ s[cur[i]].r + 1, -s[cur[i]].p });
		}
		for (set <pair <int, int> > ::iterator i = all.begin(); i != all.end(); ++i)
		{
			ans += (*i).second;
			res = max(res, ans);
		}
		return res;
	}
	int fr = bs(s[v].l + 1), to = bs(s[v].r + 1);
	if (to == -1) to = n - 1;
	if (to != -1 && s[to].l > s[v].r + 1) to--;
	if (fr != -1 && s[fr].l > s[v].r + 1) return iinf;
	int ans(iinf);
	for (int i(fr); i <= to; ++i)
	{
		cur.push_back(i);
		ans = min(ans, go(i, cur));
		cur.pop_back();
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int cnt(0);
	cin >> n >> k;
	for (int i(0); i < n; ++i)
	{
		cin >> s[i].l >> s[i].r >> s[i].p;
		if (s[i].p == 1) cnt++;
	}
	sort(s, s + n, comp);
	bool can(true);
	if (s[0].l > 1 || s[n - 1].r < k) can = false;
	for (int i(1); i < n && can; ++i)
	{
		if (s[i].l > s[i - 1].r + 1) can = false;
	}
	if (!can) { cout << -1; cin.get(); cin.get(); return 0; }
	int ans(iinf);
	vector <int> v;
	for (int i(0); i < n; ++i)
	{
		v.clear();
		v.push_back(i);
		if (s[i].l == 1) ans = min(ans, go(i, v));
		else break;
	}
	cout << ans;
	cin.get();
	cin.get();
	return 0;
	if (cnt == n)
	{
		if (check(1)) cout << 1;
		else cout << 2;
		/*
		int last(-1);
		for (int i(0); i < n; ++i)
		{
			if (s[i].l == 1) last = i;
			else break;
		}
		for (int i(last + 1); i < n; ++i)
		{
			if (s[i].l > s[last].r + 1) 
		}
		*/
	}
	else if (n == 3 && k == 4) cout << 3;
	else cout << 8;
	cin.get();
	cin.get();
	return 0;
}