#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#ifdef USE_CERR
#define CERR(a) cerr << a << endl
#else
#define CERR(a)
#endif

//#define HOME

struct solver {
    ll ank;
    int cnt;

    void init(ll val) {
        ank = val;
        cnt = 0;
    }

#ifdef HOME
    pll ask(ll val) {
        cnt++;
        if (cnt > 60) {
            throw 0;
        }
        ll a = ank / val;
        if (a == 0)
            return make_pair(0, 1);
        ll gc = __gcd(a, ank);
        return make_pair(a / gc, ank / gc);
    }
#else
    pll ask(ll val) {
        cout << "X " << val << endl;
        ll a, b;
        cin >> a >> b;
        return make_pair(a, b);
    }
#endif


#ifdef HOME
    bool ans(ll val) {
        return val == ank;
    }
#else
    bool ans(ll val) {
        cout << "N " << val << endl;
        string s;
        cin >> s;
        return (s == "Correct");
    }
#endif

};

bool play(solver sl) {
    ll val = 2;
    ll ank = 1;
    for (int i = 0; i < 60; i++) {
        pll cur = sl.ask(val);
        if (cur.first != 0) {
            ank = cur.second;
        } else if (cur.first == 0) {
            break;
        }
        val *= 2;
    }
    return sl.ans(ank);
}

void go() {
    solver sl;
    play(sl);
}

void test() {
    ll rnd = abs(rand()) + 1;
    solver sl;
    sl.init(rnd);

    if (!play(sl)) {
        throw 0;
    }
}

int main() {
    srand(13);

    int g;
    cin >> g;
    for (int i = 0; i < g; i++)
        go();
}