#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long int ll;
typedef pair<ll, ll> pll;

vector<ll> pows;

struct pr {
    ll a, b;
};

pr ask(ll v) {
    cout << "X " << v << endl;
    pr ret;
    cin >> ret.a;
    if (ret.a != -1)
        cin >> ret.b;
    return ret;
}

bool ans(ll v) {
    cout << "N " << v << endl;
    cout << flush;
    string s;
    cin >> s;
    return (s == "Correct");
}

pr written;

bool can(int v) {
    pr p = ask(pows[v]);
    written = p;
    return p.a != 0;
}

bool gt(vector<bool> & was, vector<bool> & calc, vector<pr> & prs, int val) {
    if (calc[val])
        return was[val];
    calc[val] = true;
    was[val] = can(val);
    prs[val] = written;
    return was[val];
}

bool play() {
    int a = 0, b = 60;
    vector<bool> was(64);
    vector<bool> calc(64);
    vector<pr> prs(64);

    while (a != b) {
        int la = a, lb = b;
        int mid = (a + b) / 2;

        if (!gt(was, calc, prs, mid))
            b = mid;
        else
            a = mid;

        if (la == a && lb == b) {
            if (gt(was, calc, prs, a))
                b = a;
            else
                a = b;
        }
    }

    if (a == 0)
        return ans(1);

    gt(was, calc, prs, a);

    return ans(prs[a].b);
}

void precalc() {
    pows.resize(64);
    for (long i = 0; i < 64; i++)
        pows[i] = (1ULL << i);
}

int main() {
    precalc();

    int g;
    cin >> g;
    for (int i = 0; i < g; i++) {
        if (!play()) break;
    }
}