#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>


using namespace std;


#define mendl "\n"


const long long INF = 1000000000000000000;


int main()
{
	int n, buff;
	cin >> n;
	map < int, int > mp;
	for (int i = 0; i < n; i++) {
		cin >> buff;
		mp[buff]++;
	}
	map < int, int > ::iterator k;
	int maxim = 1, a, b;
	vector < vector < int > > pred(6, vector < int >(11, 0));
	for (int i = 1; i <= 10; i++) {
		pred[1][i] = i;
	}
	for (int i = 1; i <= 5; i++) {
		pred[i][1] = 1;
	}
	for (int i = 2; i <= 5; i++) {
		for (int j = 2; j <= 10; j++) {
			pred[i][j] = pred[i - 1][j] + pred[i][j - 1];
		}
	}
	int ind;
	for (k = mp.begin(); k != mp.end(); k++) {
		a = k->first;
		b = k->second;
		ind = 1;
		while (ind < 11 && pred[a][ind] < b)
			ind++;
		maxim = max(maxim, ind);
	}
	cout << maxim;
	return 0;
}

