#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>


using namespace std;


#define mendl "\n"


const long long INF = 1000000000000000000;


int main()
{
	long long n, buff;
	cin >> n;
	map < long long, long long > mp;
	for (long long i = 0; i < n; i++) {
		cin >> buff;
		mp[buff]++;
	}
	map < long long, long long > ::iterator k;
	long long maxim = 1, a, b;
	vector < vector < long long > > pred(101, vector < long long >(101, 0));
	for (long long i = 1; i <= 100; i++) {
		pred[1][i] = i;
	}
	for (long long i = 1; i <= 100; i++) {
		pred[i][1] = 1;
	}
	for (long long i = 2; i <= 100; i++) {
		for (long long j = 2; j <= 100; j++) {
			pred[i][j] = pred[i - 1][j] + pred[i][j - 1];
		}
	}
	long long ind;
	for (k = mp.begin(); k != mp.end(); k++) {
		a = k->first;
		b = k->second;
		ind = 1;
		while (ind < 101 && pred[a][ind] < b)
			ind++;
		maxim = max(maxim, ind);
	}
	cout << maxim;
	return 0;
}

