#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iterator>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define for1(i, n) for(int i = 1; i <= (int)n; i++)
#define all(v) v.begin(), v.end()

void solve();

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const ll C = (ll)1e18;

vector<ll> p = { 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53};

ll gcd(ll a, ll b) {
	while (a && b) {
		a %= b, swap(a, b);
	}
	return a + b;
}

ll nok(ll a, ll b) {
	ll g = gcd(a, b);
	return a / g * b;
}

bool divide(ll x) {
	printf("X %lld\n", x);
	cout.flush();

	ll a, b;
	cin >> a >> b;
	return (a == 1 && b == x);
}

ll pw(ll x, ll y) {
	ll s = 1;
	forn(j, y) s *= x;
	return s;
}

ll f() {
	ll m = 1;
	forn(i, p.size()) {
		ll l = 0, r = log(C / m) / log(p[i]) + 1;
		while (r - l > 1) {
			ll mid = (r + l) / 2;
			ll s = pw(p[i], mid);
			if (divide(s)) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		m *= pw(p[i], l);
	}
	return m;
}

void solve() {
	int test;
	cin >> test;
	while (test--) {
		printf("N %lld\n", f());
		cout.flush();
		string ans;
		cin >> ans;
		if (ans != "Correct") {
			return;
		}
	}
}